(* ::Package:: *)

(* :Title: Utils.m *)

(* :Authors:
	Andrew Hunt, Shaun McCance, Todd Gayley
	andy@wolfram.com, shaunm@wolfram.com, tgayley@wolfram.com
*)

(* :Package Version: 0.50 *)

(* :Mathematica Version: 6.0 *)

BeginPackage["DocumentationBuild`Utils`", {
    "DocumentationBuild`Common`",
    "Transmogrify`", "JLink`"
}];

AddSpaces::usage = "Add spaces to content.";
AddSpans::usage = "Add spaces to content.";
AddSpaceToCamelCase::usage = "AddSpaceToCamelCase[str] adds space to camel case e.g. 'SomeFunction' -> 'Some Function'.";
ReplaceCharacters::usage = "";
ItalicizeMoreAboutKeyWords::usage = "";
makeTitleModiferString::usage ="";
StringList::usage = "StringList[list] returns the contents of list as a single string."
ToStringList::usage = "ToStringList[list] returns the contents of list as a string, and empty string for empty list or other expressions."
titlemaker::usage = "";
NumberToLetter::usage = "";
MakeCamelCaseString::usage = "MakeCamelCaseString[str] capitalizes the first letter(s) and deletes spaces in str.";
CapitalizeString::usage = "CapitalizeString[str] returns str in all capital letters.";
LowercaseString::usage = "LowercaseString[str] returns str in all lowercase letters.";
GetQuietly::usage = "Turn off Syntax::newl before using Get.";
GetPrimaryGuide::usage = "";
CoreMathematicaPacletQ::usage = "";
HasOptionsQ::usage = "HasOptionsQ[nb] returns True if the symbol page nb has an options table. Note: no page type checking.";

RepairMetadataCellLabels::usage = "RepairMetadataCellLabels[notebook] will return the nb expr of a notebook with the Categorization and Details cell labels re-added.
                                   RepairMetadataCellLabels[filename] will do the same to a notebook file and overwrite-save that file."

DocumentFlag::usage = "DocumentFlag[nbfile] returns the flag style (\"InternalFlag\"
etc.), if any, that is used in the first cell in the notebook saved in nbfile."

ConvertFileQ::usage = "ConvertFileQ[nbfile] returns True if nb should be converted during documentation build.";

IsManipulateQ::usage = "IsManipulateQ[cell] returns True if cell is a Manipulate expression.";
IsSoundQ::usage = "IsSoundQ[cell] returns True if cell contains a Sound expression.";
IsAudioQ::usage = "IsAudioQ[cell] returns True if cell contains a Audio expression.";

UnsortedUnion::usage = "UnsortedUnion[list] returns a list of unique elements in order in which thery appear."
GetLanguageExtension::usage = "GetLanguageExtension[lang] returns langs two letter language extension.";

DotHTML::usage = "";

GetFirstCellContents::usage = "";

Localized::usage = "Localized[key, lang, args___] looks up the localized content for\
 the key in Localization.m, possibly calling it as a function with args.";

BaseName::usage = "BaseName[file] returns the base file name of a full path\
 filename.  For example, /path/to/file.nb -> file.nb.  BaseName[file,\
 Extension->False] causes the file extension to not be included,\
 /path/to/file.nb -> file";

CellToString::usage = "Converts cell expression to String suitable as content for alt tags";

CreateInputForm::usage = "CreateInputForm[cell] returns the InputForm string of a cell."
Options[CreateInputForm] = {PrintErrors->True};

RemoveEmptyCellGroups::usage = "RemoveEmptyCellGroups[ expr, styleList ] removes all single\
 cells in expr that are normally the header cell for CellGroups as identified by the\
 second argument styleList."

MakeActionMenu::usage = "MakeActionMenu[caption, dat]. The caption is the string data which will\
 be shown. The dat is the item data that DocumentationBuild`Utils`GetMoreAboutSectionList[file]\
 returns, for example.";

GetClassificationBoxes::usage = "";

GetMoreAboutSectionList::usage =
  "GetMoreAboutSectionList[nb] returns a list of 'More About' titles from a symbol notebook.";
GetRelatedGuidesSectionList::usage ="";
GetRelatedFunctionsSectionList::usage ="";
GetTechNotesSectionList::usage ="";
GetSeeAlsoSectionList::usage =
  "GetSeeAlsoSectionList[nb] returns a list of 'See Also' functions from a symbol notebook.";
GetTutorialFunctionList::usage =
  "GetTutorialFunctionList[nb] returns a list of functions within Tutorial DefinitionBoxes.";
GetTutorialMoreAboutSectionList::usage =
  "GetTutorialMoreAboutSectionList[nb] returns a list of 'More About' titles from a tutorial notebook.";
GetTutorialsSectionList::usage =
  "GetTutorialsSectionList[nb] returns a list of 'tutorials' from a symbol notebook.";
GetWorkflowsSectionList::usage =
  "GetWorkflowsSectionList[nb] returns a list of 'workflows' from a symbol notebook.";
GetRelatedTutorialsSectionList::usage =
  "GetRelatedTutorialsSectionList[nb] returns a list of 'related tutorials' from a tutorial notebook.";
GetTutorialMoreAboutList::usage =
  "GetTutorialMoreAboutList[nb] returns a list of 'tutorials' from a symbol notebook.";
GetFeaturedExampleMoreAboutSectionList::usage =
  "GetFeaturedExampleMoreAboutSectionList[nb] returns a list of 'related guides' from a notebook.";
GetFeaturedExampleTutorialsSectionList::usage =
  "GetFeaturedExampleTutorialsSectionList[nb] returns a list of 'related guides' from a notebook.";
GetGuideMoreAboutSectionList::usage =
  "GetGuideMoreAboutSectionList[nb] returns a list of 'More About' titles from a guide notebook.";
GetGuideTutorialsSectionList::usage =
  "GetGuideTutorialsSectionList[nb] returns a list of 'tutorials' from a guide notebook.";
GetGuideFunctionList::usage =
  "GetGuideFunctionList[nb] returns an alphabetized list of functions the Guide page..";
GetGuideHowTosList::usage =
  "GetGuideHowTosList[nb] returns a list of how-to links from a guide notebook.";

GetGuidesDirectory::usage =
  "GetGuidesDirectory[dir] returns the path to the 'Guides' directory.";
GetTutorialsDirectory::usage =
  "GetTutorialsDirectory[dir] returns the path to the 'Tutorials' directory.";
GetNotebookIndexQ::usage = 
  "GetNotebookIndexQ[pagetype] returns True or False for whether the pagetype should be indexed.";
GetOverviewButtonLinks::usage = "GetOverviewButtonLinks[uri, language] returns a list previous/next overview links.";

AppendHTMLDirectory::usage = "AppendHTMLDirectory[path] returns ToFileName[{path, 'html'}].";
ExportTOCXML::usage = "ExportTOCXML[filepath, nb, linkbase] returns an xml expression of a documentation TOC nb ready for inclusion in Workbench."
ExportPluginXML::usage = "ExportPluginXML[filepath, nb, linkbase]";
ExportEclipseResourceFiles::usage = "ExportEclipseResourceFiles[dir, nb, linkbase]";

CleanSummaryForWeb::usage = "";

HyperlinkEqualityTest::usage = "Test consecutive ButtonBoxes or StyleBoxes which contain ButtonBoxes for Links with same ButtonData";
ApplyStyleBoxInside::usage = "Utility for MergeButtonBoxes";
MergeButtonBoxes::usage = "Utility for ConvertTextData";
ConvertTextData::usage = "Checks TextData[] using HyperlinkEqualityTest, if so it merges consectutive Style/ButtonBoxes into one ButtonBox";

MakePacletButton::usage = "Turn a normal button box into the appropriate 'paclet:' link."

ConvertButtonBoxesToTemplateBoxes::usage = "ConvertButtonBoxesToTemplateBoxes[nb] changes ButtonBoxes into TemplateBoxes.";
ConfirmButtonBoxesToTemplateBoxes::usage = "ConfirmButtonBoxesToTemplateBoxes[nb] makes sure TemplateBoxes aren't inside TextData.";

MakeCharacterNotesGrid::usage = "MakeCharacterNotesGrid[charImageCell, notesGroup] constructs the side-by-side character/notes grid for character pages.";

FESaveNotebook::usage = "FESaveNotebook[file, nb] saves the nb to file using the FE.";
FETimeConstrained::usage = "";

NotebookSaveVisible::usage = "NotebookSaveVisible[notebook, \"file\"] saves an invisible notebook as a visible notebook."

GetSearchMetaDataList::usage = "";

GetCellsFromCellGroup::usage = "";

BlockMessageOff::usage =
"BlockMessageOff[{symbol1::tag1, symbol2::tag2, ... }, body] evaluates body with
the specified messages turned off. Messages that were on in the first place are
turned back on after body is evaluated."

BuildLog::usage = "";
ShowImageDifferences::usage = "ShowImageDifferences[objA, objB, type] shows the graphical differences of two objects and type (either NB or URL) defines whether these objects are notebooks or urls"

sameLinkTrailsQ::usage = "";
samePacletNameCellQ::usage = "";
notesInNotesSectionQ::usage = "";
seeAlsoInSeeAlsoSectionQ::usage = "";
moreAboutInMoreAboutSectionQ::usage = "";
corruptedCellsQ::usage = "";
samePulldownMenusQ::usage = "";
samePulldownMenuTextQ::usage = "";
buttonBoxDataMissingQ::usage = "";

PreviousNextElementList::usage = "";
GetBlockStyleList::usage="";
FlattenCellGroups::usage="";
MakeComparisonListingCell::usage="";
MakeComparisonItemCell::usage="";

functionAncestorQ::usage="functionAncestorQ[check, totalexpr, subexpr] returns True if check is a 
         function head that appears as such in the totalexpr as an ancestor of subexpr."

MakeThumbnail::usage = "MakeThumbnail[expr] creates two cells: a SuppressedMaterial preview cell, \
and an AlternateThumbnail cell.  The preview cell shows the 300x300 pixel thumbnail at 150x150 size, \
and the AlternateThumbnail cell provides the image used by the build system to make the thumbnail.  \
A standard frame can be added to the thumbnail image with the Framed and FrameMargins options. \
Typically MakeThumnail[expr, Framed->True] suffices. \
To create a thumbnail of an excerpt of the rendering of 'expr', use the option Excerpt->{{l, b}, f} \
where f is the linear fraction of the excerpt and {l, b} is the scaled coordinate of the left bottom corner of the excerpt. \
For example, Excerpt \[Rule] {{.25, .25}, .5} excerpts the center 100x100 subimage of a 200x200 image and \
Excerpt \[Rule] {{0, 0}, .5} excerpts the bottom left quadrant.";

stringReplaceRepeated::usage = "The old chestnut: run StringReplace repeatedly until the expression no longer changes.";
convertWSMLink::usage = "If a string starts with wsm://, convert it to an http:// link.";
convertModelicaLink::ysage = "If a string starts with modelica://, convert it to an http:// link.";

CheckSeeAlsos::usage = "CheckSeeAlsos[nb, lang] removes links from see alsos that are to future or nonexistent pages.";
CheckGuideInlineListings::usage = "CheckGuideInlineListings[nb] removes links from guide inline listings that are to future or nonexistent pages.";

MakeNotesImage::usage = "MakeNotesImage[nbobj] generates the thumbnail list of images for the notes section of ref pages.";

(* format::usage = "format[expr] pretty-prints expr.  Useful in debugging as ToString[format@InputForm[expr]]."; *)

LanguageAbbreviation::usage = "LanguageAbbreviation[language] returns the language's wri-standard ISO 639-1-like abbreviation code: English is en, etc.";
languageList::usage = "A list of languages we use and their wri-standard abbreviations.";

ExportToAnimatedGIF::usage = "";
ExportToMP4::usage = "";

ChangeImageTransparency::usage = "ChangeImageTransparency[img, alpha] will set the alpha channel for a fully opaque image to alpha, or multiply the existing alpha channel values by alpha.";

ChangeGraphicsTransparency::usage = "ChangeGraphicsTransparency[graphics, alpha] will set the transparency in any colors in graphics to alpha.";

Ancestor::usage = "Ancestor[expr, list]: given a node whose Position in expr is given by list, return the node's nearest ancestor that is a cell whose first element is not CellGroupData.  Ancestor[expr, list, test]: given a node whose Position in expr is given by list, return the node's nearest ancestor for which test is True.";

exportFEBitmap::usage = "DocumentationBuild`Utils`exportFEBitmap[filename, string]: retrieve the FEBitmap named 'string' and save it to 'filename', which should most likely be an image file.

DocumentationBuild`Utils`exportFEBitmap[filename, string, format]: as before, but explicitly specify an image format for the output file.";
  
exportFEBitmap::nofile="exportFEBitmap failed to generate file `1`.";
exportFEBitmap::zerofile="exportFEBitmap output file `1` has zero bytes.";
exportFEBitmap::nobitmap="The requested FEBitmap name `1` is not available.";

BuildCitation::usage = "BuildCitation[historyCell, type] creates a textual citation for insertion into the page.";
BuildCitationCell::usage = "BuildCitationCell[citation] builds the Citation cell group from a textual citation.";

NestedLookup::usage = "NestedLookup[map, {keys__}, default] iteratively uses keys to index into map, returning default if any key does not exist at the associated level";

(* Note: ReplaceAt was added in v13.1; this definition is kept for compatibility with earlier WL versions. *)
replaceAt::usage = "replaceAt[expr, pos, rules] applies a rule or list of rules in an attempt to transform the part of expr at pos.";

compoundDuration::usage = "Given a duration in seconds, report it in weeks, days, hours, minutes, seconds.";
partitionList::usage = "Given a list of numbers, partition it into lists whose Totals are nearly equal.";

containsLinkQ::usage = "True if an expression contains known elements of links.  Expand its knowledge as needed.";

decamel::usage = "In[x]:= decamel[#, \"Lowercase\" -> True, \"Separator\" -> \"-\"]& /@ {\"Plot3D\", \"AbcDef\", \"ZIPCode\"}
Out[x]= {plot-3d, abc-def, zip-code}";

GetFeaturesetFunctions::usage = "GetFeaturesetFunctions[funcs_List, guides_List] will return a list of symbols with funcs leading and the symbols on the guides appended.";
GetFeaturesetDocsThumbnails::usage = "GetFeaturesetDocsThumbnails[uri, urlPrefix, windowsize, headersize]";

Begin["`Private`"];

(******************************************************************************)
(* Generic Utilities                                                          *)
(******************************************************************************)

(* NestedLookup routine, copied from the NestedLookup Wolfram Function Repository item. *)

Attributes[NestedLookup] = {HoldAllComplete}
Options[NestedLookup] = {}

NestedLookup[keys_][a_, arg___] := NestedLookup[a, keys, arg]

NestedLookup[a_, {seq___}, default_] :=
 Catch[iNestedLookup[a, {seq}, {}, default], NestedLookup]

NestedLookup[a_, key : Except[_List], default_] :=
 NestedLookup[a, {key}, default]

NestedLookup[a_, {seq___}] := NestedLookup[a, {seq}, Automatic]


Attributes[iNestedLookup] = {HoldAllComplete}

iNestedLookup[a_, {key_, seq___}, {traversed___}, default_] := iNestedLookup[
  checkLookup[
    a,
    key,
    Throw[Replace[
      default,
      Automatic :> Missing["KeySequenceAbsent", {traversed, key}]
    ], NestedLookup]
  ],
  {seq},
  {traversed, key},
  default
]

iNestedLookup[a_, {}, _, _] := a

Options[iNestedLookup] = {}

Attributes[checkLookup] = {HoldAllComplete}

checkLookup[a_, key_, default_] := Quiet[
  Check[
    Lookup[If[DispatchQ[a], Normal[a], a], key, default],
    Message[NestedLookup::invrl, a];
    default,
    Lookup::invrl
  ],
  Lookup::invrl
]

(****************************************************************************************)

(*--------------------------------*)
(* Canonicalize the 2nd argument. *)
(*--------------------------------*)

replaceAt[expr0_, index_?IntegerQ, rules_] :=
	replaceAt[expr0, {{index}}, rules]

replaceAt[expr0_, position : {___?IntegerQ}, rules_] :=
	replaceAt[expr0, {position}, rules]

(*--------------------------------*)
(* Canonicalize the 3rd argument. *)
(*--------------------------------*)

replaceAt[
	expr0_,
	positions : {{___?IntegerQ} ...},
	rule : (_ ~ (Rule|RuleDelayed) ~ _)
] := replaceAt[expr0, positions, {rule}]

(*------------------*)
(* Main definition. *)
(*------------------*)

replaceAt[
	expr0_,
	positions : {{___?IntegerQ} ...},
	rules : {(_ ~ (Rule|RuleDelayed) ~ _) ...}
] := Module[{
	expr = expr0
},
	Scan[
		Function[pos,
			Part[expr, Sequence @@ pos] = Replace[Part[expr, Sequence @@ pos], rules];
		],
		positions
	];

	expr
]

(******************************************************************************)
(** Small Utilities *)

(* DocumentationBuild`Utils`languageList *)
languageList = {
  "English"    -> "en",
  "Japanese"   -> "ja", 
  "Spanish"    -> "es", 
  "Russian"    -> "ru",
  "Korean"     -> "ko",
  "German"     -> "de",
  "French"     -> "fr",
  "Portuguese" -> "pt-br",
  "ChineseSimplified" -> "zh"
};

LanguageAbbreviation::nolang = "Language `1` is not provided for in DocumentationBuild`Utils`LanguageAbbreviation.  Assuming you meant English.";

(* DocumentationBuild`Utils`LanguageAbbreviation *)
LanguageAbbreviation[language_String] := Module[{res},
  res = language /. languageList;
  If[res == language, Message[LanguageAbbreviation::nolang, language]; res = "en"];
  Return[res]
]

(** AddSpaces **)
AddSpaces[c_String]:= StringReplace[c, {","->", "}];
AddSpaces[c_List]:= AddSpaces /@ c;
AddSpaces[XMLElement[tag_, attr_, c_]]:= XMLElement[tag, attr, AddSpaces /@ c];
AddSpaces[s__String] := AddSpaces[StringJoin[s]]
AddSpaces[expr__ ] := Sequence@@({expr} /. x:(_XMLElement|_String):>AddSpaces[x])

(** AddSpaces **)
AddSpans[c_String]:= If[!StringFreeQ[c, {"|", ",", "[", "]", "{", "}", "(", ")"}], 
	XMLElement["span", {"class"->"specialcharacters"}, Characters[c] /. {
	"|" -> XMLElement["span", {"class" -> "verticalbar"}, {"|"}],
	"," -> XMLElement["span", {"class" -> "comma"}, {","}],
	"[" -> XMLElement["span", {"class" -> "openbracket"}, {"["}],
	"]" -> XMLElement["span", {"class" -> "closebracket"}, {"]"}],
	"{" -> XMLElement["span", {"class" -> "openbrace"}, {"{"}],
	"}" -> XMLElement["span", {"class" -> "closebrace"}, {"}"}],
	"(" -> XMLElement["span", {"class" -> "openparenthesis"}, {"("}],
	")" -> XMLElement["span", {"class" -> "closeparenthesis"}, {")"}]
	}],
	c];
AddSpans[c_List]:= AddSpans /@ c;
AddSpans[XMLElement[tag_, attr_, c_]]:= XMLElement[tag, attr, AddSpans /@ c];
AddSpans[s__String] := AddSpans[StringJoin[s]]
AddSpans[expr__ ] := Sequence@@({expr} /. x:(_XMLElement|_String):>AddSpans[x])

(** AddSpaceToCamelCase **)
AddSpaceToCamelCase[str_String] :=
  Module[{lst, opts},
  	opts = Alternatives["WorldPlot", "GUIKit", "MSP", "XML", "DatabaseLink",
                     "JLink", "NETLink", "MathLink", "ANOVA", "J/Link",
                     "WebServices", "XMLSchema", "webMathematica", "CUDALink", 
                     "TetGenLink", "GPUTools", "DLLTools", "OpenCLLink", "FDLLink", 
                     "SystemModeler", "RLink", "HTTPClient", "LibraryLink", "FEM", "PDE"];
    If[StringMatchQ[str, ___ ~~ opts ~~ ___],
      Return[StringReplace[str, some___ ~~ opt:opts ~~ rest___ :> 
      	AddSpaceToCamelCase[some] <> opt <> If[StringLength[rest] > 0, " ", ""] <> AddSpaceToCamelCase[rest]]] ];
    StringReplace[
      StringReplace[str, 
        RegularExpression["(?<![ 0-9$]|^)([A-Z])"] -> " $1"], 
      {RegularExpression["^\\s"] -> "", RegularExpression["\\s+"] -> " "}]
  ];
AddSpaceToCamelCase[TextData[c___]] := TextData[c];
AddSpaceToCamelCase[s___] := (Message[AddSpaceToCamelCase::args, s]; $Failed);
AddSpaceToCamelCase::args = "Expected string but found: `1`";

(** ReplaceCharacters **)
ReplaceCharacters[str_String, search_String, rep_] :=
  Flatten[StringSplit[str, search -> rep]];
ReplaceCharacters[Cell[TextData[lst_List], r___], search_String, rep_] :=
 Cell[TextData[Flatten[
    If[Head@# === String,
       ReplaceCharacters[#, search, rep],
       #
       ] & /@ lst]], r
  ];
ReplaceCharacters[Cell[str_String, r___], search_String, rep_] :=
  ReplaceCharacters[str, search, rep];

makeTitleModiferString[tm_List] := Module[{},
  Which[
   Length[tm] === 0, "",
   Length[tm] === 1, "(" <> tm[[1]] <> ")",
   Length[tm] > 1, "(" <> StringJoin[Riffle[tm, ", "]] <> ")",
   True, ""]];

(** StringList **)
StringList[s_]:= If[Length[s] > 0, StringJoin[First[s], (", " <> #) & /@ Rest[s]], ""];

ToStringList[lis_List] := Which[Length[lis] < 1, " ",
   Length[lis] === 1, StringJoin[lis],
   True, StringJoin[Riffle[lis, ", "]]
   ];

ToStringList[lis_] := "";

titlemaker[title_String] := 
 Module[{}, 
  ToLowerCase[
   StringReplace[
    title, {" " -> "-", "\[EAcute]" -> "e", "\[Not]\[EAcute]" -> "e", 
     "\[Hyphen]" -> "-", "-" -> "-",  ":"->"-", "&" -> "And", "\[Pi]"->"pi" }]]];
     
NumberToLetter[num_String] := 
 Module[{}, FromCharacterCode[96 + ToExpression[num]]];

(** MakeCamelCaseString **)
MakeCamelCaseString[str_String] := 
  StringReplace[
    StringReplace[str, {
      "&" -> "And",
      "-" -> " ",
      ("/"|"{"|"}"|"'"|"\""|","|":"|"."|"["|"]") -> ""
    }],
    RegularExpression["\\s(\\w)"] :> ToUpperCase["$1"]
  ];
MakeCamelCaseString[c___] := 
  MakeCamelCaseString@Transmogrify`ConvertToString[c];

(** CapitalizeString **)
CapitalizeString[str_String]:= StringReplace[str, RegularExpression["(\\w*)"] :> ToUpperCase["$1"]];
CapitalizeString[expr___]:= (Message[CapitalizeString::str,expr]; expr);
CapitalizeString::str = "Expected String found: `1`";

(** LowercaseString **)
LowercaseString[str_String]:= StringReplace[str, RegularExpression["(\\w*)"] :> ToLowerCase["$1"]];
LowercaseString[expr___]:= (Message[LowercaseString::str,expr]; expr);
LowercaseString::str = "Expected String found: `1`";

(** GetQuietly **)
GetQuietly[name_String] := (Off[Syntax::"newl"]; Get[name]);

(** Get first cell in nb -- Used within DocumentFlag[] **)
FirstCell[ nbFile_String] := GetQuietly[nbFile][[1, 1]];

(** DocumentFlag **)
(* DocumentFlag[ nbfile_String] :=
Replace[ FirstCell[ nbfile],
{
  Cell[_,
    flagStyle:(
      "ObsoleteFlag" |
      "InternalFlag" |
      "TemporaryFlag" |
      "PreviewFlag" | 
      "FutureFlag" |
      "ExcisedFlag"
    ),
    ___] :>
      flagStyle,
  _ -> None
}]; *)

DocumentFlag[nb_String] := DocumentFlag[GetQuietly[nb]];

DocumentFlag[expr_Notebook]:=
Module[{f, g},
  f = Cases[expr, Cell[_, "ObsoleteFlag"|"InternalFlag"|"TemporaryFlag"|"PreviewFlag"|"FutureFlag"|"ExcisedFlag"|"AwaitingFutureDesignReviewFlag", ___], Infinity];
  g = ScreenStyleEnvironment /. Options[expr];
  
  If[Length[f] < 1 && ! MatchQ[g, ScreenStyleEnvironment | "Working"],
    f = Switch[g,
     "InternalDocument", {{"", "InternalFlag"}},
     "ObsoleteObject" | "FutureObject" | "ExcisedObject" | "TemporaryObject",
     {{"", StringReplace[g, "Object" -> "Flag"]}},
     _,
     f]
    ];
  
  If[Length@f > 0,
  	If[Length[Cases[expr, "U N D E R   D E V E L O P M E N T", Infinity]]>0, 
  		Switch[Part[List@@First@f,2], 
  			"ObsoleteFlag", None,
  			"InternalFlag", Part[List@@First@f,2],
  			"TemporaryFlag", None,
  			"PreviewFlag", None,
  			"FutureFlag", None,
  			"ExcisedFlag", Part[List@@First@f,2],
  			"AwaitingFutureDesignReviewFlag", None,  
  			_ , Part[List@@First@f,2]], 
  			Part[List@@First@f,2]
  			],  
  	None]
];

(** ConvertFileQ **)
ConvertFileQ[ file_String]:= ConvertFileQ[ GetQuietly@file];

ConvertFileQ[expr_Notebook]:=
Module[{ convert},
  convert = Cases[expr, Rule[TaggingRules, {___, Rule["UndeployInDocsBuild", val_], ___}] :> val, Infinity, 1];
  If[convert === {True}, False, True]
];

(* Returns True if `infile` is a member of `ignorefile`. *)
ConvertFileQ[infile_String, ignorefiles_List] :=
	And[
		Length[ignorefiles] > 0,
		MemberQ[Alternatives @@ ignorefiles, FileNameTake[infile]]
	]

(** UnsortedUnion **)

(*
v7's DeleteDuplicates (the long-awaited 2008 wri implementation of UnsortedUnion) is about 8x faster than using Sow/Reap:

In[4]:= Table[Timing[Table[UnsortedUnion   [RandomChoice[Range[10], 10]], {10000}]] // First, {10}] /
        Table[Timing[Table[DeleteDuplicates[RandomChoice[Range[10], 10]], {10000}]] // First, {10}]

Out[4]= {7.57375, 8.13448, 6.78032, 8.15619, 9.20515, 9.65895, 9.365, 8.63653, 8.2962, 8.29851}
*)

(* UnsortedUnion[list_List]:= Reap[Sow[1, list], _, # &][[2]] *)
UnsortedUnion = DeleteDuplicates;

(** GetLanguageExtension **)
GetLanguageExtension[ext_String] := Switch[ext, "Japanese", "ja", "ChineseSimplified", "zh", "Spanish", "es", _, "en"];

(** DotHTML **)
DotHTML[s_String] :=
  If[StringMatchQ[s, "*#*"],
    (StringTake[s, #] <> ".html" <> StringDrop[s, #])&[StringPosition[s, "#"][[-1, -1]] - 1],
    s<> ".html" ];

(* get string form of first cell in nb *)
GetFirstCellContents[nb_Notebook] := 
  GetFirstCellContents[Cases[nb, Cell[c_, ___] :> c, Infinity]];
GetFirstCellContents[{l_, ___}] := GetFirstCellContents[l];
GetFirstCellContents[s_String] := s;
GetFirstCellContents[___] := $Failed;

(** IsManipulateQ **)
IsManipulateQ[___]:= False;
IsManipulateQ[c_Cell]:= Not[FreeQ[c, Manipulate`InterpretManipulate]];

(** IsSoundQ **)
IsSoundQ[___]:= False;
IsSoundQ[c_Cell]:= Not[FreeQ[c, Sound]];

(** IsAudioQ **)
IsAudioQ[___]:= False;
IsAudioQ[c_Cell]:= Not[FreeQ[c, Audio]];

(******************************************************************************)
(** Localized **)
$Localization := $Localization = Dispatch[Get[DocsAsset["LocalizationData"]]];
Localized::nokey = "Localized could not find the key `1`.";
Localized::nolang = "Localized could not find the `1` translation of `2`.";
Localized[key_, lang_, args___] :=
  Module[{vals, val},
    vals = key /. $Localization;
    If[vals === key,
      Message[Localized::nokey, key];
      Return[None]];
    If[MatchQ[vals, {___, lang -> _, ___}],
        val = lang /. vals,
        Message[Localized::nolang, lang, key];
        val = "English" /. vals
    ];
    If[Length[{args}] > 0, val[args], val]
  ];


(******************************************************************************)
(** GetNotebookIndexQ **)
GetNotebookIndexQ::arg = "String expected as input but value was: `1`";
GetNotebookIndexQ[c___]:= (Message[GetNotebookIndexQ::arg, c]; False);
GetNotebookIndexQ[type_String]:=
  Switch[type,
    (*"Message", False,*)
    "HowTo", False,
    _, True
  ];


(******************************************************************************)
(** BaseName **)

Options[BaseName] = {"Extension" -> True};
BaseName[f_String,opts___?OptionQ]:= (
  If[("Extension" /. {opts} /. Options[BaseName])===True,
    #,
    StringReplace[#, RegularExpression["\\.\\w+$"] :> ""]
  ]&@ StringReplace[f, DirectoryName[f]->""]
);



(******************************************************************************)
(** CellToString **)
TextCharacterReplacementRules := TextCharacterReplacementRules =
  Get[DocsAsset["TextCharacterReplacementRules"]];

Parenth[x_String?((StringLength[#] == 1)&)] := x;
Parenth[x_, ___] := {"(", x, ")"};

CellToString[mycell_] :=
  StringReplace[
    StringJoin[
      ToString/@Flatten[
        {mycell //. {
          Cell[x__, ("NumberedEquation" | "NumberedEquationArray" | "NumberedEquations"), ___]
            :> {" ", x, " "},
          Cell[x__, ("JSP" | "JPG"), ___] :> {},
          Cell[x__, ___] :> x,
          TextData[x__] :> x,
          RowBox[x__] :> x,
          FormBox[x__, ___] :> x,
          ButtonBox[x__, ___] :> x,
          BoxData[x__] :> x,
          SubsuperscriptBox[x__, y__, z__]
            :> {x, "_", Parenth[y], "^", Parenth[z]},
          SuperscriptBox[x__, y__]
            :> {x, "^", Parenth[y]},
          SubscriptBox[x__, y__]
            :> {x, "_", Parenth[y]},
          FractionBox[x__, y__]
            :> {Parenth[x], "/", Parenth[y]},
          SqrtBox[x__] :> {"sqrt(", x, ")"},
          StyleBox[x__, ___] :> x,
          GridBox[x__, ___]
            :> Riffle[Riffle[#, {" "}]& /@ x, {"; "}],
          UnderoverscriptBox[x__, y__, z__]
            :> {x, "_", Parenth[y], "^", Parenth[z]},
          UnderscriptBox[x__, y__]
            :> {x, "_", Parenth[y]},
          OverscriptBox[x__, y__]
            :> {x, "^", Parenth[y]},
          TagBox[x__, ___] :> x
      }}]
    ],
    TextCharacterReplacementRules];


(******************************************************************************)
(** CreateInputForm **)
CreateInputForm::str = "Incorrect output: `1`";
CreateInputForm[c : Cell[___], opts___] := 
  Developer`UseFrontEnd@Module[{nbObj, newish, nbExpr, expr},
    If[IsManipulateQ[c], " ",
      newish = 1;
      If[newish === 1,
        nbExpr = MathLink`CallFrontEnd[ExportPacket[c, "InputText"]], 
        (* Else *)
        nbObj = NotebookPut@Notebook[{c}];
        FrontEndExecute[FrontEnd`FrontEndToken[nbObj, "SelectAll"]];
        FrontEndExecute[FrontEnd`FrontEndToken[nbObj, "CopySpecial", "InputText"]];
        nbExpr = NotebookGet[ClipboardNotebook[]];
        NotebookClose[nbObj];
      ];
      expr = GetFirstCellContents[nbExpr];
      expr = If[StringQ@expr, 
        expr = Transmogrify`ConvertToString@expr;
        FixedPoint[StringReplace[#, RegularExpression["(\r|\n)+"] :> "\n"]&, expr],
        (* Else *)
        expr];
      If[(Head@expr =!= String) || (StringLength@expr < 1), 
        If[!FAILED,
          FAILED=True;
          Export["CreateInputFormFailed.m", {Global`PageTitleForCreateInputForm, c, nbExpr, expr}];
        ];
        Message[CreateInputForm::str,expr]; $Failed, 
        expr]
  ]];


(******************************************************************************)
(** RemoveEmptyCellGroups **)

RemoveEmptyCellGroups[ expr_, style__String ] := RemoveEmptyCellGroups[ expr, {style} ]

RemoveEmptyCellGroups[ expr_, styles:{__String} ]:= 
  Module[{ex, pos},
    (* This seems to happen from time to time *)
    ex = DeleteCases[expr, Cell[CellGroupData[{}, ___], ___], Infinity];
    (* First we find and delete all appropriately-styled non-inline
       cells that are not the lead cell of a CellGroupData. *)
    pos = Position[ex, Cell[_, Alternatives@@styles, ___], Infinity];
    pos = Select[pos,
        And[
            MemberQ[{CellGroupData, Notebook}, Head@First@Extract[ex, {Drop[#, -2]}]],
            Last[#] =!= 1]&];
    pos = Select[pos,
      (!MatchQ[First[Extract[ex, {#}]], Cell[___, CellTags->"IncludedEmptySection", ___]])&];
    ex = Delete[ex, pos];
    (* Then we delete Cell@CellGroupData expressions containing
       only appropriately-styled lead cells. *)
    While[(
        pos = Position[ex,
          (Cell[CellGroupData[{}, ___], ___] | 
           Cell[CellGroupData[{Cell[_, Alternatives@@styles, ___]}, ___], ___] |
           Cell[CellGroupData[{Cell[_, Alternatives@@styles, ___], Cell[TextData[{}], ___]}, ___], ___]),
          Infinity];
        pos = Select[pos,
          (!MatchQ[First[Extract[ex, {#}]], Cell[___, CellTags->"IncludedEmptySection", ___]])&];
        Length[pos] > 0),
      ex = Delete[ex, pos]
    ];
    ex];


(******************************************************************************)
(** MakeActionMenu **)

Options[MakeActionMenu] = {"Appearance" -> None, FieldSize->Automatic};

MakeActionMenu[caption_String, style_String, dat_List, opts___?OptionQ] :=
  MakeActionMenu[Cell[TextData[caption]], style, dat, opts];

MakeActionMenu[caption_TextCell, style_String, dat_List, opts___?OptionQ] := 
  Module[{outList = {}, uri, action},
    appear = "Appearance" /. {opts} /. Options[MakeActionMenu];
    ClearAttributes[RuleDelayed, HoldRest];
    Scan[
      Function[{i},
        Which[
        dat[[i]] === Delimiter,
        AppendTo[outList, dat[[i]]],
        MatchQ[dat[[i]], {Style[__] | _String, None}],
        AppendTo[outList, dat[[i]][[1]] :> NBFindXXXX[evnb[], "SeeAlsoSection", All, CellStyle]],
        True,
        uri = If[StringMatchQ[dat[[i]][[2]], "paclet*"], dat[[i]][[2]], "paclet:" <> dat[[i]][[2]] ];
        action = ActionXXXX[uri];
        AppendTo[outList, dat[[i]][[1]] :> action]];
      ],
      Range[Length[dat]] ];
    SetAttributes[RuleDelayed, HoldRest];
    outList = outList /. {ActionXXXX -> Documentation`HelpLookup, NBFindXXXX -> NotebookFind, evnb -> EvaluationNotebook};
    ActionMenu[Framed[caption], outList, MenuStyle->style, Appearance -> appear, MenuAppearance -> Automatic]
  ];
  
MakeActionMenu[boxes_PaneSelectorBox, style_, dat_List, OptionsPattern[]] :=
  Module[{outList = {}, uri, action, appear, size},
    appear = OptionValue["Appearance"];
    size = OptionValue[FieldSize];
    ClearAttributes[RuleDelayed, HoldRest];
    Scan[
      Function[{i},
        uri = If[StringMatchQ[dat[[i]][[2]], "paclet*"], dat[[i]][[2]], "paclet:" <> dat[[i]][[2]] ];
        action = ActionXXXX[uri];
        AppendTo[outList, dat[[i]][[1]] :> action];
      ],
      Range[Length[dat]] ];
    SetAttributes[RuleDelayed, HoldRest];
    outList = outList /. ActionXXXX -> Documentation`HelpLookup;
    ActionMenuBox[boxes, outList, MenuStyle->style, Appearance -> appear, MenuAppearance -> Automatic, FieldSize->size]
  ];


(******************************************************************************)
(** GetClassificationBoxes **)

GetClassificationBoxes::args = "Incorrect arguments: `1`";

GetClassificationBoxes[nb_String, lang_String:"English", opts:OptionsPattern[]] :=
  GetClassificationBoxes[GetQuietly[nb], lang, opts];

GetClassificationBoxes[nb_Notebook, lang_String:"English", opts:OptionsPattern[]] :=
  GetClassificationBoxes[GetNotebookInfo[nb], lang, opts];

GetClassificationBoxes[info_List, lang_String:"English", opts:OptionsPattern[]] :=
  Module[{type, paclet, pacletQ, flag},
    type = "EntityType" /. info;
    paclet = "PacletName" /. info;
    flag = "Flag" /. info;
    GetClassificationBoxes[type, paclet, flag, lang, opts]
  ];

GetClassificationBoxes["Net Function", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["NetFunctionClassification", lang];
  
GetClassificationBoxes["Workflow", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["WorkflowClassification", lang];
  
GetClassificationBoxes["Workflow Guide", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["WorkflowGuideClassification", lang];

GetClassificationBoxes["Character Name", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["CharacterNameClassification_Rebranded", lang], Localized["CharacterNameClassification", lang]];
  	
GetClassificationBoxes["Device Connection", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["DeviceClassification_Rebranded", lang], Localized["DeviceClassification", lang]];
  	
GetClassificationBoxes["Data Structure", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["DataStructureClassification", lang];
  	
GetClassificationBoxes["Service Connection", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["ServiceClassification_Rebranded", lang], Localized["ServiceClassification", lang]];
  	
GetClassificationBoxes["Embedding Format", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["EmbeddingFormatClassification_Rebranded", lang], Localized["EmbeddingFormatClassification", lang]];

GetClassificationBoxes["Net Encoder", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["NetEncoderClassification", lang];
  
GetClassificationBoxes["Net Decoder", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["NetDecoderClassification", lang];
  
GetClassificationBoxes["MLModel", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["MLModelClassification", lang];

GetClassificationBoxes["Classifier", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["ClassifierClassification", lang];
  
GetClassificationBoxes["Compiled Type", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["CompiledTypeClassification", lang];

GetClassificationBoxes["Predictor", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["PredictorClassification", lang];

GetClassificationBoxes["Blockchain", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["BlockchainClassification", lang];
  
GetClassificationBoxes["Database Connection", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["DatabaseConnectionClassification", lang];

GetClassificationBoxes["External Evaluation System", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["ExternalEvaluationSystemClassification", lang];
  	
GetClassificationBoxes["Interpreter", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["InterpreterClassification_Rebranded", lang], Localized["InterpreterClassification", lang]];
  	
GetClassificationBoxes["Entity", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["EntityClassification", lang];

GetClassificationBoxes["Example", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["ExampleClassification_Rebranded", lang], Localized["ExampleClassification", lang]];

GetClassificationBoxes["File", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]]:= 
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["FileClassification_Rebranded", lang], Localized["FileClassification", lang]];

GetClassificationBoxes["Format", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["FormatClassification_Rebranded", lang], Localized["FormatClassification", lang]];

GetClassificationBoxes[("Front End Object" | "FE Token"),
                       ("" | "Mathematica"),
                       _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["FrontEndObjectClassification_Rebranded", lang], Localized["FrontEndObjectClassification", lang]];

GetClassificationBoxes["Guide", "Compatibility Package", _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["CompatibilityGuideClassification_Rebranded", lang], Localized["CompatibilityGuideClassification", lang]];

GetClassificationBoxes["HowTo", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["HowToClassification_Rebranded", lang], Localized["HowToClassification", lang]];
  
GetClassificationBoxes["Indicator", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["IndicatorClassification_Rebranded", lang], Localized["IndicatorClassification", lang]];
  
GetClassificationBoxes["MathLink C Function", "Mathematica", "ObsoleteFlag", lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["ObsoleteMathLinkClassification_Rebranded", lang], Localized["ObsoleteMathLinkClassification", lang]];

GetClassificationBoxes["MathLink C Function", "Mathematica", _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["MathLinkClassification_Rebranded", lang], Localized["MathLinkClassification", lang]];
  
GetClassificationBoxes["PythonLink Python Function", "Mathematica", _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["PythonLinkClassification_Rebranded", lang], Localized["PythonLinkClassification", lang]];
  
GetClassificationBoxes["LibraryLink C Function", "Mathematica", _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["LibraryLinkClassification_Rebranded", lang], Localized["LibraryLinkClassification", lang]];

GetClassificationBoxes["LibraryLink C Function", "LibraryLink", _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["LibraryLinkClassification_Rebranded", lang], Localized["LibraryLinkClassification", lang]];

GetClassificationBoxes["Menu Item", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["MenuItemClassification_Rebranded", lang], Localized["MenuItemClassification", lang]];

GetClassificationBoxes["Message", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["MessageClassification_Rebranded", lang], Localized["MessageClassification", lang]];
  	
GetClassificationBoxes["Method", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["MethodClassification_Rebranded", lang], Localized["MethodClassification", lang]];

GetClassificationBoxes["Note", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["NoteClassification_Rebranded", lang], Localized["NoteClassification", lang]];

GetClassificationBoxes["Overview", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["OverviewClassification_Rebranded", lang], Localized["OverviewClassification", lang]];
  	
GetClassificationBoxes["Program", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["ProgramClassification_Rebranded", lang], Localized["ProgramClassification", lang]];
  	
GetClassificationBoxes["Question Interface", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["QuestionInterfaceClassification", lang];
  	
GetClassificationBoxes["Remote Batch Computation Provider", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["BatchComputationProviderClassification", lang];
  
GetClassificationBoxes["ResourceObject"|"Resource Object", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["ResourceObjectClassification", lang];

GetClassificationBoxes["Symbol", "Mathematica", "PreviewFlag", lang_String:"English", opts:OptionsPattern[]]:= 
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["PreviewClassification_Rebranded", lang], Localized["PreviewClassification", lang]];

GetClassificationBoxes["Symbol", "Mathematica", "AwaitingFutureDesignReviewFlag", lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["FutureDesignReviewClassification_Rebranded", lang], Localized["FutureDesignReviewClassification", lang]];

GetClassificationBoxes["Symbol", "Mathematica", "ObsoleteFlag", lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["ObsoleteSymbolClassification_Rebranded", lang], Localized["ObsoleteSymbolClassification", lang]];

GetClassificationBoxes["Symbol", "Mathematica", _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["SymbolClassification_Rebranded", lang], Localized["SymbolClassification", lang]];
  
GetClassificationBoxes["Symbol", "", _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["SymbolClassification_Rebranded", lang], Localized["SymbolClassification", lang]];

(*GetClassificationBoxes["Symbol", paclet_, _, lang_String:"English"] :=
  Localized["PacletSymbolClassification", lang][paclet]; *)

GetClassificationBoxes["System Program", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["SystemProgramClassification_Rebranded", lang], Localized["SystemProgramClassification", lang]];

GetClassificationBoxes[("Tutorial" | "Upgrade Information" | "Compatibility Package"),
                       "Compatibility Package", _,
                       lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["CompatibilityInformationClassification_Rebranded", lang], Localized["CompatibilityInformationClassification", lang]];
  
  
GetClassificationBoxes["Tutorial", ("" | "Mathematica"), "ObsoleteFlag", lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["ObsoleteTutorialClassification_Rebranded", lang], Localized["ObsoleteTutorialClassification", lang]];

GetClassificationBoxes["Tutorial", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["TutorialClassification_Rebranded", lang], Localized["TutorialClassification", lang]];
  	
GetClassificationBoxes["Monograph"|"Monograph Overview", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["MonographClassification", lang];
  
GetClassificationBoxes["Tech Note", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["TechNoteClassification", lang];
  
GetClassificationBoxes["Text Content", ("" | "Mathematica"), _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["TextContentClassification", lang];
  
GetClassificationBoxes["UnityLink C# Function", "UnityLink"|"Mathematica", _, lang_String:"English", opts:OptionsPattern[]] :=
  Localized["UnityLinkClassification", lang];

GetClassificationBoxes["Guide", ("" | "Mathematica"), None, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["MathematicaGuideClassification_Rebranded", lang], Localized["MathematicaGuideClassification", lang]];

GetClassificationBoxes["ExamplePage", _, _, lang_String:"English", opts:OptionsPattern[]] :=
  If[TrueQ["Rebranded" /. {opts}], 
  	Localized["ExamplePage_Rebranded", lang], Localized["ExamplePage", lang]];

(* TODO Handle this catch all routine for localizing M- calssifications *)
GetClassificationBoxes[str_String, ("" | "Mathematica"), None, lang_String:"English", opts:OptionsPattern[]] :=
  TextData[{
    StyleBox["Mathematica", Rule[FontSlant, "Italic"]], " ", str}];

GetClassificationBoxes[type_, paclet_, flag_, lang_String:"English", opts:OptionsPattern[]]:= 
  Module[{pn=paclet, typestr},
    typestr = Localized[type, lang];
    If [(paclet =!= "") && (paclet =!= None),
      (
        pn = If[StringMatchQ[pn, "*Package"], {
            StyleBox[
              AddSpaceToCamelCase@StringReplace[pn, RegularExpression["\\s+Package\\s*$"]->""],
              FontSlant->"Italic"],
            Localized["Package", lang]
          },
          StyleBox[AddSpaceToCamelCase@pn , FontSlant->"Italic"] ];
        TextData[Riffle[Flatten@{flag, pn, typestr} /. {"ObsoleteFlag"->"Obsolete ", None|"" -> Sequence[]}, " "]]
      ),
      StringJoin @@ Riffle[Flatten@{flag, pn, typestr} /. {"ObsoleteFlag"->"Obsolete ", None|"" -> Sequence[]}, " "]
  ]];

GetClassificationBoxes[a___]:= (Message[GetClassificationBoxes::args, a]; $Failed);


(******************************************************************************)
(* Remove single and double quotes for Web meta description *)
CleanSummaryForWeb[{desc_String}]:= (
   {StringReplace[desc, {"'" -> "&apos;", "\"" -> "&quot;"}]}
   );
CleanSummaryForWeb[desc_String]:= (
   StringReplace[desc, {"'" -> "&apos;", "\"" -> "&quot;"}]
   );
(* end CleanSummaryForWeb *)


(******************************************************************************)
(* Igor's code for converting consecutive ButtonBoxes/StyleBoxes with the same ButtonData.*)
HyperlinkEqualityTest[
   StyleBox[ButtonBox[con1_, buttonOpts1___], styopts1___], 
   StyleBox[ButtonBox[con2_, buttonOpts2___], 
    styopts2___]] := (HyperlinkEqualityTest[
    ButtonBox[con1, buttonOpts1], ButtonBox[con2, buttonOpts2]]);

HyperlinkEqualityTest[ButtonBox[con1_, buttonOpts1___], 
   StyleBox[ButtonBox[con2_, buttonOpts2___], 
    styopts2___]] := (HyperlinkEqualityTest[
    ButtonBox[con1, buttonOpts1], ButtonBox[con2, buttonOpts2]]);

HyperlinkEqualityTest[
   StyleBox[ButtonBox[con1_, buttonOpts1___], styopts1___], 
   ButtonBox[con2_, buttonOpts2___]] := (HyperlinkEqualityTest[
    ButtonBox[con1, buttonOpts1], ButtonBox[con2, buttonOpts2]]);

HyperlinkEqualityTest[ButtonBox[contents1_, buttonOpts1___], 
   ButtonBox[contents2_, 
    buttonOpts2___]] := (MemberQ[{buttonOpts1}, 
     BaseStyle -> sty_/;MemberQ[{sty},"Hyperlink" | "Link",Infinity]] && 
    MemberQ[{buttonOpts2}, 
     BaseStyle -> 
      sty_/;MemberQ[{sty},"Hyperlink" | "Link",Infinity]] && ((ButtonData /. {buttonOpts1} /. 
        ButtonData :> contents1) === (ButtonData /. {buttonOpts2} /. 
        ButtonData :> contents2)));

HyperlinkEqualityTest[otherwise__] = False;

(*ApplyStyleBoxInside[]-Takes StyleBoxes that are outside a ButtonBox \
and applies it to the contents of the ButtonBox (places it \
"inside").IgorA.Dec/2007.*)

ApplyStyleBoxInside[
   StyleBox[ButtonBox[contents_, buttonopts___], 
    styopts___]] := (ButtonBox[StyleBox[contents, styopts], 
    buttonopts]);

ApplyStyleBoxInside[
   StyleBox[ButtonBox[contents_, buttonopts___], style : "", 
    styopts___]] := (ButtonBox[StyleBox[contents, style, styopts], 
    buttonopts]);

ApplyStyleBoxInside[else__] := else;

(*MergeButtonBox[]-Extracts the BaseStyle and ButtonData of the first \
ButtonBox extracts the contents of all ButtonBoxes (which already \
have StyleBoxes wrapped around them when necessary),and returns a \
single,new ButtonBox.IgorA.Dec/2007.*)

MergeButtonBoxes[cells_List] := 
  Module[{buttons, firstButton, contents, bstyle, bdata}, 
   buttons = ApplyStyleBoxInside /@ cells;
   firstButton = First@Cases[buttons, _ButtonBox, Infinity];
   bstyle = Options[firstButton, BaseStyle] /. {{} -> "Hyperlink"};
   bdata = Options[firstButton, ButtonData] /. {{} -> "#"};
   contents = Cases[buttons, ButtonBox[con_, bttnopts___] :> con];
   ButtonBox[contents, Sequence @@ Flatten[{bstyle, bdata}]]];
   
   
 ConvertTextData[TextData[cont_]] := 
  Module[{elems, splitelems, newelems},
  	(*ensure the content is a list*)
   elems = If[ListQ@cont, cont, {cont}];
   (*split the list & test hyperlinks*)
   splitelems = Split[elems, (HyperlinkEqualityTest[#1, #2] &)];
   (*merge multistyle links*)
   If[Max[Length /@ splitelems] > 1,
    newelems = 
     Flatten[(If[Length[#] > 1, MergeButtonBoxes[#], #] &) /@ 
       splitelems, 1];
    TextData[
     If[ListQ@newelems, newelems, {newelems}]
     (*leave all other cases*)
      (*TextData[If[ListQ@elems, elems, {elems}]] *)
     ],TextData[cont] 
    ]
   ];

(*end Igor's code.*)

(*  Utility to italicize Mathematica in autogenerated MoreAbouts *)
(* Commenting out since a newer, more generalized version exists just below  --brianv

 ItalicizeMoreAboutKeyWords[moreAboutCell_Cell, keyWord_String] := 
  Module[{keywordLength, output},
   keywordLength = StringLength[keyWord];
   output = 
    moreAboutCell /. {Cell[TextData[ButtonBox[a_String/;StringMatchQ[a, keyWord~~WordBoundary~~__],
              b__]], "MoreAbout", c__]:> 
       Cell[TextData[ButtonBox[{StyleBox[keyWord, FontSlant -> "Italic"], StringDrop[a,11]}, b]], "MoreAbout", c],
      Cell[TextData[ButtonBox[a_String/;StringMatchQ[a, __~~WordBoundary~~keyWord~~WordBoundary~~__], 
          b__]], "MoreAbout", c__]:> 
      Cell[TextData[ButtonBox[{First[StringSplit[a, WordBoundary~~keyWord~~WordBoundary]],
       	StyleBox[keyWord, FontSlant -> "Italic"], 
           Last[StringSplit[a, WordBoundary~~keyWord~~WordBoundary]]}, b]], "MoreAbout", c],
      Cell[TextData[ButtonBox[a_String/;StringMatchQ[a, __~~WordBoundary~~keyWord], 
          b__]], "MoreAbout", c__]:> 
       Cell[TextData[ButtonBox[{StringDrop[a, -keywordLength], StyleBox[keyWord, FontSlant -> "Italic"]}, b]], 
        "MoreAbout", c]};
   output
   ]; *)

ItalicizeMoreAboutKeyWords[macell_Cell, kws_String] :=
 ItalicizeMoreAboutKeyWords[macell, {kws}]

ItalicizeMoreAboutKeyWords[macell_Cell, kws_List] := 
 macell /. 
  Cell[TextData[ButtonBox[s_, rest___]], more___] /; MemberQ[{more}, "MoreAbout"] :> 
   Cell[TextData[
     ButtonBox[
      List @@ StringReplace[s, 
        MapThread[
         Rule, {StringExpression[WordBoundary, #, WordBoundary] & /@ 
           kws, StyleBox[#, FontSlant -> "Italic"] & /@ kws}]], 
      rest]], more]

(******************************************************************************)
(** GetJoinedButtonCaptions - Internal **)
GetJoinedButtonCaptions[expr_] := 
  Module[{boxInstances, link, expr2}, 
  	
  	expr2 = DeleteCases[expr, _["ReplacedText", ___], Infinity];

    boxInstances = Cases[
      expr2,
      ButtonBox[c_, ___, ButtonData -> l_, ___] :> {ConvertToString[c], l},
      Infinity
    ];

    If[boxInstances === {},
      Return[{}];
    ];

    link = Last[First[boxInstances]];

    (* return list of pairs { {title, uri}, {...} } *)
    {StringJoin[First[#] & /@ boxInstances], 
    	Which[
    		MatchQ[link, {URL[_], _}], link[[1,1]],
    		True, StringReplace[link, "paclet:" :> ""]
    	]}
  ];


GetJoinedButtonCaptionsWorkflowRelatedFcns[expr_] :=
  Module[{boxInstances, stringInstances, link, expr2}, 
  	
  	expr2 = DeleteCases[expr, _["ReplacedText", ___], Infinity];

    boxInstances = 
      Cases[expr2, ButtonBox[c_, ___, ButtonData -> l_, ___] :> {ConvertToString[c], l}, Infinity];
	link = Last[First[boxInstances]];
	(* gather unlinked related funcs *)
	stringInstances = StringReplace[#," . "->""]& /@
	  Flatten[Cases[expr2,s_String/;StringMatchQ[s,"* . *"] :>
	    StringCases[s,((LetterCharacter | DigitCharacter).. ~~ " . ") | 
	      (" . " ~~ (LetterCharacter | DigitCharacter)..)], Infinity]];
	stringInstances = {#, "ref/"<>#}& /@ stringInstances;
	
    If[boxInstances === {} && stringInstances === {}, Return[{}]];
    boxInstances = Join[stringInstances, boxInstances];
    (* return list of pairs { {title, uri}, {...} } *)
    If[And@@(StringMatchQ[Last[#], "paclet:*ref/*" | "ref/*"]& /@ boxInstances),
      ReplaceAll[boxInstances, s_String/;StringMatchQ[s, "paclet:*"] :> StringReplace[s, "paclet:"->""]],
    {StringJoin[First[#] & /@ boxInstances], 
    	Which[
    		MatchQ[link, {URL[_], _}], link[[1,1]],
    		True, StringReplace[link, "paclet:" :> ""]
    	]}
    ]
  ];


(******************************************************************************)
(** GetMoreAboutSectionList **)

GetMoreAboutSectionList[nb_String, opts___?OptionQ] := 
  GetMoreAboutSectionList[GetQuietly@nb, opts];

GetMoreAboutSectionList[nb_Notebook, opts___?OptionQ] := 
  Module[{cell, expr, url, c, moreAbouts}, 
    moreAbouts = Cases[nb, Cell[__, "MoreAbout", ___], Infinity];
    GetJoinedButtonCaptions /@moreAbouts
  ];


(******************************************************************************)
(** GetRelatedGuidesSectionList **)

GetRelatedGuidesSectionList[nb_String, opts___?OptionQ] := 
  GetRelatedGuidesSectionList[GetQuietly@nb, opts];

GetRelatedGuidesSectionList[nb_Notebook, opts___?OptionQ] := 
  Module[{cell, expr, url, c, moreAbouts}, 
    moreAbouts = Cases[nb, Cell[__, "RelatedGuides", ___], Infinity];
    GetJoinedButtonCaptions /@moreAbouts
  ];


(******************************************************************************)
(** GetRelatedFunctionsSectionList **)

Options[GetRelatedFunctionsSectionList] = {"PageType"->Automatic};

GetRelatedFunctionsSectionList[nb_String, opts:OptionsPattern[]] := 
  GetRelatedFunctionsSectionList[GetQuietly@nb, opts];

GetRelatedFunctionsSectionList[nb_Notebook, opts:OptionsPattern[]] := 
  Module[{cell, expr, url, c, funcs, pagetype},
    pagetype = "PageType"/.{opts}/.Options[GetRelatedFunctionsSectionList]; 
    funcs = Cases[nb, Cell[__, "RelatedFunctions", ___], Infinity];
    If[MatchQ[pagetype, "Workflow"],
      Flatten[GetJoinedButtonCaptionsWorkflowRelatedFcns /@ funcs, 1],
      GetJoinedButtonCaptions /@funcs]
  ];


(******************************************************************************)
(** GetTechNotesSectionList **)

GetTechNotesSectionList[nb_String, opts___?OptionQ] := 
  GetTechNotesSectionList[GetQuietly@nb, opts];

GetTechNotesSectionList[nb_Notebook, opts___?OptionQ] := 
  Module[{cell, expr, url, c, tns}, 
    tns = Cases[nb, Cell[__, "TechNotesSection", ___], Infinity];
    GetJoinedButtonCaptions /@tns
  ];


(******************************************************************************)
(** GetSeeAlsoSectionList **)

Options[GetSeeAlsoSectionList] = {"IncludePaclets"->True, "Language"->"English", "BuildMode"->"Normal", "PacletName" -> "Mathematica",
  "PageType" -> "Normal" (*or "Workflow"*)};

GetSeeAlsoSectionList[nb_String, opts___?OptionQ] :=
  GetSeeAlsoSectionList[Get@nb, opts]; 

GetSeeAlsoSectionList[nb_Notebook, opts___?OptionQ] :=
  Module[{cell, paclets, lst, tlst, seeAlsoGroup, lang, uri, buildmode, pacletName, type},
    paclets = "IncludePaclets" /. {opts} /. Options[GetSeeAlsoSectionList];
    lang = "Language" /. {opts} /. Options[GetSeeAlsoSectionList];
    buildmode = "BuildMode" /. {opts} /. Options[GetSeeAlsoSectionList];
    pacletName = "PacletName" /. {opts} /. Options[GetSeeAlsoSectionList];
    type = "PageType" /. {opts} /. Options[GetSeeAlsoSectionList];

	BuildLog["-- Remove SeeAlso links to flagged notebooks"];
	seeAlsoGroup = DocumentationBuild`Make`Private`GetSeeAlsoGroup[nb, lang];
	seeAlsoGroup = DocumentationBuild`Make`Private`RemoveSeeAlsoGroupLinksToFlaggedSymbols[
		seeAlsoGroup,
		pacletName,
		buildmode
	];

    (* fix for bug 366820 *)
    cell = 
      Cases[seeAlsoGroup, Cell[__, "SeeAlso", ___], Infinity];
    lst = Cases[cell,
      (ButtonBox[c_, o___] :>
        {Transmogrify`ConvertToString[c], 
          If[MemberQ[{o}, ButtonData -> _]||MemberQ[{o}, ButtonData :> _], 
            ButtonData /. Cases[{o}, _~(Rule|RuleDelayed)~_],
            "paclet:ref/" <> Transmogrify`ConvertToString[c] ] }),
      Infinity];
     If[lst === {}, lst = Cases[cell,TemplateBox[c_,___]:>{Transmogrify`ConvertToString[c[[1]]],c[[2]]}, Infinity]];
      
    If[paclets === True, lst, First /@ lst]
  ];


(******************************************************************************)
(** GetTutorialFunctionList **)

Options[GetTutorialFunctionList]= {"IncludePaclets"->False};

GetTutorialFunctionList[nb_, opts___?OptionQ]:= GetTutorialFunctionList[Get@nb, opts]; 
GetTutorialFunctionList[nbExpr_Notebook, opts___?OptionQ]:= 
Module[{cell, paclets, defBoxes, funcURL, c, syms}, 
  paclets = "IncludePaclets" /. {opts} /. Options[GetTutorialFunctionList];
  defBoxes = Cases[nbExpr, Cell[_, "DefinitionBox", ___], Infinity];
  
  defBoxes = defBoxes /. a_TextData -> ConvertTextData[a];
  
  syms = Union@Cases[defBoxes, ButtonBox[c_String, ___, BaseStyle->"Link", ___, ButtonData~(Rule|RuleDelayed)~funcURL_String, ___] :> {c,StringReplace[funcURL, "paclet:" -> ""]}, Infinity];
  If[syms =!= {}, syms,
    Union[Cases[defBoxes, TemplateBox[{n_, uri_},___] :> {n, StringReplace[uri, "paclet:"->""]}, Infinity]]
  ]
];


(******************************************************************************)
(** GetGuideFunctionList **)

Options[GetGuideFunctionList]= {"IncludePaclets"->False};

GetGuideFunctionList[nb_, opts___?OptionQ]:= GetGuideFunctionList[Get@nb, opts]; 
GetGuideFunctionList[nbExpr_Notebook, opts___?OptionQ] := Module[{
	cell, paclets, guideText, funcURL, c,
	flag
}, 
	paclets = "IncludePaclets" /. {opts} /. Options[GetGuideFunctionList];

	guideText = DeleteCases[
		Cases[
			nbExpr,
			Cell[_, "GuideText" | "InlineGuideFunctionListing", ___],
			Infinity
		], 
		StyleBox[_ButtonBox, "FutureExample", ___],
		Infinity
	];

	guideText = guideText /. a_TextData -> ConvertTextData[a];

	(* Formatting note: 1722135a: *)
	(* 4/17/14 -- edit to make sure future, etc. ref links don't show up in the
		Functions drop down in guides *)
	Union @ Select[
		DeleteCases[
			Cases[
				guideText,
				ButtonBox[
					c_String,
					___,
					BaseStyle -> "Link" | "NewInVersionLink" | {"Link", a_} /; a =!= "BrighterFlag",
					___,
					ButtonData ~ (Rule | RuleDelayed) ~ funcURL_String,
					___
				] /; StringMatchQ[c, RegularExpression["\\w+"] ]
					:> {c, StringReplace[funcURL, "paclet:" -> ""]},
				Infinity
			],
			{"_" | "__" | "___", _String}
		],
		MatchQ[
			DocumentationBuild`Info`LookupSourceInformation[
				"paclet:" <> #[[2]],
				Automatic,
				"Flag",
				None
			],
			None | "None"
		]&
	]
];


(******************************************************************************)
(** GetTutorialMoreAboutList **)

Options[GetTutorialMoreAboutList] = {"IncludePaclets"->False};

GetTutorialMoreAboutList[nb_String, opts___?OptionQ] :=
  GetTutorialMoreAboutList[Get@nb, opts];

GetTutorialMoreAboutList[nb_Notebook, opts___?OptionQ] :=
  Module[{cell, expr, url, c}, 
    expr = Cases[nb, Cell[__, "TutorialMoreAbout", ___], Infinity];
    expr = If[opts==="", 
    	(* for web include all cells *)  expr, 
    	(* for nb delete invisible cells *)   DeleteCases[expr, Cell[a__, b_String, c__, 
 CellElementSpacings -> {"ClosedCellHeight" -> 0}, d___], Infinity]];
    GetJoinedButtonCaptions /@expr
  ];

(******************************************************************************)
(** GetTutorialMoreAboutSectionList **)

Options[GetTutorialMoreAboutSectionList] = {"IncludePaclets"->False};

GetTutorialMoreAboutSectionList[nb_String, opts___?OptionQ] :=
  GetTutorialMoreAboutSectionList[GetQuietly@nb, opts];

GetTutorialMoreAboutSectionList[nb_Notebook, opts___?OptionQ] :=
  Module[{expr, c}, 
    expr = Cases[nb, Cell[__, "TutorialMoreAbout", ___], Infinity];
    expr = If[opts==="", 
    	(* for web include all cells *)  expr, 
    	(* for nb delete invisible cells *)   DeleteCases[expr, Cell[a__, b_String, c__, 
 CellElementSpacings -> {"ClosedCellHeight" -> 0}, d___], Infinity]];
    GetJoinedButtonCaptions /@expr
  ];
  
(******************************************************************************)
(** GetGuideMoreAboutSectionList **)

Options[GetGuideMoreAboutSectionList] = {"IncludePaclets"->False};

GetGuideMoreAboutSectionList[nb_String, opts___?OptionQ] :=
  GetGuideMoreAboutSectionList[GetQuietly@nb, opts];

GetGuideMoreAboutSectionList[nb_Notebook, opts___?OptionQ] :=
  Module[{expr},
    expr = Cases[nb, Cell[__, "GuideMoreAbout" | "GuideMoreAboutSub", ___], Infinity];
    expr = If[opts==="",
      (* for web include all cells *)
      expr,
      (* for nb delete invisible cells *)
      DeleteCases[expr, Cell[a__, b_String, c__, CellElementSpacings -> {"ClosedCellHeight" -> 0}, d___], Infinity]
    ];
    GetJoinedButtonCaptions /@expr
  ];
  
  
(******************************************************************************)
(** GetFeaturedExampleMoreAboutSectionList **)

Options[GetFeaturedExampleMoreAboutSectionList] = {"IncludePaclets"->False};

GetFeaturedExampleMoreAboutSectionList[nb_String, opts___?OptionQ] :=
  GetFeaturedExampleMoreAboutSectionList[GetQuietly@nb, opts];

GetFeaturedExampleMoreAboutSectionList[nb_Notebook, opts___?OptionQ] :=
  Module[{expr}, 
    expr = Cases[nb, Cell[__, "FeaturedExampleMoreAbout", ___], Infinity];
    expr = If[opts==="", 
    	(* for web include all cells *)  expr, 
    	(* for nb delete invisible cells *)   DeleteCases[expr, Cell[a__, b_String, c__, 
 CellElementSpacings -> {"ClosedCellHeight" -> 0}, d___], Infinity]];
    GetJoinedButtonCaptions /@expr
  ];
  
(******************************************************************************)
(** GetFeaturedExampleTutorialsSectionList **)

Options[GetFeaturedExampleTutorialsSectionList] = {"IncludePaclets"->False};

GetFeaturedExampleTutorialsSectionList[nb_String, opts___?OptionQ] :=
  GetFeaturedExampleTutorialsSectionList[GetQuietly@nb, opts];

GetFeaturedExampleTutorialsSectionList[nb_Notebook, opts___?OptionQ] :=
  Module[{expr}, 
    expr = Cases[nb, Cell[__, "FeaturedExampleTutorial", ___], Infinity];
    expr = If[opts==="", 
    	(* for web include all cells *)  expr, 
    	(* for nb delete invisible cells *)   DeleteCases[expr, Cell[a__, b_String, c__, 
 CellElementSpacings -> {"ClosedCellHeight" -> 0}, d___], Infinity]];
    GetJoinedButtonCaptions /@expr
  ];
  
  
(******************************************************************************)
(** GetRelatedTutorialsSectionList **)

Options[GetRelatedTutorialsSectionList] = {"IncludePaclets"->False};

GetRelatedTutorialsSectionList[nb_String, opts___?OptionQ] :=
  GetRelatedTutorialsSectionList[Get@nb, opts];

GetRelatedTutorialsSectionList[nb_Notebook, opts___?OptionQ] :=
  Module[{expr, c}, 
    expr = Cases[nb, Cell[__, "RelatedTutorials", ___], Infinity];
    expr = If[opts==="", 
    	(* for web include all cells *)  expr, 
    	(* for nb delete invisible cells *)   DeleteCases[expr, Cell[a__, b_String, c__, 
 CellElementSpacings -> {"ClosedCellHeight" -> 0}, d___], Infinity]];
    GetJoinedButtonCaptions /@expr
  ];


(******************************************************************************)
(** GetWorkflowsSectionList **)

Options[GetWorkflowsSectionList] = {"IncludePaclets"->False};

GetWorkflowsSectionList[nb_String, opts___?OptionQ] :=
  GetWorkflowsSectionList[Get@nb, opts];

GetWorkflowsSectionList[nb_Notebook, opts___?OptionQ] :=
  Module[{expr, c}, 
    expr = Cases[nb, Cell[__, "RelatedWorkflows", ___], Infinity];
    expr = If[opts==="", 
    	(* for web include all cells *)  expr, 
    	(* for nb delete invisible cells *)   DeleteCases[expr, Cell[a__, b_String, c__, 
 CellElementSpacings -> {"ClosedCellHeight" -> 0}, d___], Infinity]];
    GetJoinedButtonCaptions /@expr
  ];


(******************************************************************************)
(** GetTutorialsSectionList **)

Options[GetTutorialsSectionList] = {"IncludePaclets"->False};

GetTutorialsSectionList[nb_String, opts___?OptionQ] :=
  GetTutorialsSectionList[Get@nb, opts];

GetTutorialsSectionList[nb_Notebook, opts___?OptionQ] :=
  Module[{expr, c}, 
    expr = Cases[nb, Cell[__, "Tutorials"|"TechNotes", ___], Infinity];
    expr = If[opts==="", 
    	(* for web include all cells *)  expr, 
    	(* for nb delete invisible cells *)   DeleteCases[expr, Cell[a__, b_String, c__, 
 CellElementSpacings -> {"ClosedCellHeight" -> 0}, d___], Infinity]];
    GetJoinedButtonCaptions /@expr
  ];
  
  
(******************************************************************************)
(** GetGuideTutorialsSectionList **)

Options[GetGuideTutorialsSectionList] = {"IncludePaclets"->False};

GetGuideTutorialsSectionList[nb_String, opts___?OptionQ] :=
  GetGuideTutorialsSectionList[Get@nb, opts];

GetGuideTutorialsSectionList[nb_Notebook, opts___?OptionQ] :=
  Module[{expr}, 
    expr = Cases[nb, Cell[__, "GuideTutorial", ___], Infinity];
    expr = If[opts==="", 
    	(* for web include all cells *)  expr, 
    	(* for nb delete invisible cells *)   DeleteCases[expr, Cell[a__, b_String, c__, 
 CellElementSpacings -> {"ClosedCellHeight" -> 0}, d___], Infinity]];
    GetJoinedButtonCaptions /@expr
  ];

(******************************************************************************)
(** GetGuideHowTosList **)

GetGuideHowTosList[nb_String] :=
  GetGuideHowTosList[Get[nb]];
  
GetGuideHowTosList[nb_Notebook] :=
  Module[{expr},
  	expr = Cases[nb, 
      cell : Cell[c_, ___, "GuideRelatedLinks", ___] /; 
        MemberQ[{c}, (s_String /; StringMatchQ[s, "paclet:*howto/*"]), 
          Infinity] :> 
        {Transmogrify`ConvertToString[cell], 
          First[Cases[c, str_String /; StringMatchQ[str, "paclet:*howto/*"], 
           Infinity]]}, 
      Infinity];
    expr
  ];
  	


(******************************************************************************)
(** GetGuidesDirectory **)

GetGuidesDirectory[path_String, language_String: "English"] :=
Module[{dirs, pre},
  pre = If[StringMatchQ[path, "/*"], "/", ""];
  dirs = Join[{pre}, StringSplit[path, "\\" | "/"]];
  Which[
    Last@dirs === "Mathematica", 
		Return@ToFileName[ Join[dirs, {"Documentation", language, "System", "Guides"}]],
	Last@dirs === language, 
		Return@ToFileName[Join[dirs, {"Guides"}]],
	Last@dirs === "Documentation", 
		Return@ToFileName[Join[dirs, {language, "Guides"}]],
	True, 
  path]
  ];

(******************************************************************************)
(** GetTutorialsDirectory **)

GetTutorialsDirectory[path_String, language_String: "English"] :=
Module[{dirs, pre},
  pre = If[StringMatchQ[path, "/*"], "/", ""];
  dirs = Join[{pre}, StringSplit[path, "\\" | "/"]];
  Which[
    Last@dirs === "Mathematica", 
		Return@ToFileName[ Join[dirs, {"Documentation", language, "System", "Tutorials"}]],
	Last@dirs === language, 
		Return@ToFileName[Join[dirs, {"Tutorials"}]],
	Last@dirs === "Documentation", 
		Return@ToFileName[Join[dirs, {language, "Tutorials"}]],
	True, 
  path]
  ];


(******************************************************************************)
(** GetOverviewButtonLinks **)

(*  Get overview tagging rules *)
GetOverviewButtonLinks[uri_String, language___String:"English"]:=
Module[{info, overview, chapters, pos, prev, next, prevnext, cell},
  (* Create overview links *)
  info = DocumentationBuild`Info`GetSourceInformation[uri, language];
  If[OptionQ[info] && MemberQ[info, _["Overview", _]],
    (*  make links *)
    overview = "Overview" /. ("Links" /. info);
    chapters = "Chapters" /. ("Links" /.
        ( DocumentationBuild`Info`GetSourceInformation[overview, language] ) );
    chapters = Cases[chapters, {_String, _String}, Infinity];
    pos = Position[chapters, {_, uri}][[1, 1]];
    prev = If[pos =!= 1,
      ButtonBox[StyleBox["\[FilledLeftTriangle]", "OverviewNavText"],
          BaseStyle -> "Link",
          ButtonData -> chapters[[pos - 1, 2]] ],
        None];
    next = If[pos < Length[chapters],
        ButtonBox[StyleBox["\[FilledRightTriangle]", "OverviewNavText"],
          BaseStyle -> "Link",
          ButtonData -> chapters[[pos + 1, 2]] ],
        None];
    cell = 
        Cell[BoxData[
          ButtonBox[StyleBox[
            If[Head[#] === TextData, ReplacePart[#, {0} -> RowBox], #]&[
              "Title" /. ( DocumentationBuild`Info`GetSourceInformation[overview, language] )], "OverviewNavText"],
            BaseStyle -> "Link",
            ButtonData -> overview]
          ], "Text", FontFamily->"Verdana"];
    prevnext = Cell[TextData[Join[
          If[prev =!= None, {prev}, {}],
          If[prev =!= None && next =!= None, {"\[ThickSpace]\[ThickSpace]\[ThickSpace]|\[ThickSpace]\[ThickSpace]\[ThickSpace]"}, {}],
          If[next =!= None, {next}, {}]
        ]], "Text", FontFamily->"Verdana"];
     {"toc" -> cell, "prevnext" -> prevnext
     },
     (* No match, return empty list *)
     {}
   ]
];


(******************************************************************************)
(** GetPrimaryGuide - Internal **)
(* 
	GetPrimaryGuide
	in: paclet uri
	out: primary guide paclet uri
*)
(* Hard code specifc package primary guides *)
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:WSMLink/*"], ___]:= "paclet:WSMLink/guide/WSMLink";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:JLink/*"], ___]:= "paclet:JLink/guide/JavaInterface";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:NETLink/*"], ___]:= "paclet:NETLink/guide/DotNETInterface";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:DatabaseLink/*"], ___]:= "paclet:DatabaseLink/guide/SQLDatabaseOperations";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:WebServices/*"], ___]:= "paclet:WebServices/guide/WebServiceOperations";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:GUIKit/*"], ___]:= "paclet:GUIKit/guide/GUIKitPackage";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:ANOVA/*"], ___]:= "paclet:ANOVA/guide/AnalysisOfVariancePackage";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:FEMDocumentation/*"], ___]:= "paclet:FEMDocumentation/guide/FiniteElementMethodGuide";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:Compatibility/*"], ___]:= 
Module[{pkg}, 
  If[StringMatchQ[uri, "paclet:Compatibility/guide/StandardPackageCompatibilityGuide"], (* XX Root guide rename change XX *)Return["paclet:guide/WolframRoot"]];
  If[StringMatchQ[uri, "paclet:Compatibility/*UpgradingInformation"], Return["paclet:Compatibility/guide/StandardPackageCompatibilityGuide"]];
  pkg = StringReplace[uri, RegularExpression[ "paclet:Compatibility/(ref|guide|tutorial)/(.+)(/.)*"] -> "$2"];
  "paclet:Compatibility/guide/" <> pkg <> "/" <> pkg <> "UpgradingInformation"
];
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:ErrorBarPlots/*"], ___]:= "paclet:ErrorBarPlots/guide/ErrorBarPlottingPackage";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:VectorAnalysis/*"], ___]:= "paclet:VectorAnalysis/guide/CoordinateSystems";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:VectorFieldPlots/*"], ___]:= "paclet:VectorFieldPlots/guide/VectorFieldPlottingPackage";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:WorldPlot/*"], ___]:= "paclet:WorldPlot/guide/WorldPlottingPackage";
(* Hard code specifc core M- primary guides *)
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:ref/c/*"], ___]:= "paclet:guide/WSTPCLanguageFunctions";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:ref/character/*"], ___]:= "paclet:guide/SpecialCharacters";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:LibraryLink/*"], ___]:= "paclet:guide/LibraryLink";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:ref/format/*"], ___]:= "paclet:guide/ImportingAndExporting";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:ref/frontendobject/*"], ___]:= "paclet:guide/FrontEndTokens";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:ref/menuitem/*"], ___]:= "paclet:guide/MenuItems";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:ref/message/*"], ___]:= "paclet:guide/Messages";
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:ref/indicator/*"], ___]:= "paclet:guide/FinancialVisualization";

(* all other uris *)
GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:*"], primaryGuides_List|Dispatch]:=
	GetPrimaryGuide[uri, "English", primaryGuides ];

GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:*"], language_String:"English"]:=
	GetPrimaryGuide[uri, language, DocumentationBuild`Info`GetCoreInformation[language]];

GetPrimaryGuide[uri_String /; StringMatchQ[uri,"paclet:*"], language_String:"English", primaryGuides_]:= 
Module[{info, primaryGuide, packageList, linkBase, suffix},
	BuildLog["-- GetPrimaryGuide: "<>uri];
	{packageList} = {"Packages"} /. Options[GetPrimaryGuide];
	packageList = If[packageList === "Packages", {}, packageList];
	linkBase = LinkBaseFromPacletURI[uri];
	(* only M- Packages have root guides named '<paclet>Package' *)
	suffix = If[MemberQ[packageList, linkBase], "Package", ""];
	BuildLog["-- "<>ToString[{linkBase,suffix}]];

	DocsAssert[
		AssociationQ[primaryGuides] || MatchQ[primaryGuides, {___Rule}],
		"primaryGuides had unexpected structure: ``",
		Short[primaryGuides]
	];

	If[CoreMathematicaPacletQ[uri], 
		(* get paclet info from CoreInformation *)
		info = Lookup[primaryGuides, uri, None];

		DocsAssert[
			MatchQ[info, {___Rule} | None],
			"uri info had unexpected structure: ``",
			info
		];

		If[OptionQ@info,
			(* get PrimaryGuide *)
			primaryGuide = "PrimaryGuide" /. info;
			If[!StringMatchQ[primaryGuide, "PrimaryGuide"], 
				(* return PrimaryGuide *)			
				primaryGuide,
				(* no guide, return empty String *)
				(* XX Root guide rename change XX *)"paclet:guide/WolframRoot"
			],
			(* no guide, return empty String *)
			(* XX Root guide rename change XX *)"paclet:guide/WolframRoot"
		],
		StringJoin["paclet:", linkBase, "/guide/", linkBase <> suffix]
	]
];
GetPrimaryGuide[uri_, __]:= (Message[GetPrimaryGuide::args,uri]; $Failed);
GetPrimaryGuide::args = "Expected uri but found: `1`";
Options[GetPrimaryGuide] = {"Packages" -> 
{"Audio", "BarCharts", "Benchmarking", "BlackBodyRadiation", "Calendar", "Combinatorica", \
"ComputationalGeometry", "ComputerArithmetic", "Developer", "EquationTrekker", "Experimental", "FiniteFields", \
"FourierSeries", "FunctionApproximations", "Geodesy", "GraphUtilities", "HierarchicalClustering", "Histograms", \
"HypothesisTesting", "LinearRegression", "MultivariateStatistics", "Music", "NonlinearRegression", "Notation", "NumericalCalculus", \
"NumericalDifferentialEquationAnalysis", "PhysicalConstants", "PieCharts", "PlotLegends", "PolyhedronOperations", "Polytopes", \
"PrimalityProving", "Quaternions", "RegressionCommon", "ResonanceAbsorptionLines", "Splines", "StandardAtmosphere", \
"StatisticalPlots", "Units", "VariationalMethods", "XML"}};


(******************************************************************************)
(** CoreMathematicaPacletQ **)
CoreMathematicaPacletQ[u_String /; StringMatchQ[u,"paclet:*"], opts___?OptionQ]:= 
Module[{coreDirs, lst, uri=u},
	coreDirs = "CoreDirectories" /. {opts} /. Options[CoreMathematicaPacletQ];
	uri = StringReplace[u, "paclet:" -> ""];
	lst = StringSplit[uri, "/"];
	(* does uri contain 1 or more "/"? *)
	If[Length@lst <= 1, Return@False];
	(* simplistic heuristic... *)
	If[MemberQ[coreDirs, First@lst], True, False]
];
CoreMathematicaPacletQ[___]:= False;
Options[CoreMathematicaPacletQ]= {"CoreDirectories"->{"guide","tutorial","note","ref","howto","screencast","preview"} };


(******************************************************************************)
(** HasOptionsQ **)
HasOptionsQ[nb_Notebook, base_String]:=
 Module[{styles = {"3ColumnTableMod", "2ColumnTableMod"}},
 	((*MemberQ[nb, Cell[___, Alternatives@@styles, ___], Infinity] && *)
 	 (TrueQ[Length[DocumentationBuild`SystemResourcesFromDocs`Private`getoptionnames[base]] > 0]))
 ];


(******************************************************************************)
(** RepairMetadataCellLabels **)
RepairMetadataCellLabels[nb_Notebook]:=
 Module[{newnb = nb, catcells, detcells, 
  catlabels = {"Entity Type", "Paclet Name", "Context", "URI"}, 
  detlabels = {"Lead", "Developers", "Authors", "Feature Name", "QA", 
    "DA", "Docs", "Features Page Notes", "Comments"}}, 
  catcells = Cases[newnb, Cell[__, "Categorization", ___], Infinity];
  If[Length[catcells] =!= 4, 
   Return["Not right num: Categorization cells"]];
  detcells = Cases[newnb, Cell[__, "Details", ___], Infinity];
  If[Length[detcells] =!= 9, Return["Not right num: Details cells"]];
  (newnb = 
      ReplaceAll[
      newnb, #[[1]] -> Append[#[[1]], CellLabel -> #[[2]]]]) & /@ 
    Thread[{catcells, catlabels}];
  (newnb = 
      ReplaceAll[
      newnb, #[[1]] -> Append[#[[1]], CellLabel -> #[[2]]]]) & /@ 
    Thread[{detcells, detlabels}]; newnb];
    
RepairMetadataCellLabels[filename_String]:=
 Module[{nbdata = Quiet[Get[filename]], newnb}, 
  newnb = RepairMetadataCellLabels[nbdata];
  If[(nbdata =!= newnb) && (Head[newnb] === Notebook), Export[filename, newnb]]];

(******************************************************************************)
(** LinkBaseFromPacletURI **)
LinkBaseFromPacletURI[u_String /; StringMatchQ[u,"paclet:*"], opts___?OptionQ]:= 
Module[{coreDirs, lst, uri=u},
	If[ CoreMathematicaPacletQ[u], 
		"Mathematica",
		lst = StringSplit[StringReplace[u, "paclet:" -> ""], "/"];
		(* does uri contain 1 or more "/"? *)
		(* TODO: Return empty string? *)
		If[Length@lst < 1, "", First@lst]
	]
];
LinkBaseFromPacletURI[a___]:= (Message[LinkBaseFromPacletURI::arg, a]; $Failed);
LinkBaseFromPacletURI::arg = "Paclet uri expected but found `1`";


(******************************************************************************)
(** MakePacletButton **)
(* convert "FunctionLink", "TutorialLink", etc. into the appropriate
   "paclet:location" format.
*)
MakePacletButton[c___]:= (Message[MakePacletButton::arg,c]; c);

Options[MakePacletButton] = {BaseStyle->"Link", ButtonData->None};

(* Return if ButtonData contains a URL *)
(* MakePacletButton[bb:ButtonBox[__, ButtonData~(Rule|RuleDelayed)~{URL[_],___}, ___]]:= Return@bb; *)
(* Process button *)
MakePacletButton[bb:ButtonBox[content_String, opts___?OptionQ]] :=
  Module[{b, style, data, newdata, buttonFunction},
    {style, data} = {BaseStyle, ButtonData} /. {opts} /. Options[MakePacletButton];
    buttonFunction = Hold[{ButtonFunction} /. {opts} /. Options[MakePacletButton]];
    (* TODO: Handle multiple link styles; For now, take the first *)
    If[style==={}, Return[bb]];
    style = If[Head@style===List, First@Flatten@{style}, style];

    If[style===None, Return[bb]];
    (* external links *)
    If[MatchQ[style, "Hyperlink" ], Return[bb] ];
    If[MemberQ[data, _URL], If[style==="Link"||"NKSLink", Return@ResetOptions[bb, BaseStyle->"Hyperlink"],Return[bb]] ];

    If[StringMatchQ[style, "NKSLink" | "InformationLink" | "MathWorldLink" | "FunctionsLink"],
      b = bb /. _[BaseStyle, _]:>(BaseStyle->"Hyperlink"); Return[b] ];
      
        If[StringMatchQ[style, "AlphaSymbolLink"],
      b = ButtonBox[content, BaseStyle->"Hyperlink", ButtonData->{URL["http://wadocs.wolfram.com/mathdoc/Function/"<>content<>".html"], None}, opts]; Return[b] ];

    If[MatchQ[style, "FunctionLink"|"TutorialLink"|"GuideLink"|"InterfaceLink"|"CharacterLink"|"FormatLink"],
      b = bb /. _[BaseStyle, _]:>(BaseStyle->"Link"),
      b = bb];
    If[MatchQ[style, "ExampleLink"],
      b = ButtonBox["\[NonBreakingSpace]\[RightGuillemet]", BaseStyle->"ExampleLink", opts] ];

    (* just return the button if we have nothing to check over *)
    If[style===None || MatchQ[data, {s_String,_}|s_String/;!StringFreeQ[s,"paclet:"]],
      b = b /. _[ButtonData, p_]:>ButtonData-> StringReplace[p, {"paclet://"->"paclet:"}];
      Return[b]
    ];

    Switch[style,
      "Link"|"FunctionLink"|"NewInVersionLink"(*|"ExampleLink"*), newdata = "paclet:ref/",
      "TutorialLink", newdata = "paclet:tutorials/",
      "GuideLink", newdata = "paclet:guides/",
      "InterfaceLink", newdata = "paclet:interfaces/",
      "CharacterLink", newdata = "paclet:characters/",
      "FormatLink", newdata = "paclet:formats/",
      _ , Return[b]
    ];

    (* add filename base *)
    Switch[style,
      (* get filename from ButtonData for Tutorials *)
      "TutorialLink", 
        Which[
          data===None,
            Message[MakePacletButton::nodata];
            Return[b],
          ListQ[data], newdata = newdata<>data[[1]],
          True, newdata = newdata<>data],

      (* get filename from content for everything else *)
      _, 
      	If[data==="data", Return[b],
      		newdata = newdata <> content ]
    ];
  
    (* add anchor link *)
    If[Length[data]===2,
      newdata = newdata <> "#"<>data[[2]]];
  
    (* Strip nb extension, and turn \[Character]s into "Character"s *)
    newdata = StringReplace[newdata, {".nb" -> "", "\"" ->"" (*, "RawGuides"->"Guides"*),
      RegularExpression["[\\\\\[Backslash]]\\[(.*?)\\]"]->"$1"}];

    (* Links to certain Flags should be kept, but delinkified *)
    If[(DocumentationBuild`Info`GetSourceInformation[newdata, Automatic, "Flag"] === "InternalFlag") &&
       (FreeQ[{opts},ButtonFunction] && FreeQ[BaseStyle/.{opts},"Link"]),
      Return[Transmogrify`ConvertToString[content]] ];

    (*If[data===None,
      ButtonBox[content, opts, ButtonData->newdata],
      b /. _[ButtonData,_]:>ButtonData->newdata
    ]*)
    If[data===None, 
    Which[
    	MatchQ[buttonFunction, Hold[{ButtonFunction}/. {BaseStyle->"Link",Evaluator->Automatic,ButtonFunction:>(TreeBrowse`DocsNavigatorLookup[True]&)}/. Options[MakePacletButton]]], 
    		(*If[MatchQ[ButtonBox[content,opts], 
              ButtonBox[_, opt___]/;(MemberQ[{opt},BaseStyle->"Link",Infinity]&&FreeQ[{opt},_[ButtonFunction,_],Infinity])],
             TemplateBox[{b[[1]],ButtonData /. Options[b]},"RefLink"],
             ButtonBox[content,opts]],*)
             ButtonBox[content,opts],
    	MatchQ[buttonFunction, Hold[{ButtonFunction}/. {BaseStyle->"Link",Evaluator->Automatic,ButtonFunction:>(TreeBrowse`DocsNavigatorLookup[False]&)}/. Options[MakePacletButton]]], 
    		(*If[MatchQ[ButtonBox[content,opts], 
              ButtonBox[_, opt___]/;(MemberQ[{opt},_[BaseStyle,"Link"],Infinity]&&FreeQ[{opt},_[ButtonFunction,_],Infinity])],
             TemplateBox[{b[[1]],ButtonData /. Options[b]},"RefLink"],
             ButtonBox[content,opts]],*)
             ButtonBox[content,opts],
      	True, (*If[MatchQ[ButtonBox[content, opts, ButtonData->newdata], 
              ButtonBox[_, opt___]/;(MemberQ[{opt},_[BaseStyle,"Link"],Infinity]&&FreeQ[{opt},_[ButtonFunction,_],Infinity])],
             TemplateBox[{b[[1]],newdata},"RefLink"],
             ButtonBox[content, opts, ButtonData->newdata]]*)
             ButtonBox[content, opts, ButtonData->newdata]
    	],
      (* V9 EDIT BELOW (commented out now) *)
      (*If[MatchQ[(b = b /. _[ButtonData,_]:>ButtonData->newdata), 
        ButtonBox[_, opt___]/;(MemberQ[{opt},BaseStyle->"Link",Infinity]&&FreeQ[{opt},_[ButtonFunction,_],Infinity])],
       TemplateBox[{b[[1]],ButtonData /. Options[b]},"RefLink"],
       b]*)
       b /. _[ButtonData,_]:>ButtonData->newdata
    ]
  ];

MakePacletButton::nodata = "Tutorial button for `1` has no ButtonData.";
MakePacletButton::arg = "Incorrect arguments for `1`.";


(******************************************************************************)
(** ConvertButtonBoxesToTemplateBoxes **)

ConvertButtonBoxesToTemplateBoxes[nb_Notebook] := Module[{
	nbexpr = nb,
	(* Formatting note: b954b666: fix bug 368671 and incorrect coloring of ref/c/ see alsos *)
	(* Formatting note: 6e093b88: fix bug 388750 and others *)
	bluestyles = {
		"InlineFunctionSans", "InlineFormula", "InlineCode",
		"GuideMoreAbout", "GuideMoreAboutSub", "GuideTutorial",
		"Tutorials", "MoreAbout", "RelatedLinks", "RelatedWorkflows",
		"Subsubsection",
		"InlineGuideFunction", "InlineCharacterName",
		"GuideWorkflowGuide",
		"TOCSection", "TOCSubsection", "TOCSubsubsection", "GuideTOCLink",
		"WorkflowGuideText",
		"3ColumnTableMod", "3ColumnIllustratedTableMod", "2ColumnTableMod", "1ColumnTableMod",
		"DefinitionBox", "DefinitionBox2Col", "DefinitionBox3Col", "MonographTOCSection"
	},
	greenuris = {
		"JLink/ref/java/",
		"NETLink/ref/net/",
		"ref/c/",
		"LibraryLink/ref/callback/",
		"CloudConnectorForExcel/ref/excelfunction/",
		"UnityLink/ref/csharp/"
	},
	stringtypeuris = {
		"ref/format/",
		"ref/interpreter/",
		"ref/service/",
		"ref/device/",
		"ref/indicator/",
		"ref/embeddingformat/",
		"ref/externalevaluationsystem/",
		"ref/classifier/",
		"ref/predictor/",
		"ref/method/",
		"ref/netencoder/",
		"ref/netdecoder/",
		"ref/frontendobject/",
		"ref/compiledtype/",
		"ref/databaseconnection/",
		"ref/datastructure/",
		"ref/textcontent/",
		"ref/questioninterface/",
		"ref/questioninterfacetypes/"
	},
	resourceuris = {
		"resourcefunction/"
	},
	entitytypeuris = {
		"ref/entity/"
	},
	(* the preceding *uris symbols are subtypes of "bluestyles" *)
	(* Formatting note: 571a035b:
		implement WLDOCS-2087, fix bug 349780, fix box-entity links in tables
	*)
	entitylinkexceptions = {
		"InlineFormula",
		"2ColumnTableMod", "3ColumnTableMod", "3ColumnIllustratedTableMod"
	},
	orangestyles = {
		"GuideFunctionsSubsection", "TOCChapter", "TOCPart"
	},
	(* Formatting note: f6f64dfa: fix to include TechNotes in workflows (bug 345785 and others) *)
	workfloworangestyles = {
		"WorkflowThingsToKnowItem", "WorkflowRelatedWorkflows", "WorkflowGuideSectionHeader",
		"WorkflowRelatedGuides", "WorkflowTechNotes"
	},
	menugraystyles = {
		"MenuName"
	},
	graystyles = {
		"WorkflowGuideSection", "MonographTOCChapter"
	},
	tealstyles = {
		"WorkflowGuideEntry"
	},
	(* Formatting note: e9434389: docs build side of 375240 *)
	greenurls = {
		"*reference.wolfram.com/language/WolframClientForPython/*"
	},
	pos,
	anchor,
	boxstring,
	(*------------------------*)
	(* Local helper functions *)
	(*------------------------*)
	ConvertIfTextData,
	ConvertBasicLinkStyles
},

	ConvertIfTextData[contents_] := Replace[contents, {
		dat_[c___] :> (
			If[dat === TextData,
				{First[ConvertTextData[dat[c]]]},
				{c}
			]
		),
		other_ :> DocsError["unexpected link cell contents: ``", other]
	}];


	ConvertBasicLinkStyles[
		sourceStyles:{___?StringQ},
		templateStyle_?StringQ
	] := ReplaceAll[
		nbexpr,
		cell : Cell[
			contents:(dat_[c___]),
			some___,
			sty : (Alternatives @@ sourceStyles),
			rest___
		] /; MemberQ[
			{c},
			ButtonBox[
				___,
				BaseStyle -> (s_ /; MemberQ[{s}, "Link", Infinity]),
				___
			],
			Infinity
		] :> Cell[
			BoxData[
				(* Formatting note: 3ca89c80: fixing bug 224955 *)
				Sequence @@ ReplaceRepeated[
					ConvertIfTextData[contents],
					ButtonBox[n_, ___, ButtonData -> uri_, ___]
						:> TemplateBox[
							{Cell[TextData[n]], uri},
							templateStyle,
							BaseStyle -> sty
						]
				]
			],
			some,
			sty,
			rest
		]
	];

	(*---------------------*)
	(* Start function body *)
	(*---------------------*)

	(* Take out anchor bar so it doesn't get messed with -- we'll put it back later *)
	pos = Position[nbexpr, Cell[___, "AnchorBarGrid", ___]];
	anchor = Extract[nbexpr, pos];
	nbexpr = Delete[nbexpr, pos];

	(* Handle bare StyleBoxes with, e.g., InlineCode (handles links to WSTP fcns, etc.) *)
	nbexpr = ReplaceAll[
		nbexpr,
		StyleBox[
			bb:ButtonBox[
				n_,
				___,
				ButtonData -> uri_,
				___
			] /; (
				MemberQ[bb, BaseStyle -> "Link"] && FreeQ[n, PaneSelectorBox]
			),
			style__
		] /; MemberQ[{style}, "InlineCode", Infinity]
			:> (
				Cell[BoxData[
					TemplateBox[{n, uri}, "RefLink", BaseStyle -> Flatten[{style}]]
				]]
			)
	];

	(* Blue links and then orange links *)
	(* ButtonBoxes with enclosing StyleBoxes first (e.g. SeeAlso links) *)
	nbexpr = ReplaceAll[
		nbexpr,
		cell : Cell[
			contents:(dat_[c___]),
			some___,
			sty : (Alternatives @@ bluestyles),
			rest___
		] /; MemberQ[
			{c},
			StyleBox[
				ButtonBox[
					n_,
					___,
					BaseStyle -> (s_ /; MemberQ[{s}, "Link" | "NewInVersionLink", Infinity]),
					___
				],
				__
			] /; FreeQ[n, PaneSelectorBox],
			Infinity
		] :> Cell[
			BoxData[
				Sequence @@ ReplaceRepeated[
					ConvertIfTextData[contents],
					StyleBox[ButtonBox[n_, ___, ButtonData -> uri_String, ___], st__] :> With[{
						datahead = If[FreeQ[n, SubscriptBox], TextData, BoxData]
					},
						Which[
							StringMatchQ[uri, "paclet:*/ref/*"] && !StringMatchQ[uri, "paclet:/ref/*"] && MatchQ[sty, "InlineFunctionSans"],
								TemplateBox[
									{Cell[datahead[n]], uri, StringReplace[First[StringSplit[uri, "/"]], "paclet:"->""] <> " Package Symbol"},
									(* Formatting note: f341ab88: fixed package links in DefinitionBoxes (bug 328593) *)
									"PackageLink",
									BaseStyle -> Flatten[Join[
										{sty},
										If[StringMatchQ[sty, "DefinitionBox*"], {st, CellFrame->0}, {st}]
									]]
								]
							,
							!StringMatchQ[uri, "paclet:*ref/*"],
								TemplateBox[
									{Cell[datahead[n]], uri},
									"RefLinkPlain",
									BaseStyle -> Flatten[Join[
										{sty},
										If[StringMatchQ[sty, "DefinitionBox*"], {st, CellFrame->0}, {st}]
									]]
								]
							,
							True,
								TemplateBox[
									{Cell[datahead[n]], uri},
									"RefLink",
									BaseStyle -> Flatten[Join[
										{StringReplace[sty, "InlineGuideFunction"->"InlineFunctionSans"]},
										If[StringMatchQ[sty, "DefinitionBox*"], {st, CellFrame->0}, {st}]
									]]
								]
						]
					]
				]
			],
			some,
			sty,
			rest
		]
	];

	(* Now the rest of the ButtonBoxes *)
	nbexpr = ReplaceAll[
		nbexpr,
		cell : Cell[
			contents:(dat_[c___]),
			some___,
			sty : (Alternatives @@ bluestyles),
			rest___
		] /; MemberQ[
			{c},
			ButtonBox[
				n_,
				___,
				BaseStyle -> (s_ /; MemberQ[{s}, "Link" | "NewInVersionLink", Infinity]),
				___
			] /; FreeQ[n, PaneSelectorBox],
			Infinity
		] :> Cell[
			BoxData[
				Sequence @@ ReplaceRepeated[
					ConvertIfTextData[contents],
					bb:ButtonBox[n_, ___, ButtonData -> uri_String, ___] /; FreeQ[bb, "ExampleLink"] :> With[{
						datahead = If[FreeQ[n, SubscriptBox], TextData, BoxData]
					}, {
						linkCell = Cell[
							If[MemberQ[n, str_String /; !StringFreeQ[str, "\!"], Infinity],
								boxstring = First @ Cases[
									n,
									str_String /; !StringFreeQ[str, "\!"],
									Infinity
								];
								datahead[
									ReplaceAll[n, boxstring -> Cell[BoxData[boxstring]]]
								]
								,
								datahead[n]
							]
						]
					},
						Which[
							StringMatchQ[uri, "paclet:*/ref/*"] && !StringMatchQ[uri, "paclet:/ref/*"],
								TemplateBox[
									{
										linkCell,
										uri,
										StringJoin[
											StringReplace[
												First[StringSplit[uri, "/"]],
												"paclet:" -> ""
											],
											" Package Symbol"
										]
									},
									"PackageLink",
									BaseStyle -> If[StringMatchQ[sty, "DefinitionBox*"], {sty, CellFrame->0}, sty]
								]
							,
							(* Formatting note: ea893c10: fix bug 417893 *)
							!StringMatchQ[uri, "paclet:*ref/*"|"paclet:resourcefunction/*"],
								TemplateBox[
									{linkCell, uri},
									"RefLinkPlain",
									BaseStyle -> If[StringMatchQ[sty, "DefinitionBox*"], {sty, CellFrame->0}, {sty}]
								]
							,
							True,
								TemplateBox[
									{linkCell, uri},
									"RefLink",
									BaseStyle -> If[StringMatchQ[sty, "DefinitionBox*"],
										{StringReplace[sty, "InlineGuideFunction" -> "InlineFunctionSans"], CellFrame->0},
										{StringReplace[sty, "InlineGuideFunction" -> "InlineFunctionSans"]}
									]
								]
						]
					]
				]
			],
			some,
			sty,
			rest
		]
	];

	(* sub-blues: greens, string-types, entity-types, resource functions *)
	nbexpr = ReplaceAll[
		nbexpr,
		TemplateBox[
			{name_, uri_, tooltip___},
			some___,
			sty : ("RefLink" | "PackageLink"),
			rest___
		] :> Which[
			!StringFreeQ[uri, Alternatives @@ greenuris],
				TemplateBox[{name, uri, tooltip}, some, "NonWLLink", rest]
			,
			!StringFreeQ[uri, Alternatives @@ resourceuris],
				TemplateBox[
					{
						Cell[TextData[{
							Cell[BoxData[DynamicBox[FEPrivate`FrontEndResource["DocumentationToolsExpressions", "WFRLinkIcon"]]]],
							" ",
							name[[1,1]]
						}]],
						uri,
						tooltip
					},
					some,
					sty,
					rest
				]
			,
			Or[
				(!StringFreeQ[uri, Alternatives @@ stringtypeuris]),
				(* Formatting note: 571a035b:
					implement WLDOCS-2087, fix bug 349780, fix box-entity links in tables *)
				(* keeps entity links from framing in, e.g., usages on Entity pages *)
				(!FreeQ[rest, Alternatives@@entitylinkexceptions] && !StringFreeQ[uri, Alternatives@@entitytypeuris])
			],
				(* Formatting note: 636f9a66: fixed 368671 and 368829, restyled SeeAlso sub-refs *)
				If[FreeQ[name, "SeeAlsoSubLink"],
					TemplateBox[{name, uri, tooltip}, some, "StringTypeLink", rest],
					TemplateBox[{DeleteCases[name, "SeeAlsoSubLink", Infinity], uri, tooltip}, some, sty, rest]
				]
			,
			!StringFreeQ[uri, Alternatives @@ entitytypeuris] && FreeQ[rest, Alternatives @@ entitylinkexceptions],
				TemplateBox[
					{
						ReplaceAll[name, s_String :> StringReplace[s,"\""->""]],
						uri,
						tooltip
					},
					some,
					"EntityTypeLink",
					Sequence @@ ReplaceAll[
						{rest},
						r_[BaseStyle, s_List] :> r[BaseStyle,Append[s, FontSize->13]]
					]
				]
			,
			True,
				TemplateBox[{name, uri, tooltip}, some, sty, rest]
		]
	];

	(* Orange-colored links *)
	nbexpr = ConvertBasicLinkStyles[orangestyles, "OrangeLink"];

	(* And Workflow orange links *)
	nbexpr = ReplaceAll[
		nbexpr,
		cell : Cell[
			contents:(dat_[c___]),
			some___,
			sty : (Alternatives @@ workfloworangestyles),
			rest___
		] /; MemberQ[
			{c},
			ButtonBox[___, BaseStyle -> (s_ /; MemberQ[{s}, "Link", Infinity]), ___],
			Infinity
		] :> Cell[
			TextData[
				Sequence @@ ReplaceRepeated[
					ConvertIfTextData[contents],
					ButtonBox[n_, ___, ButtonData -> uri_, ___]
						:> Cell[BoxData[TemplateBox[
							{Cell[TextData[n]], uri},
							"WFOrangeLink",
							BaseStyle -> sty
						]]]
				]
			],
			some,
			sty,
			rest
		]
	];

	(* Now convert Hyperlinks *)
	(* StyleBox[ButtonBox[...]] first *)
	nbexpr = ReplaceAll[
		nbexpr,
		Cell[
			contents:(dat_[c___]),
			some___,
			sty_String,
			rest___
		] /; (
			MemberQ[
				{c},
				StyleBox[
					bb:ButtonBox[
						n_,
						___,
						BaseStyle -> (s_ /; MemberQ[{s}, "Hyperlink", Infinity]),
						___
					],
					__
				] /; (MemberQ[bb, URL[___], Infinity] && FreeQ[n, PaneSelectorBox]),
				Infinity
			]
			&& !MatchQ[sty, "HowToScreencastLink" | "Input" | "Output"]
			(* Formatting note: b66690d3: fix for bug 295565 *)
			(* Additional exclusion to make sure hyperlinks inside of Databin blobs
				aren't converted! *)
			&& FreeQ[{some, sty, rest}, "HowToScreencastLink" | "Input" | "Output", 1]
		) :> Cell[
			dat[
				Sequence @@ ReplaceRepeated[
					ConvertIfTextData[contents],
					StyleBox[
						ButtonBox[
							n_,
							___,
							BaseStyle -> s_,
							___,
							ButtonData -> {URL[url_],___},
							___
						],
						st__
					] :>
						(* Formatting note: e9434389: docs build side of 375240 *)
						Cell[BoxData[TemplateBox[
							{Cell[TextData[n]], url},
							If[Quiet @ TrueQ[StringMatchQ[url, greenurls]],
								"NonWLWebLink",
								"WebLink"
							],
							BaseStyle -> Flatten[Join[
								{StringReplace[sty, "RelatedLinksSection" -> "RelatedLinks"]},
								{st},
								Flatten[DeleteCases[{s}, "Hyperlink", Infinity]]
							]]
						]]]
				]
			],
			some,
			sty,
			rest
		]
	];

	nbexpr = ReplaceAll[
		nbexpr,
		Cell[
			contents:(dat_[c___]),
			some___,
			sty_String,
			rest___
		] /; (
			MemberQ[
				{c},
				bb:ButtonBox[
					n_,
					___,
					BaseStyle -> (s_ /; MemberQ[{s}, "Hyperlink", Infinity]),
					___
				] /; (MemberQ[bb, URL[___], Infinity] && FreeQ[n, PaneSelectorBox]),
				Infinity
			]
			&& !MatchQ[sty, "HowToScreencastLink" | "Input" | "Output"]
			(* Additional exclusion to make sure hyperlinks inside of Databin blobs
				aren't converted! *)
			&& FreeQ[{some, sty, rest}, "HowToScreencastLink" | "Input" | "Output", 1]
		) :> Cell[
			dat[
				Sequence @@ ReplaceRepeated[
					ConvertIfTextData[contents],
					ButtonBox[
						n_,
						___,
						BaseStyle -> s_,
						___,
						ButtonData -> {URL[url_],___},
						___
					] :> Cell[BoxData[TemplateBox[
						{Cell[TextData[n]], url},
						If[Quiet @ TrueQ[StringMatchQ[url, greenurls]],
							"NonWLWebLink",
							"WebLink"
						],
						BaseStyle -> Flatten[Join[
							{StringReplace[sty, "RelatedLinksSection" -> "RelatedLinks"]},
							Flatten[DeleteCases[{s}, "Hyperlink", Infinity]]
						]]
					]]]
				]
			],
			some,
			sty,
			rest
		]
	];

	(* Formatting note: c56d3138: added code to support menu item link rollover *)
	(* Now handle "gray links"; for now, just menu names -- which are all
		StyleBox[ButtonBox[...], "MenuName"] *)
	nbexpr = ReplaceAll[
		nbexpr,
		StyleBox[c_, some___, sty_String, rest___] /; (
			MemberQ[
				{c},
				bb:ButtonBox[___]
					/; MemberQ[
						bb,
						s_String /; StringMatchQ[s, "paclet:*ref/menuitem/*" | "paclet:guide/*Menu"],
						Infinity
					],
				Infinity
			]
			&& MemberQ[menugraystyles, sty]
		) :> Cell[
			BoxData[
				Sequence @@ ReplaceRepeated[
					{c},
					ButtonBox[n_, ___, ButtonData -> uri_, ___]
						:> TemplateBox[
							{Cell[TextData[n]], uri},
							"MenuGrayLink",
							BaseStyle -> Flatten[Join[
								{sty},
								Cases[{some,rest}, _[FontSize, __], Infinity]
							]]
						]
				]
			],
			some, sty, rest
		]

	];

	(* GrayLinks *)
	nbexpr = ConvertBasicLinkStyles[graystyles, "GrayLink"];

	(* TealLinks *)
	nbexpr = ConvertBasicLinkStyles[tealstyles, "TealLink"];

	(* Reinsert anchor bar *)
	nbexpr = Insert[nbexpr, anchor, pos];

	ReplaceRepeated[
		nbexpr,
		TextData[TemplateBox[c___]] :> BoxData[TemplateBox[c]]
	]
]


(******************************************************************************)
(** ConfirmButtonBoxesToTemplateBoxes **)
ConfirmButtonBoxesToTemplateBoxes[expr_Notebook] := Module[{
	newnb = expr
},
	newnb = ReplaceRepeated[
		newnb,
		TextData[{s___, tb:TemplateBox[__], r___}]
			:> TextData[{s, Cell[BoxData[tb]], r}]
	];

	newnb
]



(******************************************************************************)
(** MakeCharacterNotesGrid **)

MakeCharacterNotesGrid[characterImageCell_, notesGroup_] :=
  Module[{chargrid, notescells, notesgrid},
    chargrid = ReplaceAll[First[Cases[characterImageCell, GridBox[___], Infinity, 1]],
      r_[GridBoxSpacings, ___] :> r[GridBoxSpacings, {"Columns" -> {{2}}, "Rows" -> {{3}}}]];
    notescells = Cases[notesGroup, Cell[c___, "Notes", rest___]:>Cell[c, "CharacterNotes", rest], Infinity];
    notesgrid = GridBox[Map[
      {RowBox[Flatten[{Cell["\[FilledVerySmallSquare]", "CharacterNotesDingbat"], "\[NonBreakingSpace]", #}]]}&, notescells], 
     BaseStyle->{AutoIndent->False},
     GridBoxSpacings->{"Rows"->{{0.6}},"Columns"->{{0}}},
     GridBoxItemSize->{"Columns"->{{Scaled[.75]}},"Rows"->{{.4}}}];
    Cell[BoxData[GridBox[{{
      chargrid,
      notesgrid}}]], "CharacterImage"]
  ];


(******************************************************************************)
(** FESaveNotebook **)

FESaveNotebook[s___]:= {$Failed;s}
FESaveNotebook[outfile_String, exp_Notebook, opts___?OptionQ]:=
Developer`UseFrontEnd @ 
Module[{nbObj, maxtime},
	BuildLog["     FESaveNotebook"];
  maxtime = MaxTime /. {opts} /. Options[FESaveNotebook];
  nbObj = FETimeConstrained[
    FrontEnd`NotebookPutReturnObject[exp], maxtime];

  If[Head[nbObj] === ReturnPacket, nbObj = First[nbObj]];
  CreateDirectory[DirectoryName@outfile];
  If[Head[nbObj] === NotebookObject,
    FETimeConstrained[
      FrontEnd`NotebookSave[nbObj, outfile], maxtime];
    FETimeConstrained[
      FrontEnd`NotebookClose[nbObj], maxtime];
  ,
  nbObj]
];
Options[FESaveNotebook] = {MaxTime -> 3000};

(******************************************************************************)
(** NotebookSaveVisible **)

(* Save an invisible notebook as a visible notebook.

	This workaround is to prevent the "flashing" effect which used to happen when building
	many documentation notebooks: each notebook would be opened for a brief moment for
	processing, and then closed again.

	Processing invisible notebooks isn't completely trivial, because you have to clear the
	`Visible -> False` flag before saving them. The naive code to do that is:

		SetOptions[nbObj, Visible -> Inherited];
		NotebookSave[nbObj, ...];
		NotebookClose[nbObj];

	which has the drawback that there is a small period in which the Kernel and the
	FrontEnd will race, potentially causing `nbObj` to become visible before it is closed.
	This makes NotebookSave unusable for saving invisible notebooks.

	Instead, this function keeps the `NotebookObject` notebook invisible for it's entire
	existence, and removes the `Visible -> False` option only from the Notebook[{..}]
	expression.
*)
NotebookSaveVisible[nbObj_NotebookObject, outfile_?StringQ] := Module[{
	expr,
	previous,
	result
},
	If[TrueQ[DocumentationBuild`Settings`$InvisibleNotebooks],
		Once[DocsWarning[
			"using '$InvisibleNotebooks === True' is experimental "
			<> "and may result in malformed output."
		]];

		expr = NotebookGet[nbObj];

		(* Remove the expected `Visible -> False` option from the notebook. *)
		expr = DeleteCases[expr, Visible ~ (Rule|RuleDelayed) ~ _];

		(* Save the notebook expression. The "NB" export type saves the notebook cache
		information as well. (Doing Put[expr, outfile] doesn't generate the cache.) *)
		Export[outfile, expr, "NB"]
		,
		previous = Options[nbObj, Visible];

       (* Save `nbObj` as a visible notebook, minimizing the amount of time between making
          the notebook visible and restoring it's invisibility. We're attempting to prevent
          (or at least minimize) the "flashing" effect which can happen when building many
          documentation notebooks, where each notebook opens only for a brief moment. *)
		SetOptions[nbObj, Visible -> Inherited];
		result = NotebookSave[nbObj, outfile];
		SetOptions[nbObj, Visible -> previous];

		result
	]
]

(******************************************************************************)
(** FETimeConstrained **)
FETimeConstrained[func_, time_]:=
MathLink`CallFrontEnd @ FrontEnd`TimeConstrained[func, time];


(******************************************************************************)
(** Marketing Page functions**)
GetBlockStyleList[expr_]:=
Union@Cases[Flatten[{FlattenCellGroups @ expr }], 
                Cell[_, s_String, ss___String, ___?OptionQ] :> s <> If[Length[{ss}] > 0, "*" <> ss, ""], 1];

(* Flatten Cell Groups *)
FlattenCellGroups[Notebook[{c__Cell}, opts___]] := 
	Notebook[Flatten[FlattenCellGroups /@ {c}], opts];

FlattenCellGroups[Cell[CellGroupData[{c__Cell}, ___],___]] := 
	Map[FlattenCellGroups, {c}];

FlattenCellGroups[c_Cell] := c;
FlattenCellGroups[c_List] := 
  FlattenCellGroups @ Cell@CellGroupData@Flatten[{c}];
  
(*  *)
PreviousNextElementList[m_String, l:{___, p_, m_, n_, ___}]:= {p, n};
PreviousNextElementList[m_String, l:{m_, n_, ___, p_}]:= {p, n};
PreviousNextElementList[m_String, l:{n_, ___, p_, m_}]:= {p, n};
PreviousNextElementList[m_String, l:{n_, m_}]:= {n, n};
PreviousNextElementList[m_String, l:{m_, p_}]:= {p, p};
PreviousNextElementList[___]:= {$Failed, $Failed};


MakeComparisonListingCell[Cell[c_, "ComparisonListing", ___]]:= MakeComparisonListingCell @ c;
MakeComparisonListingCell[TextData[lst_List]]:= MakeComparisonListingCell @ lst;
MakeComparisonListingCell[TextData[con_]]:= MakeComparisonListingCell[{con}];
MakeComparisonListingCell[str_]:=
Module[{elems, list},
  (* split list on "," *)
  elems = Transmogrify`ConvertToString @ str;
  elems = StringSplit[ elems, RegularExpression[",\\s*"]];
  elems = DeleteCases[elems, "" | "(" | ")" | "," | ", " | "...)" | ", ...)", Infinity];
  elems = If[Head@#===String, FixedPoint[StringReplace[#, {"(" | ")" | "..." -> ""}]&, #], #]&/@elems;
  elems = DeleteCases[elems, "" | "(" | ")" | "," | ", " | "...)" | ", ...)", Infinity];
(*  list = If[(StringLength@StringJoin@@Take[elems, 3] < 35, Take[elems, 2], Take[elems, 3], elems];*)
  Cell[TextData[ 
    Flatten@Join[{"("}, Riffle[Join[If[Length@elems > 2, Take[elems, 3], elems], {"... )"}], ", "]]], "ComparisonListing"]
];


MakeComparisonItemCell[Cell[con_, sty_String, opts___]]:= 
  Cell[TextData[Flatten@{ MakeComparisonItemCell@con }], sty, opts];
MakeComparisonItemCell[TextData[lst_List]]:= MakeComparisonItemCell @ lst;
MakeComparisonItemCell[TextData[con_]]:= MakeComparisonItemCell[{con}];
MakeComparisonItemCell[con_]:=
Module[{elems, str},
  str = Transmogrify`ConvertToString @ con;
  If[ StringLength@str > 86,
    Print["Too long: "<>ToString@StringLength@str],
    Print["Just right: "<>ToString@StringLength@str]
  ];
  con
];


(******************************************************************************)
(** GetSearchMetaDataList **)
GetSearchMetaDataList[nb_String, opts___?OptionQ]:= 
  GetSearchMetaDataList[GetQuietly@nb, opts];
GetSearchMetaDataList[c___]:= (Message[GetSearchMetaDataList::arg, c]; $Failed);
GetSearchMetaDataList::arg = "Incorrect arg: `1`";
GetSearchMetaDataList[nbExpr_Notebook, opts___?OptionQ]:=
Module[{expr, ret},
  expr = Rest[List @@ nbExpr];
  If[Length@expr > 0,
  	If[ OptionQ[ret = TaggingRules /. expr],
  	If[ MemberQ[ret, _["ResourceType", "Function"], Infinity],
  	ret = {"label" -> "Resource Function", "index" -> True, "status" -> "None", "type" -> "ResourceFunction"},
      ret = Flatten[ {"Metadata" /. ret}]], {}]
    ,
    Return[{}];
  ];
  If[Length@ret < 2, {}, ret]
];


(******************************************************************************)
(** AppendHTMLDirectory **)
AppendHTMLDirectory[path_String]:=
Module[{dir},
	dir = StringSplit[ path, "/"|"\\"];
 	If[ Last@dir === "html", path, ToFileName[path, "html"] ]
];


(******************************************************************************)
(** ExportEclipseResourceFiles **)
ExportEclipseResourceFiles[path_String, nb_String, linkbase_String:"", opts___?OptionQ] :=
  ExportEclipseResourceFiles[path, Get@nb, linkbase, opts];

ExportEclipseResourceFiles[path_String, nbExpr_Notebook, linkbase_String:"", opts___?OptionQ] :=
Module[{fileList, files},
	fileList = "ReturnFileList" /. {opts} /. {"ReturnFileList" -> True};
	files = ExportTOCXML[ ToFileName[{path}, linkbase<>".xml"], nbExpr, linkbase, "ReturnFileList"->fileList];
	ExportPluginXML[ ToFileName[{path}, "plugin.xml"], nbExpr, linkbase, "FileList"->files];
]

(* *)
ExportTOCXML[file_String, nb_String, linkbase_String:"", opts___?OptionQ] :=
  ExportTOCXML[file, Get@nb, linkbase, opts];

ExportTOCXML[file_String, nbExpr_Notebook, linkbase_String:"", opts___?OptionQ] :=
Module[{ret, DocumentationBuild`$xmlFileList, fileList},
	fileList = "ReturnFileList" /. {opts} /. {"ReturnFileList" -> False};
	DocumentationBuild`$xmlFileList={BaseName[file]};
ret = 
Transmogrify`Transmogrify[file, nbExpr, 
Transmogrify`XMLTransform[{ 
	Notebook :> 
		Module[{children, label }, 
			label = Cases[Transmogrify`SelectSelf[], Cell[con_, "TOCDocumentTitle", ___] :> 
				Transmogrify`ConvertToString@con, Infinity]; 
			children = Cases[Transmogrify`SelectSelf[], Cell[CellGroupData[{Cell[_, "TOCChapter", ___], ___},___],___], Infinity]; 
			(*Transmogrify`Recurse[]; *)
			XMLObject["Document"][{
				XMLObject["Declaration"]["Version" -> "1.0", "Encoding" -> "UTF-8"], 
				XMLObject["ProcessingInstruction"]["NLS", "TYPE=\"org.eclipse.help.toc\""]
				},
				XMLElement["toc", {If[Length@label > 0, "label" -> First@label]}, 
					Flatten@{Transmogrify`Recurse[ children] }], {}]
		], 
	{CellGroupData, All} :> 
		Module[{ce, self, uri},
			self = Transmogrify`SelectSelf[];
			uri = getButtonData[Transmogrify`SelectChildren[1], linkbase];
			uri = If[uri =!= None, {"href" -> "html" <> uri}, {}];
			ce = Transmogrify`ConvertToString @ Transmogrify`SelectChildren[1];
			XMLElement[ "topic", Flatten@{"label" -> ce, uri }, 
				Flatten@{ Transmogrify`Recurse[] }]
		], 
	{Cell, All} :> 
		Module[{uri, label, children},
			(*Print@Transmogrify`SelectSelf[];
			children = Transmogrify`SelectChildren[]; *)
			uri = getButtonData[Transmogrify`SelectSelf[], linkbase]; 
			uri = If[uri =!= None, {"href" -> "html" <> uri}, {}];
			label = Transmogrify`ConvertToString @ Transmogrify`SelectSelf[]; 
			XMLElement[ "topic", Flatten@{"label" -> label,  uri }, {}]
		],
	{String} :> Transmogrify`SelectSelf[]
	}]
];
	If[fileList===True, DocumentationBuild`$xmlFileList, ret]
];


(******************************************************************************)
(** ExportPluginXML **)
ExportPluginXML[file_String, nb_String, linkbase_String:"", opts___?OptionQ] :=
  ExportPluginXML[file, Get@nb, linkbase, opts];

ExportPluginXML[file_String, nbExpr_Notebook, linkbase_String:"", opts___?OptionQ] :=
Module[{ret, xmlFileList, fileList},
	fileList = "FileList" /. {opts} /. {"FileList" -> {} };

	Export[file,
		XMLObject["Document"][{
			XMLObject["Declaration"]["Version" -> "1.0", "Encoding" -> "UTF-8"]
				},
			XMLElement["plugin", {
			"name"->linkbase<>" Documentation", 
			"id"->"com.wolfram.eclipse."<> LowercaseString@linkbase<>".help", 
			"version"->"1.0.0", 
			"provider-name"->"Wolfram Research, Inc."}, {
			XMLElement["extension", {
				"point" -> "org.eclipse.help.toc"
				}, Flatten@{
				If[Length@fileList>0, {
					XMLElement["toc", {"file"->First@fileList, "primary"->"true"}, {}],
					If[Length@fileList>1,
						{XMLElement["toc", {"file"->#}, {}] &/@ Rest@fileList},
						{}] },
					{fileList}]
		}]
			}], {}], "XML"]
];

                                                                                                                                                                                
getTitleFromCell[Cell[CellGroupData[expr_List, ___], ___]] := 
 getTitleFromCell@expr;
getTitleFromCell[CellGroupData[expr_List, ___]] := 
 getTitleFromCell@expr;
getTitleFromCell[{expr_, ___}] := 
 Transmogrify`ConvertToString@expr;
getTitleFromCell[a___] := 
 Transmogrify`ConvertToString@a;
 
getButtonData[{Cell[ce___]}, sty_String] := getButtonData[Cell[ce], sty];
getButtonData[Cell[ce___], sty_String] := 
 Module[{uri}, 
	uri = Union@
		Cases[{ce}, 
		ButtonBox[___, Rule[ButtonData, uri_String], ___] :> uri, Infinity]; 
	uri = If[Length@uri > 0, First@uri, Return[None] ];
	uri = Rest@StringSplit[uri, sty];
	If[Length@uri > 0, DocumentationBuild`Utils`DotHTML[First@uri (*<> ".html"*)], None]
];


(******************************************************************************)
(**
    option manipulation helpers
    these are the fastest implementations i could come up with! 

    As you can see, PrependOptions is by far the fastest as it doesn't
    try to delete the original option.  this is fine for most cases where
    they are applied via Replace*.
**)
(** PrependOptions **)
PrependOptions[h_[stuff___,opts___?OptionQ],newopts:{__?OptionQ}]:=
  h[stuff,Sequence@@Flatten@newopts,opts]
PrependOptions[h_[stuff___,opts___?OptionQ], newopts__?OptionQ]:=
  h[stuff,newopts,opts]

(** DeleteOptions **)
DeleteOptions[h_[stuff___,opts___?OptionQ], newopts__?OptionQ]:=
  DeleteOptions[h[stuff,opts],{newopts}]

(* delete the exact option,value pair *)
DeleteOptions[h_[stuff___,opts___?OptionQ], newopts:{__?OptionQ}]:=
  h[stuff, Sequence @@ DeleteCases[{opts},Alternatives@@newopts]]

(* delete all options with the optioname specified in newopts *)
DeleteOptions[h_[stuff___,opts___?OptionQ], newopts:{__}]:=
  h[stuff, Sequence @@ DeleteCases[{opts},_[Alternatives@@newopts,_]]]

(** ResetOptions **)
(* actually reset options. it's faster to define this in terms of 
   delete cases rather than have another call to DeleteOptions *)
ResetOptions[h_[stuff___,opts___?OptionQ], newopts__?OptionQ]:=
  h[stuff, Sequence@@Flatten@{newopts}, Sequence @@ DeleteCases[{opts}, _[Alternatives @@ (Flatten[{newopts}][[All, 1]]), _]]];

ResetOptions[h_[stuff___],newopts__?OptionQ]:=h[stuff,newopts];


(******************************************************************************)
(** fixSplitHyperlinks - Internal **)
fixSplitHyperlinks[nbExpr_Notebook] :=
  Module[{expr, text1, text2, text3, text4, text5, stylebox1, stylebox2, url},
    (**********************************************************************
      5 consecutive hyperlink boxes: button, style, button, style, button.
    **********************************************************************)
    expr = nbExpr;
    expr = expr /. 
      List[
        listleft___,
        ButtonBox[text1_String, Rule[_, _], Rule[ButtonData, List[URL[url_String], None]]],
        StyleBox[ButtonBox[text2_String, Rule[_, _], Rule[ButtonData, List[URL[url_String], None]]], stylebox1___],
        ButtonBox[text3_String, Rule[_, _], Rule[ButtonData, List[URL[url_String], None]]],
        StyleBox[ButtonBox[text4_String, Rule[_, _], Rule[ButtonData, List[URL[url_String], None]]], stylebox2___],
        ButtonBox[text5_String, Rule[_, _], Rule[ButtonData, List[URL[url_String], None]]],
        listright___
      ] ->
      List[
        listleft,
        ButtonBox[
          StyleBox[List[text1, StyleBox[text2, stylebox1], text3, StyleBox[text4, stylebox2], text5]],
          Rule[BaseStyle, "Hyperlink"],
          Rule[ButtonData, List[URL[url], None]]
        ],
        listright
      ];
    (**********************************************************************
      3 consecutive hyperlink boxes: button, style, button.
    **********************************************************************)
    expr = expr /. 
      List[
        listleft___,
        ButtonBox[text1_String, Rule[_, _], Rule[ButtonData, List[URL[url_String], None]]],
        StyleBox[ButtonBox[text2_String, Rule[_, _], Rule[ButtonData, List[URL[url_String], None]]], stylebox1___],
        ButtonBox[text3_String, Rule[_, _], Rule[ButtonData, List[URL[url_String], None]]],
        listright___
      ] ->
      List[
        listleft,
        ButtonBox[
          StyleBox[List[text1, StyleBox[text2, stylebox1], text3]],
          Rule[BaseStyle, "Hyperlink"],
          Rule[ButtonData, List[URL[url], None]]
        ],
        listright
      ]; 
    (**********************************************************************
      3 consecutive hyperlink boxes: style, button, style
    **********************************************************************)
    expr = expr /. 
      List[
        listleft___,
        StyleBox[ButtonBox[text1_String, Rule[_, _], Rule[ButtonData, List[URL[url_String], None]]], stylebox1___],
        ButtonBox[text2_String, Rule[_, _], Rule[ButtonData, List[URL[url_String], None]]],
        StyleBox[ButtonBox[text3_String, Rule[_, _], Rule[ButtonData, List[URL[url_String], None]]], stylebox2___],
        listright___
      ] ->
      List[
        listleft,
        ButtonBox[
          StyleBox[List[StyleBox[text1, stylebox1], text2, StyleBox[text3, stylebox2]]],
          Rule[BaseStyle, "Hyperlink"],
          Rule[ButtonData, List[URL[url], None]]
        ],
        listright
      ]; 
    (**********************************************************************
      2 consecutive hyperlink boxes: style, button
    **********************************************************************)
    expr = expr /. 
      List[
        listleft___,
        StyleBox[ButtonBox[text1_String, Rule[_, _], Rule[ButtonData, List[URL[url_String], None]]], stylebox1___],
        ButtonBox[text2_String, Rule[_, _], Rule[ButtonData, List[URL[url_String], None]]],
        listright___
      ] ->
      List[
        listleft,
        ButtonBox[
          StyleBox[List[StyleBox[text1, stylebox1], text2]],
          Rule[BaseStyle, "Hyperlink"],
          Rule[ButtonData, List[URL[url], None]]
        ],
        listright
      ]; 
    (**********************************************************************
      2 consecutive hyperlink boxes: button, style
    **********************************************************************)
    expr = expr /. 
      List[
        listleft___,
        ButtonBox[text1_String, Rule[_, _], Rule[ButtonData, List[URL[url_String], None]]],
        StyleBox[ButtonBox[text2_String, Rule[_, _], Rule[ButtonData, List[URL[url_String], None]]], stylebox1___],
        listright___
      ] ->
      List[
        listleft,
        ButtonBox[
          StyleBox[List[text1, StyleBox[text2, stylebox1]]],
          Rule[BaseStyle, "Hyperlink"],
          Rule[ButtonData, List[URL[url], None]]
        ],
        listright
      ]; 
    expr]

fixSplitHyperlinks[dir_String] :=
    Module[{manifest, increment, count = 0},
    manifest = FileNames[{"*.nb"}, dir, Infinity];
    increment = Floor[N[Length@manifest / 100]];
    Module[{nb, nbExpr, initialByteCount, finalByteCount},
      (* begin poor man's progress meter *)
      count++;
      If[increment > 1 && Mod[count, increment] === 0,
        Print[ToString@count<> " of "<> ToString@Length@manifest<> ": "<>ToString[100*N[count/Length@manifest]]<>"%"]];
      (* end poor man's progress meter *)
      nb = #;
      nbExpr = Quiet@Get@nb;
      initialByteCount = ByteCount[nbExpr];
      nbExpr = fixSplitHyperlinks[nbExpr];
     (**********************************************************************
       If the notebook expression has changed then Put it into the
       notebook file, overwriting the original notebook.  As of
       November 2007, Export in 6.0.2 Linux M-- will resplit unified
       hyperlinks so use Put here.
      **********************************************************************)
      finalByteCount = ByteCount[nbExpr];
      If[initialByteCount =!= finalByteCount, 
        Put[nbExpr, nb];
        Print[nb<>" changed"]];
    ]& /@ manifest]



(* Flatten Cell Groups *)
flattenCellGroups[Notebook[{c__Cell}, opts___]] := 
	Notebook[Flatten[flattenCellGroups /@ {c}], opts];

flattenCellGroups[Cell[CellGroupData[{c__Cell}, ___],___]] := 
	Map[flattenCellGroups, {c}];

flattenCellGroups[c_Cell] := c;
flattenCellGroups[c_List] := 
  flattenCellGroups @ Cell@CellGroupData@Flatten[{c}];
  

(* create timestamp *)
timestamp:=ToString[(StringForm["`1`/`2`/`3` `4`:"<>
  (#[[1]]<>":"<>#[[2]]&)[
    (If[#<10,"0"<>ToString@#,ToString[#]]&)/@{#5,Round[#6]}], 
  ##]& @@ Date[])]

line="--------------------------------------------------\n"

(* quick logging *)
BuildLog[str_]:=
Module[{log},
	If[TrueQ[DocumentationBuild`Common`$DocumentationBuildDebug],
		log = DocumentationBuild`Utils`Private`timestamp<>"\n"<>ToString[str];
		Which[
			TrueQ[Global`$AntBuildQ], Global`AntLog[log],
			True, Print@log
		]
	]
];



(* Format Messages list *)
formatMessageList[lst_List]:=
Module[{},
	StringJoin @@ Flatten[
		Riffle[{First@# <> " (" <> ToString@Length[#] <> ")"} & /@ 
    			Split@Sort[ToString /@ lst], ", "]
    	]
];


(* GetCellsFromCellGroup within template nb *)
GetCellsFromCellGroup[str_String, grp_String, sty___:"Output", opts___?OptionQ]:=
  GetCellsFromCellGroup[GetQuietly@str, grp, sty, opts];
GetCellsFromCellGroup[expr_Notebook, grp_String, sty___:"Output", opts___?OptionQ]:=
Module[{cells, s, keepHeadCell},
  {keepHeadCell} = {"IncludeHeadCell"} /. {opts} /. {"IncludeHeadCell" -> True};
  PacletBuildLog[line <> " GetCellsFromCellGroup ("<>ToString[grp]<>") " <> line];
  cells = 
    Cases[expr, 
       Cell[CellGroupData[{Cell[_, grp, ___], ___}, ___], ___],
    Infinity];
  (*  *)
  If[!keepHeadCell, 
    cells = Flatten@DeleteCases[cells, Cell[_, grp, ___], Infinity]];
  If[ sty =!= All,
  cells = flattenCellGroups@
      DeleteCases[cells, Cell[_, s_String /; !StringMatchQ[s, sty], ___], Infinity],
    cells = flattenCellGroups@cells
  ];
  PacletBuildLog["   Found "<>ToString[Length[cells]]<>" cell(s)"];
  Flatten@cells
];


(* line breaking routine for XML files *)
indentFunction[{"", "table"}] := Automatic;
indentFunction[{"", "a"}] := False;
indentFunction[{"", "div"}] := Automatic;
indentFunction[{"", "ul"}] := True;
indentFunction[{"", "li"}] := Automatic;
indentFunction[{"", "span"}] := False;
indentFunction[{"", "p"}] := Automatic;



(******************************************************************************)
(* BlockMessageOff *)

SetAttributes[BlockMessageOff, HoldAll];

BlockMessageOff[{msgnames___MessageName}, body_] :=
With[{
   onMsgNames = DeleteCases[ Hold[msgnames], mn_ /; Head[mn] === $Off ]
},
   Scan[Off, onMsgNames];
   First @ {body, Scan[On, onMsgNames] }
];



(******************************************************************************)
(* Image Difference Code*)

GetScreenCapture[url_String] := 
  Module[{}, 
   Import["http://webtestmac.wri.wolfram.com:8080/webMathematica/screencapture.jsp?url=" <> url, {"PNG", "Data"}]];

GetNotebookCapture[file_String] := Module[{nb, ras},
   nb = NotebookOpen[file, Visible -> False];
   FrontEndTokenExecute[nb, "SelectAll"];
   FrontEndTokenExecute[nb, "SelectionOpenAllGroups"];
   ras = Rasterize[nb][[1, 1]];
   NotebookClose[nb]; ras];

HashIt[data_] := Module[{hash},
  hash = Map[IntegerString[Hash[#, "SHA"], 16, 40] &, data];
  Compress[ExportString[hash, "Text"]]
  ];

GetDiff[hashAA_, hashBB_] := Module[{},
	InstallJava[];
   client = JavaNew["org.apache.commons.httpclient.HttpClient"];
   mPost = JavaNew["org.apache.commons.httpclient.methods.PostMethod", "http://webtestmac.wri.wolfram.com:8080/webMathematica/diff.jsp"];
   mPost@addParameter["hash1", hashAA];
   mPost@addParameter["hash2", hashBB];
   client@executeMethod[mPost];
   output = mPost@getResponseBodyAsString[];
   mPost@releaseConnection[]; 
   ImportString[Uncompress[output], "Lines"]];

URLImageDifference[url1_, url2_, type_] := Module[
  {raster1, raster2, dimrast1, dimrast2, rastmax, hash1, hash2, count1 = 1, count2 = 1, hashA, 
   hashB, len1, len2, length, res = {}, command, difference, 
   red = {255, 0, 0}, blue = {0, 0, 255}, black = {0, 0, 0}, 
   green = {0, 255, 0}, blueline, redline, shortblueline, 
   shortredline, shortsameline},
  
Which[type === "URL",
  raster1 = Reverse@GetScreenCapture[url1];
  raster2 = Reverse@GetScreenCapture[url2];
  dimrast1 = Dimensions[raster1][[2]];
  dimrast2 = Dimensions[raster2][[2]];
  rastmax = Min[dimrast1, dimrast2];
  raster1 = Take[raster1, All, {1, rastmax}];
  raster2 = Take[raster2, All, {1, rastmax}]
  ,
  type == "Image",
  raster1 = Reverse@Import[url1, "Data"];
  raster2 = Reverse@Import[url2, "Data"];
  dimrast1 = Dimensions[raster1][[2]];
  dimrast2 = Dimensions[raster2][[2]];
  rastmax = Min[dimrast1, dimrast2];
  raster1 = Take[raster1, All, {1, rastmax}];
  raster2 = Take[raster2, All, {1, rastmax}]
  ,
  type == "NB",
  raster1 = GetNotebookCapture[url1];
  raster2 = GetNotebookCapture[url2];
  dimrast1 = Dimensions[raster1][[2]];
  dimrast2 = Dimensions[raster2][[2]];
  rastmax = Min[dimrast1, dimrast2];
  raster1 = Take[raster1, All, {1, rastmax}];
  raster2 = Take[raster2, All, {1, rastmax}]
  , True,
  raster1 = Reverse@GetScreenCapture[url1];
  raster2 = Reverse@GetScreenCapture[url2];
  dimrast1 = Dimensions[raster1][[2]];
  dimrast2 = Dimensions[raster2][[2]];
  rastmax = Min[dimrast1, dimrast2];
  raster1 = Take[raster1, All, {1, rastmax}];
  raster2 = Take[raster2, All, {1, rastmax}]];
  
If[(length = Length[First[raster1]]) =!= Length[First[raster2]], 
  Print["Captured images are not the same width " <> 
    ToString[{Length[First[raster1]], Length[First[raster2]]}] <> 
    ", Aborting...."]; ];
  
  If[Last[Dimensions[raster1]] === 4, AppendTo[red, 255]; 
   AppendTo[blue, 255]; AppendTo[black, 255]; AppendTo[green, 255]];
  blueline = Table[blue, {length}];
  shortblueline = Join[{black}, Table[blue, {8}], {black}];
  shortredline = Join[{black}, Table[red, {8}], {black}];
  shortsameline = Join[{black}, Table[green, {8}], {black}];
  
  hashA = HashIt[raster1];
  hashB = HashIt[raster2];
  
  difference = GetDiff[hashA, hashB];

If[StringMatchQ[StringJoin[difference], ___ ~~ ">" | "<" | "|" ~~ ___],
  Scan[
   Function[{d},
    Which[
     StringMatchQ[d, ___ ~~ ">" ~~ ___], 
     AppendTo[res, 
      Join[shortblueline, blueline, shortblueline, 
       raster2[[count2++]], shortblueline]],
     StringMatchQ[d, ___ ~~ "<" ~~ ___], 
     AppendTo[res, 
      Join[shortblueline, raster1[[count1++]], shortblueline, 
       blueline, shortblueline]],
     StringMatchQ[d, ___ ~~ "|" ~~ ___], 
     AppendTo[res, 
      Join[shortredline, raster1[[count1++]], shortredline, 
       raster2[[count2++]], shortredline]],
     True, 
     AppendTo[res, 
      Join[shortsameline, raster1[[count1++]], shortsameline, 
       raster2[[count2++]], shortsameline]]
     ]
    ],
   difference], res="$Failed"];
  res
  ];
  
ShowImageDifferences[url1_String, url2_String, type_String:"URL"] := Module[{dimensions, raster, image},
  (*
  ShowImageDifferences["http://www.google.com", "http://www.google.co.uk", "URL"] 
  ShowImageDifferences["/tmp/Mathematica.nb", "/tmp/test/Mathematica.nb", "NB"] 
  *)
  raster=URLImageDifference[url1, url2, type];
  If[raster==="$Failed", "No image difference",
  dimensions = Reverse@Dimensions[raster, 2];
  image = 
   Graphics[Raster[raster, {{0, 0}, dimensions}, {0, 255}], 
    ImageSize -> dimensions]
  ]
  ];
  
sameLinkTrailsQ[nb1_String, nb2_String] := 
  sameLinkTrailsQ[Quiet@Get@nb1, Quiet@Get@nb2];

sameLinkTrailsQ[nb1Expr_Notebook, nb2Expr_Notebook] := 
  Module[{nb1linktrails, nb2linktrails},
   nb1linktrails = 
    Cases[nb1Expr, Cell[___, "LinkTrail", ___], Infinity];
   nb2linktrails = 
    Cases[nb2Expr, Cell[___, "LinkTrail", ___], Infinity];
   nb1linktrails === nb2linktrails];

samePacletNameCellQ[nb1_String, nb2_String] := 
  samePacletNameCellQ[Quiet@Get@nb1, Quiet@Get@nb2];

samePacletNameCellQ[nb1Expr_Notebook, nb2Expr_Notebook] := 
  Module[{nb1pacletnamecell, nb2pacletnamecell},
   nb1pacletnamecell = 
    Cases[nb1Expr, Cell[___, "PacletNameCell", ___], Infinity];
   nb2pacletnamecell = 
    Cases[nb2Expr, Cell[___, "PacletNameCell", ___], Infinity];
   nb1pacletnamecell === nb2pacletnamecell];

notesInNotesSectionQ[nb_String] := notesInNotesSectionQ[Quiet@Get@nb];

notesInNotesSectionQ[nbExpr_Notebook] := 
  Module[{notessection}, 
   notessection = 
    Cases[nbExpr, Cell[___, "NotesSection", ___], Infinity];
   If[Length[notessection] > 0, 
    If[Length[Cases[nbExpr, Cell[___, "Notes", ___], Infinity]] > 0, 
     True, False ], True]];

seeAlsoInSeeAlsoSectionQ[nb_String] := 
  seeAlsoInSeeAlsoSectionQ[Quiet@Get@nb];

seeAlsoInSeeAlsoSectionQ[nbExpr_Notebook] := 
  Module[{seealsosection}, 
   seealsosection = 
    Cases[nbExpr, Cell[___, "SeeAlsoSection", ___], Infinity];
   If[Length[seealsosection] > 0, 
    If[Length[Cases[nbExpr, Cell[___, "SeeAlso", ___], Infinity]] > 0,
      True, False ], True]];

moreAboutInMoreAboutSectionQ[nb_String] := 
  moreAboutInMoreAboutSectionQ[Quiet@Get@nb];

moreAboutInMoreAboutSectionQ[nbExpr_Notebook] := 
  Module[{moreaboutsection}, 
   moreaboutsection = 
    Cases[nbExpr, Cell[___, "MoreAboutSection", ___], Infinity];
   If[Length[moreaboutsection] > 0, 
    If[Length[Cases[nbExpr, Cell[___, "MoreAbout", ___], Infinity]] > 
      0, True, False ], True]];

corruptedCellsQ[nb_String] := corruptedCellsQ[Quiet@Get@nb];

corruptedCellsQ[nbExpr_Notebook] := 
  Module[{documentationbuilderrors}, 
   documentationbuilderrors = 
    StringCases[ToString[nbExpr], "DocumentationBuild`", Infinity];
   If[Length[documentationbuilderrors] > 0, True, False]];

samePulldownMenusQ[nb1_String, nb2_String] := 
  samePulldownMenusQ[Quiet@Get@nb1, Quiet@Get@nb2];

samePulldownMenusQ[nb1Expr_Notebook, nb2Expr_Notebook] := 
  Module[{nb1lpulldown, nb2lpulldown},
   nb1lpulldown = 
    Cases[nb1Expr, Cell[___, "AnchorBarGrid", ___], Infinity];
   nb2lpulldown = 
    Cases[nb2Expr, Cell[___, "AnchorBarGrid", ___], Infinity];
   nb1lpulldown === nb2lpulldown];

samePulldownMenuTextQ[nb1_String, nb2_String] := 
  samePulldownMenuTextQ[Quiet@Get@nb1, Quiet@Get@nb2];

samePulldownMenuTextQ[nb1Expr_Notebook, nb2Expr_Notebook] := 
  Module[{nb1lpulldown, nb2lpulldown},
   nb1lpulldown = 
    Cases[Cases[nb1Expr, Cell[___, "AnchorBarGrid", ___], Infinity], 
     FrameBox[a_, b___] :> a, Infinity];
   nb2lpulldown = 
    Cases[Cases[nb2Expr, Cell[___, "AnchorBarGrid", ___], Infinity], 
     FrameBox[a_, b___] :> a, Infinity];
   nb1lpulldown === nb2lpulldown];

buttonBoxDataMissingQ[nb_String] := 
  buttonBoxDataMissingQ[Quiet@Get@nb];

buttonBoxDataMissingQ[nbExpr_Notebook] := 
  Module[{allButtons, buttonboxamount}, 
   allButtons = Cases[nbExpr, _ButtonBox, {1, \[Infinity]}]; 
   buttonboxamount = 
    Select[allButtons, 
     FreeQ[#, ButtonData | ButtonFunction, {-1}, Heads -> True] &]; 
   If[Length[buttonboxamount] =!= 0, True, False]];


(******************************************************************************)
(* functionAncestorQ *)

functionAncestorQ[check_Symbol, totalexpr_, subexpr_] := 
 Module[{parentlist = {}, superexpr = totalexpr, sub2 = subexpr}, 
  While[! AtomQ[superexpr] && ! MatchQ[superexpr, {}], 
   superexpr = 
    Cases[{totalexpr}, 
     expr : (f_[___, sub2, ___]) :> (AppendTo[parentlist, f]; expr), 
     Infinity, Heads -> True]; 
   If[Length[superexpr] > 0, superexpr = superexpr[[1]]]; 
   sub2 = superexpr]; MemberQ[Flatten@parentlist, check]];
   
functionAncestorQ[check_List, totalexpr_, subexpr_] :=
 Module[{parentlist = {}, superexpr = totalexpr, sub2 = subexpr}, 
  While[! AtomQ[superexpr] && ! MatchQ[superexpr, {}], 
   superexpr = 
    Cases[{totalexpr}, 
     expr : (f_[___, sub2, ___]) :> (AppendTo[parentlist, f]; expr), 
     Infinity, Heads -> True]; 
   If[Length[superexpr] > 0, superexpr = superexpr[[1]]]; 
   sub2 = superexpr]; MemberQ[Flatten@parentlist, Alternatives@@check]];

(******************************************************************************)



(******************************************************************************)
(* BuildCitation / BuildCitationCell *)

BuildCitation[
	(* The new and modified dates should be years, not version numbers. *)
	{new_String, mod0_String},
	info_List,
	lang_String:"English"
] := With[{
	icon = DynamicBox[FEPrivate`FrontEndResource["DocumentationExpressions", "CitationCloseButton"]]
}, Module[{
	mod = mod0,
	makeCitationCell,
	citationInfo,
	callback,
	citationStyles,
	name, url,
	text
},
	(*-------*)
	(* Setup *)
	(*-------*)

	(* Callback for transforming metadata about the page being processed into citations
	   for that page. The value returned from this function should be an Association
	   whose keys are the names of common citation styles (Chicago, APS, BibTex, etc.),
	   and whose values are the text which other users should copy to cite this page in
	   that style.

		This enables users to control the content of the citations in their built
		documentation.
	*)
	(* TODO:
		Simplify this mechanism, so that users don't have to implement their own
		citation formatting logic. At the moment, users have to generate the text of
		the citation themselves. Maybe do this by designing a CitedAs[<|..|>] symbolic
		form, which could be converted to different styles. E.g.
			ExportString[
				CitedAs[<|"Title" -> "MyFunction", "Author" -> "John Smith", "LastModified" -> 2021, ...|>],
				"BibTeX"
			]
	*)
	callback = DocumentationBuild`Settings`$CitationCallback;

	(* If no callback has been specified, don't generate citations. *)
	If[callback === None,
		Return[$Failed];
	];

	If[!StringMatchQ[new, DigitCharacter..],
		Return[$Failed]
	];

	If[!StringMatchQ[mod, DigitCharacter..],
		mod = None;
	];

	(* Page information used to create the citation content. Not every citation format
	   uses every field. *)
	(* TODO: Include "PacletName" as a field? "Publisher__Paclet" or "Publisher: Paclet"? *)
	citationInfo = <|
		"Language" -> lang,
		"Title" -> Lookup[info, "Title", DocsError["Notebook information for citation is missing \"Title\"."]],
		"URI" -> Lookup[info, "URI", DocsError["Notebook information for citation is missing \"URI\"."]],
		"NewInYear" -> new,
		"ModifiedInYear" -> mod
	|>;

	makeCitationCell[type_?StringQ, content_] := Cell[TextData[{
		StyleBox[Localized["CiteThisAs" <> type <> "Label", lang], "CitationFormatsLabel"],
		"\[LineSeparator]",
		Cell @ BoxData @ StyleBox[
			StyleBox[
				TemplateBox[
					{FormBox[content, TextForm]},
					"ClickToCopy",
					BaseStyle -> "CitationText"
				],
				ShowStringCharacters -> True
			],
			"CitationText"
		]
	}]];

	(*------------------------*)
	(* Create citation styles *)
	(*------------------------*)

	citationStyles = callback[citationInfo];

	If[!MatchQ[citationStyles, Association[(_?StringQ -> _?StringQ) ..]],
		DocsError["Citation styles are malformed: ``", InputForm[citationStyles]];
	];

	(* Get the plain text citation. This is always required, as it is shown at the
	   bottom of the page. *)
	text = Lookup[
		citationStyles,
		"Text",
		DocsError["Citation style \"Text\" is missing. A plain text citation style is required."]
	];

	(* Generate the citation cells *)
	citationStyles = KeyValueMap[makeCitationCell, citationStyles];

	DocsAssert[
		MatchQ[citationStyles, {Cell[__] ...}],
		"Citation style cells are malformed."
	];

	{
		text,
		GridBox[Join[
			{{
				ItemBox["", ItemSize -> "Fit"],
				ItemBox[
					TagBox[
						ButtonBox[icon, BaseStyle -> "CitationPopupCloseButton", Appearance -> None],
						MouseAppearanceTag["LinkHand"]
					],
					Alignment -> Right
				]
			}},
			Map[
				{#, "\[SpanFromLeft]"} &,
				citationStyles
			]
		]]
	}
]];

BuildCitation[___] := $Failed;


BuildCitationCell[lang_String:"English"] := With[{
	icon = DynamicBox[FEPrivate`FrontEndResource["DocumentationExpressions", "CitationArrow"]],
	spacer = Cell[BoxData[TemplateBox[{#}, "Spacer1"]]] &,
	citethisas = DynamicBox[FEPrivate`FrontEndResource["DocumentationStrings", "CiteThisAs"]]
},
    Cell[
		TextData[{
			Cell[
				BoxData[DynamicBox[
					If[CurrentValue[EvaluationNotebook[], {TaggingRules, "ShowCitation"}] === False,
						TagBox[
							ButtonBox[
								FrameBox[RowBox[{icon, StyleBox[citethisas, "CitationButtonText"]}]],
								BaseStyle -> "CiteThisAsButton"
							],
							MouseAppearanceTag["LinkHand"]
						],
						StyleBox[TemplateBox[{86, 22}, "Spacer2"]]
					]
				]],
				"CitationCell"
			],
			spacer[8],
			Cell[BoxData[DynamicBox[
				If[CurrentValue[EvaluationNotebook[], {TaggingRules, "ShowCitation"}] === False,
					StyleBox[
						TemplateBox[
							{CurrentValue[EvaluationNotebook[], {TaggingRules, "CitationPopupData"}][[1]]},
							"ClickToCopy",
							BaseStyle -> "CitationText"
						],
						"CitationText"
					],
					StyleBox[TemplateBox[{86, 22}, "Spacer2"]]
				]
			]]]
		}],
		"CitationContainerCell"
	]
]

BuildCitationCell[___] := {};

(******************************************************************************)
(* MakeThumbnail *)

Options[MakeThumbnail] = {Framed -> False, FrameMargins -> 10, Excerpt->{{0, 0}, 1}};

MakeThumbnail[expr_, OptionsPattern[]] :=
	Block[{
			thumbnailSize = 300, frameColor = LightGray, frameThickness = 2, 
			excerpt = OptionValue[Excerpt],
			size, nativeSize, thumbnailImage
		},

		size = thumbnailSize - If[OptionValue[Framed], 2 OptionValue[FrameMargins], 0];
		nativeSize = Max[ImageDimensions[If[Head[expr]=!=Image,Rasterize[expr],expr]]];
		thumbnailImage = ImageCrop[
			Rasterize[Cell[BoxData@ToBoxes@Style[expr, Magnification->N[size/nativeSize]/Last[excerpt]],"Output",PageWidth->1000],"Image"],
			{size, size}, If[excerpt[[2]]==1, {0, 0}, ((excerpt[[2]] + 2 # - 1)/(excerpt[[2]] - 1))& /@ excerpt[[1]]], Padding -> White];
		thumbnailImage = If[!OptionValue[Framed],
			thumbnailImage,
			ReplacePixelValue[
				ImageCrop[thumbnailImage, thumbnailSize {1, 1}, Padding -> White], 
				{{1;;thumbnailSize, 1;;frameThickness} -> frameColor,
				{1;;thumbnailSize, (thumbnailSize - frameThickness + 1);;thumbnailSize} -> frameColor,
				{1;;frameThickness, 1;;thumbnailSize} -> frameColor, 
				{(thumbnailSize - frameThickness + 1);;thumbnailSize, 1;;thumbnailSize} -> frameColor
			}]
		];
		CellPrint[Cell[BoxData[ToBoxes[Row[{Style[thumbnailImage, Magnification->0.5, ImageSizeMultipliers->{}], " (size preview)"}]]],
			"Output", "SuppressedMaterial"]];
		CellPrint[Cell[BoxData[ToBoxes[thumbnailImage]], "Output", "AlternateThumbnail"]]
	]
(******************************************************************************)

(******************************************************************************)
(* GetFeaturesetFunctions												      *)
(*   Since build machines may not have local docs installed, this does guide  *)
(*   page lookups using the web docs                                          *)

GetFeaturesetFunctions[funcs_List] := funcs;

GetFeaturesetFunctions[funcs_List, guideURIs_List, lang_String:"English"] :=
  Module[{URLprefix = "https://reference.wolfram.com/language/", URLsuffix, guidefuncs},
  	If[MatchQ[guideURIs, {}], Return[funcs]];
  	
  	URLsuffix = ".html" <> Switch[lang,
  		"English", "",
  		"Japanese", ".ja",
  		"ChineseSimplified", ".zh",
  		_, ""
  	];
  	
  	(* need to use web guides since local docs may not exist *)
  	(* need to do Reverse shenanigans to avoid getting results in alpha-order because of dropdown links *)
  	guidefuncs = 
  	  Check[
  		Flatten[(
  		Reverse[DeleteDuplicates[StringCases[#, "ref/" ~~ (name__ /; StringFreeQ[name, "/"]) ~~ ".html" :> name] & /@ 
  		Select[Reverse[Import[StringJoin[URLprefix, #, URLsuffix], "Hyperlinks"]], 
  			StringMatchQ[#, "*/language/ref/*"] &]]]) & /@ guideURIs],
  		{}
  		];
  			
  	DeleteDuplicates[Join[funcs, guidefuncs]]

  ];
  
(******************************************************************************)
(* GetFeaturesetDocsThumbnails											      *)

GetFeaturesetDocsThumbnails[uri_String, urlprefix_String : "https://reference.wolfram.com/language/", windowsize_ : {640, 702},
	headersize_ : -129] :=
 Module[{session = StartWebSession["Firefox", Visible -> False], im},

  im = FeaturesetCaptureThumbnail[session, uri, urlprefix, windowsize];
  DeleteObject[session];
  ImagePad[im, {{0, 0}, {0, headersize}}]
  ];
  
GetFeaturesetDocsThumbnails[uris_List, urlprefix_String : "https://reference.wolfram.com/language/", windowsize_ : {640, 702},
	headersize_ : -129] :=
 Module[{session = StartWebSession["Firefox", Visible -> False], im},

  im = FeaturesetCaptureThumbnail[session, #, urlprefix, windowsize] & /@ uris;
  DeleteObject[session];
  Association[
   Thread[uris -> (ImagePad[#, {{0, 0}, {0, headersize}}] & /@ im)]]
  ];
  
FeaturesetCaptureThumbnail[session_WebSessionObject, uri_String, urlprefix_String : "https://reference.wolfram.com/language/",
	windowsize_ : {640, 702}] :=
 Module[{},
  WebExecute[session, "SetWindowSize" -> windowsize];
  WebExecute[session, 
   "OpenPage" -> "https://reference.wolfram.com/language/" <> StringReplace[uri, "paclet:"->""]];
  WebExecute[session, "CapturePage"]
  ];
  
(******************************************************************************)
(* handle special links in the WSM docs *)

(* beware recursion: rhs of a rule should not contain the lhs of the rule *)
stringReplaceRepeated[s_String, rules___] := FixedPoint[StringReplace[#, rules]&, s];

(* this returns a valid http:// url for every known modelica:// link in WSM 4.1 *)
convertModelicaLink[link_String] := 
  If[StringMatchQ[link, StartOfString ~~ "modelica://" ~~ __],
    (* StringReplace[link, RegularExpression["modelica:///([^\\.]+)(.*\)"] -> "http://reference.wolfram.com/system-modeler/libraries/$1/$1$2.html"], *)
    StringReplace[link, RegularExpression["modelica:///([^\\.]+)(.*)"] -> "/system-modeler/libraries/$1/$1$2.html"],
    link
  ]

(* this returns a valid http:// url for every known wsm:// link in WSM 4.1 *)
convertWSMLink[link_String] := 
  If[StringMatchQ[link, StartOfString ~~ "wsm://" ~~ __],
    stringReplaceRepeated[link, {

      ".nb" ~~ EndOfString                   -> ".html",
      StartOfString ~~ "wsm:///ref/ModelicaSpecification/" -> "https://specification.modelica.org/maint/3.5/",
      StartOfString ~~ "wsm:///ref/ModelicaByExample/" -> "https://mbe.modelica.university/",
      (* StartOfString ~~ "wsm://"              -> "http://reference.wolfram.com", *) (* absolute paths *)
      StartOfString ~~ "wsm://"              -> "", (* relative paths *)
      (* as of 11.3.0, WSMLink is maintained at language/WSMLink *)
      "/mathematica/ReferencePages/Symbols/" -> "/language/WSMLink/ref/",
      "/mathematica/Tutorials/"              -> "/language/WSMLink/tutorial/",
      "/ref/GettingStarted/"                 -> "/system-modeler/GettingStarted/",
      "/ref/UserGuide/"                      -> "/system-modeler/UserGuide/",
      "/ref/root.html"                       -> "/system-modeler/",
      "/ref/guide/WolframRoot.html"          -> "/language/guide/WolframRoot.html",
      "/ref/WhatsNew/"                       -> "/system-modeler/WhatsNew/",

      (* temporary kludge til the file is renamed *)
      "ReliabilityInSystemModeler.html"      -> "ReliabilityinSystemModeler.html"
    }],
    link
  ]

(******************************************************************************)

CheckSeeAlsos[
	nbexpr_,
	lang_?StringQ
] := Module[{
	knownLinkBases = DocumentationBuild`Info`GetSourceInformationLinkBases[lang],
	seealsocell,
	uris,
	allUrisCount,
	notOKuris,
	newcell
},
	(* Each documentation notebook should have at most one "SeeAlso" section. *)
	seealsocell = Replace[
		Cases[nbexpr, Cell[___, "SeeAlso", ___], Infinity],
		{
			{} :> Return[nbexpr, Module],
			{first_} :> first,
			{first_, __} :> (
				DocsWarning["notebook contains more than one \"SeeAlso\" section cell."];
				first
			)
		}
	];

	(* Get the list of See Also links to filter. This only includes URI's that we have
	   source information about. *)
	uris = Module[{system, package},
		(* Most link types, 2-arg template box. *)
		system  = Cases[seealsocell, TemplateBox[{_, uri_}, __] :> uri, Infinity];

		(* Package links and other special links, 3-arg template box. *)
		package = Cases[seealsocell, TemplateBox[{_, uri_, _}, __] :> uri, Infinity];

		(* Get the total number of URIs in the source See Also list. *)
		allUrisCount = Length[Join[system, package]];

		(* Only include package links if we have source information about the link
		   destination package. If we don't, then we don't know if this is a valid
		   page or not, so we shouldn't bother checking it.

		   This check is require in the situation that e.g. we're building documentation
		   for PacletFoo, which happens to contain links into PacletBar. At build time, we
		   can compute the source info for PacletFoo, but likely won't have the source
		   info for PacletBar. We don't want to confuse not have *any* source info for
		   PacletBar with determining that a *particular* PacletBar link is in error
		   because that one URI doesn't appear in the PacletBar source info we do have.
		*)
		package = Select[
			package,
			uri |-> StringStartsQ[
				ToPacletURI[uri],
				"paclet:" ~~ Alternatives @@ knownLinkBases
			]
		];

		Join[system, package]
	];

	If[uris === {},
		Return[nbexpr]
	];

	DocsAssert[
		MatchQ[uris, {___?StringQ}],
		"\"SeeAlso\" section TemplateBox(s) expected URI field was not a string: ``",
		InputForm[uris]
	];

	(* The "not OK" URIs are ones which either don't correspond to a known piece of
		documentation, or correspond to a piece of documentation which is either not ready
		for release (has the Future flag) or has been explicitly hidden (has the Excised
		flag). *)
	notOKuris = Select[
		uris,
		Function[{uri},
			With[{uriFlag = DocumentationBuild`Info`LookupSourceInformation[uri, lang, "Flag"]},
				If[MissingQ[uriFlag],
					DocsWarning["See Also section link to unknown URI has been removed: '``'", uri];
				];

				MissingQ[uriFlag] || MatchQ[uriFlag, "FutureFlag" | "ExcisedFlag" | "InternalFlag"]
			]
		]
	];

	(* If every URI in the source See Also section is bad, remove the entire section. *)
	If[Length[notOKuris] === allUrisCount,
		Return[ReplaceAll[nbexpr, Cell[___, "SeeAlsoSection", ___] -> Sequence[]]];
	];

	newcell = CollapseListings[
		DeleteCases[
			seealsocell,
			Cell[c_,___] /; MemberQ[c, Alternatives @@ notOKuris, Infinity],
			Infinity
		]
	];

	ReplaceAll[nbexpr, seealsocell -> newcell]
]

CheckGuideInlineListings[nbexpr_, lang_:"English"] :=
  Module[{listingcells},
  (* TODO: write this function *)
  nbexpr]

(* re-including seealsos to ref/menuitem/* since I'm not sure why they were ever removed or if it was intentional... *)
CollapseListings[cell_] := Module[{buttons, delimiter},
	delimiter = StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", "InlineSeparator"];

	buttons = Cases[cell, Cell[__, "InlineFunctionSans" | "InlineFormula" | "InlineCharacterName" | "MenuName", ___], Infinity];

	Cell[
		TextData[
			Flatten[Append[{#, "\[NonBreakingSpace]", delimiter, " "}& /@ Most[buttons], Last[buttons]]]
		],
		Sequence @@ Rest[cell]
	]
]

(******************************************************************************)

MakeNotesImage[refpage_NotebookObject] := 
 Module[{cell, workingnb, img},
  cell = Cells[refpage, CellStyle -> "NotesSection"];
  Catch[If[! MatchQ[cell, {}], cell = First[cell], Throw[$Failed]];
   SelectionMove[cell, All, Cell];
   FrontEndTokenExecute[refpage, "ExpandSelection"];
   DocumentationBuild`Utils`Private`cells = SelectedCells[refpage];
   workingnb = 
    CreateWindow[Visible -> False, 
     StyleDefinitions -> "Wolfram/Reference.nb"];
   NotebookWrite[workingnb, 
    Cell[BoxData[
      RowBox[{"Rasterize", "[", "Rest", "[", 
        "DocumentationBuild`Utils`Private`cells", "]", "]"}]], 
     "Input"]];
   img = NotebookEvaluate[workingnb];
   NotebookClose[workingnb];
   img = ImageResize[img, {160, Automatic}];
   img = Flatten[ImagePartition[img, {160, 80}]];
   img = Append[{img}, 
     If[Length[img] > 4, "IncludeEllipsis" -> True, 
      "IncludeEllipsis" -> False]];
   CompressDataAsImage[img]]];
   
CompressDataAsImage[data_]:=Module[{cc=ToCharacterCode[Compress[data]],l,part,diff=0,diffflag=False,square},l=Length[cc];
  Which[
    IntegerQ[Sqrt[l]],
      part=Sqrt[l],
    Abs[Ceiling[Length[Divisors[l]]/2]-Sqrt[l]]<Min[2l,6],
      part=Ceiling[Length[Divisors[l]]/2],
    Abs[Floor[Length[Divisors[l]]/2]-Sqrt[l]]<Min[2l,6],
      part=Floor[Length[Divisors[l]]/2],
    True,
      square=(part=Ceiling[Sqrt[l]])^2;
      diff=square-l;
      diffflag=True];
  If[diffflag,
    cc=Join[cc,Table[0,diff]]
  ];
  Image[Partition[cc,part],"Byte",TaggingRules->{"CompDiff"->diff}]
 ];

UncompressDataAsImage[image_]:=Module[{fcc,diff},
  diff="CompDiff"/.(TaggingRules/.Options[image]);
  fcc=Uncompress[FromCharacterCode[Drop[Flatten[ImageData[image,"Byte"]],-diff]]];
  fcc];

Options[ExportToMP4] = {
  "VideoEncoding" -> "MPEG-4 Video",
  "ShowControls" -> True,
  "ControlAppearance" -> Automatic,
  "FrameRate" -> 7
};

ExportToMP4[exportFile_String, manipulateExpr_Cell, OptionsPattern[]] := Module[
  {optVideoEncoding, optShowControls, optControlAppearance, optFrameRate},

  {optVideoEncoding, optShowControls, optControlAppearance, optFrameRate} =
    OptionValue[{"VideoEncoding", "ShowControls", "ControlAppearance", "FrameRate"}];

  Export[
    exportFile, 
    manipulateExpr,
    "QuickTime",
    "VideoEncoding" -> optVideoEncoding
    (* "ShowControls" -> optShowControls, *)
    (* "ControlAppearance" -> optControlAppearance, *)
    (* "FrameRate" -> optFrameRate *)
  ]
];

Options[ExportToAnimatedGIF] = {
  "QuicktimeOptions" -> {
    "ShowControls" -> True,
    "ControlAppearance" -> Automatic,
    "FrameRate" -> 7
  },
  "AnimatedGIFOptions" -> {
    "DisplayDurations" -> .25,
    "ShowControls" -> True,
    "ControlAppearance" -> Automatic,
    "FrameRate" -> 7
  }
};

ExportToAnimatedGIF[exportFile_String, manipulateExpr_Cell, OptionsPattern[]] := Module[
  {
    movie, optQuicktimeOptions, optAnimatedGIFOptions, tmpFile
  },

Print["entering ExportToAnimatedGIF"];

  {optQuicktimeOptions, optAnimatedGIFOptions} = OptionValue[{
     "QuicktimeOptions",  "AnimatedGIFOptions"}];

Print["   optQuicktimeOptions = "<>ToString[InputForm[optQuicktimeOptions]]];
Print["   optAnimatedGIFOptions = "<>ToString[InputForm[optAnimatedGIFOptions]]];

  (* this happens in the "Output" transform in Defaults.m *)
  (* manipulateExpr = ReleaseHold@MakeExpression[First@expr, StandardForm]; *)

  (* Export to QuickTime *)

  tmpFile = CreateFile[]<>".mov";
Print["   exporting expr to "<>tmpFile];
  Export[
    CreateFile[],
    manipulateExpr,
    "QuickTime",
    optQuicktimeOptions
  ];

  (* Import QuickTime as list, Export animated GIF *)
  Export[
    exportFile,
    Import[movie, "ImageList"][[1 ;; -1 ;; 3]],
    optAnimatedGIFOptions
  ]
]

ChangeImageTransparency[img_, alphapercent_?NumericQ] := 
 Module[{newimg = img}, 
  If[TrueQ[ImageMeasurements[img, "Transparency"]],
   newimg = 
    SetAlphaChannel[newimg, 
     Image[ImageData[AlphaChannel[newimg]]*alphapercent]],
   newimg = SetAlphaChannel[newimg, alphapercent]]];

ChangeGraphicsTransparency[gr_, tr_?NumericQ] :=
  ReplaceAll[gr,{
   (col:(RGBColor|LABColor|LCHColor|XYZColor|LUVColor))[r_,g_,b_]:>col[r,g,b,tr],
   CMYKColor[c_,m_,y_,k_]:>CMYKColor[c,m,y,k,tr]}];

(*********************************************************************
Ancestor[expr, list]

  given a node whose Position in expr is given by list, return the
  node's nearest ancestor that is a cell whose first element is not
  CellGroupData.

Ancestor[expr, list, test]

  given a node whose Position in expr is given by list, return the
  node's nearest ancestor for which test is True.

Options
-------

  AllAncestors
  ------------

  AllAncestors -> False is the default; return the first matching ancestor.

  AllAncestors -> True returns each expression from the leaf to the root.  Take care
  here: an expression near the root may be an entire notebook or page or other
  gargantuan item.

  Direction
  ---------

  Direction -> "FromRoot" examines expr for leaf's ancestor starting
  at the root of the expression tree and moving toward the leaf,
  returning the first one found.

  Direction -> "TowardRoot" examines expr for leaf's ancestor starting
  at leaf and moving toward the root, returning the first one found.

  Self
  ----

  Self -> True allows the function to return leaf as its ancestor, if
  leaf matches test.

  Self -> False will not return leaf as its ancestor, even if it
  matches test.

*********************************************************************)

Options[Ancestor] = {
  Direction -> "FromRoot", (* or "TowardRoot" *)
  Self -> True,
  AllAncestors -> False
}

(*********************************************************************
The default test function here was given me by Lou D'Andria when I
asked about a "nearest enclosing cell" function: searching from the
root of the expression, return the first cell whose first element is
not CellGroupData.
*********************************************************************)

Ancestor[expr_, position_List, OptionsPattern[]] :=
  Ancestor[
    expr,
    position,
    Function[x, (Head[x] == Cell && Head[First[x]] =!= CellGroupData)],
    OptionValue[{Direction, Self, AllAncestors}]];

Ancestor[expr_, position_List, test_Function, OptionsPattern[]] := Module[
  {optDirection, optSelf, optAllAncestors, pos = position, posList, exprList, res}
,
  {optDirection, optSelf, optAllAncestors} = OptionValue[{Direction, Self, AllAncestors}];

  (***************************************************************
  debug
  Print["DEBUG: "<>"Direction = "<>ToString@optDirection];
  Print["DEBUG: "<>"Self = "<>ToString@optSelf];
  ***************************************************************)

  (*****************************************************************
  When Self -> True, the leaf at position 'pos' is considered for test.
  When Self -> False, the leaf's position 'pos' is removed from the
  position vector so it can never be considered for test.
  *****************************************************************)
  pos = If[optSelf, pos, Most@pos];

  (***************************************************************
  debug
  Print["DEBUG: "<>"pos = "<>ToString@pos];
  ***************************************************************)

  (*****************************************************************
  Convert a position vector into a partitioned list.

  When Direction -> "FromRoot", the position vector {1,2,3} becomes
  {{1}, {1, 2}, {1, 2, 3}}, where {1} is the Position of root.

  When Direction -> "TowardRoot", the position vector {1,2,3} becomes
  {{1, 2, 3}, {1, 2}, {1}}, where {1} is the Position of root.
  *****************************************************************)
  posList = Switch[optDirection,
    "FromRoot",   Reverse[NestList[Most, pos, Length[pos] - 1]],
    "TowardRoot",         NestList[Most, pos, Length[pos] - 1]];

  (*********************************************************************
  debug
  Print["DEBUG: "<>"posList = "<>ToString@posList];
  *********************************************************************)

  exprList = Extract[expr, #]& /@ posList;
  (* select and return the first element found that matches test *)
  res = Select[exprList, test];
  res = If[Length@res === 0, {}, If[optAllAncestors, res, First@res]];
  res
];

(* ** exportFEBitmap *)

(* $InstallationDirectory/SystemFiles/FrontEnd/TextResources/Bitmaps.tr *)

(*
possible heads for retrieved FEBitmaps:
In[10]:= DeleteDuplicates[Head /@ bitmaps[[All, 2]]]
Out[10]= {GraphicsBox, DynamicBox, FEPrivate`FrontEndResource, FrameBox, StyleBox, Cell, RasterBox}
*)

exportFEBitmap[file:_String, bitmapName:_String, format:___String] :=
  Export[
    file,
    Dynamic@RawBoxes@FEPrivate`FrontEndResource["FEBitmaps", bitmapName],
    format
  ];

(* ** compoundDuration *)

(*
In[2]:= compoundDuration[999]
Out[2]= 16 min, 39 sec

https://rosettacode.org/wiki/Convert_seconds_to_compound_duration#Mathematica *)
compoundDuration[x_Integer] :=
  StringJoin @@ (Riffle[
    ToString /@ (
      (
        (
          {Floor[x/604800] , Mod[x, 604800]} /. {a_, b_} -> {a, Floor[b/86400], Mod[b, 86400]}
        ) /. {a__, b_} -> {a, Floor[b/3600], Mod[b, 3600]}
      ) /. {a__, b_} -> {a, Floor[b/60], Mod[b, 60]}
    )
  , {" wk, ", " d, ", " hr, ", " min, ", " sec"}] //. {a___, "0", b_, c___} -> {a, c}
  );

(* ** partitionList *)

(* given a list of integers (build times for files), partition the list into 8
parts so the Totals of the parts are approximately the same.

There are cleverer ways to split a list of integers into n parts so that the
Total of each is close to a given number.  See these for background:
 - https://mathematica.stackexchange.com/questions/7511/partitioning-with-varying-partition-size
 - https://mathematica.stackexchange.com/questions/66815/partition-list-into-a-given-number-of-sub-lists
 - https://mathematica.stackexchange.com/questions/193570/divide-a-list-into-two-lists-with-equal-sums
 - https://mathematica.stackexchange.com/questions/141173/partition-list-into-n-sublists
 - https://mathematica.stackexchange.com/questions/34952/how-to-partition-a-list-of-numbers-in-two-lists-of-numbers-such-that-each-lists

Returns a list of Take specifications.

In[3]:= partitionList[RandomChoice[Range[10], 15000]]
Each of the 8 parts should take about 10295 seconds = 2 hr, 51 min, 35 sec, depending on the build machine.
Partitioning specs are: {{1, 1861}, {1862, 3718}, {3719, 5618}, {5619, 7494}, {7495, 9364}, {9365, 11249}, {11250, 13105}, {13106, 15000}}

Out[3]= {{1, 1861}, {1862, 3718}, {3719, 5618}, {5619, 7494}, {7495, 9364}, {9365, 11249}, {11250, 13105}, {13106, 15000}} *)

partitionList[list_List] := Module[{temp, binNumber, binSize, p}, 
  (* we'll destructively drop items from temp into our 8 bins, but we'll still want to refer to the original data at the end of the action *)
  temp = list;

  (* Print["filling bins"]; *)
  binNumber = 1; p = {};
  binSize = IntegerPart @ Total[temp/8];

  While[Total[temp] > binSize,
    (* while there are still enough seconds left in temp to fill a bin.., *)
    (* start the bin-filling action with the first item in temp *)
    i = 1;

    While[Total[temp[[;;i]]] < binSize,
      (* the bin-filler: while we haven't yet filled a bin with items from temp... *)
      (* ...grab the next item from temp *)
      i++;
    ]; (* close the bin-filler *)

    (* now we have enough items from temp to fill a bin.  save the number of the last item... *)
    AppendTo[p, i];

    (* and remove that many items from the front of temp, since we have now conceptually dropped them into a bin *)
    temp = Drop[temp, i];

    binNumber++;
  ]; (* close "while there are enough items left in temp to fill a bin" *)

  partSpecs = Total[p[[;;#]]]& /@ Range[Length[p]];
  PrependTo[partSpecs, 0]; AppendTo[partSpecs, Length[list]];
  partSpecs = Partition[partSpecs, 2, 1];
  partSpecs[[All, 1]] = partSpecs[[All, 1]] + 1;
  Print["Each of the 8 parts should take about "<>ToString[binSize]<>" seconds = "<>ToString[compoundDuration[IntegerPart[binSize]]]<>", depending on the build machine."];
  Print["Partitioning specs are: "<>ToString[partSpecs, InputForm]];
  partSpecs
];

containsLinkQ[x_] :=
Or[
  Positive @ Count[x, s_String /; StringContainsQ[s, StartOfString ~~ "paclet:"], All]
, Positive @ Count[x, URL[_String], All]
];

(* https://mathematica.stackexchange.com/a/66114 *)
Options[decamel] = {
  "Lowercase" -> False
, "Separator" -> "-"
, "Replacements" -> {RegularExpression["[[:punct:][:space:]]"].. -> ""}
};
decamel[s:_String, OptionsPattern[]] := Module[
  {optLowercase, optSeparator, optReplacements, res, string = s}
, {optLowercase, optSeparator, optReplacements} = OptionValue[{"Lowercase", "Separator", "Replacements"}];
  (* so we have "This and That" -> "This-And-That", not "Thisand-That" *)
  string = StringReplace[string, WordBoundary ~~ x_ :> ToUpperCase[x]];
  res = StringJoin[Riffle[
    StringSplit[
      StringReplace[string, optReplacements]
    , RegularExpression["(?=\\$)|(?<![\\d[:upper:]])(?=[\\d[:upper:]])|(?=[\\d[:upper:]][^\\d[:upper:]])"]
    ]
  , optSeparator
  ]];
  If[optLowercase, res = ToLowerCase[res]];
  res
];

(*
In[13]:= decamel[#, "Lowercase" -> True, "Separator" -> "-"]& /@ {"Plot3D", "AbcDef", "ZIPCode"}
Out[13]= {plot-3d, abc-def, zip-code}
*)


End[]
EndPackage[]
