#!/usr/bin/env bash

htdocs=/www/sites/reference.wolfram.com/htdocs
cloud=$htdocs/cloudplatform

# convert a single file
indexconvert () {
    perl -i -pe 'BEGIN{undef $/;}

        s|/language-assets/|/cloud-assets/|smg;
        s|<!DOCTYPE html>|<!--#include virtual="/cloud-assets/inc/doc-beginning.html.en"-->|smg;
        s|<html lang="en" class="_footer-thin _header-thin-only">||smg;
        s|<html lang="ja" class="_footer-thin _header-thin-only">||smg;
        s|<html lang="zh" class="_footer-thin _header-thin-only">||smg;
        s|<head>||smg;
        s|<!--#include virtual="/common/framework/inc/head.en.php"-->||smg;
        s|<!--#include virtual="/common/framework/inc/head.ja.php"-->||smg;
        s|<!--#include virtual="/common/framework/inc/head.zh.php"-->||smg;
        s|<!--#include virtual="/common/framework/inc/footer.en.php"-->||smg;
        s|<!--#include virtual="/common/framework/inc/footer.ja.php"-->||smg;
        s|<!--#include virtual="/common/framework/inc/footer.zh.php"-->||smg;

        s|href="/language/|href="/cloudplatform/|smg;
        s|href=\x27/language/|href=\x27/cloudplatform/|smg;

        s|src="http://reference\.wolfram\.com/chars|src="/chars|smg;
        s|src="http://reference|src="//reference|smg;

        # add to all, then remove selectively
        s|href="http|target="_blank"\ href="http|smg;
        s|target="_blank" href="/cloudplatform/guide/AlphabeticalListing"|href="/cloudplatform/guide/AlphabeticalListing"|smg;

    ' "$1" # quoted to ensure correct handling of filenames with spaces
}

echo "Converting the main index files..."
indexconvert $cloud/index.html.en
indexconvert $cloud/index.html.ja
indexconvert $cloud/index.html.zh
echo "Done."
