#!/Applications/Mathematica.app/Contents/MacOS/WolframScript -script

PrependTo[$Path, "~/git"];
PacletDirectoryLoad["~/git"];
Get["DocumentationBuild`"];
Print[StringJoin["DocumentationBuild: ", ToString[FindFile["DocumentationBuild`"]]]];
Print[StringJoin["Transmogrify:       ", ToString[FindFile["Transmogrify`"]]]];

dir = "~/git/featuresetpages/";
manifest = FileNames["*.nb", dir, Infinity];

res = Reap[Module[{nb, expr, thumbpages},
  nb = #;
  expr = Quiet@Get@nb;
  thumbpages = Cases[expr, Cell[CellGroupData[{Cell["Thumbnailed Pages", "FeaturesetRelatedDocumentationSubsection", ___], c:__Cell}, ___], ___] :> c, Infinity];
  thumbpages = Cases[thumbpages, Rule[ButtonData, s:_String] :> StringReplace[s, {"paclet:System/WorkflowGuides/" -> "workflowguide/", "paclet:" -> ""}], Infinity];
  If[Positive @ Length @ thumbpages, Sow[thumbpages, nb]]
]& /@ manifest, _, Rule][[2]];

res[[All, 2]] = Flatten /@ res[[All, 2]];

(* report what was found *)
Print["Pages that specify thumbnail urls:"];
Print[format[res]];

uris = Union @ Flatten[res[[All, 2]]];
(* Print["uris:"]; *)
(* Print[format[uris]]; *)

res = Reap[Module[{uri, url, file, commonassetsDir = "/Users/billw/git/featuresetpages/English/_CommonAssets"},
  uri = #;
  file = StringReplace[uri, {
    StartOfString ~~ "guide/"              :> FileNameJoin[{commonassetsDir, "System", "Guides"}]<>$PathnameSeparator
  , StartOfString ~~ "workflowguide/"      :> FileNameJoin[{commonassetsDir, "System", "WorkflowGuides"}]<>$PathnameSeparator
  , StartOfString ~~ "tutorial/"           :> FileNameJoin[{commonassetsDir, "System", "Tutorials"}]<>$PathnameSeparator
  , StartOfString ~~ "PDEModels/tutorial/" :> FileNameJoin[{commonassetsDir, "PDEModels", "Tutorials"}]<>$PathnameSeparator
  }]<>".webp";

  Sow[file, uri]
]& /@ uris, _, List][[2]];

res[[All, 2]] = First /@ res[[All, 2]];

(* Print[format[res]]; *)

Module[{uri, file},
  {uri, file} = #;
  Print["Taking a screenshot of "<>uri<>" and saving it at "<>file];
  Export[file, GetFeaturesetDocsThumbnails[uri]]
]& /@ res

Quit[]

After taking screenshots, update the web assets by running documentationbuild/Scripts/FeaturesetScreenshots/push.sh
