

BeginPackage[ "MEET`RemoteFiles`"]

MakeFile::usage = "MakeRemoteFile[ name, contents] makes a remote file with given name and contents."

SetProjectBase::usage = "SetProjectBase[ proj] creates the base for the project in the remote file system, this might delete the current setting." 


Begin["`Private`"]



$WorkbenchFileRoot = ToFileName[ {$UserBaseDirectory}, "WorkbenchFiles"];

createDirectories[ ""] :=
	Error
	
createDirectories[ dir_] :=
	Module[ {parent},
		If[ FileType[dir] === None,
			parent = DirectoryName[ dir];
			createDirectories[ parent];
			CreateDirectory[ dir]];
	]


SetProjectBase[ projName_String] :=
	Module[ {dir},
		dir = ToFileName[ {$WorkbenchFileRoot}, projName];
		deleteEntry[ dir];
		createDirectories[ dir];
		PrependTo[ $Path, dir];
	]
	
deleteEntry[ name_] :=
		Switch[ FileType[dir],
			File, DeleteFile[ dir],
			Directory, DeleteDirectory[dir, DeleteContents -> False],
			_, 1];
	

MakeFile[ projName_String, dirFile_String, nameFile_String, contents_String] :=
	Module[ {dir, fullFile, stm},
		dir = ToFileName[ {$WorkbenchFileRoot, projName}, dirFile];
		createDirectories[ dir];
		fullFile = ToFileName[ {dir}, nameFile];
		deleteEntry[ fullFile];
		stm = OpenWrite[ fullFile, BinaryFormat -> True];
		BinaryWrite[ stm, contents];
		Close[ stm];
	]


End[]

EndPackage[]

