(* Mathematica Package *)

BeginPackage["WorkbenchDocumentation`", {"DocumentationTools`"}]

WorkbenchCreateSymbolPages::usage = "CreateSymbolPages[ symbols, workingDir, docDir] creates filled out symbol pages in workingDir then moves to docDir."
(* Exported symbols added here with SymbolName::usage *)  

Begin["`Private`"] (* Begin Private Context *) 

DocumentationTools`DocuToolsLoader[];

WorkbenchCreateSymbolPages[ symbols_List, workingDir_, docsDir_] :=
	Module[ {files, outFiles},
		files = FileNames[ "*.nb", workingDir];
		Map[ DeleteFile, files];
		DocumentationTools`$ReferencePagesDirectory = workingDir;
		DocumentationTools`AuxiliaryCreateReferencePages[ symbols];
		files = FileNames[ "*.nb", workingDir];
		outFiles = Map[ FileNameTake[#, -1]&, files];
		outFiles = Map[ FileNameJoin[ {docsDir, #}]&, outFiles];
		files = Transpose[ {files, outFiles}];
		Apply[ RenameFile[#1, #2]&, files, {1}]
	]

WorkbenchCreateSymbolPages[ All, workingDir_, docsDir_] :=
	Module[ {},
		DocumentationTools`$ReferencePagesDirectory = docsDir;
		DocumentationTools`AuxiliaryCreateReferencePages[ DocumentationTools`$ReferencePagesDirectory]
	]

End[] (* End Private Context *)

EndPackage[]