
PrintLogger::usage =
"PrintLogger[] is an MUnit logger that writes a simple form of test output to $Output."

ProgressLogger::usage =
"ProgressLogger[] is an MUnit logger that prints a progress indicator during the test run."

NotebookLogger::usage =
"NotebookLogger[] is an MUnit logger that writes test results to a notebook."

BatchPrintLogger::usage =
"BatchPrintLogger[] is a deprecated logger that is aliasing to PrintLogger."

VerbosePrintLogger::usage =
"VerbosePrintLogger[] is an MUnit logger that writes verbose test results to $Output."

LogStart::usage =
"LogStart[logger] logs the beginning of a test run. LogStart is deprecated. please use LogBegin"



LogBegin::usage =
"LogBegin[logger] logs the beginning of a test run."

LogTestRunProgress::usage =
"LogTestRunProgress[logger, progress] logs the progress of a test run."

LogMessage::usage =
"LogMessage[logger, string] logs a message."

LogSuccess::usage =
"LogSuccess[logger, tr] logs a test success."

LogFailure::usage =
"LogFailure[logger, tr] logs a test failure."

LogMessagesFailure::usage =
"LogMessagesFailure[logger, tr] logs a test messages failure."

LogError::usage =
"LogError[logger, tr] logs a test error."

LogTestInfo::usage =
"LogTestInfo[logger, testid, index, willRun] logs a test id and approximate test index, whether or not the test will run."

LogFatal::usage =
"LogFatal[logger, string] logs a fatal error."

LogBeginTestSection::usage =
"LogBeginTestSection[logger, section, require] logs the start of a section."

LogEndTestSection::usage =
"LogEndTestSection[logger] logs the end of a section."

LogCPUTimeUsed::usage =
"LogCPUTimeUsed[logger, time] logs the amount of CPU time used by the test run."

LogAbsoluteTimeUsed::usage =
"LogAbsoluteTimeUsed[logger, time] logs the amount of absolute time used by the test run."

LogMemoryUsed::usage =
"LogMemoryUsed[logger, mem] logs the amount of memory used by the test run."

LogBeginTestSource::usage =
"LogBeginTestSource[logger, source] logs the beginning of a test source in a test run."

LogEndTestSource::usage =
"LogEndTestSource[logger] logs the end of a test source in a test run."

LogEnd::usage =
"LogEnd[logger] logs the end of a test run."

LogTestCount::usage =
"LogTestCount[logger, cnt] logs the number of tests in a test run."

LogSuccessCount::usage =
"LogSuccessCount[logger, cnt] logs the number of successes in a test run."

LogFailureCount::usage =
"LogFailureCount[logger, cnt] logs the number of failures in a test run."

LogMessagesFailureCount::usage =
"LogMessagesFailureCount[logger, cnt] logs the number of messages failures in a test run."

LogSkippedTestCount::usage =
"LogSkippedTestCount[logger, cnt] logs the number of skipped tests in a test run."

LogErrorCount::usage =
"LogErrorCount[logger, cnt] logs the number of errors in a test run."

LogWasAborted::usage =
"LogWasAborted[logger, was] logs whether the test run was aborted."

LogWasFatal::usage =
"LogWasFatal[logger, was] logs whether the test run had a fatal error."

LogWasSyntax::usage =
"LogWasSyntax[logger, was] logs whether the test run had a syntax error."

LogWasSuccessful::usage =
"LogWasSuccessful[logger, succ] logs whether the test run was successful or not."

TestResultsNotebook::usage =
"TestResultsNotebook is an accessor for the notebook logger that returns the results notebook."


 

Begin["`Package`"]

End[]

Begin["`Loggers`Private`"]

(* Compatibility layer for old style loggers *)


(* 
	
	Implementating deprecated behaviour for LogBegin and LogStart, LogStart has been deprecated however something might still use it

	The source code of the Workbench plugin is here: https://stash.wolfram.com/projects/JAVA/repos/workbenchsource/browse
	The custom logger they use is here: https://stash.wolfram.com/projects/JAVA/repos/workbenchsource/browse/com.wolfram.eclipse.testing/MathematicaSource/MeetLogger.m

	This call will simply return unevaluated for other loggers, but if there is un UpValue for LogStart it will be used
	
	The previous code was calling two times the function, only one would match, the following code is making sure we are trying both the 2 argument form and the 3 argument form

	Ideally this code will be removed at some point in the future.
*)
LogBegin[sym_:Except[_Association], first_, second_] /; Not @ TrueQ[logBeginRecursion] := 
	Block[
		{logBeginRecursion = True},
		Scan[
			Function @ If[
				MatchQ[#, Except[_LogBegin|_LogStart]],
				Return[#]
			],
			Hold[
				LogBegin[sym, first],
				LogBegin[sym, first, second],
				LogStart[sym, first],
				LogStart[sym, first, second]
			]
		]
	]

LogBegin[a_Association, rest___]                := a["LogBegin"][rest]
LogTestRunProgress[a_Association, rest___]      := a["LogTestRunProgress"][rest]
LogMessage[a_Association, rest___]              := a["LogMessage"][rest]
LogSuccess[a_Association, rest___]              := a["LogSuccess"][rest]
LogFailure[a_Association, rest___]              := a["LogFailure"][rest]
LogMessagesFailure[a_Association, rest___]      := a["LogMessagesFailure"][rest]
LogError[a_Association, rest___]                := a["LogError"][rest]
LogTestInfo[a_Association, rest___]             := a["LogTestInfo"][rest]
LogFatal[a_Association, rest___]                := a["LogFatal"][rest]
LogBeginTestSection[a_Association, rest___]     := a["LogBeginTestSection"][rest]
LogEndTestSection[a_Association, rest___]       := a["LogEndTestSection"][rest]
LogCPUTimeUsed[a_Association, rest___]          := a["LogCPUTimeUsed"][rest]
LogAbsoluteTimeUsed[a_Association, rest___]     := a["LogAbsoluteTimeUsed"][rest]
LogMemoryUsed[a_Association, rest___]           := a["LogMemoryUsed"][rest]
LogBeginTestSource[a_Association, rest___]      := a["LogBeginTestSource"][rest]
LogEndTestSource[a_Association, rest___]        := a["LogEndTestSource"][rest]
LogEnd[a_Association, rest___]                  := a["LogEnd"][rest]
LogTestCount[a_Association, rest___]            := a["LogTestCount"][rest]
LogSuccessCount[a_Association, rest___]         := a["LogSuccessCount"][rest]
LogFailureCount[a_Association, rest___]         := a["LogFailureCount"][rest]
LogMessagesFailureCount[a_Association, rest___] := a["LogMessagesFailureCount"][rest]
LogSkippedTestCount[a_Association, rest___]     := a["LogSkippedTestCount"][rest]
LogErrorCount[a_Association, rest___]           := a["LogErrorCount"][rest]
LogWasAborted[a_Association, rest___]           := a["LogWasAborted"][rest]
LogWasFatal[a_Association, rest___]             := a["LogWasFatal"][rest]
LogWasSyntax[a_Association, rest___]            := a["LogWasSyntax"][rest]
LogWasSuccessful[a_Association, rest___]        := a["LogWasSuccessful"][rest]

PrintLogger[] :=
	Module[{fatal = False}, Association[
		"LogBegin" -> Function[
		If[# === None,
			WriteString[$Output, "Starting Test Run\n"],
			WriteString[$Output, "Starting test run \"" <> ToString@# <> "\"\n"]
		]],
		"LogBeginTestSection" -> Function[{section, require}, 
			WriteString[$Output, "Starting test section ", section, "\n"]],
		"LogEndTestSection" -> Function[{},
			WriteString[$Output, "\nEnding test section\n"]],
		"LogMessage" -> Function[{msg},
			WriteString[$Output, "\n" <> msg <> "\n"]],

		"LogSuccess" -> Function[{tr},
			WriteString[$Output, "."]],
		"LogFailure" -> Function[{tr},
			Module[{msg = TestFailureMessage[tr]},
				WriteString[$Output, "!"];
				If[msg != "", WriteString[$Output, "\n** " <> ToString[msg] <> " **\n"]]
			]],
		"LogMessagesFailure" -> Function[{tr},
			WriteString[$Output, "*"]],
		"LogError" -> Function[{tr},
			Module[{msg = ErrorMessage[tr]},
				WriteString[$Output, "!"];
				If[msg != "", WriteString[$Output, "\n** " <> msg <> " **\n"]]
			]],
		"LogFatal" -> Function[{msg},
			(fatal = True;
			WriteString[$Output, "\n" <> msg <> "\n"])],
		"LogEnd" -> Function[{testCnt, successCnt, failCnt, msgFailCnt, skippedTestCnt, errorCnt, abort},
			(
				(*
				there is some bug with \n inside of StringForm
				*)
				WriteString[$Output, "\nTests run: " <> ToString[testCnt]];
				WriteString[$Output, "\nFailures: " <> ToString[failCnt]];
				WriteString[$Output, "\nMessages Failures: " <> ToString[msgFailCnt]];
				WriteString[$Output, "\nSkipped Tests: " <> ToString[skippedTestCnt]];
				WriteString[$Output, "\nErrors: " <> ToString[errorCnt]];
				WriteString[$Output, "\nFatal: " <> ToString[fatal]];
				WriteString[$Output, "\n\n"];
			)]
		]
	]

BatchPrintLogger[] := PrintLogger[]

ProgressLogger[] :=
	Module[{col = Column[{}], progStack = {}}, Association[
		"LogBegin" ->  Function[PrintTemporary[Dynamic[col]]],
		"LogBeginTestSource" ->  Function[{source}, (progStack = Append[progStack, 0];col = Column[ProgressIndicator /@ progStack])],
		"LogEndTestSource" ->  Function[{}, (progStack = Most[progStack];col = Column[ProgressIndicator /@ progStack])],
		"LogTestRunProgress" ->  Function[{prog}, (progStack[[-1]] = prog;col = Column[ProgressIndicator /@ progStack])]
	]]


depthToSectionStyle[depth_Integer] := depth /. {1 -> "Title", 2 -> "Section", 3 -> "Subsection", 4 -> "Subsubsection", 5 -> "Subsubsubsection", _ -> "Unknownsection"}

sectionStyleToDepth[style_String] := style /. {"Title" -> 1, "Section" -> 2, "Subsection" -> 3, "Subsubsection" -> 4, "Subsubsubsection" -> 5, _ -> $UnknownDepth}


initializeNotebook[nbSym_, title_] :=
	If[Head[nbSym] =!= NotebookObject,
		nbSym =
			CreateDocument[
				{},
				WindowTitle -> If[MatchQ[title, None|Automatic], "MUnit Test Run Results", title],
				StyleDefinitions -> FrontEnd`FileName[{"MUnit"}, "TestResults.nb"],
				Saveable->False,
				(* to accomodate the failure mode pane and the buttons *)
				WindowSize -> {Large, Automatic},
				(* ensure that the test results notebook does not take focus away from the InputNotebook[]
				during the test run, since there are hooks using InputNotebook[] *)
				(*WindowClickSelect -> False*)
				ShowCellTags -> True
			]
	]


toCell[expr_, type_] := Cell[BoxData[RowBox[{ToBoxes[expr]}]], type]


(*
testNb is the test notebook object
*)
NotebookLogger[] :=
	With[{resNb = Unique["MUnit`Loggers`Private`nb"], dynProg = Unique["MUnit`Loggers`Private`prog"]},
		Module[{$depth = 0}, Association[
			"LogBegin"-> Function[
				UsingFrontEnd[
					initializeNotebook[resNb, #];
					SetOptions[resNb, DockedCells -> {Cell[BoxData[ProgressIndicatorBox[Dynamic[dynProg]]], "Output"]}]
				]],
			"LogTestRunProgress"-> Function[{prog},
				UsingFrontEnd[
					dynProg = prog;
				]],
			"LogMessage"-> Function[{msg},
				UsingFrontEnd[
					NotebookWrite[resNb, Cell[msg, "TestMessage"]];
				]],
			"LogSuccess"-> Function[{tr},
				UsingFrontEnd[
					NotebookWrite[resNb, {toCell[tr, "Input"]}]
				]],
			"LogFailure"-> Function[{tr},
				UsingFrontEnd[
					NotebookWrite[resNb, {toCell[tr, "Input"]}]
				]],
			"LogMessagesFailure"-> Function[{tr},
				UsingFrontEnd[
					NotebookWrite[resNb, {toCell[tr, "Input"]}]
				]],
			"LogError"-> Function[{tr},
				UsingFrontEnd[
					NotebookWrite[resNb, {toCell[tr, "Input"]}]
				]],
			"LogFatal"-> Function[{msg},
				UsingFrontEnd[
					NotebookWrite[
						resNb, 
						Cell[msg, "TestFatal"]
					]
				]],
			"LogBeginTestSection"-> Function[{section, require},
				UsingFrontEnd[
					$depth++;
					(*If[$depth == 1,
						SetOptions[nb, WindowTitle -> "MUnit Test Run Results for " <> section]
					];*)
					NotebookWrite[resNb, Cell[If[require, section, TextData[StyleBox[section, FontVariations->{"StrikeThrough"->True}]]], depthToSectionStyle[$depth]]];
				]],
			(* LogEndTestSection goes back up the notebook and groups all of the cells *)
			"LogEndTestSection"-> Function[{},
				Module[{(*info*)},
					UsingFrontEnd[
						(*While[(info = Developer`CellInformation[nb]) =!= $Failed && ("Style" /. info[[1]]) != depthToSectionStyle[$depth],
							FrontEndTokenExecute[nb, "SelectPreviousCell"]
						];
						$depth--;
						FrontEndTokenExecute[nb, "CellGroup"];
						SelectionMove[nb, After, Notebook]*)
						$depth--;
					]
				]],
			"LogCPUTimeUsed"-> Function[{time},
				UsingFrontEnd[
					NotebookWrite[resNb, Cell[TextData[{"Test run used ", Cell[BoxData[ToString[time, InputForm]], "Output"], " seconds of CPU time"}], "TestMessage"]];
				]],
			"LogAbsoluteTimeUsed"-> Function[{time},
				UsingFrontEnd[
					NotebookWrite[resNb, Cell[TextData[{"Test run used ", Cell[BoxData[ToString[time, InputForm]], "Output"], " seconds of absolute time"}], "TestMessage"]];
				]],
			"LogMemoryUsed"-> Function[{mem},
				UsingFrontEnd[
					NotebookWrite[resNb, Cell["Test run used " <> ToString[mem, OutputForm] <> " bytes of memory", "TestMessage"]];
				]],
			"LogEnd"-> Function[{testCnt, successCnt, failCnt, msgFailCnt, skippedTestCnt, errorCnt, abortOrFatal},
				UsingFrontEnd[
					NotebookWrite[resNb,
						Cell[ToString[StringForm["Tests run: `1`,  Failures: `2`,  Messages Failures: `3`,  Skipped Tests: `4`, Errors: `5`", testCnt, failCnt, msgFailCnt, skippedTestCnt, errorCnt], OutputForm],
							If[successCnt == testCnt && errorCnt == 0 && !abortOrFatal, "TestRunSuccess", "TestRunFailure"]]];
					SetOptions[resNb, DockedCells -> {}];
					(* restore clickability after test run *)
					(*SetOptions[resNb, WindowClickSelect -> True]*)
				]],
			"TestResultsNotebook"-> Function[resNb]
		]]
	]



	



VerbosePrintLogger[] :=
	Module[{wasAbortedOrFatal = False}, Association[
		"LogBegin" -> Function[
		If[# === None,
			WriteString[$Output, "Starting Test Run\n"],
			WriteString[$Output, "Starting test run \"" <> ToString@# <> "\"\n"]
		]],
		"LogBeginTestSection" -> Function[{section, require},
			WriteString[$Output, "Starting test section ", section, "\n"]],
		"LogEndTestSection" -> Function[
			WriteString[$Output, "\nEnding test section\n"]],
		"LogMessage" -> Function[{msg},
			WriteString[$Output, "\n" <> msg <> "\n"]],
		"LogFatal" -> Function[{msg},
			WriteString[$Output, "\n" <> msg <> "\n"]],
		"LogSuccess" -> Function[{tr},
			WriteString[$Output, "."]],
		"LogFailure" -> Function[{tr},
			Module[{msg = TestFailureMessage[tr]},
				WriteString[$Output, "!\n"];
				WriteString[$Output, "Test number " <> ToString[TestIndex[tr], OutputForm] <> " with TestID " <> ToString[TestID[tr], OutputForm] <> " had a failure.\n"];
				WriteString[$Output, "\tInput: " <> ToString[TestInput[tr], InputForm] <> "\n"];
				WriteString[$Output, "\tExpected output: " <> ToString[ExpectedOutput[tr], InputForm] <> "\n"];
				WriteString[$Output, "\tActual output: " <> ToString[ActualOutput[tr], InputForm] <> "\n"];
				WriteString[$Output, "\tExpected messages: " <> ToString[ExpectedMessages[tr], InputForm] <> "\n"];
				WriteString[$Output, "\tActual messages: " <> ToString[ActualMessages[tr], InputForm] <> "\n"];
				If[msg =!= "", WriteString[$Output, "\n** " <> ToString[msg] <> " **\n"]]
			]],
		"LogMessagesFailure" -> Function[{tr},
			Module[{msg = TestFailureMessage[tr]},
				WriteString[$Output, "*\n"];
				WriteString[$Output, "Test number " <> ToString[TestIndex[tr], OutputForm] <> " with TestID " <> ToString[TestID[tr], OutputForm] <> " had a messages failure.\n"];
				WriteString[$Output, "\tInput: " <> ToString[TestInput[tr], InputForm] <> "\n"];
				WriteString[$Output, "\tExpected messages: " <> ToString[ExpectedMessages[tr], InputForm] <> "\n"];
				WriteString[$Output, "\tActual messages: " <> ToString[ActualMessages[tr], InputForm] <> "\n"];
				If[msg =!= "", WriteString[$Output, "\n** " <> ToString[msg] <> " **\n"]]
			]],
		"LogError" -> Function[{tr},
			Module[{msg = ErrorMessage[tr]},
				WriteString[$Output, "!\n"];
				WriteString[$Output, "Test number " <> ToString[TestIndex[tr], OutputForm] <> " with TestID " <> ToString[TestID[tr], OutputForm] <> " had an error.\n"];
				If[msg =!= "", WriteString[$Output, "\n** " <> msg <> " **\n"]]
			]],
		"LogWasAborted" -> Function[{wasAborted},
			(If[wasAborted, wasAbortedOrFatal = True])],
		"LogWasFatal" -> Function[{wasFatal},
			(If[wasFatal, wasAbortedOrFatal = True])],
		"LogEnd" -> Function[{testCnt, successCnt, failCnt, msgFailCnt, skippedTestCnt, errorCnt, abort},
			(
				If[wasAbortedOrFatal, WriteString[$Output, "\nTest run stopped before completion.\n"]];
				WriteString[$Output, "\nTests run: " <> ToString[testCnt]];
				WriteString[$Output, "\nFailures: " <> ToString[failCnt]];
				WriteString[$Output, "\nMessages Failures: " <> ToString[msgFailCnt]];
				WriteString[$Output, "\nSkipped Tests: " <> ToString[skippedTestCnt]];
				WriteString[$Output, "\nErrors: " <> ToString[errorCnt]];
				WriteString[$Output, "\nFatal: " <> ToString[wasAbortedOrFatal]];
				WriteString[$Output, "\n\n"];
			)]
	]]


End[]
