
Begin["`Package`"]

$MessageWithArgsList


MUnitMessageHandler

messageStringHandler

$MessageStringList

messageNiceStringHandler

$MessageNiceStringList



End[]

Begin["`Messages`Private`"]





(* messageNiceStringHandler provides more detailed error messages and explains how to fix problems.
It is used in the pre-processing loop in TestRun. *)
messageNiceStringHandler[ctlString_String, Hold[msg_MessageName], Hold[Message[msg_MessageName, args___]]] :=
	(
	If[(* stdout would have been in $Messages *)
		ListQ[$Messages],
		Switch[Unevaluated[msg],
			HoldPattern[Syntax::sntunc],
			If[{args} === {HoldForm[""]},
				AppendTo[$MessageNiceStringList,
					"You have \"\\[\" in your code. You probably meant to have \"\\\\[\"." <>
					"\nOriginal Message:\n" <> ToString[StringForm[ctlString, args]]];
				,
				AppendTo[$MessageNiceStringList, ToString[StringForm[ctlString, args]]];
			];
			,
			HoldPattern[Syntax::com],
			AppendTo[$MessageNiceStringList,
				"You have stray commas in your code." <>
				"\nOriginal Message:\n" <> ToString[StringForm[ctlString, args]]]
			,
			_,
			AppendTo[$MessageNiceStringList, ToString[StringForm[ctlString, args]]];
		];
	])

End[]
