
BeginPackage["MUnit`"]

`Information`$VersionNumber = 1.6

`Information`$ReleaseNumber = 0

`Information`$Version = "MUnit Version 1.6.0"

Begin["`Package`"]

$MUnitProtectedSymbols = Hold[
    System`VerificationTest,
    System`TestReport,
    System`TestResultObject,
    System`TestReportObject,
    System`MemoryConstraint,
    System`TestID,
    System`SameTest,
    System`$TestFileName
];

processDecls[file_] :=
    Block[{
        strm = OpenRead[file], 
        expr = Hold[]
        },     
        If[
            Head[strm] =!= InputStream,
            Return[$Failed]
        ];
        While[
            MatchQ[expr, Except[Hold[_End], _Hold]],
            expr = Read[strm, Hold[Expression]];
            ReleaseHold[expr]
        ];
        Close[file];
        file
    ]

End[]

AppendTo[$ContextPath, "MUnit`Package`"]

Scan[Unprotect, MUnit`Package`$MUnitProtectedSymbols]
Scan[ClearAll, MUnit`Package`$MUnitProtectedSymbols]
Scan[
    Get, 
    Map[
        MUnit`Package`processDecls,
        FileNames[
            "*.m", 
            FileNameJoin @ {DirectoryName @ $InputFileName, "Kernel"}
        ]
    ]
]

(*
Add appropriate handlers.
A problem with using MessageTextFilter is that it is "top-level",
it doesn't get called inside of Quiet 
*)
If[ListQ["MessageTextFilter" /. Internal`Handlers[]],
	Internal`AddHandler["MessageTextFilter", MUnitMessageHandler]
]

If[ListQ["GetFileEvent" /. Internal`Handlers[]],
	Internal`AddHandler["GetFileEvent", MUnitGetFileHandler]
]

EndPackage[]

(* Loader for testing, TODO: unify the two loaders. *)

BeginPackage["Testing`"]

Begin["`Private`"]

Scan[
    Get,
    FileNames[
        "*.m", 
        FileNameJoin @ {DirectoryName @ $InputFileName, "Testing"}
    ]
];

End[] 

EndPackage[]

Scan[Protect, MUnit`Package`$MUnitProtectedSymbols];