
SetAttributes[{VerificationTest, iVerificationTest}, HoldAllComplete]

Options[VerificationTest] = {
	MemoryConstraint -> Inherited, 
	SameTest         -> Inherited, 
 	TestID           -> None, 
 	TimeConstraint   -> Inherited
}

(* Parse arguments for VerificationTest and handle them appropriately *)
VerificationTest[pre___, Evaluate[args___], post___] := With[{a = args}, VerificationTest[pre, a, post]]
VerificationTest[pre___, Sequence[args___], post___] := VerificationTest[pre, args, post]
VerificationTest[args___]:=
	With[
		{parse = System`Private`ArgumentsWithRules[VerificationTest[args], {1,3}, HoldComplete]}, 
		Replace[
			parse,
			{_[a_, b_:True, c_:{}], _[o___]} :> iVerificationTest[a, b, c, o]
		] /; Length[parse] == 2
	]

(* Main implementation of System`VerificationTest *)
iVerificationTest[input_, expected_, msg_, opts___] := 
	With[
		{merged = DeleteCases[Flatten @ {opts, $DefaultOptions}, _[_, Inherited]]},
		TestEvaluate @ <|
			"TestID"           -> OptionValue[VerificationTest, merged, "TestID"],
			"SameTest"         -> OptionValue[VerificationTest, merged, "SameTest"],
			"MemoryConstraint" -> OptionValue[VerificationTest, merged, "MemoryConstraint"],
			"TimeConstraint"   -> OptionValue[VerificationTest, merged, "TimeConstraint"],
			"Input"            -> HoldForm[input],
			"ExpectedOutput"   -> HoldForm[expected],
			"ExpectedMessages" -> HoldForm[msg]
		|>
	]
