(* ::Package:: *)

(* ::Title:: *)
(*WRI*)

(* ::Section:: *)
(*Information*)

`Information`$WRIId = "$Id: WRI.m,v 1.11 2009/11/09 14:43:55 brenton Exp $"

(* ::Section:: *)
(*Public*)

ConditionalTest::usage =
""

DefectiveTest::usage =
""

EndIgnore::usage =
""

EndRequirement::usage =
""

ExactTest::usage =
""

ExactTestCaveat::usage =
""

NTest::usage =
""

NTestCaveat::usage =
""

OrTest::usage =
""

TestCaveat::usage =
""

TestExecute::usage =
""

TestIgnore::usage =
""

TestRequirement::usage =
""

$DefaultTestManager::usage =
""

$FailurePriority::usage =
""

$FailureReportProlog::usage =
""

$MinimumTestAbortTime::usage =
""

$MemoryMessages::usage =
""

$RunDefectiveTests::usage =
""

$SaveTiming::usage =
""

$ShowMemoryInUse::usage =
""

$ShowReport::usage =
""

$TestAbortTime::usage =
""

$TestAbortTimeInitial::usage =
""

$TestAbortTimeMultiplier::usage =
""

$TestMemoryLimitInitial::usage =
""

$TestMemoryLimit::usage =
""

$TestSearchPath::usage =
""

(* ::Section:: *)
(*Package*)

Begin["`Package`"]

End[]

(* ::Section:: *)
(*Private*)

Begin["`WRI`Private`"]

expectedMessagesHeads = _MessageName|_Message
expectedMessagesPattern = expectedMessagesHeads | {expectedMessagesHeads...} | _Alternatives

compatOptionValue[name_, opts_, sym_] :=
	name /. Flatten[opts] /. Options[sym]

Attributes[ConditionalTest] = {HoldAll}

Options[ConditionalTest] = Options[Test]

Attributes[$Hold] = {HoldAll}

Attributes[testtypeheld] = {HoldAll}

(* opts isn't using ___?OptionQ because OptionQ evaluates its arguments and we don't want that *)

ConditionalTest[test_, input_, expectedList__List, opts:(_Rule | _RuleDelayed)...] :=
	Module[{expres, expresbool, boolposn, returnargs, t},
		expres = Map[Hold, Hold[{expectedList}], 3];
		expres = ReleaseHold[ReleaseHold[ReleaseHold[expres]]];
		expresbool = Map[ReleaseHold[#[[1]]] &, expres];
		boolposn = Position[expresbool, True];
		returnargs = Drop[expres[[boolposn[[1, 1]]]], 1];
		returnargs = Map[Apply[$Hold, #] &, returnargs];
		With[{returnargs = returnargs},
			testtypeheld[input, t, opts] /. t -> Apply[Sequence, returnargs] /. $Hold[x_] -> x /. testtypeheld :> test
		]
	]

ConditionalTest[args___] :=
	Test[args]

Attributes[DefectiveTest] = {HoldAllComplete}


AddTestFunction[ExactTest]

Attributes[ExactTest] = {HoldAll}

SetOptions[ExactTest,
	EquivalenceFunction ->
		Function[{actual, expected},
			With[{actual = actual, expected = expected},
				SameQ[Hold[actual], Hold[expected]]
			]
			,
			{HoldAllComplete}
		]
]



CompareNumerical[e2_, e1_, tol_] :=
	Module[{t1, t2, temp},
		If[Precision[e1] === Infinity,
			(*Message[CompareNumerical::exact, e1, e2]*)
			Null
		];
		t1 = RepNums[ReleaseHold[e1]];
		t2 = RepNums[ReleaseHold[e2]];
		If[First[t1] =!= First[t2],
			{False},
			temp = NumberCompare[Last[t1], Last[t2], tol];
			If[temp === True, {True}, {False, {"CompareNumerical", {False, temp}}}]
		]
	]

(* RepNums takes an expression and replaces the numbers in it with
   numbered slots.  For instance:
   2.3 + x^4.2  --> {$Number[1] + x^$Number[2], {2.3, 4.2}}
   We then check that the structure is the same and that the numbers
   are the same within tolerances. *)

RepNums[expr_] :=
	Module[{nums = {}, numcount = 1, t, temp},
		temp = expr /. Function[Display[_,_]] -> Identity;
		(* this avoids problems with DisplayFunction for Graphics & Sound *)
		temp = temp /. Function -> holdFunction;
		(* this avoids problems with pure Functions *)
		t =
		Map[
			If[NumberQ[#] && # =!= Overflow[],
				(* this corresponds to RepNums in the Testing` package, but I inlined it so that nums and numscount don't have leak *)
				If[Or[Precision[#] < Infinity, Precision[#] === MachinePrecision],
					AppendTo[nums, #];
					$Number[numcount++],
					#
				]
				,
				#
			]&
			,
			temp
			,
			{-1}
		];
		(* numbers can appear only at the leaves *)
		{t /. holdFunction -> Function, nums}
	]

(* NumberCompare0[ ] needs to be Listable *)
Attributes[NumberCompare0] = {Listable}

NumberCompare[e1_, e2_, tol_] :=
    AndNumerical[NumberCompare0[e1, e2, tol]]

NumberCompare0[n1_, n2_, tol_] :=
	Module[{t, n1a, n2a},
		If[Accuracy[n1] > Accuracy[n2] && !MachineNumberQ[n1],
			(*Message[CompareNumerical::fuzzy, n1, n2]*)
			Null
		];
		If[Abs[n1] < 10^-$MachinePrecision,
			n1a = n1 + 10.^-$MachinePrecision, n1a=n1
		];
		If[Abs[n2] < 10^-$MachinePrecision,
			n2a = n2 + 10.^-$MachinePrecision, n2a=n2
		];
		If[Or[Precision[n1a] === MachinePrecision, Precision[n1a] <= $MachinePrecision] && Abs[n1a] < .00000001 && Abs[n2a] < .00000001,
			(* had previously included NumberQ[Log[n1]] && NumberQ[Log[n2]] *)
			t = 10^(Abs[Log[10.,n1a] - Log[10.,n2a]]),
			(* note I wrap N[] around Min[] on 5-15-97 *)
			t = Abs[n1a-n2a] * 10^N[Min[Accuracy[n1a],Accuracy[n2a]]],
			(* note I wrap N[] around Min[] on 5-15-97 *)
			t = Abs[n1a-n2a] * 10^N[Min[Accuracy[n1a],Accuracy[n2a]]]
		];
		If[t < tol,
			True,
			t,
			t
		]
	]

AndNumerical[l_] :=
	Module[{numlist = Select[l, NumberQ]},
		If[numlist == {},
			Apply[And, l],
			Apply[Max, numlist]
		]
	]



Attributes[NTest] = {HoldAll}

Options[NTest] = Union[Options[Test], {AccuracyGoal -> None, PrecisionGoal -> None, Tolerance -> None}]

(* setting EquivalenceFunction can't work because options need to be passed to CompareToPAT *)

With[{expectedMessagesPattern = expectedMessagesPattern},
	NTest[input_, expected_, Optional[ulps:(_?NumberQ | None), 10^(3+$MachinePrecision-16)], messages:expectedMessagesPattern:{}, opts___?OptionQ] :=
		Module[{accuracy, precision, tolerance},
			accuracy = compatOptionValue[AccuracyGoal, {opts}, NTest];
			precision = compatOptionValue[PrecisionGoal, {opts}, NTest];
			tolerance = compatOptionValue[Tolerance, {opts}, NTest];
			Which[
				{accuracy, precision, tolerance} =!= {None, None, None},
				With[{accuracy = accuracy, precision = precision, tolerance = tolerance, opts2 = FilterRules[{opts}, Options[Test]]},
					Test[
						Internal`CompareToPAT[
							input,
							expected,
							AccuracyGoal -> accuracy,
							PrecisionGoal -> precision,
							Tolerance -> tolerance
						],
						True,
						messages,
						opts2
					]
				]
				,
				ulps =!= None,
				With[{opts2 = FilterRules[{Join[Flatten[{opts}], Options[NTest]]}, Options[Test]]},
					Test[
						CompareNumerical[Hold[input], Hold[expected], ulps],
						{True},
						messages,
						opts2
					]
				]
				,
				(*
				{accuracy, precision, tolerance} === {None, None, None} && ulps === None,
				treat this as an error, per amoylan
				*)
				True,
				testError["Invalid values for AccuracyGoal, PrecisionGoal, and Tolerance options and ulps parameter: " <> ToString[{accuracy, precision, tolerance, ulps}], opts]
			]
		]
]

NTest[args___] :=
	testError["Incorrect arguments: " <> ToString[Unevaluated[{args}]], args]



AddTestFunction[OrTest]

SetOptions[OrTest, EquivalenceFunction -> MatchQ]

With[{expectedMessagesPattern = expectedMessagesPattern},
	OrTest[input_, expected_:True, messages:expectedMessagesPattern:{}, opts___?OptionQ] :=
		Test[input, Alternatives @@ expected, messages, Join[Flatten[{opts}], Options[OrTest]]]
]

OrTest[args___] :=
	Test[args]



AddTestFunction[TestCaveat]

With[{expectedMessagesPattern = expectedMessagesPattern},
	TestCaveat[input_, expected_:True, messages:expectedMessagesPattern:{}, failmsg_String, opts___?OptionQ] :=
		Test[input, expected, messages, Join[{TestFailureMessage -> failmsg}, Flatten[{opts}], Options[TestCaveat]]]
]


TestExecute = Identity


TestRequirement[cond_] :=
	BeginTestSection["", cond]

EndRequirement = EndTestSection

End[]
