(* ::Package:: *)

(* ::Title:: *)
(*MUnit*)

BeginPackage["MUnit`"]

(* ::Section:: *)
(*Information*)

`Information`$VersionNumber = 1.2

`Information`$ReleaseNumber = 0

`Information`$Version = "MUnit Version 1.2.0"

`Information`$MUnitRevision = "$Revision: 1.5 $"

(* ::Section:: *)
(*Package*)

Begin["`Package`"]

$MUnitDirectory

End[]

AppendTo[$ContextPath, "MUnit`Package`"]

(* ::Section:: *)
(*Private*)

Begin["`MUnit`"]

$MUnitDirectory =
	DirectoryName[System`Private`FindFile[$Input]]

$implementationFiles =
	{
		ToFileName[{$MUnitDirectory, "Kernel"}, "Buttons.m"],
		ToFileName[{$MUnitDirectory, "Kernel"}, "Loggers.m"],
		ToFileName[{$MUnitDirectory, "Kernel"}, "Notebooks.m"],
		ToFileName[{$MUnitDirectory, "Kernel"}, "Palette.m"],
		ToFileName[{$MUnitDirectory, "Kernel"}, "Test.m"],
		ToFileName[{$MUnitDirectory, "Kernel"}, "TestRun.m"],
		ToFileName[{$MUnitDirectory, "Kernel"}, "Typesetting.m"],
		ToFileName[{$MUnitDirectory, "Kernel"}, "WRI.m"]
	}

processDecls[file_] :=
	Module[{strm, e, moreLines = True},
		strm = OpenRead[file];
		If[Head[strm] =!= InputStream,
			Return[$Failed]
		];
		While[moreLines,
			e = Read[strm, Hold[Expression]];
			ReleaseHold[e];
			If[e === $Failed || MatchQ[e, Hold[_End]],
				moreLines = False
			]
		];
		Close[file]
	]

End[]

Scan[`MUnit`processDecls, `MUnit`$implementationFiles]

Scan[Get, `MUnit`$implementationFiles]

EndPackage[]
