FormatSpec[
    Name -> "Paclet Submission Format",
    RestrictTo[
        (* TODO: fill in the real names  *)
      FileName -> "SubmissionInfo.m"
      (*Head -> "PacletSubmission"*)
    ],
	RuleErrorMessages[
		SearchTerms -> "Illegal setting for search terms",
		Price -> "Illegal setting for price"
    ],
    RootRule -> "Root",
    ExpressionSpec[
        Root -> 
            ExprLiteral[ "SubmissionInfo",
                AdditionalRequirementsRule[]|Empty[],
                DescriptionRule[], 
                 ExprLiteral["Rule",
            		StringLiteral["Encode"], Encode[]] | Empty[], 
                KeyFeaturesRule[]|Empty[], 
               	NewInVersionRule[]|Empty[], 
                PriceRule[](*|Empty[]*),
                SearchTermsRule[]|Empty[],
                Orderless -> True
            ],
            
        DescriptionRule -> ExprLiteral["Rule",
            StringLiteral["Description"],
            Description[]
        ],
        
        Description -> Regexp[".*"],
        
        Encode -> StringLiteral["True"] | StringLiteral["False"],
        
        AdditionalRequirementsRule -> ExprLiteral["Rule",
            StringLiteral["AdditionalRequirements"],
           AdditionalRequirements[]
        ],  
        AdditionalRequirements -> Regexp[".*"],
        
       KeyFeaturesRule -> ExprLiteral["Rule",
            StringLiteral["KeyFeatures"],
            KeyFeatures[]
        ],  
       KeyFeatures -> Regexp[".*"],
        
        (*
         Not sure- does this mean a list of features added since the last submission?
         Wouldn't this better be a List of Strings?
        *)
        NewInVersionRule -> ExprLiteral["Rule",
            StringLiteral["NewInVersion"],
            NewInVersion[]
        ],  
        NewInVersion -> Regexp[".*"],
        
        PriceRule -> ExprLiteral["Rule",
            StringLiteral["Price"],
            Price[]
        ],  
        Price -> StringLiteral["Free"] | Regexp["[0-9]+"] ,
        
        
        SearchTermsRule -> ExprLiteral["Rule",
            StringLiteral["SearchTerms"],
             SearchTerms1[] 
        ],
        SearchTerms1 -> ExprLiteral["List",
                Regexp["[a-zA-Z][a-zA-Z0-9]*"]...
            ], 
       
       SearchTerms ->  Regexp["\\s*([a-zA-Z][a-zA-Z0-9]*)(\\s*\\,\\s*[a-zA-Z][a-zA-Z0-9]*)*\\s*"]|Regexp["\\s*"]
        
    ]
]