(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     46256,       1196]
NotebookOptionsPosition[     25509,        727]
NotebookOutlinePosition[     38970,       1054]
CellTagsIndexPosition[     38927,       1051]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["DESCRIPTION PLACEHOLDER",
 CellContext->"Cell$$25520`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->134112371,ExpressionUUID->"9ecb39c2-9180-41a6-87d0-ff06a37b0966"],

Cell["\<\
ALL INPUT AND SECTION CELLS ARE REMOVED BEFORE CONTENT IS INSERTED\
\>", "Text",
 FontWeight->"Bold",
 CellID->90280312,ExpressionUUID->"435bc244-df7c-449d-9298-3cc581e7dbb4"],

Cell[CellGroupData[{

Cell["Docked Cell Generation", "Section",
 ShowGroupOpener->True,
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellID->9074762,ExpressionUUID->"863fe2cf-f406-4027-b55d-b646164f765a"],

Cell[BoxData[
 RowBox[{"SetOptions", "[", 
  RowBox[{
   RowBox[{"InputNotebook", "[", "]"}], ",", 
   RowBox[{
   "StyleDefinitions", "\[Rule]", "\"\<Wolfram\\\\Reference.nb\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.704034031534266*^9, 3.704034044245511*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"e63ea951-aaa8-4d9d-863b-3e5503dabfeb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{
    RowBox[{"BoxData", "[", 
     RowBox[{"GridBox", "[", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Cell", "[", 
          RowBox[{"\"\<WORKFLOW\>\"", ",", "\"\<PacletNameCell\>\"", ",", 
           RowBox[{"TextAlignment", "\[Rule]", "Center"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"0.2157", ",", "0.6588", ",", "0.6745"}], "]"}]}]}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Cell", "[", 
          RowBox[{
           RowBox[{"BoxData", "[", 
            RowBox[{"GridBox", "[", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"Cell", "[", "\"\<MENUPLACEHOLDER\>\"", "]"}], "}"}], 
              "}"}], "]"}], "]"}], ",", "\"\<AnchorBar\>\""}], "]"}]}], "}"}],
        "}"}], "]"}], "]"}], ",", "\"\<AnchorBarGrid\>\""}], "]"}], "//", 
  "CellPrint"}]], "Input",
 CellLabel->"In[4]:=",ExpressionUUID->"1339f070-0bdf-400f-b92f-07a3eeb85715"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{
    RowBox[{"TextData", "[", "\"\<TITLEPLACEHOLDER\>\"", "]"}], ",", 
    "\"\<WorkflowTitle\>\""}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->267713489,ExpressionUUID->"e9bdd0d7-8181-4a12-8e85-8f831c49350a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{"BoxData", "[", 
    RowBox[{"GridBox", "[", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"Cell", "[", "\"\<TABSPLACEHOLDER\>\"", "]"}], "}"}], "}"}], 
     "]"}], "]"}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->133403045,ExpressionUUID->"6f7d9063-1e5d-4041-a955-fbc37a30fa0d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dc", "=", 
   RowBox[{"CurrentValue", "[", 
    RowBox[{
     RowBox[{"InputNotebook", "[", "]"}], ",", "DockedCells"}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->17199079,ExpressionUUID->"42f71ceb-a1be-44c7-ba30-e262fa0eda03"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CurrentValue", "[", 
    RowBox[{
     RowBox[{"InputNotebook", "[", "]"}], ",", "DockedCells"}], "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{"dc", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{
         RowBox[{"BoxData", "[", 
          RowBox[{"GridBox", "[", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"GridBox", "[", 
               RowBox[{
                RowBox[{"{", "\n", "      ", 
                 RowBox[{"{", "\n", "       ", 
                  RowBox[{
                   RowBox[{"ItemBox", "[", 
                    RowBox[{
                    RowBox[{"Cell", "[", 
                    RowBox[{
                    RowBox[{"BoxData", "[", "\n", "         ", 
                    RowBox[{"RowBox", "[", 
                    RowBox[{"{", "\n", "          ", 
                    RowBox[{
                    RowBox[{"InterpretationBox", "[", "\n", "           ", 
                    RowBox[{
                    RowBox[{"StyleBox", "[", "\n", "            ", 
                    RowBox[{
                    RowBox[{"GraphicsBox", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", "\n", "             ", 
                    RowBox[{"BaselinePosition", "->", "Baseline"}], ",", "\n",
                     "             ", 
                    RowBox[{"ImageSize", "->", 
                    RowBox[{"{", 
                    RowBox[{"8", ",", " ", "0"}], "}"}]}]}], "]"}], ",", "\n",
                     "            ", 
                    RowBox[{"CacheGraphics", "->", "False"}]}], "]"}], ",", 
                    "\n", "           ", 
                    RowBox[{"Spacer", "[", "8", "]"}], ",", "\n", 
                    "           ", 
                    RowBox[{"Selectable", "->", "False"}]}], "]"}], ",", " ", 
                    
                    RowBox[{"Cell", "[", 
                    RowBox[{"\"\<WORKFLOW\>\"", ",", " ", 
                    "\"\<PacletNameCell\>\"", ",", "\n", "           ", 
                    RowBox[{"TextAlignment", "->", "Center"}]}], "]"}], ",", 
                    " ", "\n", "          ", 
                    RowBox[{"InterpretationBox", "[", "\n", "           ", 
                    RowBox[{
                    RowBox[{"StyleBox", "[", "\n", "            ", 
                    RowBox[{
                    RowBox[{"GraphicsBox", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", "\n", "             ", 
                    RowBox[{"BaselinePosition", "->", "Baseline"}], ",", "\n",
                     "             ", 
                    RowBox[{"ImageSize", "->", 
                    RowBox[{"{", 
                    RowBox[{"8", ",", " ", "0"}], "}"}]}]}], "]"}], ",", "\n",
                     "            ", 
                    RowBox[{"CacheGraphics", "->", "False"}]}], "]"}], ",", 
                    "\n", "           ", 
                    RowBox[{"Spacer", "[", "8", "]"}], ",", "\n", 
                    "           ", 
                    RowBox[{"Selectable", "->", "False"}]}], "]"}]}], "}"}], 
                    "]"}], "]"}], ",", "\n", "         ", 
                    RowBox[{"TextAlignment", "->", "Center"}]}], "]"}], ",", 
                    "\n", "        ", 
                    RowBox[{"Background", "->", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{
                    "0.2157", ",", " ", "0.6588", ",", " ", "0.6745"}], 
                    "]"}]}], ",", "\n", "        ", 
                    RowBox[{"ItemSize", "->", "Full"}]}], "]"}], ",", " ", 
                   "\"\<\>\""}], "}"}], "\n", "     ", "}"}], ",", "\n", 
                "     ", 
                RowBox[{"GridBoxAlignment", "->", 
                 RowBox[{"{", 
                  RowBox[{"\"\<Rows\>\"", " ", "->", " ", 
                   RowBox[{"{", 
                    RowBox[{"{", "Center", "}"}], "}"}]}], "}"}]}], ",", "\n",
                 "     ", 
                RowBox[{"GridBoxItemSize", "->", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"\"\<Columns\>\"", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{"Full", ",", " ", "\n", "         ", 
                    RowBox[{"Scaled", "[", "0.02", "]"}]}], "}"}]}], ",", " ", 
                   RowBox[{"\"\<Rows\>\"", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{"{", "2.5", "}"}], "}"}]}]}], "}"}]}]}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"Cell", "[", 
               RowBox[{
                RowBox[{"BoxData", "[", 
                 RowBox[{"GridBox", "[", 
                  RowBox[{"{", 
                   RowBox[{"{", 
                    RowBox[{"Cell", "[", "\"\<MENUPLACEHOLDER\>\"", "]"}], 
                    "}"}], "}"}], "]"}], "]"}], ",", "\"\<AnchorBar\>\""}], 
               "]"}]}], "}"}], "}"}], "]"}], "]"}], ",", 
         "\"\<AnchorBarGrid\>\"", ",", "\"\<WorkflowDockedCell\>\""}], "]"}], 
       ",", 
       RowBox[{"Cell", "[", 
        RowBox[{
         RowBox[{"TextData", "[", "\"\<TITLEPLACEHOLDER\>\"", "]"}], ",", 
         "\"\<WorkflowTitle\>\"", ",", "\"\<WorkflowDockedCell\>\""}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"Cell", "[", 
        RowBox[{
         RowBox[{"BoxData", "[", 
          RowBox[{"GridBox", "[", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"Cell", "[", "\"\<TABSPLACEHOLDER\>\"", "]"}], "}"}], 
            "}"}], "]"}], "]"}], ",", "\"\<WorkflowTabGrid\>\"", ",", 
         "\"\<WorkflowDockedCell\>\""}], "]"}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[13]:=",
 CellID->606224123,ExpressionUUID->"4d382d47-c214-494f-a3c8-870bf4e3124c"]
}, Closed]],

Cell[CellGroupData[{

Cell["Content Generation", "Section",
 ShowGroupOpener->True,
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellID->600980217,ExpressionUUID->"dec05b2b-7055-4a4b-a71c-59d6df54be81"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dynamic", "[", 
  RowBox[{"CurrentValue", "[", 
   RowBox[{"{", 
    RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], "}"}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->208333714,ExpressionUUID->"926a4819-831c-4e45-b5d7-f71a424b9838"],

Cell[BoxData[
 DynamicBox[ToBoxes[
   CurrentValue[{TaggingRules, "SelectedPlatform"}], StandardForm],
  ImageSizeCache->{16., {0., 10.}}]], "Output",
 CellContext->"Cell$$25520`",
 CellLabel->"Out[7]=",
 CellID->413967391,ExpressionUUID->"00420e10-d258-474e-8888-54e51234044b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<DESKTOP\>\"", ",", "\"\<WorkflowPlatform\>\"", ",", 
         RowBox[{"ShowCellBracket", "\[Rule]", "True"}], ",", 
         RowBox[{"CellOpen", "\[Rule]", 
          RowBox[{"Dynamic", "[", 
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{"CurrentValue", "[", 
              RowBox[{
               RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], 
                "}"}]}], "]"}], ",", 
             RowBox[{"All", "|", "\"\<Desktop\>\""}]}], "]"}], "]"}]}]}], 
        "]"}], ",", 
       RowBox[{"Cell", "[", "\"\<DESKTOP PLACEHOLDER\>\"", "]"}]}], "}"}], 
     ",", 
     RowBox[{"Dynamic", "[", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"CurrentValue", "[", 
         RowBox[{
          RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], "}"}], 
          ",", "\"\<Desktop\>\""}], "]"}], ",", 
        RowBox[{"\"\<Desktop\>\"", "|", "\"\<All\>\""}]}], "]"}], "]"}]}], 
    "]"}], "]"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->60780229,ExpressionUUID->"75649f2d-6a34-4c61-ba7e-077fdc6fc4ca"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<CLOUD\>\"", ",", "\"\<WorkflowPlatform\>\"", ",", 
         RowBox[{"ShowCellBracket", "\[Rule]", "True"}], ",", 
         RowBox[{"CellOpen", "\[Rule]", 
          RowBox[{"Dynamic", "[", 
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{"CurrentValue", "[", 
              RowBox[{
               RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], 
                "}"}]}], "]"}], ",", 
             RowBox[{"All", "|", "\"\<Cloud\>\""}]}], "]"}], "]"}]}]}], "]"}],
        ",", 
       RowBox[{"Cell", "[", "\"\<CLOUD PLACEHOLDER\>\"", "]"}]}], "}"}], ",", 
     
     RowBox[{"Dynamic", "[", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"CurrentValue", "[", 
         RowBox[{
          RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], "}"}], 
          ",", "\"\<Desktop\>\""}], "]"}], ",", 
        RowBox[{"\"\<Cloud\>\"", "|", "\"\<All\>\""}]}], "]"}], "]"}]}], 
    "]"}], "]"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->7106460,ExpressionUUID->"5ee71bd6-5b58-4b08-b96e-5ba4c6b7e0a4"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<MOBILE\>\"", ",", "\"\<WorkflowPlatform\>\"", ",", 
         RowBox[{"ShowCellBracket", "\[Rule]", "True"}], ",", 
         RowBox[{"CellOpen", "\[Rule]", 
          RowBox[{"Dynamic", "[", 
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{"CurrentValue", "[", 
              RowBox[{
               RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], 
                "}"}]}], "]"}], ",", 
             RowBox[{"All", "|", "\"\<Mobile\>\""}]}], "]"}], "]"}]}]}], 
        "]"}], ",", 
       RowBox[{"Cell", "[", "\"\<MOBILE PLACEHOLDER\>\"", "]"}]}], "}"}], ",", 
     RowBox[{"Dynamic", "[", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"CurrentValue", "[", 
         RowBox[{
          RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], "}"}], 
          ",", "\"\<Desktop\>\""}], "]"}], ",", 
        RowBox[{"\"\<Mobile\>\"", "|", "\"\<All\>\""}]}], "]"}], "]"}]}], 
    "]"}], "]"}], "]"}]], "Input",
 CellID->740894912,ExpressionUUID->"5f117db9-2b1f-452a-afd0-567900f5a3df"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"Dynamic", "[", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"CurrentValue", "[", 
      RowBox[{
       RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], "}"}]}], 
      "]"}], ",", 
     RowBox[{"\"\<All\>\"", "|", "\"\<Desktop\>\""}]}], "]"}], 
   "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->222152546,ExpressionUUID->"bf13d498-6b41-43f3-b3c4-4d610f52d0c9"],

Cell[BoxData[
 DynamicBox[ToBoxes[
   MatchQ[
    CurrentValue[
     EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}], 
    Alternatives["All", "Desktop"]], StandardForm],
  ImageSizeCache->{28., {0., 9.}}]], "Output",
 CellContext->"Cell$$7799`",
 CellLabel->"Out[3]=",
 CellID->474749300,ExpressionUUID->"6e3a8170-684c-49a7-9685-1c66c9c3f0d7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"CurrentValue", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], "}"}]}], 
   "]"}], "=", "\"\<All\>\""}]], "Input",
 CellLabel->"In[13]:=",
 CellID->95570290,ExpressionUUID->"83cf0887-5c62-47e3-a1bb-eb53490b37e3"]
}, Open  ]],

Cell[CellGroupData[{

Cell["DESKTOP", "WorkflowPlatform",
 ShowCellBracket->True,
 CellOpen->Dynamic[
   MatchQ[
    CurrentValue[
     EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}], 
    Alternatives["All", "Desktop"]]],
 CellID->515390594,ExpressionUUID->"0cc218d0-aef2-459f-ab6f-60ae25278e44"],

Cell["DESKTOP PLACEHOLDER",
 CellContext->"Cell$$25520`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->77743858,ExpressionUUID->"0ba5de83-e2bc-41c1-af99-b0986a3a7ea3"]
}, Dynamic[MatchQ[
 CurrentValue[
  EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}, "Desktop"], 
  Alternatives["Desktop", "All"]]]]],

Cell[CellGroupData[{

Cell["CLOUD", "WorkflowPlatform",
 ShowCellBracket->True,
 CellOpen->Dynamic[
   MatchQ[
    CurrentValue[
     EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}], 
    Alternatives["All", "Cloud"]]],
 CellID->135602052,ExpressionUUID->"24202825-bdb2-4b21-beee-5eec6494f616"],

Cell["CLOUD PLACEHOLDER",
 CellContext->"Cell$$25780`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->58879777,ExpressionUUID->"bd07d57d-333a-4686-bf45-72a30cd725fd"]
}, Dynamic[MatchQ[
 CurrentValue[
  EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}, "Desktop"], 
  Alternatives["Cloud", "All"]]]]],

Cell[CellGroupData[{

Cell["MOBILE", "WorkflowPlatform",
 ShowCellBracket->True,
 CellOpen->Dynamic[
   MatchQ[
    CurrentValue[
     EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}], 
    Alternatives["All", "Mobile"]]],
 CellID->683030426,ExpressionUUID->"06ebb6bc-848c-44fe-97f8-5be4de071841"],

Cell["MOBILE PLACEHOLDER",
 CellContext->"Cell$$25797`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->83489441,ExpressionUUID->"ac655b93-7e4c-45f8-b207-f32e6098c229"],

Cell[CellGroupData[{

Cell["Footer Generation", "Section",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellID->41735091,ExpressionUUID->"53b47bf8-eccf-4eb6-8387-0888883ef195"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterTopDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->671902962,ExpressionUUID->"8463fcb7-b7ba-4906-a92d-361514cc8155"]
}, Open  ]]
}, Dynamic[MatchQ[
 CurrentValue[
  EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}, "Desktop"], 
  Alternatives["Mobile", "All"]]]]],

Cell[CellGroupData[{

Cell["", "WorkflowFooterTopDelimiter",
 CellContext->"Cell$$6046`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->175919488,ExpressionUUID->"de466a8f-2182-421d-b8ba-5ffb484d64ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<See Also\>\"", ",", "\"\<FooterHeader\>\"", ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"CurrentValue", "[", 
           RowBox[{"{", 
            RowBox[{
            "StyleHints", ",", "\"\<WorkflowFooterBackgroundColor\>\""}], 
            "}"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Cell", "[", "\"\<SEEALSO PLACEHOLDER\>\"", "]"}]}], "}"}], 
     ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->13208771,ExpressionUUID->"336feb5d-6e48-4518-8472-de4fd37bdc03"]
}, Open  ]],

Cell[CellGroupData[{

Cell["See Also", "FooterHeader",
 CellID->351896171,ExpressionUUID->"cbc06bce-c23e-4c08-aba9-8be04b189bef"],

Cell["SEEALSO PLACEHOLDER",
 CellContext->"Cell$$26587`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->35458802,ExpressionUUID->"6a229c40-6f1f-4aff-98ac-25fd838f790a"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->51221915,ExpressionUUID->"6c872a04-aa3d-49cc-bb03-7348d5292997"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$6048`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->435938663,ExpressionUUID->"d773a0e6-9522-430f-801b-fe7a0801c2c8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<Related Functions\>\"", ",", "\"\<FooterHeader\>\"", ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"CurrentValue", "[", 
           RowBox[{"{", 
            RowBox[{
            "StyleHints", ",", "\"\<WorkflowFooterBackgroundColor\>\""}], 
            "}"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Cell", "[", "\"\<RELATEDFUNCTIONS PLACEHOLDER\>\"", "]"}]}], 
      "}"}], ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->12660416,ExpressionUUID->"f2b6b70c-4977-4b97-b8fc-e223cbe9cd28"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Functions", "FooterHeader",
 CellID->77064428,ExpressionUUID->"18880abf-5c3b-4fa3-89ac-3c22a64160ae"],

Cell["RELATEDFUNCTIONS PLACEHOLDER",
 CellContext->"Cell$$26587`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->389045652,ExpressionUUID->"22007a06-432d-4071-8550-d69294b49408"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->125738797,ExpressionUUID->"3c9d6a6b-46eb-4513-83e6-5efa2ae39ec9"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$6048`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->869216197,ExpressionUUID->"38ec371b-d489-42b9-9178-a7c2fd2cea66"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<Related Guides\>\"", ",", "\"\<FooterHeader\>\""}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Cell", "[", "\"\<RELATEDGUIDES PLACEHOLDER\>\"", "]"}]}], 
      "}"}], ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->251796805,ExpressionUUID->"1448f594-a22f-4c57-8cf7-760bd1cf085a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Guides", "FooterHeader",
 CellID->291956413,ExpressionUUID->"72d030a6-c84d-4229-81bc-85a938dc38e8"],

Cell["RELATEDGUIDES PLACEHOLDER",
 CellContext->"Cell$$26587`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->326400149,ExpressionUUID->"1e7e9a55-9182-4bc6-8efe-a557642278e3"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->319555874,ExpressionUUID->"7ecda1fc-6d3d-4005-b411-6fd0f64b3010"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$6048`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->124395404,ExpressionUUID->"102913b7-e550-4707-9794-07b13c4b9f06"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<Related Tech Notes\>\"", ",", "\"\<FooterHeader\>\""}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Cell", "[", "\"\<RELATEDTECHNOTES PLACEHOLDER\>\"", "]"}]}], 
      "}"}], ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->500763758,ExpressionUUID->"f0526ddf-d8db-4596-869b-47312c6f7b27"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Tech Notes", "FooterHeader",
 CellID->624027471,ExpressionUUID->"2211f83a-b3dc-4251-9b8d-a6558d967267"],

Cell["RELATEDTECHNOTES PLACEHOLDER",
 CellContext->"Cell$$6054`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->172786405,ExpressionUUID->"21b1dc2b-d822-443a-9a9e-327b52a2b4fb"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->647333165,ExpressionUUID->"0d5e3e97-eea2-4a0a-9f81-6017866e706b"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$48730`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->789161539,ExpressionUUID->"15f1c69b-209b-46bf-ae5b-02f79e82596b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<Related Links\>\"", ",", " ", "\"\<FooterHeader\>\""}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Cell", "[", "\"\<RELATEDLINKS PLACEHOLDER\>\"", "]"}]}], 
      "}"}], ",", " ", "Open"}], "]"}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->482658414,ExpressionUUID->"14078a09-ab3a-4850-878e-3e53a5a32e9b"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Links", "FooterHeader",
 CellContext->"Cell$$48730`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->762311939,ExpressionUUID->"8cffa393-0086-4e85-9aa9-d6fb587ac888"],

Cell["RELATEDLINKS PLACEHOLDER",
 CellContext->"Cell$$48730`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->136656972,ExpressionUUID->"7d1c3381-c2d6-46f2-be26-dca9513dd413"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterBottomDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->137855366,ExpressionUUID->"52a230a3-d296-4063-b1ab-11955f9da1b5"]
}, Open  ]],

Cell["", "WorkflowFooterBottomDelimiter",
 CellContext->"Cell$$2532`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->61232784,ExpressionUUID->"a733295c-1808-4eaa-934c-bbbadc5130ff"]
},
WindowSize->{808, 911},
WindowMargins->{{322, Automatic}, {Automatic, 26}},
DockedCells->{
  Cell[
   BoxData[
    PanelBox[
     StyleBox[
      TemplateBox[{
        StyleBox[
         GraphicsBox[{}, ImageSize -> {9, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        TemplateBox[{
          TooltipBox[
           DynamicModuleBox[{$CellContext`destination$$ = 0}, 
            DynamicBox[
             FEPrivate`If[FEPrivate`HistoryList["Back"] === {}, 
              ButtonBox[
               DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "DisabledBackIcon.png"]]], Enabled -> False, Appearance -> 
               None, FrameMargins -> 0], 
              ButtonBox[
               PaneSelectorBox[{True -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "BackIconHot.png"]]], False -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "BackIcon.png"]]]}, 
                Dynamic[
                 CurrentValue["MouseOver"]]], ButtonFunction :> 
               FrontEndToken[
                 FrontEnd`ButtonNotebook[], "HyperlinkGoBack"], Evaluator -> 
               None, Appearance -> None, FrameMargins -> 0]]], 
            DynamicModuleValues :> {}], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipBack"]]], 
          StyleBox[
           GraphicsBox[{}, ImageSize -> {2, 0}, BaselinePosition -> Baseline],
            "CacheGraphics" -> False], 
          TooltipBox[
           DynamicModuleBox[{$CellContext`destination$$ = 0}, 
            DynamicBox[
             FEPrivate`If[FEPrivate`HistoryList["Forward"] === {}, 
              ButtonBox[
               DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "DisabledForwardIcon.png"]]], Enabled -> False, Appearance -> 
               None, FrameMargins -> 0], 
              ButtonBox[
               PaneSelectorBox[{True -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "ForwardIconHot.png"]]], False -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "ForwardIcon.png"]]]}, 
                Dynamic[
                 CurrentValue["MouseOver"]]], ButtonFunction :> 
               FrontEndToken[
                 FrontEnd`ButtonNotebook[], "HyperlinkGoForward"], Evaluator -> 
               None, Appearance -> None, FrameMargins -> 0]]], 
            DynamicModuleValues :> {}], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipForward"]]], 
          TooltipBox[
           DynamicBox[
            ToBoxes[
             FEPrivate`GenerateHelpViewerActionMenu[], StandardForm]], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipHistory"]]], 
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {13, 0}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          TooltipBox[
           ButtonBox[
            PaneSelectorBox[{True -> DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "HomeIconHot.png"]]], False -> DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "HomeIcon.png"]]]}, 
             Dynamic[
              CurrentValue["MouseOver"]]], ButtonFunction :> 
            Documentation`HelpLookup[
              CurrentValue[HomePage], 
              FrontEnd`ButtonNotebook[], 
              CurrentValue[Language]], Appearance -> None, Evaluator -> 
            Automatic, Method -> "Preemptive"], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipHome"]]]}, 
         "RowDefault"], 
        StyleBox[
         GraphicsBox[{}, ImageSize -> {39, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        FrameBox[
         StyleBox[
          DynamicBox[
           FEPrivate`FrontEndResource[
           "FEExpressions", "HelpViewerSearchField"]], 
          InputFieldBoxOptions -> {
           ImageSize -> Dynamic[AbsoluteCurrentValue[{WindowSize, 1}] - 220], 
            FrameMargins -> 
            FEPrivate`Switch[
             FEPrivate`$OperatingSystem, "MacOSX", {{3, 3}, {0, -1}}, 
              "Windows", {{0, 2}, {0, 2}}, 
              Blank[], {{2, 2}, {0, 0}}]}], FrameStyle -> None, 
         FrameMargins -> {{0, 0}, {4, 0}}], 
        StyleBox[
         GraphicsBox[{}, ImageSize -> {12, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        TooltipBox[
         ButtonBox[
          PaneSelectorBox[{True -> DynamicBox[
              FEPrivate`ImportImage[
               
               FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                "RevertIconHot.png"]]], False -> DynamicBox[
              FEPrivate`ImportImage[
               
               FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                "RevertIcon.png"]]]}, 
           Dynamic[
            CurrentValue["MouseOver"]]], ButtonFunction :> FrontEndToken[
            FrontEnd`ButtonNotebook[], "Revert", False], Evaluator -> None, 
          Appearance -> None, Method -> "Preemptive"], 
         DynamicBox[
          FEPrivate`FrontEndResource["HelpToolbarText", "TooltipRefresh"]]]}, 
       "RowDefault"], CacheGraphics -> False, 
      ButtonBoxOptions -> {BaselinePosition -> (Baseline -> Baseline)}], 
     Alignment -> {Left, Center}, Appearance -> Image[CompressedData["
1:eJztyDkKAkEUhOFGE0OvIHgIU0PTEQ8ww7SDSQs9gnhXl3HBfbmC7Q0qeWDw
f1CPqtcr5tm05ZyrO+lk+XIYY74ad9OYhHpWBV+OwsJXPg6Kdnr2U8qUX/8A
AAAA+HtvyF6AgSdg4AHZHbIbYOAKGLhAdobsBBg4QnaAbA9ZAxjYAQa2gIEN
ZGvIvp8pRMU=
       "], "Byte", ColorSpace -> "RGB", Interleaving -> True], 
     ImageSize -> {
       Scaled[1], Full}]], "DockedCell", CellFrame -> 0, 
   CellMargins -> {{0, -10}, {-2, -1}}, CellFrameMargins -> {{0, 0}, {0, 0}}, 
   ShowCodeAssist -> False, Background -> None], 
  Cell[
   BoxData[
    DynamicBox[
     FEPrivate`If[FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "SearchTextTranslated"},
         ""] === "", "", 
      StyleBox[
       RowBox[{
         ButtonBox[
          DynamicBox[
           DynamicBox[
            FEPrivate`ImportImage[
             
             FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
              "SearchIcon.png"]]]], ButtonData :> FEPrivate`StringJoin[
            FrontEnd`CurrentValue[
             FrontEnd`EvaluationNotebook[], {
             TaggingRules, "SearchTextTranslated"}, ""], " start:1"], 
          BaseStyle -> {
           "Link", FontWeight -> "Bold", 
            FontVariations -> {"Underline" -> True}}, ButtonNote -> ""], 
         "   ", 
         DynamicBox[
          FEPrivate`FrontEndResource["HelpToolbarText", "SearchString1"]], 
         "\[InvisibleSpace]", 
         ButtonBox[
          DynamicBox[
           FrontEnd`CurrentValue[
            FrontEnd`EvaluationNotebook[], {
            TaggingRules, "SearchTextTranslated"}, ""]], ButtonData :> 
          FEPrivate`StringJoin[
            FrontEnd`CurrentValue[
             FrontEnd`EvaluationNotebook[], {
             TaggingRules, "SearchTextTranslated"}, ""], " start:1"], 
          BaseStyle -> {
           "Link", FontWeight -> "Bold", 
            FontVariations -> {"Underline" -> True}}, ButtonNote -> ""], 
         "\[InvisibleSpace]", 
         DynamicBox[
          FEPrivate`FrontEndResource["HelpToolbarText", "SearchString2"]]}], 
       FontSize -> 11]], ImageSizeCache -> {4., {0., 0.}}]], "DockedCell", 
   "ControlStyle", CellFrame -> Dynamic[
     FEPrivate`If[
      FEPrivate`UnsameQ[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], 
       ""], {{0, 0}, {3, 0}}, {{0, 0}, {0, 0}}]], 
   CellMargins -> {{0, -10}, {0, -1}}, CellOpen -> 
   Dynamic[FrontEnd`CurrentValue[
       FrontEnd`EvaluationNotebook[], {TaggingRules, "SearchTextTranslated"}, 
       ""] =!= ""], CellFrameMargins -> {{146, 5}, {3, 0}}, CellFrameColor -> 
   Dynamic[
     FEPrivate`If[
      FEPrivate`SameQ[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], ""], 
      CurrentValue["ToolbarBackground"], 
      FEPrivate`Switch[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "ColorType"}], 
       "SymbolColor", 
       RGBColor[0.481193, 0.528023, 0.813489], "GuideColor", 
       RGBColor[1, 0.6, 0], "TutorialColor", 
       RGBColor[0.641154, 0.223011, 0.0623026], "RootColor", 
       RGBColor[1, 0, 0], 
       Blank[], 
       GrayLevel[0.8]]]], ShowCodeAssist -> False, LineIndent -> 0, 
   LinebreakAdjustments -> {1, 10, 0, 100, 0}, Background -> 
   GrayLevel[0.8627450980392157]], 
  Cell[
   BoxData[
    DynamicBox[
     FrontEnd`CurrentValue[
      FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], 
     ImageSizeCache -> {4., {0., 0.}}]], "DockedLinkTrail", CellOpen -> 
   Dynamic[FrontEnd`CurrentValue[
       FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""] =!= 
     ""], CellFrameColor -> Dynamic[
     FEPrivate`If[
      FEPrivate`UnsameQ[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], ""], 
      GrayLevel[0.8], 
      FEPrivate`Switch[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "ColorType"}], 
       "SymbolColor", 
       RGBColor[0.481193, 0.528023, 0.813489], "GuideColor", 
       RGBColor[1, 0.6, 0], "TutorialColor", 
       RGBColor[0.641154, 0.223011, 0.0623026], "RootColor", 
       RGBColor[1, 0, 0], 
       Blank[], 
       GrayLevel[0.8]]]], ShowCodeAssist -> False], 
  Cell[
   BoxData[
    GridBox[{{
       GridBox[{{
          ItemBox[
           Cell[
            BoxData[
             RowBox[{
               InterpretationBox[
                StyleBox[
                 
                 GraphicsBox[{}, BaselinePosition -> Baseline, 
                  ImageSize -> {8, 0}], CacheGraphics -> False], 
                Spacer[8], Selectable -> False], 
               Cell["WORKFLOW", "PacletNameCell", TextAlignment -> Center], 
               InterpretationBox[
                StyleBox[
                 
                 GraphicsBox[{}, BaselinePosition -> Baseline, 
                  ImageSize -> {8, 0}], CacheGraphics -> False], 
                Spacer[8], Selectable -> False]}]], TextAlignment -> Center], 
           Background -> RGBColor[0.2157, 0.6588, 0.6745], ItemSize -> Full], 
          ""}}, GridBoxAlignment -> {"Rows" -> {{Center}}}, 
        GridBoxItemSize -> {"Columns" -> {Full, 
            Scaled[0.02]}, "Rows" -> {{2.5}}}], 
       Cell[
        BoxData[
         GridBox[{{
            Cell["MENUPLACEHOLDER"]}}]], "AnchorBar"]}}]], "AnchorBarGrid", 
   "WorkflowDockedCell"], 
  Cell[
   TextData["TITLEPLACEHOLDER"], "WorkflowTitle", "WorkflowDockedCell"], 
  Cell[
   BoxData[
    GridBox[{{
       Cell["TABSPLACEHOLDER"]}}]], "WorkflowTabGrid", 
   "WorkflowDockedCell"]},
TaggingRules->{
 "DocuToolsSettingsInternal" -> {
   "$PacletVersion" -> "0.9.2018", "$MVersion" -> "11.2", "$FlaggedVersion" -> 
    11.1, "$ApplicationName" -> "Pubs", "$LinkBase" -> "Pubs", 
    "$ApplicationDirectory" -> "C:\\Workspace\\Pubs\\", 
    "$DocumentationDirectory" -> 
    "C:\\Workspace\\Pubs\\Documentation\\English\\", "$UseNewPageDialog" -> 
    ""}, "ChatTools" -> {
   "Contacts" -> {
     "andre@wolfram.com", "bradym@wolfram.com", "brady@wolfram.com", 
      "chatframework@wolfram.com", "jayw@wolfram.com", 
      "s.wolfram@wolfram.com", "sw@wolfram.com"}}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> "", "SelectedPlatform" -> "All"},
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (February 12, 2019)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> 
     FrontEnd`FileName[{"Wolfram"}, "Reference.nb", CharacterEncoding -> 
       "UTF-8"]]], 
   Cell[
    StyleData["Notebook"], GraphicsBoxOptions -> {ImageSize -> 240}, 
    Graphics3DBoxOptions -> {ImageSize -> 240}], 
   Cell[
    StyleData["Input"], CellContext -> Notebook, SpanMaxSize -> 1, 
    LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, FontFamily -> 
    "Source Sans Pro", FontSize -> 14], 
   Cell[
    StyleData["StandardForm"], FontFamily -> "Source Sans Pro"], 
   Cell[
    StyleData["Output"], CellContext -> Notebook, FontFamily -> 
    "Source Sans Pro", FontSize -> 14]}, Visible -> False, FrontEndVersion -> 
  "12.0 for Microsoft Windows (64-bit) (February 12, 2019)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 184, 4, 23, InheritFromParent,ExpressionUUID->"9ecb39c2-9180-41a6-87d0-ff06a37b0966",
 CellID->134112371],
Cell[745, 26, 185, 4, 35, "Text",ExpressionUUID->"435bc244-df7c-449d-9298-3cc581e7dbb4",
 CellID->90280312],
Cell[CellGroupData[{
Cell[955, 34, 188, 4, 70, "Section",ExpressionUUID->"863fe2cf-f406-4027-b55d-b646164f765a",
 CellID->9074762],
Cell[1146, 40, 349, 8, 27, "Input",ExpressionUUID->"e63ea951-aaa8-4d9d-863b-3e5503dabfeb"],
Cell[1498, 50, 1066, 26, 62, "Input",ExpressionUUID->"1339f070-0bdf-400f-b92f-07a3eeb85715"],
Cell[2567, 78, 296, 7, 27, "Input",ExpressionUUID->"e9bdd0d7-8181-4a12-8e85-8f831c49350a",
 CellID->267713489],
Cell[2866, 87, 375, 10, 27, "Input",ExpressionUUID->"6f7d9063-1e5d-4041-a955-fbc37a30fa0d",
 CellID->133403045],
Cell[3244, 99, 281, 8, 27, "Input",ExpressionUUID->"42f71ceb-a1be-44c7-ba30-e262fa0eda03",
 CellID->17199079],
Cell[3528, 109, 5893, 127, 538, "Input",ExpressionUUID->"4d382d47-c214-494f-a3c8-870bf4e3124c",
 CellID->606224123]
}, Closed]],
Cell[CellGroupData[{
Cell[9458, 241, 186, 4, 50, "Section",ExpressionUUID->"dec05b2b-7055-4a4b-a71c-59d6df54be81",
 CellID->600980217],
Cell[CellGroupData[{
Cell[9669, 249, 283, 7, 30, "Input",ExpressionUUID->"926a4819-831c-4e45-b5d7-f71a424b9838",
 CellID->208333714],
Cell[9955, 258, 278, 6, 39, "Output",ExpressionUUID->"00420e10-d258-474e-8888-54e51234044b",
 CellID->413967391]
}, Open  ]],
Cell[10248, 267, 1448, 36, 191, "Input",ExpressionUUID->"75649f2d-6a34-4c61-ba7e-077fdc6fc4ca",
 CellID->60780229],
Cell[11699, 305, 1438, 36, 191, "Input",ExpressionUUID->"5ee71bd6-5b58-4b08-b96e-5ba4c6b7e0a4",
 CellID->7106460],
Cell[13140, 343, 1416, 34, 191, "Input",ExpressionUUID->"5f117db9-2b1f-452a-afd0-567900f5a3df",
 CellID->740894912],
Cell[CellGroupData[{
Cell[14581, 381, 501, 14, 54, "Input",ExpressionUUID->"bf13d498-6b41-43f3-b3c4-4d610f52d0c9",
 CellID->222152546],
Cell[15085, 397, 354, 9, 39, "Output",ExpressionUUID->"6e3a8170-684c-49a7-9685-1c66c9c3f0d7",
 CellID->474749300]
}, Open  ]],
Cell[15454, 409, 351, 9, 30, "Input",ExpressionUUID->"83cf0887-5c62-47e3-a1bb-eb53490b37e3",
 CellID->95570290]
}, Open  ]],
Cell[CellGroupData[{
Cell[15842, 423, 286, 7, 0, "WorkflowPlatform",ExpressionUUID->"0cc218d0-aef2-459f-ab6f-60ae25278e44",
 CellOpen->Dynamic[
   MatchQ[
    CurrentValue[
     EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}], 
    Alternatives["All", "Desktop"]]],
 CellID->515390594],
Cell[16131, 432, 179, 4, 23, InheritFromParent,ExpressionUUID->"0ba5de83-e2bc-41c1-af99-b0986a3a7ea3",
 CellID->77743858]
}, Dynamic[MatchQ[CurrentValue[EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}, "Desktop"], Alternatives["Desktop", "All"]]]]],
Cell[CellGroupData[{
Cell[16479, 444, 282, 7, 0, "WorkflowPlatform",ExpressionUUID->"24202825-bdb2-4b21-beee-5eec6494f616",
 CellOpen->Dynamic[
   MatchQ[
    CurrentValue[
     EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}], 
    Alternatives["All", "Cloud"]]],
 CellID->135602052],
Cell[16764, 453, 177, 4, 23, InheritFromParent,ExpressionUUID->"bd07d57d-333a-4686-bf45-72a30cd725fd",
 CellID->58879777]
}, Dynamic[MatchQ[CurrentValue[EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}, "Desktop"], Alternatives["Cloud", "All"]]]]],
Cell[CellGroupData[{
Cell[17108, 465, 284, 7, 0, "WorkflowPlatform",ExpressionUUID->"06ebb6bc-848c-44fe-97f8-5be4de071841",
 CellOpen->Dynamic[
   MatchQ[
    CurrentValue[
     EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}], 
    Alternatives["All", "Mobile"]]],
 CellID->683030426],
Cell[17395, 474, 178, 4, 23, InheritFromParent,ExpressionUUID->"ac655b93-7e4c-45f8-b207-f32e6098c229",
 CellID->83489441],
Cell[CellGroupData[{
Cell[17598, 482, 160, 3, 70, "Section",ExpressionUUID->"53b47bf8-eccf-4eb6-8387-0888883ef195",
 CellID->41735091],
Cell[17761, 487, 258, 6, 30, "Input",ExpressionUUID->"8463fcb7-b7ba-4906-a92d-361514cc8155",
 CellID->671902962]
}, Open  ]]
}, Dynamic[MatchQ[CurrentValue[EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}, "Desktop"], Alternatives["Mobile", "All"]]]]],
Cell[CellGroupData[{
Cell[18199, 502, 190, 4, 6, "WorkflowFooterTopDelimiter",ExpressionUUID->"de466a8f-2182-421d-b8ba-5ffb484d64ec",
 CellID->175919488],
Cell[18392, 508, 736, 18, 71, "Input",ExpressionUUID->"336feb5d-6e48-4518-8472-de4fd37bdc03",
 CellID->13208771]
}, Open  ]],
Cell[CellGroupData[{
Cell[19165, 531, 107, 1, 50, "FooterHeader",ExpressionUUID->"cbc06bce-c23e-4c08-aba9-8be04b189bef",
 CellID->351896171],
Cell[19275, 534, 179, 4, 23, InheritFromParent,ExpressionUUID->"6a229c40-6f1f-4aff-98ac-25fd838f790a",
 CellID->35458802],
Cell[19457, 540, 254, 6, 30, "Input",ExpressionUUID->"6c872a04-aa3d-49cc-bb03-7348d5292997",
 CellID->51221915],
Cell[19714, 548, 187, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"d773a0e6-9522-430f-801b-fe7a0801c2c8",
 CellID->435938663],
Cell[19904, 554, 755, 18, 71, "Input",ExpressionUUID->"f2b6b70c-4977-4b97-b8fc-e223cbe9cd28",
 CellID->12660416]
}, Open  ]],
Cell[CellGroupData[{
Cell[20696, 577, 115, 1, 50, "FooterHeader",ExpressionUUID->"18880abf-5c3b-4fa3-89ac-3c22a64160ae",
 CellID->77064428],
Cell[20814, 580, 189, 4, 23, InheritFromParent,ExpressionUUID->"22007a06-432d-4071-8550-d69294b49408",
 CellID->389045652],
Cell[21006, 586, 255, 6, 30, "Input",ExpressionUUID->"3c9d6a6b-46eb-4513-83e6-5efa2ae39ec9",
 CellID->125738797],
Cell[21264, 594, 187, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"38ec371b-d489-42b9-9178-a7c2fd2cea66",
 CellID->869216197],
Cell[21454, 600, 521, 13, 51, "Input",ExpressionUUID->"1448f594-a22f-4c57-8cf7-760bd1cf085a",
 CellID->251796805]
}, Open  ]],
Cell[CellGroupData[{
Cell[22012, 618, 113, 1, 50, "FooterHeader",ExpressionUUID->"72d030a6-c84d-4229-81bc-85a938dc38e8",
 CellID->291956413],
Cell[22128, 621, 186, 4, 23, InheritFromParent,ExpressionUUID->"1e7e9a55-9182-4bc6-8efe-a557642278e3",
 CellID->326400149],
Cell[22317, 627, 255, 6, 30, "Input",ExpressionUUID->"7ecda1fc-6d3d-4005-b411-6fd0f64b3010",
 CellID->319555874],
Cell[22575, 635, 187, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"102913b7-e550-4707-9794-07b13c4b9f06",
 CellID->124395404],
Cell[22765, 641, 528, 13, 51, "Input",ExpressionUUID->"f0526ddf-d8db-4596-869b-47312c6f7b27",
 CellID->500763758]
}, Open  ]],
Cell[CellGroupData[{
Cell[23330, 659, 117, 1, 50, "FooterHeader",ExpressionUUID->"2211f83a-b3dc-4251-9b8d-a6558d967267",
 CellID->624027471],
Cell[23450, 662, 188, 4, 23, InheritFromParent,ExpressionUUID->"21b1dc2b-d822-443a-9a9e-327b52a2b4fb",
 CellID->172786405],
Cell[23641, 668, 255, 6, 30, "Input",ExpressionUUID->"0d5e3e97-eea2-4a0a-9f81-6017866e706b",
 CellID->647333165],
Cell[23899, 676, 188, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"15f1c69b-209b-46bf-ae5b-02f79e82596b",
 CellID->789161539],
Cell[24090, 682, 529, 13, 51, "Input",ExpressionUUID->"14078a09-ab3a-4850-878e-3e53a5a32e9b",
 CellID->482658414]
}, Open  ]],
Cell[CellGroupData[{
Cell[24656, 700, 190, 4, 50, "FooterHeader",ExpressionUUID->"8cffa393-0086-4e85-9aa9-d6fb587ac888",
 CellID->762311939],
Cell[24849, 706, 185, 4, 23, InheritFromParent,ExpressionUUID->"7d1c3381-c2d6-46f2-be26-dca9513dd413",
 CellID->136656972],
Cell[25037, 712, 261, 6, 30, "Input",ExpressionUUID->"52a230a3-d296-4063-b1ab-11955f9da1b5",
 CellID->137855366]
}, Open  ]],
Cell[25313, 721, 192, 4, 20, "WorkflowFooterBottomDelimiter",ExpressionUUID->"a733295c-1808-4eaa-934c-bbbadc5130ff",
 CellID->61232784]
}
]
*)

