(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     35778,        913]
NotebookOptionsPosition[     17555,        497]
NotebookOutlinePosition[     30898,        819]
CellTagsIndexPosition[     30855,        816]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\
ALL INPUT AND SECTION CELLS ARE REMOVED BEFORE CONTENT IS INSERTED\
\>", "Text",
 FontWeight->"Bold",
 CellID->90280312,ExpressionUUID->"942b9a7c-e08a-41a4-8f01-5d48a517617b"],

Cell[CellGroupData[{

Cell["Docked Cell Generation", "Section",
 ShowGroupOpener->True,
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellID->9074762,ExpressionUUID->"f25c98b0-296f-471f-9610-59a12cd83129"],

Cell[BoxData[
 RowBox[{"SetOptions", "[", 
  RowBox[{
   RowBox[{"InputNotebook", "[", "]"}], ",", 
   RowBox[{
   "StyleDefinitions", "\[Rule]", "\"\<Wolfram\\\\Reference.nb\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.704034031534266*^9, 3.704034044245511*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"fce7574c-c8f3-4711-bbf7-0f8e2c63d187"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{
    RowBox[{"BoxData", "[", 
     RowBox[{"GridBox", "[", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Cell", "[", 
          RowBox[{"\"\<WORKFLOW\>\"", ",", "\"\<PacletNameCell\>\"", ",", 
           RowBox[{"TextAlignment", "\[Rule]", "Center"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"0.2157", ",", "0.6588", ",", "0.6745"}], "]"}]}]}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Cell", "[", 
          RowBox[{
           RowBox[{"BoxData", "[", 
            RowBox[{"GridBox", "[", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"Cell", "[", "\"\<MENUPLACEHOLDER\>\"", "]"}], "}"}], 
              "}"}], "]"}], "]"}], ",", "\"\<AnchorBar\>\""}], "]"}]}], "}"}],
        "}"}], "]"}], "]"}], ",", "\"\<AnchorBarGrid\>\""}], "]"}], "//", 
  "CellPrint"}]], "Input",
 CellLabel->"In[4]:=",ExpressionUUID->"47ecc42b-76c1-4f7b-8ebd-cb5a8c4bf452"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{
    RowBox[{"TextData", "[", "\"\<TITLEPLACEHOLDER\>\"", "]"}], ",", 
    "\"\<WorkflowTitle\>\""}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->267713489,ExpressionUUID->"d7c4ac6b-fba9-42c3-ab29-e89be9f029ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{"BoxData", "[", 
    RowBox[{"GridBox", "[", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"Cell", "[", "\"\<TABSPLACEHOLDER\>\"", "]"}], "}"}], "}"}], 
     "]"}], "]"}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->133403045,ExpressionUUID->"b9d09364-cc74-461c-be4a-492cf8c6a35b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dc", "=", 
   RowBox[{"CurrentValue", "[", 
    RowBox[{
     RowBox[{"InputNotebook", "[", "]"}], ",", "DockedCells"}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->17199079,ExpressionUUID->"15766225-eb0d-4e6f-b830-0e17ec981ab0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CurrentValue", "[", 
    RowBox[{
     RowBox[{"InputNotebook", "[", "]"}], ",", "DockedCells"}], "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{"dc", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{
         RowBox[{"BoxData", "[", 
          RowBox[{"GridBox", "[", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"GridBox", "[", 
               RowBox[{
                RowBox[{"{", "\n", "      ", 
                 RowBox[{"{", "\n", "       ", 
                  RowBox[{
                   RowBox[{"ItemBox", "[", 
                    RowBox[{
                    RowBox[{"Cell", "[", 
                    RowBox[{
                    RowBox[{"BoxData", "[", "\n", "         ", 
                    RowBox[{"RowBox", "[", 
                    RowBox[{"{", "\n", "          ", 
                    RowBox[{
                    RowBox[{"InterpretationBox", "[", "\n", "           ", 
                    RowBox[{
                    RowBox[{"StyleBox", "[", "\n", "            ", 
                    RowBox[{
                    RowBox[{"GraphicsBox", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", "\n", "             ", 
                    RowBox[{"BaselinePosition", "->", "Baseline"}], ",", "\n",
                     "             ", 
                    RowBox[{"ImageSize", "->", 
                    RowBox[{"{", 
                    RowBox[{"8", ",", " ", "0"}], "}"}]}]}], "]"}], ",", "\n",
                     "            ", 
                    RowBox[{"CacheGraphics", "->", "False"}]}], "]"}], ",", 
                    "\n", "           ", 
                    RowBox[{"Spacer", "[", "8", "]"}], ",", "\n", 
                    "           ", 
                    RowBox[{"Selectable", "->", "False"}]}], "]"}], ",", " ", 
                    
                    RowBox[{"Cell", "[", 
                    RowBox[{"\"\<WORKFLOW\>\"", ",", " ", 
                    "\"\<PacletNameCell\>\"", ",", "\n", "           ", 
                    RowBox[{"TextAlignment", "->", "Center"}]}], "]"}], ",", 
                    " ", "\n", "          ", 
                    RowBox[{"InterpretationBox", "[", "\n", "           ", 
                    RowBox[{
                    RowBox[{"StyleBox", "[", "\n", "            ", 
                    RowBox[{
                    RowBox[{"GraphicsBox", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", "\n", "             ", 
                    RowBox[{"BaselinePosition", "->", "Baseline"}], ",", "\n",
                     "             ", 
                    RowBox[{"ImageSize", "->", 
                    RowBox[{"{", 
                    RowBox[{"8", ",", " ", "0"}], "}"}]}]}], "]"}], ",", "\n",
                     "            ", 
                    RowBox[{"CacheGraphics", "->", "False"}]}], "]"}], ",", 
                    "\n", "           ", 
                    RowBox[{"Spacer", "[", "8", "]"}], ",", "\n", 
                    "           ", 
                    RowBox[{"Selectable", "->", "False"}]}], "]"}]}], "}"}], 
                    "]"}], "]"}], ",", "\n", "         ", 
                    RowBox[{"TextAlignment", "->", "Center"}]}], "]"}], ",", 
                    "\n", "        ", 
                    RowBox[{"Background", "->", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{
                    "0.2157", ",", " ", "0.6588", ",", " ", "0.6745"}], 
                    "]"}]}], ",", "\n", "        ", 
                    RowBox[{"ItemSize", "->", "Full"}]}], "]"}], ",", " ", 
                   "\"\<\>\""}], "}"}], "\n", "     ", "}"}], ",", "\n", 
                "     ", 
                RowBox[{"GridBoxAlignment", "->", 
                 RowBox[{"{", 
                  RowBox[{"\"\<Rows\>\"", " ", "->", " ", 
                   RowBox[{"{", 
                    RowBox[{"{", "Center", "}"}], "}"}]}], "}"}]}], ",", "\n",
                 "     ", 
                RowBox[{"GridBoxItemSize", "->", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"\"\<Columns\>\"", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{"Full", ",", " ", "\n", "         ", 
                    RowBox[{"Scaled", "[", "0.02", "]"}]}], "}"}]}], ",", " ", 
                   RowBox[{"\"\<Rows\>\"", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{"{", "2.5", "}"}], "}"}]}]}], "}"}]}]}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"Cell", "[", 
               RowBox[{
                RowBox[{"BoxData", "[", 
                 RowBox[{"GridBox", "[", 
                  RowBox[{"{", 
                   RowBox[{"{", 
                    RowBox[{"Cell", "[", "\"\<MENUPLACEHOLDER\>\"", "]"}], 
                    "}"}], "}"}], "]"}], "]"}], ",", "\"\<AnchorBar\>\""}], 
               "]"}]}], "}"}], "}"}], "]"}], "]"}], ",", 
         "\"\<AnchorBarGrid\>\"", ",", "\"\<WorkflowDockedCell\>\""}], "]"}], 
       ",", 
       RowBox[{"Cell", "[", 
        RowBox[{
         RowBox[{"TextData", "[", "\"\<TITLEPLACEHOLDER\>\"", "]"}], ",", 
         "\"\<WorkflowTitle\>\"", ",", "\"\<WorkflowDockedCell\>\""}], 
        "]"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->606224123,ExpressionUUID->"f1913aa0-3249-448e-abc9-10bdb470da58"]
}, Closed]],

Cell[CellGroupData[{

Cell["Content Generation", "Section",
 ShowGroupOpener->True,
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellID->600980217,ExpressionUUID->"98b12beb-67d4-49ff-9cdc-05a936dea172"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dynamic", "[", 
  RowBox[{"CurrentValue", "[", 
   RowBox[{"{", 
    RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], "}"}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->208333714,ExpressionUUID->"5a170403-37d6-4847-a86f-53b2ed6880a6"],

Cell[BoxData[
 DynamicBox[ToBoxes[
   CurrentValue[{TaggingRules, "SelectedPlatform"}], StandardForm],
  ImageSizeCache->{16., {0., 10.}}]], "Output",
 CellContext->"Cell$$25520`",
 CellLabel->"Out[7]=",
 CellID->413967391,ExpressionUUID->"b8833248-9cde-4292-91f4-3b371027098e"]
}, Open  ]],

Cell["CONTENT PLACEHOLDER",ExpressionUUID->"feb0eb94-9a2b-4589-9401-706d238bbe60"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Footer Generation", "Section",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellID->41735091,ExpressionUUID->"918a5f7a-b951-44d5-a890-cfc35e488010"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterTopDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->671902962,ExpressionUUID->"153b7afd-2baa-4997-9a98-72c0d1f6acaa"]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "WorkflowFooterTopDelimiter",
 CellContext->"Cell$$6046`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->175919488,ExpressionUUID->"81b0b876-1451-4b6e-a105-a4cb7418a97f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<See Also\>\"", ",", "\"\<FooterHeader\>\"", ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"CurrentValue", "[", 
           RowBox[{"{", 
            RowBox[{
            "StyleHints", ",", "\"\<WorkflowFooterBackgroundColor\>\""}], 
            "}"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Cell", "[", "\"\<SEEALSO PLACEHOLDER\>\"", "]"}]}], "}"}], 
     ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->13208771,ExpressionUUID->"c89f22dd-7e18-4365-a747-842a7905997e"]
}, Open  ]],

Cell[CellGroupData[{

Cell["See Also", "FooterHeader",
 CellID->351896171,ExpressionUUID->"d2443d73-089b-4e4d-aaf9-49119d46766f"],

Cell["SEEALSO PLACEHOLDER",
 CellContext->"Cell$$26587`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->35458802,ExpressionUUID->"6a229c40-6f1f-4aff-98ac-25fd838f790a"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->51221915,ExpressionUUID->"6c872a04-aa3d-49cc-bb03-7348d5292997"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$6048`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->435938663,ExpressionUUID->"d773a0e6-9522-430f-801b-fe7a0801c2c8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<Related Functions\>\"", ",", "\"\<FooterHeader\>\"", ",", 
         RowBox[{"Background", "\[Rule]", 
          RowBox[{"CurrentValue", "[", 
           RowBox[{"{", 
            RowBox[{
            "StyleHints", ",", "\"\<WorkflowFooterBackgroundColor\>\""}], 
            "}"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Cell", "[", "\"\<RELATEDFUNCTIONS PLACEHOLDER\>\"", "]"}]}], 
      "}"}], ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->12660416,ExpressionUUID->"f2b6b70c-4977-4b97-b8fc-e223cbe9cd28"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Functions", "FooterHeader",
 CellID->77064428,ExpressionUUID->"18880abf-5c3b-4fa3-89ac-3c22a64160ae"],

Cell["RELATEDFUNCTIONS PLACEHOLDER",
 CellContext->"Cell$$26587`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->389045652,ExpressionUUID->"22007a06-432d-4071-8550-d69294b49408"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->125738797,ExpressionUUID->"3c9d6a6b-46eb-4513-83e6-5efa2ae39ec9"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$6048`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->869216197,ExpressionUUID->"38ec371b-d489-42b9-9178-a7c2fd2cea66"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<Related Guides\>\"", ",", "\"\<FooterHeader\>\""}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Cell", "[", "\"\<RELATEDGUIDES PLACEHOLDER\>\"", "]"}]}], 
      "}"}], ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->251796805,ExpressionUUID->"1448f594-a22f-4c57-8cf7-760bd1cf085a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Guides", "FooterHeader",
 CellID->291956413,ExpressionUUID->"72d030a6-c84d-4229-81bc-85a938dc38e8"],

Cell["RELATEDGUIDES PLACEHOLDER",
 CellContext->"Cell$$26587`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->326400149,ExpressionUUID->"1e7e9a55-9182-4bc6-8efe-a557642278e3"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->319555874,ExpressionUUID->"7ecda1fc-6d3d-4005-b411-6fd0f64b3010"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$6048`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->124395404,ExpressionUUID->"102913b7-e550-4707-9794-07b13c4b9f06"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<Related Tech Notes\>\"", ",", "\"\<FooterHeader\>\""}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Cell", "[", "\"\<RELATEDTECHNOTES PLACEHOLDER\>\"", "]"}]}], 
      "}"}], ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->500763758,ExpressionUUID->"f0526ddf-d8db-4596-869b-47312c6f7b27"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Tech Notes", "FooterHeader",
 CellID->624027471,ExpressionUUID->"2211f83a-b3dc-4251-9b8d-a6558d967267"],

Cell["RELATEDTECHNOTES PLACEHOLDER",
 CellContext->"Cell$$6054`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->172786405,ExpressionUUID->"21b1dc2b-d822-443a-9a9e-327b52a2b4fb"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->647333165,ExpressionUUID->"6320e627-adce-40ce-be39-3f134f91d5d3"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$48730`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->789161539,ExpressionUUID->"8fbb2920-37ca-4c00-bdbf-f99fe582d52c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<Related Links\>\"", ",", " ", "\"\<FooterHeader\>\""}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Cell", "[", "\"\<RELATEDLINKS PLACEHOLDER\>\"", "]"}]}], 
      "}"}], ",", " ", "Open"}], "]"}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->482658414,ExpressionUUID->"c42bbcc4-1cba-4264-bac2-67ebef349813"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Links", "FooterHeader",
 CellContext->"Cell$$48730`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->762311939,ExpressionUUID->"87ec7aef-261d-4abd-accd-a050e63340fd"],

Cell["RELATEDLINKS PLACEHOLDER",
 CellContext->"Cell$$48730`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->136656972,ExpressionUUID->"46af29c6-5e12-4de6-b643-7dadcb8b41bd"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterBottomDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->137855366,ExpressionUUID->"52a230a3-d296-4063-b1ab-11955f9da1b5"]
}, Open  ]],

Cell["", "WorkflowFooterBottomDelimiter",
 CellContext->"Cell$$2532`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->61232784,ExpressionUUID->"a733295c-1808-4eaa-934c-bbbadc5130ff"]
},
WindowSize->{808, 911},
WindowMargins->{{331, Automatic}, {Automatic, 23}},
DockedCells->{
  Cell[
   BoxData[
    PanelBox[
     StyleBox[
      TemplateBox[{
        StyleBox[
         GraphicsBox[{}, ImageSize -> {9, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        TemplateBox[{
          TooltipBox[
           DynamicModuleBox[{$CellContext`destination$$ = 0}, 
            DynamicBox[
             FEPrivate`If[FEPrivate`HistoryList["Back"] === {}, 
              ButtonBox[
               DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "DisabledBackIcon.png"]]], Enabled -> False, Appearance -> 
               None, FrameMargins -> 0], 
              ButtonBox[
               PaneSelectorBox[{True -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "BackIconHot.png"]]], False -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "BackIcon.png"]]]}, 
                Dynamic[
                 CurrentValue["MouseOver"]]], ButtonFunction :> 
               FrontEndToken[
                 FrontEnd`ButtonNotebook[], "HyperlinkGoBack"], Evaluator -> 
               None, Appearance -> None, FrameMargins -> 0]]], 
            DynamicModuleValues :> {}], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipBack"]]], 
          StyleBox[
           GraphicsBox[{}, ImageSize -> {2, 0}, BaselinePosition -> Baseline],
            "CacheGraphics" -> False], 
          TooltipBox[
           DynamicModuleBox[{$CellContext`destination$$ = 0}, 
            DynamicBox[
             FEPrivate`If[FEPrivate`HistoryList["Forward"] === {}, 
              ButtonBox[
               DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "DisabledForwardIcon.png"]]], Enabled -> False, Appearance -> 
               None, FrameMargins -> 0], 
              ButtonBox[
               PaneSelectorBox[{True -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "ForwardIconHot.png"]]], False -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "ForwardIcon.png"]]]}, 
                Dynamic[
                 CurrentValue["MouseOver"]]], ButtonFunction :> 
               FrontEndToken[
                 FrontEnd`ButtonNotebook[], "HyperlinkGoForward"], Evaluator -> 
               None, Appearance -> None, FrameMargins -> 0]]], 
            DynamicModuleValues :> {}], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipForward"]]], 
          TooltipBox[
           DynamicBox[
            ToBoxes[
             FEPrivate`GenerateHelpViewerActionMenu[], StandardForm]], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipHistory"]]], 
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {13, 0}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          TooltipBox[
           ButtonBox[
            PaneSelectorBox[{True -> DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "HomeIconHot.png"]]], False -> DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "HomeIcon.png"]]]}, 
             Dynamic[
              CurrentValue["MouseOver"]]], ButtonFunction :> 
            Documentation`HelpLookup[
              CurrentValue[HomePage], 
              FrontEnd`ButtonNotebook[], 
              CurrentValue[Language]], Appearance -> None, Evaluator -> 
            Automatic, Method -> "Preemptive"], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipHome"]]]}, 
         "RowDefault"], 
        StyleBox[
         GraphicsBox[{}, ImageSize -> {39, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        FrameBox[
         StyleBox[
          DynamicBox[
           FEPrivate`FrontEndResource[
           "FEExpressions", "HelpViewerSearchField"]], 
          InputFieldBoxOptions -> {
           ImageSize -> Dynamic[AbsoluteCurrentValue[{WindowSize, 1}] - 220], 
            FrameMargins -> 
            FEPrivate`Switch[
             FEPrivate`$OperatingSystem, "MacOSX", {{3, 3}, {0, -1}}, 
              "Windows", {{0, 2}, {0, 2}}, 
              Blank[], {{2, 2}, {0, 0}}]}], FrameStyle -> None, 
         FrameMargins -> {{0, 0}, {4, 0}}], 
        StyleBox[
         GraphicsBox[{}, ImageSize -> {12, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        TooltipBox[
         ButtonBox[
          PaneSelectorBox[{True -> DynamicBox[
              FEPrivate`ImportImage[
               
               FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                "RevertIconHot.png"]]], False -> DynamicBox[
              FEPrivate`ImportImage[
               
               FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                "RevertIcon.png"]]]}, 
           Dynamic[
            CurrentValue["MouseOver"]]], ButtonFunction :> FrontEndToken[
            FrontEnd`ButtonNotebook[], "Revert", False], Evaluator -> None, 
          Appearance -> None, Method -> "Preemptive"], 
         DynamicBox[
          FEPrivate`FrontEndResource["HelpToolbarText", "TooltipRefresh"]]]}, 
       "RowDefault"], CacheGraphics -> False, 
      ButtonBoxOptions -> {BaselinePosition -> (Baseline -> Baseline)}], 
     Alignment -> {Left, Center}, Appearance -> Image[CompressedData["
1:eJztyDkKAkEUhOFGE0OvIHgIU0PTEQ8ww7SDSQs9gnhXl3HBfbmC7Q0qeWDw
f1CPqtcr5tm05ZyrO+lk+XIYY74ad9OYhHpWBV+OwsJXPg6Kdnr2U8qUX/8A
AAAA+HtvyF6AgSdg4AHZHbIbYOAKGLhAdobsBBg4QnaAbA9ZAxjYAQa2gIEN
ZGvIvp8pRMU=
       "], "Byte", ColorSpace -> "RGB", Interleaving -> True], 
     ImageSize -> {
       Scaled[1], Full}]], "DockedCell", CellFrame -> 0, 
   CellMargins -> {{0, -10}, {-2, -1}}, CellFrameMargins -> {{0, 0}, {0, 0}}, 
   ShowCodeAssist -> False, Background -> None], 
  Cell[
   BoxData[
    DynamicBox[
     FEPrivate`If[FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "SearchTextTranslated"},
         ""] === "", "", 
      StyleBox[
       RowBox[{
         ButtonBox[
          DynamicBox[
           DynamicBox[
            FEPrivate`ImportImage[
             
             FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
              "SearchIcon.png"]]]], ButtonData :> FEPrivate`StringJoin[
            FrontEnd`CurrentValue[
             FrontEnd`EvaluationNotebook[], {
             TaggingRules, "SearchTextTranslated"}, ""], " start:1"], 
          BaseStyle -> {
           "Link", FontWeight -> "Bold", 
            FontVariations -> {"Underline" -> True}}, ButtonNote -> ""], 
         "   ", 
         DynamicBox[
          FEPrivate`FrontEndResource["HelpToolbarText", "SearchString1"]], 
         "\[InvisibleSpace]", 
         ButtonBox[
          DynamicBox[
           FrontEnd`CurrentValue[
            FrontEnd`EvaluationNotebook[], {
            TaggingRules, "SearchTextTranslated"}, ""]], ButtonData :> 
          FEPrivate`StringJoin[
            FrontEnd`CurrentValue[
             FrontEnd`EvaluationNotebook[], {
             TaggingRules, "SearchTextTranslated"}, ""], " start:1"], 
          BaseStyle -> {
           "Link", FontWeight -> "Bold", 
            FontVariations -> {"Underline" -> True}}, ButtonNote -> ""], 
         "\[InvisibleSpace]", 
         DynamicBox[
          FEPrivate`FrontEndResource["HelpToolbarText", "SearchString2"]]}], 
       FontSize -> 11]], ImageSizeCache -> {4., {0., 0.}}]], "DockedCell", 
   "ControlStyle", CellFrame -> Dynamic[
     FEPrivate`If[
      FEPrivate`UnsameQ[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], 
       ""], {{0, 0}, {3, 0}}, {{0, 0}, {0, 0}}]], 
   CellMargins -> {{0, -10}, {0, -1}}, CellOpen -> 
   Dynamic[FrontEnd`CurrentValue[
       FrontEnd`EvaluationNotebook[], {TaggingRules, "SearchTextTranslated"}, 
       ""] =!= ""], CellFrameMargins -> {{146, 5}, {3, 0}}, CellFrameColor -> 
   Dynamic[
     FEPrivate`If[
      FEPrivate`SameQ[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], ""], 
      CurrentValue["ToolbarBackground"], 
      FEPrivate`Switch[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "ColorType"}], 
       "SymbolColor", 
       RGBColor[0.481193, 0.528023, 0.813489], "GuideColor", 
       RGBColor[1, 0.6, 0], "TutorialColor", 
       RGBColor[0.641154, 0.223011, 0.0623026], "RootColor", 
       RGBColor[1, 0, 0], 
       Blank[], 
       GrayLevel[0.8]]]], ShowCodeAssist -> False, LineIndent -> 0, 
   LinebreakAdjustments -> {1, 10, 0, 100, 0}, Background -> 
   GrayLevel[0.8627450980392157]], 
  Cell[
   BoxData[
    DynamicBox[
     FrontEnd`CurrentValue[
      FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], 
     ImageSizeCache -> {4., {0., 0.}}]], "DockedLinkTrail", CellOpen -> 
   Dynamic[FrontEnd`CurrentValue[
       FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""] =!= 
     ""], CellFrameColor -> Dynamic[
     FEPrivate`If[
      FEPrivate`UnsameQ[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], ""], 
      GrayLevel[0.8], 
      FEPrivate`Switch[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "ColorType"}], 
       "SymbolColor", 
       RGBColor[0.481193, 0.528023, 0.813489], "GuideColor", 
       RGBColor[1, 0.6, 0], "TutorialColor", 
       RGBColor[0.641154, 0.223011, 0.0623026], "RootColor", 
       RGBColor[1, 0, 0], 
       Blank[], 
       GrayLevel[0.8]]]], ShowCodeAssist -> False], 
  Cell[
   BoxData[
    GridBox[{{
       GridBox[{{
          ItemBox[
           Cell[
            BoxData[
             RowBox[{
               InterpretationBox[
                StyleBox[
                 
                 GraphicsBox[{}, BaselinePosition -> Baseline, 
                  ImageSize -> {8, 0}], CacheGraphics -> False], 
                Spacer[8], Selectable -> False], 
               Cell["WORKFLOW", "PacletNameCell", TextAlignment -> Center], 
               InterpretationBox[
                StyleBox[
                 
                 GraphicsBox[{}, BaselinePosition -> Baseline, 
                  ImageSize -> {8, 0}], CacheGraphics -> False], 
                Spacer[8], Selectable -> False]}]], TextAlignment -> Center], 
           Background -> RGBColor[0.2157, 0.6588, 0.6745], ItemSize -> Full], 
          ""}}, GridBoxAlignment -> {"Rows" -> {{Center}}}, 
        GridBoxItemSize -> {"Columns" -> {Full, 
            Scaled[0.02]}, "Rows" -> {{2.5}}}], 
       Cell[
        BoxData[
         GridBox[{{
            Cell["MENUPLACEHOLDER"]}}]], "AnchorBar"]}}]], "AnchorBarGrid", 
   "WorkflowDockedCell"], 
  Cell[
   TextData["TITLEPLACEHOLDER"], "WorkflowTitle", "WorkflowDockedCell"]},
TaggingRules->{
 "DocuToolsSettingsInternal" -> {
   "$PacletVersion" -> "0.9.2018", "$MVersion" -> "11.2", "$FlaggedVersion" -> 
    11.1, "$ApplicationName" -> "Pubs", "$LinkBase" -> "Pubs", 
    "$ApplicationDirectory" -> "C:\\Workspace\\Pubs\\", 
    "$DocumentationDirectory" -> 
    "C:\\Workspace\\Pubs\\Documentation\\English\\", "$UseNewPageDialog" -> 
    ""}, "ChatTools" -> {
   "Contacts" -> {
     "andre@wolfram.com", "bradym@wolfram.com", "brady@wolfram.com", 
      "chatframework@wolfram.com", "jayw@wolfram.com", 
      "s.wolfram@wolfram.com", "sw@wolfram.com"}}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> "", "SelectedPlatform" -> "All"},
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (February 12, 2019)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> 
     FrontEnd`FileName[{"Wolfram"}, "Reference.nb", CharacterEncoding -> 
       "UTF-8"]]], 
   Cell[
    StyleData["Notebook"], GraphicsBoxOptions -> {ImageSize -> 240}, 
    Graphics3DBoxOptions -> {ImageSize -> 240}], 
   Cell[
    StyleData["Input"], CellContext -> Notebook, SpanMaxSize -> 1, 
    LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, FontFamily -> 
    "Source Sans Pro", FontSize -> 14], 
   Cell[
    StyleData["StandardForm"], FontFamily -> "Source Sans Pro"], 
   Cell[
    StyleData["Output"], CellContext -> Notebook, FontFamily -> 
    "Source Sans Pro", FontSize -> 14]}, Visible -> False, FrontEndVersion -> 
  "12.0 for Microsoft Windows (64-bit) (February 12, 2019)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 185, 4, 35, "Text",ExpressionUUID->"942b9a7c-e08a-41a4-8f01-5d48a517617b",
 CellID->90280312],
Cell[CellGroupData[{
Cell[768, 28, 188, 4, 70, "Section",ExpressionUUID->"f25c98b0-296f-471f-9610-59a12cd83129",
 CellID->9074762],
Cell[959, 34, 349, 8, 26, "Input",ExpressionUUID->"fce7574c-c8f3-4711-bbf7-0f8e2c63d187"],
Cell[1311, 44, 1066, 26, 75, "Input",ExpressionUUID->"47ecc42b-76c1-4f7b-8ebd-cb5a8c4bf452"],
Cell[2380, 72, 296, 7, 26, "Input",ExpressionUUID->"d7c4ac6b-fba9-42c3-ab29-e89be9f029ec",
 CellID->267713489],
Cell[2679, 81, 375, 10, 26, "Input",ExpressionUUID->"b9d09364-cc74-461c-be4a-492cf8c6a35b",
 CellID->133403045],
Cell[3057, 93, 281, 8, 26, "Input",ExpressionUUID->"15766225-eb0d-4e6f-b830-0e17ec981ab0",
 CellID->17199079],
Cell[3341, 103, 5500, 117, 507, "Input",ExpressionUUID->"f1913aa0-3249-448e-abc9-10bdb470da58",
 CellID->606224123]
}, Closed]],
Cell[CellGroupData[{
Cell[8878, 225, 186, 4, 50, "Section",ExpressionUUID->"98b12beb-67d4-49ff-9cdc-05a936dea172",
 CellID->600980217],
Cell[CellGroupData[{
Cell[9089, 233, 283, 7, 30, "Input",ExpressionUUID->"5a170403-37d6-4847-a86f-53b2ed6880a6",
 CellID->208333714],
Cell[9375, 242, 278, 6, 39, "Output",ExpressionUUID->"b8833248-9cde-4292-91f4-3b371027098e",
 CellID->413967391]
}, Open  ]],
Cell[9668, 251, 82, 0, 23, InheritFromParent,ExpressionUUID->"feb0eb94-9a2b-4589-9401-706d238bbe60"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9787, 256, 160, 3, 70, "Section",ExpressionUUID->"918a5f7a-b951-44d5-a890-cfc35e488010",
 CellID->41735091],
Cell[9950, 261, 258, 6, 30, "Input",ExpressionUUID->"153b7afd-2baa-4997-9a98-72c0d1f6acaa",
 CellID->671902962]
}, Open  ]],
Cell[CellGroupData[{
Cell[10245, 272, 190, 4, 6, "WorkflowFooterTopDelimiter",ExpressionUUID->"81b0b876-1451-4b6e-a105-a4cb7418a97f",
 CellID->175919488],
Cell[10438, 278, 736, 18, 111, "Input",ExpressionUUID->"c89f22dd-7e18-4365-a747-842a7905997e",
 CellID->13208771]
}, Open  ]],
Cell[CellGroupData[{
Cell[11211, 301, 107, 1, 50, "FooterHeader",ExpressionUUID->"d2443d73-089b-4e4d-aaf9-49119d46766f",
 CellID->351896171],
Cell[11321, 304, 179, 4, 23, InheritFromParent,ExpressionUUID->"6a229c40-6f1f-4aff-98ac-25fd838f790a",
 CellID->35458802],
Cell[11503, 310, 254, 6, 30, "Input",ExpressionUUID->"6c872a04-aa3d-49cc-bb03-7348d5292997",
 CellID->51221915],
Cell[11760, 318, 187, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"d773a0e6-9522-430f-801b-fe7a0801c2c8",
 CellID->435938663],
Cell[11950, 324, 755, 18, 111, "Input",ExpressionUUID->"f2b6b70c-4977-4b97-b8fc-e223cbe9cd28",
 CellID->12660416]
}, Open  ]],
Cell[CellGroupData[{
Cell[12742, 347, 115, 1, 50, "FooterHeader",ExpressionUUID->"18880abf-5c3b-4fa3-89ac-3c22a64160ae",
 CellID->77064428],
Cell[12860, 350, 189, 4, 23, InheritFromParent,ExpressionUUID->"22007a06-432d-4071-8550-d69294b49408",
 CellID->389045652],
Cell[13052, 356, 255, 6, 30, "Input",ExpressionUUID->"3c9d6a6b-46eb-4513-83e6-5efa2ae39ec9",
 CellID->125738797],
Cell[13310, 364, 187, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"38ec371b-d489-42b9-9178-a7c2fd2cea66",
 CellID->869216197],
Cell[13500, 370, 521, 13, 51, "Input",ExpressionUUID->"1448f594-a22f-4c57-8cf7-760bd1cf085a",
 CellID->251796805]
}, Open  ]],
Cell[CellGroupData[{
Cell[14058, 388, 113, 1, 50, "FooterHeader",ExpressionUUID->"72d030a6-c84d-4229-81bc-85a938dc38e8",
 CellID->291956413],
Cell[14174, 391, 186, 4, 23, InheritFromParent,ExpressionUUID->"1e7e9a55-9182-4bc6-8efe-a557642278e3",
 CellID->326400149],
Cell[14363, 397, 255, 6, 30, "Input",ExpressionUUID->"7ecda1fc-6d3d-4005-b411-6fd0f64b3010",
 CellID->319555874],
Cell[14621, 405, 187, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"102913b7-e550-4707-9794-07b13c4b9f06",
 CellID->124395404],
Cell[14811, 411, 528, 13, 51, "Input",ExpressionUUID->"f0526ddf-d8db-4596-869b-47312c6f7b27",
 CellID->500763758]
}, Open  ]],
Cell[CellGroupData[{
Cell[15376, 429, 117, 1, 50, "FooterHeader",ExpressionUUID->"2211f83a-b3dc-4251-9b8d-a6558d967267",
 CellID->624027471],
Cell[15496, 432, 188, 4, 23, InheritFromParent,ExpressionUUID->"21b1dc2b-d822-443a-9a9e-327b52a2b4fb",
 CellID->172786405],
Cell[15687, 438, 255, 6, 30, "Input",ExpressionUUID->"6320e627-adce-40ce-be39-3f134f91d5d3",
 CellID->647333165],
Cell[15945, 446, 188, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"8fbb2920-37ca-4c00-bdbf-f99fe582d52c",
 CellID->789161539],
Cell[16136, 452, 529, 13, 51, "Input",ExpressionUUID->"c42bbcc4-1cba-4264-bac2-67ebef349813",
 CellID->482658414]
}, Open  ]],
Cell[CellGroupData[{
Cell[16702, 470, 190, 4, 50, "FooterHeader",ExpressionUUID->"87ec7aef-261d-4abd-accd-a050e63340fd",
 CellID->762311939],
Cell[16895, 476, 185, 4, 23, InheritFromParent,ExpressionUUID->"46af29c6-5e12-4de6-b643-7dadcb8b41bd",
 CellID->136656972],
Cell[17083, 482, 261, 6, 30, "Input",ExpressionUUID->"52a230a3-d296-4063-b1ab-11955f9da1b5",
 CellID->137855366]
}, Open  ]],
Cell[17359, 491, 192, 4, 20, "WorkflowFooterBottomDelimiter",ExpressionUUID->"a733295c-1808-4eaa-934c-bbbadc5130ff",
 CellID->61232784]
}
]
*)

