(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     38454,        993]
NotebookOptionsPosition[     20316,        579]
NotebookOutlinePosition[     33465,        897]
CellTagsIndexPosition[     33422,        894]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\
ALL INPUT AND SECTION CELLS ARE REMOVED BEFORE CONTENT IS INSERTED\
\>", "Text",
 FontWeight->"Bold",
 CellID->90280312,ExpressionUUID->"942b9a7c-e08a-41a4-8f01-5d48a517617b"],

Cell[CellGroupData[{

Cell["Docked Cell Generation", "Section",
 ShowGroupOpener->True,
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellID->9074762,ExpressionUUID->"f25c98b0-296f-471f-9610-59a12cd83129"],

Cell[BoxData[
 RowBox[{"SetOptions", "[", 
  RowBox[{
   RowBox[{"InputNotebook", "[", "]"}], ",", 
   RowBox[{
   "StyleDefinitions", "\[Rule]", "\"\<Wolfram\\\\Reference.nb\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.704034031534266*^9, 3.704034044245511*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"fce7574c-c8f3-4711-bbf7-0f8e2c63d187"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{
    RowBox[{"BoxData", "[", 
     RowBox[{"GridBox", "[", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Cell", "[", 
          RowBox[{"\"\<WORKFLOW\>\"", ",", "\"\<PacletNameCell\>\"", ",", 
           RowBox[{"TextAlignment", "\[Rule]", "Center"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"0.2157", ",", "0.6588", ",", "0.6745"}], "]"}]}]}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Cell", "[", 
          RowBox[{
           RowBox[{"BoxData", "[", 
            RowBox[{"GridBox", "[", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"Cell", "[", "\"\<MENUPLACEHOLDER\>\"", "]"}], "}"}], 
              "}"}], "]"}], "]"}], ",", "\"\<AnchorBar\>\""}], "]"}]}], "}"}],
        "}"}], "]"}], "]"}], ",", "\"\<AnchorBarGrid\>\""}], "]"}], "//", 
  "CellPrint"}]], "Input",
 CellLabel->"In[4]:=",ExpressionUUID->"47ecc42b-76c1-4f7b-8ebd-cb5a8c4bf452"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{
    RowBox[{"TextData", "[", "\"\<TITLEPLACEHOLDER\>\"", "]"}], ",", 
    "\"\<WorkflowTitle\>\""}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->267713489,ExpressionUUID->"d7c4ac6b-fba9-42c3-ab29-e89be9f029ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{"BoxData", "[", 
    RowBox[{"GridBox", "[", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"Cell", "[", "\"\<TABSPLACEHOLDER\>\"", "]"}], "}"}], "}"}], 
     "]"}], "]"}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->133403045,ExpressionUUID->"b9d09364-cc74-461c-be4a-492cf8c6a35b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dc", "=", 
   RowBox[{"CurrentValue", "[", 
    RowBox[{
     RowBox[{"InputNotebook", "[", "]"}], ",", "DockedCells"}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->17199079,ExpressionUUID->"15766225-eb0d-4e6f-b830-0e17ec981ab0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CurrentValue", "[", 
    RowBox[{
     RowBox[{"InputNotebook", "[", "]"}], ",", "DockedCells"}], "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{"dc", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{
         RowBox[{"BoxData", "[", 
          RowBox[{"GridBox", "[", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"GridBox", "[", 
               RowBox[{
                RowBox[{"{", "\n", "      ", 
                 RowBox[{"{", "\n", "       ", 
                  RowBox[{
                   RowBox[{"ItemBox", "[", 
                    RowBox[{
                    RowBox[{"Cell", "[", 
                    RowBox[{
                    RowBox[{"BoxData", "[", "\n", "         ", 
                    RowBox[{"RowBox", "[", 
                    RowBox[{"{", "\n", "          ", 
                    RowBox[{
                    RowBox[{"InterpretationBox", "[", "\n", "           ", 
                    RowBox[{
                    RowBox[{"StyleBox", "[", "\n", "            ", 
                    RowBox[{
                    RowBox[{"GraphicsBox", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", "\n", "             ", 
                    RowBox[{"BaselinePosition", "->", "Baseline"}], ",", "\n",
                     "             ", 
                    RowBox[{"ImageSize", "->", 
                    RowBox[{"{", 
                    RowBox[{"8", ",", " ", "0"}], "}"}]}]}], "]"}], ",", "\n",
                     "            ", 
                    RowBox[{"CacheGraphics", "->", "False"}]}], "]"}], ",", 
                    "\n", "           ", 
                    RowBox[{"Spacer", "[", "8", "]"}], ",", "\n", 
                    "           ", 
                    RowBox[{"Selectable", "->", "False"}]}], "]"}], ",", " ", 
                    
                    RowBox[{"Cell", "[", 
                    RowBox[{"\"\<WORKFLOW\>\"", ",", " ", 
                    "\"\<PacletNameCell\>\"", ",", "\n", "           ", 
                    RowBox[{"TextAlignment", "->", "Center"}]}], "]"}], ",", 
                    " ", "\n", "          ", 
                    RowBox[{"InterpretationBox", "[", "\n", "           ", 
                    RowBox[{
                    RowBox[{"StyleBox", "[", "\n", "            ", 
                    RowBox[{
                    RowBox[{"GraphicsBox", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", "\n", "             ", 
                    RowBox[{"BaselinePosition", "->", "Baseline"}], ",", "\n",
                     "             ", 
                    RowBox[{"ImageSize", "->", 
                    RowBox[{"{", 
                    RowBox[{"8", ",", " ", "0"}], "}"}]}]}], "]"}], ",", "\n",
                     "            ", 
                    RowBox[{"CacheGraphics", "->", "False"}]}], "]"}], ",", 
                    "\n", "           ", 
                    RowBox[{"Spacer", "[", "8", "]"}], ",", "\n", 
                    "           ", 
                    RowBox[{"Selectable", "->", "False"}]}], "]"}]}], "}"}], 
                    "]"}], "]"}], ",", "\n", "         ", 
                    RowBox[{"TextAlignment", "->", "Center"}]}], "]"}], ",", 
                    "\n", "        ", 
                    RowBox[{"Background", "->", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{
                    "0.2157", ",", " ", "0.6588", ",", " ", "0.6745"}], 
                    "]"}]}], ",", "\n", "        ", 
                    RowBox[{"ItemSize", "->", "Full"}]}], "]"}], ",", " ", 
                   "\"\<\>\""}], "}"}], "\n", "     ", "}"}], ",", "\n", 
                "     ", 
                RowBox[{"GridBoxAlignment", "->", 
                 RowBox[{"{", 
                  RowBox[{"\"\<Rows\>\"", " ", "->", " ", 
                   RowBox[{"{", 
                    RowBox[{"{", "Center", "}"}], "}"}]}], "}"}]}], ",", "\n",
                 "     ", 
                RowBox[{"GridBoxItemSize", "->", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"\"\<Columns\>\"", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{"Full", ",", " ", "\n", "         ", 
                    RowBox[{"Scaled", "[", "0.02", "]"}]}], "}"}]}], ",", " ", 
                   RowBox[{"\"\<Rows\>\"", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{"{", "2.5", "}"}], "}"}]}]}], "}"}]}]}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"Cell", "[", 
               RowBox[{
                RowBox[{"BoxData", "[", 
                 RowBox[{"GridBox", "[", 
                  RowBox[{"{", 
                   RowBox[{"{", 
                    RowBox[{"Cell", "[", "\"\<MENUPLACEHOLDER\>\"", "]"}], 
                    "}"}], "}"}], "]"}], "]"}], ",", "\"\<AnchorBar\>\""}], 
               "]"}]}], "}"}], "}"}], "]"}], "]"}], ",", 
         "\"\<AnchorBarGrid\>\"", ",", "\"\<WorkflowDockedCell\>\""}], "]"}], 
       ",", 
       RowBox[{"Cell", "[", 
        RowBox[{
         RowBox[{"TextData", "[", "\"\<TITLEPLACEHOLDER\>\"", "]"}], ",", 
         "\"\<WorkflowTitle\>\"", ",", "\"\<WorkflowDockedCell\>\""}], 
        "]"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->606224123,ExpressionUUID->"f1913aa0-3249-448e-abc9-10bdb470da58"]
}, Closed]],

Cell[CellGroupData[{

Cell["Content Generation", "Section",
 ShowGroupOpener->True,
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellID->600980217,ExpressionUUID->"98b12beb-67d4-49ff-9cdc-05a936dea172"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dynamic", "[", 
  RowBox[{"CurrentValue", "[", 
   RowBox[{"{", 
    RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], "}"}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->208333714,ExpressionUUID->"5a170403-37d6-4847-a86f-53b2ed6880a6"],

Cell[BoxData[
 DynamicBox[ToBoxes[
   CurrentValue[{TaggingRules, "SelectedPlatform"}], StandardForm],
  ImageSizeCache->{16., {0., 10.}}]], "Output",
 CellContext->"Cell$$25520`",
 CellLabel->"Out[7]=",
 CellID->413967391,ExpressionUUID->"b8833248-9cde-4292-91f4-3b371027098e"]
}, Open  ]],

Cell["CONTENT PLACEHOLDER",ExpressionUUID->"feb0eb94-9a2b-4589-9401-706d238bbe60"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Footer Generation", "Section",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellID->41735091,ExpressionUUID->"9dd2c517-fff0-4119-b1c8-869343351721"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Translation", " ", "instructions", " ", "below", " ", "in", " ", "code", 
   " ", 
   RowBox[{"comments", ".", "  ", "Evaluate"}], " ", "all", " ", "inputs", 
   " ", 
   RowBox[{"(", 
    RowBox[{"once", "!"}], ")"}], " ", "in", " ", "this", " ", 
   "\"\<Footer Generation\>\"", " ", "section", " ", "when", " ", 
   "translation", " ", "is", " ", 
   RowBox[{"finished", "."}]}], " ", "*)"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->134734596,ExpressionUUID->"4cd59632-b7b4-4f8f-a09c-1591080cc8c1"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterTopDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->671902962,ExpressionUUID->"d533fb54-15b4-4442-ad87-bd9b8b5c6b35"]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "WorkflowFooterTopDelimiter",
 CellContext->"Cell$$8712`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->105312497,ExpressionUUID->"49762d7d-5829-4c0b-81b7-6c0af686ba53"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Translate", " ", "\"\<See Also\>\"", " ", "in", " ", "this", " ", 
     "input"}], ";", " ", 
    RowBox[{
     RowBox[{"don", "'"}], "t", " ", "translate", " ", 
     RowBox[{"\"\<SEEALSO PLACEHOLDER\>\"", "."}]}]}], "  ", "*)"}], "\n", 
  RowBox[{
   RowBox[{"Cell", "[", 
    RowBox[{"CellGroupData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cell", "[", 
         RowBox[{
         "\"\<\:95a2\:9023\:9805\:76ee\>\"", ",", "\"\<FooterHeader\>\"", ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"CurrentValue", "[", 
            RowBox[{"{", 
             RowBox[{
             "StyleHints", ",", "\"\<WorkflowFooterBackgroundColor\>\""}], 
             "}"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\"\<SEEALSO PLACEHOLDER\>\"", "]"}]}], "}"}], 
      ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->313298683,ExpressionUUID->"23299ba3-fcd1-4794-82fb-dbf378cab098"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\:95a2\:9023\:9805\:76ee", "FooterHeader",
 CellContext->"Cell$$8778`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->97709305,ExpressionUUID->"7ad08efd-d227-4127-8389-8ffd78238220"],

Cell["SEEALSO PLACEHOLDER",
 CellContext->"Cell$$8778`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->20424118,ExpressionUUID->"1460d529-0233-4d9d-b4ef-86d2c6bccff2"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->51221915,ExpressionUUID->"795f4c9d-9c7f-461f-be37-9a09a3ec0689"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$8780`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->88845279,ExpressionUUID->"b5b461a0-dc63-4490-9c16-7609e379a01d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Translate", " ", "\"\<Related Functions\>\"", " ", "in", " ", "this", 
     " ", "input"}], ";", " ", 
    RowBox[{
     RowBox[{"don", "'"}], "t", " ", "translate", " ", 
     RowBox[{"\"\<RELATEDFUNCTIONS PLACEHOLDER\>\"", "."}]}]}], "  ", "*)"}], 
  "\n", 
  RowBox[{
   RowBox[{"Cell", "[", 
    RowBox[{"CellGroupData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cell", "[", 
         RowBox[{
         "\"\<\:95a2\:9023\:3059\:308b\:95a2\:6570\>\"", ",", 
          "\"\<FooterHeader\>\"", ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"CurrentValue", "[", 
            RowBox[{"{", 
             RowBox[{
             "StyleHints", ",", "\"\<WorkflowFooterBackgroundColor\>\""}], 
             "}"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\"\<RELATEDFUNCTIONS PLACEHOLDER\>\"", "]"}]}], 
       "}"}], ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->3537032,ExpressionUUID->"793e9fe1-23c4-4b72-83ba-b23cacb3df6c"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\:95a2\:9023\:3059\:308b\:95a2\:6570", "FooterHeader",
 CellContext->"Cell$$8780`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->231683094,ExpressionUUID->"49205d43-1a26-41c9-ab66-f44739e13e36"],

Cell["RELATEDFUNCTIONS PLACEHOLDER",
 CellContext->"Cell$$8780`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->463588309,ExpressionUUID->"49a922dc-965d-48de-a203-e5449913db8a"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->125738797,ExpressionUUID->"6a4ae0a5-9162-4e25-9061-741ad6512dd1"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$8786`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->124088127,ExpressionUUID->"c5064117-b43e-4047-87f4-2913756711f8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Translate", " ", "\"\<Related Guides\>\"", " ", "in", " ", "this", " ", 
     "input"}], ";", " ", 
    RowBox[{
     RowBox[{"don", "'"}], "t", " ", "translate", " ", 
     RowBox[{"\"\<RELATEDGUIDES PLACEHOLDER\>\"", "."}]}]}], "  ", "*)"}], 
  "\n", 
  RowBox[{
   RowBox[{"Cell", "[", 
    RowBox[{"CellGroupData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cell", "[", 
         RowBox[{
         "\"\<\:95a2\:9023\:3059\:308b\:30ac\:30a4\:30c9\>\"", ",", 
          "\"\<FooterHeader\>\""}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\"\<RELATEDGUIDES PLACEHOLDER\>\"", "]"}]}], 
       "}"}], ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->274272625,ExpressionUUID->"628ffa86-6417-4654-b4f0-1125afcce2ce"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\:95a2\:9023\:3059\:308b\:30ac\:30a4\:30c9", "FooterHeader",
 CellContext->"Cell$$8786`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->1257928,ExpressionUUID->"1461a394-d162-4354-891e-c9d67de3546f"],

Cell["RELATEDGUIDES PLACEHOLDER",
 CellContext->"Cell$$8786`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->309180147,ExpressionUUID->"f8bb28e7-85fc-4a2e-963a-59c85afc8ec9"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->319555874,ExpressionUUID->"633d9567-76e7-4ab9-a431-0b6e1f34c5c1"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$8792`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->760233509,ExpressionUUID->"7419098f-93cc-404f-824b-9885edb3258b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Translate", " ", "\"\<Related Tech Notes\>\"", " ", "in", " ", "this", 
     " ", "input"}], ";", " ", 
    RowBox[{
     RowBox[{"don", "'"}], "t", " ", "translate", " ", 
     RowBox[{"\"\<RELATEDTECHNOTES PLACEHOLDER\>\"", "."}]}]}], " ", "*)"}], 
  "\n", 
  RowBox[{
   RowBox[{"Cell", "[", 
    RowBox[{"CellGroupData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cell", "[", 
         RowBox[{
         "\"\<\:6280\:8853\:7684\:306a\:6ce8\:91c8\>\"", ",", 
          "\"\<FooterHeader\>\""}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\"\<RELATEDTECHNOTES PLACEHOLDER\>\"", "]"}]}], 
       "}"}], ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->133770192,ExpressionUUID->"6569509d-053f-45cf-91cd-a130ec64f202"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\:6280\:8853\:7684\:306a\:6ce8\:91c8", "FooterHeader",
 CellContext->"Cell$$8792`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->55001204,ExpressionUUID->"f7ef36d7-31b7-4786-9a85-cb292a99c2ed"],

Cell["RELATEDTECHNOTES PLACEHOLDER",
 CellContext->"Cell$$8792`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->55721292,ExpressionUUID->"d5dbeef7-7368-4800-be35-3071ff927ab0"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->647333165,ExpressionUUID->"f1c662a7-911f-46ce-b423-a4fe2bdb7b3d"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$8798`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->908982495,ExpressionUUID->"9e3ae0f3-b1f4-4e96-8857-a6110697a18a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Translate", " ", "\"\<Related Links\>\"", " ", "in", " ", "this", " ", 
     "input"}], ";", " ", 
    RowBox[{
     RowBox[{"don", "'"}], "t", " ", "translate", " ", 
     RowBox[{"\"\<RELATEDLINKS PLACEHOLDER\>\"", "."}]}]}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{"Cell", "[", 
    RowBox[{"CellGroupData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cell", "[", 
         RowBox[{
         "\"\<\:95a2\:9023\:30ea\:30f3\:30af\>\"", ",", " ", 
          "\"\<FooterHeader\>\""}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\"\<RELATEDLINKS PLACEHOLDER\>\"", "]"}]}], 
       "}"}], ",", " ", "Open"}], "]"}], "]"}], "//", 
   "CellPrint"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->176273973,ExpressionUUID->"47ac16fb-f5ab-4775-b91b-1cb2af7bea38"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\:95a2\:9023\:30ea\:30f3\:30af", "FooterHeader",
 CellContext->"Cell$$8798`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->777198478,ExpressionUUID->"96de3149-9466-49c4-85da-a57fe39d1eab"],

Cell["RELATEDLINKS PLACEHOLDER",
 CellContext->"Cell$$8798`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->9621463,ExpressionUUID->"3a42fb0c-4890-491f-803f-d634471f846c"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterBottomDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->137855366,ExpressionUUID->"201c54ec-00b3-4d16-b236-28d3da45446d"]
}, Open  ]],

Cell["", "WorkflowFooterBottomDelimiter",
 CellContext->"Cell$$8804`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->340697842,ExpressionUUID->"550d5820-13c6-4165-bafa-bf9ae92a2af8"]
},
WindowSize->{808, 911},
WindowMargins->{{254, Automatic}, {Automatic, 27}},
DockedCells->{
  Cell[
   BoxData[
    PanelBox[
     StyleBox[
      TemplateBox[{
        StyleBox[
         GraphicsBox[{}, ImageSize -> {9, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        TemplateBox[{
          TooltipBox[
           DynamicModuleBox[{$CellContext`destination$$ = 0}, 
            DynamicBox[
             FEPrivate`If[FEPrivate`HistoryList["Back"] === {}, 
              ButtonBox[
               DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "DisabledBackIcon.png"]]], Enabled -> False, Appearance -> 
               None, FrameMargins -> 0], 
              ButtonBox[
               PaneSelectorBox[{True -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "BackIconHot.png"]]], False -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "BackIcon.png"]]]}, 
                Dynamic[
                 CurrentValue["MouseOver"]]], ButtonFunction :> 
               FrontEndToken[
                 FrontEnd`ButtonNotebook[], "HyperlinkGoBack"], Evaluator -> 
               None, Appearance -> None, FrameMargins -> 0]]], 
            DynamicModuleValues :> {}], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipBack"]]], 
          StyleBox[
           GraphicsBox[{}, ImageSize -> {2, 0}, BaselinePosition -> Baseline],
            "CacheGraphics" -> False], 
          TooltipBox[
           DynamicModuleBox[{$CellContext`destination$$ = 0}, 
            DynamicBox[
             FEPrivate`If[FEPrivate`HistoryList["Forward"] === {}, 
              ButtonBox[
               DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "DisabledForwardIcon.png"]]], Enabled -> False, Appearance -> 
               None, FrameMargins -> 0], 
              ButtonBox[
               PaneSelectorBox[{True -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "ForwardIconHot.png"]]], False -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "ForwardIcon.png"]]]}, 
                Dynamic[
                 CurrentValue["MouseOver"]]], ButtonFunction :> 
               FrontEndToken[
                 FrontEnd`ButtonNotebook[], "HyperlinkGoForward"], Evaluator -> 
               None, Appearance -> None, FrameMargins -> 0]]], 
            DynamicModuleValues :> {}], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipForward"]]], 
          TooltipBox[
           DynamicBox[
            ToBoxes[
             FEPrivate`GenerateHelpViewerActionMenu[], StandardForm]], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipHistory"]]], 
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {13, 0}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          TooltipBox[
           ButtonBox[
            PaneSelectorBox[{True -> DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "HomeIconHot.png"]]], False -> DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "HomeIcon.png"]]]}, 
             Dynamic[
              CurrentValue["MouseOver"]]], ButtonFunction :> 
            Documentation`HelpLookup[
              CurrentValue[HomePage], 
              FrontEnd`ButtonNotebook[], 
              CurrentValue[Language]], Appearance -> None, Evaluator -> 
            Automatic, Method -> "Preemptive"], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipHome"]]]}, 
         "RowDefault"], 
        StyleBox[
         GraphicsBox[{}, ImageSize -> {39, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        FrameBox[
         StyleBox[
          DynamicBox[
           FEPrivate`FrontEndResource[
           "FEExpressions", "HelpViewerSearchField"]], 
          InputFieldBoxOptions -> {
           ImageSize -> Dynamic[AbsoluteCurrentValue[{WindowSize, 1}] - 220], 
            FrameMargins -> 
            FEPrivate`Switch[
             FEPrivate`$OperatingSystem, "MacOSX", {{3, 3}, {0, -1}}, 
              "Windows", {{0, 2}, {0, 2}}, 
              Blank[], {{2, 2}, {0, 0}}]}], FrameStyle -> None, 
         FrameMargins -> {{0, 0}, {4, 0}}], 
        StyleBox[
         GraphicsBox[{}, ImageSize -> {12, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        TooltipBox[
         ButtonBox[
          PaneSelectorBox[{True -> DynamicBox[
              FEPrivate`ImportImage[
               
               FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                "RevertIconHot.png"]]], False -> DynamicBox[
              FEPrivate`ImportImage[
               
               FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                "RevertIcon.png"]]]}, 
           Dynamic[
            CurrentValue["MouseOver"]]], ButtonFunction :> FrontEndToken[
            FrontEnd`ButtonNotebook[], "Revert", False], Evaluator -> None, 
          Appearance -> None, Method -> "Preemptive"], 
         DynamicBox[
          FEPrivate`FrontEndResource["HelpToolbarText", "TooltipRefresh"]]]}, 
       "RowDefault"], CacheGraphics -> False, 
      ButtonBoxOptions -> {BaselinePosition -> (Baseline -> Baseline)}], 
     Alignment -> {Left, Center}, Appearance -> Image[CompressedData["
1:eJztyDkKAkEUhOFGE0OvIHgIU0PTEQ8ww7SDSQs9gnhXl3HBfbmC7Q0qeWDw
f1CPqtcr5tm05ZyrO+lk+XIYY74ad9OYhHpWBV+OwsJXPg6Kdnr2U8qUX/8A
AAAA+HtvyF6AgSdg4AHZHbIbYOAKGLhAdobsBBg4QnaAbA9ZAxjYAQa2gIEN
ZGvIvp8pRMU=
       "], "Byte", ColorSpace -> "RGB", Interleaving -> True], 
     ImageSize -> {
       Scaled[1], Full}]], "DockedCell", CellFrame -> 0, 
   CellMargins -> {{0, -10}, {-2, -1}}, CellFrameMargins -> {{0, 0}, {0, 0}}, 
   ShowCodeAssist -> False, Background -> None], 
  Cell[
   BoxData[
    DynamicBox[
     FEPrivate`If[FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "SearchTextTranslated"},
         ""] === "", "", 
      StyleBox[
       RowBox[{
         ButtonBox[
          DynamicBox[
           DynamicBox[
            FEPrivate`ImportImage[
             
             FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
              "SearchIcon.png"]]]], ButtonData :> FEPrivate`StringJoin[
            FrontEnd`CurrentValue[
             FrontEnd`EvaluationNotebook[], {
             TaggingRules, "SearchTextTranslated"}, ""], " start:1"], 
          BaseStyle -> {
           "Link", FontWeight -> "Bold", 
            FontVariations -> {"Underline" -> True}}, ButtonNote -> ""], 
         "   ", 
         DynamicBox[
          FEPrivate`FrontEndResource["HelpToolbarText", "SearchString1"]], 
         "\[InvisibleSpace]", 
         ButtonBox[
          DynamicBox[
           FrontEnd`CurrentValue[
            FrontEnd`EvaluationNotebook[], {
            TaggingRules, "SearchTextTranslated"}, ""]], ButtonData :> 
          FEPrivate`StringJoin[
            FrontEnd`CurrentValue[
             FrontEnd`EvaluationNotebook[], {
             TaggingRules, "SearchTextTranslated"}, ""], " start:1"], 
          BaseStyle -> {
           "Link", FontWeight -> "Bold", 
            FontVariations -> {"Underline" -> True}}, ButtonNote -> ""], 
         "\[InvisibleSpace]", 
         DynamicBox[
          FEPrivate`FrontEndResource["HelpToolbarText", "SearchString2"]]}], 
       FontSize -> 11]], ImageSizeCache -> {4., {0., 0.}}]], "DockedCell", 
   "ControlStyle", CellFrame -> Dynamic[
     FEPrivate`If[
      FEPrivate`UnsameQ[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], 
       ""], {{0, 0}, {3, 0}}, {{0, 0}, {0, 0}}]], 
   CellMargins -> {{0, -10}, {0, -1}}, CellOpen -> 
   Dynamic[FrontEnd`CurrentValue[
       FrontEnd`EvaluationNotebook[], {TaggingRules, "SearchTextTranslated"}, 
       ""] =!= ""], CellFrameMargins -> {{146, 5}, {3, 0}}, CellFrameColor -> 
   Dynamic[
     FEPrivate`If[
      FEPrivate`SameQ[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], ""], 
      CurrentValue["ToolbarBackground"], 
      FEPrivate`Switch[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "ColorType"}], 
       "SymbolColor", 
       RGBColor[0.481193, 0.528023, 0.813489], "GuideColor", 
       RGBColor[1, 0.6, 0], "TutorialColor", 
       RGBColor[0.641154, 0.223011, 0.0623026], "RootColor", 
       RGBColor[1, 0, 0], 
       Blank[], 
       GrayLevel[0.8]]]], ShowCodeAssist -> False, LineIndent -> 0, 
   LinebreakAdjustments -> {1, 10, 0, 100, 0}, Background -> 
   GrayLevel[0.8627450980392157]], 
  Cell[
   BoxData[
    DynamicBox[
     FrontEnd`CurrentValue[
      FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], 
     ImageSizeCache -> {4., {0., 0.}}]], "DockedLinkTrail", CellOpen -> 
   Dynamic[FrontEnd`CurrentValue[
       FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""] =!= 
     ""], CellFrameColor -> Dynamic[
     FEPrivate`If[
      FEPrivate`UnsameQ[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], ""], 
      GrayLevel[0.8], 
      FEPrivate`Switch[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "ColorType"}], 
       "SymbolColor", 
       RGBColor[0.481193, 0.528023, 0.813489], "GuideColor", 
       RGBColor[1, 0.6, 0], "TutorialColor", 
       RGBColor[0.641154, 0.223011, 0.0623026], "RootColor", 
       RGBColor[1, 0, 0], 
       Blank[], 
       GrayLevel[0.8]]]], ShowCodeAssist -> False], 
  Cell[
   BoxData[
    GridBox[{{
       GridBox[{{
          ItemBox[
           Cell[
            BoxData[
             RowBox[{
               InterpretationBox[
                StyleBox[
                 
                 GraphicsBox[{}, BaselinePosition -> Baseline, 
                  ImageSize -> {8, 0}], CacheGraphics -> False], 
                Spacer[8], Selectable -> False], 
               Cell["WORKFLOW", "PacletNameCell", TextAlignment -> Center], 
               InterpretationBox[
                StyleBox[
                 
                 GraphicsBox[{}, BaselinePosition -> Baseline, 
                  ImageSize -> {8, 0}], CacheGraphics -> False], 
                Spacer[8], Selectable -> False]}]], TextAlignment -> Center], 
           Background -> RGBColor[0.2157, 0.6588, 0.6745], ItemSize -> Full], 
          ""}}, GridBoxAlignment -> {"Rows" -> {{Center}}}, 
        GridBoxItemSize -> {"Columns" -> {Full, 
            Scaled[0.02]}, "Rows" -> {{2.5}}}], 
       Cell[
        BoxData[
         GridBox[{{
            Cell["MENUPLACEHOLDER"]}}]], "AnchorBar"]}}]], "AnchorBarGrid", 
   "WorkflowDockedCell"], 
  Cell[
   TextData["TITLEPLACEHOLDER"], "WorkflowTitle", "WorkflowDockedCell"]},
TaggingRules->{
 "DocuToolsSettingsInternal" -> {
   "$PacletVersion" -> "0.9.2018", "$MVersion" -> "11.2", "$FlaggedVersion" -> 
    11.1, "$ApplicationName" -> "Pubs", "$LinkBase" -> "Pubs", 
    "$ApplicationDirectory" -> "C:\\Workspace\\Pubs\\", 
    "$DocumentationDirectory" -> 
    "C:\\Workspace\\Pubs\\Documentation\\English\\", "$UseNewPageDialog" -> 
    ""}, "ChatTools" -> {
   "Contacts" -> {
     "andre@wolfram.com", "bradym@wolfram.com", "brady@wolfram.com", 
      "chatframework@wolfram.com", "jayw@wolfram.com", 
      "s.wolfram@wolfram.com", "sw@wolfram.com"}}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> "", "SelectedPlatform" -> "All"},
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (February 12, 2019)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> 
     FrontEnd`FileName[{"Wolfram"}, "Reference-ja.nb", CharacterEncoding -> 
       "UTF-8"]]], 
   Cell[
    StyleData["Input"], CellContext -> Notebook, FontFamily -> 
    "Source Sans Pro", FontSize -> 14], 
   Cell[
    StyleData["StandardForm"], FontFamily -> "Source Sans Pro"], 
   Cell[
    StyleData["Output"], CellContext -> Notebook, FontFamily -> 
    "Source Sans Pro", FontSize -> 14]}, Visible -> False, FrontEndVersion -> 
  "12.0 for Microsoft Windows (64-bit) (February 12, 2019)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 185, 4, 35, "Text",ExpressionUUID->"942b9a7c-e08a-41a4-8f01-5d48a517617b",
 CellID->90280312],
Cell[CellGroupData[{
Cell[768, 28, 188, 4, 70, "Section",ExpressionUUID->"f25c98b0-296f-471f-9610-59a12cd83129",
 CellID->9074762],
Cell[959, 34, 349, 8, 26, "Input",ExpressionUUID->"fce7574c-c8f3-4711-bbf7-0f8e2c63d187"],
Cell[1311, 44, 1066, 26, 75, "Input",ExpressionUUID->"47ecc42b-76c1-4f7b-8ebd-cb5a8c4bf452"],
Cell[2380, 72, 296, 7, 26, "Input",ExpressionUUID->"d7c4ac6b-fba9-42c3-ab29-e89be9f029ec",
 CellID->267713489],
Cell[2679, 81, 375, 10, 26, "Input",ExpressionUUID->"b9d09364-cc74-461c-be4a-492cf8c6a35b",
 CellID->133403045],
Cell[3057, 93, 281, 8, 26, "Input",ExpressionUUID->"15766225-eb0d-4e6f-b830-0e17ec981ab0",
 CellID->17199079],
Cell[3341, 103, 5500, 117, 507, "Input",ExpressionUUID->"f1913aa0-3249-448e-abc9-10bdb470da58",
 CellID->606224123]
}, Closed]],
Cell[CellGroupData[{
Cell[8878, 225, 186, 4, 50, "Section",ExpressionUUID->"98b12beb-67d4-49ff-9cdc-05a936dea172",
 CellID->600980217],
Cell[CellGroupData[{
Cell[9089, 233, 283, 7, 30, "Input",ExpressionUUID->"5a170403-37d6-4847-a86f-53b2ed6880a6",
 CellID->208333714],
Cell[9375, 242, 278, 6, 39, "Output",ExpressionUUID->"b8833248-9cde-4292-91f4-3b371027098e",
 CellID->413967391]
}, Open  ]],
Cell[9668, 251, 82, 0, 23, InheritFromParent,ExpressionUUID->"feb0eb94-9a2b-4589-9401-706d238bbe60"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9787, 256, 160, 3, 70, "Section",ExpressionUUID->"9dd2c517-fff0-4119-b1c8-869343351721",
 CellID->41735091],
Cell[9950, 261, 552, 13, 51, "Input",ExpressionUUID->"4cd59632-b7b4-4f8f-a09c-1591080cc8c1",
 CellID->134734596],
Cell[10505, 276, 258, 6, 30, "Input",ExpressionUUID->"d533fb54-15b4-4442-ad87-bd9b8b5c6b35",
 CellID->671902962]
}, Open  ]],
Cell[CellGroupData[{
Cell[10800, 287, 190, 4, 6, "WorkflowFooterTopDelimiter",ExpressionUUID->"49762d7d-5829-4c0b-81b7-6c0af686ba53",
 CellID->105312497],
Cell[10993, 293, 1082, 28, 91, "Input",ExpressionUUID->"23299ba3-fcd1-4794-82fb-dbf378cab098",
 CellID->313298683]
}, Open  ]],
Cell[CellGroupData[{
Cell[12112, 326, 199, 4, 50, "FooterHeader",ExpressionUUID->"7ad08efd-d227-4127-8389-8ffd78238220",
 CellID->97709305],
Cell[12314, 332, 178, 4, 23, InheritFromParent,ExpressionUUID->"1460d529-0233-4d9d-b4ef-86d2c6bccff2",
 CellID->20424118],
Cell[12495, 338, 254, 6, 30, "Input",ExpressionUUID->"795f4c9d-9c7f-461f-be37-9a09a3ec0689",
 CellID->51221915],
Cell[12752, 346, 186, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"b5b461a0-dc63-4490-9c16-7609e379a01d",
 CellID->88845279],
Cell[12941, 352, 1134, 30, 91, "Input",ExpressionUUID->"793e9fe1-23c4-4b72-83ba-b23cacb3df6c",
 CellID->3537032]
}, Open  ]],
Cell[CellGroupData[{
Cell[14112, 387, 212, 4, 50, "FooterHeader",ExpressionUUID->"49205d43-1a26-41c9-ab66-f44739e13e36",
 CellID->231683094],
Cell[14327, 393, 188, 4, 23, InheritFromParent,ExpressionUUID->"49a922dc-965d-48de-a203-e5449913db8a",
 CellID->463588309],
Cell[14518, 399, 255, 6, 30, "Input",ExpressionUUID->"6a4ae0a5-9162-4e25-9061-741ad6512dd1",
 CellID->125738797],
Cell[14776, 407, 187, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"c5064117-b43e-4047-87f4-2913756711f8",
 CellID->124088127],
Cell[14966, 413, 889, 24, 71, "Input",ExpressionUUID->"628ffa86-6417-4654-b4f0-1125afcce2ce",
 CellID->274272625]
}, Open  ]],
Cell[CellGroupData[{
Cell[15892, 442, 216, 4, 50, "FooterHeader",ExpressionUUID->"1461a394-d162-4354-891e-c9d67de3546f",
 CellID->1257928],
Cell[16111, 448, 185, 4, 23, InheritFromParent,ExpressionUUID->"f8bb28e7-85fc-4a2e-963a-59c85afc8ec9",
 CellID->309180147],
Cell[16299, 454, 255, 6, 30, "Input",ExpressionUUID->"633d9567-76e7-4ab9-a431-0b6e1f34c5c1",
 CellID->319555874],
Cell[16557, 462, 187, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"7419098f-93cc-404f-824b-9885edb3258b",
 CellID->760233509],
Cell[16747, 468, 892, 24, 71, "Input",ExpressionUUID->"6569509d-053f-45cf-91cd-a130ec64f202",
 CellID->133770192]
}, Open  ]],
Cell[CellGroupData[{
Cell[17676, 497, 211, 4, 50, "FooterHeader",ExpressionUUID->"f7ef36d7-31b7-4786-9a85-cb292a99c2ed",
 CellID->55001204],
Cell[17890, 503, 187, 4, 23, InheritFromParent,ExpressionUUID->"d5dbeef7-7368-4800-be35-3071ff927ab0",
 CellID->55721292],
Cell[18080, 509, 255, 6, 30, "Input",ExpressionUUID->"f1c662a7-911f-46ce-b423-a4fe2bdb7b3d",
 CellID->647333165],
Cell[18338, 517, 187, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"9e3ae0f3-b1f4-4e96-8857-a6110697a18a",
 CellID->908982495],
Cell[18528, 523, 884, 24, 71, "Input",ExpressionUUID->"47ac16fb-f5ab-4775-b91b-1cb2af7bea38",
 CellID->176273973]
}, Open  ]],
Cell[CellGroupData[{
Cell[19449, 552, 206, 4, 50, "FooterHeader",ExpressionUUID->"96de3149-9466-49c4-85da-a57fe39d1eab",
 CellID->777198478],
Cell[19658, 558, 182, 4, 23, InheritFromParent,ExpressionUUID->"3a42fb0c-4890-491f-803f-d634471f846c",
 CellID->9621463],
Cell[19843, 564, 261, 6, 30, "Input",ExpressionUUID->"201c54ec-00b3-4d16-b236-28d3da45446d",
 CellID->137855366]
}, Open  ]],
Cell[20119, 573, 193, 4, 20, "WorkflowFooterBottomDelimiter",ExpressionUUID->"550d5820-13c6-4165-bafa-bf9ae92a2af8",
 CellID->340697842]
}
]
*)

