(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     38342,        991]
NotebookOptionsPosition[     20200,        577]
NotebookOutlinePosition[     33348,        895]
CellTagsIndexPosition[     33305,        892]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\
ALL INPUT AND SECTION CELLS ARE REMOVED BEFORE CONTENT IS INSERTED\
\>", "Text",
 FontWeight->"Bold",
 CellID->90280312,ExpressionUUID->"942b9a7c-e08a-41a4-8f01-5d48a517617b"],

Cell[CellGroupData[{

Cell["Docked Cell Generation", "Section",
 ShowGroupOpener->True,
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellID->9074762,ExpressionUUID->"f25c98b0-296f-471f-9610-59a12cd83129"],

Cell[BoxData[
 RowBox[{"SetOptions", "[", 
  RowBox[{
   RowBox[{"InputNotebook", "[", "]"}], ",", 
   RowBox[{
   "StyleDefinitions", "\[Rule]", "\"\<Wolfram\\\\Reference.nb\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.704034031534266*^9, 3.704034044245511*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"fce7574c-c8f3-4711-bbf7-0f8e2c63d187"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{
    RowBox[{"BoxData", "[", 
     RowBox[{"GridBox", "[", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Cell", "[", 
          RowBox[{"\"\<WORKFLOW\>\"", ",", "\"\<PacletNameCell\>\"", ",", 
           RowBox[{"TextAlignment", "\[Rule]", "Center"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"0.2157", ",", "0.6588", ",", "0.6745"}], "]"}]}]}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Cell", "[", 
          RowBox[{
           RowBox[{"BoxData", "[", 
            RowBox[{"GridBox", "[", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"Cell", "[", "\"\<MENUPLACEHOLDER\>\"", "]"}], "}"}], 
              "}"}], "]"}], "]"}], ",", "\"\<AnchorBar\>\""}], "]"}]}], "}"}],
        "}"}], "]"}], "]"}], ",", "\"\<AnchorBarGrid\>\""}], "]"}], "//", 
  "CellPrint"}]], "Input",
 CellLabel->"In[4]:=",ExpressionUUID->"47ecc42b-76c1-4f7b-8ebd-cb5a8c4bf452"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{
    RowBox[{"TextData", "[", "\"\<TITLEPLACEHOLDER\>\"", "]"}], ",", 
    "\"\<WorkflowTitle\>\""}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->267713489,ExpressionUUID->"d7c4ac6b-fba9-42c3-ab29-e89be9f029ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{"BoxData", "[", 
    RowBox[{"GridBox", "[", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"Cell", "[", "\"\<TABSPLACEHOLDER\>\"", "]"}], "}"}], "}"}], 
     "]"}], "]"}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->133403045,ExpressionUUID->"b9d09364-cc74-461c-be4a-492cf8c6a35b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dc", "=", 
   RowBox[{"CurrentValue", "[", 
    RowBox[{
     RowBox[{"InputNotebook", "[", "]"}], ",", "DockedCells"}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->17199079,ExpressionUUID->"15766225-eb0d-4e6f-b830-0e17ec981ab0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CurrentValue", "[", 
    RowBox[{
     RowBox[{"InputNotebook", "[", "]"}], ",", "DockedCells"}], "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{"dc", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{
         RowBox[{"BoxData", "[", 
          RowBox[{"GridBox", "[", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"GridBox", "[", 
               RowBox[{
                RowBox[{"{", "\n", "      ", 
                 RowBox[{"{", "\n", "       ", 
                  RowBox[{
                   RowBox[{"ItemBox", "[", 
                    RowBox[{
                    RowBox[{"Cell", "[", 
                    RowBox[{
                    RowBox[{"BoxData", "[", "\n", "         ", 
                    RowBox[{"RowBox", "[", 
                    RowBox[{"{", "\n", "          ", 
                    RowBox[{
                    RowBox[{"InterpretationBox", "[", "\n", "           ", 
                    RowBox[{
                    RowBox[{"StyleBox", "[", "\n", "            ", 
                    RowBox[{
                    RowBox[{"GraphicsBox", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", "\n", "             ", 
                    RowBox[{"BaselinePosition", "->", "Baseline"}], ",", "\n",
                     "             ", 
                    RowBox[{"ImageSize", "->", 
                    RowBox[{"{", 
                    RowBox[{"8", ",", " ", "0"}], "}"}]}]}], "]"}], ",", "\n",
                     "            ", 
                    RowBox[{"CacheGraphics", "->", "False"}]}], "]"}], ",", 
                    "\n", "           ", 
                    RowBox[{"Spacer", "[", "8", "]"}], ",", "\n", 
                    "           ", 
                    RowBox[{"Selectable", "->", "False"}]}], "]"}], ",", " ", 
                    
                    RowBox[{"Cell", "[", 
                    RowBox[{"\"\<WORKFLOW\>\"", ",", " ", 
                    "\"\<PacletNameCell\>\"", ",", "\n", "           ", 
                    RowBox[{"TextAlignment", "->", "Center"}]}], "]"}], ",", 
                    " ", "\n", "          ", 
                    RowBox[{"InterpretationBox", "[", "\n", "           ", 
                    RowBox[{
                    RowBox[{"StyleBox", "[", "\n", "            ", 
                    RowBox[{
                    RowBox[{"GraphicsBox", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", "\n", "             ", 
                    RowBox[{"BaselinePosition", "->", "Baseline"}], ",", "\n",
                     "             ", 
                    RowBox[{"ImageSize", "->", 
                    RowBox[{"{", 
                    RowBox[{"8", ",", " ", "0"}], "}"}]}]}], "]"}], ",", "\n",
                     "            ", 
                    RowBox[{"CacheGraphics", "->", "False"}]}], "]"}], ",", 
                    "\n", "           ", 
                    RowBox[{"Spacer", "[", "8", "]"}], ",", "\n", 
                    "           ", 
                    RowBox[{"Selectable", "->", "False"}]}], "]"}]}], "}"}], 
                    "]"}], "]"}], ",", "\n", "         ", 
                    RowBox[{"TextAlignment", "->", "Center"}]}], "]"}], ",", 
                    "\n", "        ", 
                    RowBox[{"Background", "->", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{
                    "0.2157", ",", " ", "0.6588", ",", " ", "0.6745"}], 
                    "]"}]}], ",", "\n", "        ", 
                    RowBox[{"ItemSize", "->", "Full"}]}], "]"}], ",", " ", 
                   "\"\<\>\""}], "}"}], "\n", "     ", "}"}], ",", "\n", 
                "     ", 
                RowBox[{"GridBoxAlignment", "->", 
                 RowBox[{"{", 
                  RowBox[{"\"\<Rows\>\"", " ", "->", " ", 
                   RowBox[{"{", 
                    RowBox[{"{", "Center", "}"}], "}"}]}], "}"}]}], ",", "\n",
                 "     ", 
                RowBox[{"GridBoxItemSize", "->", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"\"\<Columns\>\"", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{"Full", ",", " ", "\n", "         ", 
                    RowBox[{"Scaled", "[", "0.02", "]"}]}], "}"}]}], ",", " ", 
                   RowBox[{"\"\<Rows\>\"", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{"{", "2.5", "}"}], "}"}]}]}], "}"}]}]}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"Cell", "[", 
               RowBox[{
                RowBox[{"BoxData", "[", 
                 RowBox[{"GridBox", "[", 
                  RowBox[{"{", 
                   RowBox[{"{", 
                    RowBox[{"Cell", "[", "\"\<MENUPLACEHOLDER\>\"", "]"}], 
                    "}"}], "}"}], "]"}], "]"}], ",", "\"\<AnchorBar\>\""}], 
               "]"}]}], "}"}], "}"}], "]"}], "]"}], ",", 
         "\"\<AnchorBarGrid\>\"", ",", "\"\<WorkflowDockedCell\>\""}], "]"}], 
       ",", 
       RowBox[{"Cell", "[", 
        RowBox[{
         RowBox[{"TextData", "[", "\"\<TITLEPLACEHOLDER\>\"", "]"}], ",", 
         "\"\<WorkflowTitle\>\"", ",", "\"\<WorkflowDockedCell\>\""}], 
        "]"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->606224123,ExpressionUUID->"f1913aa0-3249-448e-abc9-10bdb470da58"]
}, Closed]],

Cell[CellGroupData[{

Cell["Content Generation", "Section",
 ShowGroupOpener->True,
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellID->600980217,ExpressionUUID->"98b12beb-67d4-49ff-9cdc-05a936dea172"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dynamic", "[", 
  RowBox[{"CurrentValue", "[", 
   RowBox[{"{", 
    RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], "}"}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->208333714,ExpressionUUID->"5a170403-37d6-4847-a86f-53b2ed6880a6"],

Cell[BoxData[
 DynamicBox[ToBoxes[
   CurrentValue[{TaggingRules, "SelectedPlatform"}], StandardForm],
  ImageSizeCache->{16., {0., 10.}}]], "Output",
 CellContext->"Cell$$25520`",
 CellLabel->"Out[7]=",
 CellID->413967391,ExpressionUUID->"b8833248-9cde-4292-91f4-3b371027098e"]
}, Open  ]],

Cell["CONTENT PLACEHOLDER",ExpressionUUID->"feb0eb94-9a2b-4589-9401-706d238bbe60"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Footer Generation", "Section",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellID->41735091,ExpressionUUID->"a3d70873-eb14-48c3-a0f9-52640790f721"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Translation", " ", "instructions", " ", "below", " ", "in", " ", "code", 
   " ", 
   RowBox[{"comments", ".", "  ", "Evaluate"}], " ", "all", " ", "inputs", 
   " ", 
   RowBox[{"(", 
    RowBox[{"once", "!"}], ")"}], " ", "in", " ", "this", " ", 
   "\"\<Footer Generation\>\"", " ", "section", " ", "when", " ", 
   "translation", " ", "is", " ", 
   RowBox[{"finished", "."}]}], " ", "*)"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->134734596,ExpressionUUID->"5750a12b-7ff0-4694-909d-195c7331a511"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterTopDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->671902962,ExpressionUUID->"e602b226-b6bd-4ad7-a98f-b19df16a40b4"]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "WorkflowFooterTopDelimiter",
 CellContext->"Cell$$5148`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->3198045,ExpressionUUID->"d22f4894-35e8-41c8-8f62-e2c98e50198d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Translate", " ", "\"\<See Also\>\"", " ", "in", " ", "this", " ", 
     "input"}], ";", " ", 
    RowBox[{
     RowBox[{"don", "'"}], "t", " ", "translate", " ", 
     RowBox[{"\"\<SEEALSO PLACEHOLDER\>\"", "."}]}]}], "  ", "*)"}], "\n", 
  RowBox[{
   RowBox[{"Cell", "[", 
    RowBox[{"CellGroupData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cell", "[", 
         RowBox[{"\"\<\:53c2\:89c1\>\"", ",", "\"\<FooterHeader\>\"", ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"CurrentValue", "[", 
            RowBox[{"{", 
             RowBox[{
             "StyleHints", ",", "\"\<WorkflowFooterBackgroundColor\>\""}], 
             "}"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\"\<SEEALSO PLACEHOLDER\>\"", "]"}]}], "}"}], 
      ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->313298683,ExpressionUUID->"ed7a3169-2358-47f2-a45b-9c925eee9670"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\:53c2\:89c1", "FooterHeader",
 CellContext->"Cell$$6372`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->676218911,ExpressionUUID->"b791da9d-85af-4e19-a6dc-aafe453fa360"],

Cell["SEEALSO PLACEHOLDER",
 CellContext->"Cell$$6372`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->349308439,ExpressionUUID->"d8b63790-3e76-47a3-b43e-9c0d63526749"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->51221915,ExpressionUUID->"5710bf6d-0c02-4516-8098-5533775a039a"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$6374`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->252607947,ExpressionUUID->"b2d90305-df92-4eec-8e5a-a8fb92a6f767"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Translate", " ", "\"\<Related Functions\>\"", " ", "in", " ", "this", 
     " ", "input"}], ";", " ", 
    RowBox[{
     RowBox[{"don", "'"}], "t", " ", "translate", " ", 
     RowBox[{"\"\<RELATEDFUNCTIONS PLACEHOLDER\>\"", "."}]}]}], "  ", "*)"}], 
  "\n", 
  RowBox[{
   RowBox[{"Cell", "[", 
    RowBox[{"CellGroupData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cell", "[", 
         RowBox[{
         "\"\<\:76f8\:5173\:51fd\:6570\>\"", ",", "\"\<FooterHeader\>\"", ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"CurrentValue", "[", 
            RowBox[{"{", 
             RowBox[{
             "StyleHints", ",", "\"\<WorkflowFooterBackgroundColor\>\""}], 
             "}"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\"\<RELATEDFUNCTIONS PLACEHOLDER\>\"", "]"}]}], 
       "}"}], ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->3537032,ExpressionUUID->"68eead07-db01-4627-9874-8d085b3d3f87"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\:76f8\:5173\:51fd\:6570", "FooterHeader",
 CellContext->"Cell$$6374`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->273419540,ExpressionUUID->"f6a77348-d716-4e8b-bc8f-ddb1c9200d30"],

Cell["RELATEDFUNCTIONS PLACEHOLDER",
 CellContext->"Cell$$6374`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->560026731,ExpressionUUID->"0801536d-7afe-41a5-b3bd-e9dfdb376dff"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->125738797,ExpressionUUID->"de6b331e-0d68-4d59-9d90-46f1c521afe6"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$6380`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->271915205,ExpressionUUID->"d6793922-3e0f-4cbd-bf16-0d5f4c7ff346"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Translate", " ", "\"\<Related Guides\>\"", " ", "in", " ", "this", " ", 
     "input"}], ";", " ", 
    RowBox[{
     RowBox[{"don", "'"}], "t", " ", "translate", " ", 
     RowBox[{"\"\<RELATEDGUIDES PLACEHOLDER\>\"", "."}]}]}], "  ", "*)"}], 
  "\n", 
  RowBox[{
   RowBox[{"Cell", "[", 
    RowBox[{"CellGroupData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cell", "[", 
         RowBox[{
         "\"\<\:76f8\:5173\:6307\:5357\>\"", ",", "\"\<FooterHeader\>\""}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\"\<RELATEDGUIDES PLACEHOLDER\>\"", "]"}]}], 
       "}"}], ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->274272625,ExpressionUUID->"f120c0d1-6676-45f4-89b0-1b2c64b3efbe"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\:76f8\:5173\:6307\:5357", "FooterHeader",
 CellContext->"Cell$$6380`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->149881907,ExpressionUUID->"7be06bf1-91ec-4704-a8b2-a861344a916e"],

Cell["RELATEDGUIDES PLACEHOLDER",
 CellContext->"Cell$$6380`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->9972972,ExpressionUUID->"4b294a6e-c6f5-4186-bd02-de41f7035445"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->319555874,ExpressionUUID->"15608a54-e8b3-42ee-8e73-5478be8440e2"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$6386`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->61818264,ExpressionUUID->"76fe86e0-ce7c-41b4-b327-63eabd64b549"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Translate", " ", "\"\<Related Tech Notes\>\"", " ", "in", " ", "this", 
     " ", "input"}], ";", " ", 
    RowBox[{
     RowBox[{"don", "'"}], "t", " ", "translate", " ", 
     RowBox[{"\"\<RELATEDTECHNOTES PLACEHOLDER\>\"", "."}]}]}], " ", "*)"}], 
  "\n", 
  RowBox[{
   RowBox[{"Cell", "[", 
    RowBox[{"CellGroupData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cell", "[", 
         RowBox[{
         "\"\<\:76f8\:5173\:6280\:672f\:8981\:70b9\>\"", ",", 
          "\"\<FooterHeader\>\""}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\"\<RELATEDTECHNOTES PLACEHOLDER\>\"", "]"}]}], 
       "}"}], ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->133770192,ExpressionUUID->"f238b63b-55bb-4316-b3d7-5d6a83af5102"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\:76f8\:5173\:6280\:672f\:8981\:70b9", "FooterHeader",
 CellContext->"Cell$$6386`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->204690158,ExpressionUUID->"56617de6-5128-4c03-b1ea-51a75f28ac19"],

Cell["RELATEDTECHNOTES PLACEHOLDER",
 CellContext->"Cell$$6386`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->93057085,ExpressionUUID->"ce20df4c-427a-4eb0-b441-a27151d2bdd6"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->647333165,ExpressionUUID->"d4011a13-92b6-4c8d-a444-12a4e5a8bae0"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$6392`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->115391304,ExpressionUUID->"97dbd05e-8bef-47c1-b8b4-8a7e44d28c20"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Translate", " ", "\"\<Related Links\>\"", " ", "in", " ", "this", " ", 
     "input"}], ";", " ", 
    RowBox[{
     RowBox[{"don", "'"}], "t", " ", "translate", " ", 
     RowBox[{"\"\<RELATEDLINKS PLACEHOLDER\>\"", "."}]}]}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{"Cell", "[", 
    RowBox[{"CellGroupData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cell", "[", 
         RowBox[{
         "\"\<\:76f8\:5173\:94fe\:63a5\>\"", ",", " ", 
          "\"\<FooterHeader\>\""}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\"\<RELATEDLINKS PLACEHOLDER\>\"", "]"}]}], 
       "}"}], ",", " ", "Open"}], "]"}], "]"}], "//", 
   "CellPrint"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->176273973,ExpressionUUID->"c839015f-d48f-4c1f-bdd7-874ec5b2c0f0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\:76f8\:5173\:94fe\:63a5", "FooterHeader",
 CellContext->"Cell$$6392`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->168484726,ExpressionUUID->"d6502b98-2982-47ae-ab89-be024b12cbc1"],

Cell["RELATEDLINKS PLACEHOLDER",
 CellContext->"Cell$$6392`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->89143201,ExpressionUUID->"302f1845-6dcd-40ef-9adf-fc583a274a3d"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterBottomDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->137855366,ExpressionUUID->"de21177a-c6de-40c8-ba04-54a9fe7fed17"]
}, Open  ]],

Cell["", "WorkflowFooterBottomDelimiter",
 CellContext->"Cell$$6398`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->156560340,ExpressionUUID->"8d166293-2ff2-4f90-8a4d-ac30ca888f69"]
},
WindowSize->{808, 774},
WindowMargins->{{Automatic, 297}, {Automatic, 9}},
DockedCells->{
  Cell[
   BoxData[
    PanelBox[
     StyleBox[
      TemplateBox[{
        StyleBox[
         GraphicsBox[{}, ImageSize -> {9, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        TemplateBox[{
          TooltipBox[
           DynamicModuleBox[{$CellContext`destination$$ = 0}, 
            DynamicBox[
             FEPrivate`If[FEPrivate`HistoryList["Back"] === {}, 
              ButtonBox[
               DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "DisabledBackIcon.png"]]], Enabled -> False, Appearance -> 
               None, FrameMargins -> 0], 
              ButtonBox[
               PaneSelectorBox[{True -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "BackIconHot.png"]]], False -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "BackIcon.png"]]]}, 
                Dynamic[
                 CurrentValue["MouseOver"]]], ButtonFunction :> 
               FrontEndToken[
                 FrontEnd`ButtonNotebook[], "HyperlinkGoBack"], Evaluator -> 
               None, Appearance -> None, FrameMargins -> 0]]], 
            DynamicModuleValues :> {}], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipBack"]]], 
          StyleBox[
           GraphicsBox[{}, ImageSize -> {2, 0}, BaselinePosition -> Baseline],
            "CacheGraphics" -> False], 
          TooltipBox[
           DynamicModuleBox[{$CellContext`destination$$ = 0}, 
            DynamicBox[
             FEPrivate`If[FEPrivate`HistoryList["Forward"] === {}, 
              ButtonBox[
               DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "DisabledForwardIcon.png"]]], Enabled -> False, Appearance -> 
               None, FrameMargins -> 0], 
              ButtonBox[
               PaneSelectorBox[{True -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "ForwardIconHot.png"]]], False -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "ForwardIcon.png"]]]}, 
                Dynamic[
                 CurrentValue["MouseOver"]]], ButtonFunction :> 
               FrontEndToken[
                 FrontEnd`ButtonNotebook[], "HyperlinkGoForward"], Evaluator -> 
               None, Appearance -> None, FrameMargins -> 0]]], 
            DynamicModuleValues :> {}], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipForward"]]], 
          TooltipBox[
           DynamicBox[
            ToBoxes[
             FEPrivate`GenerateHelpViewerActionMenu[], StandardForm]], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipHistory"]]], 
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {13, 0}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          TooltipBox[
           ButtonBox[
            PaneSelectorBox[{True -> DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "HomeIconHot.png"]]], False -> DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "HomeIcon.png"]]]}, 
             Dynamic[
              CurrentValue["MouseOver"]]], ButtonFunction :> 
            Documentation`HelpLookup[
              CurrentValue[HomePage], 
              FrontEnd`ButtonNotebook[], 
              CurrentValue[Language]], Appearance -> None, Evaluator -> 
            Automatic, Method -> "Preemptive"], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipHome"]]]}, 
         "RowDefault"], 
        StyleBox[
         GraphicsBox[{}, ImageSize -> {39, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        FrameBox[
         StyleBox[
          DynamicBox[
           FEPrivate`FrontEndResource[
           "FEExpressions", "HelpViewerSearchField"]], 
          InputFieldBoxOptions -> {
           ImageSize -> Dynamic[AbsoluteCurrentValue[{WindowSize, 1}] - 220], 
            FrameMargins -> 
            FEPrivate`Switch[
             FEPrivate`$OperatingSystem, "MacOSX", {{3, 3}, {0, -1}}, 
              "Windows", {{0, 2}, {0, 2}}, 
              Blank[], {{2, 2}, {0, 0}}]}], FrameStyle -> None, 
         FrameMargins -> {{0, 0}, {4, 0}}], 
        StyleBox[
         GraphicsBox[{}, ImageSize -> {12, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        TooltipBox[
         ButtonBox[
          PaneSelectorBox[{True -> DynamicBox[
              FEPrivate`ImportImage[
               
               FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                "RevertIconHot.png"]]], False -> DynamicBox[
              FEPrivate`ImportImage[
               
               FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                "RevertIcon.png"]]]}, 
           Dynamic[
            CurrentValue["MouseOver"]]], ButtonFunction :> FrontEndToken[
            FrontEnd`ButtonNotebook[], "Revert", False], Evaluator -> None, 
          Appearance -> None, Method -> "Preemptive"], 
         DynamicBox[
          FEPrivate`FrontEndResource["HelpToolbarText", "TooltipRefresh"]]]}, 
       "RowDefault"], CacheGraphics -> False, 
      ButtonBoxOptions -> {BaselinePosition -> (Baseline -> Baseline)}], 
     Alignment -> {Left, Center}, Appearance -> Image[CompressedData["
1:eJztyDkKAkEUhOFGE0OvIHgIU0PTEQ8ww7SDSQs9gnhXl3HBfbmC7Q0qeWDw
f1CPqtcr5tm05ZyrO+lk+XIYY74ad9OYhHpWBV+OwsJXPg6Kdnr2U8qUX/8A
AAAA+HtvyF6AgSdg4AHZHbIbYOAKGLhAdobsBBg4QnaAbA9ZAxjYAQa2gIEN
ZGvIvp8pRMU=
       "], "Byte", ColorSpace -> "RGB", Interleaving -> True], 
     ImageSize -> {
       Scaled[1], Full}]], "DockedCell", CellFrame -> 0, 
   CellMargins -> {{0, -10}, {-2, -1}}, CellFrameMargins -> {{0, 0}, {0, 0}}, 
   ShowCodeAssist -> False, Background -> None], 
  Cell[
   BoxData[
    DynamicBox[
     FEPrivate`If[FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "SearchTextTranslated"},
         ""] === "", "", 
      StyleBox[
       RowBox[{
         ButtonBox[
          DynamicBox[
           DynamicBox[
            FEPrivate`ImportImage[
             
             FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
              "SearchIcon.png"]]]], ButtonData :> FEPrivate`StringJoin[
            FrontEnd`CurrentValue[
             FrontEnd`EvaluationNotebook[], {
             TaggingRules, "SearchTextTranslated"}, ""], " start:1"], 
          BaseStyle -> {
           "Link", FontWeight -> "Bold", 
            FontVariations -> {"Underline" -> True}}, ButtonNote -> ""], 
         "   ", 
         DynamicBox[
          FEPrivate`FrontEndResource["HelpToolbarText", "SearchString1"]], 
         "\[InvisibleSpace]", 
         ButtonBox[
          DynamicBox[
           FrontEnd`CurrentValue[
            FrontEnd`EvaluationNotebook[], {
            TaggingRules, "SearchTextTranslated"}, ""]], ButtonData :> 
          FEPrivate`StringJoin[
            FrontEnd`CurrentValue[
             FrontEnd`EvaluationNotebook[], {
             TaggingRules, "SearchTextTranslated"}, ""], " start:1"], 
          BaseStyle -> {
           "Link", FontWeight -> "Bold", 
            FontVariations -> {"Underline" -> True}}, ButtonNote -> ""], 
         "\[InvisibleSpace]", 
         DynamicBox[
          FEPrivate`FrontEndResource["HelpToolbarText", "SearchString2"]]}], 
       FontSize -> 11]], ImageSizeCache -> {4., {0., 0.}}]], "DockedCell", 
   "ControlStyle", CellFrame -> Dynamic[
     FEPrivate`If[
      FEPrivate`UnsameQ[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], 
       ""], {{0, 0}, {3, 0}}, {{0, 0}, {0, 0}}]], 
   CellMargins -> {{0, -10}, {0, -1}}, CellOpen -> 
   Dynamic[FrontEnd`CurrentValue[
       FrontEnd`EvaluationNotebook[], {TaggingRules, "SearchTextTranslated"}, 
       ""] =!= ""], CellFrameMargins -> {{146, 5}, {3, 0}}, CellFrameColor -> 
   Dynamic[
     FEPrivate`If[
      FEPrivate`SameQ[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], ""], 
      CurrentValue["ToolbarBackground"], 
      FEPrivate`Switch[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "ColorType"}], 
       "SymbolColor", 
       RGBColor[0.481193, 0.528023, 0.813489], "GuideColor", 
       RGBColor[1, 0.6, 0], "TutorialColor", 
       RGBColor[0.641154, 0.223011, 0.0623026], "RootColor", 
       RGBColor[1, 0, 0], 
       Blank[], 
       GrayLevel[0.8]]]], ShowCodeAssist -> False, LineIndent -> 0, 
   LinebreakAdjustments -> {1, 10, 0, 100, 0}, Background -> 
   GrayLevel[0.8627450980392157]], 
  Cell[
   BoxData[
    DynamicBox[
     FrontEnd`CurrentValue[
      FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], 
     ImageSizeCache -> {4., {0., 0.}}]], "DockedLinkTrail", CellOpen -> 
   Dynamic[FrontEnd`CurrentValue[
       FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""] =!= 
     ""], CellFrameColor -> Dynamic[
     FEPrivate`If[
      FEPrivate`UnsameQ[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], ""], 
      GrayLevel[0.8], 
      FEPrivate`Switch[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "ColorType"}], 
       "SymbolColor", 
       RGBColor[0.481193, 0.528023, 0.813489], "GuideColor", 
       RGBColor[1, 0.6, 0], "TutorialColor", 
       RGBColor[0.641154, 0.223011, 0.0623026], "RootColor", 
       RGBColor[1, 0, 0], 
       Blank[], 
       GrayLevel[0.8]]]], ShowCodeAssist -> False], 
  Cell[
   BoxData[
    GridBox[{{
       GridBox[{{
          ItemBox[
           Cell[
            BoxData[
             RowBox[{
               InterpretationBox[
                StyleBox[
                 
                 GraphicsBox[{}, BaselinePosition -> Baseline, 
                  ImageSize -> {8, 0}], CacheGraphics -> False], 
                Spacer[8], Selectable -> False], 
               Cell["WORKFLOW", "PacletNameCell", TextAlignment -> Center], 
               InterpretationBox[
                StyleBox[
                 
                 GraphicsBox[{}, BaselinePosition -> Baseline, 
                  ImageSize -> {8, 0}], CacheGraphics -> False], 
                Spacer[8], Selectable -> False]}]], TextAlignment -> Center], 
           Background -> RGBColor[0.2157, 0.6588, 0.6745], ItemSize -> Full], 
          ""}}, GridBoxAlignment -> {"Rows" -> {{Center}}}, 
        GridBoxItemSize -> {"Columns" -> {Full, 
            Scaled[0.02]}, "Rows" -> {{2.5}}}], 
       Cell[
        BoxData[
         GridBox[{{
            Cell["MENUPLACEHOLDER"]}}]], "AnchorBar"]}}]], "AnchorBarGrid", 
   "WorkflowDockedCell"], 
  Cell[
   TextData["TITLEPLACEHOLDER"], "WorkflowTitle", "WorkflowDockedCell"]},
TaggingRules->{
 "DocuToolsSettingsInternal" -> {
   "$PacletVersion" -> "0.9.2018", "$MVersion" -> "11.2", "$FlaggedVersion" -> 
    11.1, "$ApplicationName" -> "Pubs", "$LinkBase" -> "Pubs", 
    "$ApplicationDirectory" -> "C:\\Workspace\\Pubs\\", 
    "$DocumentationDirectory" -> 
    "C:\\Workspace\\Pubs\\Documentation\\English\\", "$UseNewPageDialog" -> 
    ""}, "ChatTools" -> {
   "Contacts" -> {
     "andre@wolfram.com", "bradym@wolfram.com", "brady@wolfram.com", 
      "chatframework@wolfram.com", "jayw@wolfram.com", 
      "s.wolfram@wolfram.com", "sw@wolfram.com"}}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> "", "SelectedPlatform" -> "All"},
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (February 12, 2019)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> 
     FrontEnd`FileName[{"Wolfram"}, "Reference-zh.nb", CharacterEncoding -> 
       "UTF-8"]]], 
   Cell[
    StyleData["Input"], CellContext -> Notebook, FontFamily -> 
    "Source Sans Pro", FontSize -> 14], 
   Cell[
    StyleData["StandardForm"], FontFamily -> "Source Sans Pro"], 
   Cell[
    StyleData["Output"], CellContext -> Notebook, FontFamily -> 
    "Source Sans Pro", FontSize -> 14]}, Visible -> False, FrontEndVersion -> 
  "12.0 for Microsoft Windows (64-bit) (February 12, 2019)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 185, 4, 35, "Text",ExpressionUUID->"942b9a7c-e08a-41a4-8f01-5d48a517617b",
 CellID->90280312],
Cell[CellGroupData[{
Cell[768, 28, 188, 4, 70, "Section",ExpressionUUID->"f25c98b0-296f-471f-9610-59a12cd83129",
 CellID->9074762],
Cell[959, 34, 349, 8, 26, "Input",ExpressionUUID->"fce7574c-c8f3-4711-bbf7-0f8e2c63d187"],
Cell[1311, 44, 1066, 26, 75, "Input",ExpressionUUID->"47ecc42b-76c1-4f7b-8ebd-cb5a8c4bf452"],
Cell[2380, 72, 296, 7, 26, "Input",ExpressionUUID->"d7c4ac6b-fba9-42c3-ab29-e89be9f029ec",
 CellID->267713489],
Cell[2679, 81, 375, 10, 26, "Input",ExpressionUUID->"b9d09364-cc74-461c-be4a-492cf8c6a35b",
 CellID->133403045],
Cell[3057, 93, 281, 8, 26, "Input",ExpressionUUID->"15766225-eb0d-4e6f-b830-0e17ec981ab0",
 CellID->17199079],
Cell[3341, 103, 5500, 117, 507, "Input",ExpressionUUID->"f1913aa0-3249-448e-abc9-10bdb470da58",
 CellID->606224123]
}, Closed]],
Cell[CellGroupData[{
Cell[8878, 225, 186, 4, 50, "Section",ExpressionUUID->"98b12beb-67d4-49ff-9cdc-05a936dea172",
 CellID->600980217],
Cell[CellGroupData[{
Cell[9089, 233, 283, 7, 30, "Input",ExpressionUUID->"5a170403-37d6-4847-a86f-53b2ed6880a6",
 CellID->208333714],
Cell[9375, 242, 278, 6, 39, "Output",ExpressionUUID->"b8833248-9cde-4292-91f4-3b371027098e",
 CellID->413967391]
}, Open  ]],
Cell[9668, 251, 82, 0, 23, InheritFromParent,ExpressionUUID->"feb0eb94-9a2b-4589-9401-706d238bbe60"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9787, 256, 160, 3, 70, "Section",ExpressionUUID->"a3d70873-eb14-48c3-a0f9-52640790f721",
 CellID->41735091],
Cell[9950, 261, 552, 13, 51, "Input",ExpressionUUID->"5750a12b-7ff0-4694-909d-195c7331a511",
 CellID->134734596],
Cell[10505, 276, 258, 6, 30, "Input",ExpressionUUID->"e602b226-b6bd-4ad7-a98f-b19df16a40b4",
 CellID->671902962]
}, Open  ]],
Cell[CellGroupData[{
Cell[10800, 287, 188, 4, 6, "WorkflowFooterTopDelimiter",ExpressionUUID->"d22f4894-35e8-41c8-8f62-e2c98e50198d",
 CellID->3198045],
Cell[10991, 293, 1060, 27, 91, "Input",ExpressionUUID->"ed7a3169-2358-47f2-a45b-9c925eee9670",
 CellID->313298683]
}, Open  ]],
Cell[CellGroupData[{
Cell[12088, 325, 188, 4, 50, "FooterHeader",ExpressionUUID->"b791da9d-85af-4e19-a6dc-aafe453fa360",
 CellID->676218911],
Cell[12279, 331, 179, 4, 23, InheritFromParent,ExpressionUUID->"d8b63790-3e76-47a3-b43e-9c0d63526749",
 CellID->349308439],
Cell[12461, 337, 254, 6, 30, "Input",ExpressionUUID->"5710bf6d-0c02-4516-8098-5533775a039a",
 CellID->51221915],
Cell[12718, 345, 187, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"b2d90305-df92-4eec-8e5a-a8fb92a6f767",
 CellID->252607947],
Cell[12908, 351, 1111, 29, 91, "Input",ExpressionUUID->"68eead07-db01-4627-9874-8d085b3d3f87",
 CellID->3537032]
}, Open  ]],
Cell[CellGroupData[{
Cell[14056, 385, 200, 4, 50, "FooterHeader",ExpressionUUID->"f6a77348-d716-4e8b-bc8f-ddb1c9200d30",
 CellID->273419540],
Cell[14259, 391, 188, 4, 23, InheritFromParent,ExpressionUUID->"0801536d-7afe-41a5-b3bd-e9dfdb376dff",
 CellID->560026731],
Cell[14450, 397, 255, 6, 48, "Input",ExpressionUUID->"de6b331e-0d68-4d59-9d90-46f1c521afe6",
 CellID->125738797],
Cell[14708, 405, 187, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"d6793922-3e0f-4cbd-bf16-0d5f4c7ff346",
 CellID->271915205],
Cell[14898, 411, 870, 24, 107, "Input",ExpressionUUID->"f120c0d1-6676-45f4-89b0-1b2c64b3efbe",
 CellID->274272625]
}, Open  ]],
Cell[CellGroupData[{
Cell[15805, 440, 200, 4, 50, "FooterHeader",ExpressionUUID->"7be06bf1-91ec-4704-a8b2-a861344a916e",
 CellID->149881907],
Cell[16008, 446, 183, 4, 23, InheritFromParent,ExpressionUUID->"4b294a6e-c6f5-4186-bd02-de41f7035445",
 CellID->9972972],
Cell[16194, 452, 255, 6, 48, "Input",ExpressionUUID->"15608a54-e8b3-42ee-8e73-5478be8440e2",
 CellID->319555874],
Cell[16452, 460, 186, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"76fe86e0-ce7c-41b4-b327-63eabd64b549",
 CellID->61818264],
Cell[16641, 466, 892, 24, 107, "Input",ExpressionUUID->"f238b63b-55bb-4316-b3d7-5d6a83af5102",
 CellID->133770192]
}, Open  ]],
Cell[CellGroupData[{
Cell[17570, 495, 212, 4, 50, "FooterHeader",ExpressionUUID->"56617de6-5128-4c03-b1ea-51a75f28ac19",
 CellID->204690158],
Cell[17785, 501, 187, 4, 23, InheritFromParent,ExpressionUUID->"ce20df4c-427a-4eb0-b441-a27151d2bdd6",
 CellID->93057085],
Cell[17975, 507, 255, 6, 48, "Input",ExpressionUUID->"d4011a13-92b6-4c8d-a444-12a4e5a8bae0",
 CellID->647333165],
Cell[18233, 515, 187, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"97dbd05e-8bef-47c1-b8b4-8a7e44d28c20",
 CellID->115391304],
Cell[18423, 521, 878, 24, 107, "Input",ExpressionUUID->"c839015f-d48f-4c1f-bdd7-874ec5b2c0f0",
 CellID->176273973]
}, Open  ]],
Cell[CellGroupData[{
Cell[19338, 550, 200, 4, 50, "FooterHeader",ExpressionUUID->"d6502b98-2982-47ae-ab89-be024b12cbc1",
 CellID->168484726],
Cell[19541, 556, 183, 4, 23, InheritFromParent,ExpressionUUID->"302f1845-6dcd-40ef-9adf-fc583a274a3d",
 CellID->89143201],
Cell[19727, 562, 261, 6, 48, "Input",ExpressionUUID->"de21177a-c6de-40c8-ba04-54a9fe7fed17",
 CellID->137855366]
}, Open  ]],
Cell[20003, 571, 193, 4, 20, "WorkflowFooterBottomDelimiter",ExpressionUUID->"8d166293-2ff2-4f90-8a4d-ac30ca888f69",
 CellID->156560340]
}
]
*)

