(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     48943,       1276]
NotebookOptionsPosition[     28273,        809]
NotebookOutlinePosition[     41540,       1132]
CellTagsIndexPosition[     41497,       1129]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["DESCRIPTION PLACEHOLDER",
 CellContext->"Cell$$25520`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->134112371,ExpressionUUID->"9ecb39c2-9180-41a6-87d0-ff06a37b0966"],

Cell["\<\
ALL INPUT AND SECTION CELLS ARE REMOVED BEFORE CONTENT IS INSERTED\
\>", "Text",
 FontWeight->"Bold",
 CellID->90280312,ExpressionUUID->"435bc244-df7c-449d-9298-3cc581e7dbb4"],

Cell[CellGroupData[{

Cell["Docked Cell Generation", "Section",
 ShowGroupOpener->True,
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellID->9074762,ExpressionUUID->"863fe2cf-f406-4027-b55d-b646164f765a"],

Cell[BoxData[
 RowBox[{"SetOptions", "[", 
  RowBox[{
   RowBox[{"InputNotebook", "[", "]"}], ",", 
   RowBox[{
   "StyleDefinitions", "\[Rule]", "\"\<Wolfram\\\\Reference.nb\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.704034031534266*^9, 3.704034044245511*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"e63ea951-aaa8-4d9d-863b-3e5503dabfeb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{
    RowBox[{"BoxData", "[", 
     RowBox[{"GridBox", "[", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Cell", "[", 
          RowBox[{"\"\<WORKFLOW\>\"", ",", "\"\<PacletNameCell\>\"", ",", 
           RowBox[{"TextAlignment", "\[Rule]", "Center"}], ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"0.2157", ",", "0.6588", ",", "0.6745"}], "]"}]}]}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Cell", "[", 
          RowBox[{
           RowBox[{"BoxData", "[", 
            RowBox[{"GridBox", "[", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"Cell", "[", "\"\<MENUPLACEHOLDER\>\"", "]"}], "}"}], 
              "}"}], "]"}], "]"}], ",", "\"\<AnchorBar\>\""}], "]"}]}], "}"}],
        "}"}], "]"}], "]"}], ",", "\"\<AnchorBarGrid\>\""}], "]"}], "//", 
  "CellPrint"}]], "Input",
 CellLabel->"In[4]:=",ExpressionUUID->"1339f070-0bdf-400f-b92f-07a3eeb85715"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{
    RowBox[{"TextData", "[", "\"\<TITLEPLACEHOLDER\>\"", "]"}], ",", 
    "\"\<WorkflowTitle\>\""}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->267713489,ExpressionUUID->"e9bdd0d7-8181-4a12-8e85-8f831c49350a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Cell", "[", 
   RowBox[{"BoxData", "[", 
    RowBox[{"GridBox", "[", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"Cell", "[", "\"\<TABSPLACEHOLDER\>\"", "]"}], "}"}], "}"}], 
     "]"}], "]"}], "]"}], "//", "CellPrint"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->133403045,ExpressionUUID->"6f7d9063-1e5d-4041-a955-fbc37a30fa0d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dc", "=", 
   RowBox[{"CurrentValue", "[", 
    RowBox[{
     RowBox[{"InputNotebook", "[", "]"}], ",", "DockedCells"}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->17199079,ExpressionUUID->"42f71ceb-a1be-44c7-ba30-e262fa0eda03"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CurrentValue", "[", 
    RowBox[{
     RowBox[{"InputNotebook", "[", "]"}], ",", "DockedCells"}], "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{"dc", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{
         RowBox[{"BoxData", "[", 
          RowBox[{"GridBox", "[", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"GridBox", "[", 
               RowBox[{
                RowBox[{"{", "\n", "      ", 
                 RowBox[{"{", "\n", "       ", 
                  RowBox[{
                   RowBox[{"ItemBox", "[", 
                    RowBox[{
                    RowBox[{"Cell", "[", 
                    RowBox[{
                    RowBox[{"BoxData", "[", "\n", "         ", 
                    RowBox[{"RowBox", "[", 
                    RowBox[{"{", "\n", "          ", 
                    RowBox[{
                    RowBox[{"InterpretationBox", "[", "\n", "           ", 
                    RowBox[{
                    RowBox[{"StyleBox", "[", "\n", "            ", 
                    RowBox[{
                    RowBox[{"GraphicsBox", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", "\n", "             ", 
                    RowBox[{"BaselinePosition", "->", "Baseline"}], ",", "\n",
                     "             ", 
                    RowBox[{"ImageSize", "->", 
                    RowBox[{"{", 
                    RowBox[{"8", ",", " ", "0"}], "}"}]}]}], "]"}], ",", "\n",
                     "            ", 
                    RowBox[{"CacheGraphics", "->", "False"}]}], "]"}], ",", 
                    "\n", "           ", 
                    RowBox[{"Spacer", "[", "8", "]"}], ",", "\n", 
                    "           ", 
                    RowBox[{"Selectable", "->", "False"}]}], "]"}], ",", " ", 
                    
                    RowBox[{"Cell", "[", 
                    RowBox[{"\"\<WORKFLOW\>\"", ",", " ", 
                    "\"\<PacletNameCell\>\"", ",", "\n", "           ", 
                    RowBox[{"TextAlignment", "->", "Center"}]}], "]"}], ",", 
                    " ", "\n", "          ", 
                    RowBox[{"InterpretationBox", "[", "\n", "           ", 
                    RowBox[{
                    RowBox[{"StyleBox", "[", "\n", "            ", 
                    RowBox[{
                    RowBox[{"GraphicsBox", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", "\n", "             ", 
                    RowBox[{"BaselinePosition", "->", "Baseline"}], ",", "\n",
                     "             ", 
                    RowBox[{"ImageSize", "->", 
                    RowBox[{"{", 
                    RowBox[{"8", ",", " ", "0"}], "}"}]}]}], "]"}], ",", "\n",
                     "            ", 
                    RowBox[{"CacheGraphics", "->", "False"}]}], "]"}], ",", 
                    "\n", "           ", 
                    RowBox[{"Spacer", "[", "8", "]"}], ",", "\n", 
                    "           ", 
                    RowBox[{"Selectable", "->", "False"}]}], "]"}]}], "}"}], 
                    "]"}], "]"}], ",", "\n", "         ", 
                    RowBox[{"TextAlignment", "->", "Center"}]}], "]"}], ",", 
                    "\n", "        ", 
                    RowBox[{"Background", "->", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{
                    "0.2157", ",", " ", "0.6588", ",", " ", "0.6745"}], 
                    "]"}]}], ",", "\n", "        ", 
                    RowBox[{"ItemSize", "->", "Full"}]}], "]"}], ",", " ", 
                   "\"\<\>\""}], "}"}], "\n", "     ", "}"}], ",", "\n", 
                "     ", 
                RowBox[{"GridBoxAlignment", "->", 
                 RowBox[{"{", 
                  RowBox[{"\"\<Rows\>\"", " ", "->", " ", 
                   RowBox[{"{", 
                    RowBox[{"{", "Center", "}"}], "}"}]}], "}"}]}], ",", "\n",
                 "     ", 
                RowBox[{"GridBoxItemSize", "->", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"\"\<Columns\>\"", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{"Full", ",", " ", "\n", "         ", 
                    RowBox[{"Scaled", "[", "0.02", "]"}]}], "}"}]}], ",", " ", 
                   RowBox[{"\"\<Rows\>\"", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{"{", "2.5", "}"}], "}"}]}]}], "}"}]}]}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"Cell", "[", 
               RowBox[{
                RowBox[{"BoxData", "[", 
                 RowBox[{"GridBox", "[", 
                  RowBox[{"{", 
                   RowBox[{"{", 
                    RowBox[{"Cell", "[", "\"\<MENUPLACEHOLDER\>\"", "]"}], 
                    "}"}], "}"}], "]"}], "]"}], ",", "\"\<AnchorBar\>\""}], 
               "]"}]}], "}"}], "}"}], "]"}], "]"}], ",", 
         "\"\<AnchorBarGrid\>\"", ",", "\"\<WorkflowDockedCell\>\""}], "]"}], 
       ",", 
       RowBox[{"Cell", "[", 
        RowBox[{
         RowBox[{"TextData", "[", "\"\<TITLEPLACEHOLDER\>\"", "]"}], ",", 
         "\"\<WorkflowTitle\>\"", ",", "\"\<WorkflowDockedCell\>\""}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"Cell", "[", 
        RowBox[{
         RowBox[{"BoxData", "[", 
          RowBox[{"GridBox", "[", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"Cell", "[", "\"\<TABSPLACEHOLDER\>\"", "]"}], "}"}], 
            "}"}], "]"}], "]"}], ",", "\"\<WorkflowTabGrid\>\"", ",", 
         "\"\<WorkflowDockedCell\>\""}], "]"}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[13]:=",
 CellID->606224123,ExpressionUUID->"4d382d47-c214-494f-a3c8-870bf4e3124c"]
}, Closed]],

Cell[CellGroupData[{

Cell["Content Generation", "Section",
 ShowGroupOpener->True,
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellID->600980217,ExpressionUUID->"dec05b2b-7055-4a4b-a71c-59d6df54be81"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dynamic", "[", 
  RowBox[{"CurrentValue", "[", 
   RowBox[{"{", 
    RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], "}"}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->208333714,ExpressionUUID->"926a4819-831c-4e45-b5d7-f71a424b9838"],

Cell[BoxData[
 DynamicBox[ToBoxes[
   CurrentValue[{TaggingRules, "SelectedPlatform"}], StandardForm],
  ImageSizeCache->{16., {0., 10.}}]], "Output",
 CellContext->"Cell$$25520`",
 CellLabel->"Out[7]=",
 CellID->413967391,ExpressionUUID->"00420e10-d258-474e-8888-54e51234044b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<DESKTOP\>\"", ",", "\"\<WorkflowPlatform\>\"", ",", 
         RowBox[{"ShowCellBracket", "\[Rule]", "True"}], ",", 
         RowBox[{"CellOpen", "\[Rule]", 
          RowBox[{"Dynamic", "[", 
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{"CurrentValue", "[", 
              RowBox[{
               RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], 
                "}"}]}], "]"}], ",", 
             RowBox[{"All", "|", "\"\<Desktop\>\""}]}], "]"}], "]"}]}]}], 
        "]"}], ",", 
       RowBox[{"Cell", "[", "\"\<DESKTOP PLACEHOLDER\>\"", "]"}]}], "}"}], 
     ",", 
     RowBox[{"Dynamic", "[", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"CurrentValue", "[", 
         RowBox[{
          RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], "}"}], 
          ",", "\"\<Desktop\>\""}], "]"}], ",", 
        RowBox[{"\"\<Desktop\>\"", "|", "\"\<All\>\""}]}], "]"}], "]"}]}], 
    "]"}], "]"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->60780229,ExpressionUUID->"75649f2d-6a34-4c61-ba7e-077fdc6fc4ca"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<CLOUD\>\"", ",", "\"\<WorkflowPlatform\>\"", ",", 
         RowBox[{"ShowCellBracket", "\[Rule]", "True"}], ",", 
         RowBox[{"CellOpen", "\[Rule]", 
          RowBox[{"Dynamic", "[", 
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{"CurrentValue", "[", 
              RowBox[{
               RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], 
                "}"}]}], "]"}], ",", 
             RowBox[{"All", "|", "\"\<Cloud\>\""}]}], "]"}], "]"}]}]}], "]"}],
        ",", 
       RowBox[{"Cell", "[", "\"\<CLOUD PLACEHOLDER\>\"", "]"}]}], "}"}], ",", 
     
     RowBox[{"Dynamic", "[", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"CurrentValue", "[", 
         RowBox[{
          RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], "}"}], 
          ",", "\"\<Desktop\>\""}], "]"}], ",", 
        RowBox[{"\"\<Cloud\>\"", "|", "\"\<All\>\""}]}], "]"}], "]"}]}], 
    "]"}], "]"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->7106460,ExpressionUUID->"5ee71bd6-5b58-4b08-b96e-5ba4c6b7e0a4"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"CellGroupData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cell", "[", 
        RowBox[{"\"\<MOBILE\>\"", ",", "\"\<WorkflowPlatform\>\"", ",", 
         RowBox[{"ShowCellBracket", "\[Rule]", "True"}], ",", 
         RowBox[{"CellOpen", "\[Rule]", 
          RowBox[{"Dynamic", "[", 
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{"CurrentValue", "[", 
              RowBox[{
               RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], 
                "}"}]}], "]"}], ",", 
             RowBox[{"All", "|", "\"\<Mobile\>\""}]}], "]"}], "]"}]}]}], 
        "]"}], ",", 
       RowBox[{"Cell", "[", "\"\<MOBILE PLACEHOLDER\>\"", "]"}]}], "}"}], ",", 
     RowBox[{"Dynamic", "[", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"CurrentValue", "[", 
         RowBox[{
          RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], "}"}], 
          ",", "\"\<Desktop\>\""}], "]"}], ",", 
        RowBox[{"\"\<Mobile\>\"", "|", "\"\<All\>\""}]}], "]"}], "]"}]}], 
    "]"}], "]"}], "]"}]], "Input",
 CellID->740894912,ExpressionUUID->"5f117db9-2b1f-452a-afd0-567900f5a3df"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"Dynamic", "[", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"CurrentValue", "[", 
      RowBox[{
       RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], "}"}]}], 
      "]"}], ",", 
     RowBox[{"\"\<All\>\"", "|", "\"\<Desktop\>\""}]}], "]"}], 
   "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->222152546,ExpressionUUID->"bf13d498-6b41-43f3-b3c4-4d610f52d0c9"],

Cell[BoxData[
 DynamicBox[ToBoxes[
   MatchQ[
    CurrentValue[
     EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}], 
    Alternatives["All", "Desktop"]], StandardForm],
  ImageSizeCache->{28., {0., 9.}}]], "Output",
 CellContext->"Cell$$7799`",
 CellLabel->"Out[3]=",
 CellID->474749300,ExpressionUUID->"6e3a8170-684c-49a7-9685-1c66c9c3f0d7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"CurrentValue", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"TaggingRules", ",", "\"\<SelectedPlatform\>\""}], "}"}]}], 
   "]"}], "=", "\"\<All\>\""}]], "Input",
 CellLabel->"In[13]:=",
 CellID->95570290,ExpressionUUID->"83cf0887-5c62-47e3-a1bb-eb53490b37e3"]
}, Open  ]],

Cell[CellGroupData[{

Cell["DESKTOP", "WorkflowPlatform",
 ShowCellBracket->True,
 CellOpen->Dynamic[
   MatchQ[
    CurrentValue[
     EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}], 
    Alternatives["All", "Desktop"]]],
 CellID->515390594,ExpressionUUID->"0cc218d0-aef2-459f-ab6f-60ae25278e44"],

Cell["DESKTOP PLACEHOLDER",
 CellContext->"Cell$$25520`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->77743858,ExpressionUUID->"0ba5de83-e2bc-41c1-af99-b0986a3a7ea3"]
}, Dynamic[MatchQ[
 CurrentValue[
  EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}, "Desktop"], 
  Alternatives["Desktop", "All"]]]]],

Cell[CellGroupData[{

Cell["CLOUD", "WorkflowPlatform",
 ShowCellBracket->True,
 CellOpen->Dynamic[
   MatchQ[
    CurrentValue[
     EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}], 
    Alternatives["All", "Cloud"]]],
 CellID->135602052,ExpressionUUID->"24202825-bdb2-4b21-beee-5eec6494f616"],

Cell["CLOUD PLACEHOLDER",
 CellContext->"Cell$$25780`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->58879777,ExpressionUUID->"bd07d57d-333a-4686-bf45-72a30cd725fd"]
}, Dynamic[MatchQ[
 CurrentValue[
  EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}, "Desktop"], 
  Alternatives["Cloud", "All"]]]]],

Cell[CellGroupData[{

Cell["MOBILE", "WorkflowPlatform",
 ShowCellBracket->True,
 CellOpen->Dynamic[
   MatchQ[
    CurrentValue[
     EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}], 
    Alternatives["All", "Mobile"]]],
 CellID->683030426,ExpressionUUID->"06ebb6bc-848c-44fe-97f8-5be4de071841"],

Cell["MOBILE PLACEHOLDER",
 CellContext->"Cell$$25797`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->83489441,ExpressionUUID->"ac655b93-7e4c-45f8-b207-f32e6098c229"],

Cell[CellGroupData[{

Cell["Footer Generation", "Section",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellID->41735091,ExpressionUUID->"53b47bf8-eccf-4eb6-8387-0888883ef195"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Translation", " ", "instructions", " ", "below", " ", "in", " ", "code", 
   " ", 
   RowBox[{"comments", ".", "  ", "Evaluate"}], " ", "all", " ", "inputs", 
   " ", 
   RowBox[{"(", 
    RowBox[{"once", "!"}], ")"}], " ", "in", " ", "this", " ", 
   "\"\<Footer Generation\>\"", " ", "section", " ", "when", " ", 
   "translation", " ", "is", " ", 
   RowBox[{"finished", "."}]}], " ", "*)"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->134734596,ExpressionUUID->"ff394bc6-d72b-494d-b419-68396bf06bf7"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterTopDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->671902962,ExpressionUUID->"8463fcb7-b7ba-4906-a92d-361514cc8155"]
}, Open  ]]
}, Dynamic[MatchQ[
 CurrentValue[
  EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}, "Desktop"], 
  Alternatives["Mobile", "All"]]]]],

Cell[CellGroupData[{

Cell["", "WorkflowFooterTopDelimiter",
 CellContext->"Cell$$8961`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->584048617,ExpressionUUID->"cc87aaf9-e18a-4230-a05f-a9a082f8d7cf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Translate", " ", "\"\<See Also\>\"", " ", "in", " ", "this", " ", 
     "input"}], ";", " ", 
    RowBox[{
     RowBox[{"don", "'"}], "t", " ", "translate", " ", 
     RowBox[{"\"\<SEEALSO PLACEHOLDER\>\"", "."}]}]}], "  ", "*)"}], "\n", 
  RowBox[{
   RowBox[{"Cell", "[", 
    RowBox[{"CellGroupData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cell", "[", 
         RowBox[{
         "\"\<\:95a2\:9023\:9805\:76ee\>\"", ",", "\"\<FooterHeader\>\"", ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"CurrentValue", "[", 
            RowBox[{"{", 
             RowBox[{
             "StyleHints", ",", "\"\<WorkflowFooterBackgroundColor\>\""}], 
             "}"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\"\<SEEALSO PLACEHOLDER\>\"", "]"}]}], "}"}], 
      ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->313298683,ExpressionUUID->"48dad7b6-fb50-4c0b-a669-55d4dd601d7e"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\:95a2\:9023\:9805\:76ee", "FooterHeader",
 CellContext->"Cell$$9118`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->363905197,ExpressionUUID->"d6d797d8-6dfc-4230-a6ad-e299eb967721"],

Cell["SEEALSO PLACEHOLDER",
 CellContext->"Cell$$9118`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->315800079,ExpressionUUID->"ae40c634-d024-41a5-8971-4ddb0758bac9"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->51221915,ExpressionUUID->"6c872a04-aa3d-49cc-bb03-7348d5292997"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$9120`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->7884615,ExpressionUUID->"4eda684a-cf52-4056-a719-6e030512853f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Translate", " ", "\"\<Related Functions\>\"", " ", "in", " ", "this", 
     " ", "input"}], ";", " ", 
    RowBox[{
     RowBox[{"don", "'"}], "t", " ", "translate", " ", 
     RowBox[{"\"\<RELATEDFUNCTIONS PLACEHOLDER\>\"", "."}]}]}], "  ", "*)"}], 
  "\n", 
  RowBox[{
   RowBox[{"Cell", "[", 
    RowBox[{"CellGroupData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cell", "[", 
         RowBox[{
         "\"\<\:95a2\:9023\:3059\:308b\:95a2\:6570\>\"", ",", 
          "\"\<FooterHeader\>\"", ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"CurrentValue", "[", 
            RowBox[{"{", 
             RowBox[{
             "StyleHints", ",", "\"\<WorkflowFooterBackgroundColor\>\""}], 
             "}"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\"\<RELATEDFUNCTIONS PLACEHOLDER\>\"", "]"}]}], 
       "}"}], ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->3537032,ExpressionUUID->"56cb742d-a82b-4939-906b-321c0309b172"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\:95a2\:9023\:3059\:308b\:95a2\:6570", "FooterHeader",
 CellContext->"Cell$$9120`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->8800322,ExpressionUUID->"9ea58d31-97ff-4d28-9bc1-a4c3d274fb9f"],

Cell["RELATEDFUNCTIONS PLACEHOLDER",
 CellContext->"Cell$$9120`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->482038021,ExpressionUUID->"fa1360aa-a759-4ef9-8e51-eb0a4f3cdb8b"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->125738797,ExpressionUUID->"3c9d6a6b-46eb-4513-83e6-5efa2ae39ec9"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$9126`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->129411724,ExpressionUUID->"3b355b35-f560-442e-8ff0-a28ef8d7fc4b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Translate", " ", "\"\<Related Guides\>\"", " ", "in", " ", "this", " ", 
     "input"}], ";", " ", 
    RowBox[{
     RowBox[{"don", "'"}], "t", " ", "translate", " ", 
     RowBox[{"\"\<RELATEDGUIDES PLACEHOLDER\>\"", "."}]}]}], "  ", "*)"}], 
  "\n", 
  RowBox[{
   RowBox[{"Cell", "[", 
    RowBox[{"CellGroupData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cell", "[", 
         RowBox[{
         "\"\<\:95a2\:9023\:3059\:308b\:30ac\:30a4\:30c9\>\"", ",", 
          "\"\<FooterHeader\>\""}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\"\<RELATEDGUIDES PLACEHOLDER\>\"", "]"}]}], 
       "}"}], ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->274272625,ExpressionUUID->"004f43b2-6297-457c-bee5-593f6d466b83"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\:95a2\:9023\:3059\:308b\:30ac\:30a4\:30c9", "FooterHeader",
 CellContext->"Cell$$9126`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->36398789,ExpressionUUID->"2675dda1-4cb1-4bd2-8953-c10b08b07f8f"],

Cell["RELATEDGUIDES PLACEHOLDER",
 CellContext->"Cell$$9126`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->110293073,ExpressionUUID->"19f33ac3-df8f-44d4-a173-8169693c0bc4"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->319555874,ExpressionUUID->"7ecda1fc-6d3d-4005-b411-6fd0f64b3010"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$9132`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->155409682,ExpressionUUID->"005e1691-bc69-493e-a00b-6df6356f27dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Translate", " ", "\"\<Related Tech Notes\>\"", " ", "in", " ", "this", 
     " ", "input"}], ";", " ", 
    RowBox[{
     RowBox[{"don", "'"}], "t", " ", "translate", " ", 
     RowBox[{"\"\<RELATEDTECHNOTES PLACEHOLDER\>\"", "."}]}]}], " ", "*)"}], 
  "\n", 
  RowBox[{
   RowBox[{"Cell", "[", 
    RowBox[{"CellGroupData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cell", "[", 
         RowBox[{
         "\"\<\:6280\:8853\:7684\:306a\:6ce8\:91c8\>\"", ",", 
          "\"\<FooterHeader\>\""}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\"\<RELATEDTECHNOTES PLACEHOLDER\>\"", "]"}]}], 
       "}"}], ",", "Open"}], "]"}], "]"}], "//", "CellPrint"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->133770192,ExpressionUUID->"b8e0ddfb-51bb-4619-8cd4-9db9ac2e1e16"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\:6280\:8853\:7684\:306a\:6ce8\:91c8", "FooterHeader",
 CellContext->"Cell$$9132`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->181935887,ExpressionUUID->"7b4b5063-f9a5-4495-850e-91068be6bcfd"],

Cell["RELATEDTECHNOTES PLACEHOLDER",
 CellContext->"Cell$$9132`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->142510872,ExpressionUUID->"82359417-18b3-4801-8e99-08db79409c6c"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->647333165,ExpressionUUID->"0d5e3e97-eea2-4a0a-9f81-6017866e706b"],

Cell["", "WorkflowFooterDelimiter",
 CellContext->"Cell$$9138`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->17497259,ExpressionUUID->"c8c3730e-1f23-4907-88b4-77cfb3989bdb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Translate", " ", "\"\<Related Links\>\"", " ", "in", " ", "this", " ", 
     "input"}], ";", " ", 
    RowBox[{
     RowBox[{"don", "'"}], "t", " ", "translate", " ", 
     RowBox[{"\"\<RELATEDLINKS PLACEHOLDER\>\"", "."}]}]}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{"Cell", "[", 
    RowBox[{"CellGroupData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Cell", "[", 
         RowBox[{
         "\"\<\:95a2\:9023\:30ea\:30f3\:30af\>\"", ",", " ", 
          "\"\<FooterHeader\>\""}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\"\<RELATEDLINKS PLACEHOLDER\>\"", "]"}]}], 
       "}"}], ",", " ", "Open"}], "]"}], "]"}], "//", 
   "CellPrint"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->176273973,ExpressionUUID->"30c1def7-cce5-41e3-8472-23a2ead9c42c"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\:95a2\:9023\:30ea\:30f3\:30af", "FooterHeader",
 CellContext->"Cell$$9138`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->631585028,ExpressionUUID->"c1369244-944c-4a52-b888-370b318de726"],

Cell["RELATEDLINKS PLACEHOLDER",
 CellContext->"Cell$$9138`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->212997474,ExpressionUUID->"1fef35f5-4c63-454b-87fd-f564bfe96891"],

Cell[BoxData[
 RowBox[{"CellPrint", "[", 
  RowBox[{"Cell", "[", 
   RowBox[{"\"\<\>\"", ",", "\"\<WorkflowFooterBottomDelimiter\>\""}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->137855366,ExpressionUUID->"52a230a3-d296-4063-b1ab-11955f9da1b5"]
}, Open  ]],

Cell["", "WorkflowFooterBottomDelimiter",
 CellContext->"Cell$$9144`",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellID->106882089,ExpressionUUID->"b244ef6d-fb71-44c3-a529-bc46556e52d3"]
},
WindowSize->{808, 911},
WindowMargins->{{178, Automatic}, {Automatic, 12}},
DockedCells->{
  Cell[
   BoxData[
    PanelBox[
     StyleBox[
      TemplateBox[{
        StyleBox[
         GraphicsBox[{}, ImageSize -> {9, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        TemplateBox[{
          TooltipBox[
           DynamicModuleBox[{$CellContext`destination$$ = 0}, 
            DynamicBox[
             FEPrivate`If[FEPrivate`HistoryList["Back"] === {}, 
              ButtonBox[
               DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "DisabledBackIcon.png"]]], Enabled -> False, Appearance -> 
               None, FrameMargins -> 0], 
              ButtonBox[
               PaneSelectorBox[{True -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "BackIconHot.png"]]], False -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "BackIcon.png"]]]}, 
                Dynamic[
                 CurrentValue["MouseOver"]]], ButtonFunction :> 
               FrontEndToken[
                 FrontEnd`ButtonNotebook[], "HyperlinkGoBack"], Evaluator -> 
               None, Appearance -> None, FrameMargins -> 0]]], 
            DynamicModuleValues :> {}], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipBack"]]], 
          StyleBox[
           GraphicsBox[{}, ImageSize -> {2, 0}, BaselinePosition -> Baseline],
            "CacheGraphics" -> False], 
          TooltipBox[
           DynamicModuleBox[{$CellContext`destination$$ = 0}, 
            DynamicBox[
             FEPrivate`If[FEPrivate`HistoryList["Forward"] === {}, 
              ButtonBox[
               DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "DisabledForwardIcon.png"]]], Enabled -> False, Appearance -> 
               None, FrameMargins -> 0], 
              ButtonBox[
               PaneSelectorBox[{True -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "ForwardIconHot.png"]]], False -> DynamicBox[
                   FEPrivate`ImportImage[
                    
                    FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                    "ForwardIcon.png"]]]}, 
                Dynamic[
                 CurrentValue["MouseOver"]]], ButtonFunction :> 
               FrontEndToken[
                 FrontEnd`ButtonNotebook[], "HyperlinkGoForward"], Evaluator -> 
               None, Appearance -> None, FrameMargins -> 0]]], 
            DynamicModuleValues :> {}], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipForward"]]], 
          TooltipBox[
           DynamicBox[
            ToBoxes[
             FEPrivate`GenerateHelpViewerActionMenu[], StandardForm]], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipHistory"]]], 
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {13, 0}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          TooltipBox[
           ButtonBox[
            PaneSelectorBox[{True -> DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "HomeIconHot.png"]]], False -> DynamicBox[
                FEPrivate`ImportImage[
                 
                 FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                  "HomeIcon.png"]]]}, 
             Dynamic[
              CurrentValue["MouseOver"]]], ButtonFunction :> 
            Documentation`HelpLookup[
              CurrentValue[HomePage], 
              FrontEnd`ButtonNotebook[], 
              CurrentValue[Language]], Appearance -> None, Evaluator -> 
            Automatic, Method -> "Preemptive"], 
           DynamicBox[
            FEPrivate`FrontEndResource["HelpToolbarText", "TooltipHome"]]]}, 
         "RowDefault"], 
        StyleBox[
         GraphicsBox[{}, ImageSize -> {39, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        FrameBox[
         StyleBox[
          DynamicBox[
           FEPrivate`FrontEndResource[
           "FEExpressions", "HelpViewerSearchField"]], 
          InputFieldBoxOptions -> {
           ImageSize -> Dynamic[AbsoluteCurrentValue[{WindowSize, 1}] - 220], 
            FrameMargins -> 
            FEPrivate`Switch[
             FEPrivate`$OperatingSystem, "MacOSX", {{3, 3}, {0, -1}}, 
              "Windows", {{0, 2}, {0, 2}}, 
              Blank[], {{2, 2}, {0, 0}}]}], FrameStyle -> None, 
         FrameMargins -> {{0, 0}, {4, 0}}], 
        StyleBox[
         GraphicsBox[{}, ImageSize -> {12, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        TooltipBox[
         ButtonBox[
          PaneSelectorBox[{True -> DynamicBox[
              FEPrivate`ImportImage[
               
               FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                "RevertIconHot.png"]]], False -> DynamicBox[
              FEPrivate`ImportImage[
               
               FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
                "RevertIcon.png"]]]}, 
           Dynamic[
            CurrentValue["MouseOver"]]], ButtonFunction :> FrontEndToken[
            FrontEnd`ButtonNotebook[], "Revert", False], Evaluator -> None, 
          Appearance -> None, Method -> "Preemptive"], 
         DynamicBox[
          FEPrivate`FrontEndResource["HelpToolbarText", "TooltipRefresh"]]]}, 
       "RowDefault"], CacheGraphics -> False, 
      ButtonBoxOptions -> {BaselinePosition -> (Baseline -> Baseline)}], 
     Alignment -> {Left, Center}, Appearance -> Image[CompressedData["
1:eJztyDkKAkEUhOFGE0OvIHgIU0PTEQ8ww7SDSQs9gnhXl3HBfbmC7Q0qeWDw
f1CPqtcr5tm05ZyrO+lk+XIYY74ad9OYhHpWBV+OwsJXPg6Kdnr2U8qUX/8A
AAAA+HtvyF6AgSdg4AHZHbIbYOAKGLhAdobsBBg4QnaAbA9ZAxjYAQa2gIEN
ZGvIvp8pRMU=
       "], "Byte", ColorSpace -> "RGB", Interleaving -> True], 
     ImageSize -> {
       Scaled[1], Full}]], "DockedCell", CellFrame -> 0, 
   CellMargins -> {{0, -10}, {-2, -1}}, CellFrameMargins -> {{0, 0}, {0, 0}}, 
   ShowCodeAssist -> False, Background -> None], 
  Cell[
   BoxData[
    DynamicBox[
     FEPrivate`If[FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "SearchTextTranslated"},
         ""] === "", "", 
      StyleBox[
       RowBox[{
         ButtonBox[
          DynamicBox[
           DynamicBox[
            FEPrivate`ImportImage[
             
             FrontEnd`FileName[{"Toolbars", "DocCenter"}, 
              "SearchIcon.png"]]]], ButtonData :> FEPrivate`StringJoin[
            FrontEnd`CurrentValue[
             FrontEnd`EvaluationNotebook[], {
             TaggingRules, "SearchTextTranslated"}, ""], " start:1"], 
          BaseStyle -> {
           "Link", FontWeight -> "Bold", 
            FontVariations -> {"Underline" -> True}}, ButtonNote -> ""], 
         "   ", 
         DynamicBox[
          FEPrivate`FrontEndResource["HelpToolbarText", "SearchString1"]], 
         "\[InvisibleSpace]", 
         ButtonBox[
          DynamicBox[
           FrontEnd`CurrentValue[
            FrontEnd`EvaluationNotebook[], {
            TaggingRules, "SearchTextTranslated"}, ""]], ButtonData :> 
          FEPrivate`StringJoin[
            FrontEnd`CurrentValue[
             FrontEnd`EvaluationNotebook[], {
             TaggingRules, "SearchTextTranslated"}, ""], " start:1"], 
          BaseStyle -> {
           "Link", FontWeight -> "Bold", 
            FontVariations -> {"Underline" -> True}}, ButtonNote -> ""], 
         "\[InvisibleSpace]", 
         DynamicBox[
          FEPrivate`FrontEndResource["HelpToolbarText", "SearchString2"]]}], 
       FontSize -> 11]], ImageSizeCache -> {4., {0., 0.}}]], "DockedCell", 
   "ControlStyle", CellFrame -> Dynamic[
     FEPrivate`If[
      FEPrivate`UnsameQ[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], 
       ""], {{0, 0}, {3, 0}}, {{0, 0}, {0, 0}}]], 
   CellMargins -> {{0, -10}, {0, -1}}, CellOpen -> 
   Dynamic[FrontEnd`CurrentValue[
       FrontEnd`EvaluationNotebook[], {TaggingRules, "SearchTextTranslated"}, 
       ""] =!= ""], CellFrameMargins -> {{146, 5}, {3, 0}}, CellFrameColor -> 
   Dynamic[
     FEPrivate`If[
      FEPrivate`SameQ[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], ""], 
      CurrentValue["ToolbarBackground"], 
      FEPrivate`Switch[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "ColorType"}], 
       "SymbolColor", 
       RGBColor[0.481193, 0.528023, 0.813489], "GuideColor", 
       RGBColor[1, 0.6, 0], "TutorialColor", 
       RGBColor[0.641154, 0.223011, 0.0623026], "RootColor", 
       RGBColor[1, 0, 0], 
       Blank[], 
       GrayLevel[0.8]]]], ShowCodeAssist -> False, LineIndent -> 0, 
   LinebreakAdjustments -> {1, 10, 0, 100, 0}, Background -> 
   GrayLevel[0.8627450980392157]], 
  Cell[
   BoxData[
    DynamicBox[
     FrontEnd`CurrentValue[
      FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], 
     ImageSizeCache -> {4., {0., 0.}}]], "DockedLinkTrail", CellOpen -> 
   Dynamic[FrontEnd`CurrentValue[
       FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""] =!= 
     ""], CellFrameColor -> Dynamic[
     FEPrivate`If[
      FEPrivate`UnsameQ[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "LinkTrails"}, ""], ""], 
      GrayLevel[0.8], 
      FEPrivate`Switch[
       FrontEnd`CurrentValue[
        FrontEnd`EvaluationNotebook[], {TaggingRules, "ColorType"}], 
       "SymbolColor", 
       RGBColor[0.481193, 0.528023, 0.813489], "GuideColor", 
       RGBColor[1, 0.6, 0], "TutorialColor", 
       RGBColor[0.641154, 0.223011, 0.0623026], "RootColor", 
       RGBColor[1, 0, 0], 
       Blank[], 
       GrayLevel[0.8]]]], ShowCodeAssist -> False], 
  Cell[
   BoxData[
    GridBox[{{
       GridBox[{{
          ItemBox[
           Cell[
            BoxData[
             RowBox[{
               InterpretationBox[
                StyleBox[
                 
                 GraphicsBox[{}, BaselinePosition -> Baseline, 
                  ImageSize -> {8, 0}], CacheGraphics -> False], 
                Spacer[8], Selectable -> False], 
               Cell["WORKFLOW", "PacletNameCell", TextAlignment -> Center], 
               InterpretationBox[
                StyleBox[
                 
                 GraphicsBox[{}, BaselinePosition -> Baseline, 
                  ImageSize -> {8, 0}], CacheGraphics -> False], 
                Spacer[8], Selectable -> False]}]], TextAlignment -> Center], 
           Background -> RGBColor[0.2157, 0.6588, 0.6745], ItemSize -> Full], 
          ""}}, GridBoxAlignment -> {"Rows" -> {{Center}}}, 
        GridBoxItemSize -> {"Columns" -> {Full, 
            Scaled[0.02]}, "Rows" -> {{2.5}}}], 
       Cell[
        BoxData[
         GridBox[{{
            Cell["MENUPLACEHOLDER"]}}]], "AnchorBar"]}}]], "AnchorBarGrid", 
   "WorkflowDockedCell"], 
  Cell[
   TextData["TITLEPLACEHOLDER"], "WorkflowTitle", "WorkflowDockedCell"], 
  Cell[
   BoxData[
    GridBox[{{
       Cell["TABSPLACEHOLDER"]}}]], "WorkflowTabGrid", 
   "WorkflowDockedCell"]},
TaggingRules->{
 "DocuToolsSettingsInternal" -> {
   "$PacletVersion" -> "0.9.2018", "$MVersion" -> "11.2", "$FlaggedVersion" -> 
    11.1, "$ApplicationName" -> "Pubs", "$LinkBase" -> "Pubs", 
    "$ApplicationDirectory" -> "C:\\Workspace\\Pubs\\", 
    "$DocumentationDirectory" -> 
    "C:\\Workspace\\Pubs\\Documentation\\English\\", "$UseNewPageDialog" -> 
    ""}, "ChatTools" -> {
   "Contacts" -> {
     "andre@wolfram.com", "bradym@wolfram.com", "brady@wolfram.com", 
      "chatframework@wolfram.com", "jayw@wolfram.com", 
      "s.wolfram@wolfram.com", "sw@wolfram.com"}}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> "", "SelectedPlatform" -> "All"},
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (February 12, 2019)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> 
     FrontEnd`FileName[{"Wolfram"}, "Reference-ja.nb", CharacterEncoding -> 
       "UTF-8"]]], 
   Cell[
    StyleData["Input"], CellContext -> Notebook, FontFamily -> 
    "Source Sans Pro", FontSize -> 14], 
   Cell[
    StyleData["StandardForm"], FontFamily -> "Source Sans Pro"], 
   Cell[
    StyleData["Output"], CellContext -> Notebook, FontFamily -> 
    "Source Sans Pro", FontSize -> 14]}, Visible -> False, FrontEndVersion -> 
  "12.0 for Microsoft Windows (64-bit) (February 12, 2019)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 184, 4, 23, InheritFromParent,ExpressionUUID->"9ecb39c2-9180-41a6-87d0-ff06a37b0966",
 CellID->134112371],
Cell[745, 26, 185, 4, 35, "Text",ExpressionUUID->"435bc244-df7c-449d-9298-3cc581e7dbb4",
 CellID->90280312],
Cell[CellGroupData[{
Cell[955, 34, 188, 4, 70, "Section",ExpressionUUID->"863fe2cf-f406-4027-b55d-b646164f765a",
 CellID->9074762],
Cell[1146, 40, 349, 8, 30, "Input",ExpressionUUID->"e63ea951-aaa8-4d9d-863b-3e5503dabfeb"],
Cell[1498, 50, 1066, 26, 91, "Input",ExpressionUUID->"1339f070-0bdf-400f-b92f-07a3eeb85715"],
Cell[2567, 78, 296, 7, 30, "Input",ExpressionUUID->"e9bdd0d7-8181-4a12-8e85-8f831c49350a",
 CellID->267713489],
Cell[2866, 87, 375, 10, 30, "Input",ExpressionUUID->"6f7d9063-1e5d-4041-a955-fbc37a30fa0d",
 CellID->133403045],
Cell[3244, 99, 281, 8, 30, "Input",ExpressionUUID->"42f71ceb-a1be-44c7-ba30-e262fa0eda03",
 CellID->17199079],
Cell[3528, 109, 5893, 127, 671, "Input",ExpressionUUID->"4d382d47-c214-494f-a3c8-870bf4e3124c",
 CellID->606224123]
}, Closed]],
Cell[CellGroupData[{
Cell[9458, 241, 186, 4, 50, "Section",ExpressionUUID->"dec05b2b-7055-4a4b-a71c-59d6df54be81",
 CellID->600980217],
Cell[CellGroupData[{
Cell[9669, 249, 283, 7, 30, "Input",ExpressionUUID->"926a4819-831c-4e45-b5d7-f71a424b9838",
 CellID->208333714],
Cell[9955, 258, 278, 6, 39, "Output",ExpressionUUID->"00420e10-d258-474e-8888-54e51234044b",
 CellID->413967391]
}, Open  ]],
Cell[10248, 267, 1448, 36, 111, "Input",ExpressionUUID->"75649f2d-6a34-4c61-ba7e-077fdc6fc4ca",
 CellID->60780229],
Cell[11699, 305, 1438, 36, 111, "Input",ExpressionUUID->"5ee71bd6-5b58-4b08-b96e-5ba4c6b7e0a4",
 CellID->7106460],
Cell[13140, 343, 1416, 34, 111, "Input",ExpressionUUID->"5f117db9-2b1f-452a-afd0-567900f5a3df",
 CellID->740894912],
Cell[CellGroupData[{
Cell[14581, 381, 501, 14, 51, "Input",ExpressionUUID->"bf13d498-6b41-43f3-b3c4-4d610f52d0c9",
 CellID->222152546],
Cell[15085, 397, 354, 9, 39, "Output",ExpressionUUID->"6e3a8170-684c-49a7-9685-1c66c9c3f0d7",
 CellID->474749300]
}, Open  ]],
Cell[15454, 409, 351, 9, 30, "Input",ExpressionUUID->"83cf0887-5c62-47e3-a1bb-eb53490b37e3",
 CellID->95570290]
}, Open  ]],
Cell[CellGroupData[{
Cell[15842, 423, 286, 7, 23, "WorkflowPlatform",ExpressionUUID->"0cc218d0-aef2-459f-ab6f-60ae25278e44",
 CellOpen->Dynamic[
   MatchQ[
    CurrentValue[
     EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}], 
    Alternatives["All", "Desktop"]]],
 CellID->515390594],
Cell[16131, 432, 179, 4, 23, InheritFromParent,ExpressionUUID->"0ba5de83-e2bc-41c1-af99-b0986a3a7ea3",
 CellID->77743858]
}, Dynamic[MatchQ[CurrentValue[EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}, "Desktop"], Alternatives["Desktop", "All"]]]]],
Cell[CellGroupData[{
Cell[16479, 444, 282, 7, 23, "WorkflowPlatform",ExpressionUUID->"24202825-bdb2-4b21-beee-5eec6494f616",
 CellOpen->Dynamic[
   MatchQ[
    CurrentValue[
     EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}], 
    Alternatives["All", "Cloud"]]],
 CellID->135602052],
Cell[16764, 453, 177, 4, 23, InheritFromParent,ExpressionUUID->"bd07d57d-333a-4686-bf45-72a30cd725fd",
 CellID->58879777]
}, Dynamic[MatchQ[CurrentValue[EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}, "Desktop"], Alternatives["Cloud", "All"]]]]],
Cell[CellGroupData[{
Cell[17108, 465, 284, 7, 23, "WorkflowPlatform",ExpressionUUID->"06ebb6bc-848c-44fe-97f8-5be4de071841",
 CellOpen->Dynamic[
   MatchQ[
    CurrentValue[
     EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}], 
    Alternatives["All", "Mobile"]]],
 CellID->683030426],
Cell[17395, 474, 178, 4, 23, InheritFromParent,ExpressionUUID->"ac655b93-7e4c-45f8-b207-f32e6098c229",
 CellID->83489441],
Cell[CellGroupData[{
Cell[17598, 482, 160, 3, 70, "Section",ExpressionUUID->"53b47bf8-eccf-4eb6-8387-0888883ef195",
 CellID->41735091],
Cell[17761, 487, 552, 13, 51, "Input",ExpressionUUID->"ff394bc6-d72b-494d-b419-68396bf06bf7",
 CellID->134734596],
Cell[18316, 502, 258, 6, 30, "Input",ExpressionUUID->"8463fcb7-b7ba-4906-a92d-361514cc8155",
 CellID->671902962]
}, Open  ]]
}, Dynamic[MatchQ[CurrentValue[EvaluationNotebook[], {TaggingRules, "SelectedPlatform"}, "Desktop"], Alternatives["Mobile", "All"]]]]],
Cell[CellGroupData[{
Cell[18754, 517, 190, 4, 6, "WorkflowFooterTopDelimiter",ExpressionUUID->"cc87aaf9-e18a-4230-a05f-a9a082f8d7cf",
 CellID->584048617],
Cell[18947, 523, 1082, 28, 91, "Input",ExpressionUUID->"48dad7b6-fb50-4c0b-a669-55d4dd601d7e",
 CellID->313298683]
}, Open  ]],
Cell[CellGroupData[{
Cell[20066, 556, 200, 4, 50, "FooterHeader",ExpressionUUID->"d6d797d8-6dfc-4230-a6ad-e299eb967721",
 CellID->363905197],
Cell[20269, 562, 179, 4, 23, InheritFromParent,ExpressionUUID->"ae40c634-d024-41a5-8971-4ddb0758bac9",
 CellID->315800079],
Cell[20451, 568, 254, 6, 30, "Input",ExpressionUUID->"6c872a04-aa3d-49cc-bb03-7348d5292997",
 CellID->51221915],
Cell[20708, 576, 185, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"4eda684a-cf52-4056-a719-6e030512853f",
 CellID->7884615],
Cell[20896, 582, 1134, 30, 91, "Input",ExpressionUUID->"56cb742d-a82b-4939-906b-321c0309b172",
 CellID->3537032]
}, Open  ]],
Cell[CellGroupData[{
Cell[22067, 617, 210, 4, 50, "FooterHeader",ExpressionUUID->"9ea58d31-97ff-4d28-9bc1-a4c3d274fb9f",
 CellID->8800322],
Cell[22280, 623, 188, 4, 23, InheritFromParent,ExpressionUUID->"fa1360aa-a759-4ef9-8e51-eb0a4f3cdb8b",
 CellID->482038021],
Cell[22471, 629, 255, 6, 30, "Input",ExpressionUUID->"3c9d6a6b-46eb-4513-83e6-5efa2ae39ec9",
 CellID->125738797],
Cell[22729, 637, 187, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"3b355b35-f560-442e-8ff0-a28ef8d7fc4b",
 CellID->129411724],
Cell[22919, 643, 889, 24, 71, "Input",ExpressionUUID->"004f43b2-6297-457c-bee5-593f6d466b83",
 CellID->274272625]
}, Open  ]],
Cell[CellGroupData[{
Cell[23845, 672, 217, 4, 50, "FooterHeader",ExpressionUUID->"2675dda1-4cb1-4bd2-8953-c10b08b07f8f",
 CellID->36398789],
Cell[24065, 678, 185, 4, 23, InheritFromParent,ExpressionUUID->"19f33ac3-df8f-44d4-a173-8169693c0bc4",
 CellID->110293073],
Cell[24253, 684, 255, 6, 30, "Input",ExpressionUUID->"7ecda1fc-6d3d-4005-b411-6fd0f64b3010",
 CellID->319555874],
Cell[24511, 692, 187, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"005e1691-bc69-493e-a00b-6df6356f27dd",
 CellID->155409682],
Cell[24701, 698, 892, 24, 71, "Input",ExpressionUUID->"b8e0ddfb-51bb-4619-8cd4-9db9ac2e1e16",
 CellID->133770192]
}, Open  ]],
Cell[CellGroupData[{
Cell[25630, 727, 212, 4, 50, "FooterHeader",ExpressionUUID->"7b4b5063-f9a5-4495-850e-91068be6bcfd",
 CellID->181935887],
Cell[25845, 733, 188, 4, 23, InheritFromParent,ExpressionUUID->"82359417-18b3-4801-8e99-08db79409c6c",
 CellID->142510872],
Cell[26036, 739, 255, 6, 30, "Input",ExpressionUUID->"0d5e3e97-eea2-4a0a-9f81-6017866e706b",
 CellID->647333165],
Cell[26294, 747, 186, 4, 3, "WorkflowFooterDelimiter",ExpressionUUID->"c8c3730e-1f23-4907-88b4-77cfb3989bdb",
 CellID->17497259],
Cell[26483, 753, 884, 24, 71, "Input",ExpressionUUID->"30c1def7-cce5-41e3-8472-23a2ead9c42c",
 CellID->176273973]
}, Open  ]],
Cell[CellGroupData[{
Cell[27404, 782, 206, 4, 50, "FooterHeader",ExpressionUUID->"c1369244-944c-4a52-b888-370b318de726",
 CellID->631585028],
Cell[27613, 788, 184, 4, 23, InheritFromParent,ExpressionUUID->"1fef35f5-4c63-454b-87fd-f564bfe96891",
 CellID->212997474],
Cell[27800, 794, 261, 6, 30, "Input",ExpressionUUID->"52a230a3-d296-4063-b1ab-11955f9da1b5",
 CellID->137855366]
}, Open  ]],
Cell[28076, 803, 193, 4, 20, "WorkflowFooterBottomDelimiter",ExpressionUUID->"b244ef6d-fb71-44c3-a529-bc46556e52d3",
 CellID->106882089]
}
]
*)

