(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    216649,       4073]
NotebookOptionsPosition[    210706,       3862]
NotebookOutlinePosition[    211133,       3878]
CellTagsIndexPosition[    211090,       3875]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 "New in: ",
 Cell["XX", "HistoryData",
  CellTags->"New"],
 " | Modified in: ",
 Cell[" ", "HistoryData",
  CellTags->"Modified"],
 " | Obsolete in: ",
 Cell[" ", "HistoryData",
  CellTags->"Obsolete"],
 " | Excised in: ",
 Cell[" ", "HistoryData",
  CellTags->"Excised"]
}], "History",
 CellID->1247902091],

Cell[CellGroupData[{

Cell["Categorization", "CategorizationSection",
 CellID->1122911449],

Cell["Tutorial", "Categorization",
 CellLabel->"Entity Type",
 CellID->686433507],

Cell["DocumentationTools Package", "Categorization",
 CellChangeTimes->{{3.4695512315845995`*^9, 3.4695512490536847`*^9}},
 CellLabel->"Paclet Name",
 CellID->605800465],

Cell["DocumentationTools`", "Categorization",
 CellChangeTimes->{{3.469551256303824*^9, 3.4695512574288454`*^9}},
 CellLabel->"Context",
 CellID->468444828],

Cell["\<\
DocumentationTools/tutorial/AuthoringGuidePagesUsingDocumentationTools\
\>", "Categorization",
 CellChangeTimes->{{3.469551568950452*^9, 3.4695515768099775`*^9}, {
  3.4695516736243362`*^9, 3.469551679327571*^9}},
 CellLabel->"URI",
 CellID->423050917]
}, Closed]],

Cell[CellGroupData[{

Cell["Keywords", "KeywordsSection",
 CellID->1427428552],

Cell["XXXX", "Keywords",
 CellID->1251852827]
}, Closed]],

Cell[CellGroupData[{

Cell["Details", "DetailsSection",
 CellID->307771771],

Cell["XXXX", "Details",
 CellLabel->"Lead",
 CellID->218895918],

Cell["XXXX", "Details",
 CellLabel->"Developers",
 CellID->350963985],

Cell["XXXX", "Details",
 CellLabel->"Authors",
 CellID->795871300],

Cell["XXXX", "Details",
 CellLabel->"Feature Name",
 CellID->199739161],

Cell["XXXX", "Details",
 CellLabel->"QA",
 CellID->40625308],

Cell["XXXX", "Details",
 CellLabel->"DA",
 CellID->357121918],

Cell["XXXX", "Details",
 CellLabel->"Docs",
 CellID->35949532],

Cell["XXXX", "Details",
 CellLabel->"Features Page Notes",
 CellID->929432370],

Cell["XXXX", "Details",
 CellLabel->"Comments",
 CellID->240026365]
}, Closed]],

Cell[CellGroupData[{

Cell["Authoring Guide Pages Using DocumentationTools", "Title",
 CellChangeTimes->{{3.448216418441999*^9, 3.448216423174631*^9}, 
   3.4644638652614317`*^9},
 CellID->509267359],

Cell["\<\
A guide page focuses on a single topic, providing links to functions that \
share functionality. Sections are provided to link to other related documents.\
\>", "Text",
 CellChangeTimes->{{3.4482164709475193`*^9, 3.448216471585455*^9}, 
   3.46446399315615*^9, 3.464464029829198*^9, 3.4645342789685106`*^9, 
   3.464629281968425*^9, {3.4646293160782366`*^9, 3.464629325093977*^9}},
 CellID->1534169418],

Cell[TextData[{
 "The material below assumes that you have already set up an appropriate \
directory structure for saving and working with documentation using the \
DocumentationTools package. If you are working from ",
 StyleBox["Workbench",
  FontSlant->"Italic"],
 " it will already have been done. Otherwise, with \"MyApplication\" \
representing the name of your application, create the directory structure ",
 StyleBox["MyApplication", "MR"],
 " > Documentation > English and the directories Guides, ReferencePages, and \
Tutorials inside the English directory. Then create the directory Symbols \
within the ReferencePages directory."
}], "Text",
 CellChangeTimes->{{3.4644495753083887`*^9, 3.4644497573107185`*^9}, {
   3.4644499062970004`*^9, 3.4644500350486484`*^9}, {3.4644506803850336`*^9, 
   3.464450752698459*^9}, {3.4644511405627985`*^9, 3.464451184157107*^9}, {
   3.4645343194065285`*^9, 3.4645343257347345`*^9}, 3.464629364875736*^9, 
   3.464629475986533*^9},
 CellID->398579895]
}, Open  ]],

Cell[CellGroupData[{

Cell["Setting Up DocumentationTools", "Section",
 CellChangeTimes->{{3.446836472485368*^9, 3.44683647540952*^9}, 
   3.464463890387236*^9},
 CellID->1589624943],

Cell[CellGroupData[{

Cell[TextData[{
 "Choose ",
 StyleBox[ButtonBox["Palettes",
  BaseStyle->"Link",
  ButtonData->"paclet:guide/PalettesMenu"], "MenuName"],
 StyleBox[" \[FilledRightTriangle] ", "MenuNameDelimiter"],
 StyleBox["DocumentationTools", "MenuName"],
 " from the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " menu bar. A gray palette will appear on the right side of the screen. \
Select the ",
 StyleBox["G", "DialogElementName"],
 " tab at the top of the palette for guide page authoring tools."
}], "ItemizedText",
 CellChangeTimes->{{3.464448130243017*^9, 3.464448132821175*^9}, {
   3.4644481937907057`*^9, 3.464448197337626*^9}, 3.4644641185660763`*^9, {
   3.4644698661257706`*^9, 3.4644698668914056`*^9}, 3.4646294978618135`*^9},
 CellID->39008079],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnVlsHdUZx+deu85GVBVaSgqlLaaoLUVtiFtSQgw0ZCGkWYjThITExE7s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    "], {{0, 319}, {155, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{155, 319},
  PlotRange->{{0, 155}, {0, 319}}]], "ItemizedPicture",
 CellChangeTimes->{3.4644644488376803`*^9},
 ImageSize->{159, 319},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->348629951]
}, Open  ]],

Cell[TextData[{
 "If you are not starting ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " from a project within ",
 StyleBox["Workbench",
  FontSlant->"Italic"],
 ", you will need to configure DocumentationTools. Click ",
 StyleBox["Set PacletName & Path", "DialogElementName"],
 " near the palette's top and navigate to the English directory of your \
application. This will activate the links in the authoring notebooks for \
testing purposes."
}], "ItemizedText",
 CellChangeTimes->{
  3.44580270400082*^9, 3.445803211624179*^9, {3.445973675052581*^9, 
   3.4459736794624567`*^9}, {3.445973710533258*^9, 3.445973730151601*^9}, {
   3.4459742815842533`*^9, 3.445974324086258*^9}, {3.446205387609572*^9, 
   3.446205393157836*^9}, {3.4462054293429127`*^9, 3.44620543542245*^9}, 
   3.446230546711166*^9, {3.447010438750395*^9, 3.447010442289474*^9}, {
   3.447422135007004*^9, 3.447422136083086*^9}, {3.448390291092811*^9, 
   3.448390291385187*^9}, {3.4489824310596733`*^9, 3.4489824312228613`*^9}, {
   3.449246291637199*^9, 3.4492462919921923`*^9}, 3.449421543375716*^9, 
   3.46032061816746*^9, {3.464449256491808*^9, 3.4644494277127495`*^9}, {
   3.464450997982849*^9, 3.4644510345926924`*^9}, {3.4646295656751814`*^9, 
   3.4646295671126995`*^9}},
 CellID->350456505],

Cell[TextData[{
 StyleBox["Note:",
  FontWeight->"Bold"],
 " If the palette appears nonfunctional, open the ",
 StyleBox["Option Inspector", "DialogElementName"],
 " (",
 StyleBox[ButtonBox["Format",
  BaseStyle->"Link",
  ButtonData->"paclet:guide/FormatMenu"], "MenuName"],
 StyleBox[" \[FilledRightTriangle] ", "MenuNameDelimiter"],
 StyleBox[ButtonBox["Option ",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/menuitem/OptionInspector"], "MenuNameDelimiter"],
 StyleBox[ButtonBox["Inspector",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/menuitem/OptionInspector"], "MenuName"],
 ") and check that ",
 Cell[BoxData[
  RowBox[{
   ButtonBox["DynamicUpdating",
    BaseStyle->"Link"], "->", 
   ButtonBox["Automatic",
    BaseStyle->"Link"]}]], "InlineFormula"],
 " in the ",
 StyleBox["Global Preferences", "DialogElementName"],
 "."
}], "ItemizedTextParagraph",
 CellChangeTimes->{{3.4470096348642406`*^9, 3.4470096825270452`*^9}, {
  3.447009713199542*^9, 3.4470097344477863`*^9}, {3.447009921116921*^9, 
  3.4470100140379133`*^9}, {3.447010086167214*^9, 3.44701010243943*^9}, {
  3.447010155785534*^9, 3.447010219201659*^9}, {3.4470136243698883`*^9, 
  3.447013624613661*^9}, {3.448982374884638*^9, 3.448982377422827*^9}, {
  3.4649749308508444`*^9, 3.4649749453041544`*^9}},
 CellID->6284882]
}, Open  ]],

Cell[CellGroupData[{

Cell["Authoring", "Section",
 CellChangeTimes->{{3.446836472485368*^9, 3.44683647540952*^9}, {
  3.446836570869047*^9, 3.4468365725307407`*^9}},
 CellID->2103302851],

Cell[CellGroupData[{

Cell[TextData[{
 "Clicking ",
 StyleBox["New Guide Page", "DialogElementName"],
 " brings up a dialog requesting that the title of the new guide be \
specified. "
}], "ItemizedText",
 CellChangeTimes->{{3.464465476491459*^9, 3.464465679072177*^9}, {
   3.4644657177601724`*^9, 3.4644657180883017`*^9}, 3.4644658938561764`*^9},
 CellID->431683258],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnQdYFNfXxmeXaom9YKcp2HvHxN47VhRFBAF7S0xMYmISjS2WlH+SL90Y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    "], {{0, 95}, {537, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{537, 95},
  PlotRange->{{0, 537}, {0, 95}}]], "ItemizedPicture",
 CellChangeTimes->{3.4644644488376803`*^9, 3.464465871793394*^9},
 ImageSize->{541, 95},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->49400353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Once that is done, clicking ",
 StyleBox["OK", "DialogElementName"],
 " will construct a new guide page with the title and metadata already filled \
in. In addition, the guide page will be saved in the project's Guides \
directory. The dialog that comes up is informational and may be permanently \
dismissed if so desired."
}], "ItemizedText",
 CellChangeTimes->{{3.464465476491459*^9, 3.464465679072177*^9}, {
   3.4644657177601724`*^9, 3.4644657180883017`*^9}, 3.4644658938561764`*^9, {
   3.464466629943723*^9, 3.464466685835064*^9}, {3.464629607925722*^9, 
   3.4646296350354443`*^9}},
 CellID->642016735],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3QlwFHeC5/sC+3X3dO/GbuxsdMxEv+54G9Ozu7Fv3u7OdEe8jpluu7vd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    "], {{0, 500}, {708, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag[
   "Byte", ColorSpace -> "RGB", ImageSize -> Automatic, Interleaving -> True, 
    Magnification -> Automatic],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{708, 500},
  PlotRange->{{0, 708}, {0, 500}}]], "Output",
 CellChangeTimes->{3.4644644488376803`*^9, 3.464465871793394*^9, 
  3.4644665834118776`*^9},
 CellLabel->"Out[5]=",
 CellID->143521583]
}, Open  ]],

Cell[TextData[{
 StyleBox["Note:",
  FontWeight->"Bold"],
 " The authoring notebooks contain a series of placeholders that will not be \
included with the build unless you explicitly edit them. These placeholders \
will typically contain four X's."
}], "ItemizedTextParagraph",
 CellChangeTimes->{{3.44760496490698*^9, 3.447605023314485*^9}, 
   3.448216569494198*^9, 3.448390664226063*^9, {3.448994767005025*^9, 
   3.448994806114935*^9}, 3.449247427128982*^9, {3.4603181958453093`*^9, 
   3.460318215672043*^9}, {3.460319916006525*^9, 3.460319917536476*^9}, 
   3.4644647988577857`*^9},
 CellID->1194847838],

Cell[TextData[{
 StyleBox["Note:",
  FontWeight->"Bold"],
 " A sample guide page can be found by clicking ",
 StyleBox["Sample Guide Page", "DialogElementName"],
 " near the top of the",
 " ",
 StyleBox["DocumentationTools", "MenuName"],
 " palette."
}], "ItemizedTextParagraph",
 CellChangeTimes->{{3.4476053274402227`*^9, 3.447605396759492*^9}, {
   3.448907933110716*^9, 3.448907934811652*^9}, 3.4644464907064066`*^9, {
   3.4644515020674257`*^9, 3.464451503879949*^9}, {3.46445159495924*^9, 
   3.464451626444018*^9}, {3.464465171003174*^9, 3.4644651724406924`*^9}, {
   3.4645454001733603`*^9, 3.4645454019702587`*^9}, 3.466425602102968*^9},
 CellID->688030169],

Cell[CellGroupData[{

Cell["\<\
Enter some descriptive text describing what the guide covers.\
\>", "ItemizedText",
 CellChangeTimes->{{3.446219891992948*^9, 3.446219913334681*^9}, {
  3.4462199777063437`*^9, 3.44622000327243*^9}, {3.448995782617152*^9, 
  3.448995794861979*^9}},
 CellID->211902656],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnQlQVEe7hqdM/alKpZLUn9+rpRVN0PIm5rpEza9B4xK9oMEtLqi4YERc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    "], {{0, 76}, {537, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{537, 76},
  PlotRange->{{0, 537}, {0, 76}}]], "ItemizedPicture",
 CellChangeTimes->{
  3.4644644488376803`*^9, 3.464465871793394*^9, 3.4644665834118776`*^9, {
   3.464466859181032*^9, 3.464466863821717*^9}},
 ImageSize->{541, 76},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->166790500]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Add links and descriptions for emphasized functions by using the ",
 StyleBox["1 Line Function Listing", "DialogElementName"],
 " button near the top of the ",
 StyleBox["DocumentationTools", "MenuName"],
 " palette. Place the cursor in the part of the cell where the gray X's are \
and replace XXXX with the function name. Be careful not to type over the \
inline cell. Add a short description to the right. "
}], "ItemizedText",
 CellChangeTimes->{{3.4457048025232687`*^9, 3.445704832974859*^9}, {
   3.446220190502228*^9, 3.4462203119884663`*^9}, {3.44622125027708*^9, 
   3.4462212537937107`*^9}, {3.447012345420175*^9, 3.447012347603339*^9}, {
   3.447012451166584*^9, 3.447012467221507*^9}, {3.448995812656818*^9, 
   3.448995820142888*^9}, {3.460319987294606*^9, 3.46031999018486*^9}, {
   3.4603200256204033`*^9, 3.46032008927404*^9}, {3.4644639126848245`*^9, 
   3.4644639141848726`*^9}, {3.4645454262830696`*^9, 3.4645454460489473`*^9}, 
   3.4645455184717493`*^9, {3.464629727052247*^9, 3.4646297623495736`*^9}, 
   3.4646298103658133`*^9, 3.4646300653847027`*^9, {3.4646300997757673`*^9, 
   3.4646301077758703`*^9}, {3.464630196120751*^9, 3.4646301977145214`*^9}, {
   3.4649751243064456`*^9, 3.464975126009592*^9}, {3.4650590008617*^9, 
   3.4650590180962963`*^9}, {3.4650594781490593`*^9, 
   3.4650594789928207`*^9}, {3.466170306322543*^9, 3.4661703305417585`*^9}},
 CellID->951903],

Cell[CellGroupData[{

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3WtMW+cZB3Br+1hNmjqp+5IpWjdVbTdpU79MmtpJKYy20ZqUdKo0TarW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    "], {{0, 61}, {541, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{541, 61},
  PlotRange->{{0, 541}, {0, 61}}]], "ItemizedPicture",
 CellChangeTimes->{3.465056716957467*^9, 3.465057094399798*^9, 
  3.4650572666363773`*^9, 3.465057406966299*^9, 3.4650581098502955`*^9, 
  3.46505856524675*^9},
 ImageSize->{541, 61},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->382280121],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnXlQVNeexzt5/7y8P6bqzXs1qXk1S15SldSbVCpVmpqqSVKpl/jMNolJ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    "], {{0, 68}, {537, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{537, 68},
  PlotRange->{{0, 537}, {0, 68}}]], "ItemizedPicture",
 CellChangeTimes->{3.465056716957467*^9, 3.465057094399798*^9, 
  3.4650572666363773`*^9, 3.465057406966299*^9, 3.4650581098502955`*^9, 
  3.46505856524675*^9, 3.465058804499812*^9, 3.465058872719435*^9},
 ImageSize->{541, 68},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->41896285]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Click ",
 StyleBox["1 Line Function Listing", "DialogElementName"],
 " to automatically create a link."
}], "ItemizedText",
 CellChangeTimes->{{3.4457048025232687`*^9, 3.445704832974859*^9}, {
   3.446220190502228*^9, 3.4462203119884663`*^9}, {3.44622125027708*^9, 
   3.4462212537937107`*^9}, {3.447012345420175*^9, 3.447012347603339*^9}, {
   3.447012451166584*^9, 3.447012467221507*^9}, {3.448995812656818*^9, 
   3.448995820142888*^9}, {3.460319987294606*^9, 3.46031999018486*^9}, {
   3.4603200256204033`*^9, 3.46032008927404*^9}, {3.4644639126848245`*^9, 
   3.4644639141848726`*^9}, {3.4645454262830696`*^9, 3.4645454460489473`*^9}, 
   3.4645455184717493`*^9, {3.464629727052247*^9, 3.4646297623495736`*^9}, 
   3.4646298103658133`*^9, 3.4646300653847027`*^9, {3.4646300997757673`*^9, 
   3.4646301077758703`*^9}, {3.464630196120751*^9, 3.4646301977145214`*^9}, {
   3.4649751243064456`*^9, 3.464975126009592*^9}, {3.46505902583077*^9, 
   3.465059054674889*^9}, 3.465059315225099*^9, {3.465061543503621*^9, 
   3.4650615710664735`*^9}},
 CellID->354381513],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnQlYlNe5x6e5TdunvUnaNPc27ZN7a7Nqmjxprcbk1lrciElcYzQuSSBu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    "], {{0, 69}, {541, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{541, 69},
  PlotRange->{{0, 541}, {0, 69}}]], "ItemizedPicture",
 CellChangeTimes->{3.465056716957467*^9, 3.465057094399798*^9, 
  3.4650572666363773`*^9, 3.465057406966299*^9, 3.4650581098502955`*^9, 
  3.46505856524675*^9, 3.465058804499812*^9, 3.465058872719435*^9, 
  3.4650593830384674`*^9},
 ImageSize->{545, 69},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->241074036]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Less important functions may be listed as function inline listings.\
\>", "ItemizedText",
 CellChangeTimes->{{3.4462204075046873`*^9, 3.4462204379100018`*^9}, {
   3.447012357899967*^9, 3.447012364779771*^9}, {3.447012489664731*^9, 
   3.447012492109771*^9}, {3.448995832362953*^9, 3.44899583280713*^9}, {
   3.464545763443635*^9, 3.4645457644123974`*^9}, {3.4646302434494815`*^9, 
   3.4646302541214933`*^9}, 3.4646302916375985`*^9, {3.465059890513713*^9, 
   3.4650599377486925`*^9}, {3.4650608676199694`*^9, 3.4650609020579104`*^9}, 
   3.4650613286414957`*^9},
 CellID->2099662060],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnXtMlFcaxidsNE30r4pgYr2sUaMu0Fpj1PXKH2p00xjXppqNaZqmcb3j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    "], {{0, 46}, {541, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{541, 46},
  PlotRange->{{0, 541}, {0, 46}}]], "ItemizedPicture",
 CellChangeTimes->{3.465056716957467*^9, 3.465057094399798*^9, 
  3.4650572666363773`*^9, 3.465057406966299*^9, 3.4650581098502955`*^9, 
  3.46505856524675*^9, 3.465058804499812*^9, 3.465058872719435*^9, 
  3.4650593830384674`*^9, 3.4650598186221676`*^9},
 ImageSize->{545, 46},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->153117101]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "List individual function names in place of XXXX. Any number of functions \
may be included in a list. Each pair in the list should be separated by a \
space, then a period, and then another space. If you want to include a link \
to a symbol in another application, include it as ",
 StyleBox["otherlinkbase", "MR"],
 "/ref/symbol, where ",
 StyleBox["otherlinkbase", "MR"],
 " is usually the other application's name."
}], "ItemizedText",
 CellChangeTimes->{{3.4650613770014896`*^9, 3.465061402595567*^9}, {
   3.465061480377813*^9, 3.465061481080947*^9}, {3.4650623778268003`*^9, 
   3.465062481437501*^9}, {3.4650625318600216`*^9, 3.465062536016325*^9}, 
   3.4661704057150764`*^9},
 CellID->5837652],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnQlMVNcaxydY06a1bepa02LrS321FbXaJa2pzbNJn8lzF+NWaxWxrmhd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    "], {{0, 46}, {541, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{541, 46},
  PlotRange->{{0, 541}, {0, 46}}]], "ItemizedPicture",
 CellChangeTimes->{3.4650610231688356`*^9},
 ImageSize->{545, 46},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->31808756]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "With the cursor in the cell or at the cell bracket, click ",
 StyleBox["Functions Inline Listing", "DialogElementName"],
 ". If you later want to add more functions to the list, select the cell \
bracket and click ",
 StyleBox["Functions Inline Listing", "DialogElementName"],
 ". The function list will again be plain text. Add more function names and \
then click ",
 StyleBox["Functions Inline Listing", "DialogElementName"],
 " again."
}], "ItemizedText",
 CellChangeTimes->{{3.4462204075046873`*^9, 3.4462204379100018`*^9}, {
   3.447012357899967*^9, 3.447012364779771*^9}, {3.447012489664731*^9, 
   3.447012492109771*^9}, {3.448995832362953*^9, 3.44899583280713*^9}, {
   3.464545763443635*^9, 3.4645457644123974`*^9}, {3.4646302434494815`*^9, 
   3.4646302541214933`*^9}, 3.4646302916375985`*^9, {3.465059890513713*^9, 
   3.4650599377486925`*^9}, {3.4650608676199694`*^9, 3.4650609020579104`*^9}, 
   3.4650613691107635`*^9, {3.46506144106481*^9, 3.465061472112082*^9}, 
   3.4650616358485527`*^9, {3.4650620627133913`*^9, 3.46506206415091*^9}, {
   3.4650621377456017`*^9, 3.465062138276859*^9}},
 CellID->101277750],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnQlQlPcZxjdpZxon6YxNc0wzaqvtJE2ao21spqNRx6PGxFrjmcFba/G2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    "], {{0, 53}, {541, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{541, 53},
  PlotRange->{{0, 541}, {0, 53}}]], "ItemizedPicture",
 CellChangeTimes->{3.4650610231688356`*^9, 3.465061269156359*^9},
 ImageSize->{545, 53},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->8301352]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Related functions can be organized into groups by placing the cursor \
between cells and clicking ",
 StyleBox["Delimiter", "DialogElementName"],
 " on the ",
 StyleBox["DocumentationTools", "MenuName"],
 " palette. Text above each function group may be inserted with the ",
 StyleBox["Subsection", "DialogElementName"],
 " button."
}], "ItemizedText",
 CellChangeTimes->{{3.447012167139886*^9, 3.447012201721261*^9}, {
   3.4470123730916567`*^9, 3.447012399963909*^9}, 3.4470125035424232`*^9, {
   3.447012574290535*^9, 3.447012637831362*^9}, 3.464463915481789*^9, {
   3.464545785975174*^9, 3.4645457872408147`*^9}, 3.4646301385262637`*^9, {
   3.465063249697335*^9, 3.465063315260674*^9}, {3.465063367370716*^9, 
   3.465063395183572*^9}},
 CellID->490729240],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnQdYFNf6xje5uSk35ab8U266qSYaE42axNhiL7GXaBJL7BXsKIIKCoKC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    "], {{0, 222}, {541, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{541, 222},
  PlotRange->{{0, 541}, {0, 222}}]], "ItemizedPicture",
 CellChangeTimes->{3.4650610231688356`*^9, 3.465061269156359*^9, 
  3.4650631584149165`*^9},
 ImageSize->{545, 222},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->298644160]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Adding Cross-Links", "Section",
 CellChangeTimes->{{3.4468374655935583`*^9, 3.446837470550503*^9}, 
   3.464630455530321*^9, 3.4649752007761745`*^9},
 CellID->211935376],

Cell[CellGroupData[{

Cell["\<\
The Tutorials section is for related tutorials, the More About section is for \
links to guide pages, and the Related Links section is for other related \
pages (including web pages).\
\>", "Text",
 CellChangeTimes->{{3.4457039546055984`*^9, 3.4457039738874454`*^9}, {
   3.4462093289119873`*^9, 3.446209335003468*^9}, {3.446209741065166*^9, 
   3.446209802829309*^9}, {3.446209837989963*^9, 3.44620990430267*^9}, 
   3.446220797998413*^9, {3.464466997573429*^9, 3.464467007479806*^9}, 
   3.464467057027315*^9, {3.464630462139781*^9, 3.4646304841556873`*^9}},
 CellID->2104468320],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3XlQnOedJ/CuzSRbsWPveCceeW1H8T12ZVab8tZOMluVGmdt72TGU7Fn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    "], {{0, 214}, {541, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{541, 214},
  PlotRange->{{0, 541}, {0, 214}}]], "ItemizedPicture",
 CellChangeTimes->{3.4650610231688356`*^9, 3.465061269156359*^9, 
  3.4650631584149165`*^9, 3.4650635203883*^9},
 ImageSize->{545, 214},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->823349334]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Start typing in any section to add text. Then make a selection, choose ",
 StyleBox["Links", "DialogElementName"],
 " on the",
 " ",
 StyleBox["DocumentationTools", "MenuName"],
 " palette, and pick the type of link from the column. (Expand ",
 StyleBox["More Link Tools", "DialogElementName"],
 " for more options.)"
}], "Text",
 CellChangeTimes->{{3.446218763545474*^9, 3.446218894760709*^9}, {
   3.44621898647535*^9, 3.446218986962421*^9}, {3.446221363340219*^9, 
   3.446221377323094*^9}, 3.44924645543929*^9, 3.4644639178724904`*^9, 
   3.4646305390157647`*^9, 3.4664256307753935`*^9},
 CellID->1813611861],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnEGuHDUQhlvKgpwgEkuOQPZkzRqJC2TJhivkGiMuwIJdDsI2SGSLFOkJ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    "], {{0, 230}, {155, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{155, 230},
  PlotRange->{{0, 155}, {0, 230}}]], "ItemizedPicture",
 CellChangeTimes->{3.4644522326549025`*^9, 3.4644525516589856`*^9, 
  3.46445291844493*^9, 3.46445311763498*^9, 3.46445365862628*^9, 
  3.4644539178014717`*^9, 3.4644540979131527`*^9, 3.4644542634465213`*^9, 
  3.46445435827586*^9, 3.464454938455161*^9, 3.4644550061435275`*^9, 
  3.4644560735478153`*^9, 3.4644564286617355`*^9, 3.4644566084609118`*^9, 
  3.4644572264531975`*^9},
 ImageSize->{159, 230},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->462004817]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Adding Product Artwork", "Section",
 CellChangeTimes->{{3.448995867186393*^9, 3.44899587671129*^9}},
 CellID->1389323153],

Cell[CellGroupData[{

Cell[TextData[{
 "Click ",
 StyleBox["Insert Artwork Banner Cell", "DialogElementName"],
 " ",
 "on the",
 " ",
 StyleBox["DocumentationTools", "MenuName"],
 " palette and follow the instructions to add product branding artwork to the \
guide page."
}], "Text",
 CellChangeTimes->{{3.4457048835195074`*^9, 3.4457048921776185`*^9}, {
   3.44622084106385*^9, 3.446220882364553*^9}, 3.4644639201538134`*^9, 
   3.4645459210550275`*^9, 3.464630142057559*^9},
 CellID->462024330],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnXlwVced76l5Ve+PyXtVqZnUTP7wq2SmbMfPM1XJc5Jy7MSOYyex4yTO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    "], {{0, 153}, {541, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{541, 153},
  PlotRange->{{0, 541}, {0, 153}}]], "ItemizedPicture",
 CellChangeTimes->{3.4650610231688356`*^9, 3.465061269156359*^9, 
  3.4650631584149165`*^9, 3.4650635203883*^9, 3.465063616920785*^9, 
  3.465063667530808*^9},
 ImageSize->{545, 153},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->131351731]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Adding Search Index Information", "Section",
 CellChangeTimes->{{3.4489955164286003`*^9, 3.448995525858408*^9}},
 CellID->889099401],

Cell[CellGroupData[{

Cell["\<\
Scroll to the top of the authoring notebook and expand the Keywords cell \
group.\
\>", "Text",
 CellChangeTimes->{{3.445704754661855*^9, 3.445704772820488*^9}, {
  3.4462125835587053`*^9, 3.446212599066681*^9}, {3.4462126399981537`*^9, 
  3.4462126565080767`*^9}, {3.4603196646584787`*^9, 3.46031966924461*^9}, {
  3.4644576798965015`*^9, 3.4644576847871885`*^9}},
 CellID->2110633446],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnQd4E0fax8eQXHKXu+/uSEjukksjCZBGQguQBAKEQKihY3p3o9r0Xkxv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    "], {{0, 115}, {541, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{541, 115},
  PlotRange->{{0, 541}, {0, 115}}]], "ItemizedPicture",
 CellChangeTimes->{
  3.4644644488376803`*^9, 3.464465871793394*^9, 3.4644665834118776`*^9, {
   3.464466859181032*^9, 3.464466863821717*^9}, 3.464468307621447*^9},
 ImageSize->{545, 115},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->168563096]
}, Open  ]],

Cell[TextData[{
 "\"Keyword\" cells are what the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " search index uses when cataloging the authoring notebooks, and are not \
case-sensitive."
}], "Text",
 CellChangeTimes->{{3.446212725224617*^9, 3.446212776245862*^9}, {
   3.446212817238916*^9, 3.4462129375449047`*^9}, {3.446213046404356*^9, 
   3.446213052249419*^9}, {3.4468300515211563`*^9, 3.446830058817684*^9}, 
   3.446839233695413*^9, 3.460319683497377*^9, 3.4644577569131117`*^9, 
   3.464630646673393*^9},
 CellID->1909613865],

Cell[CellGroupData[{

Cell["\<\
Keywords are set up to return the page in the list of search results if a \
user were to search for that word in the Documentation Center.\
\>", "Text",
 CellChangeTimes->{{3.446212944186151*^9, 3.446212987264474*^9}, 
   3.4492475549555473`*^9, {3.464630674298746*^9, 3.4646306827988553`*^9}, {
   3.4646307554247847`*^9, 3.464630756752927*^9}},
 CellID->1335856376],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnQdclEf6x0fT6128XHJ3/0vuYnIxPbZEU0zUGGsUe7BrYuy9N8DeFRtg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    "], {{0, 130}, {541, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{541, 130},
  PlotRange->{{0, 541}, {0, 130}}]], "ItemizedPicture",
 CellChangeTimes->{
  3.4644644488376803`*^9, 3.464465871793394*^9, 3.4644665834118776`*^9, {
   3.464466859181032*^9, 3.464466863821717*^9}, 3.464468307621447*^9, 
   3.4644684320292892`*^9},
 ImageSize->{545, 130},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->80331440]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Leaving XXXX", "Section",
 CellChangeTimes->{{3.4489955164286003`*^9, 3.448995525858408*^9}, {
  3.465067737989159*^9, 3.465067744770496*^9}},
 CellID->320656080],

Cell["\<\
Whenever a cell is left with content XXXX, it will be omitted by the build \
process. Thus the author need not do anything with such cells.\
\>", "Text",
 CellChangeTimes->{{3.465067755364382*^9, 3.4650678558656683`*^9}, 
   3.4661705477021775`*^9},
 CellID->425841723],

Cell[CellGroupData[{

Cell["More About", "TutorialMoreAboutSection",
 CellID->23220180],

Cell["XXXX", "TutorialMoreAbout",
 CellID->1567025153]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Tutorials", "RelatedTutorialsSection",
 CellID->415694126],

Cell["XXXX", "RelatedTutorials",
 CellID->806871991]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Wolfram Education Group Courses", "TutorialRelatedLinksSection",
 CellID->415694148],

Cell["XXXX", "TutorialRelatedLinks",
 CellID->415694149]
}, Open  ]]
}, Open  ]]
},
WindowSize->{700, 770},
WindowMargins->{{129, Automatic}, {Automatic, 3}},
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (February 18, 2009)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "TutorialPageStyles.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 324, 14, 22, "History",
 CellID->1247902091],
Cell[CellGroupData[{
Cell[894, 38, 68, 1, 27, "CategorizationSection",
 CellID->1122911449],
Cell[965, 41, 81, 2, 31, "Categorization",
 CellID->686433507],
Cell[1049, 45, 169, 3, 31, "Categorization",
 CellID->605800465],
Cell[1221, 50, 156, 3, 31, "Categorization",
 CellID->468444828],
Cell[1380, 55, 262, 6, 31, "Categorization",
 CellID->423050917]
}, Closed]],
Cell[CellGroupData[{
Cell[1679, 66, 56, 1, 17, "KeywordsSection",
 CellID->1427428552],
Cell[1738, 69, 45, 1, 70, "Keywords",
 CellID->1251852827]
}, Closed]],
Cell[CellGroupData[{
Cell[1820, 75, 53, 1, 17, "DetailsSection",
 CellID->307771771],
Cell[1876, 78, 63, 2, 70, "Details",
 CellID->218895918],
Cell[1942, 82, 69, 2, 70, "Details",
 CellID->350963985],
Cell[2014, 86, 66, 2, 70, "Details",
 CellID->795871300],
Cell[2083, 90, 71, 2, 70, "Details",
 CellID->199739161],
Cell[2157, 94, 60, 2, 70, "Details",
 CellID->40625308],
Cell[2220, 98, 61, 2, 70, "Details",
 CellID->357121918],
Cell[2284, 102, 62, 2, 70, "Details",
 CellID->35949532],
Cell[2349, 106, 78, 2, 70, "Details",
 CellID->929432370],
Cell[2430, 110, 67, 2, 70, "Details",
 CellID->240026365]
}, Closed]],
Cell[CellGroupData[{
Cell[2534, 117, 177, 3, 105, "Title",
 CellID->509267359],
Cell[2714, 122, 412, 7, 36, "Text",
 CellID->1534169418],
Cell[3129, 131, 999, 18, 97, "Text",
 CellID->398579895]
}, Open  ]],
Cell[CellGroupData[{
Cell[4165, 154, 160, 3, 40, "Section",
 CellID->1589624943],
Cell[CellGroupData[{
Cell[4350, 161, 757, 18, 58, "ItemizedText",
 CellID->39008079],
Cell[5110, 181, 6857, 119, 329, "ItemizedPicture",
 CellID->348629951]
}, Open  ]],
Cell[11982, 303, 1281, 25, 71, "ItemizedText",
 CellID->350456505],
Cell[13266, 330, 1301, 33, 38, "ItemizedTextParagraph",
 CellID->6284882]
}, Open  ]],
Cell[CellGroupData[{
Cell[14604, 368, 165, 3, 40, "Section",
 CellID->2103302851],
Cell[CellGroupData[{
Cell[14794, 375, 346, 8, 33, "ItemizedText",
 CellID->431683258],
Cell[15143, 385, 17643, 296, 105, "ItemizedPicture",
 CellID->49400353]
}, Open  ]],
Cell[CellGroupData[{
Cell[32823, 686, 628, 12, 58, "ItemizedText",
 CellID->642016735],
Cell[33454, 700, 26022, 434, 374, "Output",
 CellID->143521583]
}, Open  ]],
Cell[59491, 1137, 609, 12, 36, "ItemizedTextParagraph",
 CellID->1194847838],
Cell[60103, 1151, 666, 15, 36, "ItemizedTextParagraph",
 CellID->688030169],
Cell[CellGroupData[{
Cell[60794, 1170, 278, 6, 25, "ItemizedText",
 CellID->211902656],
Cell[61075, 1178, 7160, 125, 86, "ItemizedPicture",
 CellID->166790500]
}, Open  ]],
Cell[CellGroupData[{
Cell[68272, 1308, 1416, 22, 71, "ItemizedText",
 CellID->951903],
Cell[CellGroupData[{
Cell[69713, 1334, 4648, 83, 71, "ItemizedPicture",
 CellID->382280121],
Cell[74364, 1419, 6859, 119, 78, "ItemizedPicture",
 CellID->41896285]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[81272, 1544, 1083, 18, 33, "ItemizedText",
 CellID->354381513],
Cell[82358, 1564, 7566, 131, 79, "ItemizedPicture",
 CellID->241074036]
}, Open  ]],
Cell[CellGroupData[{
Cell[89961, 1700, 595, 10, 33, "ItemizedText",
 CellID->2099662060],
Cell[90559, 1712, 5056, 89, 56, "ItemizedPicture",
 CellID->153117101]
}, Open  ]],
Cell[CellGroupData[{
Cell[95652, 1806, 720, 14, 73, "ItemizedText",
 CellID->5837652],
Cell[96375, 1822, 5677, 100, 56, "ItemizedPicture",
 CellID->31808756]
}, Open  ]],
Cell[CellGroupData[{
Cell[102089, 1927, 1144, 20, 58, "ItemizedText",
 CellID->101277750],
Cell[103236, 1949, 5926, 104, 63, "ItemizedPicture",
 CellID->8301352]
}, Open  ]],
Cell[CellGroupData[{
Cell[109199, 2058, 780, 16, 58, "ItemizedText",
 CellID->490729240],
Cell[109982, 2076, 28273, 471, 230, "ItemizedPicture",
 CellID->298644160]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[138304, 2553, 175, 3, 40, "Section",
 CellID->211935376],
Cell[CellGroupData[{
Cell[138504, 2560, 591, 10, 36, "Text",
 CellID->2104468320],
Cell[139098, 2572, 11286, 192, 223, "ItemizedPicture",
 CellID->823349334]
}, Open  ]],
Cell[CellGroupData[{
Cell[150421, 2769, 630, 14, 51, "Text",
 CellID->1813611861],
Cell[151054, 2785, 3490, 64, 240, "ItemizedPicture",
 CellID->462004817]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[154593, 2855, 127, 2, 40, "Section",
 CellID->1389323153],
Cell[CellGroupData[{
Cell[154745, 2861, 474, 13, 36, "Text",
 CellID->462024330],
Cell[155222, 2876, 12236, 208, 162, "ItemizedPicture",
 CellID->131351731]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[167507, 3090, 138, 2, 40, "Section",
 CellID->889099401],
Cell[CellGroupData[{
Cell[167670, 3096, 396, 8, 21, "Text",
 CellID->2110633446],
Cell[168069, 3106, 19642, 329, 124, "ItemizedPicture",
 CellID->168563096]
}, Open  ]],
Cell[187726, 3438, 540, 12, 36, "Text",
 CellID->1909613865],
Cell[CellGroupData[{
Cell[188291, 3454, 377, 7, 36, "Text",
 CellID->1335856376],
Cell[188671, 3463, 21003, 352, 139, "ItemizedPicture",
 CellID->80331440]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[209723, 3821, 168, 3, 40, "Section",
 CellID->320656080],
Cell[209894, 3826, 279, 6, 36, "Text",
 CellID->425841723],
Cell[CellGroupData[{
Cell[210198, 3836, 65, 1, 64, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[210266, 3839, 54, 1, 20, "TutorialMoreAbout",
 CellID->1567025153]
}, Open  ]],
Cell[CellGroupData[{
Cell[210357, 3845, 72, 1, 70, "RelatedTutorialsSection",
 CellID->415694126],
Cell[210432, 3848, 52, 1, 20, "RelatedTutorials",
 CellID->806871991]
}, Open  ]],
Cell[CellGroupData[{
Cell[210521, 3854, 98, 1, 70, "TutorialRelatedLinksSection",
 CellID->415694148],
Cell[210622, 3857, 56, 1, 20, "TutorialRelatedLinks",
 CellID->415694149]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
