(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     15408,        513]
NotebookOptionsPosition[      8896,        308]
NotebookOutlinePosition[     13236,        438]
CellTagsIndexPosition[     13193,        435]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 "New in: ",
 Cell["1", "HistoryData",
  CellTags->"New"],
 " | Modified in: ",
 Cell[" ", "HistoryData",
  CellTags->"Modified"],
 " | Obsolete in: ",
 Cell[" ", "HistoryData",
  CellTags->"Obsolete"],
 " | Excised in: ",
 Cell[" ", "HistoryData",
  CellTags->"Excised"]
}], "History",
 CellChangeTimes->{3.410894606249012*^9},
 CellID->6298],

Cell[CellGroupData[{

Cell["Categorization", "CategorizationSection",
 CellLabel->
  "Categorization: metadata such as page URI, context, and type of \
documentation page",
 CellID->1122911449],

Cell["Guide", "Categorization",
 CellLabel->"Entity Type",
 CellID->686433507],

Cell["NumericalAnalysis", "Categorization",
 CellChangeTimes->{{3.410888631979097*^9, 3.4108886398616886`*^9}, {
  3.4108896172604647`*^9, 3.41088961873242*^9}},
 CellLabel->"Paclet Name",
 CellID->605800465],

Cell["NumericalAnalysis`", "Categorization",
 CellChangeTimes->{{3.410888643096857*^9, 3.4108886502482805`*^9}},
 CellLabel->"Context",
 CellID->468444828],

Cell["NumericalAnalysis/guide/NumericalAnalysisPackage", "Categorization",
 CellChangeTimes->{{3.410888656057561*^9, 3.410888667776281*^9}, {
  3.41088907595706*^9, 3.410889087757671*^9}},
 CellLabel->"URI",
 CellID->31593272]
}, Open  ]],

Cell[CellGroupData[{

Cell["Keywords", "KeywordsSection",
 CellLabel->
  "Keywords: contains a list of words or phrases to be used as keywords for \
this page when indexing",
 CellID->1427428552],

Cell["XXXX", "Keywords",
 CellID->1251852827]
}, Closed]],

Cell[CellGroupData[{

Cell["Details", "DetailsSection",
 CellLabel->
  "Details: metadata on developer(s) for the functionality described on this \
page, along with any general comments about the page",
 CellID->556663832],

Cell["XXXX", "Details",
 CellLabel->"Developers"],

Cell["XXXX", "Details",
 CellLabel->"Comments"]
}, Closed]],

Cell[CellGroupData[{

Cell["Numerical Analysis Package", "GuideTitle",
 CellChangeTimes->{{3.36793376812776*^9, 3.36793377173715*^9}, {
  3.3938484413819356`*^9, 3.3938484440301104`*^9}},
 CellLabel->"The page title",
 CellID->942062912],

Cell[TextData[{
 "The built\[Hyphen]in functions ",
 Cell[BoxData[
  ButtonBox["D",
   BaseStyle->"Link"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["Limit",
   BaseStyle->"Link"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["Residue",
   BaseStyle->"Link"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["Series",
   BaseStyle->"Link"]], "InlineFormula"],
 " perform computations using symbolic and analytic methods. The functions ",
 Cell[BoxData[
  ButtonBox["ND",
   BaseStyle->"Link",
   ButtonData->"paclet:NumericalAnalysis/ref/ND"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["NLimit",
   BaseStyle->"Link",
   ButtonData->"paclet:NumericalAnalysis/ref/NLimit"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["NResidue",
   BaseStyle->"Link",
   ButtonData->"paclet:NumericalAnalysis/ref/NResidue"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["NSeries",
   BaseStyle->"Link",
   ButtonData->"paclet:NumericalAnalysis/ref/NSeries"]], "InlineFormula"],
 ", in this package, are the numerical versions of these functions",
 "."
}], "GuideAbstract",
 CellChangeTimes->{{3.3683613778011*^9, 3.36836159299273*^9}, {
   3.371401237798204*^9, 3.371401390723524*^9}, {3.37510431837531*^9, 
   3.375104363635188*^9}, {3.37521041270959*^9, 3.375210444675766*^9}, 
   3.3798033879407587`*^9},
 CellLabel->
  "An optional paragraph describing the package's functionality, motivations, \
etc.",
 CellID->2001916300]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "GuideFunctionsSection",
 CellID->1866139230],

Cell[CellGroupData[{

Cell["Limits and Derivatives", "GuideFunctionsSubsection",
 CellChangeTimes->{{3.36793377965908*^9, 3.3679337825341*^9}},
 CellLabel->
  "A subsection header, used for grouping similar symbols on a guide page",
 CellID->173109221],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["NLimit",
   BaseStyle->"Link",
   ButtonData:>"paclet:NumericalAnalysis/ref/NLimit"]], "InlineGuideFunction"],
 " \[LongDash] numerical limit of a function"
}], "GuideText",
 CellChangeTimes->{{3.36793378554974*^9, 3.367933786331*^9}, {
  3.3679339389726*^9, 3.3679339433945*^9}, {3.36793408792665*^9, 
  3.36793408794227*^9}, {3.36819251524642*^9, 3.36819251684009*^9}},
 CellLabel->
  "Symbols important to the package often are briefly explained on the guide \
page",
 CellID->203374175],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["ND",
   BaseStyle->"Link",
   ButtonData:>"paclet:NumericalAnalysis/ref/ND"]], "InlineGuideFunction"],
 " \[LongDash] numerical derivative of a function at a point"
}], "GuideText",
 CellChangeTimes->{{3.36793378856539*^9, 3.36793378870601*^9}, {
  3.3679339508633*^9, 3.36793396784778*^9}, {3.36793409030157*^9, 
  3.36793409031719*^9}},
 CellID->1463276848],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["WorkingPrecision",
   BaseStyle->"Link"]], "InlineFormula"],
 " . ",
 Cell[BoxData[
  ButtonBox["PrecisionGoal",
   BaseStyle->"Link"]], "InlineFormula"]
}], "InlineGuideFunctionListing",
 CellChangeTimes->{{3.462023783501452*^9, 3.462023804054607*^9}},
 CellLabel->
  "Multiple less-important symbols, like options, can be listed inline",
 CellID->21735734]
}, Open  ]],

Cell["\t", "GuideDelimiter",
 CellLabel->"Delimiters such as this are used to separate subsections",
 CellID->195981991],

Cell[CellGroupData[{

Cell["Summations and Series", "GuideFunctionsSubsection",
 CellChangeTimes->{{3.36793380553425*^9, 3.36793381639369*^9}},
 CellID->137740830],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["EulerSum",
   BaseStyle->"Link",
   ButtonData:>"paclet:NumericalAnalysis/ref/EulerSum"]], 
  "InlineGuideFunction"],
 " \[LongDash] numerical sum using Euler's transformation"
}], "GuideText",
 CellChangeTimes->{{3.36793382228435*^9, 3.36793382392499*^9}, {
  3.36793399905111*^9, 3.36793400559803*^9}, {3.36793409228588*^9, 
  3.36793409230151*^9}},
 CellID->39625104],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["NSeries",
   BaseStyle->"Link",
   ButtonData:>"paclet:NumericalAnalysis/ref/NSeries"]], 
  "InlineGuideFunction"],
 " \[LongDash] numerical series expansion of a function"
}], "GuideText",
 CellChangeTimes->{{3.36793382670626*^9, 3.36793382762814*^9}, {
  3.36793401948874*^9, 3.36793402844192*^9}, {3.36793409448894*^9, 
  3.36793409450456*^9}},
 CellID->547646493]
}, Open  ]],

Cell[CellGroupData[{

Cell["\t", "GuideDelimiter",
 CellID->195090415],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["NResidue",
   BaseStyle->"Link",
   ButtonData:>"paclet:NumericalAnalysis/ref/NResidue"]], 
  "InlineGuideFunction"],
 " \[LongDash] numerical residue of an expression near a specified point"
}], "GuideText",
 CellChangeTimes->{{3.36793385011266*^9, 3.36793385225329*^9}, {
  3.36793404294201*^9, 3.36793406172338*^9}, {3.36793409670762*^9, 
  3.36793409672324*^9}},
 CellID->182913984]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tutorials", "GuideTutorialsSection",
 CellChangeTimes->{3.381931905408058*^9},
 CellLabel->"Tutorials: links to related tutorials",
 CellID->415694126],

Cell[TextData[ButtonBox["Numerical Analysis Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:NumericalAnalysis/tutorial/NumericalAnalysis"]], "GuideTutorial",
 CellChangeTimes->{{3.385403835153248*^9, 3.3854038442159214`*^9}, {
  3.4108911521705427`*^9, 3.410891155326934*^9}},
 CellID->846728239]
}, Open  ]],

Cell[CellGroupData[{

Cell["More About", "GuideMoreAboutSection",
 CellChangeTimes->{3.381931902376769*^9},
 CellLabel->"More About: links to related guide pages",
 CellID->23220180],

Cell[TextData[ButtonBox["Numerical Evaluation & Precision",
 BaseStyle->"Link",
 ButtonData:>
  "paclet:guide/NumericalEvaluationAndPrecision"]], "GuideMoreAbout",
 CellChangeTimes->{{3.36827561369415*^9, 3.36827561820986*^9}, {
  3.36827569482071*^9, 3.36827569485196*^9}},
 CellID->1567025153],

Cell[TextData[ButtonBox["Numerical Functions",
 BaseStyle->"Link",
 ButtonData:>"paclet:guide/NumericalFunctions"]], "GuideMoreAbout",
 CellChangeTimes->{{3.368275631882*^9, 3.36827563535081*^9}, {
  3.36827570227397*^9, 3.3682757022896*^9}},
 CellID->252299663]
}, Open  ]],

Cell["Related Links", "GuideRelatedLinksSection",
 CellLabel->
  "Related Links: these links can be to any related page, including web pages",
 CellID->415694148]
},
WindowSize->{719, 673},
WindowMargins->{{-3, Automatic}, {Automatic, 5}},
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (February 18, 2009)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> 
     FrontEnd`FileName[{"Wolfram"}, "GuidePageStyles.nb", CharacterEncoding -> 
       "WindowsANSI"]]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["CategorizationSection"], 
       CellLabelMargins -> {{36, Inherited}, {Inherited, Inherited}}], 
      Cell[
       StyleData["CategorizationSection", "Printout"], 
       CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}]}, 
     Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["KeywordsSection"], 
       CellLabelMargins -> {{36, Inherited}, {Inherited, Inherited}}], 
      Cell[
       StyleData["KeywordsSection", "Printout"], 
       CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}]}, 
     Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["DetailsSection"], 
       CellLabelMargins -> {{36, Inherited}, {Inherited, Inherited}}], 
      Cell[
       StyleData["DetailsSection", "Printout"], 
       CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}]}, 
     Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["GuideTitle"], 
       CellLabelMargins -> {{36, Inherited}, {Inherited, Inherited}}], 
      Cell[
       StyleData["GuideTitle", "Printout"], 
       CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}]}, 
     Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["GuideAbstract"], 
       CellLabelMargins -> {{36, Inherited}, {Inherited, Inherited}}], 
      Cell[
       StyleData["GuideAbstract", "Printout"], 
       CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}]}, 
     Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["GuideFunctionsSubsection"], 
       CellLabelMargins -> {{36, Inherited}, {Inherited, Inherited}}], 
      Cell[
       StyleData["GuideFunctionsSubsection", "Printout"], 
       CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}]}, 
     Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["GuideText"], 
       CellLabelMargins -> {{48, Inherited}, {Inherited, Inherited}}], 
      Cell[
       StyleData["GuideText", "Printout"], 
       CellLabelMargins -> {{43, Inherited}, {Inherited, Inherited}}]}, 
     Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["InlineGuideFunctionListing"], 
       CellLabelMargins -> {{48, Inherited}, {Inherited, Inherited}}], 
      Cell[
       StyleData["InlineGuideFunctionListing", "Printout"], 
       CellLabelMargins -> {{43, Inherited}, {Inherited, Inherited}}]}, 
     Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["GuideDelimiter"], 
       CellLabelMargins -> {{36, Inherited}, {Inherited, Inherited}}], 
      Cell[
       StyleData["GuideDelimiter", "Printout"], 
       CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}]}, 
     Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["GuideTutorialsSection"], 
       CellLabelMargins -> {{36, Inherited}, {Inherited, Inherited}}], 
      Cell[
       StyleData["GuideTutorialsSection", "Printout"], 
       CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}]}, 
     Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["GuideMoreAboutSection"], 
       CellLabelMargins -> {{36, Inherited}, {Inherited, Inherited}}], 
      Cell[
       StyleData["GuideMoreAboutSection", "Printout"], 
       CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}]}, 
     Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["GuideRelatedLinksSection"], 
       CellLabelMargins -> {{36, Inherited}, {Inherited, Inherited}}], 
      Cell[
       StyleData["GuideRelatedLinksSection", "Printout"], 
       CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}]}, 
     Closed]]}, Visible -> False, FrontEndVersion -> 
  "7.0 for Microsoft Windows (32-bit) (February 18, 2009)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 359, 15, 22, "History",
 CellID->6298],
Cell[CellGroupData[{
Cell[929, 39, 171, 4, 41, "CategorizationSection",
 CellID->1122911449],
Cell[1103, 45, 78, 2, 31, "Categorization",
 CellID->686433507],
Cell[1184, 49, 208, 4, 31, "Categorization",
 CellID->605800465],
Cell[1395, 55, 155, 3, 31, "Categorization",
 CellID->468444828],
Cell[1553, 60, 226, 4, 31, "Categorization",
 CellID->31593272]
}, Open  ]],
Cell[CellGroupData[{
Cell[1816, 69, 173, 4, 41, "KeywordsSection",
 CellID->1427428552],
Cell[1992, 75, 45, 1, 17, "Keywords",
 CellID->1251852827]
}, Closed]],
Cell[CellGroupData[{
Cell[2074, 81, 200, 4, 31, "DetailsSection",
 CellID->556663832],
Cell[2277, 87, 49, 1, 31, "Details"],
Cell[2329, 90, 47, 1, 31, "Details"]
}, Closed]],
Cell[CellGroupData[{
Cell[2413, 96, 215, 4, 90, "GuideTitle",
 CellID->942062912],
Cell[2631, 102, 1469, 47, 71, "GuideAbstract",
 CellID->2001916300]
}, Open  ]],
Cell[CellGroupData[{
Cell[4137, 154, 54, 1, 68, "GuideFunctionsSection",
 CellID->1866139230],
Cell[CellGroupData[{
Cell[4216, 159, 230, 4, 47, "GuideFunctionsSubsection",
 CellID->173109221],
Cell[4449, 165, 534, 13, 37, "GuideText",
 CellID->203374175],
Cell[4986, 180, 403, 10, 23, "GuideText",
 CellID->1463276848],
Cell[5392, 192, 402, 12, 37, "InlineGuideFunctionListing",
 CellID->21735734]
}, Open  ]],
Cell[5809, 207, 120, 2, 40, "GuideDelimiter",
 CellID->195981991],
Cell[CellGroupData[{
Cell[5954, 213, 141, 2, 33, "GuideFunctionsSubsection",
 CellID->137740830],
Cell[6098, 217, 414, 11, 23, "GuideText",
 CellID->39625104],
Cell[6515, 230, 411, 11, 23, "GuideText",
 CellID->547646493]
}, Open  ]],
Cell[CellGroupData[{
Cell[6963, 246, 48, 1, 26, "GuideDelimiter",
 CellID->195090415],
Cell[7014, 249, 430, 11, 23, "GuideText",
 CellID->182913984]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7493, 266, 157, 3, 84, "GuideTutorialsSection",
 CellID->415694126],
Cell[7653, 271, 302, 6, 20, "GuideTutorial",
 CellID->846728239]
}, Open  ]],
Cell[CellGroupData[{
Cell[7992, 282, 160, 3, 84, "GuideMoreAboutSection",
 CellID->23220180],
Cell[8155, 287, 295, 6, 20, "GuideMoreAbout",
 CellID->1567025153],
Cell[8453, 295, 262, 5, 20, "GuideMoreAbout",
 CellID->252299663]
}, Open  ]],
Cell[8730, 303, 162, 3, 84, "GuideRelatedLinksSection",
 CellID->415694148]
}
]
*)

(* End of internal cache information *)
