(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    104282,       3566]
NotebookOptionsPosition[     74564,       2814]
NotebookOutlinePosition[     74908,       2829]
CellTagsIndexPosition[     74865,       2826]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Style Definitions for Function Pages", "Title",
 CellChangeTimes->{{3.464621101598092*^9, 3.4646211023793526`*^9}}],

Cell[StyleData[StyleDefinitions -> "Core.nb"]],

Cell[StyleData[StyleDefinitions -> "StyleMenuClear.nb"]],

Cell[CellGroupData[{

Cell["Style Environment Names", "Section"],

Cell[StyleData[All, "Working"],
 PageWidth->650,
 ShowCellBracket->True,
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 ShowAutoStyles->False,
 ScriptMinSize->9,
 MenuSortingValue->1100],

Cell[StyleData[All, "Preview"],
 PageWidth->650,
 ShowCellBracket->False,
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 ShowAutoStyles->False,
 ScriptMinSize->9,
 MenuSortingValue->1200],

Cell[StyleData[All, "Printout"],
 PageWidth->PaperWidth,
 ShowCellBracket->False,
 ShowAutoStyles->False,
 ScriptMinSize->5,
 MenuSortingValue->1300,
 PrivateFontOptions->{"FontType"->"Outline"}],

Cell[StyleData[All, "InternalDocument"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.9, 1, 0.5]],

Cell[StyleData[All, "ObsoleteObject"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[1, 0.95, 0.8]],

Cell[StyleData[All, "FutureObject"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[1, 0.8, 0.9]],

Cell[StyleData[All, "TentativeObject"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.85, 0.95, 1]],

Cell[StyleData[All, "TemporaryObject"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.5, 1, 0.95]],

Cell[StyleData[All, "AwaitingFutureDesignReview"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.9, 0.9, 1]],

Cell[StyleData[All, "PreviewDocument"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.8, 0.9, 1]],

Cell[StyleData[All, "ExcisedObject"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->GrayLevel[0.6]],

Cell[StyleData[All, "Condensed"],
 MenuSortingValue->0],

Cell[StyleData[All, "Presentation"],
 MenuSortingValue->0],

Cell[StyleData[All, "SlideShow"],
 MenuSortingValue->0]
}, Closed]],

Cell[CellGroupData[{

Cell["Notebook Options", "Section"],

Cell["\<\
  The options defined for the style below will be used at the Notebook level.\
\>", "Text",
 CellChangeTimes->{{3.35428247134284*^9, 3.35428247821855*^9}}],

Cell[StyleData["Notebook"],
 PageHeaders->{{None, None, None}, {None, None, 
    Cell[
     TextData[{
       Cell[
        TextData[{"Printed from the ", 
          StyleBox["Mathematica", FontSlant -> "Italic"], " Help System "}], 
        "PageHeader"], 
       Cell[
        TextData[{
          CounterBox["Page"]}], "PageNumber"]}], 
     CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
 PageFooters->{{None, None, None}, {
    Cell[
     TextData[{
      "\[Copyright]1988\[Dash]2008 Wolfram Research, Inc. All rights \
reserved."}], "PageFooter"], None, None}},
 PageHeaderLines->{False, False},
 PageFooterLines->{False, False},
 PrintingOptions->{"FacingPages"->False},
 CreateCellID->True,
 CellContext->CellGroup,
 CellLabelAutoDelete->False,
 CellFrameLabelMargins->6,
 DefaultNewInlineCellStyle->"InlineFormula",
 DefaultInlineFormatType->"DefaultInputInlineFormatType",
 InputAliases->{"intt" -> RowBox[{"\[Integral]", 
      RowBox[{"\[SelectionPlaceholder]", 
        RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "dintt" -> RowBox[{
      SubsuperscriptBox[
      "\[Integral]", "\[SelectionPlaceholder]", "\[Placeholder]"], 
      RowBox[{"\[Placeholder]", 
        RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "sumt" -> RowBox[{
      UnderoverscriptBox["\[Sum]", 
       RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
       "\[Placeholder]"], "\[Placeholder]"}], "prodt" -> RowBox[{
      UnderoverscriptBox["\[Product]", 
       RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
       "\[Placeholder]"], "\[Placeholder]"}], "dt" -> RowBox[{
      SubscriptBox["\[PartialD]", "\[Placeholder]"], " ", 
      "\[SelectionPlaceholder]"}], "ls" -> "\[LineSeparator]"},
 InputAutoReplacements->{"->" -> "->", "gridMathematica" -> FormBox[
     RowBox[{"grid", 
       AdjustmentBox[
        StyleBox["Mathematica", FontSlant -> "Italic"], 
        BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], "webMathematica" -> 
   FormBox[
     RowBox[{"web", 
       AdjustmentBox[
        StyleBox["Mathematica", FontSlant -> "Italic"], 
        BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm]},
 TrackCellChangeTimes->True,
 AutoQuoteCharacters->{},
 PasteAutoQuoteCharacters->{},
 ShowStringCharacters->True,
 CacheGraphics->False,
 StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Input/Output", "Section"],

Cell["\<\
The cells in this section define styles used for input and output to the \
kernel.  Be careful when modifying, renaming, or removing these styles, \
because the front end associates special meanings with these style names.    \
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["Input"],
 ShowCellBracket->True,
 CellMargins->{{114, 4}, {3, 8}},
 CellProlog->DocumentationTools`WolframDocumentProlog[],
 CellLabelAutoDelete->False,
 CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
 MenuSortingValue->1200,
 MenuCommandKey->"9"],

Cell[StyleData["Input", "Printout"],
 ShowCellBracket->False,
 CellMargins->{{79, 0}, {4, 6}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Output"],
 ShowCellBracket->True,
 CellMargins->{{114, 4}, {8, 2}},
 CellAutoOverwrite->True,
 CellLabelPositioning->Left,
 CellLabelAutoDelete->False,
 CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
 GraphicsBoxOptions->{ImageSize->Small},
 Graphics3DBoxOptions->{ImageSize->Small}],

Cell[StyleData["Output", "Printout"],
 ShowCellBracket->False,
 CellMargins->{{79, 0}, {6, 4}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OutputStub"],
 ShowCellBracket->True,
 CellMargins->{{114, 4}, {8, 2}}],

Cell[StyleData["OutputStub", "Printout"],
 ShowCellBracket->False,
 CellMargins->{{79, 0}, {6, 4}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InputOnly"],
 ShowCellBracket->True,
 CellMargins->{{114, 4}, {3, 8}},
 CellLabelAutoDelete->False,
 CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}}],

Cell[StyleData["InputOnly", "Printout"],
 ShowCellBracket->False,
 CellMargins->{{79, 0}, {6, 6}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Message"],
 ShowCellBracket->True,
 CellMargins->{{114, 4}, {4, 2}},
 ShowCellLabel->False,
 CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
 StyleMenuListing->None],

Cell[StyleData["Message", "Printout"],
 CellDingbat->None,
 ShowCellBracket->False,
 CellMargins->{{68, Inherited}, {Inherited, Inherited}},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Print"],
 PageWidth->WindowWidth,
 ShowCellBracket->True,
 CellMargins->{{114, 27}, {4, 2}},
 CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}}],

Cell[StyleData["Print", "Printout"],
 ShowCellBracket->False,
 CellMargins->{{68, 2}, {Inherited, Inherited}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CellLabel"]],

Cell[StyleData["CellLabel", "Printout"],
 FontSize->7,
 FontSlant->"Oblique",
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Name"],
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontSize->9,
 FontWeight->"Plain",
 FontSlant->"Italic",
 FontColor->RGBColor[0.269993, 0.308507, 0.6]],

Cell[StyleData["Name", "Printout"],
 FontSize->7,
 FontSlant->"Oblique",
 FontColor->GrayLevel[0]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Function Page Styles", "Section"],

Cell[CellGroupData[{

Cell[StyleData["History"],
 Editable->False,
 PageWidth->680,
 CellMargins->{{48, 12}, {Inherited, Inherited}},
 TaggingRules->{"Tentativeable" -> False},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->12,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["History", "Printout"],
 CellMargins->{{24, 12}, {Inherited, Inherited}},
 FontSize->9]
}, Closed]],

Cell[StyleData["HistoryData"],
 Editable->True,
 Deletable->False,
 CellSize->{36, 14},
 StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["InternalFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{48, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["InternalFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FutureFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{48, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["FutureFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TemporaryFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{48, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["TemporaryFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ObsoleteFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{48, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["ObsoleteFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExcisedFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{48, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.8]],

Cell[StyleData["ExcisedFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubjectToChangeFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{48, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["SubjectToChangeFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AwaitingFutureDesignReviewFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{48, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["AwaitingFutureDesignReviewFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PreviewFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{48, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["PreviewFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CategorizationSection"],
 CellMargins->{{48, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 TaggingRules->{"Tentativeable" -> False},
 DefaultNewCellStyle->"Categorization",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["CategorizationSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Categorization"],
 CellMargins->{{72, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 TaggingRules->{"Tentativeable" -> False},
 CellLabelPositioning->Above,
 CellLabelMargins->{{48, Inherited}, {Inherited, Inherited}},
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["Categorization", "Printout"],
 CellMargins->{{36, 80}, {2, 2}},
 CellLabelMargins->{{24, Inherited}, {Inherited, Inherited}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SynonymsSection"],
 CellMargins->{{48, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 TaggingRules->{"Tentativeable" -> False},
 DefaultNewCellStyle->"Synonyms",
 ParagraphSpacing->{0.7000000000000002, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["SynonymsSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[StyleData["Synonyms"],
 CellMargins->{{72, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 TaggingRules->{"Tentativeable" -> False},
 CellLabelPositioning->Above,
 CellLabelMargins->{{28, Inherited}, {Inherited, Inherited}},
 ParagraphSpacing->{0.7000000000000002, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["KeywordsSection"],
 CellMargins->{{48, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 TaggingRules->{"Tentativeable" -> False},
 DefaultNewCellStyle->"Keywords",
 ParagraphSpacing->{0.7000000000000001, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["KeywordsSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Keywords"],
 CellMargins->{{72, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 TaggingRules->{"Tentativeable" -> False},
 CellLabelPositioning->Above,
 CellLabelMargins->{{48, Inherited}, {Inherited, Inherited}},
 ParagraphSpacing->{0.7000000000000001, 0},
 AutoItalicWords->{},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["Keywords", "Printout"],
 CellMargins->{{36, 80}, {2, 2}},
 CellLabelMargins->{{24, Inherited}, {Inherited, Inherited}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DocumentStatusSection"],
 CellMargins->{{48, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"DocumentStatus",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["DocumentStatusSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DocumentStatus"],
 CellMargins->{{72, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 CellLabelPositioning->Above,
 CellLabelMargins->{{48, Inherited}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["DocumentStatus", "Printout"],
 CellMargins->{{36, 80}, {2, 2}},
 CellLabelMargins->{{24, Inherited}, {Inherited, Inherited}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DetailsSection"],
 CellMargins->{{48, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 TaggingRules->{"Tentativeable" -> False},
 DefaultNewCellStyle->"DocumentStatus",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["DetailsSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Details"],
 CellMargins->{{72, 80}, {2, 2}},
 TaggingRules->{"Tentativeable" -> False},
 CellLabelPositioning->Above,
 CellLabelMargins->{{48, Inherited}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["Details", "Printout"],
 CellMargins->{{36, 80}, {2, 2}},
 CellLabelMargins->{{24, Inherited}, {Inherited, Inherited}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExampleStatusSection"],
 CellMargins->{{48, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"ExampleStatus",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["ExampleStatusSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExampleStatus"],
 CellMargins->{{72, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 CellLabelPositioning->Above,
 CellLabelMargins->{{48, Inherited}, {Inherited, Inherited}},
 ShowStringCharacters->False,
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["ExampleStatus", "Printout"],
 CellMargins->{{36, 80}, {2, 2}},
 CellLabelMargins->{{24, Inherited}, {Inherited, Inherited}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TemplatesSection"],
 CellMargins->{{48, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 TaggingRules->{"Tentativeable" -> False},
 DefaultNewCellStyle->"Template",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["TemplatesSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Template"],
 CellMargins->{{72, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 59},
 TaggingRules->{"Tentativeable" -> False},
 CellLabelPositioning->Above,
 CellLabelMargins->{{48, Inherited}, {1, 8}},
 CellFrameMargins->4,
 CellFrameColor->RGBColor[0.960006, 0.910002, 0.850004],
 DefaultNewInlineCellStyle->"None",
 DefaultFormatType->DefaultInputFormatType,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->10,
 FontWeight->"Plain"],

Cell[StyleData["Template", "Printout"],
 CellMargins->{{36, 80}, {2, 2}},
 CellLabelMargins->{{24, Inherited}, {Inherited, Inherited}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AllowableOptionsSection"],
 CellMargins->{{48, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"AllowableOptions",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["AllowableOptionsSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AllowableOptions"],
 CellMargins->{{72, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 59},
 CellLabelPositioning->Above,
 CellLabelMargins->{{40, Inherited}, {1, 8}},
 CellFrameMargins->4,
 CellFrameColor->RGBColor[0.960006, 0.910002, 0.850004],
 DefaultNewInlineCellStyle->"None",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->10,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["AllowableOptions", "Printout"],
 CellMargins->{{36, 80}, {2, 2}},
 CellLabelMargins->{{24, Inherited}, {Inherited, Inherited}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AttributesSection"],
 CellMargins->{{48, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"Attributes",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["AttributesSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Attributes"],
 CellMargins->{{72, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 59},
 CellLabelPositioning->Above,
 CellLabelMargins->{{40, Inherited}, {1, 8}},
 CellFrameMargins->4,
 CellFrameColor->RGBColor[0.960006, 0.910002, 0.850004],
 DefaultNewInlineCellStyle->"None",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->10,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["Attributes", "Printout"],
 CellMargins->{{36, 80}, {2, 2}},
 CellLabelMargins->{{24, Inherited}, {Inherited, Inherited}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ErrorMessagesSection"],
 CellMargins->{{48, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["ErrorMessagesSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ErrorMessages"],
 CellMargins->{{72, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 59},
 CellLabelPositioning->Above,
 CellLabelMargins->{{40, Inherited}, {1, 8}},
 CellFrameMargins->4,
 CellFrameColor->RGBColor[0.960006, 0.910002, 0.850004],
 DefaultNewInlineCellStyle->"None",
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->10,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["ErrorMessages", "Printout"],
 CellMargins->{{36, 80}, {2, 2}},
 CellLabelMargins->{{24, Inherited}, {Inherited, Inherited}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["UsageMessagesSection"],
 CellMargins->{{48, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["UsageMessagesSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["UsageMessages"],
 CellMargins->{{72, 80}, {18, 0}},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 59},
 CellFrameMargins->4,
 CellFrameColor->RGBColor[0.960006, 0.910002, 0.850004],
 DefaultNewInlineCellStyle->"None",
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->10,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["UsageMessages", "Printout"],
 CellMargins->{{36, 80}, {16, 2}},
 CellLabelMargins->{{24, Inherited}, {Inherited, Inherited}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Section"],
 ShowCellBracket->True,
 CellMargins->{{48, 4}, {12, 18}},
 CellGroupingRules->{"SectionGrouping", 30},
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 FontFamily->"Verdana",
 FontSize->13,
 FontWeight->"Bold",
 FontColor->RGBColor[0.6, 0.45, 0.35]],

Cell[StyleData["Section", "Printout"],
 CellMargins->{{12, 0}, {10, 16}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->11]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Status"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{48, 12}, {0, 30}},
 CellElementSpacings->{"ClosedGroupTopMargin"->50},
 CellGroupingRules->{"SectionGrouping", 50},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["Status", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ObjectName"],
 Editable->True,
 ShowCellBracket->True,
 CellMargins->{{45, 12}, {10, 30}},
 CellElementSpacings->{"ClosedGroupTopMargin"->62},
 CellGroupingRules->{"SectionGrouping", 50},
 TaggingRules->{"Tentativeable" -> False},
 CellLabelPositioning->Above,
 DefaultNewCellStyle->"Notes",
 DefaultNewInlineCellStyle->"InlineMath",
 DefaultInlineFormatType->"DefaultTextInlineFormatType",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->18,
 FontWeight->"Bold",
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {Left, {Right}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {{
      Scaled[0.5]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["ObjectName", "Printout"],
 CellMargins->{{24, 8}, {8, 27}},
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->16]
}, Closed]],

Cell[StyleData["ObjectNameSmall", StyleDefinitions -> StyleData["ObjectName"]]],

Cell[CellGroupData[{

Cell[StyleData["ObjectNameAlt"],
 CellMargins->{{45, 12}, {10, 30}},
 CellElementSpacings->{"ClosedGroupTopMargin"->62},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"Notes",
 DefaultNewInlineCellStyle->"InlineMath",
 DefaultInlineFormatType->"DefaultTextInlineFormatType",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->18,
 FontWeight->"Bold",
 FontColor->RGBColor[0.4, 0.3, 0.3],
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {Left, {Right}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {{
      Scaled[0.5]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["ObjectNamealt", "Printout"],
 CellMargins->{{24, 8}, {8, 27}},
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->16]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FullListing"],
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->RGBColor[0.7, 0.4, 0]],

Cell[StyleData["FullListing", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ObsolescenceNote"],
 CellFrame->True,
 CellMargins->{{9, 8}, {12, 6}},
 CellFrameMargins->{{38, 12}, {12, 12}},
 CellFrameColor->RGBColor[0.9, 0.9, 0],
 Hyphenation->False,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 Background->RGBColor[1, 1, 0]],

Cell[StyleData["ObsolescenceNote", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 StyleMenuListing->None,
 FontSize->10,
 FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AwaitingReviewNote"],
 Editable->False,
 CellFrame->True,
 CellMargins->{{9, 8}, {12, 6}},
 CellFrameMargins->{{38, 12}, {12, 12}},
 CellFrameColor->RGBColor[0.9, 0.9, 0],
 Hyphenation->False,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 Background->RGBColor[1, 1, 0]],

Cell[StyleData["AwaitingReviewNote", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 StyleMenuListing->None,
 FontSize->10,
 FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PreviewNote"],
 Editable->False,
 CellFrame->True,
 CellMargins->{{9, 8}, {12, 6}},
 CellFrameMargins->{{38, 12}, {12, 12}},
 CellFrameColor->RGBColor[0.6, 0.7, 1],
 Hyphenation->False,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 Background->RGBColor[0.9, 0.98, 1]],

Cell[StyleData["PreviewNote", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 StyleMenuListing->None,
 FontSize->10,
 FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Usage"],
 Editable->True,
 CellFrame->True,
 ShowCellBracket->True,
 CellMargins->{{9, 8}, {12, 6}},
 CellFrameMargins->{{12, 12}, {12, 12}},
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 Hyphenation->False,
 ParagraphSpacing->{0.5, 0},
 ParagraphIndent->-52,
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 Background->RGBColor[0.960784, 0.945098, 0.905882],
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{},
 GridBoxItemSize->{},
 GridBoxSpacings->{}}],

Cell[StyleData["Usage", "Printout"],
 CellFrame->0.5,
 CellMargins->{{0, 0}, {10, 5}},
 CellFrameMargins->{{4, 23}, {10, 10}},
 CellFrameColor->GrayLevel[0.5],
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 LineSpacing->{1., 2, 2.},
 ParagraphIndent->-40,
 StyleMenuListing->None,
 FontSize->10,
 FontWeight->"Plain",
 Background->GrayLevel[0.95]],

Cell[StyleData["Usage", "InternalDocument"],
 Background->RGBColor[0.9, 1, 0.5]],

Cell[StyleData["Usage", "ObsoleteObject"],
 Background->RGBColor[1, 0.95, 0.8]],

Cell[StyleData["Usage", "FutureObject"],
 Background->RGBColor[1, 0.8, 0.9]],

Cell[StyleData["Usage", "TemporaryObject"],
 Background->RGBColor[0.5, 1, 0.95]],

Cell[StyleData["Usage", "SubjectToChange"],
 Background->RGBColor[0.9, 0.9, 1]],

Cell[StyleData["Usage", "AwaitingFutureDesignReview"],
 Background->RGBColor[0.9, 0.9, 1]],

Cell[StyleData["Usage", "PreviewDocument"],
 Background->RGBColor[0.8, 0.9, 1]],

Cell[StyleData["Usage", "ExcisedObject"],
 Background->GrayLevel[0.6]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ModInfo"],
 CellSize->{25, Inherited},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->Inherited 0.9,
 FontWeight->"Plain",
 FontColor->RGBColor[0.269993, 0.308507, 0.6]],

Cell[StyleData["ModInfo", "Printout"],
 CellSize->{20, Inherited},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"}]
}, Closed]],

Cell[StyleData["DingbatMod"],
 CellDingbat->None,
 TextAlignment->Right,
 MenuSortingValue->None],

Cell[CellGroupData[{

Cell[StyleData["BrightFlag"],
 StyleMenuListing->None,
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontColor->GrayLevel[1],
 Background->RGBColor[1, 0, 0],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>(DocumentationTools`DocLink[#, #2]& ),
 Evaluator->Automatic}],

Cell[StyleData["BrightFlag", "Printout"],
 Background->GrayLevel[0.8]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BrighterFlag"],
 StyleMenuListing->None,
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontColor->GrayLevel[1],
 Background->RGBColor[1, 0., 0.8],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>(DocumentationTools`DocLink[#, #2]& ),
 Evaluator->Automatic}],

Cell[StyleData["BrighterFlag", "Printout"],
 Background->GrayLevel[0.9]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TemplateExclusion"],
 StyleMenuListing->None,
 Background->RGBColor[1, 0.7, 0.7]],

Cell[StyleData["TemplateExclusion", "Printout"],
 Background->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TemplateInclusion"],
 StyleMenuListing->None,
 Background->RGBColor[0.85, 0.95, 0.85]],

Cell[StyleData["TemplateInclusion", "Printout"],
 Background->None]
}, Closed]],

Cell[StyleData["ConversionSpecial"],
 CellBracketOptions->{"Color"->RGBColor[0.7, 0.5, 0.8],
 "Thickness"->3},
 GeneratedCellStyles->{"Graphics"->{"Graphics", "ConversionSpecial"},
 "Message"->{"Message", "MSG", "ConversionSpecial"},
 "Output"->{"Output", "ConversionSpecial"},
 "Print"->{"Print", "ConversionSpecial"},
 "PrintTemporary"->{"PrintTemporary", "ConversionSpecial"}},
 StyleMenuListing->None],

Cell[StyleData["ConversionLockdown"],
 CellBracketOptions->{"Color"->RGBColor[0.8, 0.5, 0.4],
 "Thickness"->3},
 Evaluatable->False,
 StyleMenuListing->None],

Cell[StyleData["FutureExample"],
 CellBracketOptions->{"Color"->RGBColor[0.9, 0.4, 0.4],
 "Thickness"->5},
 GeneratedCellStyles->{"Graphics"->{"Graphics", "FutureExample"},
 "Message"->{"Message", "MSG", "FutureExample"},
 "Output"->{"Output", "FutureExample"},
 "Print"->{"Print", "FutureExample"},
 "PrintTemporary"->{"PrintTemporary", "FutureExample"}},
 CellFrameMargins->4,
 StyleMenuListing->None,
 Background->RGBColor[1, 0.9500000000000003, 0.9500000000000003]],

Cell[StyleData["TentativeExample"],
 CellBracketOptions->{
 "Color"->RGBColor[
  0.30000000000000016`, 0.6000000000000003, 0.7000000000000003],
 "Thickness"->5},
 GeneratedCellStyles->{"Graphics"->{"Graphics", "TentativeExample"},
 "Message"->{"Message", "MSG", "TentativeExample"},
 "Output"->{"Output", "TentativeExample"},
 "Print"->{"Print", "TentativeExample"},
 "PrintTemporary"->{"PrintTemporary", "TentativeExample"}},
 CellFrameMargins->4,
 StyleMenuListing->None,
 Background->RGBColor[0.8500000000000003, 0.9500000000000003, 1]],

Cell[CellGroupData[{

Cell[StyleData["TentativeID"],
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Plain",
 FontColor->RGBColor[0.10000000000000002`, 0.30000000000000016`, 0.4],
 Background->GrayLevel[1]],

Cell[StyleData["TentativeID", "Printout"]]
}, Closed]],

Cell[StyleData["ExcludedMaterial"],
 CellBracketOptions->{"Color"->RGBColor[0.8, 0.8, 0.6],
 "Thickness"->5},
 GeneratedCellStyles->{"Graphics"->{"Graphics", "ExcludedMaterial"},
 "Message"->{"Message", "MSG", "ExcludedMaterial"},
 "Output"->{"Output", "ExcludedMaterial"},
 "Print"->{"Print", "ExcludedMaterial"},
 "PrintTemporary"->{"PrintTemporary", "ExcludedMaterial"}},
 CellFrameMargins->4,
 StyleMenuListing->None,
 Background->RGBColor[0.95, 0.95, 0.8]],

Cell[CellGroupData[{

Cell[StyleData["TextAnnotation"],
 CellFrame->1,
 CellFrameColor->RGBColor[0.8, 0, 0],
 AutoSpacing->False,
 LineIndent->Automatic,
 FontSize->11,
 FontWeight->"Plain",
 FontColor->RGBColor[0.4, 0.2, 0.2],
 Background->GrayLevel[0.999]],

Cell[StyleData["TextAnnotation", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextAnnotationButton"],
 Editable->False,
 FontFamily->"Verdana",
 FontSize->9,
 ButtonBoxOptions->{Active->True,
 Appearance->"DialogBox",
 ButtonFunction:>(Needs["DocumentationTools`"]; 
  DocumentationTools`GenerateAnnotationDialog[]),
 ButtonMargins->1,
 Evaluator->Automatic,
 Method->"Queued"}],

Cell[StyleData["TextAnnotationButton", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextAnnotationRemoveButton"],
 Editable->False,
 FontFamily->"Verdana",
 FontSize->9,
 ButtonBoxOptions->{Active->True,
 Appearance->"DialogBox",
 ButtonFunction:>(Needs["DocumentationTools`"]; 
  DocumentationTools`AnnotationRemove[
   DocumentationTools`CalledFromFrameLabel -> True]),
 ButtonMargins->1,
 Evaluator->Automatic,
 Method->"Queued"}],

Cell[StyleData["TextAnnotationRemoveButton", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Notes"],
 Editable->True,
 CellDingbat->None,
 ShowCellBracket->True,
 CellMargins->{{48, 12}, {5, 5}},
 ReturnCreatesNewCell->True,
 TaggingRules->{"AddModInfo" -> True},
 CellFrameLabelMargins->2,
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], 
   "gridMathematica" -> FormBox[
     RowBox[{"grid", 
       AdjustmentBox[
        StyleBox["Mathematica", FontSlant -> "Italic"], 
        BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], "webMathematica" -> 
   FormBox[
     RowBox[{"web", 
       AdjustmentBox[
        StyleBox["Mathematica", FontSlant -> "Italic"], 
        BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm]},
 MenuSortingValue->700,
 MenuCommandKey->"1",
 FontFamily->"Verdana",
 FontSize->11],

Cell[StyleData["Notes", "Printout"],
 CellMargins->{{24, 0}, {4, 4}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 LineSpacing->{1., 2, 2.},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["1ColumnTable"],
 PageWidth->700,
 CellMargins->{{66, 50}, {6, 0}},
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {{
      Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridDefaultElement->Cell["XXXX", "TableText"]}],

Cell[StyleData["1ColumnTable", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {0, 8}},
 FontSize->9,
 GridBoxOptions->{GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.56]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["2ColumnTable"],
 PageWidth->700,
 CellMargins->{{66, 50}, {6, 0}},
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.4], {
      Scaled[0.6]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["2ColumnTable", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {0, 8}},
 FontSize->9,
 GridBoxOptions->{GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.56]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["3ColumnTable"],
 PageWidth->700,
 CellMargins->{{66, 50}, {6, 0}},
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.28], 
     Scaled[0.28], {
      Scaled[0.44]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["3ColumnTable", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {0, 8}},
 FontSize->9,
 GridBoxOptions->{GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.56]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["1ColumnTableMod"],
 PageWidth->700,
 CellMargins->{{40, 50}, {6, 0}},
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{
  "Columns" -> {{False}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {False, {False}, False}, "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.04], {
      Scaled[0.966]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], 
     Offset[0.126], {
      Offset[0.77]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.4]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}],

Cell[StyleData["1ColumnTableMod", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {5, 0}},
 FontSize->9,
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.078], {
      Scaled[0.922]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.56]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["2ColumnTableMod"],
 PageWidth->700,
 CellMargins->{{40, 50}, {6, 0}},
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{
  "Columns" -> {{False}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {False, {False}, False}, "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.41], {
      Scaled[0.54]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], 
     Offset[0.14], {
      Offset[0.77]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.4]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}],

Cell[StyleData["2ColumnTableMod", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {5, 0}},
 FontSize->9,
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.079], 
     Scaled[0.363], {
      Scaled[0.558]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.56]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["3ColumnTableMod"],
 PageWidth->700,
 CellMargins->{{40, 50}, {6, 0}},
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{
  "Columns" -> {{False}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {False, {False}, False}, "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.04], 
     Scaled[0.266], 
     Scaled[0.26], {
      Scaled[0.434]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], 
     Offset[0.14], {
      Offset[0.77]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.4]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}],

Cell[StyleData["3ColumnTableMod", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {5, 0}},
 FontSize->9,
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.08], 
     Scaled[0.25], 
     Scaled[0.25], {
      Scaled[0.42]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.56]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableText"],
 DefaultInlineFormatType->"DefaultInputInlineFormatType",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->Inherited 0.952],

Cell[StyleData["TableText", "Printout"],
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 LineSpacing->{1., 2, 2.}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineFormula"],
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LanguageCategory->"Formula",
 AutoSpacing->True,
 ScriptLevel->1,
 AutoMultiplicationSymbol->False,
 SingleLetterItalics->False,
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->12,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 FractionBoxOptions->{BaseStyle->{SpanMaxSize -> Automatic}},
 GridBoxOptions->{
 GridBoxItemSize->{
  "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["InlineFormula", "Working"],
 Background->RGBColor[1, 0.875, 0.75]],

Cell[StyleData["InlineFormula", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineOutput"],
 CellMargins->{{27, 4}, {0, 8}},
 CellHorizontalScrolling->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LanguageCategory->None,
 AutoMultiplicationSymbol->False,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->12],

Cell[StyleData["InlineOutput", "Printout"],
 CellMargins->{{2, 0}, {0, 8}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineMath"],
 DefaultFormatType->"DefaultTextFormatType",
 DefaultInlineFormatType->"TraditionalForm",
 LanguageCategory->"Formula",
 AutoSpacing->True,
 ScriptLevel->1,
 AutoMultiplicationSymbol->False,
 SingleLetterItalics->True,
 SpanMaxSize->Infinity,
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->1.05 Inherited,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxItemSize->{
  "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["InlineMath", "Working"],
 Background->RGBColor[0.875, 0.9375, 1]],

Cell[StyleData["InlineMath", "Printout"],
 CellMargins->{{2, 0}, {0, 8}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Code"],
 CellMargins->{{107, 10}, {5, 7}},
 CellGroupingRules->"InputGrouping",
 StripStyleOnPaste->True,
 PageBreakWithin->False,
 GroupPageBreakWithin->False,
 AutoIndent->False,
 ShowAutoStyles->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LineSpacing->{1.2, 1., 2.},
 AutoItalicWords->{},
 AutoSpacing->False,
 ShowStringCharacters->True,
 CounterIncrements->"Code",
 FontFamily->"Courier",
 Background->GrayLevel[0.92]],

Cell[StyleData["Code", "Printout"],
 CellMargins->{{39, 0}, {4, 6}},
 Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Program"],
 CellMargins->{{107, 10}, {5, 7}},
 CellGroupingRules->"InputGrouping",
 StripStyleOnPaste->True,
 PageBreakWithin->False,
 GroupPageBreakWithin->False,
 AutoIndent->False,
 ShowAutoStyles->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LineSpacing->{1.2, 1., 2.},
 AutoItalicWords->{},
 AutoSpacing->False,
 ShowStringCharacters->True,
 CounterIncrements->"Code",
 FontFamily->"Courier",
 Background->GrayLevel[0.92]],

Cell[StyleData["Program", "Printout"],
 CellMargins->{{39, 0}, {4, 6}},
 Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PrimaryExamplesSection"],
 CellFrame->{{0, 0}, {0, 0.5}},
 CellMargins->{{48, 8}, {12, 36}},
 CellElementSpacings->{"ClosedGroupTopMargin"->60},
 Evaluatable->True,
 CellGroupingRules->{"SectionGrouping", 30},
 TaggingRules->{"Tentativeable" -> False},
 ShowCellLabel->False,
 CellLabelAutoDelete->True,
 CellFrameMargins->4,
 DefaultNewCellStyle->"Input",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {Left, {Right}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {{
      Scaled[0.5]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["PrimaryExamplesSection", "Printout"],
 CellMargins->{{24, 0}, {10, 32}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExtendedExamplesLink"],
 ParagraphSpacing->{0, 3},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontWeight->"Plain",
 FontColor->GrayLevel[0.5],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`NotebookLocate[#2]}]& )}],

Cell[StyleData["ExtendedExamplesLink", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExtendedExamplesSection"],
 CellFrame->{{0, 0}, {0, 0.5}},
 CellMargins->{{48, 8}, {0, 36}},
 CellElementSpacings->{"ClosedGroupTopMargin"->36},
 CellGroupingRules->{"SectionGrouping", 30},
 TaggingRules->{"Tentativeable" -> False},
 CellFrameMargins->4,
 DefaultNewCellStyle->"Input",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {Left, {Right}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {{
      Scaled[0.5]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["ExtendedExamplesSection", "Printout"],
 CellMargins->{{24, 0}, {0, 32}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExampleDelimiter"],
 CellMargins->{{72, 10}, {0, 3}},
 Evaluatable->True,
 CellGroupingRules->{"SectionGrouping", 58},
 ShowCellLabel->False,
 CellLabelAutoDelete->True,
 TabFilling->".\[ThinSpace]",
 TabSpacings->{68},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Plain",
 FontSlant->"Plain",
 DefaultContext -> SectionUnique],

Cell[StyleData["ExampleDelimiter", "Printout"],
 CellMargins->{{43, 0}, {0, 3}},
 TabSpacings->{71.3},
 FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExampleText"],
 CellMargins->{{72, 40}, {0, 8}},
 ReturnCreatesNewCell->True,
 TaggingRules->{"AddModInfo" -> True},
 DefaultReturnCreatedCellStyle->"Input",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 ParagraphSpacing->{0, 6},
 MenuSortingValue->1100,
 MenuCommandKey->"5",
 FontFamily->"Verdana",
 FontSize->10],

Cell[StyleData["ExampleText", "Printout"],
 CellMargins->{{43, 80}, {0, 6}},
 PageBreakBelow->False,
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->8,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExampleSection"],
 Editable->True,
 CellMargins->{{72, 4}, {0, 16}},
 Evaluatable->True,
 CellGroupingRules->{"SectionGrouping", 54},
 TaggingRules->{"Tentativeable" -> False},
 ShowCellLabel->False,
 CellLabelAutoDelete->True,
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->RGBColor[0.1, 0.2, 0.5],
 DefaultContext -> SectionUnique],

Cell[StyleData["ExampleSection", "Printout"],
 CellMargins->{{43, 0}, {0, 14}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExampleSubsection"],
 Editable->True,
 CellMargins->{{72, 4}, {0, 8}},
 Evaluatable->True,
 CellGroupingRules->{"SectionGrouping", 56},
 ShowCellLabel->False,
 CellLabelAutoDelete->True,
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Bold",
 FontColor->RGBColor[0.3, 0.5, 0.7]],

Cell[StyleData["ExampleSubsection", "Printout"],
 CellMargins->{{43, 0}, {0, 6}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExampleSubsubsection"],
 Editable->True,
 CellMargins->{{72, 4}, {0, 8}},
 Evaluatable->True,
 CellGroupingRules->{"SectionGrouping", 57},
 ShowCellLabel->False,
 CellLabelAutoDelete->True,
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9.5,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.4]],

Cell[StyleData["ExampleSubsubsection", "Printout"],
 CellMargins->{{43, 0}, {0, 6}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NotebookImage"],
 PageWidth->650,
 CellMargins->{{72, 12}, {8, 2}},
 CellGroupingRules->"OutputGrouping",
 CellFrameMargins->{{42, 0}, {6, 6}},
 Background->RGBColor[0.94, 0.96, 0.98]],

Cell[StyleData["NotebookImage", "Preview"]],

Cell[StyleData["NotebookImage", "Printout"],
 CellMargins->{{45, 0}, {6, 4}},
 CellFrameMargins->{{32, 0}, {6, 6}},
 Background->GrayLevel[0.94]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Picture"],
 CellMargins->{{74, 4}, {3, 8}},
 CellGroupingRules->"GraphicsGrouping",
 CellHorizontalScrolling->True,
 StyleMenuListing->None,
 GraphicsBoxOptions->{ImageSize->Medium},
 Graphics3DBoxOptions->{ImageSize->Medium}],

Cell[StyleData["Picture", "Printout"],
 CellMargins->{{2, Inherited}, {4, 4}},
 Magnification->0.65]
}, Closed]],

Cell[StyleData["Deemphasis"],
 ShowCellLabel->False,
 CellLabelAutoDelete->True,
 ShowAutoStyles->False,
 FontSize->9,
 FontColor->GrayLevel[0.75]],

Cell[CellGroupData[{

Cell[StyleData["ExampleLink"],
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontSize->Inherited 0.8,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, "DialogBox"},
 Background->RGBColor[0.7, 0.8, 0.9],
 ButtonFunction:>(DocumentationTools`FindExampleLink[#]& ),
 ButtonMinHeight->0.1,
 ButtonNote->"Examples Link",
 Evaluator->Automatic,
 Method->"Preemptive"}],

Cell[StyleData["ExampleLink", "Printout"],
 CellMargins->{{2, 80}, {0, 8}},
 PageBreakBelow->False,
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->8,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExampleBacklink"],
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontSize->10,
 FontColor->RGBColor[0.4, 0.5, 0.7],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>(DocumentationTools`FindBacklink[#]& ),
 ButtonMinHeight->0.1,
 ButtonNote->"Backlink to Examples Link",
 Evaluator->Automatic},
 FontWieght -> "Plain"],

Cell[StyleData["ExampleBacklink", "Printout"],
 CellMargins->{{2, 80}, {0, 8}},
 PageBreakBelow->False,
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->8,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[StyleData["LinkID"],
 StyleMenuListing->None,
 FontSize->0.5,
 FontColor->RGBColor[0.7, 0.8, 0.9]],

Cell[CellGroupData[{

Cell[StyleData["TutorialsSection"],
 CellFrame->{{0, 0}, {0, 0.1}},
 CellMargins->{{48, 4}, {3, 24}},
 CellElementSpacings->{"ClosedGroupTopMargin"->60},
 CellGroupingRules->{"SectionGrouping", 30},
 TaggingRules->{"Tentativeable" -> False},
 CellFrameMargins->4,
 DefaultNewCellStyle->"Tutorials",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Bold"],

Cell[StyleData["TutorialsSection", "Printout"],
 CellMargins->{{24, 0}, {2, 21}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Tutorials"],
 CellMargins->{{74, 12}, {2, 2}},
 ReturnCreatesNewCell->True,
 MenuSortingValue->800,
 MenuCommandKey->"2",
 FontFamily->"Verdana",
 FontSize->9],

Cell[StyleData["Tutorials", "Printout"],
 CellMargins->{{43, 0}, {1, 1}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 LineSpacing->{1., 2., 2.},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RelatedDemonstrationsSection"],
 CellFrame->{{0, 0}, {0, 0.1}},
 CellMargins->{{48, 4}, {2, 12}},
 CellGroupingRules->{"SectionGrouping", 30},
 TaggingRules->{"Tentativeable" -> False},
 CellFrameMargins->4,
 DefaultNewCellStyle->"RelatedDemonstrations",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Bold"],

Cell[StyleData["RelatedDemonstrationsSection", "Printout"],
 CellMargins->{{24, 0}, {1, 10}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RelatedDemonstrations"],
 CellMargins->{{72, 12}, {2, 2}},
 ReturnCreatesNewCell->True,
 ParagraphSpacing->{0, 3},
 FontFamily->"Verdana",
 FontSize->9],

Cell[StyleData["RelatedDemonstrations", "Printout"],
 CellMargins->{{43, 0}, {1, 1}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 LineSpacing->{1., 2., 2.},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RelatedLinksSection"],
 CellFrame->{{0, 0}, {0, 0.1}},
 CellMargins->{{48, 4}, {2, 12}},
 CellGroupingRules->{"SectionGrouping", 30},
 TaggingRules->{"Tentativeable" -> False},
 CellFrameMargins->4,
 DefaultNewCellStyle->"RelatedLinks",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Bold"],

Cell[StyleData["RelatedLinksSection", "Printout"],
 CellMargins->{{24, 0}, {1, 10}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RelatedLinks"],
 CellMargins->{{72, 12}, {2, 2}},
 ReturnCreatesNewCell->True,
 ParagraphSpacing->{0, 3},
 MenuSortingValue->900,
 MenuCommandKey->"3",
 FontFamily->"Verdana",
 FontSize->9],

Cell[StyleData["RelatedLinks", "Printout"],
 CellMargins->{{43, 0}, {1, 1}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 LineSpacing->{1., 2., 2.},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SeeAlsoSection"],
 CellFrame->{{0, 0}, {0, 0.1}},
 CellMargins->{{48, 4}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->28},
 CellGroupingRules->{"SectionGrouping", 30},
 TaggingRules->{"Tentativeable" -> False},
 CellFrameMargins->4,
 DefaultNewCellStyle->"SeeAlso",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Bold"],

Cell[StyleData["SeeAlsoSection", "Printout"],
 CellMargins->{{24, 0}, {1, 10}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SeeAlso"],
 CellMargins->{{72, 12}, {2, 2}},
 ReturnCreatesNewCell->True,
 ParagraphSpacing->{0, 3},
 MenuSortingValue->1000,
 MenuCommandKey->"4",
 FontFamily->"Verdana",
 FontSize->9],

Cell[StyleData["SeeAlso", "Printout"],
 CellMargins->{{43, 0}, {1, 1}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 LineSpacing->{1., 2., 2.},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MoreAboutSection"],
 CellFrame->{{0, 0}, {0, 0.1}},
 CellMargins->{{48, 4}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->28},
 CellGroupingRules->{"SectionGrouping", 30},
 TaggingRules->{"Tentativeable" -> False},
 CellFrameMargins->4,
 DefaultNewCellStyle->"MoreAbout",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Bold"],

Cell[StyleData["MoreAboutSection", "Printout"],
 CellMargins->{{24, 0}, {1, 10}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MoreAbout"],
 CellMargins->{{72, 12}, {2, 2}},
 ReturnCreatesNewCell->True,
 ParagraphSpacing->{0, 3},
 FontFamily->"Verdana",
 FontSize->9],

Cell[StyleData["MoreAbout", "Printout"],
 CellMargins->{{43, 0}, {1, 1}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 LineSpacing->{1., 2., 2.},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExtensionsSection"],
 CellFrame->{{0, 0}, {0, 0.1}},
 CellMargins->{{48, 4}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->28},
 CellGroupingRules->{"SectionGrouping", 30},
 TaggingRules->{"Tentativeable" -> False},
 CellFrameMargins->4,
 DefaultNewCellStyle->"Extensions",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Bold"],

Cell[StyleData["ExtensionsSection", "Printout"],
 CellMargins->{{24, 0}, {1, 10}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Extensions"],
 CellMargins->{{72, 12}, {2, 2}},
 ReturnCreatesNewCell->True,
 ParagraphSpacing->{0, 3},
 FontFamily->"Verdana",
 FontSize->9],

Cell[StyleData["Extensions", "Printout"],
 CellMargins->{{43, 0}, {1, 1}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 LineSpacing->{1., 2., 2.},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DesignDiscussionSection"],
 CellFrame->{{0, 0}, {0, 0.1}},
 CellMargins->{{48, 4}, {2, 60}},
 CellElementSpacings->{"ClosedGroupTopMargin"->60},
 CellGroupingRules->{"SectionGrouping", 30},
 TaggingRules->{"Tentativeable" -> False},
 CellFrameMargins->4,
 DefaultNewCellStyle->"DesignDiscussion",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Bold"],

Cell[StyleData["DesignDiscussionSection", "Printout"],
 CellMargins->{{24, 0}, {1, 54}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DesignDiscussion"],
 CellMargins->{{72, 12}, {2, 2}},
 ReturnCreatesNewCell->True,
 MenuSortingValue->1300,
 FontFamily->"Verdana",
 FontSize->9],

Cell[StyleData["DesignDiscussion", "Printout"],
 CellMargins->{{43, 0}, {1, 1}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 LineSpacing->{1., 2., 2.},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ApplicationNotesSection"],
 CellFrame->{{0, 0}, {0, 0.1}},
 CellMargins->{{48, 4}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->28},
 CellGroupingRules->{"SectionGrouping", 30},
 TaggingRules->{"Tentativeable" -> False},
 CellFrameMargins->4,
 DefaultNewCellStyle->"ApplicationNotes",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Bold"],

Cell[StyleData["ApplicationNotesSection", "Printout"],
 CellMargins->{{24, 0}, {1, 10}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ApplicationNotes"],
 CellMargins->{{72, 12}, {2, 2}},
 ReturnCreatesNewCell->True,
 MenuSortingValue->1400,
 FontFamily->"Verdana",
 FontSize->9],

Cell[StyleData["ApplicationNotes", "Printout"],
 CellMargins->{{43, 0}, {1, 1}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 LineSpacing->{1., 2., 2.},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TestCasesSection"],
 CellFrame->{{0, 0}, {0, 0.1}},
 CellMargins->{{48, 4}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->28},
 CellGroupingRules->{"SectionGrouping", 30},
 TaggingRules->{"Tentativeable" -> False},
 CellFrameMargins->4,
 DefaultNewCellStyle->"Input",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Bold"],

Cell[StyleData["TestCasesSection", "Printout"],
 CellMargins->{{24, 0}, {1, 10}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["LegacyMaterialSection"],
 CellFrame->{{0, 0}, {0, 0.1}},
 CellMargins->{{48, 4}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->28},
 CellGroupingRules->{"SectionGrouping", 30},
 TaggingRules->{"Tentativeable" -> False},
 CellFrameMargins->4,
 DefaultNewCellStyle->"LegacyMaterial",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Bold"],

Cell[StyleData["LegacyMaterialSection", "Printout"],
 CellMargins->{{24, 0}, {1, 10}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["LegacyMaterial"],
 CellMargins->{{72, 12}, {2, 2}},
 ParagraphSpacing->{0, 3},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9],

Cell[StyleData["LegacyMaterial", "Printout"],
 CellMargins->{{43, 0}, {1, 1}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 LineSpacing->{1., 2., 2.},
 FontSize->9]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Inline Formatting", "Section"],

Cell["\<\
These styles are for modifying individual words or letters in a cell \
exclusive of the cell tag.\
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["KeyboardChars"],
 StyleMenuListing->None,
 FontSize->12],

Cell[StyleData["KeyboardChars", "Printout"],
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineCode"],
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 AutoItalicWords->{},
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->Inherited 1.05],

Cell[StyleData["InlineCode", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineCharacterName"],
 ShowSpecialCharacters->False,
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 AutoItalicWords->{},
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->Inherited 1.05],

Cell[StyleData["InlineCharacterName", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FilenameExtension"],
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 AutoItalicWords->{},
 StyleMenuListing->None,
 FontWeight->"Plain"],

Cell[StyleData["FilenameExtension", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OperatorCharacter"],
 Hyphenation->True,
 AutoItalicWords->{},
 StyleMenuListing->None,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.3]],

Cell[StyleData["OperatorCharacter", "Printout"]]
}, Closed]],

Cell[StyleData["MenuName"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->RGBColor[0.35, 0.25, 0.25]],

Cell[StyleData["MenuNameDelimiter"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->RGBColor[0.35, 0.25, 0.25]],

Cell[StyleData["KeyEvent"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->RGBColor[0.35, 0.25, 0.25],
 Background->RGBColor[0.9, 0.85, 0.8]],

Cell[StyleData["KeyEventDelimiter"],
 FontSize->Inherited + 4,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontColor->RGBColor[0.75, 0.5, 0]],

Cell[StyleData["PointerEvent"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->RGBColor[0.35, 0.25, 0.25]],

Cell[StyleData["PointerEventDelimiter"],
 FontSize->Inherited + 4,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontColor->RGBColor[0.75, 0.5, 0]],

Cell[StyleData["DialogElementName"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->RGBColor[0.35, 0.25, 0.25]]
}, Closed]],

Cell[CellGroupData[{

Cell["Hyperlinks", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Link"],
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Appearance->{Automatic, None},
 ButtonFunction:>((Needs["DocumentationTools`"]; 
  DocumentationTools`DocLink[#, #2])& ),
 ButtonNote->ButtonData,
 ButtonSource->ButtonContents,
 Evaluator->Automatic}],

Cell[StyleData["Link", "Printout"],
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MathWorldLink"],
 CellChangeTimes->{3.428704684073299*^9},
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>((Needs["DocumentationTools`"]; 
  DocumentationTools`DocLink[DocumentationTools`$MathWorldPath, #, #2])& ),
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["MathWorldLink", "Printout"],
 CellChangeTimes->{3.428704684073496*^9},
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FunctionsSiteLink"],
 CellChangeTimes->{3.428704684073674*^9},
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>((Needs["DocumentationTools`"]; 
  DocumentationTools`DocLink[DocumentationTools`$FunctionsSitePath, #, #2])& ),
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["FunctionsSiteLink", "Printout"],
 CellChangeTimes->{3.4287046840738697`*^9},
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NKSLink"],
 CellChangeTimes->{3.428704684074047*^9},
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>((Needs["DocumentationTools`"]; 
  DocumentationTools`DocLink[DocumentationTools`$NKSPath, #, #2])& ),
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["NKSLink", "Printout"],
 CellChangeTimes->{3.428704684074252*^9},
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NETDocLink"],
 CellChangeTimes->{3.428704684074802*^9},
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Appearance->{Automatic, None},
 ButtonFunction:>((Needs["DocumentationTools`"]; NETDocLink[#, #2])& ),
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["NETDocLink", "Printout"],
 CellChangeTimes->{3.428704684074998*^9},
 FontColor->GrayLevel[0]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Page Headers and Footers", "Section"],

Cell[CellGroupData[{

Cell[StyleData["PageHeader"],
 CellMargins->{{0, 0}, {2, 0}},
 LineSpacing->{1, 8},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->7,
 FontSlant->"Italic"],

Cell[StyleData["PageHeader", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageNumber"],
 CellFrame->{{0.5, 0}, {0, 0}},
 CellMargins->{{0, 0}, {2, 0}},
 CellFrameMargins->{{4, 4}, {12, 12}},
 CellSize->{24, Inherited},
 LineSpacing->{1, 8},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->7,
 FontWeight->"Bold"],

Cell[StyleData["PageNumber", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageFooter"],
 CellMargins->{{0, 0}, {0, 2}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->6],

Cell[StyleData["PageFooter", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell["For compatibility", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Header"],
 CellMargins->{{0, 0}, {2, 0}},
 StyleMenuListing->None,
 FontSize->8,
 FontSlant->"Italic"],

Cell[StyleData["Header", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Footer"],
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontSize->6],

Cell[StyleData["Footer", "Printout"]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
},
WindowSize->{835, 688},
WindowMargins->{{257, Automatic}, {Automatic, 9}},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (October 12, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 121, 1, 83, "Title"],
Cell[691, 25, 46, 0, 40, 46, 0, "StyleData", "StyleDefinitions", ""],
Cell[740, 27, 56, 0, 40, 56, 0, "StyleData", "StyleDefinitions", ""],
Cell[CellGroupData[{
Cell[821, 31, 42, 0, 71, "Section"],
Cell[866, 33, 207, 6, 70, 31, 0, "StyleData", "All", "Working",
 MenuSortingValue->1100],
Cell[1076, 41, 208, 6, 70, 31, 0, "StyleData", "All", "Preview",
 MenuSortingValue->1200],
Cell[1287, 49, 195, 6, 70, 32, 0, "StyleData", "All", "Printout",
 MenuSortingValue->1300],
Cell[1485, 57, 118, 3, 70, 40, 0, "StyleData", "All", "InternalDocument",
 StyleMenuListing->None],
Cell[1606, 62, 117, 3, 70, 38, 0, "StyleData", "All", "ObsoleteObject",
 StyleMenuListing->None],
Cell[1726, 67, 114, 3, 70, 36, 0, "StyleData", "All", "FutureObject",
 StyleMenuListing->None],
Cell[1843, 72, 119, 3, 70, 39, 0, "StyleData", "All", "TentativeObject",
 StyleMenuListing->None],
Cell[1965, 77, 118, 3, 70, 39, 0, "StyleData", "All", "TemporaryObject",
 StyleMenuListing->None],
Cell[2086, 82, 128, 3, 70, 50, 0, "StyleData", "All", \
"AwaitingFutureDesignReview",
 StyleMenuListing->None],
Cell[2217, 87, 117, 3, 70, 39, 0, "StyleData", "All", "PreviewDocument",
 StyleMenuListing->None],
Cell[2337, 92, 108, 3, 70, 37, 0, "StyleData", "All", "ExcisedObject",
 StyleMenuListing->None],
Cell[2448, 97, 55, 1, 70, 33, 0, "StyleData", "All", "Condensed",
 MenuSortingValue->0],
Cell[2506, 100, 58, 1, 70, 36, 0, "StyleData", "All", "Presentation",
 MenuSortingValue->0],
Cell[2567, 103, 55, 1, 70, 33, 0, "StyleData", "All", "SlideShow",
 MenuSortingValue->0]
}, Closed]],
Cell[CellGroupData[{
Cell[2659, 109, 35, 0, 41, "Section"],
Cell[2697, 111, 165, 3, 29, "Text"],
Cell[2865, 116, 2324, 56, 40, 27, 0, "StyleData", "Notebook", "All",
 StyleMenuListing->None]
}, Closed]],
Cell[CellGroupData[{
Cell[5226, 177, 31, 0, 41, "Section"],
Cell[5260, 179, 250, 4, 47, "Text"],
Cell[CellGroupData[{
Cell[5535, 187, 277, 7, 43, 24, 0, "StyleData", "Input", "All",
 MenuSortingValue->1200,
 MenuCommandKey->"9"],
Cell[5815, 196, 108, 3, 70, 36, 0, "StyleData", "Input", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[5960, 204, 313, 8, 42, 25, 0, "StyleData", "Output", "All"],
Cell[6276, 214, 109, 3, 70, 37, 0, "StyleData", "Output", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[6422, 222, 87, 2, 42, 29, 0, "StyleData", "OutputStub", "All"],
Cell[6512, 226, 113, 3, 70, 41, 0, "StyleData", "OutputStub", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[6662, 234, 177, 4, 39, 28, 0, "StyleData", "InputOnly", "All"],
Cell[6842, 240, 112, 3, 70, 40, 0, "StyleData", "InputOnly", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[6991, 248, 194, 5, 36, 26, 0, "StyleData", "Message", "All",
 StyleMenuListing->None],
Cell[7188, 255, 180, 5, 70, 38, 0, "StyleData", "Message", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[7405, 265, 170, 4, 38, 24, 0, "StyleData", "Print", "All"],
Cell[7578, 271, 124, 3, 70, 36, 0, "StyleData", "Print", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[7739, 279, 28, 0, 37, 28, 0, "StyleData", "CellLabel", "All"],
Cell[7770, 281, 103, 3, 70, 40, 0, "StyleData", "CellLabel", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[7910, 289, 179, 6, 37, 23, 0, "StyleData", "Name", "All",
 StyleMenuListing->None],
Cell[8092, 297, 98, 3, 70, 35, 0, "StyleData", "Name", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[8239, 306, 39, 0, 41, "Section"],
Cell[CellGroupData[{
Cell[8303, 310, 273, 9, 39, 26, 0, "StyleData", "History", "All",
 StyleMenuListing->None],
Cell[8579, 321, 102, 2, 70, 38, 0, "StyleData", "History", "Printout"]
}, Closed]],
Cell[8696, 326, 112, 4, 22, 30, 0, "StyleData", "HistoryData", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[8833, 334, 254, 9, 37, 31, 0, "StyleData", "InternalFlag", "All",
 StyleMenuListing->None],
Cell[9090, 345, 57, 1, 70, 43, 0, "StyleData", "InternalFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[9184, 351, 252, 9, 37, 29, 0, "StyleData", "FutureFlag", "All",
 StyleMenuListing->None],
Cell[9439, 362, 55, 1, 70, 41, 0, "StyleData", "FutureFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[9531, 368, 255, 9, 37, 32, 0, "StyleData", "TemporaryFlag", "All",
 StyleMenuListing->None],
Cell[9789, 379, 58, 1, 70, 44, 0, "StyleData", "TemporaryFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[9884, 385, 254, 9, 37, 31, 0, "StyleData", "ObsoleteFlag", "All",
 StyleMenuListing->None],
Cell[10141, 396, 57, 1, 70, 43, 0, "StyleData", "ObsoleteFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10235, 402, 248, 9, 37, 30, 0, "StyleData", "ExcisedFlag", "All",
 StyleMenuListing->None],
Cell[10486, 413, 56, 1, 70, 42, 0, "StyleData", "ExcisedFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10579, 419, 261, 9, 37, 38, 0, "StyleData", "SubjectToChangeFlag", "All",
 StyleMenuListing->None],
Cell[10843, 430, 64, 1, 70, 50, 0, "StyleData", "SubjectToChangeFlag", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10944, 436, 272, 9, 37, 49, 0, "StyleData", \
"AwaitingFutureDesignReviewFlag", "All",
 StyleMenuListing->None],
Cell[11219, 447, 75, 1, 70, 61, 0, "StyleData", \
"AwaitingFutureDesignReviewFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[11331, 453, 253, 9, 37, 30, 0, "StyleData", "PreviewFlag", "All",
 StyleMenuListing->None],
Cell[11587, 464, 56, 1, 70, 42, 0, "StyleData", "PreviewFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[11680, 470, 401, 11, 34, 40, 0, "StyleData", "CategorizationSection", \
"All",
 StyleMenuListing->None],
Cell[12084, 483, 171, 4, 37, 52, 0, "StyleData", "CategorizationSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[12292, 492, 357, 10, 34, 33, 0, "StyleData", "Categorization", "All",
 StyleMenuListing->None],
Cell[12652, 504, 155, 3, 70, 45, 0, "StyleData", "Categorization", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[12844, 512, 404, 11, 34, 34, 0, "StyleData", "SynonymsSection", "All",
 StyleMenuListing->None],
Cell[13251, 525, 165, 4, 33, 46, 0, "StyleData", "SynonymsSection", "Printout"]
}, Closed]],
Cell[13431, 532, 366, 10, 34, 27, 0, "StyleData", "Synonyms", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[13822, 546, 404, 11, 44, 34, 0, "StyleData", "KeywordsSection", "All",
 StyleMenuListing->None],
Cell[14229, 559, 165, 4, 33, 46, 0, "StyleData", "KeywordsSection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[14431, 568, 388, 11, 34, 27, 0, "StyleData", "Keywords", "All",
 StyleMenuListing->None],
Cell[14822, 581, 149, 3, 70, 39, 0, "StyleData", "Keywords", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[15008, 589, 358, 10, 34, 40, 0, "StyleData", "DocumentStatusSection", \
"All",
 StyleMenuListing->None],
Cell[15369, 601, 171, 4, 33, 52, 0, "StyleData", "DocumentStatusSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[15577, 610, 285, 8, 34, 33, 0, "StyleData", "DocumentStatus", "All",
 StyleMenuListing->None],
Cell[15865, 620, 155, 3, 70, 45, 0, "StyleData", "DocumentStatus", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[16057, 628, 394, 11, 34, 33, 0, "StyleData", "DetailsSection", "All",
 StyleMenuListing->None],
Cell[16454, 641, 164, 4, 33, 45, 0, "StyleData", "DetailsSection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[16655, 650, 292, 8, 34, 26, 0, "StyleData", "Details", "All",
 StyleMenuListing->None],
Cell[16950, 660, 148, 3, 70, 38, 0, "StyleData", "Details", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[17135, 668, 356, 10, 34, 39, 0, "StyleData", "ExampleStatusSection", \
"All",
 StyleMenuListing->None],
Cell[17494, 680, 170, 4, 33, 51, 0, "StyleData", "ExampleStatusSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[17701, 689, 314, 9, 34, 32, 0, "StyleData", "ExampleStatus", "All",
 StyleMenuListing->None],
Cell[18018, 700, 154, 3, 70, 44, 0, "StyleData", "ExampleStatus", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[18209, 708, 390, 11, 34, 35, 0, "StyleData", "TemplatesSection", "All",
 StyleMenuListing->None],
Cell[18602, 721, 166, 4, 33, 47, 0, "StyleData", "TemplatesSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[18805, 730, 499, 14, 33, 27, 0, "StyleData", "Template", "All",
 StyleMenuListing->None],
Cell[19307, 746, 149, 3, 70, 39, 0, "StyleData", "Template", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[19493, 754, 362, 10, 34, 42, 0, "StyleData", "AllowableOptionsSection", \
"All",
 StyleMenuListing->None],
Cell[19858, 766, 173, 4, 33, 54, 0, "StyleData", "AllowableOptionsSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[20068, 775, 470, 14, 33, 35, 0, "StyleData", "AllowableOptions", "All",
 StyleMenuListing->None],
Cell[20541, 791, 157, 3, 70, 47, 0, "StyleData", "AllowableOptions", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[20735, 799, 350, 10, 34, 36, 0, "StyleData", "AttributesSection", "All",
 StyleMenuListing->None],
Cell[21088, 811, 167, 4, 33, 48, 0, "StyleData", "AttributesSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[21292, 820, 464, 14, 33, 29, 0, "StyleData", "Attributes", "All",
 StyleMenuListing->None],
Cell[21759, 836, 151, 3, 70, 41, 0, "StyleData", "Attributes", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[21947, 844, 317, 9, 34, 39, 0, "StyleData", "ErrorMessagesSection", "All",
 StyleMenuListing->None],
Cell[22267, 855, 170, 4, 33, 51, 0, "StyleData", "ErrorMessagesSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[22474, 864, 438, 13, 33, 32, 0, "StyleData", "ErrorMessages", "All",
 StyleMenuListing->None],
Cell[22915, 879, 154, 3, 70, 44, 0, "StyleData", "ErrorMessages", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[23106, 887, 317, 9, 34, 39, 0, "StyleData", "UsageMessagesSection", "All",
 StyleMenuListing->None],
Cell[23426, 898, 170, 4, 33, 51, 0, "StyleData", "UsageMessagesSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[23633, 907, 363, 11, 47, 32, 0, "StyleData", "UsageMessages", "All",
 StyleMenuListing->None],
Cell[23999, 920, 155, 3, 70, 44, 0, "StyleData", "UsageMessages", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[24191, 928, 862, 23, 49, 26, 0, "StyleData", "Section", "All"],
Cell[25056, 953, 164, 4, 57, 38, 0, "StyleData", "Section", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[25257, 962, 330, 11, 59, 25, 0, "StyleData", "Status", "All",
 StyleMenuListing->None],
Cell[25590, 975, 51, 1, 70, 37, 0, "StyleData", "Status", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[25678, 981, 762, 21, 79, 29, 0, "StyleData", "ObjectName", "All",
 StyleMenuListing->None],
Cell[26443, 1004, 142, 3, 70, 41, 0, "StyleData", "ObjectName", "Printout"]
}, Closed]],
Cell[26600, 1010, 79, 0, 79, 79, 0, "StyleData", "ObjectNameSmall", "All"],
Cell[CellGroupData[{
Cell[26704, 1014, 688, 18, 79, 32, 0, "StyleData", "ObjectNameAlt", "All",
 StyleMenuListing->None],
Cell[27395, 1034, 145, 3, 70, 44, 0, "StyleData", "ObjectNamealt", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[27577, 1042, 150, 5, 38, 30, 0, "StyleData", "FullListing", "All",
 StyleMenuListing->None],
Cell[27730, 1049, 56, 1, 70, 42, 0, "StyleData", "FullListing", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[27823, 1055, 313, 10, 70, 35, 0, "StyleData", "ObsolescenceNote", "All",
 StyleMenuListing->None],
Cell[28139, 1067, 247, 6, 70, 47, 0, "StyleData", "ObsolescenceNote", \
"Printout",
 StyleMenuListing->None]
}, Closed]],
Cell[CellGroupData[{
Cell[28423, 1078, 333, 11, 70, 37, 0, "StyleData", "AwaitingReviewNote", "All",
 StyleMenuListing->None],
Cell[28759, 1091, 249, 6, 70, 49, 0, "StyleData", "AwaitingReviewNote", \
"Printout",
 StyleMenuListing->None]
}, Closed]],
Cell[CellGroupData[{
Cell[29045, 1102, 331, 11, 70, 30, 0, "StyleData", "PreviewNote", "All",
 StyleMenuListing->None],
Cell[29379, 1115, 242, 6, 70, 42, 0, "StyleData", "PreviewNote", "Printout",
 StyleMenuListing->None]
}, Closed]],
Cell[CellGroupData[{
Cell[29658, 1126, 1242, 36, 70, 24, 0, "StyleData", "Usage", "All",
 StyleMenuListing->None],
Cell[30903, 1164, 353, 11, 70, 36, 0, "StyleData", "Usage", "Printout",
 StyleMenuListing->None],
Cell[31259, 1177, 80, 1, 70, 44, 0, "StyleData", "Usage", "InternalDocument"],
Cell[31342, 1180, 79, 1, 70, 42, 0, "StyleData", "Usage", "ObsoleteObject"],
Cell[31424, 1183, 76, 1, 70, 40, 0, "StyleData", "Usage", "FutureObject"],
Cell[31503, 1186, 80, 1, 70, 43, 0, "StyleData", "Usage", "TemporaryObject"],
Cell[31586, 1189, 79, 1, 70, 43, 0, "StyleData", "Usage", "SubjectToChange"],
Cell[31668, 1192, 90, 1, 70, 54, 0, "StyleData", "Usage", \
"AwaitingFutureDesignReview"],
Cell[31761, 1195, 79, 1, 70, 43, 0, "StyleData", "Usage", "PreviewDocument"],
Cell[31843, 1198, 70, 1, 70, 41, 0, "StyleData", "Usage", "ExcisedObject"]
}, Closed]],
Cell[CellGroupData[{
Cell[31950, 1204, 198, 6, 37, 26, 0, "StyleData", "ModInfo", "All",
 StyleMenuListing->None],
Cell[32151, 1212, 138, 3, 35, 38, 0, "StyleData", "ModInfo", "Printout"]
}, Closed]],
Cell[32304, 1218, 97, 3, 40, 29, 0, "StyleData", "DingbatMod", "All",
 MenuSortingValue->None],
Cell[CellGroupData[{
Cell[32426, 1225, 316, 10, 56, 29, 0, "StyleData", "BrightFlag", "All",
 StyleMenuListing->None],
Cell[32745, 1237, 70, 1, 70, 41, 0, "StyleData", "BrightFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[32852, 1243, 321, 10, 56, 31, 0, "StyleData", "BrighterFlag", "All",
 StyleMenuListing->None],
Cell[33176, 1255, 72, 1, 70, 43, 0, "StyleData", "BrighterFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[33285, 1261, 97, 2, 56, 36, 0, "StyleData", "TemplateExclusion", "All",
 StyleMenuListing->None],
Cell[33385, 1265, 67, 1, 70, 48, 0, "StyleData", "TemplateExclusion", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[33489, 1271, 102, 2, 56, 36, 0, "StyleData", "TemplateInclusion", "All",
 StyleMenuListing->None],
Cell[33594, 1275, 67, 1, 70, 48, 0, "StyleData", "TemplateInclusion", \
"Printout"]
}, Closed]],
Cell[33676, 1279, 405, 8, 40, 36, 0, "StyleData", "ConversionSpecial", "All",
 StyleMenuListing->None],
Cell[34084, 1289, 157, 4, 40, 37, 0, "StyleData", "ConversionLockdown", "All",
 StyleMenuListing->None],
Cell[34244, 1295, 469, 10, 48, 32, 0, "StyleData", "FutureExample", "All",
 StyleMenuListing->None],
Cell[34716, 1307, 539, 12, 48, 35, 0, "StyleData", "TentativeExample", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[35280, 1323, 213, 6, 37, 30, 0, "StyleData", "TentativeID", "All",
 StyleMenuListing->None],
Cell[35496, 1331, 42, 0, 70, 42, 0, "StyleData", "TentativeID", "Printout"]
}, Closed]],
Cell[35553, 1334, 461, 10, 48, 35, 0, "StyleData", "ExcludedMaterial", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[36039, 1348, 236, 8, 57, 33, 0, "StyleData", "TextAnnotation", "All"],
Cell[36278, 1358, 45, 0, 58, 45, 0, "StyleData", "TextAnnotation", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[36360, 1363, 316, 10, 37, 39, 0, "StyleData", "TextAnnotationButton", \
"All"],
Cell[36679, 1375, 51, 0, 37, 51, 0, "StyleData", "TextAnnotationButton", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[36767, 1380, 365, 11, 37, 45, 0, "StyleData", \
"TextAnnotationRemoveButton", "All"],
Cell[37135, 1393, 57, 0, 37, 57, 0, "StyleData", \
"TextAnnotationRemoveButton", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[37229, 1398, 1318, 37, 39, 24, 0, "StyleData", "Notes", "All",
 MenuSortingValue->700,
 MenuCommandKey->"1"],
Cell[38550, 1437, 182, 5, 70, 36, 0, "StyleData", "Notes", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[38769, 1447, 529, 15, 37, 31, 0, "StyleData", "1ColumnTable", "All",
 StyleMenuListing->None],
Cell[39301, 1464, 347, 10, 70, 43, 0, "StyleData", "1ColumnTable", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[39685, 1479, 498, 15, 37, 31, 0, "StyleData", "2ColumnTable", "All",
 StyleMenuListing->None],
Cell[40186, 1496, 347, 10, 70, 43, 0, "StyleData", "2ColumnTable", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[40570, 1511, 576, 17, 37, 31, 0, "StyleData", "3ColumnTable", "All",
 StyleMenuListing->None],
Cell[41149, 1530, 347, 10, 70, 43, 0, "StyleData", "3ColumnTable", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[41533, 1545, 871, 26, 37, 34, 0, "StyleData", "1ColumnTableMod", "All",
 StyleMenuListing->None],
Cell[42407, 1573, 497, 14, 70, 46, 0, "StyleData", "1ColumnTableMod", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[42941, 1592, 945, 28, 37, 34, 0, "StyleData", "2ColumnTableMod", "All",
 StyleMenuListing->None],
Cell[43889, 1622, 518, 15, 34, 46, 0, "StyleData", "2ColumnTableMod", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[44444, 1642, 967, 29, 37, 34, 0, "StyleData", "3ColumnTableMod", "All",
 StyleMenuListing->None],
Cell[45414, 1673, 535, 16, 34, 46, 0, "StyleData", "3ColumnTableMod", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[45986, 1694, 796, 20, 38, 28, 0, "StyleData", "TableText", "All",
 StyleMenuListing->None],
Cell[46785, 1716, 139, 3, 70, 40, 0, "StyleData", "TableText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[46961, 1724, 561, 16, 40, 32, 0, "StyleData", "InlineFormula", "All",
 StyleMenuListing->None],
Cell[47525, 1742, 82, 1, 56, 43, 0, "StyleData", "InlineFormula", "Working"],
Cell[47610, 1745, 44, 0, 44, 44, 0, "StyleData", "InlineFormula", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[47691, 1750, 285, 8, 37, 31, 0, "StyleData", "InlineOutput", "All",
 StyleMenuListing->None],
Cell[47979, 1760, 75, 1, 40, 43, 0, "StyleData", "InlineOutput", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[48091, 1766, 536, 16, 40, 29, 0, "StyleData", "InlineMath", "All",
 StyleMenuListing->None],
Cell[48630, 1784, 81, 1, 70, 40, 0, "StyleData", "InlineMath", "Working"],
Cell[48714, 1787, 73, 1, 70, 41, 0, "StyleData", "InlineMath", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[48824, 1793, 468, 15, 58, 23, 0, "StyleData", "Code", "All",
 CounterIncrements->"Code"],
Cell[49295, 1810, 95, 2, 42, 35, 0, "StyleData", "Code", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[49427, 1817, 471, 15, 57, 26, 0, "StyleData", "Program", "All",
 CounterIncrements->"Code"],
Cell[49901, 1834, 98, 2, 42, 38, 0, "StyleData", "Program", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[50036, 1841, 757, 22, 82, 41, 0, "StyleData", "PrimaryExamplesSection", \
"All",
 StyleMenuListing->None],
Cell[50796, 1865, 204, 5, 70, 53, 0, "StyleData", "PrimaryExamplesSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[51037, 1875, 306, 9, 39, 39, 0, "StyleData", "ExtendedExamplesLink", \
"All",
 StyleMenuListing->None],
Cell[51346, 1886, 170, 4, 70, 51, 0, "StyleData", "ExtendedExamplesLink", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[51553, 1895, 657, 18, 70, 42, 0, "StyleData", "ExtendedExamplesSection", \
"All",
 StyleMenuListing->None],
Cell[52213, 1915, 204, 5, 70, 54, 0, "StyleData", "ExtendedExamplesSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[52454, 1925, 375, 13, 32, 35, 0, "StyleData", "ExampleDelimiter", "All",
 StyleMenuListing->None],
Cell[52832, 1940, 116, 3, 25, 47, 0, "StyleData", "ExampleDelimiter", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[52985, 1948, 919, 25, 33, 30, 0, "StyleData", "ExampleText", "All",
 MenuSortingValue->1100,
 MenuCommandKey->"5"],
Cell[53907, 1975, 212, 6, 70, 42, 0, "StyleData", "ExampleText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[54156, 1986, 399, 13, 34, 33, 0, "StyleData", "ExampleSection", "All",
 StyleMenuListing->None],
Cell[54558, 2001, 169, 4, 70, 45, 0, "StyleData", "ExampleSection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[54764, 2010, 324, 11, 33, 36, 0, "StyleData", "ExampleSubsection", "All",
 StyleMenuListing->None],
Cell[55091, 2023, 171, 4, 70, 48, 0, "StyleData", "ExampleSubsection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[55299, 2032, 319, 11, 33, 39, 0, "StyleData", "ExampleSubsubsection", \
"All",
 StyleMenuListing->None],
Cell[55621, 2045, 174, 4, 70, 51, 0, "StyleData", "ExampleSubsubsection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[55832, 2054, 200, 5, 54, 32, 0, "StyleData", "NotebookImage", "All"],
Cell[56035, 2061, 43, 0, 70, 43, 0, "StyleData", "NotebookImage", "Preview"],
Cell[56081, 2063, 145, 3, 70, 44, 0, "StyleData", "NotebookImage", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[56263, 2071, 242, 6, 39, 26, 0, "StyleData", "Picture", "All",
 StyleMenuListing->None],
Cell[56508, 2079, 100, 2, 70, 38, 0, "StyleData", "Picture", "Printout"]
}, Closed]],
Cell[56623, 2084, 147, 5, 37, 29, 0, "StyleData", "Deemphasis", "All"],
Cell[CellGroupData[{
Cell[56795, 2093, 415, 12, 35, 30, 0, "StyleData", "ExampleLink", "All",
 StyleMenuListing->None],
Cell[57213, 2107, 211, 6, 70, 42, 0, "StyleData", "ExampleLink", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[57461, 2118, 373, 11, 38, 34, 0, "StyleData", "ExampleBacklink", "All",
 StyleMenuListing->None],
Cell[57837, 2131, 215, 6, 70, 46, 0, "StyleData", "ExampleBacklink", \
"Printout"]
}, Closed]],
Cell[58067, 2140, 103, 3, 27, 25, 0, "StyleData", "LinkID", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[58195, 2147, 382, 11, 60, 35, 0, "StyleData", "TutorialsSection", "All",
 StyleMenuListing->None],
Cell[58580, 2160, 197, 5, 70, 47, 0, "StyleData", "TutorialsSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[58814, 2170, 175, 6, 33, 28, 0, "StyleData", "Tutorials", "All",
 MenuSortingValue->800,
 MenuCommandKey->"2"],
Cell[58992, 2178, 187, 5, 70, 40, 0, "StyleData", "Tutorials", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[59216, 2188, 354, 10, 39, 47, 0, "StyleData", \
"RelatedDemonstrationsSection", "All",
 StyleMenuListing->None],
Cell[59573, 2200, 209, 5, 70, 59, 0, "StyleData", \
"RelatedDemonstrationsSection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[59819, 2210, 168, 5, 33, 40, 0, "StyleData", "RelatedDemonstrations", \
"All"],
Cell[59990, 2217, 199, 5, 70, 52, 0, "StyleData", "RelatedDemonstrations", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[60226, 2227, 336, 10, 39, 38, 0, "StyleData", "RelatedLinksSection", \
"All",
 StyleMenuListing->None],
Cell[60565, 2239, 200, 5, 70, 50, 0, "StyleData", "RelatedLinksSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[60802, 2249, 205, 7, 33, 31, 0, "StyleData", "RelatedLinks", "All",
 MenuSortingValue->900,
 MenuCommandKey->"3"],
Cell[61010, 2258, 190, 5, 27, 43, 0, "StyleData", "RelatedLinks", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[61237, 2268, 378, 11, 47, 33, 0, "StyleData", "SeeAlsoSection", "All",
 StyleMenuListing->None],
Cell[61618, 2281, 195, 5, 36, 45, 0, "StyleData", "SeeAlsoSection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[61850, 2291, 201, 7, 33, 26, 0, "StyleData", "SeeAlso", "All",
 MenuSortingValue->1000,
 MenuCommandKey->"4"],
Cell[62054, 2300, 185, 5, 27, 38, 0, "StyleData", "SeeAlso", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[62276, 2310, 382, 11, 47, 35, 0, "StyleData", "MoreAboutSection", "All",
 StyleMenuListing->None],
Cell[62661, 2323, 197, 5, 70, 47, 0, "StyleData", "MoreAboutSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[62895, 2333, 156, 5, 33, 28, 0, "StyleData", "MoreAbout", "All"],
Cell[63054, 2340, 187, 5, 70, 40, 0, "StyleData", "MoreAbout", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[63278, 2350, 384, 11, 47, 36, 0, "StyleData", "ExtensionsSection", "All",
 StyleMenuListing->None],
Cell[63665, 2363, 198, 5, 70, 48, 0, "StyleData", "ExtensionsSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[63900, 2373, 157, 5, 33, 29, 0, "StyleData", "Extensions", "All"],
Cell[64060, 2380, 188, 5, 27, 41, 0, "StyleData", "Extensions", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[64285, 2390, 396, 11, 95, 42, 0, "StyleData", "DesignDiscussionSection", \
"All",
 StyleMenuListing->None],
Cell[64684, 2403, 204, 5, 70, 54, 0, "StyleData", "DesignDiscussionSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[64925, 2413, 161, 5, 33, 35, 0, "StyleData", "DesignDiscussion", "All",
 MenuSortingValue->1300],
Cell[65089, 2420, 194, 5, 27, 47, 0, "StyleData", "DesignDiscussion", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[65320, 2430, 396, 11, 47, 42, 0, "StyleData", "ApplicationNotesSection", \
"All",
 StyleMenuListing->None],
Cell[65719, 2443, 204, 5, 36, 54, 0, "StyleData", "ApplicationNotesSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[65960, 2453, 161, 5, 33, 35, 0, "StyleData", "ApplicationNotes", "All",
 MenuSortingValue->1400],
Cell[66124, 2460, 194, 5, 27, 47, 0, "StyleData", "ApplicationNotes", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[66355, 2470, 378, 11, 47, 35, 0, "StyleData", "TestCasesSection", "All",
 StyleMenuListing->None],
Cell[66736, 2483, 197, 5, 70, 47, 0, "StyleData", "TestCasesSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[66970, 2493, 392, 11, 47, 40, 0, "StyleData", "LegacyMaterialSection", \
"All",
 StyleMenuListing->None],
Cell[67365, 2506, 202, 5, 70, 52, 0, "StyleData", "LegacyMaterialSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[67604, 2516, 157, 5, 33, 33, 0, "StyleData", "LegacyMaterial", "All",
 StyleMenuListing->None],
Cell[67764, 2523, 192, 5, 70, 45, 0, "StyleData", "LegacyMaterial", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[68005, 2534, 36, 0, 41, "Section"],
Cell[68044, 2536, 121, 3, 70, "Text"],
Cell[CellGroupData[{
Cell[68190, 2543, 72, 2, 70, 32, 0, "StyleData", "KeyboardChars", "All",
 StyleMenuListing->None],
Cell[68265, 2547, 59, 1, 70, 44, 0, "StyleData", "KeyboardChars", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[68361, 2553, 213, 6, 70, 29, 0, "StyleData", "InlineCode", "All",
 StyleMenuListing->None],
Cell[68577, 2561, 41, 0, 70, 41, 0, "StyleData", "InlineCode", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[68655, 2566, 253, 7, 70, 38, 0, "StyleData", "InlineCharacterName", "All",
 StyleMenuListing->None],
Cell[68911, 2575, 50, 0, 70, 50, 0, "StyleData", "InlineCharacterName", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[68998, 2580, 191, 5, 70, 36, 0, "StyleData", "FilenameExtension", "All",
 StyleMenuListing->None],
Cell[69192, 2587, 48, 0, 70, 48, 0, "StyleData", "FilenameExtension", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[69277, 2592, 153, 5, 70, 36, 0, "StyleData", "OperatorCharacter", "All",
 StyleMenuListing->None],
Cell[69433, 2599, 48, 0, 70, 48, 0, "StyleData", "OperatorCharacter", \
"Printout"]
}, Closed]],
Cell[69496, 2602, 133, 4, 70, 27, 0, "StyleData", "MenuName", "All"],
Cell[69632, 2608, 142, 4, 70, 36, 0, "StyleData", "MenuNameDelimiter", "All"],
Cell[69777, 2614, 172, 5, 70, 27, 0, "StyleData", "KeyEvent", "All"],
Cell[69952, 2621, 141, 4, 70, 36, 0, "StyleData", "KeyEventDelimiter", "All"],
Cell[70096, 2627, 137, 4, 70, 31, 0, "StyleData", "PointerEvent", "All"],
Cell[70236, 2633, 145, 4, 70, 40, 0, "StyleData", "PointerEventDelimiter", \
"All"],
Cell[70384, 2639, 142, 4, 70, 36, 0, "StyleData", "DialogElementName", "All"]
}, Closed]],
Cell[CellGroupData[{
Cell[70563, 2648, 29, 0, 41, "Section"],
Cell[CellGroupData[{
Cell[70617, 2652, 343, 9, 40, 23, 0, "StyleData", "Link", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[70963, 2663, 61, 1, 40, 35, 0, "StyleData", "Link", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[71061, 2669, 413, 10, 40, 32, 0, "StyleData", "MathWorldLink", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[71477, 2681, 112, 2, 40, 44, 0, "StyleData", "MathWorldLink", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[71626, 2688, 421, 10, 40, 36, 0, "StyleData", "FunctionsSiteLink", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[72050, 2700, 118, 2, 40, 48, 0, "StyleData", "FunctionsSiteLink", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[72205, 2707, 401, 10, 40, 26, 0, "StyleData", "NKSLink", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[72609, 2719, 106, 2, 40, 38, 0, "StyleData", "NKSLink", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[72752, 2726, 341, 8, 40, 29, 0, "StyleData", "NETDocLink", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[73096, 2736, 109, 2, 70, 41, 0, "StyleData", "NETDocLink", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[73254, 2744, 43, 0, 41, "Section"],
Cell[CellGroupData[{
Cell[73322, 2748, 168, 6, 70, 29, 0, "StyleData", "PageHeader", "All",
 StyleMenuListing->None],
Cell[73493, 2756, 41, 0, 70, 41, 0, "StyleData", "PageHeader", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[73571, 2761, 266, 9, 70, 29, 0, "StyleData", "PageNumber", "All",
 StyleMenuListing->None],
Cell[73840, 2772, 41, 0, 70, 41, 0, "StyleData", "PageNumber", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[73918, 2777, 124, 4, 70, 29, 0, "StyleData", "PageFooter", "All",
 StyleMenuListing->None],
Cell[74045, 2783, 41, 0, 70, 41, 0, "StyleData", "PageFooter", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[74123, 2788, 39, 0, 70, "Subsection"],
Cell[CellGroupData[{
Cell[74187, 2792, 118, 4, 70, 25, 0, "StyleData", "Header", "All",
 StyleMenuListing->None],
Cell[74308, 2798, 37, 0, 70, 37, 0, "StyleData", "Header", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[74382, 2803, 90, 3, 70, 25, 0, "StyleData", "Footer", "All",
 StyleMenuListing->None],
Cell[74475, 2808, 37, 0, 70, 37, 0, "StyleData", "Footer", "Printout"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
