(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     94849,       3222]
NotebookOptionsPosition[     68669,       2554]
NotebookOutlinePosition[     69014,       2569]
CellTagsIndexPosition[     68971,       2566]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Style Definitions for Guide Pages", "Title",
 CellChangeTimes->{{3.4646210963480253`*^9, 3.464621097254287*^9}}],

Cell[StyleData[StyleDefinitions -> "Core.nb"]],

Cell[StyleData[StyleDefinitions -> "StyleMenuClear.nb"]],

Cell[CellGroupData[{

Cell["Style Environment Names", "Section"],

Cell[StyleData[All, "Working"],
 PageWidth->650,
 ShowCellBracket->True,
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 ShowAutoStyles->False,
 ScriptMinSize->9,
 MenuSortingValue->1100],

Cell[StyleData[All, "Preview"],
 PageWidth->650,
 ShowCellBracket->False,
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 ShowAutoStyles->False,
 ScriptMinSize->9,
 MenuSortingValue->1300],

Cell[StyleData[All, "Printout"],
 PageWidth->PaperWidth,
 ShowCellBracket->False,
 ShowAutoStyles->False,
 ScriptMinSize->5,
 MenuSortingValue->1400,
 PrivateFontOptions->{"FontType"->"Outline"}],

Cell[StyleData[All, "InternalDocument"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.9, 1, 0.5]],

Cell[StyleData[All, "ObsoleteObject"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[1, 0.9500000000000001, 0.8]],

Cell[StyleData[All, "FutureObject"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[1, 0.8, 0.9]],

Cell[StyleData[All, "TentativeObject"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.85, 0.95, 1]],

Cell[StyleData[All, "TemporaryObject"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.5, 1, 0.9500000000000001]],

Cell[StyleData[All, "AwaitingFutureDesignReview"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.9, 0.9, 1]],

Cell[StyleData[All, "PreviewDocument"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.8, 0.9, 1]],

Cell[StyleData[All, "ExcisedObject"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->GrayLevel[0.6000000000000001]],

Cell[StyleData[All, "Condensed"],
 MenuSortingValue->0],

Cell[StyleData[All, "Presentation"],
 MenuSortingValue->0],

Cell[StyleData[All, "SlideShow"],
 MenuSortingValue->0]
}, Closed]],

Cell[CellGroupData[{

Cell["Notebook Options", "Section"],

Cell["\<\
  The options defined for the style below will be used at the Notebook level.\
\>", "Text",
 CellChangeTimes->{{3.35428247134284*^9, 3.35428247821855*^9}}],

Cell[StyleData["Notebook"],
 PageHeaders->{{None, None, None}, {None, None, 
    Cell[
     TextData[{
       Cell[
        TextData[{"Printed from the ", 
          StyleBox["Mathematica", FontSlant -> "Italic"], " Help System "}], 
        "PageHeader"], 
       Cell[
        TextData[{
          CounterBox["Page"]}], "PageNumber"]}], 
     CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
 PageFooters->{{None, None, None}, {
    Cell[
     TextData[{
      "\[Copyright]1988\[Dash]2008 Wolfram Research, Inc. All rights \
reserved."}], "PageFooter"], None, None}},
 PageHeaderLines->{False, False},
 PageFooterLines->{False, False},
 PrintingOptions->{"FacingPages"->False},
 CreateCellID->True,
 CellLabelAutoDelete->False,
 CellFrameLabelMargins->6,
 DefaultNewCellStyle->"GuideText",
 DefaultNewInlineCellStyle->"InlineFormula",
 DefaultInlineFormatType->"DefaultInputInlineFormatType",
 InputAliases->{"intt" -> RowBox[{"\[Integral]", 
      RowBox[{"\[SelectionPlaceholder]", 
        RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "dintt" -> RowBox[{
      SubsuperscriptBox[
      "\[Integral]", "\[SelectionPlaceholder]", "\[Placeholder]"], 
      RowBox[{"\[Placeholder]", 
        RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "sumt" -> RowBox[{
      UnderoverscriptBox["\[Sum]", 
       RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
       "\[Placeholder]"], "\[Placeholder]"}], "prodt" -> RowBox[{
      UnderoverscriptBox["\[Product]", 
       RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
       "\[Placeholder]"], "\[Placeholder]"}], "dt" -> RowBox[{
      SubscriptBox["\[PartialD]", "\[Placeholder]"], " ", 
      "\[SelectionPlaceholder]"}], "ls" -> "\[LineSeparator]"},
 InputAutoReplacements->{"gridMathematica" -> StyleBox[
     RowBox[{"grid", 
       AdjustmentBox[
        StyleBox["Mathematica", FontSlant -> "Italic"], 
        BoxMargins -> {{-0.175, 0}, {0, 0}}]}]], "webMathematica" -> StyleBox[
     RowBox[{"web", 
       AdjustmentBox[
        StyleBox["Mathematica", FontSlant -> "Italic"], 
        BoxMargins -> {{-0.175, 0}, {0, 0}}]}]]},
 TrackCellChangeTimes->True,
 AutoQuoteCharacters->{},
 PasteAutoQuoteCharacters->{},
 ShowStringCharacters->True,
 CacheGraphics->False,
 StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Input/Output", "Section"],

Cell["\<\
The cells in this section define styles used for input and output to the \
kernel.  Be careful when modifying, renaming, or removing these styles, \
because the front end associates special meanings with these style names.    \
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["Input"],
 ShowCellBracket->True,
 CellMargins->{{114, 4}, {3, 8}},
 CellProlog->DocumentationTools`WolframDocumentProlog[],
 CellLabelAutoDelete->False,
 CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}}],

Cell[StyleData["Input", "Printout"],
 ShowCellBracket->False,
 CellMargins->{{79, 0}, {4, 6}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Output"],
 ShowCellBracket->True,
 CellMargins->{{114, 4}, {8, 2}},
 CellAutoOverwrite->True,
 CellLabelPositioning->Left,
 CellLabelAutoDelete->False,
 CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
 GraphicsBoxOptions->{ImageSize->Small},
 Graphics3DBoxOptions->{ImageSize->Small}],

Cell[StyleData["Output", "Printout"],
 ShowCellBracket->False,
 CellMargins->{{79, 0}, {6, 4}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OutputStub"],
 ShowCellBracket->True,
 CellMargins->{{114, 4}, {8, 2}}],

Cell[StyleData["OutputStub", "Printout"],
 ShowCellBracket->False,
 CellMargins->{{79, 0}, {6, 4}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InputOnly"],
 ShowCellBracket->True,
 CellMargins->{{80, 4}, {8, 8}},
 CellLabelAutoDelete->False,
 CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}}],

Cell[StyleData["InputOnly", "Printout"],
 ShowCellBracket->False,
 CellMargins->{{79, 0}, {6, 6}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Message"],
 ShowCellBracket->True,
 CellMargins->{{114, 4}, {4, 2}},
 ShowCellLabel->False,
 CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
 StyleMenuListing->None],

Cell[StyleData["Message", "Printout"],
 CellDingbat->None,
 ShowCellBracket->False,
 CellMargins->{{68, Inherited}, {Inherited, Inherited}},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Print"],
 PageWidth->WindowWidth,
 ShowCellBracket->True,
 CellMargins->{{114, 27}, {4, 2}},
 CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}}],

Cell[StyleData["Print", "Printout"],
 ShowCellBracket->False,
 CellMargins->{{68, 2}, {Inherited, Inherited}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CellLabel"]],

Cell[StyleData["CellLabel", "Printout"],
 FontSize->7,
 FontSlant->"Oblique",
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Name"],
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontSize->9,
 FontWeight->"Plain",
 FontSlant->"Italic",
 FontColor->RGBColor[0.269993, 0.308507, 0.6]],

Cell[StyleData["Name", "Printout"],
 FontSize->7,
 FontSlant->"Oblique",
 FontColor->GrayLevel[0]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Guide Page Styles", "Section"],

Cell[CellGroupData[{

Cell[StyleData["History"],
 Editable->False,
 PageWidth->680,
 CellMargins->{{36, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->12,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["History", "Printout"],
 FontSize->9]
}, Closed]],

Cell[StyleData["HistoryData"],
 Editable->True,
 Deletable->False,
 CellSize->{36, 14},
 StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["InternalFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{36, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["InternalFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FutureFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{36, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["FutureFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TemporaryFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{36, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["TemporaryFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ObsoleteFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{36, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["ObsoleteFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExcisedFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{36, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.8]],

Cell[StyleData["ExcisedFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubjectToChangeFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{36, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["SubjectToChangeFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AwaitingFutureDesignReviewFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{36, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["AwaitingFutureDesignReviewFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PreviewFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{36, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["PreviewFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CategorizationSection"],
 CellMargins->{{36, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"Categorization",
 ParagraphSpacing->{0.7000000000000001, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["CategorizationSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[StyleData["Categorization"],
 CellMargins->{{60, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 CellLabelPositioning->Above,
 CellLabelMargins->{{36, Inherited}, {Inherited, Inherited}},
 ParagraphSpacing->{0.7000000000000001, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["SynonymsSection"],
 CellMargins->{{36, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"Synonyms",
 ParagraphSpacing->{0.7000000000000006, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["SynonymsSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[StyleData["Synonyms"],
 CellMargins->{{60, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 CellLabelPositioning->Above,
 CellLabelMargins->{{28, Inherited}, {Inherited, Inherited}},
 ParagraphSpacing->{0.7000000000000006, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["KeywordsSection"],
 CellMargins->{{36, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"Keywords",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["KeywordsSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[StyleData["Keywords"],
 CellMargins->{{60, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 CellLabelPositioning->Above,
 CellLabelMargins->{{36, Inherited}, {Inherited, Inherited}},
 ParagraphSpacing->{0.7, 0},
 AutoItalicWords->{},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["DocumentStatusSection"],
 CellMargins->{{36, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"DocumentStatus",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["DocumentStatusSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[StyleData["DocumentStatus"],
 CellMargins->{{60, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 CellLabelPositioning->Above,
 CellLabelMargins->{{36, Inherited}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["DetailsSection"],
 CellMargins->{{36, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"DocumentStatus",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["DetailsSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[StyleData["Details"],
 CellMargins->{{60, 80}, {2, 2}},
 CellLabelPositioning->Above,
 CellLabelMargins->{{48, Inherited}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["GuideIcon"],
 CellMargins->{{36, 80}, {6, 6}},
 CellGroupingRules->{"SectionGrouping", 50},
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.5]],

Cell[StyleData["GuideIcon", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ModInfo"],
 CellSize->{25, Inherited},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->Inherited 0.9,
 FontWeight->"Plain",
 FontColor->RGBColor[0.269993, 0.30850700000000003`, 0.6000000000000001]],

Cell[StyleData["ModInfo", "Printout"],
 CellSize->{20, Inherited},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BrightFlag"],
 StyleMenuListing->None,
 FontColor->GrayLevel[1],
 Background->RGBColor[1, 0, 0],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>(DocumentationTools`DocLink[#, #2]& ),
 Evaluator->Automatic}],

Cell[StyleData["BrightFlag", "Printout"],
 Background->GrayLevel[0.8]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BrighterFlag"],
 StyleMenuListing->None,
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontColor->GrayLevel[1],
 Background->RGBColor[1, 0., 0.8],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>(DocumentationTools`DocLink[#, #2]& ),
 Evaluator->Automatic}],

Cell[StyleData["BrighterFlag", "Printout"],
 Background->GrayLevel[0.9]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExcludedObject"],
 CellFrameMargins->2,
 StyleMenuListing->None,
 Background->GrayLevel[0.8]],

Cell[StyleData["ExcludedObject", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCExcludedObject"],
 CellFrameMargins->2,
 StyleMenuListing->None,
 Background->RGBColor[0.8, 0.88, 0.87]],

Cell[StyleData["TOCExcludedObject", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PrimaryObject"],
 CellFrameMargins->2,
 StyleMenuListing->None,
 Background->RGBColor[0.85, 0.79, 0.85]],

Cell[StyleData["PrimaryObject", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ObsolescenceNote"],
 CellFrame->True,
 CellMargins->{{9, 8}, {12, 6}},
 CellGroupingRules->{"SectionGrouping", 50},
 CellFrameMargins->{{27, 12}, {12, 12}},
 CellFrameColor->RGBColor[0.9, 0.9, 0],
 Hyphenation->False,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 Background->RGBColor[1, 1, 0]],

Cell[StyleData["ObsolescenceNote", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 StyleMenuListing->None,
 FontSize->10,
 FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AwaitingReviewNote"],
 Editable->False,
 CellFrame->True,
 CellMargins->{{9, 8}, {12, 6}},
 CellGroupingRules->{"SectionGrouping", 50},
 CellFrameMargins->{{27, 12}, {12, 12}},
 CellFrameColor->RGBColor[0.9, 0.9, 0],
 Hyphenation->False,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 Background->RGBColor[1, 1, 0]],

Cell[StyleData["AwaitingReviewNote", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 StyleMenuListing->None,
 FontSize->10,
 FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PreviewNote"],
 Editable->False,
 CellFrame->True,
 CellMargins->{{9, 8}, {12, 6}},
 CellGroupingRules->{"SectionGrouping", 50},
 CellFrameMargins->{{27, 12}, {12, 12}},
 CellFrameColor->RGBColor[0.6, 0.7, 1],
 Hyphenation->False,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 Background->RGBColor[0.9, 0.98, 1]],

Cell[StyleData["PreviewNote", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 StyleMenuListing->None,
 FontSize->10,
 FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Status"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{48, 12}, {0, 30}},
 CellElementSpacings->{"ClosedGroupTopMargin"->50},
 CellGroupingRules->{"SectionGrouping", 50},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["Status", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideTitle"],
 CellMargins->{{36, 12}, {4, 50}},
 CellElementSpacings->{"ClosedGroupTopMargin"->62},
 CellGroupingRules->{"SectionGrouping", 50},
 CellLabelPositioning->Above,
 DefaultNewCellStyle->"GuideAbstract",
 DefaultNewInlineCellStyle->"InlineMath",
 DefaultInlineFormatType->"DefaultTextInlineFormatType",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->18,
 FontWeight->"Bold",
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {Left, {Right}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {{
      Scaled[0.5]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["GuideTitle", "Printout"],
 CellMargins->{{24, 2}, {3, 42}},
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->16]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideAbstract"],
 CellMargins->{{36, 80}, {6, 6}},
 CellFrameMargins->4,
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 ParagraphSpacing->{0.7000000000000001, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11],

Cell[StyleData["GuideAbstract", "Printout"],
 CellMargins->{{24, 72}, {5, 5}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideMainTutorial"],
 CellMargins->{{36, 80}, {3, 3}},
 CellFrameMargins->4,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->RGBColor[0.7, 0.4, 0],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>NotebookLocate[{
    DocumentationTools`FileNameAppend[
     InputNotebook[], "-Intro.nb"], None}],
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["GuideMainTutorial", "Printout"],
 CellMargins->{{24, 72}, {2, 2}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0.5]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideTestDrive"],
 CellMargins->{{36, 80}, {3, 3}},
 CellFrameMargins->4,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->RGBColor[0.7, 0.4, 0],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>NotebookLocate[{
    DocumentationTools`FileNameAppend[
     ButtonNotebook[], "-Demo.nb"], None}],
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["GuideTestDrive", "Printout"],
 CellMargins->{{24, 72}, {2, 2}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0.5]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideDelimiter"],
 CellMargins->{{36, 10}, {10, 4}},
 CellGroupingRules->{"SectionGrouping", 60},
 DefaultNewCellStyle->"InlineGuideFunctionListing",
 TabFilling->".\[ThinSpace]",
 TabSpacings->{70},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["GuideDelimiter", "Printout"],
 CellMargins->{{24, 0}, {8, 2}},
 TabSpacings->{71.3},
 FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideFunctionsSection"],
 CellFrame->{{0, 0}, {0, 4}},
 CellMargins->{{36, 4}, {10, 36}},
 CellElementSpacings->{"ClosedGroupTopMargin"->30},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameMargins->4,
 CellFrameColor->RGBColor[0.2, 0.3, 0.7],
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.5]],

Cell[StyleData["GuideFunctionsSection", "Printout"],
 CellFrame->{{0, 0}, {0, 2}},
 CellMargins->{{24, 2}, {8, 32}},
 PageBreakBelow->False,
 CellFrameColor->GrayLevel[0.2],
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->10,
 FontColor->GrayLevel[0.4]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideFunctionsSubsubsection"],
 Editable->True,
 CellMargins->{{48, 4}, {0, 8}},
 Evaluatable->True,
 CellGroupingRules->{"SectionGrouping", 65},
 ShowCellLabel->False,
 CellLabelAutoDelete->True,
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.4]],

Cell[StyleData["GuideFunctionsSubsubsection", "Printout"],
 CellMargins->{{43, 2}, {0, 6}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideFunction"],
 CellMargins->{{48, 80}, {1, 8}},
 CellGroupingRules->{"SectionGrouping", 80},
 CellFrameMargins->4,
 ParagraphSpacing->{0.7, 0},
 AutoMultiplicationSymbol->False,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->12,
 FontWeight->"Bold"],

Cell[StyleData["GuideFunction", "Printout"],
 CellMargins->{{43, 2}, {0, 6}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineGuideFunction"],
 ParagraphSpacing->{0.7, 0},
 AutoMultiplicationSymbol->False,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.7]],

Cell[StyleData["InlineGuideFunction", "Printout"],
 CellMargins->{{43, 2}, {5, 0}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineGuideFunctionListing"],
 CellMargins->{{48, 80}, {6, 1}},
 DefaultNewCellStyle->"InlineGuideFunctionListing",
 ParagraphSpacing->{0.7, 0},
 AutoMultiplicationSymbol->False,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->12,
 FontWeight->"Bold"],

Cell[StyleData["InlineGuideFunctionListing", "Printout"],
 CellMargins->{{43, 2}, {5, 0}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineFormula"],
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LanguageCategory->"Formula",
 AutoSpacing->True,
 ScriptLevel->1,
 AutoMultiplicationSymbol->False,
 SingleLetterItalics->False,
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->12,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 FractionBoxOptions->{BaseStyle->{SpanMaxSize -> Automatic}},
 GridBoxOptions->{
 GridBoxItemSize->{
  "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["InlineFormula", "Printout"],
 CellMargins->{{2, 0}, {0, 8}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineMath"],
 DefaultFormatType->"DefaultTextFormatType",
 DefaultInlineFormatType->"TraditionalForm",
 LanguageCategory->"Formula",
 AutoSpacing->True,
 ScriptLevel->1,
 AutoMultiplicationSymbol->False,
 SingleLetterItalics->True,
 SpanMaxSize->Infinity,
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->1.05 Inherited,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxItemSize->{
  "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["InlineMath", "Printout"],
 CellMargins->{{2, 0}, {0, 8}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineCharacterDisplay"],
 AutoMultiplicationSymbol->False,
 SingleLetterItalics->False,
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->14,
 ButtonBoxOptions->{Appearance->{Automatic, None}}],

Cell[StyleData["InlineCharacterDisplay", "Printout"],
 CellMargins->{{2, 0}, {0, 8}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideText"],
 CellMargins->{{48, 80}, {6, 1}},
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11],

Cell[StyleData["GuideText", "Printout"],
 CellMargins->{{43, 2}, {5, 0}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideFunctionsSubsection"],
 CellMargins->{{36, 4}, {8, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->12},
 CellGroupingRules->{"SectionGrouping", 60},
 DefaultNewCellStyle->"InlineGuideFunctionListing",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.2]],

Cell[StyleData["GuideFunctionsSubsection", "Printout"],
 CellMargins->{{24, 2}, {6, 10}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideTutorialsSection"],
 CellFrame->{{0, 0}, {0, 4}},
 CellMargins->{{36, 4}, {12, 36}},
 CellElementSpacings->{"ClosedGroupTopMargin"->30},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameMargins->4,
 CellFrameColor->RGBColor[0.2, 0.3, 0.7],
 DefaultNewCellStyle->"GuideTutorial",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.5]],

Cell[StyleData["GuideTutorialsSection", "Printout"],
 CellFrame->{{0, 0}, {0, 2}},
 CellMargins->{{24, 2}, {8, 32}},
 PageBreakBelow->False,
 CellFrameColor->GrayLevel[0.2],
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->10,
 FontColor->GrayLevel[0.4]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideTutorial"],
 CellMargins->{{48, 80}, {6, 1}},
 CellFrameMargins->4,
 ParagraphSpacing->{0.7, 0},
 MenuSortingValue->100,
 MenuCommandKey->"1",
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold"],

Cell[StyleData["GuideTutorial", "Printout"],
 CellMargins->{{43, 2}, {5, 0}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideMoreAboutSection"],
 CellFrame->{{0, 0}, {0, 4}},
 CellMargins->{{36, 4}, {12, 36}},
 CellElementSpacings->{"ClosedGroupTopMargin"->30},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameMargins->4,
 CellFrameColor->RGBColor[0.8, 0.5, 0],
 DefaultNewCellStyle->"GuideMoreAbout",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.5]],

Cell[StyleData["GuideMoreAboutSection", "Printout"],
 CellFrame->{{0, 0}, {0, 2}},
 CellMargins->{{24, 2}, {8, 32}},
 PageBreakBelow->False,
 CellFrameColor->GrayLevel[0.5],
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->10,
 FontColor->GrayLevel[0.4]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideMoreAboutDelimiter"],
 CellMargins->{{36, 10}, {6, 6}},
 CellGroupingRules->{"SectionGrouping", 60},
 DefaultNewCellStyle->"GuideMoreAboutSub",
 TabFilling->".\[ThinSpace]",
 TabSpacings->{70},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["GuideMoreAboutDelimiter", "Printout"],
 CellMargins->{{24, 0}, {5, 5}},
 TabSpacings->{71.3},
 FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideMoreAbout"],
 CellMargins->{{48, 80}, {6, 1}},
 CellFrameMargins->4,
 ParagraphSpacing->{0.7, 0},
 MenuSortingValue->200,
 MenuCommandKey->"2",
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->RGBColor[0.8, 0.5, 0],
 GridBoxOptions->{ColumnsEqual->True,
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {{
      Scaled[0.5]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[1.05]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.4]}, 
     Offset[0.2]}, "RowsIndexed" -> {}},
 GridDefaultElement->Cell["XXXX", "GuideMoreAbout"]}],

Cell[StyleData["GuideMoreAbout", "Printout"],
 CellMargins->{{43, 2}, {5, 0}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideMoreAboutSub"],
 CellMargins->{{48, 80}, {6, 1}},
 CellFrameMargins->4,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.5],
 GridBoxOptions->{ColumnsEqual->True,
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {{
      Scaled[0.5]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[1.05]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.4]}, 
     Offset[0.2]}, "RowsIndexed" -> {}},
 GridDefaultElement->Cell["XXXX", "GuideMoreAboutSub"]}],

Cell[StyleData["GuideMoreAboutSub", "Printout"],
 CellMargins->{{43, 2}, {5, 0}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideMoreAboutSubsection"],
 CellMargins->{{36, 4}, {8, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->12},
 CellGroupingRules->{"SectionGrouping", 60},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.3]],

Cell[StyleData["GuideMoreAboutSubsection", "Printout"],
 CellMargins->{{3, 0}, {0, 10}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["1ColumnTable"],
 PageWidth->700,
 CellMargins->{{66, 50}, {6, 0}},
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {{
      Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridDefaultElement->Cell["XXXX", "TableText"]}],

Cell[StyleData["1ColumnTable", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {0, 8}},
 FontSize->9,
 GridBoxOptions->{GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.56]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["2ColumnTable"],
 PageWidth->700,
 CellMargins->{{66, 50}, {6, 0}},
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.4], {
      Scaled[0.6]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["2ColumnTable", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {0, 8}},
 FontSize->9,
 GridBoxOptions->{GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.56]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["3ColumnTable"],
 PageWidth->700,
 CellMargins->{{66, 50}, {6, 0}},
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.28], 
     Scaled[0.28], {
      Scaled[0.44]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["3ColumnTable", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {0, 8}},
 FontSize->9,
 GridBoxOptions->{GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.56]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["1ColumnTableMod"],
 PageWidth->700,
 CellMargins->{{40, 50}, {6, 0}},
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.04], {
      Scaled[0.966]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], 
     Offset[0.126], {
      Offset[0.77]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.4]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}],

Cell[StyleData["1ColumnTableMod", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {5, 0}},
 FontSize->9,
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.078], {
      Scaled[0.922]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.56]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["2ColumnTableMod"],
 PageWidth->700,
 CellMargins->{{40, 50}, {6, 0}},
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.41], {
      Scaled[0.54]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], 
     Offset[0.14], {
      Offset[0.77]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.4]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}],

Cell[StyleData["2ColumnTableMod", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {5, 0}},
 FontSize->9,
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.079], 
     Scaled[0.363], {
      Scaled[0.558]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.56]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["3ColumnTableMod"],
 PageWidth->700,
 CellMargins->{{40, 50}, {6, 0}},
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.04], 
     Scaled[0.266], 
     Scaled[0.26], {
      Scaled[0.434]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], 
     Offset[0.14], {
      Offset[0.77]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.4]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}],

Cell[StyleData["3ColumnTableMod", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {5, 0}},
 FontSize->9,
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.08], 
     Scaled[0.25], 
     Scaled[0.25], {
      Scaled[0.42]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.56]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableText"],
 DefaultInlineFormatType->"DefaultInputInlineFormatType",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->Inherited 0.9520000000000001],

Cell[StyleData["TableText", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 LineSpacing->{1., 2, 2.}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideCharacterImage"],
 StyleMenuListing->None,
 FontSize->16],

Cell[StyleData["GuideCharacterImage", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideRelatedLinksSection"],
 CellFrame->{{0, 0}, {0, 4}},
 CellMargins->{{36, 4}, {12, 36}},
 CellElementSpacings->{"ClosedGroupTopMargin"->30},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameMargins->4,
 CellFrameColor->RGBColor[0.8, 0.2, 0],
 DefaultNewCellStyle->"GuideRelatedLinks",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.5]],

Cell[StyleData["GuideRelatedLinksSection", "Printout"],
 CellFrame->{{0, 0}, {0, 2}},
 CellMargins->{{24, 2}, {8, 32}},
 PageBreakBelow->False,
 CellFrameColor->GrayLevel[0.5],
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->10,
 FontColor->GrayLevel[0.4]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideRelatedLinks"],
 CellMargins->{{48, 80}, {6, 1}},
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.5]],

Cell[StyleData["GuideRelatedLinks", "Printout"],
 CellMargins->{{43, 2}, {5, 0}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Section"],
 CellFrame->{{0, 0}, {0, 2}},
 CellMargins->{{36, 4}, {8, 36}},
 CellElementSpacings->{"ClosedGroupTopMargin"->30},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameMargins->4,
 CellFrameColor->RGBColor[0.1, 0.1, 0.5],
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->17,
 FontWeight->"Bold",
 FontColor->RGBColor[0.1, 0.1, 0.5]],

Cell[StyleData["Section", "Printout"],
 CellMargins->{{24, 2}, {5, 24}},
 PageBreakBelow->False,
 FontSize->15,
 FontColor->GrayLevel[0.3]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsection"],
 CellDingbat->"\[FilledSmallSquare]",
 CellMargins->{{49, 4}, {6, 24}},
 CellElementSpacings->{"ClosedGroupTopMargin"->20},
 CellGroupingRules->{"SectionGrouping", 60},
 CellFrameLabelMargins->4,
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->13,
 FontWeight->"Bold",
 FontColor->RGBColor[0.1, 0.1, 0.5]],

Cell[StyleData["Subsection", "Printout"],
 CellMargins->{{34, 2}, {4, 18}},
 PageBreakBelow->False,
 CellFrameLabelMargins->2,
 FontSize->9,
 FontColor->GrayLevel[0.4]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsection"],
 CellMargins->{{38, 4}, {4, 18}},
 CellElementSpacings->{"ClosedGroupTopMargin"->14},
 CellGroupingRules->{"SectionGrouping", 70},
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->RGBColor[0.2, 0.3, 0.6]],

Cell[StyleData["Subsubsection", "Printout"],
 CellMargins->{{26, 2}, {3, 14}},
 PageBreakBelow->False,
 FontSize->9,
 FontColor->GrayLevel[0.5]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsubsection"],
 CellMargins->{{38, 4}, {4, 14}},
 CellElementSpacings->{"ClosedGroupTopMargin"->10},
 CellGroupingRules->{"SectionGrouping", 80},
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Bold",
 FontSlant->"Italic",
 FontColor->RGBColor[0.2, 0.3, 0.6]],

Cell[StyleData["Subsubsubsection", "Printout"],
 CellMargins->{{26, 2}, {2, 10}},
 PageBreakBelow->False,
 FontSize->8,
 FontColor->GrayLevel[0.5]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Code"],
 CellMargins->{{107, 10}, {5, 7}},
 CellGroupingRules->"InputGrouping",
 StripStyleOnPaste->True,
 PageBreakWithin->False,
 GroupPageBreakWithin->False,
 AutoIndent->False,
 ShowAutoStyles->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LineSpacing->{1.2, 1., 2.},
 AutoItalicWords->{},
 AutoSpacing->False,
 ShowStringCharacters->True,
 CounterIncrements->"Code",
 FontFamily->"Courier",
 Background->GrayLevel[0.92]],

Cell[StyleData["Code", "Printout"],
 CellMargins->{{39, 0}, {4, 6}},
 Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Program"],
 CellMargins->{{107, 10}, {5, 7}},
 CellGroupingRules->"InputGrouping",
 StripStyleOnPaste->True,
 PageBreakWithin->False,
 GroupPageBreakWithin->False,
 AutoIndent->False,
 ShowAutoStyles->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LineSpacing->{1.2, 1., 2.},
 AutoItalicWords->{},
 AutoSpacing->False,
 ShowStringCharacters->True,
 CounterIncrements->"Code",
 FontFamily->"Courier",
 Background->GrayLevel[0.92]],

Cell[StyleData["Program", "Printout"],
 CellMargins->{{39, 0}, {4, 6}},
 Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OverviewSection"],
 CellFrame->{{0, 0}, {0, 4}},
 CellMargins->{{36, 4}, {10, 36}},
 CellElementSpacings->{"ClosedGroupTopMargin"->30},
 CellGroupingRules->{"SectionGrouping", 50},
 CellFrameMargins->4,
 CellFrameColor->RGBColor[0.2, 0.3, 0.7],
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.5]],

Cell[StyleData["GuideFunctionsSection", "Printout"],
 CellFrame->{{0, 0}, {0, 2}},
 CellMargins->{{24, 2}, {8, 32}},
 PageBreakBelow->False,
 CellFrameColor->GrayLevel[0.2],
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->10,
 FontColor->GrayLevel[0.4]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OverviewSubsection"],
 ShowGroupOpener->True,
 CellMargins->{{36, 80}, {4, 4}},
 CellElementSpacings->{"ClosedGroupTopMargin"->12},
 CellGroupingRules->{"SectionGrouping", 60},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.35]],

Cell[StyleData["OverviewSubsection", "Printout"],
 CellMargins->{{24, 2}, {3, 3}},
 PageBreakBelow->False,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OverviewTutorial"],
 CellMargins->{{60, 80}, {4, 2}},
 CellFrameMargins->4,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Plain"],

Cell[StyleData["OverviewTutorial", "Printout"],
 CellMargins->{{43, 2}, {5, 0}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OverviewLink"],
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->GrayLevel[0.35],
 ButtonBoxOptions->{Appearance->{Automatic, None},
 ButtonFunction:>(DocumentationTools`DocLink[#, #2]& ),
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["OverviewLink", "Printout"],
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AlphabeticalListing"],
 PageWidth->WindowWidth,
 CellMargins->{{36, 8}, {4, 4}},
 PageBreakAbove->False,
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Columns" -> {False}, "Rows" -> {False, {
      GrayLevel[1]}, False}},
 GridBoxItemStyle->{"Columns" -> {{
      Directive[FontSize -> 10, FontFamily -> "Verdana"]}}},
 GridBoxSpacings->{"Columns" -> {{3}}}}],

Cell[StyleData["AlphabeticalListing", "Printout"],
 CellMargins->{{2, 2}, {5, 0}},
 FontSize->8]
}, Closed]],

Cell[StyleData["ConversionSpecial"],
 CellBracketOptions->{"Color"->RGBColor[0.7, 0.5, 0.8],
 "Thickness"->3},
 GeneratedCellStyles->{"Graphics"->{"Graphics", "ConversionSpecial"},
 "Message"->{"Message", "MSG", "ConversionSpecial"},
 "Output"->{"Output", "ConversionSpecial"},
 "Print"->{"Print", "ConversionSpecial"},
 "PrintTemporary"->{"PrintTemporary", "ConversionSpecial"}},
 StyleMenuListing->None],

Cell[StyleData["ConversionLockdown"],
 CellBracketOptions->{"Color"->RGBColor[0.8, 0.5, 0.4],
 "Thickness"->3},
 Evaluatable->False,
 StyleMenuListing->None],

Cell[StyleData["FutureExample"],
 CellBracketOptions->{"Color"->RGBColor[0.9, 0.4, 0.4],
 "Thickness"->5},
 GeneratedCellStyles->{"Graphics"->{"Graphics", "FutureExample"},
 "Message"->{"Message", "MSG", "FutureExample"},
 "Output"->{"Output", "FutureExample"},
 "Print"->{"Print", "FutureExample"},
 "PrintTemporary"->{"PrintTemporary", "FutureExample"}},
 CellFrameMargins->4,
 StyleMenuListing->None,
 Background->RGBColor[1, 0.9500000000000003, 0.9500000000000003]],

Cell[StyleData["TentativeExample"],
 CellBracketOptions->{
 "Color"->RGBColor[
  0.30000000000000016`, 0.6000000000000003, 0.7000000000000003],
 "Thickness"->5},
 GeneratedCellStyles->{"Graphics"->{"Graphics", "TentativeExample"},
 "Message"->{"Message", "MSG", "TentativeExample"},
 "Output"->{"Output", "TentativeExample"},
 "Print"->{"Print", "TentativeExample"},
 "PrintTemporary"->{"PrintTemporary", "TentativeExample"}},
 CellFrameMargins->4,
 StyleMenuListing->None,
 Background->RGBColor[0.8500000000000003, 0.9500000000000003, 1]],

Cell[CellGroupData[{

Cell[StyleData["TentativeID"],
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Plain",
 FontColor->RGBColor[0.10000000000000002`, 0.3000000000000002, 0.4],
 Background->GrayLevel[1]],

Cell[StyleData["TentativeID", "Printout"]]
}, Closed]],

Cell[StyleData["ExcludedMaterial"],
 CellBracketOptions->{"Color"->RGBColor[0.8, 0.8, 0.6],
 "Thickness"->5},
 GeneratedCellStyles->{"Graphics"->{"Graphics", "ExcludedMaterial"},
 "Message"->{"Message", "MSG", "ExcludedMaterial"},
 "Output"->{"Output", "ExcludedMaterial"},
 "Print"->{"Print", "ExcludedMaterial"},
 "PrintTemporary"->{"PrintTemporary", "ExcludedMaterial"}},
 CellFrameMargins->4,
 StyleMenuListing->None,
 Background->RGBColor[0.95, 0.95, 0.8]],

Cell[CellGroupData[{

Cell[StyleData["TextAnnotation"],
 CellFrame->1,
 CellFrameColor->RGBColor[0.8, 0, 0],
 AutoSpacing->False,
 LineIndent->Automatic,
 FontSize->11,
 FontWeight->"Plain",
 FontColor->RGBColor[0.4, 0.2, 0.2],
 Background->GrayLevel[0.999],
 ButtonBoxOptions->{Active->True,
 Appearance->"DialogBox",
 ButtonFunction:>GenerateAnnotationDialog[],
 Evaluator->Automatic,
 Method->"Queued"}],

Cell[StyleData["TextAnnotation", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextAnnotationButton"],
 Editable->False,
 FontFamily->"Verdana",
 FontSize->9,
 ButtonBoxOptions->{Active->True,
 Appearance->"DialogBox",
 ButtonFunction:>(Needs["DocumentationTools`"]; 
  DocumentationTools`GenerateAnnotationDialog[]),
 ButtonMargins->1,
 Evaluator->Automatic,
 Method->"Queued"}],

Cell[StyleData["TextAnnotationButton", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextAnnotationRemoveButton"],
 Editable->False,
 FontFamily->"Verdana",
 FontSize->9,
 ButtonBoxOptions->{Active->True,
 Appearance->"DialogBox",
 ButtonFunction:>(Needs["DocumentationTools`"]; 
  DocumentationTools`AnnotationRemove[
   DocumentationTools`CalledFromFrameLabel -> True]),
 ButtonMargins->1,
 Evaluator->Automatic,
 Method->"Queued"}],

Cell[StyleData["TextAnnotationRemoveButton", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideTOCTitle"],
 CellMargins->{{36, 12}, {4, 50}},
 CellElementSpacings->{"ClosedGroupTopMargin"->62},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"GuideAbstract",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->16,
 FontWeight->"Bold",
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {Left, {Right}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {{
      Scaled[0.5]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["GuideTOCTitle", "Printout"],
 CellMargins->{{24, 2}, {3, 42}},
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->16]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideTOCAbstract"],
 CellFrame->{{False, False}, {1, False}},
 CellMargins->{{36, 80}, {24, 6}},
 CellFrameMargins->18,
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 ParagraphSpacing->{0.7000000000000001, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->13],

Cell[StyleData["GuideTOCAbstract", "Printout"],
 CellMargins->{{24, 72}, {5, 5}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideTOCLink"],
 CellMargins->{{36, 80}, {6, 1}},
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->12,
 FontWeight->"Bold"],

Cell[StyleData["GuideTOCLink", "Printout"],
 CellMargins->{{43, 2}, {5, 0}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GuideTOCText"],
 CellMargins->{{36, 80}, {28, 6}},
 CellFrameMargins->4,
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 ParagraphSpacing->{0.7000000000000001, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11],

Cell[StyleData["GuideTOCText", "Printout"],
 CellMargins->{{24, 72}, {5, 5}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NotebookImage"],
 PageWidth->650,
 CellMargins->{{72, 12}, {8, 2}},
 CellGroupingRules->"OutputGrouping",
 CellFrameMargins->{{42, 0}, {6, 6}},
 Background->RGBColor[0.94, 0.96, 0.98]],

Cell[StyleData["NotebookImage", "Preview"]],

Cell[StyleData["NotebookImage", "Printout"],
 CellMargins->{{45, 0}, {6, 4}},
 CellFrameMargins->{{32, 0}, {6, 6}},
 Background->GrayLevel[0.94]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Picture"],
 CellMargins->{{74, 4}, {3, 8}},
 CellGroupingRules->"GraphicsGrouping",
 CellHorizontalScrolling->True,
 StyleMenuListing->None,
 GraphicsBoxOptions->{ImageSize->Medium},
 Graphics3DBoxOptions->{ImageSize->Medium}],

Cell[StyleData["Picture", "Printout"],
 CellMargins->{{2, Inherited}, {4, 4}},
 Magnification->0.65]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BannerImage"],
 Editable->False,
 PageWidth->WindowWidth,
 CellMargins->{{20, 10}, {12, 72}},
 CellElementSpacings->{"ClosedGroupTopMargin"->36},
 CellGroupingRules->{"SectionGrouping", 50},
 StyleMenuListing->None,
 GraphicsBoxOptions->{ImagePadding->None}],

Cell[StyleData["Picture", "Printout"],
 CellMargins->{{0, 0}, {8, 0}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Inline Formatting", "Section"],

Cell[CellGroupData[{

Cell[StyleData["KeyboardChars"],
 StyleMenuListing->None,
 FontSize->12],

Cell[StyleData["KeyboardChars", "Printout"],
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineCode"],
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 AutoItalicWords->{},
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->Inherited 1.05],

Cell[StyleData["InlineCode", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineCharacterName"],
 ShowSpecialCharacters->False,
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 AutoItalicWords->{},
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->Inherited 1.05],

Cell[StyleData["InlineCharacterName", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FilenameExtension"],
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 AutoItalicWords->{},
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->Inherited 1.05],

Cell[StyleData["FilenameExtension", "Printout"]]
}, Closed]],

Cell[StyleData["MenuName"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->RGBColor[0.35, 0.25, 0.25]],

Cell[StyleData["MenuNameDelimiter"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->RGBColor[0.35, 0.25, 0.25]],

Cell[StyleData["KeyEvent"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->RGBColor[0.35, 0.25, 0.25],
 Background->RGBColor[0.9, 0.85, 0.8]],

Cell[StyleData["KeyEventDelimiter"],
 FontSize->Inherited + 4,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontColor->RGBColor[0.75, 0.5, 0]],

Cell[StyleData["PointerEvent"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->RGBColor[0.35, 0.25, 0.25]],

Cell[StyleData["PointerEventDelimiter"],
 FontSize->Inherited + 4,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontColor->RGBColor[0.75, 0.5, 0]],

Cell[StyleData["DialogElementName"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->RGBColor[0.35, 0.25, 0.25]],

Cell[CellGroupData[{

Cell[StyleData["FunctionAnnotation"],
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Plain"],

Cell[StyleData["FunctionAnnotation", "Printout"],
 FontSize->9]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Hyperlinks", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Link"],
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Appearance->{Automatic, None},
 ButtonFunction:>((Needs["DocumentationTools`"]; 
  DocumentationTools`DocLink[#, #2])& ),
 ButtonNote->ButtonData,
 ButtonSource->ButtonContents,
 Evaluator->Automatic}],

Cell[StyleData["Link", "Printout"],
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MathWorldLink"],
 CellChangeTimes->{3.428704684073299*^9},
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>((Needs["DocumentationTools`"]; 
  DocumentationTools`DocLink[DocumentationTools`$MathWorldPath, #, #2])& ),
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["MathWorldLink", "Printout"],
 CellChangeTimes->{3.428704684073496*^9},
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FunctionsSiteLink"],
 CellChangeTimes->{3.428704684073674*^9},
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>((Needs["DocumentationTools`"]; 
  DocumentationTools`DocLink[DocumentationTools`$FunctionsSitePath, #, #2])& ),
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["FunctionsSiteLink", "Printout"],
 CellChangeTimes->{3.4287046840738697`*^9},
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NKSLink"],
 CellChangeTimes->{3.428704684074047*^9},
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>((Needs["DocumentationTools`"]; 
  DocumentationTools`DocLink[DocumentationTools`$NKSPath, #, #2])& ),
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["NKSLink", "Printout"],
 CellChangeTimes->{3.428704684074252*^9},
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NETDocLink"],
 CellChangeTimes->{3.428704684074802*^9},
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Appearance->{Automatic, None},
 ButtonFunction:>((Needs["DocumentationTools`"]; NETDocLink[#, #2])& ),
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["NETDocLink", "Printout"],
 CellChangeTimes->{3.428704684074998*^9},
 FontColor->GrayLevel[0]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Page Headers and Footers", "Section"],

Cell[CellGroupData[{

Cell[StyleData["PageHeader"],
 CellMargins->{{0, 0}, {2, 0}},
 LineSpacing->{1, 8},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->7,
 FontSlant->"Italic"],

Cell[StyleData["PageHeader", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageNumber"],
 CellFrame->{{0.5, 0}, {0, 0}},
 CellMargins->{{0, 0}, {2, 0}},
 CellFrameMargins->{{4, 4}, {12, 12}},
 CellSize->{24, Inherited},
 LineSpacing->{1, 8},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->7,
 FontWeight->"Bold"],

Cell[StyleData["PageNumber", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageFooter"],
 CellMargins->{{0, 0}, {0, 2}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->6],

Cell[StyleData["PageFooter", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell["For compatibility", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Header"],
 CellMargins->{{0, 0}, {2, 0}},
 StyleMenuListing->None,
 FontSize->8,
 FontSlant->"Italic"],

Cell[StyleData["Header", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Footer"],
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontSize->6],

Cell[StyleData["Footer", "Printout"]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
},
WindowSize->{802, 670},
WindowMargins->{{379, Automatic}, {Automatic, 99}},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (October 12, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 118, 1, 83, "Title"],
Cell[688, 25, 46, 0, 40, 46, 0, "StyleData", "StyleDefinitions", ""],
Cell[737, 27, 56, 0, 40, 56, 0, "StyleData", "StyleDefinitions", ""],
Cell[CellGroupData[{
Cell[818, 31, 42, 0, 71, "Section"],
Cell[863, 33, 207, 6, 70, 31, 0, "StyleData", "All", "Working",
 MenuSortingValue->1100],
Cell[1073, 41, 208, 6, 70, 31, 0, "StyleData", "All", "Preview",
 MenuSortingValue->1300],
Cell[1284, 49, 195, 6, 70, 32, 0, "StyleData", "All", "Printout",
 MenuSortingValue->1400],
Cell[1482, 57, 118, 3, 70, 40, 0, "StyleData", "All", "InternalDocument",
 StyleMenuListing->None],
Cell[1603, 62, 131, 3, 70, 38, 0, "StyleData", "All", "ObsoleteObject",
 StyleMenuListing->None],
Cell[1737, 67, 114, 3, 70, 36, 0, "StyleData", "All", "FutureObject",
 StyleMenuListing->None],
Cell[1854, 72, 119, 3, 70, 39, 0, "StyleData", "All", "TentativeObject",
 StyleMenuListing->None],
Cell[1976, 77, 132, 3, 70, 39, 0, "StyleData", "All", "TemporaryObject",
 StyleMenuListing->None],
Cell[2111, 82, 128, 3, 70, 50, 0, "StyleData", "All", \
"AwaitingFutureDesignReview",
 StyleMenuListing->None],
Cell[2242, 87, 117, 3, 70, 39, 0, "StyleData", "All", "PreviewDocument",
 StyleMenuListing->None],
Cell[2362, 92, 123, 3, 70, 37, 0, "StyleData", "All", "ExcisedObject",
 StyleMenuListing->None],
Cell[2488, 97, 55, 1, 70, 33, 0, "StyleData", "All", "Condensed",
 MenuSortingValue->0],
Cell[2546, 100, 58, 1, 70, 36, 0, "StyleData", "All", "Presentation",
 MenuSortingValue->0],
Cell[2607, 103, 55, 1, 70, 33, 0, "StyleData", "All", "SlideShow",
 MenuSortingValue->0]
}, Closed]],
Cell[CellGroupData[{
Cell[2699, 109, 35, 0, 41, "Section"],
Cell[2737, 111, 165, 3, 29, "Text"],
Cell[2905, 116, 2298, 55, 40, 27, 0, "StyleData", "Notebook", "All",
 StyleMenuListing->None]
}, Closed]],
Cell[CellGroupData[{
Cell[5240, 176, 31, 0, 41, "Section"],
Cell[5274, 178, 250, 4, 47, "Text"],
Cell[CellGroupData[{
Cell[5549, 186, 230, 5, 43, 24, 0, "StyleData", "Input", "All"],
Cell[5782, 193, 108, 3, 70, 36, 0, "StyleData", "Input", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[5927, 201, 313, 8, 42, 25, 0, "StyleData", "Output", "All"],
Cell[6243, 211, 109, 3, 70, 37, 0, "StyleData", "Output", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[6389, 219, 87, 2, 42, 29, 0, "StyleData", "OutputStub", "All"],
Cell[6479, 223, 113, 3, 70, 41, 0, "StyleData", "OutputStub", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[6629, 231, 176, 4, 44, 28, 0, "StyleData", "InputOnly", "All"],
Cell[6808, 237, 112, 3, 70, 40, 0, "StyleData", "InputOnly", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[6957, 245, 194, 5, 36, 26, 0, "StyleData", "Message", "All",
 StyleMenuListing->None],
Cell[7154, 252, 180, 5, 70, 38, 0, "StyleData", "Message", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[7371, 262, 170, 4, 38, 24, 0, "StyleData", "Print", "All"],
Cell[7544, 268, 124, 3, 70, 36, 0, "StyleData", "Print", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[7705, 276, 28, 0, 37, 28, 0, "StyleData", "CellLabel", "All"],
Cell[7736, 278, 103, 3, 70, 40, 0, "StyleData", "CellLabel", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[7876, 286, 179, 6, 37, 23, 0, "StyleData", "Name", "All",
 StyleMenuListing->None],
Cell[8058, 294, 98, 3, 70, 35, 0, "StyleData", "Name", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[8205, 303, 36, 0, 41, "Section"],
Cell[CellGroupData[{
Cell[8266, 307, 230, 8, 39, 26, 0, "StyleData", "History", "All",
 StyleMenuListing->None],
Cell[8499, 317, 52, 1, 70, 38, 0, "StyleData", "History", "Printout"]
}, Closed]],
Cell[8566, 321, 112, 4, 22, 30, 0, "StyleData", "HistoryData", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[8703, 329, 254, 9, 37, 31, 0, "StyleData", "InternalFlag", "All",
 StyleMenuListing->None],
Cell[8960, 340, 57, 1, 70, 43, 0, "StyleData", "InternalFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[9054, 346, 252, 9, 37, 29, 0, "StyleData", "FutureFlag", "All",
 StyleMenuListing->None],
Cell[9309, 357, 55, 1, 70, 41, 0, "StyleData", "FutureFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[9401, 363, 255, 9, 37, 32, 0, "StyleData", "TemporaryFlag", "All",
 StyleMenuListing->None],
Cell[9659, 374, 58, 1, 70, 44, 0, "StyleData", "TemporaryFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[9754, 380, 254, 9, 37, 31, 0, "StyleData", "ObsoleteFlag", "All",
 StyleMenuListing->None],
Cell[10011, 391, 57, 1, 70, 43, 0, "StyleData", "ObsoleteFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10105, 397, 248, 9, 37, 30, 0, "StyleData", "ExcisedFlag", "All",
 StyleMenuListing->None],
Cell[10356, 408, 56, 1, 70, 42, 0, "StyleData", "ExcisedFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10449, 414, 261, 9, 37, 38, 0, "StyleData", "SubjectToChangeFlag", "All",
 StyleMenuListing->None],
Cell[10713, 425, 64, 1, 70, 50, 0, "StyleData", "SubjectToChangeFlag", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10814, 431, 272, 9, 37, 49, 0, "StyleData", \
"AwaitingFutureDesignReviewFlag", "All",
 StyleMenuListing->None],
Cell[11089, 442, 75, 1, 70, 61, 0, "StyleData", \
"AwaitingFutureDesignReviewFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[11201, 448, 253, 9, 37, 30, 0, "StyleData", "PreviewFlag", "All",
 StyleMenuListing->None],
Cell[11457, 459, 56, 1, 70, 42, 0, "StyleData", "PreviewFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[11550, 465, 373, 10, 34, 40, 0, "StyleData", "CategorizationSection", \
"All",
 StyleMenuListing->None],
Cell[11926, 477, 171, 4, 70, 52, 0, "StyleData", "CategorizationSection", \
"Printout"]
}, Closed]],
Cell[12112, 484, 329, 9, 34, 33, 0, "StyleData", "Categorization", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[12466, 497, 361, 10, 44, 34, 0, "StyleData", "SynonymsSection", "All",
 StyleMenuListing->None],
Cell[12830, 509, 165, 4, 70, 46, 0, "StyleData", "SynonymsSection", "Printout"]
}, Closed]],
Cell[13010, 516, 323, 9, 34, 27, 0, "StyleData", "Synonyms", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[13358, 529, 346, 10, 44, 34, 0, "StyleData", "KeywordsSection", "All",
 StyleMenuListing->None],
Cell[13707, 541, 165, 4, 70, 46, 0, "StyleData", "KeywordsSection", "Printout"]
}, Closed]],
Cell[13887, 548, 330, 10, 34, 27, 0, "StyleData", "Keywords", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[14242, 562, 358, 10, 44, 40, 0, "StyleData", "DocumentStatusSection", \
"All",
 StyleMenuListing->None],
Cell[14603, 574, 171, 4, 70, 52, 0, "StyleData", "DocumentStatusSection", \
"Printout"]
}, Closed]],
Cell[14789, 581, 285, 8, 34, 33, 0, "StyleData", "DocumentStatus", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[15099, 593, 351, 10, 44, 33, 0, "StyleData", "DetailsSection", "All",
 StyleMenuListing->None],
Cell[15453, 605, 164, 4, 70, 45, 0, "StyleData", "DetailsSection", "Printout"]
}, Closed]],
Cell[15632, 612, 249, 7, 34, 26, 0, "StyleData", "Details", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[15906, 623, 249, 8, 42, 28, 0, "StyleData", "GuideIcon", "All",
 StyleMenuListing->None],
Cell[16158, 633, 159, 4, 70, 40, 0, "StyleData", "GuideIcon", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[16354, 642, 225, 6, 37, 26, 0, "StyleData", "ModInfo", "All",
 StyleMenuListing->None],
Cell[16582, 650, 138, 3, 70, 38, 0, "StyleData", "ModInfo", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[16757, 658, 258, 7, 56, 29, 0, "StyleData", "BrightFlag", "All",
 StyleMenuListing->None],
Cell[17018, 667, 70, 1, 70, 41, 0, "StyleData", "BrightFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[17125, 673, 321, 10, 56, 31, 0, "StyleData", "BrighterFlag", "All",
 StyleMenuListing->None],
Cell[17449, 685, 72, 1, 70, 43, 0, "StyleData", "BrighterFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[17558, 691, 109, 3, 44, 33, 0, "StyleData", "ExcludedObject", "All",
 StyleMenuListing->None],
Cell[17670, 696, 45, 0, 70, 45, 0, "StyleData", "ExcludedObject", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[17752, 701, 123, 3, 44, 36, 0, "StyleData", "TOCExcludedObject", "All",
 StyleMenuListing->None],
Cell[17878, 706, 48, 0, 70, 48, 0, "StyleData", "TOCExcludedObject", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[17963, 711, 120, 3, 44, 32, 0, "StyleData", "PrimaryObject", "All",
 StyleMenuListing->None],
Cell[18086, 716, 44, 0, 70, 44, 0, "StyleData", "PrimaryObject", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[18167, 721, 358, 11, 70, 35, 0, "StyleData", "ObsolescenceNote", "All",
 StyleMenuListing->None],
Cell[18528, 734, 247, 6, 70, 47, 0, "StyleData", "ObsolescenceNote", \
"Printout",
 StyleMenuListing->None]
}, Closed]],
Cell[CellGroupData[{
Cell[18812, 745, 378, 12, 70, 37, 0, "StyleData", "AwaitingReviewNote", "All",
 StyleMenuListing->None],
Cell[19193, 759, 249, 6, 70, 49, 0, "StyleData", "AwaitingReviewNote", \
"Printout",
 StyleMenuListing->None]
}, Closed]],
Cell[CellGroupData[{
Cell[19479, 770, 376, 12, 70, 30, 0, "StyleData", "PreviewNote", "All",
 StyleMenuListing->None],
Cell[19858, 784, 242, 6, 70, 42, 0, "StyleData", "PreviewNote", "Printout",
 StyleMenuListing->None]
}, Closed]],
Cell[CellGroupData[{
Cell[20137, 795, 330, 11, 59, 25, 0, "StyleData", "Status", "All",
 StyleMenuListing->None],
Cell[20470, 808, 51, 1, 70, 37, 0, "StyleData", "Status", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[20558, 814, 685, 18, 93, 29, 0, "StyleData", "GuideTitle", "All",
 StyleMenuListing->None],
Cell[21246, 834, 142, 3, 70, 41, 0, "StyleData", "GuideTitle", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[21425, 842, 829, 22, 40, 32, 0, "StyleData", "GuideAbstract", "All",
 StyleMenuListing->None],
Cell[22257, 866, 164, 4, 70, 44, 0, "StyleData", "GuideAbstract", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[22458, 875, 473, 15, 36, 36, 0, "StyleData", "GuideMainTutorial", "All",
 StyleMenuListing->None],
Cell[22934, 892, 196, 5, 70, 48, 0, "StyleData", "GuideMainTutorial", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[23167, 902, 470, 15, 36, 33, 0, "StyleData", "GuideTestDrive", "All",
 StyleMenuListing->None],
Cell[23640, 919, 193, 5, 70, 45, 0, "StyleData", "GuideTestDrive", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[23870, 929, 321, 10, 43, 33, 0, "StyleData", "GuideDelimiter", "All",
 StyleMenuListing->None],
Cell[24194, 941, 114, 3, 70, 45, 0, "StyleData", "GuideDelimiter", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[24345, 949, 379, 11, 79, 40, 0, "StyleData", "GuideFunctionsSection", \
"All",
 StyleMenuListing->None],
Cell[24727, 962, 268, 7, 70, 52, 0, "StyleData", "GuideFunctionsSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[25032, 974, 325, 11, 34, 46, 0, "StyleData", \
"GuideFunctionsSubsubsection", "All",
 StyleMenuListing->None],
Cell[25360, 987, 181, 4, 35, 58, 0, "StyleData", \
"GuideFunctionsSubsubsection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[25578, 996, 281, 9, 38, 32, 0, "StyleData", "GuideFunction", "All",
 StyleMenuListing->None],
Cell[25862, 1007, 164, 4, 70, 44, 0, "StyleData", "GuideFunction", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[26063, 1016, 214, 7, 41, 38, 0, "StyleData", "InlineGuideFunction", "All",
 StyleMenuListing->None],
Cell[26280, 1025, 155, 3, 70, 50, 0, "StyleData", "InlineGuideFunction", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[26472, 1033, 279, 8, 40, 45, 0, "StyleData", \
"InlineGuideFunctionListing", "All",
 StyleMenuListing->None],
Cell[26754, 1043, 176, 4, 70, 57, 0, "StyleData", \
"InlineGuideFunctionListing", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[26967, 1052, 561, 16, 40, 32, 0, "StyleData", "InlineFormula", "All",
 StyleMenuListing->None],
Cell[27531, 1070, 76, 1, 40, 44, 0, "StyleData", "InlineFormula", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[27644, 1076, 536, 16, 40, 29, 0, "StyleData", "InlineMath", "All",
 StyleMenuListing->None],
Cell[28183, 1094, 73, 1, 70, 41, 0, "StyleData", "InlineMath", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[28293, 1100, 218, 6, 41, 41, 0, "StyleData", "InlineCharacterDisplay", \
"All",
 StyleMenuListing->None],
Cell[28514, 1108, 85, 1, 70, 53, 0, "StyleData", "InlineCharacterDisplay", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[28636, 1114, 788, 21, 37, 28, 0, "StyleData", "GuideText", "All",
 StyleMenuListing->None],
Cell[29427, 1137, 159, 4, 70, 40, 0, "StyleData", "GuideText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[29623, 1146, 339, 9, 50, 43, 0, "StyleData", "GuideFunctionsSubsection", \
"All",
 StyleMenuListing->None],
Cell[29965, 1157, 205, 5, 70, 55, 0, "StyleData", "GuideFunctionsSubsection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[30207, 1167, 418, 12, 81, 40, 0, "StyleData", "GuideTutorialsSection", \
"All",
 StyleMenuListing->None],
Cell[30628, 1181, 268, 7, 70, 52, 0, "StyleData", "GuideTutorialsSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[30933, 1193, 223, 8, 37, 32, 0, "StyleData", "GuideTutorial", "All",
 MenuSortingValue->100,
 MenuCommandKey->"1"],
Cell[31159, 1203, 163, 4, 34, 44, 0, "StyleData", "GuideTutorial", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[31359, 1212, 417, 12, 81, 40, 0, "StyleData", "GuideMoreAboutSection", \
"All",
 StyleMenuListing->None],
Cell[31779, 1226, 268, 7, 79, 52, 0, "StyleData", "GuideMoreAboutSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[32084, 1238, 320, 10, 39, 42, 0, "StyleData", "GuideMoreAboutDelimiter", \
"All",
 StyleMenuListing->None],
Cell[32407, 1250, 123, 3, 35, 54, 0, "StyleData", "GuideMoreAboutDelimiter", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[32567, 1258, 810, 24, 37, 33, 0, "StyleData", "GuideMoreAbout", "All",
 MenuSortingValue->200,
 MenuCommandKey->"2"],
Cell[33380, 1284, 164, 4, 34, 45, 0, "StyleData", "GuideMoreAbout", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[33581, 1293, 788, 23, 37, 36, 0, "StyleData", "GuideMoreAboutSub", "All",
 StyleMenuListing->None],
Cell[34372, 1318, 167, 4, 34, 48, 0, "StyleData", "GuideMoreAboutSub", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[34576, 1327, 287, 8, 50, 43, 0, "StyleData", "GuideMoreAboutSubsection", \
"All",
 StyleMenuListing->None],
Cell[34866, 1337, 204, 5, 70, 55, 0, "StyleData", "GuideMoreAboutSubsection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[35107, 1347, 529, 15, 37, 31, 0, "StyleData", "1ColumnTable", "All",
 StyleMenuListing->None],
Cell[35639, 1364, 347, 10, 70, 43, 0, "StyleData", "1ColumnTable", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[36023, 1379, 498, 15, 37, 31, 0, "StyleData", "2ColumnTable", "All",
 StyleMenuListing->None],
Cell[36524, 1396, 347, 10, 70, 43, 0, "StyleData", "2ColumnTable", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[36908, 1411, 576, 17, 37, 31, 0, "StyleData", "3ColumnTable", "All",
 StyleMenuListing->None],
Cell[37487, 1430, 347, 10, 70, 43, 0, "StyleData", "3ColumnTable", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[37871, 1445, 740, 23, 37, 34, 0, "StyleData", "1ColumnTableMod", "All",
 StyleMenuListing->None],
Cell[38614, 1470, 497, 14, 70, 46, 0, "StyleData", "1ColumnTableMod", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[39148, 1489, 814, 25, 37, 34, 0, "StyleData", "2ColumnTableMod", "All",
 StyleMenuListing->None],
Cell[39965, 1516, 518, 15, 34, 46, 0, "StyleData", "2ColumnTableMod", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[40520, 1536, 836, 26, 37, 34, 0, "StyleData", "3ColumnTableMod", "All",
 StyleMenuListing->None],
Cell[41359, 1564, 535, 16, 34, 46, 0, "StyleData", "3ColumnTableMod", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[41931, 1585, 809, 20, 38, 28, 0, "StyleData", "TableText", "All",
 StyleMenuListing->None],
Cell[42743, 1607, 172, 4, 70, 40, 0, "StyleData", "TableText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[42952, 1616, 78, 2, 44, 38, 0, "StyleData", "GuideCharacterImage", "All",
 StyleMenuListing->None],
Cell[43033, 1620, 50, 0, 70, 50, 0, "StyleData", "GuideCharacterImage", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[43120, 1625, 423, 12, 81, 43, 0, "StyleData", \
"GuideRelatedLinksSection", "All",
 StyleMenuListing->None],
Cell[43546, 1639, 271, 7, 70, 55, 0, "StyleData", "GuideRelatedLinksSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[43854, 1651, 845, 23, 37, 36, 0, "StyleData", "GuideRelatedLinks", "All",
 StyleMenuListing->None],
Cell[44702, 1676, 167, 4, 70, 48, 0, "StyleData", "GuideRelatedLinks", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[44906, 1685, 1006, 27, 81, 26, 0, "StyleData", "Section", "All",
 StyleMenuListing->None],
Cell[45915, 1714, 139, 4, 70, 38, 0, "StyleData", "Section", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[46091, 1723, 980, 26, 59, 29, 0, "StyleData", "Subsection", "All",
 StyleMenuListing->None],
Cell[47074, 1751, 168, 5, 70, 41, 0, "StyleData", "Subsection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[47279, 1761, 918, 24, 48, 32, 0, "StyleData", "Subsubsection", "All",
 StyleMenuListing->None],
Cell[48200, 1787, 144, 4, 70, 44, 0, "StyleData", "Subsubsection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[48381, 1796, 943, 25, 43, 35, 0, "StyleData", "Subsubsubsection", "All",
 StyleMenuListing->None],
Cell[49327, 1823, 147, 4, 70, 47, 0, "StyleData", "Subsubsubsection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[49511, 1832, 468, 15, 58, 23, 0, "StyleData", "Code", "All",
 CounterIncrements->"Code"],
Cell[49982, 1849, 95, 2, 42, 35, 0, "StyleData", "Code", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[50114, 1856, 471, 15, 57, 26, 0, "StyleData", "Program", "All",
 CounterIncrements->"Code"],
Cell[50588, 1873, 98, 2, 42, 38, 0, "StyleData", "Program", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[50723, 1880, 373, 11, 79, 34, 0, "StyleData", "OverviewSection", "All",
 StyleMenuListing->None],
Cell[51099, 1893, 268, 7, 70, 52, 0, "StyleData", "GuideFunctionsSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[51404, 1905, 306, 9, 38, 37, 0, "StyleData", "OverviewSubsection", "All",
 StyleMenuListing->None],
Cell[51713, 1916, 198, 5, 70, 49, 0, "StyleData", "OverviewSubsection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[51948, 1926, 206, 7, 36, 35, 0, "StyleData", "OverviewTutorial", "All",
 StyleMenuListing->None],
Cell[52157, 1935, 166, 4, 70, 47, 0, "StyleData", "OverviewTutorial", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[52360, 1944, 277, 7, 40, 31, 0, "StyleData", "OverviewLink", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[52640, 1953, 69, 1, 70, 43, 0, "StyleData", "OverviewLink", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[52746, 1959, 604, 16, 37, 38, 0, "StyleData", "AlphabeticalListing", \
"All",
 StyleMenuListing->None],
Cell[53353, 1977, 96, 2, 70, 50, 0, "StyleData", "AlphabeticalListing", \
"Printout"]
}, Closed]],
Cell[53464, 1982, 405, 8, 40, 36, 0, "StyleData", "ConversionSpecial", "All",
 StyleMenuListing->None],
Cell[53872, 1992, 157, 4, 40, 37, 0, "StyleData", "ConversionLockdown", "All",
 StyleMenuListing->None],
Cell[54032, 1998, 469, 10, 48, 32, 0, "StyleData", "FutureExample", "All",
 StyleMenuListing->None],
Cell[54504, 2010, 539, 12, 48, 35, 0, "StyleData", "TentativeExample", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[55068, 2026, 211, 6, 37, 30, 0, "StyleData", "TentativeID", "All",
 StyleMenuListing->None],
Cell[55282, 2034, 42, 0, 70, 42, 0, "StyleData", "TentativeID", "Printout"]
}, Closed]],
Cell[55339, 2037, 461, 10, 48, 35, 0, "StyleData", "ExcludedMaterial", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[55825, 2051, 384, 13, 57, 33, 0, "StyleData", "TextAnnotation", "All"],
Cell[56212, 2066, 45, 0, 57, 45, 0, "StyleData", "TextAnnotation", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[56294, 2071, 316, 10, 37, 39, 0, "StyleData", "TextAnnotationButton", \
"All"],
Cell[56613, 2083, 51, 0, 37, 51, 0, "StyleData", "TextAnnotationButton", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[56701, 2088, 365, 11, 37, 45, 0, "StyleData", \
"TextAnnotationRemoveButton", "All"],
Cell[57069, 2101, 57, 0, 37, 57, 0, "StyleData", \
"TextAnnotationRemoveButton", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[57163, 2106, 559, 15, 89, 32, 0, "StyleData", "GuideTOCTitle", "All",
 StyleMenuListing->None],
Cell[57725, 2123, 145, 3, 70, 44, 0, "StyleData", "GuideTOCTitle", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[57907, 2131, 876, 23, 80, 35, 0, "StyleData", "GuideTOCAbstract", "All",
 StyleMenuListing->None],
Cell[58786, 2156, 167, 4, 70, 47, 0, "StyleData", "GuideTOCAbstract", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[58990, 2165, 812, 22, 38, 31, 0, "StyleData", "GuideTOCLink", "All",
 StyleMenuListing->None],
Cell[59805, 2189, 162, 4, 70, 43, 0, "StyleData", "GuideTOCLink", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[60004, 2198, 829, 22, 62, 31, 0, "StyleData", "GuideTOCText", "All",
 StyleMenuListing->None],
Cell[60836, 2222, 163, 4, 70, 43, 0, "StyleData", "GuideTOCText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[61036, 2231, 200, 5, 54, 32, 0, "StyleData", "NotebookImage", "All"],
Cell[61239, 2238, 43, 0, 70, 43, 0, "StyleData", "NotebookImage", "Preview"],
Cell[61285, 2240, 145, 3, 70, 44, 0, "StyleData", "NotebookImage", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[61467, 2248, 242, 6, 39, 26, 0, "StyleData", "Picture", "All",
 StyleMenuListing->None],
Cell[61712, 2256, 100, 2, 70, 38, 0, "StyleData", "Picture", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[61849, 2263, 274, 7, 80, 30, 0, "StyleData", "BannerImage", "All",
 StyleMenuListing->None],
Cell[62126, 2272, 70, 1, 70, 38, 0, "StyleData", "Picture", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[62245, 2279, 36, 0, 41, "Section"],
Cell[CellGroupData[{
Cell[62306, 2283, 72, 2, 70, 32, 0, "StyleData", "KeyboardChars", "All",
 StyleMenuListing->None],
Cell[62381, 2287, 59, 1, 70, 44, 0, "StyleData", "KeyboardChars", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[62477, 2293, 213, 6, 70, 29, 0, "StyleData", "InlineCode", "All",
 StyleMenuListing->None],
Cell[62693, 2301, 41, 0, 70, 41, 0, "StyleData", "InlineCode", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[62771, 2306, 253, 7, 70, 38, 0, "StyleData", "InlineCharacterName", "All",
 StyleMenuListing->None],
Cell[63027, 2315, 50, 0, 70, 50, 0, "StyleData", "InlineCharacterName", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[63114, 2320, 220, 6, 70, 36, 0, "StyleData", "FilenameExtension", "All",
 StyleMenuListing->None],
Cell[63337, 2328, 48, 0, 70, 48, 0, "StyleData", "FilenameExtension", \
"Printout"]
}, Closed]],
Cell[63400, 2331, 133, 4, 70, 27, 0, "StyleData", "MenuName", "All"],
Cell[63536, 2337, 142, 4, 70, 36, 0, "StyleData", "MenuNameDelimiter", "All"],
Cell[63681, 2343, 172, 5, 70, 27, 0, "StyleData", "KeyEvent", "All"],
Cell[63856, 2350, 141, 4, 70, 36, 0, "StyleData", "KeyEventDelimiter", "All"],
Cell[64000, 2356, 137, 4, 70, 31, 0, "StyleData", "PointerEvent", "All"],
Cell[64140, 2362, 145, 4, 70, 40, 0, "StyleData", "PointerEventDelimiter", \
"All"],
Cell[64288, 2368, 142, 4, 70, 36, 0, "StyleData", "DialogElementName", "All"],
Cell[CellGroupData[{
Cell[64455, 2376, 98, 3, 70, 37, 0, "StyleData", "FunctionAnnotation", "All"],
Cell[64556, 2381, 63, 1, 70, 49, 0, "StyleData", "FunctionAnnotation", \
"Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[64668, 2388, 29, 0, 41, "Section"],
Cell[CellGroupData[{
Cell[64722, 2392, 343, 9, 40, 23, 0, "StyleData", "Link", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[65068, 2403, 61, 1, 40, 35, 0, "StyleData", "Link", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[65166, 2409, 413, 10, 40, 32, 0, "StyleData", "MathWorldLink", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[65582, 2421, 112, 2, 40, 44, 0, "StyleData", "MathWorldLink", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[65731, 2428, 421, 10, 40, 36, 0, "StyleData", "FunctionsSiteLink", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[66155, 2440, 118, 2, 40, 48, 0, "StyleData", "FunctionsSiteLink", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[66310, 2447, 401, 10, 40, 26, 0, "StyleData", "NKSLink", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[66714, 2459, 106, 2, 40, 38, 0, "StyleData", "NKSLink", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[66857, 2466, 341, 8, 40, 29, 0, "StyleData", "NETDocLink", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[67201, 2476, 109, 2, 70, 41, 0, "StyleData", "NETDocLink", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[67359, 2484, 43, 0, 41, "Section"],
Cell[CellGroupData[{
Cell[67427, 2488, 168, 6, 70, 29, 0, "StyleData", "PageHeader", "All",
 StyleMenuListing->None],
Cell[67598, 2496, 41, 0, 70, 41, 0, "StyleData", "PageHeader", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[67676, 2501, 266, 9, 70, 29, 0, "StyleData", "PageNumber", "All",
 StyleMenuListing->None],
Cell[67945, 2512, 41, 0, 70, 41, 0, "StyleData", "PageNumber", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[68023, 2517, 124, 4, 70, 29, 0, "StyleData", "PageFooter", "All",
 StyleMenuListing->None],
Cell[68150, 2523, 41, 0, 70, 41, 0, "StyleData", "PageFooter", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[68228, 2528, 39, 0, 70, "Subsection"],
Cell[CellGroupData[{
Cell[68292, 2532, 118, 4, 70, 25, 0, "StyleData", "Header", "All",
 StyleMenuListing->None],
Cell[68413, 2538, 37, 0, 70, 37, 0, "StyleData", "Header", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[68487, 2543, 90, 3, 70, 25, 0, "StyleData", "Footer", "All",
 StyleMenuListing->None],
Cell[68580, 2548, 37, 0, 70, 37, 0, "StyleData", "Footer", "Printout"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
