(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    147963,       4832]
NotebookOptionsPosition[    108684,       3866]
NotebookOutlinePosition[    109217,       3885]
CellTagsIndexPosition[    109174,       3882]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Style Definitions for Tutorial Pages", "Title",
 CellChangeTimes->{
  3.431799762651826*^9, 3.449328096078225*^9, {3.4646210901291957`*^9, 
   3.464621090488575*^9}}],

Cell[StyleData[StyleDefinitions -> "Core.nb"]],

Cell[StyleData[StyleDefinitions -> "StyleMenuClear.nb"]],

Cell[CellGroupData[{

Cell["Style Environment Names", "Section"],

Cell[StyleData[All, "Working"],
 PageWidth->650,
 ShowCellBracket->True,
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 ShowAutoStyles->False,
 ScriptMinSize->9,
 MenuSortingValue->1100],

Cell[StyleData[All, "Preview"],
 PageWidth->650,
 ShowCellBracket->False,
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 ShowAutoStyles->False,
 ScriptMinSize->9,
 MenuSortingValue->1200],

Cell[StyleData[All, "SlideShow"],
 PageWidth->WindowWidth,
 ScrollingOptions->{"PagewiseDisplay"->True,
 "VerticalScrollRange"->Fit},
 ShowCellBracket->False,
 ShowAutoStyles->False,
 ScriptMinSize->9,
 MenuSortingValue->1300],

Cell[StyleData[All, "Printout"],
 PageWidth->PaperWidth,
 ShowCellBracket->False,
 ShowAutoStyles->False,
 ScriptMinSize->5,
 MenuSortingValue->1300,
 PrivateFontOptions->{"FontType"->"Outline"}],

Cell[StyleData[All, "AlphaMathematicaDocument"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.95, 0.85, 0.5]],

Cell[StyleData[All, "MathematicaDocument"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.8, 0.95, 0.9]],

Cell[StyleData[All, "InternalDocument"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.9, 1, 0.5]],

Cell[StyleData[All, "ObsoleteObject"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[1, 0.95, 0.8]],

Cell[StyleData[All, "FutureObject"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[1, 0.8, 0.9]],

Cell[StyleData[All, "TentativeObject"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.85, 0.95, 1]],

Cell[StyleData[All, "TemporaryObject"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.5, 1, 0.95]],

Cell[StyleData[All, "AwaitingFutureDesignReview"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.9, 0.9, 1]],

Cell[StyleData[All, "PreviewDocument"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->RGBColor[0.8, 0.9, 1]],

Cell[StyleData[All, "ExcisedObject"],
 PageWidth->650,
 StyleMenuListing->None,
 Background->GrayLevel[0.6]],

Cell[StyleData[All, "Condensed"],
 MenuSortingValue->0],

Cell[StyleData[All, "Presentation"],
 MenuSortingValue->0],

Cell[StyleData[All, "SlideShow"],
 MenuSortingValue->0]
}, Closed]],

Cell[CellGroupData[{

Cell["Notebook Options", "Section"],

Cell["\<\
  The options defined for the style below will be used at the Notebook level.\
\>", "Text",
 CellChangeTimes->{{3.35428247134284*^9, 3.35428247821855*^9}}],

Cell[StyleData["Notebook"],
 PageHeaders->{{None, None, None}, {None, None, 
    Cell[
     TextData[{
       Cell[
        TextData[{"Printed from the ", 
          StyleBox["Mathematica", FontSlant -> "Italic"], " Help System "}], 
        "PageHeader"], 
       Cell[
        TextData[{
          CounterBox["Page"]}], "PageNumber"]}], 
     CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
 PageFooters->{{None, None, None}, {
    Cell[
     TextData[{
      "\[Copyright]1988\[Dash]2008 Wolfram Research, Inc. All rights \
reserved."}], "PageFooter"], None, None}},
 PageHeaderLines->{False, False},
 PageFooterLines->{False, False},
 PrintingOptions->{"FacingPages"->False},
 CreateCellID->True,
 CellLabelAutoDelete->False,
 CellFrameLabelMargins->6,
 DefaultNewInlineCellStyle->"InlineFormula",
 DefaultInlineFormatType->"DefaultInputInlineFormatType",
 InputAliases->{"intt" -> RowBox[{"\[Integral]", 
      RowBox[{"\[SelectionPlaceholder]", 
        RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "dintt" -> RowBox[{
      SubsuperscriptBox[
      "\[Integral]", "\[SelectionPlaceholder]", "\[Placeholder]"], 
      RowBox[{"\[Placeholder]", 
        RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "sumt" -> RowBox[{
      UnderoverscriptBox["\[Sum]", 
       RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
       "\[Placeholder]"], "\[Placeholder]"}], "prodt" -> RowBox[{
      UnderoverscriptBox["\[Product]", 
       RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
       "\[Placeholder]"], "\[Placeholder]"}], "dt" -> RowBox[{
      SubscriptBox["\[PartialD]", "\[Placeholder]"], " ", 
      "\[SelectionPlaceholder]"}], "ls" -> "\[LineSeparator]"},
 InputAutoReplacements->{"gridMathematica" -> FormBox[
     RowBox[{"grid", 
       AdjustmentBox[
        StyleBox["Mathematica", FontSlant -> "Italic"], 
        BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], "webMathematica" -> 
   FormBox[
     RowBox[{"web", 
       AdjustmentBox[
        StyleBox["Mathematica", FontSlant -> "Italic"], 
        BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm]},
 TrackCellChangeTimes->True,
 AutoQuoteCharacters->{},
 PasteAutoQuoteCharacters->{},
 ShowStringCharacters->True,
 CacheGraphics->False,
 StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Input/Output", "Section"],

Cell["\<\
The cells in this section define styles used for input and output to the \
kernel.  Be careful when modifying, renaming, or removing these styles, \
because the front end associates special meanings with these style names.    \
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["Input"],
 ShowCellBracket->True,
 CellMargins->{{74, 4}, {3, 8}},
 CellProlog->DocumentationTools`WolframDocumentProlog[],
 CellLabelAutoDelete->False,
 CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
 MenuSortingValue->800,
 MenuCommandKey->"9"],

Cell[StyleData["Input", "Printout"],
 ShowCellBracket->False,
 CellMargins->{{79, 0}, {4, 6}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Output"],
 ShowCellBracket->True,
 CellMargins->{{74, 4}, {8, 2}},
 CellAutoOverwrite->True,
 CellLabelPositioning->Left,
 CellLabelAutoDelete->False,
 CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
 GraphicsBoxOptions->{ImageSize->Small},
 Graphics3DBoxOptions->{ImageSize->Small}],

Cell[StyleData["Output", "Printout"],
 ShowCellBracket->False,
 CellMargins->{{79, 0}, {6, 4}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InputOnly"],
 ShowCellBracket->True,
 CellMargins->{{74, 4}, {3, 8}},
 CellLabelAutoDelete->False,
 CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}}],

Cell[StyleData["InputOnly", "Printout"],
 ShowCellBracket->False,
 CellMargins->{{79, 0}, {6, 6}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Message"],
 ShowCellBracket->True,
 CellMargins->{{74, 4}, {4, 2}},
 ShowCellLabel->False,
 CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
 StyleMenuListing->None],

Cell[StyleData["Message", "Printout"],
 CellDingbat->None,
 ShowCellBracket->False,
 CellMargins->{{68, Inherited}, {Inherited, Inherited}},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Print"],
 PageWidth->WindowWidth,
 ShowCellBracket->True,
 CellMargins->{{74, 27}, {4, 2}},
 CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}}],

Cell[StyleData["Print", "Printout"],
 ShowCellBracket->False,
 CellMargins->{{68, 2}, {Inherited, Inherited}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CellLabel"]],

Cell[StyleData["CellLabel", "Printout"],
 FontSize->7,
 FontSlant->"Oblique",
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Name"],
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontSize->9,
 FontWeight->"Plain",
 FontSlant->"Italic",
 FontColor->RGBColor[0.269993, 0.308507, 0.6]],

Cell[StyleData["Name", "Printout"],
 FontSize->7,
 FontSlant->"Oblique",
 FontColor->GrayLevel[0]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Tutorial Page Styles", "Section"],

Cell[CellGroupData[{

Cell[StyleData["History"],
 Editable->False,
 PageWidth->680,
 CellMargins->{{28, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->12,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["History", "Printout"],
 FontSize->9]
}, Closed]],

Cell[StyleData["HistoryData"],
 Editable->True,
 Deletable->False,
 CellSize->{36, 14},
 StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["InternalFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{28, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["InternalFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FutureFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{28, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["FutureFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TemporaryFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{28, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["TemporaryFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ObsoleteFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{28, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["ObsoleteFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExcisedFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{28, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.8]],

Cell[StyleData["ExcisedFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AlphaMathematicaFlag"],
 ShowCellTags->True,
 Background->RGBColor[0.95, 0.85, 0.5]],

Cell[StyleData["AlphaMathematicaFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MathematicaFlag"],
 ShowCellTags->True,
 Background->RGBColor[0.8, 0.95, 0.9]],

Cell[StyleData["MathematicaFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubjectToChangeFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{28, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["SubjectToChangeFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AwaitingFutureDesignReviewFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{28, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["AwaitingFutureDesignReviewFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PreviewFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{28, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["PreviewFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AlphaMathematicaSourceFlag"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{28, 12}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain"],

Cell[StyleData["AlphaMathematicaSourceFlag", "Printout"],
 FontSize->9]
}, Closed]],

Cell[StyleData["MathematicaSourceFlag", StyleDefinitions -> StyleData[
 "AlphaMathematicaSourceFlag"]]],

Cell[CellGroupData[{

Cell[StyleData["CategorizationSection"],
 CellMargins->{{28, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"Categorization",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["CategorizationSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[StyleData["Categorization"],
 CellMargins->{{52, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 CellLabelPositioning->Above,
 CellLabelMargins->{{28, Inherited}, {Inherited, Inherited}},
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["SynonymsSection"],
 CellMargins->{{28, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"Synonyms",
 ParagraphSpacing->{0.7000000000000002, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["SynonymsSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[StyleData["Synonyms"],
 CellMargins->{{52, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 CellLabelPositioning->Above,
 CellLabelMargins->{{28, Inherited}, {Inherited, Inherited}},
 ParagraphSpacing->{0.7000000000000002, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["KeywordsSection"],
 CellMargins->{{28, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"Keywords",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["KeywordsSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[StyleData["Keywords"],
 CellMargins->{{52, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 CellLabelPositioning->Above,
 CellLabelMargins->{{28, Inherited}, {Inherited, Inherited}},
 ParagraphSpacing->{0.7, 0},
 AutoItalicWords->{},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["DocumentStatusSection"],
 CellMargins->{{28, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"DocumentStatus",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["DocumentStatusSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[StyleData["DocumentStatus"],
 CellMargins->{{52, 80}, {2, 2}},
 ReturnCreatesNewCell->True,
 CellLabelPositioning->Above,
 CellLabelMargins->{{28, Inherited}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["DetailsSection"],
 CellMargins->{{28, 80}, {2, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewCellStyle->"DocumentStatus",
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.500008]],

Cell[StyleData["DetailsSection", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[StyleData["Details"],
 CellMargins->{{52, 80}, {2, 2}},
 CellLabelPositioning->Above,
 CellLabelMargins->{{48, Inherited}, {Inherited, Inherited}},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["ObsolescenceNote"],
 CellFrame->True,
 CellMargins->{{24, 8}, {12, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->12},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameMargins->12,
 CellFrameColor->RGBColor[1, 1, 0],
 Hyphenation->False,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 Background->RGBColor[0.95, 0.95, 0.6]],

Cell[StyleData["ObsolescenceNote", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 StyleMenuListing->None,
 FontSize->10,
 FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TutorialObsolescenceNote"],
 CellFrame->True,
 CellMargins->{{24, 8}, {12, 12}},
 CellElementSpacings->{"ClosedGroupTopMargin"->12},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameMargins->12,
 Hyphenation->False,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->RGBColor[0.6, 0.4, 0.2]],

Cell[StyleData["TutorialObsolescenceNote", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
 FontSize->10,
 FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ObsolescenceNote"],
 CellFrame->True,
 CellMargins->{{24, 8}, {12, 6}},
 CellGroupingRules->{"SectionGrouping", 50},
 CellFrameMargins->12,
 CellFrameColor->RGBColor[0.9, 0.9, 0],
 Hyphenation->False,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 Background->RGBColor[1, 1, 0]],

Cell[StyleData["ObsolescenceNote", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 StyleMenuListing->None,
 FontSize->10,
 FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AwaitingReviewNote"],
 Editable->False,
 CellFrame->True,
 CellMargins->{{24, 8}, {12, 6}},
 CellGroupingRules->{"SectionGrouping", 50},
 CellFrameMargins->12,
 CellFrameColor->RGBColor[0.9, 0.9, 0],
 Hyphenation->False,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 Background->RGBColor[1, 1, 0]],

Cell[StyleData["AwaitingReviewNote", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 StyleMenuListing->None,
 FontSize->10,
 FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PreviewNote"],
 Editable->False,
 CellFrame->True,
 CellMargins->{{24, 8}, {12, 6}},
 CellGroupingRules->{"SectionGrouping", 50},
 CellFrameMargins->12,
 CellFrameColor->RGBColor[0.6, 0.7, 1],
 Hyphenation->False,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 Background->RGBColor[0.9, 0.98, 1]],

Cell[StyleData["PreviewNote", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 StyleMenuListing->None,
 FontSize->10,
 FontWeight->"Plain"]
}, Closed]],

Cell[StyleData["GuidePageMarker"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontColor->GrayLevel[0.5]],

Cell[CellGroupData[{

Cell[StyleData["ModInfo"],
 CellSize->{25, Inherited},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->Inherited 0.9,
 FontWeight->"Plain",
 FontColor->RGBColor[0.269993, 0.308507, 0.6]],

Cell[StyleData["ModInfo", "Printout"],
 CellSize->{17, Inherited},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BrightFlag"],
 StyleMenuListing->None,
 FontColor->GrayLevel[1],
 Background->RGBColor[1, 0, 0],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>(DocumentationTools`DocLink[#, #2]& ),
 Evaluator->Automatic}],

Cell[StyleData["BrightFlag", "Printout"],
 Background->GrayLevel[0.8]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BrighterFlag"],
 StyleMenuListing->None,
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontColor->GrayLevel[1],
 Background->RGBColor[1, 0., 0.8],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>(DocumentationTools`DocLink[#, #2]& ),
 Evaluator->Automatic}],

Cell[StyleData["BrighterFlag", "Printout"],
 Background->GrayLevel[0.9]]
}, Closed]],

Cell[StyleData["ConversionSpecial"],
 CellBracketOptions->{"Color"->RGBColor[0.7, 0.5, 0.8],
 "Thickness"->3},
 GeneratedCellStyles->{"Graphics"->{"Graphics", "ConversionSpecial"},
 "Message"->{"Message", "MSG", "ConversionSpecial"},
 "Output"->{"Output", "ConversionSpecial"},
 "Print"->{"Print", "ConversionSpecial"},
 "PrintTemporary"->{"PrintTemporary", "ConversionSpecial"}},
 StyleMenuListing->None],

Cell[StyleData["ConversionLockdown"],
 CellBracketOptions->{"Color"->RGBColor[0.8, 0.5, 0.4],
 "Thickness"->3},
 Evaluatable->False,
 StyleMenuListing->None],

Cell[StyleData["FutureExample"],
 CellBracketOptions->{"Color"->RGBColor[0.9, 0.4, 0.4],
 "Thickness"->5},
 GeneratedCellStyles->{"Graphics"->{"Graphics", "FutureExample"},
 "Message"->{"Message", "MSG", "FutureExample"},
 "Output"->{"Output", "FutureExample"},
 "Print"->{"Print", "FutureExample"},
 "PrintTemporary"->{"PrintTemporary", "FutureExample"}},
 CellFrameMargins->4,
 StyleMenuListing->None,
 Background->RGBColor[1, 0.9500000000000003, 0.9500000000000003]],

Cell[StyleData["TentativeExample"],
 CellBracketOptions->{
 "Color"->RGBColor[
  0.30000000000000016`, 0.6000000000000003, 0.7000000000000003],
 "Thickness"->5},
 GeneratedCellStyles->{"Graphics"->{"Graphics", "TentativeExample"},
 "Message"->{"Message", "MSG", "TentativeExample"},
 "Output"->{"Output", "TentativeExample"},
 "Print"->{"Print", "TentativeExample"},
 "PrintTemporary"->{"PrintTemporary", "TentativeExample"}},
 CellFrameMargins->4,
 StyleMenuListing->None,
 Background->RGBColor[0.8500000000000003, 0.9500000000000003, 1]],

Cell[CellGroupData[{

Cell[StyleData["TentativeID"],
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Plain",
 FontColor->RGBColor[0.10000000000000002`, 0.30000000000000016`, 0.4],
 Background->GrayLevel[1]],

Cell[StyleData["TentativeID", "Printout"]]
}, Closed]],

Cell[StyleData["ExcludedMaterial"],
 CellBracketOptions->{"Color"->RGBColor[0.8, 0.8, 0.6],
 "Thickness"->5},
 GeneratedCellStyles->{"Graphics"->{"Graphics", "ExcludedMaterial"},
 "Message"->{"Message", "MSG", "ExcludedMaterial"},
 "Output"->{"Output", "ExcludedMaterial"},
 "Print"->{"Print", "ExcludedMaterial"},
 "PrintTemporary"->{"PrintTemporary", "ExcludedMaterial"}},
 CellFrameMargins->4,
 StyleMenuListing->None,
 Background->RGBColor[0.95, 0.95, 0.8]],

Cell[CellGroupData[{

Cell[StyleData["TextAnnotation"],
 CellFrame->1,
 CellFrameColor->RGBColor[0.8, 0, 0],
 AutoSpacing->False,
 LineIndent->Automatic,
 FontSize->11,
 FontWeight->"Plain",
 FontColor->RGBColor[0.4, 0.2, 0.2],
 Background->GrayLevel[0.999]],

Cell[StyleData["TextAnnotation", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextAnnotationButton"],
 Editable->False,
 FontFamily->"Verdana",
 FontSize->9,
 ButtonBoxOptions->{Active->True,
 Appearance->"DialogBox",
 ButtonFunction:>(Needs["DocumentationTools`"]; 
  DocumentationTools`GenerateAnnotationDialog[]),
 ButtonMargins->1,
 Evaluator->Automatic,
 Method->"Queued"}],

Cell[StyleData["TextAnnotationButton", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextAnnotationRemoveButton"],
 Editable->False,
 FontFamily->"Verdana",
 FontSize->9,
 ButtonBoxOptions->{Active->True,
 Appearance->"DialogBox",
 ButtonFunction:>(Needs["DocumentationTools`"]; 
  DocumentationTools`AnnotationRemove[
   DocumentationTools`CalledFromFrameLabel -> True]),
 ButtonMargins->1,
 Evaluator->Automatic,
 Method->"Queued"}],

Cell[StyleData["TextAnnotationRemoveButton", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Status"],
 Editable->False,
 Deletable->False,
 PageWidth->680,
 CellMargins->{{48, 12}, {0, 30}},
 CellElementSpacings->{"ClosedGroupTopMargin"->50},
 CellGroupingRules->{"SectionGrouping", 50},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontColor->GrayLevel[0.300008]],

Cell[StyleData["Status", "Printout"],
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Title"],
 CellDingbat->None,
 CellMargins->{{27, 27}, {8, 72}},
 CellElementSpacings->{"ClosedGroupTopMargin"->72},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"TitleGrouping", 10},
 PageBreakBelow->False,
 CellLabelPositioning->Above,
 CellFrameLabelMargins->6,
 DefaultNewCellStyle->"Text",
 DefaultNewInlineCellStyle->"InlineMath",
 DefaultReturnCreatedCellStyle->"Text",
 DefaultInlineFormatType->"DefaultTextInlineFormatType",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 CounterIncrements->"Section",
 CounterAssignments->{{"Section", 0}, {"Subsection", 0}, {
   "Subsubsection", 0}, {"Subsubsubsection", 0}, {"ItemizedText", 0}, {
   "NumberedEquation", 0}},
 FontFamily->"Verdana",
 FontSize->20,
 FontWeight->"Bold",
 FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["Title", "Printout"],
 CellMargins->{{2, 0}, {6, 60}},
 FontSize->15,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DataSourceTitle"],
 CellDingbat->None,
 CellMargins->{{27, 27}, {8, 72}},
 CellElementSpacings->{"ClosedGroupTopMargin"->72},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 30},
 PageBreakBelow->False,
 CellFrameLabelMargins->6,
 DefaultNewCellStyle->"DataSourceText",
 DefaultNewInlineCellStyle->"InlineMath",
 DefaultReturnCreatedCellStyle->"NotesText",
 DefaultInlineFormatType->"DefaultTextInlineFormatType",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 CounterIncrements->"Section",
 CounterAssignments->{{"Section", 0}, {"Subsection", 0}, {
   "Subsubsection", 0}, {"Subsubsubsection", 0}, {"ItemizedText", 0}, {
   "NumberedEquation", 0}},
 FontFamily->"Verdana",
 FontSize->20,
 FontWeight->"Bold",
 FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["DataSourceTitle", "Printout"],
 CellMargins->{{2, 0}, {6, 60}},
 FontSize->15,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Section"],
 CellDingbat->None,
 CellMargins->{{27, 27}, {8, 14}},
 CellElementSpacings->{"ClosedGroupTopMargin"->72},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 30},
 PageBreakBelow->False,
 CellFrameLabelMargins->6,
 DefaultNewCellStyle->"Text",
 DefaultReturnCreatedCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 CounterIncrements->"Section",
 CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}, {
   "Subsubsubsection", 0}, {"ItemizedText", 0}, {"NumberedEquation", 0}},
 MenuSortingValue->100,
 MenuCommandKey->"1",
 FontFamily->"Verdana",
 FontSize->16,
 FontWeight->"Bold",
 FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["Section", "Printout"],
 CellMargins->{{2, 0}, {6, 60}},
 FontSize->15,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsection"],
 CellDingbat->None,
 CellMargins->{{27, 27}, {8, 14}},
 CellElementSpacings->{"ClosedGroupTopMargin"->18},
 CellGroupingRules->{"SectionGrouping", 40},
 PageBreakBelow->False,
 CellFrameLabelMargins->6,
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 CounterIncrements->"Subsection",
 CounterAssignments->{{"Subsubsection", 0}, {"Subsubsubsection", 0}, {
   "ItemizedText", 0}, {"NumberedEquation", 0}},
 MenuSortingValue->200,
 MenuCommandKey->"2",
 FontFamily->"Verdana",
 FontSize->13,
 FontWeight->"Bold",
 FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["Subsection", "Printout"],
 CellMargins->{{2, 0}, {6, 16}},
 FontSize->11,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsectionOpener"],
 CellDingbat->None,
 ShowGroupOpener->True,
 CellMargins->{{27, 27}, {8, 24}},
 CellElementSpacings->{"ClosedGroupTopMargin"->24},
 CellGroupingRules->{"SectionGrouping", 40},
 PageBreakBelow->False,
 CellFrameLabelMargins->6,
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 CounterIncrements->"Subsection",
 CounterAssignments->{{"Subsubsection", 0}, {"Subsubsubsection", 0}, {
   "ItemizedText", 0}, {"NumberedEquation", 0}},
 FontFamily->"Verdana",
 FontSize->13,
 FontWeight->"Bold",
 FontColor->RGBColor[
  0.5921569999999997, 0.3137260000000001, 0.3137260000000001]],

Cell[StyleData["SubsectionOpener", "Printout"],
 CellMargins->{{2, 0}, {6, 16}},
 FontSize->11,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsection"],
 CellMargins->{{27, 27}, {8, 18}},
 CellElementSpacings->{"ClosedGroupTopMargin"->18},
 CellGroupingRules->{"SectionGrouping", 50},
 PageBreakBelow->False,
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 CounterIncrements->"Subsubsection",
 CounterAssignments->{{"Subsubsubsection", 0}, {"ItemizedText", 0}, {
   "NumberedEquation", 0}},
 MenuSortingValue->300,
 MenuCommandKey->"3",
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["Subsubsection", "Printout"],
 CellMargins->{{2, 0}, {6, 16}},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsectionOpener"],
 ShowGroupOpener->True,
 CellMargins->{{27, 27}, {8, 18}},
 CellElementSpacings->{"ClosedGroupTopMargin"->18},
 CellGroupingRules->{"SectionGrouping", 50},
 PageBreakBelow->False,
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 CounterIncrements->"Subsubsection",
 CounterAssignments->{{"Subsubsubsection", 0}, {"ItemizedText", 0}, {
   "NumberedEquation", 0}},
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->RGBColor[
  0.5921569999999997, 0.3137260000000001, 0.3137260000000001]],

Cell[StyleData["SubsubsectionOpener", "Printout"],
 CellMargins->{{2, 0}, {6, 16}},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsubsection"],
 CellMargins->{{27, 27}, {6, 18}},
 CellElementSpacings->{"ClosedGroupTopMargin"->18},
 CellGroupingRules->{"SectionGrouping", 60},
 PageBreakBelow->False,
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 CounterAssignments->{{"ItemizedText", 0}, {"NumberedEquation", 0}},
 MenuSortingValue->400,
 MenuCommandKey->"4",
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->GrayLevel[0.5]],

Cell[StyleData["Subsubsubsection", "Printout"],
 CellMargins->{{2, 0}, {5, 12}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsubsectionOpener"],
 ShowGroupOpener->True,
 CellMargins->{{27, 27}, {6, 18}},
 CellElementSpacings->{"ClosedGroupTopMargin"->18},
 CellGroupingRules->{"SectionGrouping", 60},
 PageBreakBelow->False,
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 CounterAssignments->{{"ItemizedText", 0}, {"NumberedEquation", 0}},
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->GrayLevel[0.5]],

Cell[StyleData["SubsubsubsectionOpener", "Printout"],
 CellMargins->{{2, 0}, {5, 12}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsubsubsection"],
 CellMargins->{{27, 27}, {6, 18}},
 CellElementSpacings->{"ClosedGroupTopMargin"->18},
 CellGroupingRules->{"SectionGrouping", 60},
 PageBreakBelow->False,
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 CounterAssignments->{{"ItemizedText", 0}, {"NumberedEquation", 0}},
 MenuSortingValue->500,
 MenuCommandKey->"5",
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Bold",
 FontSlant->"Italic",
 FontColor->GrayLevel[0.5]],

Cell[StyleData["Subsubsubsubsection", "Printout"],
 CellMargins->{{2, 0}, {5, 12}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsubsubsectionOpener"],
 ShowGroupOpener->True,
 CellMargins->{{27, 27}, {6, 18}},
 CellElementSpacings->{"ClosedGroupTopMargin"->18},
 CellGroupingRules->{"SectionGrouping", 60},
 PageBreakBelow->False,
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 CounterAssignments->{{"ItemizedText", 0}, {"NumberedEquation", 0}},
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Bold",
 FontSlant->"Italic",
 FontColor->GrayLevel[0.5]],

Cell[StyleData["SubsubsubsubsectionOpener", "Printout"],
 CellMargins->{{2, 0}, {5, 12}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RelatedTutorialsSection"],
 CellFrame->{{0, 0}, {0, 4}},
 CellMargins->{{36, 4}, {12, 36}},
 CellElementSpacings->{"ClosedGroupTopMargin"->30},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameMargins->4,
 CellFrameColor->RGBColor[0.2, 0.3, 0.7],
 DefaultNewCellStyle->"RelatedTutorials",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.5]],

Cell[StyleData["RelatedTutorialsSection", "Printout"],
 CellFrame->{{0, 0}, {0, 2}},
 CellMargins->{{24, 2}, {8, 32}},
 PageBreakBelow->False,
 CellFrameColor->GrayLevel[0.2],
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->10,
 FontColor->GrayLevel[0.4]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RelatedTutorials"],
 CellMargins->{{48, 80}, {6, 1}},
 CellFrameMargins->4,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold"],

Cell[StyleData["RelatedTutorials", "Printout"],
 CellMargins->{{43, 2}, {5, 0}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TutorialMoreAboutSection"],
 CellFrame->{{0, 0}, {0, 4}},
 CellMargins->{{36, 4}, {12, 36}},
 CellElementSpacings->{"ClosedGroupTopMargin"->30},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameMargins->4,
 CellFrameColor->RGBColor[0.8, 0.5, 0],
 DefaultNewCellStyle->"TutorialMoreAbout",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.5]],

Cell[StyleData["TutorialMoreAboutSection", "Printout"],
 CellFrame->{{0, 0}, {0, 2}},
 CellMargins->{{24, 2}, {8, 32}},
 PageBreakBelow->False,
 CellFrameColor->GrayLevel[0.5],
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->10,
 FontColor->GrayLevel[0.4]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TutorialMoreAbout"],
 CellMargins->{{48, 80}, {6, 1}},
 CellFrameMargins->4,
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->RGBColor[0.8, 0.5, 0],
 GridBoxOptions->{ColumnsEqual->True,
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {{
      Scaled[0.5]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[1.05]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.4]}, 
     Offset[0.2]}, "RowsIndexed" -> {}},
 GridDefaultElement->Cell["XXXX", "GuideMoreAbout"]}],

Cell[StyleData["TutorialMoreAbout", "Printout"],
 CellMargins->{{43, 2}, {5, 0}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TutorialRelatedLinksSection"],
 CellFrame->{{0, 0}, {0, 4}},
 CellMargins->{{36, 4}, {12, 36}},
 CellElementSpacings->{"ClosedGroupTopMargin"->30},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameMargins->4,
 CellFrameColor->RGBColor[0.8, 0.2, 0],
 DefaultNewCellStyle->"TutorialRelatedLinks",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.5]],

Cell[StyleData["TutorialRelatedLinksSection", "Printout"],
 CellFrame->{{0, 0}, {0, 2}},
 CellMargins->{{24, 2}, {8, 32}},
 PageBreakBelow->False,
 CellFrameColor->GrayLevel[0.5],
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->10,
 FontColor->GrayLevel[0.4]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TutorialRelatedLinks"],
 CellMargins->{{48, 80}, {6, 1}},
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 ParagraphSpacing->{0.7, 0},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold"],

Cell[StyleData["TutorialRelatedLinks", "Printout"],
 CellMargins->{{43, 2}, {5, 0}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["1ColumnTable"],
 PageWidth->720,
 CellMargins->{{66, 50}, {6, 0}},
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {{
      Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridDefaultElement->Cell["XXXX", "TableText"]}],

Cell[StyleData["1ColumnTable", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {0, 8}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["2ColumnTable"],
 PageWidth->720,
 CellMargins->{{66, 50}, {6, 0}},
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.4], {
      Scaled[0.6]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["2ColumnTable", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {0, 8}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["3ColumnTable"],
 PageWidth->720,
 CellMargins->{{66, 50}, {6, 0}},
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.28], 
     Scaled[0.28], {
      Scaled[0.44]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["3ColumnTable", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {0, 8}},
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["1ColumnTableMod"],
 PageWidth->700,
 CellMargins->{{40, 50}, {6, 0}},
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.04], {
      Scaled[0.966]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], 
     Offset[0.126], {
      Offset[0.77]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.4]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}],

Cell[StyleData["1ColumnTableMod", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {5, 0}},
 FontSize->9,
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.078], {
      Scaled[0.922]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.56]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["2ColumnTableMod"],
 PageWidth->700,
 CellMargins->{{40, 50}, {6, 0}},
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.41], {
      Scaled[0.54]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], 
     Offset[0.14], {
      Offset[0.77]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.4]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}],

Cell[StyleData["2ColumnTableMod", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {5, 0}},
 FontSize->9,
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.079], 
     Scaled[0.363], {
      Scaled[0.558]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.56]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["3ColumnTableMod"],
 PageWidth->700,
 CellMargins->{{40, 50}, {6, 0}},
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->11,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.04], 
     Scaled[0.266], 
     Scaled[0.26], {
      Scaled[0.434]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], 
     Offset[0.14], {
      Offset[0.77]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.4]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}],

Cell[StyleData["3ColumnTableMod", "Printout"],
 PageWidth->PaperWidth,
 CellMargins->{{2, 0}, {5, 0}},
 FontSize->9,
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.08], 
     Scaled[0.25], 
     Scaled[0.25], {
      Scaled[0.42]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.56]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineFormula"],
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LanguageCategory->"Formula",
 AutoSpacing->True,
 ScriptLevel->1,
 AutoMultiplicationSymbol->False,
 SingleLetterItalics->False,
 SpanMaxSize->1,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->Inherited 1.05,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 FractionBoxOptions->{BaseStyle->{SpanMaxSize -> Automatic}},
 GridBoxOptions->{
 GridBoxItemSize->{
  "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["InlineFormula", "Printout"],
 CellMargins->{{2, 0}, {0, 8}}],

Cell[StyleData["InlineFormula", "Working"],
 Background->RGBColor[1, 0.875, 0.75]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineOutput"],
 CellMargins->{{27, 4}, {0, 8}},
 CellHorizontalScrolling->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LanguageCategory->None,
 AutoMultiplicationSymbol->False,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->Inherited 1.05],

Cell[StyleData["InlineOutput", "Printout"],
 CellMargins->{{2, 0}, {0, 8}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineMath"],
 DefaultFormatType->"DefaultTextFormatType",
 DefaultInlineFormatType->"TraditionalForm",
 LanguageCategory->"Formula",
 AutoSpacing->True,
 ScriptLevel->1,
 AutoMultiplicationSymbol->False,
 SingleLetterItalics->True,
 SpanMaxSize->Infinity,
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->1.05 Inherited,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxItemSize->{
  "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["InlineMath", "Printout"],
 CellMargins->{{2, 0}, {0, 8}}],

Cell[StyleData["InlineMath", "Working"],
 Background->RGBColor[0.875, 0.9375, 1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DisplayMath"],
 CellMargins->{{74, 39}, {8, 12}},
 CellGroupingRules->{"SectionGrouping", 70},
 DefaultFormatType->"DefaultTextFormatType",
 DefaultInlineFormatType->"TraditionalForm",
 LanguageCategory->"Formula",
 AutoSpacing->True,
 ScriptLevel->0,
 AutoMultiplicationSymbol->False,
 SingleLetterItalics->True,
 SpanMaxSize->Infinity,
 MenuSortingValue->1000,
 ButtonBoxOptions->{Appearance->{Automatic, None}},
 GridBoxOptions->{
 GridBoxItemSize->{
  "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["DisplayMath", "Printout"],
 CellMargins->{{39, 0}, {6, 10}},
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NumberedEquation"],
 CellMargins->{{74, 39}, {8, 12}},
 CellFrameLabels->{{None, 
    Cell[
     TextData[{"(", 
       CounterBox["NumberedEquation"], ")"}], "Text"]}, {None, None}},
 DefaultFormatType->TraditionalForm,
 LanguageCategory->"Formula",
 AutoSpacing->True,
 ScriptLevel->1,
 AutoMultiplicationSymbol->False,
 SingleLetterItalics->True,
 SpanMaxSize->Infinity,
 CounterIncrements->"NumberedEquation",
 ButtonBoxOptions->{Appearance->{Automatic, None}}],

Cell[StyleData["NumberedEquation", "Printout"],
 CellMargins->{{39, 0}, {6, 10}},
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MathCaption"],
 CellFrame->{{0, 0}, {0, 0.5}},
 CellMargins->{{74, 100}, {2, 20}},
 CellElementSpacings->{"ClosedGroupTopMargin"->20},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 70},
 CellFrameMargins->{{8, 8}, {8, 2}},
 CellFrameColor->GrayLevel[0.700008],
 CellFrameLabelMargins->4,
 DefaultNewCellStyle->"Input",
 DefaultReturnCreatedCellStyle->"Input",
 LineSpacing->{1, 1},
 ParagraphSpacing->{0, 8},
 MenuSortingValue->700,
 MenuCommandKey->"7",
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.2]],

Cell[StyleData["MathCaption", "Printout"],
 CellMargins->{{39, 0}, {0, 14}},
 Hyphenation->True,
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ProgramCaption"],
 CellMargins->{{26, 4}, {4, 16}},
 CellElementSpacings->{"ClosedGroupTopMargin"->16},
 PageBreakAbove->False,
 MenuSortingValue->800,
 MenuCommandKey->"8",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10],

Cell[StyleData["ProgramCaption", "Printout"],
 CellMargins->{{2, 4}, {0, 2}},
 FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Program"],
 CellMargins->{{26, 10}, {5, 7}},
 CellGroupingRules->"InputGrouping",
 StripStyleOnPaste->True,
 PageBreakWithin->False,
 GroupPageBreakWithin->False,
 AutoIndent->False,
 ShowAutoStyles->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LineSpacing->{1.2, 1., 2.},
 AutoItalicWords->{},
 AutoSpacing->False,
 ShowStringCharacters->True,
 CounterIncrements->"Code",
 MenuSortingValue->1100,
 FontFamily->"Courier",
 Background->GrayLevel[0.92]],

Cell[StyleData["Program", "Printout"],
 CellMargins->{{39, 0}, {4, 6}},
 Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Code"],
 CellMargins->{{26, 10}, {5, 7}},
 CellGroupingRules->"InputGrouping",
 StripStyleOnPaste->True,
 PageBreakWithin->False,
 GroupPageBreakWithin->False,
 AutoIndent->False,
 ShowAutoStyles->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LineSpacing->{1.2, 1., 2.},
 AutoItalicWords->{},
 AutoSpacing->False,
 ShowStringCharacters->True,
 CounterIncrements->"Code",
 MenuSortingValue->1200,
 FontFamily->"Courier",
 Background->GrayLevel[0.92]],

Cell[StyleData["Code", "Printout"],
 CellMargins->{{39, 0}, {4, 6}},
 Background->GrayLevel[1]],

Cell[StyleData["MathCaption", "Printout"],
 CellMargins->{{9, 0}, {0, 14}},
 Hyphenation->True,
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Text"],
 CellMargins->{{28, 27}, {4, 4}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 70},
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 LineSpacing->{1, 2},
 ParagraphSpacing->{0, 12},
 CounterIncrements->"Text",
 MenuSortingValue->600,
 MenuCommandKey->"6",
 FontFamily->"Verdana",
 FontSize->11],

Cell[StyleData["Text", "Printout"],
 CellMargins->{{2, 2}, {6, 6}},
 TextJustification->1,
 Hyphenation->True,
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TutorialAbstract"],
 CellMargins->{{28, 27}, {4, 4}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 70},
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 LineSpacing->{1, 2},
 ParagraphSpacing->{0, 12},
 CounterIncrements->"Text",
 FontFamily->"Verdana",
 FontSize->11],

Cell[StyleData["TutorialAbstract", "Printout"],
 CellMargins->{{2, 2}, {6, 6}},
 TextJustification->1,
 Hyphenation->True,
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DataSourceSection"],
 CellMargins->{{27, 27}, {8, 18}},
 CellElementSpacings->{"ClosedGroupTopMargin"->18},
 CellGroupingRules->{"SectionGrouping", 50},
 PageBreakBelow->False,
 DefaultNewCellStyle->"DataSourceText",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["DataSourceSection", "Printout"],
 CellMargins->{{2, 0}, {6, 16}},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DataSourceText"],
 CellMargins->{{28, 27}, {4, 4}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 ReturnCreatesNewCell->True,
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 LineSpacing->{1, 3},
 ParagraphSpacing->{0, 12},
 CounterIncrements->"Text",
 MenuSortingValue->2500,
 FontFamily->"Verdana",
 FontSize->11],

Cell[StyleData["DataSourceText", "Printout"],
 CellMargins->{{2, 2}, {6, 6}},
 TextJustification->1,
 Hyphenation->True,
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DataSourceSummary"],
 CellMargins->{{28, 27}, {12, 4}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 ReturnCreatesNewCell->True,
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 LineSpacing->{1, 3},
 ParagraphSpacing->{0, 12},
 CounterIncrements->"Text",
 MenuSortingValue->2500,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.3]],

Cell[StyleData["DataSourceSummary", "Printout"],
 CellMargins->{{2, 2}, {6, 6}},
 TextJustification->1,
 Hyphenation->True,
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DataSourceContact"],
 CellFrame->{{False, False}, {False, True}},
 CellMargins->{{28, 27}, {4, 32}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 50},
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 LineSpacing->{1, 3},
 ParagraphSpacing->{0, 12},
 CounterIncrements->"Text",
 MenuSortingValue->2500,
 FontFamily->"Verdana",
 FontSize->11,
 FontColor->GrayLevel[0.3]],

Cell[StyleData["DataSourceContact", "Printout"],
 CellMargins->{{2, 2}, {6, 6}},
 TextJustification->1,
 Hyphenation->True,
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DataSourceDisclaimer"],
 PageWidth->WindowWidth,
 CellMargins->{{28, 27}, {4, 20}},
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 LineSpacing->{1, 3},
 ParagraphSpacing->{0, 12},
 MenuSortingValue->None,
 FontFamily->"Verdana",
 FontSize->11],

Cell[StyleData["DataSourceDisclaimer", "Printout"],
 CellMargins->{{2, 2}, {6, 6}},
 TextJustification->1,
 Hyphenation->True,
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextNote"],
 CellFrame->True,
 CellMargins->{{20, 27}, {8, 4}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 70},
 CellFrameColor->GrayLevel[0.8],
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 LineSpacing->{1, 2},
 ParagraphSpacing->{0, 12},
 CounterIncrements->"Text",
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Plain",
 FontSlant->"Italic"],

Cell[StyleData["TextNote", "Printout"],
 CellMargins->{{2, 2}, {6, 6}},
 TextJustification->1,
 Hyphenation->True,
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextEmphasisNote"],
 CellFrame->True,
 CellMargins->{{20, 27}, {8, 4}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 70},
 CellFrameColor->GrayLevel[0.5],
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 LineSpacing->{1, 2},
 ParagraphSpacing->{0, 12},
 CounterIncrements->"Text",
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontSlant->"Italic"],

Cell[StyleData["TextEmphasisNote", "Printout"],
 CellMargins->{{2, 2}, {6, 6}},
 TextJustification->1,
 Hyphenation->True,
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IndentedText"],
 CellMargins->{{45, 39}, {8, 12}},
 ReturnCreatesNewCell->False,
 CellGroupingRules->{"SectionGrouping", 70},
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 LineSpacing->{1, 2},
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["IndentedText", "Printout"],
 CellMargins->{{26, 2}, {6, 6}},
 TextJustification->1,
 Hyphenation->True,
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedText"],
 CellDingbat->Cell[
   TextData[{
     CounterBox["ItemizedText"], ". "}], FontWeight -> "Bold", 
   CellSize -> {24, 14}, TextAlignment -> Right],
 CellMargins->{{45, 39}, {8, 12}},
 ReturnCreatesNewCell->False,
 CellGroupingRules->{"SectionGrouping", 70},
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 CounterIncrements->"ItemizedText",
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["ItemizedText", "Printout"],
 CellDingbat->Cell[
   TextData[
    CounterBox["ItemizedText"]], FontWeight -> "Bold", CellSize -> {18, 12}, 
   TextAlignment -> Right],
 CellMargins->{{2, 2}, {6, 6}},
 TextJustification->1,
 Hyphenation->True,
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedTextParagraph"],
 CellMargins->{{45, 39}, {8, 2}},
 ReturnCreatesNewCell->False,
 CellGroupingRules->{"SectionGrouping", 70},
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 LineSpacing->{1, 2},
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["ItemizedTextParagraph", "Printout"],
 CellMargins->{{26, 2}, {6, 6}},
 TextJustification->1,
 Hyphenation->True,
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BulletedText"],
 CellDingbat->"\[FilledSmallCircle]",
 CellMargins->{{45, Inherited}, {Inherited, Inherited}},
 ReturnCreatesNewCell->False,
 CellGroupingRules->{"SectionGrouping", 70},
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 LineSpacing->{1, 2},
 MenuSortingValue->900,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["BulletedText", "Printout"],
 CellMargins->{{26, 2}, {6, 6}},
 TextJustification->1,
 Hyphenation->True,
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Notes"],
 Editable->True,
 CellDingbat->"\[FilledSmallSquare]",
 CellMargins->{{45, Inherited}, {Inherited, Inherited}},
 ReturnCreatesNewCell->False,
 CellGroupingRules->{"SectionGrouping", 70},
 DefaultNewCellStyle->"Text",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 LineSpacing->{1, 2},
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["Notes", "Printout"],
 CellMargins->{{22, 2}, {6, 6}},
 TextJustification->1,
 Hyphenation->True,
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedPicture"],
 CellMargins->{{45, 4}, {8, 2}},
 CellGroupingRules->"GraphicsGrouping",
 CellHorizontalScrolling->True,
 MenuSortingValue->1111,
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Plain",
 FontSlant->"Plain",
 GraphicsBoxOptions->{ImageSize->Medium},
 Graphics3DBoxOptions->{ImageSize->Medium}],

Cell[StyleData["ItemizedPicture", "Printout"],
 CellMargins->{{2, Inherited}, {4, 4}},
 Magnification->0.65]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Picture"],
 CellMargins->{{28, 4}, {4, 4}},
 CellGroupingRules->"GraphicsGrouping",
 CellHorizontalScrolling->True,
 MenuSortingValue->1110,
 GraphicsBoxOptions->{ImageSize->Medium},
 Graphics3DBoxOptions->{ImageSize->Medium}],

Cell[StyleData["Picture", "Printout"],
 CellMargins->{{2, Inherited}, {4, 4}},
 Magnification->0.65]
}, Closed]],

Cell[StyleData["Deemphasis"],
 ShowCellLabel->False,
 CellLabelAutoDelete->True,
 ShowAutoStyles->False,
 FontSize->9,
 FontColor->GrayLevel[0.75]],

Cell[CellGroupData[{

Cell[StyleData["ExampleLink"],
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontSize->0.8 Inherited,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, "DialogBox"},
 Background->RGBColor[0.7, 0.8, 0.9],
 ButtonFunction:>(DocumentationTools`FindExampleLink[#]& ),
 ButtonMinHeight->0.1,
 ButtonNote->"Examples Link",
 Evaluator->Automatic,
 Method->"Preemptive"}],

Cell[StyleData["ExampleLink", "Printout"],
 CellMargins->{{2, 80}, {0, 8}},
 PageBreakBelow->False,
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->8,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExampleBacklink"],
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontSize->10,
 FontColor->RGBColor[0.4, 0.5, 0.7],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>(DocumentationTools`FindBacklink[#]& ),
 ButtonMinHeight->0.1,
 ButtonNote->"Backlink to Examples Link",
 Evaluator->Automatic},
 Global`FontWieght -> "Plain"],

Cell[StyleData["ExampleBacklink", "Printout"],
 CellMargins->{{2, 80}, {0, 8}},
 PageBreakBelow->False,
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 FontSize->8,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Reference"],
 CellMargins->{{28, 27}, {6, 6}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 70},
 DefaultNewCellStyle->"Reference",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 LineSpacing->{1, 3},
 ParagraphSpacing->{0, 12},
 CounterIncrements->"Reference",
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["Reference", "Printout"],
 CellMargins->{{2, 2}, {5, 5}},
 TextJustification->1,
 Hyphenation->True,
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NotebookImage"],
 PageWidth->650,
 CellMargins->{{72, 12}, {8, 2}},
 CellGroupingRules->"OutputGrouping",
 CellFrameMargins->{{42, 0}, {6, 6}},
 Background->RGBColor[0.94, 0.96, 0.98]],

Cell[StyleData["NotebookImage", "Preview"]],

Cell[StyleData["NotebookImage", "Printout"],
 CellMargins->{{45, 0}, {6, 4}},
 CellFrameMargins->{{32, 0}, {6, 6}},
 Background->GrayLevel[0.94]]
}, Closed]],

Cell[CellGroupData[{

Cell["Definition Boxes and Other Highlighting Styles", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["DefinitionBox1Col"],
 CellFrame->0.5,
 CellMargins->{{27, 12}, {0, 8}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 CellGroupingRules->{"SectionGrouping", 70},
 CellHorizontalScrolling->True,
 PageBreakWithin->False,
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 AutoIndent->False,
 ShowSyntaxStyles->False,
 LineIndent->2,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 Background->RGBColor[0.964706, 0.929412, 0.839216],
 UnderoverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 UnderscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 OverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"ColumnsIndexed" -> {1 -> Scaled[1]}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.7]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {{0.7}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["DefinitionBox1Col", "InternalDocument"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox1Col", "ObsoleteObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox1Col", "FutureObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox1Col", "TemporaryObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox1Col", "AwaitingFutureDesignReview"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox1Col", "ExcisedObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox1Col", "Printout"],
 CellMargins->{{2, 4}, {0, 6}},
 CellFrameColor->GrayLevel[0],
 FontSize->10,
 Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DefinitionBox"],
 CellFrame->0.5,
 CellMargins->{{27, 12}, {0, 8}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 CellGroupingRules->{"SectionGrouping", 70},
 CellHorizontalScrolling->True,
 PageBreakWithin->False,
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 AutoIndent->False,
 ShowSyntaxStyles->False,
 LineIndent->2,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 Background->RGBColor[0.964706, 0.929412, 0.839216],
 UnderoverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 UnderscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 OverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.4], {
      Scaled[0.6]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.7]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {{0.7}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["DefinitionBox", "InternalDocument"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox", "ObsoleteObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox", "FutureObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox", "TemporaryObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox", "AwaitingFutureDesignReview"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox", "ExcisedObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox", "Printout"],
 CellMargins->{{2, 4}, {0, 6}},
 CellFrameColor->GrayLevel[0],
 FontSize->10,
 Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DefinitionBox3Col"],
 CellFrame->0.5,
 CellMargins->{{27, 12}, {0, 8}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 CellGroupingRules->{"SectionGrouping", 70},
 CellHorizontalScrolling->True,
 PageBreakWithin->False,
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 AutoIndent->False,
 ShowSyntaxStyles->False,
 LineIndent->2,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 Background->RGBColor[0.964706, 0.929412, 0.839216],
 UnderoverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 UnderscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 OverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.35], 
     Scaled[0.2], {
      Scaled[0.45]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.7]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {{0.7}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["DefinitionBox3Col", "InternalDocument"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox3Col", "ObsoleteObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox3Col", "FutureObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox3Col", "TemporaryObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox3Col", "AwaitingFutureDesignReview"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox3Col", "ExcisedObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox3Col", "Printout"],
 CellMargins->{{2, 4}, {0, 6}},
 CellFrameColor->GrayLevel[0],
 FontSize->10,
 Background->None]
}, Closed]],

Cell[StyleData["OverUnderScript"],
 SpanMaxSize->0,
 OverscriptBoxOptions->{DiacriticalPositioning->False}],

Cell[CellGroupData[{

Cell[StyleData["DefinitionBox4Col"],
 CellFrame->0.5,
 CellMargins->{{27, 12}, {0, 8}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 CellGroupingRules->{"SectionGrouping", 70},
 CellHorizontalScrolling->True,
 PageBreakWithin->False,
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 AutoIndent->False,
 ShowSyntaxStyles->False,
 LineIndent->2,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 Background->RGBColor[0.964706, 0.929412, 0.839216],
 UnderoverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 UnderscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 OverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.15], 
     Scaled[0.35], 
     Scaled[0.15], {
      Scaled[0.35]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.7]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {{0.7}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["DefinitionBox4Col", "InternalDocument"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox4Col", "ObsoleteObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox4Col", "FutureObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox4Col", "TemporaryObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox4Col", "AwaitingFutureDesignReview"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox4Col", "ExcisedObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox4Col", "Printout"],
 CellMargins->{{2, 4}, {0, 6}},
 CellFrameColor->GrayLevel[0],
 FontSize->10,
 Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DefinitionBox6Col"],
 CellFrame->0.5,
 CellMargins->{{27, 12}, {0, 8}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 CellGroupingRules->{"SectionGrouping", 70},
 CellHorizontalScrolling->True,
 PageBreakWithin->False,
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 AutoIndent->False,
 ShowSyntaxStyles->False,
 LineIndent->2,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 Background->RGBColor[0.964706, 0.929412, 0.839216],
 UnderoverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 UnderscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 OverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.13], 
     Scaled[0.24], 
     Scaled[0.13], 
     Scaled[0.13], 
     Scaled[0.24], {
      Scaled[0.13]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.7]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {{0.7}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["DefinitionBox6Col", "InternalDocument"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox6Col", "ObsoleteObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox6Col", "FutureObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox6Col", "TemporaryObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox6Col", "AwaitingFutureDesignReview"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox6Col", "ExcisedObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DefinitionBox6Col", "Printout"],
 CellMargins->{{2, 4}, {0, 6}},
 CellFrameColor->GrayLevel[0],
 FontSize->10,
 Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PrecedenceTable"],
 CellFrame->0.5,
 CellMargins->{{27, 12}, {0, 8}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 CellGroupingRules->{"SectionGrouping", 70},
 CellHorizontalScrolling->True,
 PageBreakWithin->False,
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 AutoIndent->False,
 ShowSyntaxStyles->False,
 LineIndent->0,
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 Background->RGBColor[0.964706, 0.929412, 0.839216],
 UnderoverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 UnderscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 OverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.3], 
     Scaled[0.45], 
     Scaled[0.2], {
      Scaled[0.05]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.7]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.6]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}],

Cell[StyleData["PrecedenceTable", "InternalDocument"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["PrecedenceTable", "ObsoleteObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["PrecedenceTable", "FutureObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["PrecedenceTable", "TemporaryObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["PrecedenceTable", "AwaitingFutureDesignReview"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["PrecedenceTable", "ExcisedObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["PrecedenceTable", "Printout"],
 CellMargins->{{2, 4}, {0, 8}},
 CellFrameColor->GrayLevel[0],
 FontSize->10,
 Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DoubleBox"],
 CellFrame->0.5,
 CellMargins->{{27, 12}, {0, 8}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 CellGroupingRules->{"SectionGrouping", 70},
 CellHorizontalScrolling->True,
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 ShowSyntaxStyles->False,
 StyleMenuListing->None,
 Background->RGBColor[0.964706, 0.929412, 0.839216],
 FrameBoxOptions->{BoxFrame->0.5,
 FrameMargins->True},
 UnderoverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 UnderscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 OverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Top}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[1.4]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.4]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}],

Cell[StyleData["DoubleBox", "InternalDocument"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DoubleBox", "ObsoleteObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DoubleBox", "FutureObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DoubleBox", "TemporaryObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DoubleBox", "AwaitingFutureDesignReview"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DoubleBox", "ExcisedObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["DoubleBox", "Printout"],
 CellMargins->{{2, 4}, {0, 8}},
 CellFrameColor->GrayLevel[0],
 FontSize->10,
 Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FramedBox"],
 CellFrame->0.5,
 CellMargins->{{27, 12}, {0, 8}},
 CellElementSpacings->{"ClosedGroupTopMargin"->8},
 CellGroupingRules->{"SectionGrouping", 70},
 CellHorizontalScrolling->True,
 PageBreakWithin->False,
 CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
 AutoIndent->False,
 ShowSyntaxStyles->False,
 LineIndent->2,
 FontWeight->"Plain",
 Background->RGBColor[0.964706, 0.929412, 0.839216],
 UnderoverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 UnderscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 OverscriptBoxOptions->{BaseStyle->{"OverUnderScript"}},
 GridBoxOptions->{
 GridBoxAlignment->{
  "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.28], {
      Offset[0.56]}, 
     Offset[0.28]}, "ColumnsIndexed" -> {}, "Rows" -> {{0.7}}, 
   "RowsIndexed" -> {}}}],

Cell[StyleData["FramedBox", "InternalDocument"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["FramedBox", "ObsoleteObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["FramedBox", "FutureObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["FramedBox", "TemporaryObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["FramedBox", "AwaitingFutureDesignReview"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["FramedBox", "ExcisedObject"],
 CellFrameColor->GrayLevel[0],
 Background->None],

Cell[StyleData["FramedBox", "Printout"],
 CellMargins->{{2, 4}, {0, 6}},
 CellFrameColor->GrayLevel[0],
 FontSize->10,
 Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableText"],
 DefaultInlineFormatType->"DefaultInputInlineFormatType",
 InputAutoReplacements->{"TeX" -> FormBox[
     StyleBox[
      RowBox[{"T", 
        AdjustmentBox[
        "E", BoxBaselineShift -> 0.5, BoxMargins -> {{-0.3, 0}, {0, 0}}], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm], "LaTeX" -> 
   FormBox[
     StyleBox[
      RowBox[{"L", 
        StyleBox[
         AdjustmentBox[
         "A", BoxMargins -> {{-0.5, -0.3}, {0, 0}}, BoxBaselineShift -> -0.4],
          FontSize -> Smaller], "T", 
        AdjustmentBox[
        "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 0.5], 
        "X"}], "TR", SingleLetterItalics -> False], TraditionalForm]},
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->Inherited 0.952],

Cell[StyleData["TableText", "Printout"],
 CellMargins->{{24, 0}, {0, 8}},
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"-"},
 LineSpacing->{1., 2, 2.}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableHeader"],
 AutoIndent->False,
 AutoSpacing->False,
 LineIndent->0,
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->Inherited 0.952,
 FontSlant->"Italic"],

Cell[StyleData["TableHeader", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableHeaderLine"],
 GridBoxOptions->{
 GridBoxDividers->{
  "Columns" -> {{False}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}}}],

Cell[StyleData["TableHeaderLine", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Caption"],
 CellMargins->{{27, 4}, {12, 3}},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 70},
 PageBreakAbove->False,
 DefaultNewCellStyle->"Text",
 DefaultReturnCreatedCellStyle->"Text",
 MenuSortingValue->600,
 MenuCommandKey->"6",
 StyleMenuListing->None,
 FontFamily->"Verdana",
 FontSize->10],

Cell[StyleData["Caption", "Printout"],
 CellMargins->{{2, 4}, {2, 0}},
 FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SessionLabel"],
 CellFrame->{{0.5, 0}, {0, 0.5}},
 CellMargins->{{27, 4}, {0, 18}},
 LineSpacing->{1, 0},
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontSize->9],

Cell[StyleData["SessionLabel", "Presentation"],
 FontSize->14],

Cell[StyleData["SessionLabel", "Printout"],
 CellMargins->{{2, 0}, {-4, 18}},
 FontSize->7]
}, Closed]],

Cell["\<\

The item above is a SessionLabel.\
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["ProgramTop"],
 CellFrame->{{0.5, 0.5}, {0, 0.5}},
 CellMargins->{{27, 4}, {-10, 18}},
 LineSpacing->{1, -4},
 StyleMenuListing->None,
 FontSize->4],

Cell[StyleData["ProgramTop", "Presentation"],
 FontSize->6],

Cell[StyleData["ProgramTop", "Printout"],
 CellMargins->{{2, 0}, {-18, 18}}]
}, Closed]],

Cell["\<\

The item above is a ProgramTop line, below is ProgramBottom line.
\
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["ProgramBottom"],
 CellFrame->{{0.5, 0.5}, {0.5, 0}},
 CellMargins->{{27, 4}, {6, 2}},
 LineSpacing->{1, -4},
 StyleMenuListing->None,
 FontSize->4],

Cell[StyleData["ProgramBottom", "Presentation"],
 FontSize->6],

Cell[StyleData["ProgramBottom", "Printout"],
 CellMargins->{{2, 0}, {-10, -2}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Overview TOC Styles", "Subsection",
 CellChangeTimes->{{3.3638151940899*^9, 3.36381520230055*^9}}],

Cell[CellGroupData[{

Cell[StyleData["TOCDocumentTitle"],
 CellDingbat->None,
 CellMargins->{{28, 27}, {72, 72}},
 CellElementSpacings->{"ClosedGroupTopMargin"->72},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 10},
 PageBreakBelow->False,
 CellFrameLabelMargins->6,
 DefaultNewCellStyle->"TOCChapter",
 CounterAssignments->{{"TOCChapter", 0}, {"TOCSection", 0}, {
   "TOCSubsection", 0}, {"TOCSubsubsection", 0}},
 FontFamily->"Verdana",
 FontSize->19,
 FontWeight->"Bold",
 FontColor->GrayLevel[0]],

Cell[StyleData["TOCDocumentTitle", "Printout"],
 CellMargins->{{24, 0}, {60, 60}},
 FontSize->16,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCPart"],
 CellFrame->{{False, False}, {True, False}},
 ShowGroupOpener->True,
 CellMargins->{{28, 27}, {4, 32}},
 CellElementSpacings->{"ClosedGroupTopMargin"->4},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 20},
 PageBreakBelow->False,
 DefaultNewCellStyle->"TOCSection",
 CounterIncrements->"TOCChapter",
 CounterAssignments->{{"TOCSection", 0}, {"TOCSubsection", 0}, {
   "TOCSubsubsection", 0}},
 FontFamily->"Verdana",
 FontSize->18],

Cell[StyleData["TOCPart", "Printout"],
 CellMargins->{{24, 0}, {3, 28}},
 FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCChapter"],
 ShowGroupOpener->True,
 CellMargins->{{28, 27}, {4, 24}},
 CellElementSpacings->{"ClosedGroupTopMargin"->4},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 30},
 PageBreakBelow->False,
 CellFrameLabelMargins->6,
 DefaultNewCellStyle->"TOCSection",
 TabFilling->"\[CenterDot]\[VeryThinSpace]",
 TabSpacings->{36},
 CounterIncrements->"TOCChapter",
 CounterAssignments->{{"TOCSection", 0}, {"TOCSubsection", 0}, {
   "TOCSubsubsection", 0}},
 FontFamily->"Verdana",
 FontSize->14,
 FontWeight->"Bold",
 FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["TOCChapter", "Printout"],
 CellMargins->{{24, 0}, {3, 21}},
 FontSize->12,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSection"],
 ShowGroupOpener->True,
 CellMargins->{{46, 27}, {4, 8}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 50},
 PageBreakBelow->False,
 CellFrameLabelMargins->6,
 DefaultNewCellStyle->"TOCSubsection",
 TabSpacings->{36},
 CounterIncrements->"TOCSection",
 CounterAssignments->{{"TOCSubsection", 0}, {"TOCSubsubsection", 0}, {
   "TOCSubsubsubsection", 0}, {"TOCSubsubsubsubsection", 0}},
 FontFamily->"Verdana",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0]],

Cell[StyleData["TOCSection", "Printout"],
 CellMargins->{{36, 0}, {3, 6}},
 FontSize->10,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSubsection"],
 ShowGroupOpener->True,
 CellMargins->{{64, 27}, {2, 2}},
 CellElementSpacings->{"ClosedGroupTopMargin"->2},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 60},
 PageBreakBelow->False,
 CellFrameLabelMargins->6,
 CounterIncrements->"TOCSsubsection",
 CounterAssignments->{{"TOCSubsection", 0}, {"TOCSubsubsection", 0}, {
   "TOCSubsubsubsection", 0}, {"TOCSubsubsubsubsection", 0}},
 FontFamily->"Verdana",
 FontSize->11,
 FontWeight->"Bold",
 FontColor->GrayLevel[0]],

Cell[StyleData["TOCSubsection", "Printout"],
 CellMargins->{{48, 0}, {2, 2}},
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSubsubsection"],
 ShowGroupOpener->True,
 CellMargins->{{82, 27}, {2, 3}},
 CellElementSpacings->{"ClosedGroupTopMargin"->3},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 70},
 PageBreakBelow->False,
 CellFrameLabelMargins->6,
 CounterIncrements->"TOCSubsubsection",
 CounterAssignments->{{"TOCSubsubsubsection", 0}, {
   "TOCSubsubsubsubsection", 0}},
 FontFamily->"Verdana",
 FontSize->10,
 FontWeight->"Bold",
 FontColor->GrayLevel[0]],

Cell[StyleData["TOCSubsubsection", "Printout"],
 CellMargins->{{60, 0}, {1, 2}},
 FontSize->8,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSubsubsubsection"],
 ShowGroupOpener->True,
 CellMargins->{{100, 27}, {2, 3}},
 CellElementSpacings->{"ClosedGroupTopMargin"->3},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 80},
 PageBreakBelow->False,
 CellFrameLabelMargins->6,
 CounterIncrements->"TOCSubsubsubsection",
 CounterAssignments->{{"TOCSubsubsubsubsection", 0}},
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Bold",
 FontColor->GrayLevel[0]],

Cell[StyleData["TOCSubsubsubsection", "Printout"],
 CellMargins->{{72, 0}, {1, 2}},
 FontSize->7.5,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSubsubsubsubsection"],
 ShowGroupOpener->True,
 CellMargins->{{118, 27}, {2, 3}},
 CellElementSpacings->{"ClosedGroupTopMargin"->3},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 90},
 PageBreakBelow->False,
 CellFrameLabelMargins->6,
 CounterIncrements->"TOCSubsubsubsubsection",
 FontFamily->"Verdana",
 FontSize->9,
 FontWeight->"Bold",
 FontColor->GrayLevel[0.4]],

Cell[StyleData["TOCSubsubsubsubsection", "Printout"],
 CellMargins->{{72, 0}, {1, 2}},
 FontSize->7.5,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSubsubsubsubsubsection"],
 ShowGroupOpener->True,
 CellMargins->{{136, 27}, {2, 3}},
 CellElementSpacings->{"ClosedGroupTopMargin"->3},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"SectionGrouping", 100},
 PageBreakBelow->False,
 CellFrameLabelMargins->6,
 CounterIncrements->"TOCSubsubsubsubsubsection",
 FontFamily->"Verdana",
 FontSize->9,
 FontColor->GrayLevel[0.4]],

Cell[StyleData["TOCSubsubsubsubsubsection", "Printout"],
 CellMargins->{{72, 0}, {1, 2}},
 FontSize->7.5,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCLink"],
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->GrayLevel[0],
 ButtonBoxOptions->{Appearance->{Automatic, None},
 ButtonFunction:>(DocumentationTools`DocLink[#, #2]& ),
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["TOCLink", "Printout"],
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCPointerLink"],
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->GrayLevel[0.46],
 ButtonBoxOptions->{ButtonFunction:>(DocumentationTools`DocLink[#, #2]& ),
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["TOCPointerLink", "Printout"],
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCOpener"],
 StyleMenuListing->None,
 ButtonBoxOptions->{Appearance->{Automatic, None},
 ButtonFunction:>(SelectionMove[
    ButtonNotebook[], All, ButtonContents]; FrontEndTokenExecute[
    ButtonNotebook[], "OpenCloseGroup"]; If[
    FreeQ[
     NotebookRead[
      ButtonNotebook[]], " \[FilledDownTriangle] "], 
    NotebookWrite[
     ButtonNotebook[], 
     TextData[
      ButtonBox[
      " \[FilledDownTriangle] ", DefaultContentStyle -> "TOCOpener"]]], 
    NotebookWrite[
     ButtonNotebook[], 
     TextData[
      ButtonBox[
      " \[FilledUpTriangle] ", DefaultContentStyle -> "TOCOpener"]]]]; 
  SelectionMove[
    ButtonNotebook[], Before, Notebook]),
 Evaluator->Automatic}],

Cell[StyleData["TOCOpener", "Printout"],
 FontColor->GrayLevel[0]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Inline Formatting", "Section"],

Cell["\<\
These styles are for modifying individual words or letters in a cell \
exclusive of the cell tag.\
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["KeyboardChars"],
 StyleMenuListing->None,
 FontSize->12],

Cell[StyleData["KeyboardChars", "Printout"],
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineCode"],
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 AutoItalicWords->{},
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->Inherited 1.05,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["InlineCode", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineCharacterName"],
 ShowSpecialCharacters->False,
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 AutoItalicWords->{},
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->Inherited 1.05],

Cell[StyleData["InlineCharacterName", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FilenameExtension"],
 Hyphenation->True,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 AutoItalicWords->{},
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->Inherited 1.05],

Cell[StyleData["FilenameExtension", "Printout"]]
}, Closed]],

Cell[StyleData["MenuName"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->RGBColor[0.35, 0.25, 0.25]],

Cell[StyleData["MenuNameDelimiter"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->RGBColor[0.35, 0.25, 0.25]],

Cell[StyleData["KeyEvent"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->RGBColor[0.35, 0.25, 0.25],
 Background->RGBColor[0.9, 0.85, 0.8]],

Cell[StyleData["KeyEventDelimiter"],
 FontSize->Inherited + 4,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontColor->RGBColor[0.75, 0.5, 0]],

Cell[StyleData["PointerEvent"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->RGBColor[0.35, 0.25, 0.25]],

Cell[StyleData["PointerEventDelimiter"],
 FontSize->Inherited + 4,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontColor->RGBColor[0.75, 0.5, 0]],

Cell[StyleData["DialogElementName"],
 FontFamily->"Verdana",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontColor->RGBColor[0.35, 0.25, 0.25]]
}, Closed]],

Cell[CellGroupData[{

Cell["Hyperlinks", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Link"],
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Appearance->{Automatic, None},
 ButtonFunction:>((Needs["DocumentationTools`"]; 
  DocumentationTools`DocLink[#, #2])& ),
 ButtonNote->ButtonData,
 ButtonSource->ButtonContents,
 Evaluator->Automatic}],

Cell[StyleData["Link", "Printout"],
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MathWorldLink"],
 CellChangeTimes->{3.428704684073299*^9},
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>((Needs["DocumentationTools`"]; 
  DocumentationTools`DocLink[DocumentationTools`$MathWorldPath, #, #2])& ),
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["MathWorldLink", "Printout"],
 CellChangeTimes->{3.428704684073496*^9},
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FunctionsSiteLink"],
 CellChangeTimes->{3.428704684073674*^9},
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>((Needs["DocumentationTools`"]; 
  DocumentationTools`DocLink[DocumentationTools`$FunctionsSitePath, #, #2])& ),
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["FunctionsSiteLink", "Printout"],
 CellChangeTimes->{3.4287046840738697`*^9},
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NKSLink"],
 CellChangeTimes->{3.428704684074047*^9},
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Active->True,
 Appearance->{Automatic, None},
 ButtonFunction:>((Needs["DocumentationTools`"]; 
  DocumentationTools`DocLink[DocumentationTools`$NKSPath, #, #2])& ),
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["NKSLink", "Printout"],
 CellChangeTimes->{3.428704684074252*^9},
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NETDocLink"],
 CellChangeTimes->{3.428704684074802*^9},
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic,
 FontColor->RGBColor[0.1, 0.1, 0.5],
 ButtonBoxOptions->{Appearance->{Automatic, None},
 ButtonFunction:>((Needs["DocumentationTools`"]; NETDocLink[#, #2])& ),
 ButtonNote->ButtonData,
 Evaluator->Automatic}],

Cell[StyleData["NETDocLink", "Printout"],
 CellChangeTimes->{3.428704684074998*^9},
 FontColor->GrayLevel[0]]
}, Closed]]
}, Closed]]
}, Open  ]]
},
WindowSize->{801, 714},
WindowMargins->{{366, Automatic}, {Automatic, 79}},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (October 12, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData["AlphaMathematicaSourceFlag"]]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (October 12, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 172, 3, 83, "Title"],
Cell[742, 27, 46, 0, 40, 46, 0, "StyleData", "StyleDefinitions", ""],
Cell[791, 29, 56, 0, 40, 56, 0, "StyleData", "StyleDefinitions", ""],
Cell[CellGroupData[{
Cell[872, 33, 42, 0, 71, "Section"],
Cell[917, 35, 207, 6, 70, 31, 0, "StyleData", "All", "Working",
 MenuSortingValue->1100],
Cell[1127, 43, 208, 6, 70, 31, 0, "StyleData", "All", "Preview",
 MenuSortingValue->1200],
Cell[1338, 51, 226, 7, 70, 33, 0, "StyleData", "All", "SlideShow",
 MenuSortingValue->1300],
Cell[1567, 60, 195, 6, 70, 32, 0, "StyleData", "All", "Printout",
 MenuSortingValue->1300],
Cell[1765, 68, 130, 3, 70, 48, 0, "StyleData", "All", \
"AlphaMathematicaDocument",
 StyleMenuListing->None],
Cell[1898, 73, 124, 3, 70, 43, 0, "StyleData", "All", "MathematicaDocument",
 StyleMenuListing->None],
Cell[2025, 78, 118, 3, 70, 40, 0, "StyleData", "All", "InternalDocument",
 StyleMenuListing->None],
Cell[2146, 83, 117, 3, 70, 38, 0, "StyleData", "All", "ObsoleteObject",
 StyleMenuListing->None],
Cell[2266, 88, 114, 3, 70, 36, 0, "StyleData", "All", "FutureObject",
 StyleMenuListing->None],
Cell[2383, 93, 119, 3, 70, 39, 0, "StyleData", "All", "TentativeObject",
 StyleMenuListing->None],
Cell[2505, 98, 118, 3, 70, 39, 0, "StyleData", "All", "TemporaryObject",
 StyleMenuListing->None],
Cell[2626, 103, 128, 3, 70, 50, 0, "StyleData", "All", \
"AwaitingFutureDesignReview",
 StyleMenuListing->None],
Cell[2757, 108, 117, 3, 70, 39, 0, "StyleData", "All", "PreviewDocument",
 StyleMenuListing->None],
Cell[2877, 113, 108, 3, 70, 37, 0, "StyleData", "All", "ExcisedObject",
 StyleMenuListing->None],
Cell[2988, 118, 55, 1, 70, 33, 0, "StyleData", "All", "Condensed",
 MenuSortingValue->0],
Cell[3046, 121, 58, 1, 70, 36, 0, "StyleData", "All", "Presentation",
 MenuSortingValue->0],
Cell[3107, 124, 55, 1, 70, 33, 0, "StyleData", "All", "SlideShow",
 MenuSortingValue->0]
}, Closed]],
Cell[CellGroupData[{
Cell[3199, 130, 35, 0, 41, "Section"],
Cell[3237, 132, 165, 3, 29, "Text"],
Cell[3405, 137, 2285, 55, 40, 27, 0, "StyleData", "Notebook", "All",
 StyleMenuListing->None]
}, Closed]],
Cell[CellGroupData[{
Cell[5727, 197, 31, 0, 41, "Section"],
Cell[5761, 199, 250, 4, 47, "Text"],
Cell[CellGroupData[{
Cell[6036, 207, 275, 7, 43, 24, 0, "StyleData", "Input", "All",
 MenuSortingValue->800,
 MenuCommandKey->"9"],
Cell[6314, 216, 108, 3, 70, 36, 0, "StyleData", "Input", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[6459, 224, 312, 8, 42, 25, 0, "StyleData", "Output", "All"],
Cell[6774, 234, 109, 3, 70, 37, 0, "StyleData", "Output", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[6920, 242, 176, 4, 39, 28, 0, "StyleData", "InputOnly", "All"],
Cell[7099, 248, 112, 3, 70, 40, 0, "StyleData", "InputOnly", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[7248, 256, 193, 5, 36, 26, 0, "StyleData", "Message", "All",
 StyleMenuListing->None],
Cell[7444, 263, 180, 5, 70, 38, 0, "StyleData", "Message", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[7661, 273, 169, 4, 38, 24, 0, "StyleData", "Print", "All"],
Cell[7833, 279, 124, 3, 70, 36, 0, "StyleData", "Print", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[7994, 287, 28, 0, 37, 28, 0, "StyleData", "CellLabel", "All"],
Cell[8025, 289, 103, 3, 70, 40, 0, "StyleData", "CellLabel", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[8165, 297, 179, 6, 37, 23, 0, "StyleData", "Name", "All",
 StyleMenuListing->None],
Cell[8347, 305, 98, 3, 70, 35, 0, "StyleData", "Name", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[8494, 314, 39, 0, 41, "Section"],
Cell[CellGroupData[{
Cell[8558, 318, 230, 8, 39, 26, 0, "StyleData", "History", "All",
 StyleMenuListing->None],
Cell[8791, 328, 52, 1, 70, 38, 0, "StyleData", "History", "Printout"]
}, Closed]],
Cell[8858, 332, 112, 4, 22, 30, 0, "StyleData", "HistoryData", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[8995, 340, 254, 9, 37, 31, 0, "StyleData", "InternalFlag", "All",
 StyleMenuListing->None],
Cell[9252, 351, 57, 1, 70, 43, 0, "StyleData", "InternalFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[9346, 357, 252, 9, 37, 29, 0, "StyleData", "FutureFlag", "All",
 StyleMenuListing->None],
Cell[9601, 368, 55, 1, 70, 41, 0, "StyleData", "FutureFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[9693, 374, 255, 9, 37, 32, 0, "StyleData", "TemporaryFlag", "All",
 StyleMenuListing->None],
Cell[9951, 385, 58, 1, 70, 44, 0, "StyleData", "TemporaryFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10046, 391, 254, 9, 37, 31, 0, "StyleData", "ObsoleteFlag", "All",
 StyleMenuListing->None],
Cell[10303, 402, 57, 1, 70, 43, 0, "StyleData", "ObsoleteFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10397, 408, 248, 9, 37, 30, 0, "StyleData", "ExcisedFlag", "All",
 StyleMenuListing->None],
Cell[10648, 419, 56, 1, 70, 42, 0, "StyleData", "ExcisedFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10741, 425, 100, 2, 56, 39, 0, "StyleData", "AlphaMathematicaFlag", \
"All"],
Cell[10844, 429, 65, 1, 70, 51, 0, "StyleData", "AlphaMathematicaFlag", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10946, 435, 94, 2, 56, 34, 0, "StyleData", "MathematicaFlag", "All"],
Cell[11043, 439, 60, 1, 70, 46, 0, "StyleData", "MathematicaFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[11140, 445, 261, 9, 37, 38, 0, "StyleData", "SubjectToChangeFlag", "All",
 StyleMenuListing->None],
Cell[11404, 456, 64, 1, 70, 50, 0, "StyleData", "SubjectToChangeFlag", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[11505, 462, 272, 9, 37, 49, 0, "StyleData", \
"AwaitingFutureDesignReviewFlag", "All",
 StyleMenuListing->None],
Cell[11780, 473, 75, 1, 70, 61, 0, "StyleData", \
"AwaitingFutureDesignReviewFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[11892, 479, 253, 9, 37, 30, 0, "StyleData", "PreviewFlag", "All",
 StyleMenuListing->None],
Cell[12148, 490, 56, 1, 70, 42, 0, "StyleData", "PreviewFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[12241, 496, 235, 8, 37, 45, 0, "StyleData", \
"AlphaMathematicaSourceFlag", "All",
 StyleMenuListing->None],
Cell[12479, 506, 71, 1, 70, 57, 0, "StyleData", "AlphaMathematicaSourceFlag", \
"Printout"]
}, Closed]],
Cell[12565, 510, 103, 1, 37, 103, 1, "StyleData", "MathematicaSourceFlag", \
"All"],
Cell[CellGroupData[{
Cell[12693, 515, 358, 10, 44, 40, 0, "StyleData", "CategorizationSection", \
"All",
 StyleMenuListing->None],
Cell[13054, 527, 171, 4, 33, 52, 0, "StyleData", "CategorizationSection", \
"Printout"]
}, Closed]],
Cell[13240, 534, 314, 9, 34, 33, 0, "StyleData", "Categorization", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[13579, 547, 361, 10, 44, 34, 0, "StyleData", "SynonymsSection", "All",
 StyleMenuListing->None],
Cell[13943, 559, 165, 4, 33, 46, 0, "StyleData", "SynonymsSection", "Printout"]
}, Closed]],
Cell[14123, 566, 323, 9, 34, 27, 0, "StyleData", "Synonyms", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[14471, 579, 346, 10, 44, 34, 0, "StyleData", "KeywordsSection", "All",
 StyleMenuListing->None],
Cell[14820, 591, 165, 4, 33, 46, 0, "StyleData", "KeywordsSection", "Printout"]
}, Closed]],
Cell[15000, 598, 330, 10, 34, 27, 0, "StyleData", "Keywords", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[15355, 612, 358, 10, 44, 40, 0, "StyleData", "DocumentStatusSection", \
"All",
 StyleMenuListing->None],
Cell[15716, 624, 171, 4, 33, 52, 0, "StyleData", "DocumentStatusSection", \
"Printout"]
}, Closed]],
Cell[15902, 631, 285, 8, 34, 33, 0, "StyleData", "DocumentStatus", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[16212, 643, 351, 10, 44, 33, 0, "StyleData", "DetailsSection", "All",
 StyleMenuListing->None],
Cell[16566, 655, 164, 4, 33, 45, 0, "StyleData", "DetailsSection", "Printout"]
}, Closed]],
Cell[16745, 662, 249, 7, 34, 26, 0, "StyleData", "Details", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[17019, 673, 398, 12, 78, 35, 0, "StyleData", "ObsolescenceNote", "All",
 StyleMenuListing->None],
Cell[17420, 687, 247, 6, 70, 47, 0, "StyleData", "ObsolescenceNote", \
"Printout",
 StyleMenuListing->None]
}, Closed]],
Cell[CellGroupData[{
Cell[17704, 698, 388, 12, 78, 43, 0, "StyleData", "TutorialObsolescenceNote", \
"All",
 StyleMenuListing->None],
Cell[18095, 712, 178, 4, 70, 55, 0, "StyleData", "TutorialObsolescenceNote", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[18310, 721, 341, 11, 72, 35, 0, "StyleData", "ObsolescenceNote", "All",
 StyleMenuListing->None],
Cell[18654, 734, 247, 6, 70, 47, 0, "StyleData", "ObsolescenceNote", \
"Printout",
 StyleMenuListing->None]
}, Closed]],
Cell[CellGroupData[{
Cell[18938, 745, 361, 12, 70, 37, 0, "StyleData", "AwaitingReviewNote", "All",
 StyleMenuListing->None],
Cell[19302, 759, 249, 6, 70, 49, 0, "StyleData", "AwaitingReviewNote", \
"Printout",
 StyleMenuListing->None]
}, Closed]],
Cell[CellGroupData[{
Cell[19588, 770, 359, 12, 70, 30, 0, "StyleData", "PreviewNote", "All",
 StyleMenuListing->None],
Cell[19950, 784, 242, 6, 70, 42, 0, "StyleData", "PreviewNote", "Printout",
 StyleMenuListing->None]
}, Closed]],
Cell[20207, 793, 107, 3, 39, 34, 0, "StyleData", "GuidePageMarker", "All"],
Cell[CellGroupData[{
Cell[20339, 800, 198, 6, 37, 26, 0, "StyleData", "ModInfo", "All",
 StyleMenuListing->None],
Cell[20540, 808, 138, 3, 70, 38, 0, "StyleData", "ModInfo", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[20715, 816, 258, 7, 56, 29, 0, "StyleData", "BrightFlag", "All",
 StyleMenuListing->None],
Cell[20976, 825, 70, 1, 70, 41, 0, "StyleData", "BrightFlag", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[21083, 831, 321, 10, 56, 31, 0, "StyleData", "BrighterFlag", "All",
 StyleMenuListing->None],
Cell[21407, 843, 72, 1, 70, 43, 0, "StyleData", "BrighterFlag", "Printout"]
}, Closed]],
Cell[21494, 847, 405, 8, 40, 36, 0, "StyleData", "ConversionSpecial", "All",
 StyleMenuListing->None],
Cell[21902, 857, 157, 4, 40, 37, 0, "StyleData", "ConversionLockdown", "All",
 StyleMenuListing->None],
Cell[22062, 863, 469, 10, 48, 32, 0, "StyleData", "FutureExample", "All",
 StyleMenuListing->None],
Cell[22534, 875, 539, 12, 48, 35, 0, "StyleData", "TentativeExample", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[23098, 891, 213, 6, 37, 30, 0, "StyleData", "TentativeID", "All",
 StyleMenuListing->None],
Cell[23314, 899, 42, 0, 70, 42, 0, "StyleData", "TentativeID", "Printout"]
}, Closed]],
Cell[23371, 902, 461, 10, 48, 35, 0, "StyleData", "ExcludedMaterial", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[23857, 916, 236, 8, 57, 33, 0, "StyleData", "TextAnnotation", "All"],
Cell[24096, 926, 45, 0, 70, 45, 0, "StyleData", "TextAnnotation", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[24178, 931, 316, 10, 37, 39, 0, "StyleData", "TextAnnotationButton", \
"All"],
Cell[24497, 943, 51, 0, 37, 51, 0, "StyleData", "TextAnnotationButton", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[24585, 948, 365, 11, 37, 45, 0, "StyleData", \
"TextAnnotationRemoveButton", "All"],
Cell[24953, 961, 57, 0, 37, 57, 0, "StyleData", "TextAnnotationRemoveButton", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[25047, 966, 330, 11, 59, 25, 0, "StyleData", "Status", "All",
 StyleMenuListing->None],
Cell[25380, 979, 51, 1, 70, 37, 0, "StyleData", "Status", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[25468, 985, 1388, 36, 122, 24, 0, "StyleData", "Title", "All",
 CounterIncrements->"Section",
 CounterAssignments->{{"Section", 0}, {"Subsection", 0}, {
   "Subsubsection", 0}, {"Subsubsubsection", 0}, {"ItemizedText", 0}, {
   "NumberedEquation", 0}}],
Cell[26859, 1023, 110, 3, 70, 36, 0, "StyleData", "Title", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[27006, 1031, 1385, 35, 122, 34, 0, "StyleData", "DataSourceTitle", "All",
 CounterIncrements->"Section",
 CounterAssignments->{{"Section", 0}, {"Subsection", 0}, {
   "Subsubsection", 0}, {"Subsubsubsection", 0}, {"ItemizedText", 0}, {
   "NumberedEquation", 0}}],
Cell[28394, 1068, 120, 3, 70, 46, 0, "StyleData", "DataSourceTitle", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[28551, 1076, 1289, 34, 57, 26, 0, "StyleData", "Section", "All",
 CounterIncrements->"Section",
 CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}, {
   "Subsubsubsection", 0}, {"ItemizedText", 0}, {"NumberedEquation", 0}},
 MenuSortingValue->100,
 MenuCommandKey->"1"],
Cell[29843, 1112, 112, 3, 96, 38, 0, "StyleData", "Section", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[29992, 1120, 1207, 32, 55, 29, 0, "StyleData", "Subsection", "All",
 CounterIncrements->"Subsection",
 CounterAssignments->{{"Subsubsection", 0}, {"Subsubsubsection", 0}, {
   "ItemizedText", 0}, {"NumberedEquation", 0}},
 MenuSortingValue->200,
 MenuCommandKey->"2"],
Cell[31202, 1154, 115, 3, 48, 41, 0, "StyleData", "Subsection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[31354, 1162, 1224, 32, 65, 35, 0, "StyleData", "SubsectionOpener", "All",
 CounterIncrements->"Subsection",
 CounterAssignments->{{"Subsubsection", 0}, {"Subsubsubsection", 0}, {
   "ItemizedText", 0}, {"NumberedEquation", 0}}],
Cell[32581, 1196, 121, 3, 70, 47, 0, "StyleData", "SubsectionOpener", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[32739, 1204, 1144, 30, 56, 32, 0, "StyleData", "Subsubsection", "All",
 CounterIncrements->"Subsubsection",
 CounterAssignments->{{"Subsubsubsection", 0}, {"ItemizedText", 0}, {
   "NumberedEquation", 0}},
 MenuSortingValue->300,
 MenuCommandKey->"3"],
Cell[33886, 1236, 117, 3, 70, 44, 0, "StyleData", "Subsubsection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[34040, 1244, 1161, 30, 56, 38, 0, "StyleData", "SubsubsectionOpener", \
"All",
 CounterIncrements->"Subsubsection",
 CounterAssignments->{{"Subsubsubsection", 0}, {"ItemizedText", 0}, {
   "NumberedEquation", 0}}],
Cell[35204, 1276, 123, 3, 70, 50, 0, "StyleData", "SubsubsectionOpener", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[35364, 1284, 1078, 29, 53, 35, 0, "StyleData", "Subsubsubsection", "All",
 CounterAssignments->{{"ItemizedText", 0}, {"NumberedEquation", 0}},
 MenuSortingValue->400,
 MenuCommandKey->"4"],
Cell[36445, 1315, 94, 2, 70, 47, 0, "StyleData", "Subsubsubsection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[36576, 1322, 1062, 28, 53, 41, 0, "StyleData", "SubsubsubsectionOpener", \
"All",
 CounterAssignments->{{"ItemizedText", 0}, {"NumberedEquation", 0}}],
Cell[37641, 1352, 100, 2, 70, 53, 0, "StyleData", "SubsubsubsectionOpener", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[37778, 1359, 1082, 29, 53, 38, 0, "StyleData", "Subsubsubsubsection", \
"All",
 CounterAssignments->{{"ItemizedText", 0}, {"NumberedEquation", 0}},
 MenuSortingValue->500,
 MenuCommandKey->"5"],
Cell[38863, 1390, 97, 2, 42, 50, 0, "StyleData", "Subsubsubsubsection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[38997, 1397, 1066, 28, 53, 44, 0, "StyleData", \
"SubsubsubsubsectionOpener", "All",
 CounterAssignments->{{"ItemizedText", 0}, {"NumberedEquation", 0}}],
Cell[40066, 1427, 103, 2, 70, 56, 0, "StyleData", \
"SubsubsubsubsectionOpener", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[40206, 1434, 423, 12, 81, 42, 0, "StyleData", "RelatedTutorialsSection", \
"All",
 StyleMenuListing->None],
Cell[40632, 1448, 270, 7, 76, 54, 0, "StyleData", "RelatedTutorialsSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[40939, 1460, 205, 7, 37, 35, 0, "StyleData", "RelatedTutorials", "All",
 StyleMenuListing->None],
Cell[41147, 1469, 166, 4, 70, 47, 0, "StyleData", "RelatedTutorials", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[41350, 1478, 423, 12, 81, 43, 0, "StyleData", \
"TutorialMoreAboutSection", "All",
 StyleMenuListing->None],
Cell[41776, 1492, 271, 7, 76, 55, 0, "StyleData", "TutorialMoreAboutSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[42084, 1504, 792, 23, 37, 36, 0, "StyleData", "TutorialMoreAbout", "All",
 StyleMenuListing->None],
Cell[42879, 1529, 167, 4, 70, 48, 0, "StyleData", "TutorialMoreAbout", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[43083, 1538, 429, 12, 81, 46, 0, "StyleData", \
"TutorialRelatedLinksSection", "All",
 StyleMenuListing->None],
Cell[43515, 1552, 274, 7, 76, 58, 0, "StyleData", \
"TutorialRelatedLinksSection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[43826, 1564, 820, 22, 37, 39, 0, "StyleData", "TutorialRelatedLinks", \
"All",
 StyleMenuListing->None],
Cell[44649, 1588, 170, 4, 70, 51, 0, "StyleData", "TutorialRelatedLinks", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[44856, 1597, 512, 14, 37, 31, 0, "StyleData", "1ColumnTable", "All",
 StyleMenuListing->None],
Cell[45371, 1613, 113, 3, 70, 43, 0, "StyleData", "1ColumnTable", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[45521, 1621, 481, 14, 37, 31, 0, "StyleData", "2ColumnTable", "All",
 StyleMenuListing->None],
Cell[46005, 1637, 113, 3, 70, 43, 0, "StyleData", "2ColumnTable", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[46155, 1645, 559, 16, 37, 31, 0, "StyleData", "3ColumnTable", "All",
 StyleMenuListing->None],
Cell[46717, 1663, 113, 3, 70, 43, 0, "StyleData", "3ColumnTable", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[46867, 1671, 740, 23, 37, 34, 0, "StyleData", "1ColumnTableMod", "All",
 StyleMenuListing->None],
Cell[47610, 1696, 497, 14, 70, 46, 0, "StyleData", "1ColumnTableMod", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[48144, 1715, 814, 25, 37, 34, 0, "StyleData", "2ColumnTableMod", "All",
 StyleMenuListing->None],
Cell[48961, 1742, 518, 15, 34, 46, 0, "StyleData", "2ColumnTableMod", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[49516, 1762, 836, 26, 37, 34, 0, "StyleData", "3ColumnTableMod", "All",
 StyleMenuListing->None],
Cell[50355, 1790, 535, 16, 34, 46, 0, "StyleData", "3ColumnTableMod", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[50927, 1811, 573, 16, 41, 32, 0, "StyleData", "InlineFormula", "All",
 StyleMenuListing->None],
Cell[51503, 1829, 76, 1, 40, 44, 0, "StyleData", "InlineFormula", "Printout"],
Cell[51582, 1832, 82, 1, 56, 43, 0, "StyleData", "InlineFormula", "Working"]
}, Closed]],
Cell[CellGroupData[{
Cell[51701, 1838, 297, 8, 37, 31, 0, "StyleData", "InlineOutput", "All",
 StyleMenuListing->None],
Cell[52001, 1848, 75, 1, 40, 43, 0, "StyleData", "InlineOutput", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[52113, 1854, 536, 16, 40, 29, 0, "StyleData", "InlineMath", "All",
 StyleMenuListing->None],
Cell[52652, 1872, 73, 1, 70, 41, 0, "StyleData", "InlineMath", "Printout"],
Cell[52728, 1875, 81, 1, 70, 40, 0, "StyleData", "InlineMath", "Working"]
}, Closed]],
Cell[CellGroupData[{
Cell[52846, 1881, 568, 16, 44, 30, 0, "StyleData", "DisplayMath", "All",
 MenuSortingValue->1000],
Cell[53417, 1899, 91, 2, 70, 42, 0, "StyleData", "DisplayMath", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[53545, 1906, 481, 14, 44, 35, 0, "StyleData", "NumberedEquation", "All",
 CounterIncrements->"NumberedEquation"],
Cell[54029, 1922, 96, 2, 70, 47, 0, "StyleData", "NumberedEquation", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[54162, 1929, 560, 17, 54, 30, 0, "StyleData", "MathCaption", "All",
 MenuSortingValue->700,
 MenuCommandKey->"7"],
Cell[54725, 1948, 136, 4, 70, 42, 0, "StyleData", "MathCaption", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[54898, 1957, 253, 8, 49, 33, 0, "StyleData", "ProgramCaption", "All",
 MenuSortingValue->800,
 MenuCommandKey->"8",
 StyleMenuListing->None],
Cell[55154, 1967, 91, 2, 70, 45, 0, "StyleData", "ProgramCaption", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[55282, 1974, 495, 16, 57, 26, 0, "StyleData", "Program", "All",
 CounterIncrements->"Code",
 MenuSortingValue->1100],
Cell[55780, 1992, 98, 2, 42, 38, 0, "StyleData", "Program", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[55915, 1999, 492, 16, 58, 23, 0, "StyleData", "Code", "All",
 CounterIncrements->"Code",
 MenuSortingValue->1200],
Cell[56410, 2017, 95, 2, 42, 35, 0, "StyleData", "Code", "Printout"],
Cell[56508, 2021, 135, 4, 43, 42, 0, "StyleData", "MathCaption", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[56680, 2030, 1008, 28, 38, 23, 0, "StyleData", "Text", "All",
 CounterIncrements->"Text",
 MenuSortingValue->600,
 MenuCommandKey->"6"],
Cell[57691, 2060, 125, 4, 38, 35, 0, "StyleData", "Text", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[57853, 2069, 974, 26, 38, 35, 0, "StyleData", "TutorialAbstract", "All",
 CounterIncrements->"Text"],
Cell[58830, 2097, 137, 4, 70, 47, 0, "StyleData", "TutorialAbstract", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[59004, 2106, 977, 25, 56, 36, 0, "StyleData", "DataSourceSection", "All"],
Cell[59984, 2133, 121, 3, 70, 48, 0, "StyleData", "DataSourceSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[60142, 2141, 922, 25, 38, 33, 0, "StyleData", "DataSourceText", "All",
 CounterIncrements->"Text",
 MenuSortingValue->2500],
Cell[61067, 2168, 135, 4, 70, 45, 0, "StyleData", "DataSourceText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[61239, 2177, 954, 26, 46, 36, 0, "StyleData", "DataSourceSummary", "All",
 CounterIncrements->"Text",
 MenuSortingValue->2500],
Cell[62196, 2205, 138, 4, 70, 48, 0, "StyleData", "DataSourceSummary", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[62371, 2214, 1044, 28, 51, 36, 0, "StyleData", "DataSourceContact", "All",
 CounterIncrements->"Text",
 MenuSortingValue->2500],
Cell[63418, 2244, 138, 4, 70, 48, 0, "StyleData", "DataSourceContact", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[63593, 2253, 846, 23, 38, 39, 0, "StyleData", "DataSourceDisclaimer", \
"All",
 MenuSortingValue->None],
Cell[64442, 2278, 141, 4, 70, 51, 0, "StyleData", "DataSourceDisclaimer", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[64620, 2287, 1061, 30, 58, 27, 0, "StyleData", "TextNote", "All",
 CounterIncrements->"Text"],
Cell[65684, 2319, 129, 4, 70, 39, 0, "StyleData", "TextNote", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[65850, 2328, 1068, 30, 58, 35, 0, "StyleData", "TextEmphasisNote", "All",
 CounterIncrements->"Text"],
Cell[66921, 2360, 137, 4, 70, 47, 0, "StyleData", "TextEmphasisNote", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[67095, 2369, 908, 25, 41, 31, 0, "StyleData", "IndentedText", "All"],
Cell[68006, 2396, 134, 4, 70, 43, 0, "StyleData", "IndentedText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[68177, 2405, 1070, 29, 41, 31, 0, "StyleData", "ItemizedText", "All",
 CounterIncrements->"ItemizedText"],
Cell[69250, 2436, 272, 8, 70, 43, 0, "StyleData", "ItemizedText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[69559, 2449, 916, 25, 39, 40, 0, "StyleData", "ItemizedTextParagraph", \
"All"],
Cell[70478, 2476, 143, 4, 70, 52, 0, "StyleData", "ItemizedTextParagraph", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[70658, 2485, 992, 27, 37, 31, 0, "StyleData", "BulletedText", "All",
 MenuSortingValue->900],
Cell[71653, 2514, 134, 4, 70, 43, 0, "StyleData", "BulletedText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[71824, 2523, 978, 27, 37, 24, 0, "StyleData", "Notes", "All"],
Cell[72805, 2552, 127, 4, 70, 36, 0, "StyleData", "Notes", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[72969, 2561, 332, 10, 39, 34, 0, "StyleData", "ItemizedPicture", "All",
 MenuSortingValue->1111],
Cell[73304, 2573, 108, 2, 70, 46, 0, "StyleData", "ItemizedPicture", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[73449, 2580, 242, 6, 40, 26, 0, "StyleData", "Picture", "All",
 MenuSortingValue->1110],
Cell[73694, 2588, 100, 2, 70, 38, 0, "StyleData", "Picture", "Printout"]
}, Closed]],
Cell[73809, 2593, 147, 5, 37, 29, 0, "StyleData", "Deemphasis", "All"],
Cell[CellGroupData[{
Cell[73981, 2602, 415, 12, 35, 30, 0, "StyleData", "ExampleLink", "All",
 StyleMenuListing->None],
Cell[74399, 2616, 211, 6, 70, 42, 0, "StyleData", "ExampleLink", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[74647, 2627, 380, 11, 38, 34, 0, "StyleData", "ExampleBacklink", "All",
 StyleMenuListing->None],
Cell[75030, 2640, 215, 6, 70, 46, 0, "StyleData", "ExampleBacklink", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[75282, 2651, 1020, 28, 42, 28, 0, "StyleData", "Reference", "All",
 CounterIncrements->"Reference"],
Cell[76305, 2681, 130, 4, 70, 40, 0, "StyleData", "Reference", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[76472, 2690, 200, 5, 54, 32, 0, "StyleData", "NotebookImage", "All"],
Cell[76675, 2697, 43, 0, 70, 43, 0, "StyleData", "NotebookImage", "Preview"],
Cell[76721, 2699, 145, 3, 70, 44, 0, "StyleData", "NotebookImage", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[76903, 2707, 68, 0, 28, "Subsection"],
Cell[CellGroupData[{
Cell[76996, 2711, 1097, 30, 70, 36, 0, "StyleData", "DefinitionBox1Col", \
"All"],
Cell[78096, 2743, 106, 2, 70, 56, 0, "StyleData", "DefinitionBox1Col", \
"InternalDocument"],
Cell[78205, 2747, 104, 2, 70, 54, 0, "StyleData", "DefinitionBox1Col", \
"ObsoleteObject"],
Cell[78312, 2751, 102, 2, 70, 52, 0, "StyleData", "DefinitionBox1Col", \
"FutureObject"],
Cell[78417, 2755, 105, 2, 70, 55, 0, "StyleData", "DefinitionBox1Col", \
"TemporaryObject"],
Cell[78525, 2759, 116, 2, 70, 66, 0, "StyleData", "DefinitionBox1Col", \
"AwaitingFutureDesignReview"],
Cell[78644, 2763, 103, 2, 70, 53, 0, "StyleData", "DefinitionBox1Col", \
"ExcisedObject"],
Cell[78750, 2767, 153, 4, 70, 48, 0, "StyleData", "DefinitionBox1Col", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[78940, 2776, 1178, 33, 70, 32, 0, "StyleData", "DefinitionBox", "All"],
Cell[80121, 2811, 102, 2, 70, 52, 0, "StyleData", "DefinitionBox", \
"InternalDocument"],
Cell[80226, 2815, 100, 2, 70, 50, 0, "StyleData", "DefinitionBox", \
"ObsoleteObject"],
Cell[80329, 2819, 98, 2, 70, 48, 0, "StyleData", "DefinitionBox", \
"FutureObject"],
Cell[80430, 2823, 101, 2, 70, 51, 0, "StyleData", "DefinitionBox", \
"TemporaryObject"],
Cell[80534, 2827, 112, 2, 70, 62, 0, "StyleData", "DefinitionBox", \
"AwaitingFutureDesignReview"],
Cell[80649, 2831, 99, 2, 70, 49, 0, "StyleData", "DefinitionBox", \
"ExcisedObject"],
Cell[80751, 2835, 149, 4, 70, 44, 0, "StyleData", "DefinitionBox", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[80937, 2844, 1203, 34, 70, 36, 0, "StyleData", "DefinitionBox3Col", \
"All"],
Cell[82143, 2880, 106, 2, 70, 56, 0, "StyleData", "DefinitionBox3Col", \
"InternalDocument"],
Cell[82252, 2884, 104, 2, 70, 54, 0, "StyleData", "DefinitionBox3Col", \
"ObsoleteObject"],
Cell[82359, 2888, 102, 2, 70, 52, 0, "StyleData", "DefinitionBox3Col", \
"FutureObject"],
Cell[82464, 2892, 105, 2, 70, 55, 0, "StyleData", "DefinitionBox3Col", \
"TemporaryObject"],
Cell[82572, 2896, 116, 2, 70, 66, 0, "StyleData", "DefinitionBox3Col", \
"AwaitingFutureDesignReview"],
Cell[82691, 2900, 103, 2, 70, 53, 0, "StyleData", "DefinitionBox3Col", \
"ExcisedObject"],
Cell[82797, 2904, 145, 4, 70, 48, 0, "StyleData", "DefinitionBox3Col", \
"Printout"]
}, Closed]],
Cell[82957, 2911, 107, 2, 70, 34, 0, "StyleData", "OverUnderScript", "All"],
Cell[CellGroupData[{
Cell[83089, 2917, 1224, 35, 70, 36, 0, "StyleData", "DefinitionBox4Col", \
"All"],
Cell[84316, 2954, 106, 2, 70, 56, 0, "StyleData", "DefinitionBox4Col", \
"InternalDocument"],
Cell[84425, 2958, 104, 2, 70, 54, 0, "StyleData", "DefinitionBox4Col", \
"ObsoleteObject"],
Cell[84532, 2962, 102, 2, 70, 52, 0, "StyleData", "DefinitionBox4Col", \
"FutureObject"],
Cell[84637, 2966, 105, 2, 70, 55, 0, "StyleData", "DefinitionBox4Col", \
"TemporaryObject"],
Cell[84745, 2970, 116, 2, 70, 66, 0, "StyleData", "DefinitionBox4Col", \
"AwaitingFutureDesignReview"],
Cell[84864, 2974, 103, 2, 70, 53, 0, "StyleData", "DefinitionBox4Col", \
"ExcisedObject"],
Cell[84970, 2978, 153, 4, 70, 48, 0, "StyleData", "DefinitionBox4Col", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[85160, 2987, 1264, 37, 70, 36, 0, "StyleData", "DefinitionBox6Col", \
"All"],
Cell[86427, 3026, 106, 2, 70, 56, 0, "StyleData", "DefinitionBox6Col", \
"InternalDocument"],
Cell[86536, 3030, 104, 2, 70, 54, 0, "StyleData", "DefinitionBox6Col", \
"ObsoleteObject"],
Cell[86643, 3034, 102, 2, 70, 52, 0, "StyleData", "DefinitionBox6Col", \
"FutureObject"],
Cell[86748, 3038, 105, 2, 70, 55, 0, "StyleData", "DefinitionBox6Col", \
"TemporaryObject"],
Cell[86856, 3042, 116, 2, 70, 66, 0, "StyleData", "DefinitionBox6Col", \
"AwaitingFutureDesignReview"],
Cell[86975, 3046, 103, 2, 70, 53, 0, "StyleData", "DefinitionBox6Col", \
"ExcisedObject"],
Cell[87081, 3050, 153, 4, 70, 48, 0, "StyleData", "DefinitionBox6Col", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[87271, 3059, 1269, 37, 70, 34, 0, "StyleData", "PrecedenceTable", "All"],
Cell[88543, 3098, 104, 2, 70, 54, 0, "StyleData", "PrecedenceTable", \
"InternalDocument"],
Cell[88650, 3102, 102, 2, 70, 52, 0, "StyleData", "PrecedenceTable", \
"ObsoleteObject"],
Cell[88755, 3106, 100, 2, 70, 50, 0, "StyleData", "PrecedenceTable", \
"FutureObject"],
Cell[88858, 3110, 103, 2, 70, 53, 0, "StyleData", "PrecedenceTable", \
"TemporaryObject"],
Cell[88964, 3114, 114, 2, 70, 64, 0, "StyleData", "PrecedenceTable", \
"AwaitingFutureDesignReview"],
Cell[89081, 3118, 101, 2, 70, 51, 0, "StyleData", "PrecedenceTable", \
"ExcisedObject"],
Cell[89185, 3122, 151, 4, 70, 46, 0, "StyleData", "PrecedenceTable", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[89373, 3131, 951, 25, 70, 28, 0, "StyleData", "DoubleBox", "All",
 StyleMenuListing->None],
Cell[90327, 3158, 98, 2, 70, 48, 0, "StyleData", "DoubleBox", \
"InternalDocument"],
Cell[90428, 3162, 96, 2, 70, 46, 0, "StyleData", "DoubleBox", \
"ObsoleteObject"],
Cell[90527, 3166, 94, 2, 70, 44, 0, "StyleData", "DoubleBox", "FutureObject"],
Cell[90624, 3170, 97, 2, 70, 47, 0, "StyleData", "DoubleBox", \
"TemporaryObject"],
Cell[90724, 3174, 108, 2, 70, 58, 0, "StyleData", "DoubleBox", \
"AwaitingFutureDesignReview"],
Cell[90835, 3178, 95, 2, 70, 45, 0, "StyleData", "DoubleBox", "ExcisedObject"],
Cell[90933, 3182, 145, 4, 70, 40, 0, "StyleData", "DoubleBox", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[91115, 3191, 908, 24, 70, 28, 0, "StyleData", "FramedBox", "All"],
Cell[92026, 3217, 98, 2, 70, 48, 0, "StyleData", "FramedBox", \
"InternalDocument"],
Cell[92127, 3221, 96, 2, 70, 46, 0, "StyleData", "FramedBox", \
"ObsoleteObject"],
Cell[92226, 3225, 94, 2, 70, 44, 0, "StyleData", "FramedBox", "FutureObject"],
Cell[92323, 3229, 97, 2, 70, 47, 0, "StyleData", "FramedBox", \
"TemporaryObject"],
Cell[92423, 3233, 108, 2, 70, 58, 0, "StyleData", "FramedBox", \
"AwaitingFutureDesignReview"],
Cell[92534, 3237, 95, 2, 70, 45, 0, "StyleData", "FramedBox", "ExcisedObject"],
Cell[92632, 3241, 145, 4, 70, 40, 0, "StyleData", "FramedBox", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[92814, 3250, 796, 20, 70, 28, 0, "StyleData", "TableText", "All",
 StyleMenuListing->None],
Cell[93613, 3272, 172, 4, 70, 40, 0, "StyleData", "TableText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[93822, 3281, 186, 7, 70, 30, 0, "StyleData", "TableHeader", "All",
 StyleMenuListing->None],
Cell[94011, 3290, 42, 0, 70, 42, 0, "StyleData", "TableHeader", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[94090, 3295, 191, 4, 70, 34, 0, "StyleData", "TableHeaderLine", "All"],
Cell[94284, 3301, 46, 0, 70, 46, 0, "StyleData", "TableHeaderLine", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[94367, 3306, 338, 11, 70, 26, 0, "StyleData", "Caption", "All",
 MenuSortingValue->600,
 MenuCommandKey->"6",
 StyleMenuListing->None],
Cell[94708, 3319, 84, 2, 70, 38, 0, "StyleData", "Caption", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[94829, 3326, 186, 6, 70, 31, 0, "StyleData", "SessionLabel", "All",
 StyleMenuListing->None],
Cell[95018, 3334, 62, 1, 70, 47, 0, "StyleData", "SessionLabel", \
"Presentation"],
Cell[95083, 3337, 91, 2, 70, 43, 0, "StyleData", "SessionLabel", "Printout"]
}, Closed]],
Cell[95189, 3342, 58, 3, 70, "Text"],
Cell[CellGroupData[{
Cell[95272, 3349, 163, 5, 70, 29, 0, "StyleData", "ProgramTop", "All",
 StyleMenuListing->None],
Cell[95438, 3356, 59, 1, 70, 45, 0, "StyleData", "ProgramTop", "Presentation"],
Cell[95500, 3359, 76, 1, 70, 41, 0, "StyleData", "ProgramTop", "Printout"]
}, Closed]],
Cell[95591, 3363, 91, 4, 70, "Text"],
Cell[CellGroupData[{
Cell[95707, 3371, 163, 5, 70, 32, 0, "StyleData", "ProgramBottom", "All",
 StyleMenuListing->None],
Cell[95873, 3378, 62, 1, 70, 48, 0, "StyleData", "ProgramBottom", \
"Presentation"],
Cell[95938, 3381, 79, 1, 70, 44, 0, "StyleData", "ProgramBottom", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[96066, 3388, 104, 1, 28, "Subsection"],
Cell[CellGroupData[{
Cell[96195, 3393, 502, 14, 70, 35, 0, "StyleData", "TOCDocumentTitle", "All",
 CounterAssignments->{{"TOCChapter", 0}, {"TOCSection", 0}, {
   "TOCSubsection", 0}, {"TOCSubsubsection", 0}}],
Cell[96700, 3409, 123, 3, 70, 47, 0, "StyleData", "TOCDocumentTitle", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[96860, 3417, 481, 13, 70, 26, 0, "StyleData", "TOCPart", "All",
 CounterIncrements->"TOCChapter",
 CounterAssignments->{{"TOCSection", 0}, {"TOCSubsection", 0}, {
   "TOCSubsubsection", 0}}],
Cell[97344, 3432, 87, 2, 70, 38, 0, "StyleData", "TOCPart", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[97468, 3439, 604, 17, 70, 29, 0, "StyleData", "TOCChapter", "All",
 CounterIncrements->"TOCChapter",
 CounterAssignments->{{"TOCSection", 0}, {"TOCSubsection", 0}, {
   "TOCSubsubsection", 0}}],
Cell[98075, 3458, 116, 3, 70, 41, 0, "StyleData", "TOCChapter", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[98228, 3466, 575, 16, 70, 29, 0, "StyleData", "TOCSection", "All",
 CounterIncrements->"TOCSection",
 CounterAssignments->{{"TOCSubsection", 0}, {"TOCSubsubsection", 0}, {
   "TOCSubsubsubsection", 0}, {"TOCSubsubsubsubsection", 0}}],
Cell[98806, 3484, 115, 3, 70, 41, 0, "StyleData", "TOCSection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[98958, 3492, 523, 14, 70, 32, 0, "StyleData", "TOCSubsection", "All",
 CounterIncrements->"TOCSsubsection",
 CounterAssignments->{{"TOCSubsection", 0}, {"TOCSubsubsection", 0}, {
   "TOCSubsubsubsection", 0}, {"TOCSubsubsubsubsection", 0}}],
Cell[99484, 3508, 117, 3, 70, 44, 0, "StyleData", "TOCSubsection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[99638, 3516, 481, 14, 70, 35, 0, "StyleData", "TOCSubsubsection", "All",
 CounterIncrements->"TOCSubsubsection",
 CounterAssignments->{{"TOCSubsubsubsection", 0}, {
   "TOCSubsubsubsubsection", 0}}],
Cell[100122, 3532, 120, 3, 70, 47, 0, "StyleData", "TOCSubsubsection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[100279, 3540, 455, 13, 70, 38, 0, "StyleData", "TOCSubsubsubsection", \
"All",
 CounterIncrements->"TOCSubsubsubsection",
 CounterAssignments->{{"TOCSubsubsubsubsection", 0}}],
Cell[100737, 3555, 125, 3, 70, 50, 0, "StyleData", "TOCSubsubsubsection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[100899, 3563, 409, 12, 70, 41, 0, "StyleData", "TOCSubsubsubsubsection", \
"All",
 CounterIncrements->"TOCSubsubsubsubsection"],
Cell[101311, 3577, 128, 3, 70, 53, 0, "StyleData", "TOCSubsubsubsubsection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[101476, 3585, 395, 11, 70, 44, 0, "StyleData", \
"TOCSubsubsubsubsubsection", "All",
 CounterIncrements->"TOCSubsubsubsubsubsection"],
Cell[101874, 3598, 131, 3, 70, 56, 0, "StyleData", \
"TOCSubsubsubsubsubsection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[102042, 3606, 269, 7, 70, 26, 0, "StyleData", "TOCLink", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[102314, 3615, 64, 1, 70, 38, 0, "StyleData", "TOCLink", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[102415, 3621, 247, 6, 70, 33, 0, "StyleData", "TOCPointerLink", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[102665, 3629, 71, 1, 70, 45, 0, "StyleData", "TOCPointerLink", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[102773, 3635, 710, 21, 70, 28, 0, "StyleData", "TOCOpener", "All",
 StyleMenuListing->None],
Cell[103486, 3658, 66, 1, 70, 40, 0, "StyleData", "TOCOpener", "Printout"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[103613, 3666, 36, 0, 41, "Section"],
Cell[103652, 3668, 121, 3, 70, "Text"],
Cell[CellGroupData[{
Cell[103798, 3675, 72, 2, 70, 32, 0, "StyleData", "KeyboardChars", "All",
 StyleMenuListing->None],
Cell[103873, 3679, 59, 1, 70, 44, 0, "StyleData", "KeyboardChars", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[103969, 3685, 256, 8, 70, 29, 0, "StyleData", "InlineCode", "All",
 StyleMenuListing->None],
Cell[104228, 3695, 41, 0, 70, 41, 0, "StyleData", "InlineCode", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[104306, 3700, 253, 7, 70, 38, 0, "StyleData", "InlineCharacterName", \
"All",
 StyleMenuListing->None],
Cell[104562, 3709, 50, 0, 70, 50, 0, "StyleData", "InlineCharacterName", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[104649, 3714, 220, 6, 70, 36, 0, "StyleData", "FilenameExtension", "All",
 StyleMenuListing->None],
Cell[104872, 3722, 48, 0, 70, 48, 0, "StyleData", "FilenameExtension", \
"Printout"]
}, Closed]],
Cell[104935, 3725, 133, 4, 70, 27, 0, "StyleData", "MenuName", "All"],
Cell[105071, 3731, 142, 4, 70, 36, 0, "StyleData", "MenuNameDelimiter", "All"],
Cell[105216, 3737, 172, 5, 70, 27, 0, "StyleData", "KeyEvent", "All"],
Cell[105391, 3744, 141, 4, 70, 36, 0, "StyleData", "KeyEventDelimiter", "All"],
Cell[105535, 3750, 137, 4, 70, 31, 0, "StyleData", "PointerEvent", "All"],
Cell[105675, 3756, 145, 4, 70, 40, 0, "StyleData", "PointerEventDelimiter", \
"All"],
Cell[105823, 3762, 142, 4, 70, 36, 0, "StyleData", "DialogElementName", "All"]
}, Closed]],
Cell[CellGroupData[{
Cell[106002, 3771, 29, 0, 41, "Section"],
Cell[CellGroupData[{
Cell[106056, 3775, 343, 9, 40, 23, 0, "StyleData", "Link", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[106402, 3786, 61, 1, 40, 35, 0, "StyleData", "Link", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[106500, 3792, 413, 10, 40, 32, 0, "StyleData", "MathWorldLink", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[106916, 3804, 112, 2, 40, 44, 0, "StyleData", "MathWorldLink", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[107065, 3811, 421, 10, 40, 36, 0, "StyleData", "FunctionsSiteLink", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[107489, 3823, 118, 2, 40, 48, 0, "StyleData", "FunctionsSiteLink", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[107644, 3830, 401, 10, 40, 26, 0, "StyleData", "NKSLink", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[108048, 3842, 106, 2, 40, 38, 0, "StyleData", "NKSLink", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[108191, 3849, 341, 8, 40, 29, 0, "StyleData", "NETDocLink", "All",
 StyleMenuListing->None,
 ButtonStyleMenuListing->Automatic],
Cell[108535, 3859, 109, 2, 70, 41, 0, "StyleData", "NETDocLink", "Printout"]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
