(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[      9999,        416]
NotebookOptionsPosition[      5805,        269]
NotebookOutlinePosition[      6423,        293]
CellTagsIndexPosition[      6345,        288]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 "New in: ",
 Cell["XX", "HistoryData",
  CellTags->"New"],
 " | Modified in: ",
 Cell[" ", "HistoryData",
  CellTags->"Modified"],
 " | Obsolete in: ",
 Cell[" ", "HistoryData",
  CellTags->"Obsolete"],
 " | Excised in: ",
 Cell[" ", "HistoryData",
  CellTags->"Excised"]
}], "History",
 CellID->1247902091],

Cell[CellGroupData[{

Cell["Categorization", "CategorizationSection",
 CellID->1122911449],

Cell["Symbol", "Categorization",
 CellLabel->"Entity Type",
 CellID->686433507],

Cell["Transmogrify Package", "Categorization",
 CellLabel->"Paclet Name",
 CellID->834096863],

Cell["Transmogrify`", "Categorization",
 CellLabel->"Context",
 CellID->41933338],

Cell["Transmogrify/ref/AtomsReturnSelf", "Categorization",
 CellLabel->"URI"]
}, Closed]],

Cell[CellGroupData[{

Cell["Synonyms", "SynonymsSection",
 CellID->1427418553],

Cell["XXXX", "Synonyms",
 CellID->1251652828]
}, Closed]],

Cell[CellGroupData[{

Cell["Keywords", "KeywordsSection",
 CellID->477174294],

Cell["XXXX", "Keywords",
 CellID->1164421360]
}, Closed]],

Cell[CellGroupData[{

Cell["Syntax Templates", "TemplatesSection",
 CellID->1872225408],

Cell[BoxData[""], "Template",
 CellLabel->"Additional Function Template",
 CellID->1562036412],

Cell[BoxData[""], "Template",
 CellLabel->"Arguments Pattern",
 CellID->158391909],

Cell[BoxData[""], "Template",
 CellLabel->"Local Variables",
 CellID->1360575930],

Cell[BoxData[""], "Template",
 CellLabel->"Color Equal Signs",
 CellID->793782254]
}, Closed]],

Cell[CellGroupData[{

Cell["Details", "DetailsSection"],

Cell["XXXX", "Details",
 CellLabel->"Developers"],

Cell["XXXX", "Details",
 CellLabel->"Comments"]
}, Closed]],

Cell[CellGroupData[{

Cell["AtomsReturnSelf", "ObjectName",
 CellID->1224892054],

Cell[TextData[{
 Cell["   ", "ModInfo"],
 "Option for Transmogrify which explains what to do when Transmogrify tries \
to recurse over an atomic expression.  If set to false, it will return Null, \
otherwise it will return the result of SelectSelf[] at that iteration."
}], "Usage"],

Cell["XXXX", "Notes",
 CellID->1067943069]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tutorials", "TutorialsSection",
 CellID->250839057],

Cell["XXXX", "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Demonstrations", "RelatedDemonstrationsSection",
 CellID->1268215905],

Cell["XXXX", "RelatedDemonstrations",
 CellID->1129518860]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Links", "RelatedLinksSection",
 CellID->1584193535],

Cell["XXXX", "RelatedLinks",
 CellID->1038487239]
}, Open  ]],

Cell[CellGroupData[{

Cell["See Also", "SeeAlsoSection",
 CellID->1255426704],

Cell["XXXX", "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell["More About", "MoreAboutSection",
 CellID->38303248],

Cell["XXXX", "MoreAbout",
 CellID->1665078683]
}, Open  ]],

Cell[CellGroupData[{

Cell["Extensions / Related Packages", "ExtensionsSection",
 CellID->1760991299],

Cell["XXXX", "Extensions",
 CellID->361139339]
}, Open  ]],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     StyleBox["Examples", "PrimaryExamplesSection"], 
     ButtonBox[
      RowBox[{
       RowBox[{"More", " ", "Examples"}], " ", "\[RightTriangle]"}],
      BaseStyle->"ExtendedExamplesLink",
      ButtonData:>"ExtendedExamples"]}
   }],
  $Line = 0; Null]], "PrimaryExamplesSection",
 CellID->880084151],

Cell[CellGroupData[{

Cell["More Examples", "ExtendedExamplesSection",
 CellTags->"ExtendedExamples",
 CellID->1854448968],

Cell[BoxData[
 InterpretationBox[Cell["Scope", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1293636265],

Cell[BoxData[
 InterpretationBox[Cell["Generalizations & Extensions", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1020263627],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["Options", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->2061341341],

Cell[BoxData[
 InterpretationBox[Cell["XXXX", "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 CellID->1757724783],

Cell[BoxData[
 InterpretationBox[Cell["XXXX", "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 CellID->1295379749]
}, Closed]],

Cell[BoxData[
 InterpretationBox[Cell["Applications", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->258228157],

Cell[BoxData[
 InterpretationBox[Cell["Properties & Relations", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->2123667759],

Cell[BoxData[
 InterpretationBox[Cell["Possible Issues", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1305812373],

Cell[BoxData[
 InterpretationBox[Cell["Interactive Examples", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1653164318],

Cell[BoxData[
 InterpretationBox[Cell["Neat Examples", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->589267740]
}, Open  ]],

Cell[CellGroupData[{

Cell["Design Discussion", "DesignDiscussionSection",
 CellID->1775809863],

Cell["XXXX", "DesignDiscussion",
 CellID->308641435]
}, Open  ]],

Cell[CellGroupData[{

Cell["Application Notes", "ApplicationNotesSection",
 CellID->1163590540],

Cell["XXXX", "ApplicationNotes",
 CellID->1480116198]
}, Open  ]]
},
WindowSize->{700, 770},
WindowMargins->{{4, Automatic}, {Automatic, 0}},
CellContext->"Global`",
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (July 8, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "FunctionPageStyles.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "ExtendedExamples"->{
  Cell[3954, 193, 100, 2, 53, "ExtendedExamplesSection",
   CellTags->"ExtendedExamples",
   CellID->1854448968]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"ExtendedExamples", 6207, 281}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 324, 14, 22, "History",
 CellID->1247902091],
Cell[CellGroupData[{
Cell[894, 38, 68, 1, 27, "CategorizationSection",
 CellID->1122911449],
Cell[965, 41, 79, 2, 31, "Categorization",
 CellID->686433507],
Cell[1047, 45, 93, 2, 31, "Categorization",
 CellID->834096863],
Cell[1143, 49, 81, 2, 31, "Categorization",
 CellID->41933338],
Cell[1227, 53, 77, 1, 31, "Categorization"]
}, Closed]],
Cell[CellGroupData[{
Cell[1341, 59, 56, 1, 17, "SynonymsSection",
 CellID->1427418553],
Cell[1400, 62, 45, 1, 70, "Synonyms",
 CellID->1251652828]
}, Closed]],
Cell[CellGroupData[{
Cell[1482, 68, 55, 1, 17, "KeywordsSection",
 CellID->477174294],
Cell[1540, 71, 45, 1, 70, "Keywords",
 CellID->1164421360]
}, Closed]],
Cell[CellGroupData[{
Cell[1622, 77, 65, 1, 17, "TemplatesSection",
 CellID->1872225408],
Cell[1690, 80, 94, 2, 70, "Template",
 CellID->1562036412],
Cell[1787, 84, 82, 2, 70, "Template",
 CellID->158391909],
Cell[1872, 88, 81, 2, 70, "Template",
 CellID->1360575930],
Cell[1956, 92, 82, 2, 70, "Template",
 CellID->793782254]
}, Closed]],
Cell[CellGroupData[{
Cell[2075, 99, 33, 0, 17, "DetailsSection"],
Cell[2111, 101, 49, 1, 70, "Details"],
Cell[2163, 104, 47, 1, 70, "Details"]
}, Closed]],
Cell[CellGroupData[{
Cell[2247, 110, 58, 1, 62, "ObjectName",
 CellID->1224892054],
Cell[2308, 113, 282, 5, 83, "Usage"],
Cell[2593, 120, 42, 1, 23, "Notes",
 CellID->1067943069]
}, Open  ]],
Cell[CellGroupData[{
Cell[2672, 126, 57, 1, 43, "TutorialsSection",
 CellID->250839057],
Cell[2732, 129, 45, 1, 16, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[2814, 135, 83, 1, 30, "RelatedDemonstrationsSection",
 CellID->1268215905],
Cell[2900, 138, 58, 1, 16, "RelatedDemonstrations",
 CellID->1129518860]
}, Open  ]],
Cell[CellGroupData[{
Cell[2995, 144, 65, 1, 30, "RelatedLinksSection",
 CellID->1584193535],
Cell[3063, 147, 49, 1, 16, "RelatedLinks",
 CellID->1038487239]
}, Open  ]],
Cell[CellGroupData[{
Cell[3149, 153, 55, 1, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[3207, 156, 43, 1, 16, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[3287, 162, 57, 1, 30, "MoreAboutSection",
 CellID->38303248],
Cell[3347, 165, 46, 1, 16, "MoreAbout",
 CellID->1665078683]
}, Open  ]],
Cell[CellGroupData[{
Cell[3430, 171, 79, 1, 30, "ExtensionsSection",
 CellID->1760991299],
Cell[3512, 174, 46, 1, 16, "Extensions",
 CellID->361139339]
}, Open  ]],
Cell[3573, 178, 356, 11, 68, "PrimaryExamplesSection",
 CellID->880084151],
Cell[CellGroupData[{
Cell[3954, 193, 100, 2, 53, "ExtendedExamplesSection",
 CellTags->"ExtendedExamples",
 CellID->1854448968],
Cell[4057, 197, 125, 3, 30, "ExampleSection",
 CellID->1293636265],
Cell[4185, 202, 148, 3, 18, "ExampleSection",
 CellID->1020263627],
Cell[CellGroupData[{
Cell[4358, 209, 127, 3, 18, "ExampleSection",
 CellID->2061341341],
Cell[4488, 214, 130, 3, 70, "ExampleSubsection",
 CellID->1757724783],
Cell[4621, 219, 130, 3, 70, "ExampleSubsection",
 CellID->1295379749]
}, Closed]],
Cell[4766, 225, 131, 3, 18, "ExampleSection",
 CellID->258228157],
Cell[4900, 230, 142, 3, 18, "ExampleSection",
 CellID->2123667759],
Cell[5045, 235, 135, 3, 70, "ExampleSection",
 CellID->1305812373],
Cell[5183, 240, 140, 3, 70, "ExampleSection",
 CellID->1653164318],
Cell[5326, 245, 132, 3, 70, "ExampleSection",
 CellID->589267740]
}, Open  ]],
Cell[CellGroupData[{
Cell[5495, 253, 73, 1, 70, "DesignDiscussionSection",
 CellID->1775809863],
Cell[5571, 256, 52, 1, 70, "DesignDiscussion",
 CellID->308641435]
}, Open  ]],
Cell[CellGroupData[{
Cell[5660, 262, 73, 1, 70, "ApplicationNotesSection",
 CellID->1163590540],
Cell[5736, 265, 53, 1, 70, "ApplicationNotes",
 CellID->1480116198]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

