(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     10113,        418]
NotebookOptionsPosition[      5920,        271]
NotebookOutlinePosition[      6538,        295]
CellTagsIndexPosition[      6460,        290]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 "New in: ",
 Cell["XX", "HistoryData",
  CellTags->"New"],
 " | Modified in: ",
 Cell[" ", "HistoryData",
  CellTags->"Modified"],
 " | Obsolete in: ",
 Cell[" ", "HistoryData",
  CellTags->"Obsolete"],
 " | Excised in: ",
 Cell[" ", "HistoryData",
  CellTags->"Excised"]
}], "History",
 CellID->1247902091],

Cell[CellGroupData[{

Cell["Categorization", "CategorizationSection",
 CellID->1122911449],

Cell["Symbol", "Categorization",
 CellLabel->"Entity Type",
 CellID->686433507],

Cell["Transmogrify Package", "Categorization",
 CellLabel->"Paclet Name",
 CellID->71839241],

Cell["Transmogrify`", "Categorization",
 CellLabel->"Context",
 CellID->50306526],

Cell["Transmogrify/ref/MaxExportErrors", "Categorization",
 CellLabel->"URI"]
}, Closed]],

Cell[CellGroupData[{

Cell["Synonyms", "SynonymsSection",
 CellID->1427418553],

Cell["XXXX", "Synonyms",
 CellID->1251652828]
}, Closed]],

Cell[CellGroupData[{

Cell["Keywords", "KeywordsSection",
 CellID->477174294],

Cell["XXXX", "Keywords",
 CellID->1164421360]
}, Closed]],

Cell[CellGroupData[{

Cell["Syntax Templates", "TemplatesSection",
 CellID->1872225408],

Cell[BoxData[""], "Template",
 CellLabel->"Additional Function Template",
 CellID->1562036412],

Cell[BoxData[""], "Template",
 CellLabel->"Arguments Pattern",
 CellID->158391909],

Cell[BoxData[""], "Template",
 CellLabel->"Local Variables",
 CellID->1360575930],

Cell[BoxData[""], "Template",
 CellLabel->"Color Equal Signs",
 CellID->793782254]
}, Closed]],

Cell[CellGroupData[{

Cell["Details", "DetailsSection"],

Cell["XXXX", "Details",
 CellLabel->"Developers"],

Cell["XXXX", "Details",
 CellLabel->"Comments"]
}, Closed]],

Cell[CellGroupData[{

Cell["MaxExportErrors", "ObjectName",
 CellID->1224892054],

Cell[TextData[{
 Cell["   ", "ModInfo"],
 "Option for Transmogrify to specify how many errors in generated SymbolicXML \
code are allowed before not attempting to Export the final result.  When \
Transmogrify fails to export, the problematic XMLOutput is saved in \
$XMLOutput, with errors in $XMLErrors.  This option obviously only has any \
effect if ExportFormat is set to \"XML\" "
}], "Usage"],

Cell["XXXX", "Notes",
 CellID->1067943069]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tutorials", "TutorialsSection",
 CellID->250839057],

Cell["XXXX", "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Demonstrations", "RelatedDemonstrationsSection",
 CellID->1268215905],

Cell["XXXX", "RelatedDemonstrations",
 CellID->1129518860]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Links", "RelatedLinksSection",
 CellID->1584193535],

Cell["XXXX", "RelatedLinks",
 CellID->1038487239]
}, Open  ]],

Cell[CellGroupData[{

Cell["See Also", "SeeAlsoSection",
 CellID->1255426704],

Cell["XXXX", "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell["More About", "MoreAboutSection",
 CellID->38303248],

Cell["XXXX", "MoreAbout",
 CellID->1665078683]
}, Open  ]],

Cell[CellGroupData[{

Cell["Extensions / Related Packages", "ExtensionsSection",
 CellID->1760991299],

Cell["XXXX", "Extensions",
 CellID->361139339]
}, Open  ]],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     StyleBox["Examples", "PrimaryExamplesSection"], 
     ButtonBox[
      RowBox[{
       RowBox[{"More", " ", "Examples"}], " ", "\[RightTriangle]"}],
      BaseStyle->"ExtendedExamplesLink",
      ButtonData:>"ExtendedExamples"]}
   }],
  $Line = 0; Null]], "PrimaryExamplesSection",
 CellID->880084151],

Cell[CellGroupData[{

Cell["More Examples", "ExtendedExamplesSection",
 CellTags->"ExtendedExamples",
 CellID->1854448968],

Cell[BoxData[
 InterpretationBox[Cell["Scope", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1293636265],

Cell[BoxData[
 InterpretationBox[Cell["Generalizations & Extensions", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1020263627],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["Options", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->2061341341],

Cell[BoxData[
 InterpretationBox[Cell["XXXX", "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 CellID->1757724783],

Cell[BoxData[
 InterpretationBox[Cell["XXXX", "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 CellID->1295379749]
}, Closed]],

Cell[BoxData[
 InterpretationBox[Cell["Applications", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->258228157],

Cell[BoxData[
 InterpretationBox[Cell["Properties & Relations", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->2123667759],

Cell[BoxData[
 InterpretationBox[Cell["Possible Issues", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1305812373],

Cell[BoxData[
 InterpretationBox[Cell["Interactive Examples", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1653164318],

Cell[BoxData[
 InterpretationBox[Cell["Neat Examples", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->589267740]
}, Open  ]],

Cell[CellGroupData[{

Cell["Design Discussion", "DesignDiscussionSection",
 CellID->1775809863],

Cell["XXXX", "DesignDiscussion",
 CellID->308641435]
}, Open  ]],

Cell[CellGroupData[{

Cell["Application Notes", "ApplicationNotesSection",
 CellID->1163590540],

Cell["XXXX", "ApplicationNotes",
 CellID->1480116198]
}, Open  ]]
},
WindowSize->{700, 770},
WindowMargins->{{4, Automatic}, {Automatic, 0}},
CellContext->"Global`",
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (July 8, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "FunctionPageStyles.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "ExtendedExamples"->{
  Cell[4069, 195, 100, 2, 53, "ExtendedExamplesSection",
   CellTags->"ExtendedExamples",
   CellID->1854448968]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"ExtendedExamples", 6322, 283}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 324, 14, 22, "History",
 CellID->1247902091],
Cell[CellGroupData[{
Cell[894, 38, 68, 1, 27, "CategorizationSection",
 CellID->1122911449],
Cell[965, 41, 79, 2, 31, "Categorization",
 CellID->686433507],
Cell[1047, 45, 92, 2, 31, "Categorization",
 CellID->71839241],
Cell[1142, 49, 81, 2, 31, "Categorization",
 CellID->50306526],
Cell[1226, 53, 77, 1, 31, "Categorization"]
}, Closed]],
Cell[CellGroupData[{
Cell[1340, 59, 56, 1, 17, "SynonymsSection",
 CellID->1427418553],
Cell[1399, 62, 45, 1, 70, "Synonyms",
 CellID->1251652828]
}, Closed]],
Cell[CellGroupData[{
Cell[1481, 68, 55, 1, 17, "KeywordsSection",
 CellID->477174294],
Cell[1539, 71, 45, 1, 70, "Keywords",
 CellID->1164421360]
}, Closed]],
Cell[CellGroupData[{
Cell[1621, 77, 65, 1, 17, "TemplatesSection",
 CellID->1872225408],
Cell[1689, 80, 94, 2, 70, "Template",
 CellID->1562036412],
Cell[1786, 84, 82, 2, 70, "Template",
 CellID->158391909],
Cell[1871, 88, 81, 2, 70, "Template",
 CellID->1360575930],
Cell[1955, 92, 82, 2, 70, "Template",
 CellID->793782254]
}, Closed]],
Cell[CellGroupData[{
Cell[2074, 99, 33, 0, 17, "DetailsSection"],
Cell[2110, 101, 49, 1, 70, "Details"],
Cell[2162, 104, 47, 1, 70, "Details"]
}, Closed]],
Cell[CellGroupData[{
Cell[2246, 110, 58, 1, 62, "ObjectName",
 CellID->1224892054],
Cell[2307, 113, 398, 7, 97, "Usage"],
Cell[2708, 122, 42, 1, 23, "Notes",
 CellID->1067943069]
}, Open  ]],
Cell[CellGroupData[{
Cell[2787, 128, 57, 1, 43, "TutorialsSection",
 CellID->250839057],
Cell[2847, 131, 45, 1, 16, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[2929, 137, 83, 1, 30, "RelatedDemonstrationsSection",
 CellID->1268215905],
Cell[3015, 140, 58, 1, 16, "RelatedDemonstrations",
 CellID->1129518860]
}, Open  ]],
Cell[CellGroupData[{
Cell[3110, 146, 65, 1, 30, "RelatedLinksSection",
 CellID->1584193535],
Cell[3178, 149, 49, 1, 16, "RelatedLinks",
 CellID->1038487239]
}, Open  ]],
Cell[CellGroupData[{
Cell[3264, 155, 55, 1, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[3322, 158, 43, 1, 16, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[3402, 164, 57, 1, 30, "MoreAboutSection",
 CellID->38303248],
Cell[3462, 167, 46, 1, 16, "MoreAbout",
 CellID->1665078683]
}, Open  ]],
Cell[CellGroupData[{
Cell[3545, 173, 79, 1, 30, "ExtensionsSection",
 CellID->1760991299],
Cell[3627, 176, 46, 1, 16, "Extensions",
 CellID->361139339]
}, Open  ]],
Cell[3688, 180, 356, 11, 68, "PrimaryExamplesSection",
 CellID->880084151],
Cell[CellGroupData[{
Cell[4069, 195, 100, 2, 53, "ExtendedExamplesSection",
 CellTags->"ExtendedExamples",
 CellID->1854448968],
Cell[4172, 199, 125, 3, 30, "ExampleSection",
 CellID->1293636265],
Cell[4300, 204, 148, 3, 18, "ExampleSection",
 CellID->1020263627],
Cell[CellGroupData[{
Cell[4473, 211, 127, 3, 18, "ExampleSection",
 CellID->2061341341],
Cell[4603, 216, 130, 3, 70, "ExampleSubsection",
 CellID->1757724783],
Cell[4736, 221, 130, 3, 70, "ExampleSubsection",
 CellID->1295379749]
}, Closed]],
Cell[4881, 227, 131, 3, 18, "ExampleSection",
 CellID->258228157],
Cell[5015, 232, 142, 3, 70, "ExampleSection",
 CellID->2123667759],
Cell[5160, 237, 135, 3, 70, "ExampleSection",
 CellID->1305812373],
Cell[5298, 242, 140, 3, 70, "ExampleSection",
 CellID->1653164318],
Cell[5441, 247, 132, 3, 70, "ExampleSection",
 CellID->589267740]
}, Open  ]],
Cell[CellGroupData[{
Cell[5610, 255, 73, 1, 70, "DesignDiscussionSection",
 CellID->1775809863],
Cell[5686, 258, 52, 1, 70, "DesignDiscussion",
 CellID->308641435]
}, Open  ]],
Cell[CellGroupData[{
Cell[5775, 264, 73, 1, 70, "ApplicationNotesSection",
 CellID->1163590540],
Cell[5851, 267, 53, 1, 70, "ApplicationNotes",
 CellID->1480116198]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

