(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     12818,        513]
NotebookOptionsPosition[      8188,        352]
NotebookOutlinePosition[      8784,        375]
CellTagsIndexPosition[      8706,        370]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 "New in: ",
 Cell["7", "HistoryData",
  CellTags->"New"],
 " | Modified in: ",
 Cell[" ", "HistoryData",
  CellTags->"Modified"],
 " | Obsolete in: ",
 Cell[" ", "HistoryData",
  CellTags->"Obsolete"],
 " | Excised in: ",
 Cell[" ", "HistoryData",
  CellTags->"Excised"]
}], "History",
 CellChangeTimes->{{3.425208738648438*^9, 3.425208738648438*^9}},
 CellID->341476719],

Cell[CellGroupData[{

Cell["Categorization", "CategorizationSection",
 CellID->1122911449],

Cell["Symbol", "Categorization",
 CellLabel->"Entity Type",
 CellID->686433507],

Cell["Transmogrify", "Categorization",
 CellLabel->"Paclet Name",
 CellID->1],

Cell["Transmogrify`", "Categorization",
 CellLabel->"Context",
 CellID->1245269497],

Cell["Transmogrify/ref/SelectChildren", "Categorization",
 CellLabel->"URI"]
}, Closed]],

Cell[CellGroupData[{

Cell["Synonyms", "SynonymsSection",
 CellID->1427418553],

Cell["XXXX", "Synonyms",
 CellID->1251652828]
}, Closed]],

Cell[CellGroupData[{

Cell["Keywords", "KeywordsSection",
 CellID->477174294],

Cell["XXXX", "Keywords",
 CellID->1164421360]
}, Closed]],

Cell[CellGroupData[{

Cell["Example Status", "ExampleStatusSection",
 CellContext->CellGroup,
 CellID->411322409],

Cell[TextData[{
 Cell[BoxData[
  TooltipBox[
   DynamicModuleBox[{$CellContext`exSum = False}, 
    TagBox[
     CheckboxBox[Dynamic[$CellContext`exSum = If[
         DocuTools`ExampleStatusSummary[
          EvaluationNotebook[]], True, False, $CellContext`exSum]], {False, 
      True, Blank[]}],
     EventHandlerTag[{
      "MouseDown" -> Null, PassEventsDown -> Automatic, PassEventsUp -> 
       True}]],
    DynamicModuleValues:>{}],
   "Automatic (non-interactive) summary of example status."]]],
 " Releasable"
}], "ExampleStatus",
 CellLabel->"Releasable",
 CellID->849528059],

Cell[TextData[{
 Cell[BoxData[
  DynamicModuleBox[{$CellContext`exStat = False}, 
   CheckboxBox[Dynamic[DocuTools`ExampleStatus[
       EvaluationNotebook[], 
       "DQA"] = $CellContext`exStat, ($CellContext`exStat = #; 
     DocuTools`ExampleStatusStamp[$CellContext`exStat])& ]],
   DynamicModuleValues:>{}]]],
 " ",
 "unsigned:undated"
}], "ExampleStatus",
 CellLabel->"DQA Completed",
 CellID->752182401],

Cell[TextData[{
 Cell[BoxData[
  DynamicModuleBox[{$CellContext`exStat = False}, 
   CheckboxBox[Dynamic[DocuTools`ExampleStatus[
       EvaluationNotebook[], 
       "Authoring"] = $CellContext`exStat, ($CellContext`exStat = #; 
     DocuTools`ExampleStatusStamp[$CellContext`exStat])& ]],
   DynamicModuleValues:>{}]]],
 " ",
 "unsigned:undated"
}], "ExampleStatus",
 CellLabel->"Authoring Completed",
 CellID->1133520534],

Cell["", "ExampleStatus",
 CellLabel->"Example Authors",
 CellID->812784410],

Cell["", "ExampleStatus",
 CellLabel->"Comments",
 CellID->2132773355]
}, Closed]],

Cell[CellGroupData[{

Cell["Syntax Templates", "TemplatesSection",
 CellID->1872225408],

Cell[BoxData[""], "Template",
 CellLabel->"Additional Function Template",
 CellID->1562036412],

Cell[BoxData[""], "Template",
 CellLabel->"Arguments Pattern",
 CellID->158391909],

Cell[BoxData[""], "Template",
 CellLabel->"Local Variables",
 CellID->1360575930],

Cell[BoxData[""], "Template",
 CellLabel->"Color Equal Signs",
 CellID->793782254]
}, Closed]],

Cell[CellGroupData[{

Cell["Details", "DetailsSection"],

Cell["XXXX", "Details",
 CellLabel->"Developers"],

Cell["XXXX", "Details",
 CellLabel->"Comments"]
}, Closed]],

Cell[CellGroupData[{

Cell["SelectChildren", "ObjectName",
 CellID->1224892054],

Cell[TextData[{
 Cell["   ", "ModInfo"],
 Cell[BoxData[
  RowBox[{"SelectChildren", "[", "]"}]], "InlineFormula"],
 " \[LineSeparator]selects all expressions one level deep inside of the \
expression currently in context\n",
 Cell["      ", "ModInfo"],
 Cell[BoxData[
  RowBox[{"SelectChildren", "[", 
   StyleBox["selector", "TI"], "]"}]], "InlineFormula"],
 "\[LineSeparator]only matches the expressions that will match ",
 Cell[BoxData[
  StyleBox["selector", "TI"]], "InlineFormula"],
 "\n",
 Cell["      ", "ModInfo"],
 Cell[BoxData[
  RowBox[{"SelectChildren", "[", 
   StyleBox["n", "TI"], "]"}]], "InlineFormula"],
 "\[LineSeparator]returns the ",
 Cell[BoxData[
  StyleBox["n", "TI"]], "InlineFormula"],
 "-th child, leaving all others unevaluated"
}], "Usage",
 CellChangeTimes->{{3.398394601982428*^9, 3.398394601986581*^9}, {
  3.4252086640055156`*^9, 3.425208732988459*^9}},
 CellID->982511436],

Cell["XXXX", "Notes",
 CellID->1067943069]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tutorials", "TutorialsSection",
 CellID->250839057],

Cell["XXXX", "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Demonstrations", "RelatedDemonstrationsSection",
 CellID->1268215905],

Cell["XXXX", "RelatedDemonstrations",
 CellID->1129518860]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Links", "RelatedLinksSection",
 CellID->1584193535],

Cell["XXXX", "RelatedLinks",
 CellID->1038487239]
}, Open  ]],

Cell[CellGroupData[{

Cell["See Also", "SeeAlsoSection",
 CellID->1255426704],

Cell["XXXX", "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell["More About", "MoreAboutSection",
 CellID->38303248],

Cell["XXXX", "MoreAbout",
 CellID->1665078683]
}, Open  ]],

Cell[CellGroupData[{

Cell["Extensions / Related Packages", "ExtensionsSection",
 CellID->1760991299],

Cell["XXXX", "Extensions",
 CellID->361139339]
}, Open  ]],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     StyleBox["Examples", "PrimaryExamplesSection"], 
     ButtonBox[
      RowBox[{
       RowBox[{"More", " ", "Examples"}], " ", "\[RightTriangle]"}],
      BaseStyle->"ExtendedExamplesLink",
      ButtonData:>"ExtendedExamples"]}
   }],
  $Line = 0; Null]], "PrimaryExamplesSection",
 CellID->880084151],

Cell[CellGroupData[{

Cell["More Examples", "ExtendedExamplesSection",
 CellTags->"ExtendedExamples",
 CellID->1854448968],

Cell[BoxData[
 InterpretationBox[Cell["Scope", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1293636265],

Cell[BoxData[
 InterpretationBox[Cell["Generalizations & Extensions", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1020263627],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["Options", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->2061341341],

Cell[BoxData[
 InterpretationBox[Cell["XXXX", "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 CellID->1757724783],

Cell[BoxData[
 InterpretationBox[Cell["XXXX", "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 CellID->1295379749]
}, Closed]],

Cell[BoxData[
 InterpretationBox[Cell["Applications", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->258228157],

Cell[BoxData[
 InterpretationBox[Cell["Properties & Relations", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->2123667759],

Cell[BoxData[
 InterpretationBox[Cell["Possible Issues", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1305812373],

Cell[BoxData[
 InterpretationBox[Cell["Interactive Examples", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1653164318],

Cell[BoxData[
 InterpretationBox[Cell["Neat Examples", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->589267740]
}, Open  ]],

Cell[CellGroupData[{

Cell["Design Discussion", "DesignDiscussionSection",
 CellID->1775809863],

Cell["XXXX", "DesignDiscussion",
 CellID->308641435]
}, Open  ]],

Cell[CellGroupData[{

Cell["Application Notes", "ApplicationNotesSection",
 CellID->1163590540],

Cell["XXXX", "ApplicationNotes",
 CellID->1480116198]
}, Open  ]]
},
WindowSize->{700, 770},
WindowMargins->{{Automatic, 180}, {Automatic, 5}},
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (July 8, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "FunctionPageStyles.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "ExtendedExamples"->{
  Cell[6337, 276, 100, 2, 53, "ExtendedExamplesSection",
   CellTags->"ExtendedExamples",
   CellID->1854448968]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"ExtendedExamples", 8568, 363}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 388, 15, 22, "History",
 CellID->341476719],
Cell[CellGroupData[{
Cell[958, 39, 68, 1, 27, "CategorizationSection",
 CellID->1122911449],
Cell[1029, 42, 79, 2, 70, "Categorization",
 CellID->686433507],
Cell[1111, 46, 77, 2, 70, "Categorization",
 CellID->1],
Cell[1191, 50, 83, 2, 70, "Categorization",
 CellID->1245269497],
Cell[1277, 54, 76, 1, 70, "Categorization"]
}, Closed]],
Cell[CellGroupData[{
Cell[1390, 60, 56, 1, 17, "SynonymsSection",
 CellID->1427418553],
Cell[1449, 63, 45, 1, 70, "Synonyms",
 CellID->1251652828]
}, Closed]],
Cell[CellGroupData[{
Cell[1531, 69, 55, 1, 17, "KeywordsSection",
 CellID->477174294],
Cell[1589, 72, 45, 1, 70, "Keywords",
 CellID->1164421360]
}, Closed]],
Cell[CellGroupData[{
Cell[1671, 78, 91, 2, 17, "ExampleStatusSection",
 CellID->411322409],
Cell[1765, 82, 586, 17, 70, "ExampleStatus",
 CellID->849528059],
Cell[2354, 101, 411, 12, 70, "ExampleStatus",
 CellID->752182401],
Cell[2768, 115, 424, 12, 70, "ExampleStatus",
 CellID->1133520534],
Cell[3195, 129, 76, 2, 70, "ExampleStatus",
 CellID->812784410],
Cell[3274, 133, 70, 2, 70, "ExampleStatus",
 CellID->2132773355]
}, Closed]],
Cell[CellGroupData[{
Cell[3381, 140, 65, 1, 17, "TemplatesSection",
 CellID->1872225408],
Cell[3449, 143, 94, 2, 70, "Template",
 CellID->1562036412],
Cell[3546, 147, 82, 2, 70, "Template",
 CellID->158391909],
Cell[3631, 151, 81, 2, 70, "Template",
 CellID->1360575930],
Cell[3715, 155, 82, 2, 70, "Template",
 CellID->793782254]
}, Closed]],
Cell[CellGroupData[{
Cell[3834, 162, 33, 0, 17, "DetailsSection"],
Cell[3870, 164, 49, 1, 70, "Details"],
Cell[3922, 167, 47, 1, 70, "Details"]
}, Closed]],
Cell[CellGroupData[{
Cell[4006, 173, 57, 1, 62, "ObjectName",
 CellID->1224892054],
Cell[4066, 176, 907, 25, 142, "Usage",
 CellID->982511436],
Cell[4976, 203, 42, 1, 23, "Notes",
 CellID->1067943069]
}, Open  ]],
Cell[CellGroupData[{
Cell[5055, 209, 57, 1, 43, "TutorialsSection",
 CellID->250839057],
Cell[5115, 212, 45, 1, 16, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[5197, 218, 83, 1, 30, "RelatedDemonstrationsSection",
 CellID->1268215905],
Cell[5283, 221, 58, 1, 16, "RelatedDemonstrations",
 CellID->1129518860]
}, Open  ]],
Cell[CellGroupData[{
Cell[5378, 227, 65, 1, 30, "RelatedLinksSection",
 CellID->1584193535],
Cell[5446, 230, 49, 1, 16, "RelatedLinks",
 CellID->1038487239]
}, Open  ]],
Cell[CellGroupData[{
Cell[5532, 236, 55, 1, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[5590, 239, 43, 1, 16, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[5670, 245, 57, 1, 30, "MoreAboutSection",
 CellID->38303248],
Cell[5730, 248, 46, 1, 16, "MoreAbout",
 CellID->1665078683]
}, Open  ]],
Cell[CellGroupData[{
Cell[5813, 254, 79, 1, 30, "ExtensionsSection",
 CellID->1760991299],
Cell[5895, 257, 46, 1, 16, "Extensions",
 CellID->361139339]
}, Open  ]],
Cell[5956, 261, 356, 11, 68, "PrimaryExamplesSection",
 CellID->880084151],
Cell[CellGroupData[{
Cell[6337, 276, 100, 2, 53, "ExtendedExamplesSection",
 CellTags->"ExtendedExamples",
 CellID->1854448968],
Cell[6440, 280, 125, 3, 30, "ExampleSection",
 CellID->1293636265],
Cell[6568, 285, 148, 3, 18, "ExampleSection",
 CellID->1020263627],
Cell[CellGroupData[{
Cell[6741, 292, 127, 3, 18, "ExampleSection",
 CellID->2061341341],
Cell[6871, 297, 130, 3, 70, "ExampleSubsection",
 CellID->1757724783],
Cell[7004, 302, 130, 3, 70, "ExampleSubsection",
 CellID->1295379749]
}, Closed]],
Cell[7149, 308, 131, 3, 18, "ExampleSection",
 CellID->258228157],
Cell[7283, 313, 142, 3, 18, "ExampleSection",
 CellID->2123667759],
Cell[7428, 318, 135, 3, 18, "ExampleSection",
 CellID->1305812373],
Cell[7566, 323, 140, 3, 18, "ExampleSection",
 CellID->1653164318],
Cell[7709, 328, 132, 3, 18, "ExampleSection",
 CellID->589267740]
}, Open  ]],
Cell[CellGroupData[{
Cell[7878, 336, 73, 1, 78, "DesignDiscussionSection",
 CellID->1775809863],
Cell[7954, 339, 52, 1, 16, "DesignDiscussion",
 CellID->308641435]
}, Open  ]],
Cell[CellGroupData[{
Cell[8043, 345, 73, 1, 30, "ApplicationNotesSection",
 CellID->1163590540],
Cell[8119, 348, 53, 1, 16, "ApplicationNotes",
 CellID->1480116198]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
