(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     13165,        528]
NotebookOptionsPosition[      8475,        365]
NotebookOutlinePosition[      9071,        388]
CellTagsIndexPosition[      8993,        383]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 "New in: ",
 Cell["7", "HistoryData",
  CellTags->"New"],
 " | Modified in: ",
 Cell[" ", "HistoryData",
  CellTags->"Modified"],
 " | Obsolete in: ",
 Cell[" ", "HistoryData",
  CellTags->"Obsolete"],
 " | Excised in: ",
 Cell[" ", "HistoryData",
  CellTags->"Excised"]
}], "History",
 CellChangeTimes->{{3.4252091511127625`*^9, 3.425209151128252*^9}},
 CellID->341476719],

Cell[CellGroupData[{

Cell["Categorization", "CategorizationSection",
 CellID->1122911449],

Cell["Symbol", "Categorization",
 CellLabel->"Entity Type",
 CellID->686433507],

Cell["Transmogrify", "Categorization",
 CellLabel->"Paclet Name",
 CellID->1],

Cell["Transmogrify`", "Categorization",
 CellLabel->"Context",
 CellID->1310106560],

Cell["Transmogrify/ref/SelectParent", "Categorization",
 CellLabel->"URI"]
}, Closed]],

Cell[CellGroupData[{

Cell["Synonyms", "SynonymsSection",
 CellID->1427418553],

Cell["XXXX", "Synonyms",
 CellID->1251652828]
}, Closed]],

Cell[CellGroupData[{

Cell["Keywords", "KeywordsSection",
 CellID->477174294],

Cell["XXXX", "Keywords",
 CellID->1164421360]
}, Closed]],

Cell[CellGroupData[{

Cell["Example Status", "ExampleStatusSection",
 CellContext->CellGroup,
 CellID->411322409],

Cell[TextData[{
 Cell[BoxData[
  TooltipBox[
   DynamicModuleBox[{$CellContext`exSum = False}, 
    TagBox[
     CheckboxBox[Dynamic[$CellContext`exSum = If[
         DocuTools`ExampleStatusSummary[
          EvaluationNotebook[]], True, False, $CellContext`exSum]], {False, 
      True, Blank[]}],
     EventHandlerTag[{
      "MouseDown" -> Null, PassEventsDown -> Automatic, PassEventsUp -> 
       True}]],
    DynamicModuleValues:>{}],
   "Automatic (non-interactive) summary of example status."]]],
 " Releasable"
}], "ExampleStatus",
 CellLabel->"Releasable",
 CellID->849528059],

Cell[TextData[{
 Cell[BoxData[
  DynamicModuleBox[{$CellContext`exStat = False}, 
   CheckboxBox[Dynamic[DocuTools`ExampleStatus[
       EvaluationNotebook[], 
       "DQA"] = $CellContext`exStat, ($CellContext`exStat = #; 
     DocuTools`ExampleStatusStamp[$CellContext`exStat])& ]],
   DynamicModuleValues:>{}]]],
 " ",
 "unsigned:undated"
}], "ExampleStatus",
 CellLabel->"DQA Completed",
 CellID->752182401],

Cell[TextData[{
 Cell[BoxData[
  DynamicModuleBox[{$CellContext`exStat = False}, 
   CheckboxBox[Dynamic[DocuTools`ExampleStatus[
       EvaluationNotebook[], 
       "Authoring"] = $CellContext`exStat, ($CellContext`exStat = #; 
     DocuTools`ExampleStatusStamp[$CellContext`exStat])& ]],
   DynamicModuleValues:>{}]]],
 " ",
 "unsigned:undated"
}], "ExampleStatus",
 CellLabel->"Authoring Completed",
 CellID->1133520534],

Cell["", "ExampleStatus",
 CellLabel->"Example Authors",
 CellID->812784410],

Cell["", "ExampleStatus",
 CellLabel->"Comments",
 CellID->2132773355]
}, Closed]],

Cell[CellGroupData[{

Cell["Syntax Templates", "TemplatesSection",
 CellID->1872225408],

Cell[BoxData[""], "Template",
 CellLabel->"Additional Function Template",
 CellID->1562036412],

Cell[BoxData[""], "Template",
 CellLabel->"Arguments Pattern",
 CellID->158391909],

Cell[BoxData[""], "Template",
 CellLabel->"Local Variables",
 CellID->1360575930],

Cell[BoxData[""], "Template",
 CellLabel->"Color Equal Signs",
 CellID->793782254]
}, Closed]],

Cell[CellGroupData[{

Cell["Details", "DetailsSection"],

Cell["XXXX", "Details",
 CellLabel->"Developers"],

Cell["XXXX", "Details",
 CellLabel->"Comments"]
}, Closed]],

Cell[CellGroupData[{

Cell["SelectParent", "ObjectName",
 CellID->1224892054],

Cell[TextData[{
 Cell["   ", "ModInfo"],
 Cell[BoxData[
  RowBox[{"SelectParent", "[", "]"}]], "InlineFormula"],
 " \[LineSeparator]selects the parent of the box structure currently in \
context\n",
 Cell["      ", "ModInfo"],
 Cell[BoxData[
  RowBox[{"SelectParent", "[", 
   StyleBox["int", "TI"], "]"}]], "InlineFormula"],
 "\[LineSeparator]selects the parent plus ",
 Cell[BoxData[
  StyleBox["int", "TI"]], "InlineFormula"],
 " ancestors"
}], "Usage",
 CellChangeTimes->{{3.3983950073038483`*^9, 3.398395007304295*^9}, {
  3.42520913501938*^9, 3.4252091579435444`*^9}, {3.425209200120908*^9, 
  3.425209204766712*^9}},
 CellID->982511436],

Cell[TextData[{
 Cell[BoxData[
  RowBox[{"SelectParent", "[", "0", "]"}]], "InlineFormula"],
 " is equivalent to ",
 Cell[BoxData[
  RowBox[{"SelectParent", "[", "]"}]], "InlineFormula"],
 "."
}], "Notes",
 CellChangeTimes->{
  3.425209170226559*^9, {3.4252092076272497`*^9, 3.4252092107054367`*^9}},
 CellID->1067943069],

Cell[TextData[{
 Cell[BoxData["SelectParent"], "InlineFormula"],
 " returns ",
 Cell[BoxData[
  ButtonBox["None",
   BaseStyle->"Link"]], "InlineFormula"],
 " on fail."
}], "Notes",
 CellChangeTimes->{{3.4252091866607065`*^9, 3.4252092130218506`*^9}},
 CellID->193906746]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tutorials", "TutorialsSection",
 CellID->250839057],

Cell["XXXX", "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Demonstrations", "RelatedDemonstrationsSection",
 CellID->1268215905],

Cell["XXXX", "RelatedDemonstrations",
 CellID->1129518860]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Links", "RelatedLinksSection",
 CellID->1584193535],

Cell["XXXX", "RelatedLinks",
 CellID->1038487239]
}, Open  ]],

Cell[CellGroupData[{

Cell["See Also", "SeeAlsoSection",
 CellID->1255426704],

Cell["XXXX", "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell["More About", "MoreAboutSection",
 CellID->38303248],

Cell["XXXX", "MoreAbout",
 CellID->1665078683]
}, Open  ]],

Cell[CellGroupData[{

Cell["Extensions / Related Packages", "ExtensionsSection",
 CellID->1760991299],

Cell["XXXX", "Extensions",
 CellID->361139339]
}, Open  ]],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     StyleBox["Examples", "PrimaryExamplesSection"], 
     ButtonBox[
      RowBox[{
       RowBox[{"More", " ", "Examples"}], " ", "\[RightTriangle]"}],
      BaseStyle->"ExtendedExamplesLink",
      ButtonData:>"ExtendedExamples"]}
   }],
  $Line = 0; Null]], "PrimaryExamplesSection",
 CellID->880084151],

Cell[CellGroupData[{

Cell["More Examples", "ExtendedExamplesSection",
 CellTags->"ExtendedExamples",
 CellID->1854448968],

Cell[BoxData[
 InterpretationBox[Cell["Scope", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1293636265],

Cell[BoxData[
 InterpretationBox[Cell["Generalizations & Extensions", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1020263627],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["Options", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->2061341341],

Cell[BoxData[
 InterpretationBox[Cell["XXXX", "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 CellID->1757724783],

Cell[BoxData[
 InterpretationBox[Cell["XXXX", "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 CellID->1295379749]
}, Closed]],

Cell[BoxData[
 InterpretationBox[Cell["Applications", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->258228157],

Cell[BoxData[
 InterpretationBox[Cell["Properties & Relations", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->2123667759],

Cell[BoxData[
 InterpretationBox[Cell["Possible Issues", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1305812373],

Cell[BoxData[
 InterpretationBox[Cell["Interactive Examples", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1653164318],

Cell[BoxData[
 InterpretationBox[Cell["Neat Examples", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->589267740]
}, Open  ]],

Cell[CellGroupData[{

Cell["Design Discussion", "DesignDiscussionSection",
 CellID->1775809863],

Cell["XXXX", "DesignDiscussion",
 CellID->308641435]
}, Open  ]],

Cell[CellGroupData[{

Cell["Application Notes", "ApplicationNotesSection",
 CellID->1163590540],

Cell["XXXX", "ApplicationNotes",
 CellID->1480116198]
}, Open  ]]
},
WindowSize->{700, 770},
WindowMargins->{{Automatic, 176}, {Automatic, 0}},
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (July 8, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "FunctionPageStyles.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "ExtendedExamples"->{
  Cell[6624, 289, 100, 2, 53, "ExtendedExamplesSection",
   CellTags->"ExtendedExamples",
   CellID->1854448968]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"ExtendedExamples", 8855, 376}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 390, 15, 22, "History",
 CellID->341476719],
Cell[CellGroupData[{
Cell[960, 39, 68, 1, 27, "CategorizationSection",
 CellID->1122911449],
Cell[1031, 42, 79, 2, 70, "Categorization",
 CellID->686433507],
Cell[1113, 46, 77, 2, 70, "Categorization",
 CellID->1],
Cell[1193, 50, 83, 2, 70, "Categorization",
 CellID->1310106560],
Cell[1279, 54, 74, 1, 70, "Categorization"]
}, Closed]],
Cell[CellGroupData[{
Cell[1390, 60, 56, 1, 17, "SynonymsSection",
 CellID->1427418553],
Cell[1449, 63, 45, 1, 70, "Synonyms",
 CellID->1251652828]
}, Closed]],
Cell[CellGroupData[{
Cell[1531, 69, 55, 1, 17, "KeywordsSection",
 CellID->477174294],
Cell[1589, 72, 45, 1, 70, "Keywords",
 CellID->1164421360]
}, Closed]],
Cell[CellGroupData[{
Cell[1671, 78, 91, 2, 17, "ExampleStatusSection",
 CellID->411322409],
Cell[1765, 82, 586, 17, 70, "ExampleStatus",
 CellID->849528059],
Cell[2354, 101, 411, 12, 70, "ExampleStatus",
 CellID->752182401],
Cell[2768, 115, 424, 12, 70, "ExampleStatus",
 CellID->1133520534],
Cell[3195, 129, 76, 2, 70, "ExampleStatus",
 CellID->812784410],
Cell[3274, 133, 70, 2, 70, "ExampleStatus",
 CellID->2132773355]
}, Closed]],
Cell[CellGroupData[{
Cell[3381, 140, 65, 1, 17, "TemplatesSection",
 CellID->1872225408],
Cell[3449, 143, 94, 2, 70, "Template",
 CellID->1562036412],
Cell[3546, 147, 82, 2, 70, "Template",
 CellID->158391909],
Cell[3631, 151, 81, 2, 70, "Template",
 CellID->1360575930],
Cell[3715, 155, 82, 2, 70, "Template",
 CellID->793782254]
}, Closed]],
Cell[CellGroupData[{
Cell[3834, 162, 33, 0, 17, "DetailsSection"],
Cell[3870, 164, 49, 1, 70, "Details"],
Cell[3922, 167, 47, 1, 70, "Details"]
}, Closed]],
Cell[CellGroupData[{
Cell[4006, 173, 55, 1, 62, "ObjectName",
 CellID->1224892054],
Cell[4064, 176, 643, 18, 107, "Usage",
 CellID->982511436],
Cell[4710, 196, 321, 10, 25, "Notes",
 CellID->1067943069],
Cell[5034, 208, 271, 9, 25, "Notes",
 CellID->193906746]
}, Open  ]],
Cell[CellGroupData[{
Cell[5342, 222, 57, 1, 43, "TutorialsSection",
 CellID->250839057],
Cell[5402, 225, 45, 1, 16, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[5484, 231, 83, 1, 30, "RelatedDemonstrationsSection",
 CellID->1268215905],
Cell[5570, 234, 58, 1, 16, "RelatedDemonstrations",
 CellID->1129518860]
}, Open  ]],
Cell[CellGroupData[{
Cell[5665, 240, 65, 1, 30, "RelatedLinksSection",
 CellID->1584193535],
Cell[5733, 243, 49, 1, 16, "RelatedLinks",
 CellID->1038487239]
}, Open  ]],
Cell[CellGroupData[{
Cell[5819, 249, 55, 1, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[5877, 252, 43, 1, 16, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[5957, 258, 57, 1, 30, "MoreAboutSection",
 CellID->38303248],
Cell[6017, 261, 46, 1, 16, "MoreAbout",
 CellID->1665078683]
}, Open  ]],
Cell[CellGroupData[{
Cell[6100, 267, 79, 1, 30, "ExtensionsSection",
 CellID->1760991299],
Cell[6182, 270, 46, 1, 16, "Extensions",
 CellID->361139339]
}, Open  ]],
Cell[6243, 274, 356, 11, 68, "PrimaryExamplesSection",
 CellID->880084151],
Cell[CellGroupData[{
Cell[6624, 289, 100, 2, 53, "ExtendedExamplesSection",
 CellTags->"ExtendedExamples",
 CellID->1854448968],
Cell[6727, 293, 125, 3, 30, "ExampleSection",
 CellID->1293636265],
Cell[6855, 298, 148, 3, 18, "ExampleSection",
 CellID->1020263627],
Cell[CellGroupData[{
Cell[7028, 305, 127, 3, 18, "ExampleSection",
 CellID->2061341341],
Cell[7158, 310, 130, 3, 70, "ExampleSubsection",
 CellID->1757724783],
Cell[7291, 315, 130, 3, 70, "ExampleSubsection",
 CellID->1295379749]
}, Closed]],
Cell[7436, 321, 131, 3, 18, "ExampleSection",
 CellID->258228157],
Cell[7570, 326, 142, 3, 18, "ExampleSection",
 CellID->2123667759],
Cell[7715, 331, 135, 3, 18, "ExampleSection",
 CellID->1305812373],
Cell[7853, 336, 140, 3, 18, "ExampleSection",
 CellID->1653164318],
Cell[7996, 341, 132, 3, 18, "ExampleSection",
 CellID->589267740]
}, Open  ]],
Cell[CellGroupData[{
Cell[8165, 349, 73, 1, 78, "DesignDiscussionSection",
 CellID->1775809863],
Cell[8241, 352, 52, 1, 16, "DesignDiscussion",
 CellID->308641435]
}, Open  ]],
Cell[CellGroupData[{
Cell[8330, 358, 73, 1, 30, "ApplicationNotesSection",
 CellID->1163590540],
Cell[8406, 361, 53, 1, 16, "ApplicationNotes",
 CellID->1480116198]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
