(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     21052,        756]
NotebookOptionsPosition[     16323,        593]
NotebookOutlinePosition[     16921,        616]
CellTagsIndexPosition[     16842,        611]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 "New in: ",
 Cell["7", "HistoryData",
  CellTags->"New"],
 " | Modified in: ",
 Cell[" ", "HistoryData",
  CellTags->"Modified"],
 " | Obsolete in: ",
 Cell[" ", "HistoryData",
  CellTags->"Obsolete"],
 " | Excised in: ",
 Cell[" ", "HistoryData",
  CellTags->"Excised"]
}], "History",
 CellChangeTimes->{{3.4252094564007425`*^9, 3.4252094564007425`*^9}},
 CellID->341476719],

Cell[CellGroupData[{

Cell["Categorization", "CategorizationSection",
 CellID->1122911449],

Cell["Symbol", "Categorization",
 CellLabel->"Entity Type",
 CellID->686433507],

Cell["Transmogrify", "Categorization",
 CellLabel->"Paclet Name",
 CellID->1],

Cell["Transmogrify`", "Categorization",
 CellLabel->"Context",
 CellID->677060020],

Cell["Transmogrify/ref/TransmogrifyString", "Categorization",
 CellLabel->"URI"]
}, Closed]],

Cell[CellGroupData[{

Cell["Synonyms", "SynonymsSection",
 CellID->1427418553],

Cell["XXXX", "Synonyms",
 CellID->1251652828]
}, Closed]],

Cell[CellGroupData[{

Cell["Keywords", "KeywordsSection",
 CellID->477174294],

Cell["XXXX", "Keywords",
 CellID->1164421360]
}, Closed]],

Cell[CellGroupData[{

Cell["Example Status", "ExampleStatusSection",
 CellContext->CellGroup,
 CellID->411322409],

Cell[TextData[{
 Cell[BoxData[
  TooltipBox[
   DynamicModuleBox[{$CellContext`exSum = False}, 
    TagBox[
     CheckboxBox[Dynamic[$CellContext`exSum = If[
         DocuTools`ExampleStatusSummary[
          EvaluationNotebook[]], True, False, $CellContext`exSum]], {False, 
      True, Blank[]}],
     EventHandlerTag[{
      "MouseDown" -> Null, PassEventsDown -> Automatic, PassEventsUp -> 
       True}]],
    DynamicModuleValues:>{}],
   "Automatic (non-interactive) summary of example status."]]],
 " Releasable"
}], "ExampleStatus",
 CellLabel->"Releasable",
 CellID->849528059],

Cell[TextData[{
 Cell[BoxData[
  DynamicModuleBox[{$CellContext`exStat = False}, 
   CheckboxBox[Dynamic[DocuTools`ExampleStatus[
       EvaluationNotebook[], 
       "DQA"] = $CellContext`exStat, ($CellContext`exStat = #; 
     DocuTools`ExampleStatusStamp[$CellContext`exStat])& ]],
   DynamicModuleValues:>{}]]],
 " ",
 "unsigned:undated"
}], "ExampleStatus",
 CellLabel->"DQA Completed",
 CellID->752182401],

Cell[TextData[{
 Cell[BoxData[
  DynamicModuleBox[{$CellContext`exStat = False}, 
   CheckboxBox[Dynamic[DocuTools`ExampleStatus[
       EvaluationNotebook[], 
       "Authoring"] = $CellContext`exStat, ($CellContext`exStat = #; 
     DocuTools`ExampleStatusStamp[$CellContext`exStat])& ]],
   DynamicModuleValues:>{}]]],
 " ",
 "unsigned:undated"
}], "ExampleStatus",
 CellLabel->"Authoring Completed",
 CellID->1133520534],

Cell["", "ExampleStatus",
 CellLabel->"Example Authors",
 CellID->812784410],

Cell["", "ExampleStatus",
 CellLabel->"Comments",
 CellID->2132773355]
}, Closed]],

Cell[CellGroupData[{

Cell["Syntax Templates", "TemplatesSection",
 CellID->1872225408],

Cell[BoxData[""], "Template",
 CellLabel->"Additional Function Template",
 CellID->1562036412],

Cell[BoxData[""], "Template",
 CellLabel->"Arguments Pattern",
 CellID->158391909],

Cell[BoxData[""], "Template",
 CellLabel->"Local Variables",
 CellID->1360575930],

Cell[BoxData[""], "Template",
 CellLabel->"Color Equal Signs",
 CellID->793782254]
}, Closed]],

Cell[CellGroupData[{

Cell["Details", "DetailsSection"],

Cell["XXXX", "Details",
 CellLabel->"Developers"],

Cell["XXXX", "Details",
 CellLabel->"Comments"]
}, Closed]],

Cell[CellGroupData[{

Cell["TransmogrifyString", "ObjectName",
 CellID->1224892054],

Cell[TextData[{
 Cell["   ", "ModInfo"],
 Cell[BoxData[
  RowBox[{"TransmogrifyString", "[", "]"}]], "InlineFormula"],
 " \[LineSeparator]",
 "converts Mathematica expressions into XML based on transmogrification rules \
specified in a ",
 Cell[BoxData[
  ButtonBox["XMLTransform",
   BaseStyle->"Link",
   ButtonData->"paclet:Transmogrify/ref/XMLTransform"]], "InlineFormula"]
}], "Usage",
 CellChangeTimes->{{3.3983944049696693`*^9, 3.3983944049701138`*^9}, 
   3.425209465647759*^9},
 CellID->982511436],

Cell["The following options can be given: ", "Notes",
 CellID->189702053],

Cell[BoxData[GridBox[{
   {Cell["   ", "ModInfo"], 
    ButtonBox["AbortOnError",
     BaseStyle->"Link",
     ButtonData->"paclet:Transmogrify/ref/AbortOnError"], 
    ButtonBox["True",
     BaseStyle->"Link"], Cell[TextData[{
     Cell[BoxData[
      ButtonBox["AbortOnError",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/AbortOnError"]], "InlineFormula"],
     
     " is an option to ",
     Cell[BoxData[
      ButtonBox["Transmogrify",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/Transmogrify"]], "InlineFormula"],
     
     " which forces ",
     Cell[BoxData[
      ButtonBox["Transmogrify",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/Transmogrify"]], "InlineFormula"],
     
     " to quit processing if it encounters a substantial error.  ",
     Cell[BoxData[
      ButtonBox["Setting",
       BaseStyle->"Link"]], "InlineFormula"],
     " this to ",
     Cell[BoxData[
      ButtonBox["False",
       BaseStyle->"Link"]], "InlineFormula"],
     " causes ",
     Cell[BoxData[
      ButtonBox["Transmogrify",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/Transmogrify"]], "InlineFormula"],
     
     " to attempt to continue using some built in guesses."
    }], "TableText"]},
   {Cell["   ", "ModInfo"], 
    ButtonBox["AtomsReturnSelf",
     BaseStyle->"Link",
     ButtonData->"paclet:Transmogrify/ref/AtomsReturnSelf"], 
    ButtonBox["True",
     BaseStyle->"Link"], Cell[TextData[{
     "Option",
     " for ",
     Cell[BoxData[
      ButtonBox["Transmogrify",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/Transmogrify"]], "InlineFormula"],
     
     " which explains what to do when ",
     Cell[BoxData[
      ButtonBox["Transmogrify",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/Transmogrify"]], "InlineFormula"],
     
     " tries to recurse over an atomic expression.  ",
     Cell[BoxData[
      ButtonBox["If",
       BaseStyle->"Link"]], "InlineFormula"],
     " set to false, it will return ",
     Cell[BoxData[
      ButtonBox["Null",
       BaseStyle->"Link"]], "InlineFormula"],
     ", otherwise it will return the result of SelectSelf[] at that \
iteration."
    }], "TableText"]},
   {Cell["   ", "ModInfo"], 
    ButtonBox["AutoRecurse",
     BaseStyle->"Link",
     ButtonData->"paclet:Transmogrify/ref/AutoRecurse"], 
    ButtonBox["True",
     BaseStyle->"Link"], Cell[TextData[{
     "Option",
     " for ",
     Cell[BoxData[
      ButtonBox["Transmogrify",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/Transmogrify"]], "InlineFormula"],
     
     " that forces automatic recursion to an expressions children if the \
expression did not change after rule application.\n Note that if returning \
SelectSelf[] can also cause this to recurse, which you may\n not want."
    }], "TableText"]},
   {Cell["   ", "ModInfo"], 
    ButtonBox["CreateImages",
     BaseStyle->"Link",
     ButtonData->"paclet:Transmogrify/ref/CreateImages"], 
    ButtonBox["True",
     BaseStyle->"Link"], Cell[TextData[{
     "Option",
     " for ",
     Cell[BoxData[
      ButtonBox["Transmogrify",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/Transmogrify"]], "InlineFormula"],
     
     " to effectively ignore ",
     Cell[BoxData[
      ButtonBox["BoxToImage",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/BoxToImage"]], "InlineFormula"],
     " calls when ",
     Cell[BoxData[
      ButtonBox["True",
       BaseStyle->"Link"]], "InlineFormula"],
     "."
    }], "TableText"]},
   {Cell["   ", "ModInfo"], 
    ButtonBox["ExportOptions",
     BaseStyle->"Link",
     ButtonData->"paclet:Transmogrify/ref/ExportOptions"], 
    RowBox[{"{", 
     RowBox[{"AttributeQuoting", " ", "->", " ", "\"\<}\>"}]}], Cell[
    TextData[{
     Cell[BoxData[
      ButtonBox["List",
       BaseStyle->"Link"]], "InlineFormula"],
     " of ",
     Cell[BoxData[
      ButtonBox["Options",
       BaseStyle->"Link"]], "InlineFormula"],
     " that will be passed to Export[] when ",
     Cell[BoxData[
      ButtonBox["Transmogrify",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/Transmogrify"]], "InlineFormula"],
     
     " exports the resulting transformed expression."
    }], "TableText"]},
   {Cell["   ", "ModInfo"], 
    ButtonBox["ExportFormat",
     BaseStyle->"Link",
     ButtonData->"paclet:Transmogrify/ref/ExportFormat"], "XML", Cell[
    TextData[{
     Cell[BoxData[
      ButtonBox["ExportFormat",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/ExportFormat"]], "InlineFormula"],
     
     " is an option for ",
     Cell[BoxData[
      ButtonBox["Transmogrify",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/Transmogrify"]], "InlineFormula"],
     
     " that tells it what file format to export the resulting transformed \
expression to."
    }], "TableText"]},
   {Cell["   ", "ModInfo"], 
    ButtonBox["InputDirDepth",
     BaseStyle->"Link",
     ButtonData->"paclet:Transmogrify/ref/InputDirDepth"], "1", Cell[
    TextData[{
     Cell[BoxData[
      ButtonBox["InputDirDepth",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/InputDirDepth"]], 
      "InlineFormula"],
     " is an option for ",
     Cell[BoxData[
      ButtonBox["Transmogrify",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/Transmogrify"]], "InlineFormula"],
     
     " that is only used when calling it on an input directory (batch mode).  \
",
     Cell[BoxData[
      ButtonBox["For",
       BaseStyle->"Link"]], "InlineFormula"],
     " example \n\nTransmogrify[\"outputdir\", \"inputdir\", \"transform\", \
InputDirDepth->Infinity]\n\nwill tell transmogrify to convert all notebooks \
in \"inputdir\" and its subdirectories.  See FileNames[]."
    }], "TableText"]},
   {Cell["   ", "ModInfo"], 
    ButtonBox["Literalize",
     BaseStyle->"Link",
     ButtonData->"paclet:Transmogrify/ref/Literalize"], 
    ButtonBox["True",
     BaseStyle->"Link"], Cell["\<\
Literalize[nb] converts all CounterBoxes in nb to corresponding literal \
values.\
\>", "TableText"]},
   {Cell["   ", "ModInfo"], 
    ButtonBox["MaxExportErrors",
     BaseStyle->"Link",
     ButtonData->"paclet:Transmogrify/ref/MaxExportErrors"], 
    ButtonBox["Infinity",
     BaseStyle->"Link"], Cell[TextData[{
     "Option",
     " for ",
     Cell[BoxData[
      ButtonBox["Transmogrify",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/Transmogrify"]], "InlineFormula"],
     
     " to specify how many errors in generated SymbolicXML code are allowed \
before not attempting to ",
     Cell[BoxData[
      ButtonBox["Export",
       BaseStyle->"Link"]], "InlineFormula"],
     " the final result.  When ",
     Cell[BoxData[
      ButtonBox["Transmogrify",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/Transmogrify"]], "InlineFormula"],
     
     " fails to export, the problematic XMLOutput is saved in ",
     Cell[BoxData[
      ButtonBox["$XMLOutput",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/$XMLOutput"]], "InlineFormula"],
     ", with errors in ",
     Cell[BoxData[
      ButtonBox["$XMLErrors",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/$XMLErrors"]], "InlineFormula"],
     ".  This option obviously only has any effect if ",
     Cell[BoxData[
      ButtonBox["ExportFormat",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/ExportFormat"]], "InlineFormula"],
     
     " is set to \"XML\" "
    }], "TableText"]},
   {Cell["   ", "ModInfo"], 
    ButtonBox["OutputExtension",
     BaseStyle->"Link",
     ButtonData->"paclet:Transmogrify/ref/OutputExtension"], "html", Cell[
    TextData[{
     "OuptutExtension",
     " is an option for ",
     Cell[BoxData[
      ButtonBox["Transmogrify",
       BaseStyle->"Link",
       ButtonData->"paclet:Transmogrify/ref/Transmogrify"]], "InlineFormula"],
     
     " that only has an effect when called in Batch mode.  ",
     Cell[BoxData[
      ButtonBox["For",
       BaseStyle->"Link"]], "InlineFormula"],
     " example, when called as\n\n\
Transmogrify[\"outputdir\",\"inputdir\",\"transformfile\", \
OutputExtension->\"html\"]\n\nAll .nb files in \"inputdir\" will be turned \
into filename.html"
    }], "TableText"]}
  }]], "3ColumnTableMod",
 CellID->226537136]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tutorials", "TutorialsSection",
 CellID->250839057],

Cell["XXXX", "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Demonstrations", "RelatedDemonstrationsSection",
 CellID->1268215905],

Cell["XXXX", "RelatedDemonstrations",
 CellID->1129518860]
}, Open  ]],

Cell[CellGroupData[{

Cell["Related Links", "RelatedLinksSection",
 CellID->1584193535],

Cell["XXXX", "RelatedLinks",
 CellID->1038487239]
}, Open  ]],

Cell[CellGroupData[{

Cell["See Also", "SeeAlsoSection",
 CellID->1255426704],

Cell["XXXX", "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell["More About", "MoreAboutSection",
 CellID->38303248],

Cell["XXXX", "MoreAbout",
 CellID->1665078683]
}, Open  ]],

Cell[CellGroupData[{

Cell["Extensions / Related Packages", "ExtensionsSection",
 CellID->1760991299],

Cell["XXXX", "Extensions",
 CellID->361139339]
}, Open  ]],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     StyleBox["Examples", "PrimaryExamplesSection"], 
     ButtonBox[
      RowBox[{
       RowBox[{"More", " ", "Examples"}], " ", "\[RightTriangle]"}],
      BaseStyle->"ExtendedExamplesLink",
      ButtonData:>"ExtendedExamples"]}
   }],
  $Line = 0; Null]], "PrimaryExamplesSection",
 CellID->880084151],

Cell[CellGroupData[{

Cell["More Examples", "ExtendedExamplesSection",
 CellTags->"ExtendedExamples",
 CellID->1854448968],

Cell[BoxData[
 InterpretationBox[Cell["Scope", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1293636265],

Cell[BoxData[
 InterpretationBox[Cell["Generalizations & Extensions", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1020263627],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["Options", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->2061341341],

Cell[BoxData[
 InterpretationBox[Cell["XXXX", "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 CellID->1757724783],

Cell[BoxData[
 InterpretationBox[Cell["XXXX", "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 CellID->1295379749]
}, Closed]],

Cell[BoxData[
 InterpretationBox[Cell["Applications", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->258228157],

Cell[BoxData[
 InterpretationBox[Cell["Properties & Relations", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->2123667759],

Cell[BoxData[
 InterpretationBox[Cell["Possible Issues", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1305812373],

Cell[BoxData[
 InterpretationBox[Cell["Interactive Examples", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->1653164318],

Cell[BoxData[
 InterpretationBox[Cell["Neat Examples", "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 CellID->589267740]
}, Open  ]],

Cell[CellGroupData[{

Cell["Design Discussion", "DesignDiscussionSection",
 CellID->1775809863],

Cell["XXXX", "DesignDiscussion",
 CellID->308641435]
}, Open  ]],

Cell[CellGroupData[{

Cell["Application Notes", "ApplicationNotesSection",
 CellID->1163590540],

Cell["XXXX", "ApplicationNotes",
 CellID->1480116198]
}, Open  ]]
},
WindowSize->{700, 770},
WindowMargins->{{Automatic, 175}, {Automatic, 1}},
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (July 8, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "FunctionPageStyles.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "ExtendedExamples"->{
  Cell[14472, 517, 100, 2, 53, "ExtendedExamplesSection",
   CellTags->"ExtendedExamples",
   CellID->1854448968]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"ExtendedExamples", 16703, 604}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 392, 15, 22, "History",
 CellID->341476719],
Cell[CellGroupData[{
Cell[962, 39, 68, 1, 27, "CategorizationSection",
 CellID->1122911449],
Cell[1033, 42, 79, 2, 70, "Categorization",
 CellID->686433507],
Cell[1115, 46, 77, 2, 70, "Categorization",
 CellID->1],
Cell[1195, 50, 82, 2, 70, "Categorization",
 CellID->677060020],
Cell[1280, 54, 80, 1, 70, "Categorization"]
}, Closed]],
Cell[CellGroupData[{
Cell[1397, 60, 56, 1, 17, "SynonymsSection",
 CellID->1427418553],
Cell[1456, 63, 45, 1, 70, "Synonyms",
 CellID->1251652828]
}, Closed]],
Cell[CellGroupData[{
Cell[1538, 69, 55, 1, 17, "KeywordsSection",
 CellID->477174294],
Cell[1596, 72, 45, 1, 70, "Keywords",
 CellID->1164421360]
}, Closed]],
Cell[CellGroupData[{
Cell[1678, 78, 91, 2, 17, "ExampleStatusSection",
 CellID->411322409],
Cell[1772, 82, 586, 17, 70, "ExampleStatus",
 CellID->849528059],
Cell[2361, 101, 411, 12, 70, "ExampleStatus",
 CellID->752182401],
Cell[2775, 115, 424, 12, 70, "ExampleStatus",
 CellID->1133520534],
Cell[3202, 129, 76, 2, 70, "ExampleStatus",
 CellID->812784410],
Cell[3281, 133, 70, 2, 70, "ExampleStatus",
 CellID->2132773355]
}, Closed]],
Cell[CellGroupData[{
Cell[3388, 140, 65, 1, 17, "TemplatesSection",
 CellID->1872225408],
Cell[3456, 143, 94, 2, 70, "Template",
 CellID->1562036412],
Cell[3553, 147, 82, 2, 70, "Template",
 CellID->158391909],
Cell[3638, 151, 81, 2, 70, "Template",
 CellID->1360575930],
Cell[3722, 155, 82, 2, 70, "Template",
 CellID->793782254]
}, Closed]],
Cell[CellGroupData[{
Cell[3841, 162, 33, 0, 17, "DetailsSection"],
Cell[3877, 164, 49, 1, 70, "Details"],
Cell[3929, 167, 47, 1, 70, "Details"]
}, Closed]],
Cell[CellGroupData[{
Cell[4013, 173, 61, 1, 62, "ObjectName",
 CellID->1224892054],
Cell[4077, 176, 506, 14, 86, "Usage",
 CellID->982511436],
Cell[4586, 192, 73, 1, 23, "Notes",
 CellID->189702053],
Cell[4662, 195, 8491, 250, 977, "3ColumnTableMod",
 CellID->226537136]
}, Open  ]],
Cell[CellGroupData[{
Cell[13190, 450, 57, 1, 43, "TutorialsSection",
 CellID->250839057],
Cell[13250, 453, 45, 1, 16, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[13332, 459, 83, 1, 30, "RelatedDemonstrationsSection",
 CellID->1268215905],
Cell[13418, 462, 58, 1, 16, "RelatedDemonstrations",
 CellID->1129518860]
}, Open  ]],
Cell[CellGroupData[{
Cell[13513, 468, 65, 1, 30, "RelatedLinksSection",
 CellID->1584193535],
Cell[13581, 471, 49, 1, 16, "RelatedLinks",
 CellID->1038487239]
}, Open  ]],
Cell[CellGroupData[{
Cell[13667, 477, 55, 1, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[13725, 480, 43, 1, 16, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[13805, 486, 57, 1, 30, "MoreAboutSection",
 CellID->38303248],
Cell[13865, 489, 46, 1, 16, "MoreAbout",
 CellID->1665078683]
}, Open  ]],
Cell[CellGroupData[{
Cell[13948, 495, 79, 1, 30, "ExtensionsSection",
 CellID->1760991299],
Cell[14030, 498, 46, 1, 16, "Extensions",
 CellID->361139339]
}, Open  ]],
Cell[14091, 502, 356, 11, 68, "PrimaryExamplesSection",
 CellID->880084151],
Cell[CellGroupData[{
Cell[14472, 517, 100, 2, 53, "ExtendedExamplesSection",
 CellTags->"ExtendedExamples",
 CellID->1854448968],
Cell[14575, 521, 125, 3, 30, "ExampleSection",
 CellID->1293636265],
Cell[14703, 526, 148, 3, 18, "ExampleSection",
 CellID->1020263627],
Cell[CellGroupData[{
Cell[14876, 533, 127, 3, 18, "ExampleSection",
 CellID->2061341341],
Cell[15006, 538, 130, 3, 70, "ExampleSubsection",
 CellID->1757724783],
Cell[15139, 543, 130, 3, 70, "ExampleSubsection",
 CellID->1295379749]
}, Closed]],
Cell[15284, 549, 131, 3, 18, "ExampleSection",
 CellID->258228157],
Cell[15418, 554, 142, 3, 18, "ExampleSection",
 CellID->2123667759],
Cell[15563, 559, 135, 3, 18, "ExampleSection",
 CellID->1305812373],
Cell[15701, 564, 140, 3, 18, "ExampleSection",
 CellID->1653164318],
Cell[15844, 569, 132, 3, 18, "ExampleSection",
 CellID->589267740]
}, Open  ]],
Cell[CellGroupData[{
Cell[16013, 577, 73, 1, 78, "DesignDiscussionSection",
 CellID->1775809863],
Cell[16089, 580, 52, 1, 16, "DesignDiscussion",
 CellID->308641435]
}, Open  ]],
Cell[CellGroupData[{
Cell[16178, 586, 73, 1, 30, "ApplicationNotesSection",
 CellID->1163590540],
Cell[16254, 589, 53, 1, 16, "ApplicationNotes",
 CellID->1480116198]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
