
(*
CreatePalette[
 DocumentNotebook[
  Panel[Column[{
    
    Tooltip[Button["New Test Notebook",
		Needs["MUnit`"];MUnit`PaletteNewTestNotebook[]],
		"Create a new MUnit test notebook", TooltipDelay -> 0.5]
	,
	Spacer[20]
	,
	Tooltip[Button["Convert Notebook",
		Needs["MUnit`"];MUnit`PaletteConvertNotebook[InputNotebook[]]],
		"Convert selected regular notebook to test notebook \nby applying the MUnit stylesheet", TooltipDelay -> 0.5]
	,
	Tooltip[Button["Convert CellGroup(s)",
		Needs["MUnit`"];MUnit`PaletteConvertCellGroup[InputNotebook[]]],
		"Convert selected regular Input/Output cell group(s) to Test cell group(s)", TooltipDelay -> 0.5]
	,
	Spacer[20]
	,
	Tooltip[Button["Run",
		Needs["MUnit`"];MUnit`PaletteRun[InputNotebook[]], Method -> "Queued"],
		"Run selected test notebook", TooltipDelay -> 0.5]
	,
	Tooltip[Button["Abort",
		Needs["MUnit`"];MUnit`PaletteAbort[InputNotebook[]]],
		"Abort currently running test run", TooltipDelay -> 0.5]
	,
	Spacer[20]
	,
	DynamicModule[{include = True},
		Row[{Tooltip[Button["Quit Kernels",
			Needs["MUnit`"];MUnit`PaletteQuitKernels[include]],
			"Quit Kernels", TooltipDelay -> 0.5]
			,
			Column[{
				Tooltip[Checkbox[Dynamic[include]], "Include Local Kernel", TooltipDelay -> 0.5],
				Text["Include Local Kernel"]}, Center]
		}]
	]
	,
	Spacer[20]
	,
	Tooltip[Button["Clear",
		Needs["MUnit`"];MUnit`PaletteClear[InputNotebook[]]],
		"Clear output from selected test notebook", TooltipDelay -> 0.5]
	,
	Tooltip[Button["Save As .mt file...", Needs["MUnit`"];
       MUnit`PaletteSaveAs[InputNotebook[]]], 
      "Save selected test notebook as .mt file", 
      TooltipDelay -> 0.5]}]]
  ,
  WindowTitle -> "MUnit Workflow"
  ]
,
NotebookAutoSave->True
]
*)

Notebook[{Cell[
   BoxData[PanelBox[
     TagBox[GridBox[{{TagBox[
          TooltipBox[
           ButtonBox["\"New Test Notebook\"", Appearance -> Automatic,
             ButtonFunction :> (Needs["MUnit`"]; 
              MUnit`PaletteNewTestNotebook[]), Evaluator -> Automatic, 
            Method -> "Preemptive"], 
           "\"Create a new MUnit test notebook\"", 
           LabelStyle -> "TextStyling", TooltipDelay -> 0.5], \!\(\*
TagBox["#1",
Annotation[#, "Create a new MUnit test notebook", 
               "Tooltip"]& ]\) &]},
               {InterpretationBox[
          
          StyleBox[
           GraphicsBox[{}, BaselinePosition -> Baseline, 
            ImageSize -> {20, 0}], CacheGraphics -> False], Spacer[
          20]]},
          {TagBox[
          TooltipBox[
           ButtonBox["\"Convert Notebook\"", Appearance -> Automatic, 
            ButtonFunction :> (Needs["MUnit`"]; 
              MUnit`PaletteConvertNotebook[InputNotebook[]]), 
            Evaluator -> Automatic, Method -> "Preemptive"], 
           "\"Convert selected regular notebook to test notebook \
\\nby applying the MUnit stylesheet\"", LabelStyle -> "TextStyling", 
           TooltipDelay -> 0.5], \!\(\*
TagBox["#1",
Annotation[#, 
               "Convert selected regular notebook to test notebook \n\
by applying the MUnit stylesheet", 
               "Tooltip"]& ]\) &]}, {TagBox[
          TooltipBox[
           ButtonBox["\"Convert CellGroup(s)\"", 
            Appearance -> Automatic, 
            ButtonFunction :> (Needs["MUnit`"]; 
              MUnit`PaletteConvertCellGroup[InputNotebook[]]), 
            Evaluator -> Automatic, Method -> "Preemptive"], 
           "\"Convert selected regular Input/Output cell group(s) to \
Test cell group(s)\"", LabelStyle -> "TextStyling", 
           TooltipDelay -> 0.5], \!\(\*
TagBox["#1",
Annotation[#, 
               "Convert selected regular Input/Output cell group(s) \
to Test cell group(s)", "Tooltip"]& ]\) &]}, {InterpretationBox[
          StyleBox[
           GraphicsBox[{}, BaselinePosition -> Baseline, 
            ImageSize -> {20, 0}], CacheGraphics -> False], Spacer[
          20]]}, {TagBox[
          TooltipBox[
           ButtonBox["\"Run\"", Appearance -> Automatic, 
            ButtonFunction :> (Needs["MUnit`"]; 
              MUnit`PaletteRun[InputNotebook[]]), Evaluator -> Automatic, 
            Method -> "Queued"], "\"Run selected test notebook\"", 
           LabelStyle -> "TextStyling", TooltipDelay -> 0.5], \!\(\*
TagBox["#1",
Annotation[#, "Run selected test notebook", 
               "Tooltip"]& ]\) &]}, {TagBox[
          TooltipBox[
           ButtonBox["\"Abort\"", Appearance -> Automatic, 
            ButtonFunction :> (Needs["MUnit`"]; 
              PaletteAbort[InputNotebook[]]), Evaluator -> Automatic, 
            Method -> "Preemptive"], 
           "\"Abort currently running test run\"", 
           LabelStyle -> "TextStyling", TooltipDelay -> 0.5], \!\(\*
TagBox["#1",
Annotation[#, "Abort currently running test run", 
               "Tooltip"]& ]\) &]}, {InterpretationBox[
          StyleBox[
           GraphicsBox[{}, BaselinePosition -> Baseline, 
            ImageSize -> {20, 0}], CacheGraphics -> False], Spacer[
          20]]}, {DynamicModuleBox[{$CellContext`include$$ = True}, 
          TemplateBox[{TagBox[
             TooltipBox[
              ButtonBox["\"Quit Kernels\"", Appearance -> Automatic, 
               ButtonFunction :> (Needs["MUnit`"]; 
                 MUnit`PaletteQuitKernels[$CellContext`include$$]), 
               Evaluator -> Automatic, Method -> "Preemptive"], 
              "\"Quit Kernels\"", LabelStyle -> "TextStyling", 
              TooltipDelay -> 0.5], 
             Annotation[#1, "Quit Kernels", "Tooltip"] &], 
            TagBox[GridBox[{{TagBox[
                 TooltipBox[
                  CheckboxBox[Dynamic[$CellContext`include$$]], 
                  "\"Include Local Kernel\"", 
                  LabelStyle -> "TextStyling", TooltipDelay -> 0.5], 
                 Annotation[#1, "Include Local Kernel", 
                   "Tooltip"] &]}, {InterpretationBox[
                 Cell[BoxData["\"Include Local Kernel\""], "Text", 
                  "TR"], Text["Include Local Kernel"]]}}, 
              GridBoxAlignment -> {"Columns" -> {{Center}}}, 
              GridBoxItemSize -> {"Columns" -> {{Automatic}}, 
                "Rows" -> {{Automatic}}}], "Column"]}, "Row", 
           DisplayFunction -> (RowBox[{#1, 
                "\[InvisibleSpace]", #2}] &), 
           InterpretationFunction -> (RowBox[{"Row", "[", 
                RowBox[{"{", RowBox[{#1, ",", #2}], "}"}], "]"}] &)], 
          DynamicModuleValues :> {}]}, {InterpretationBox[
          StyleBox[
           GraphicsBox[{}, BaselinePosition -> Baseline, 
            ImageSize -> {20, 0}], CacheGraphics -> False], Spacer[
          20]]}, {TagBox[
          TooltipBox[
           ButtonBox["\"Clear\"", Appearance -> Automatic, 
            ButtonFunction :> (Needs["MUnit`"]; 
              MUnit`PaletteClear[InputNotebook[]]), Evaluator -> Automatic, 
            Method -> "Preemptive"], 
           "\"Clear output from selected test notebook\"", 
           LabelStyle -> "TextStyling", TooltipDelay -> 0.5], \!\(\*
TagBox["#1",
Annotation[#, "Clear output from selected test notebook", 
               "Tooltip"]& ]\) &]}, {TagBox[
          TooltipBox[
           ButtonBox["\"Save As .mt file...\"", 
            Appearance -> Automatic, 
            ButtonFunction :> (Needs["MUnit`"]; 
              MUnit`PaletteSaveAs[InputNotebook[]]), Evaluator -> Automatic,
             Method -> "Preemptive"], 
           "\"Save selected test notebook as .mt file\"", 
           LabelStyle -> "TextStyling", TooltipDelay -> 0.5], \!\(\*
TagBox["#1",
Annotation[#, "Save selected test notebook as .mt file", 
               "Tooltip"]& ]\) &]}}, 
       GridBoxAlignment -> {"Columns" -> {{Left}}}, 
       GridBoxItemSize -> {"Columns" -> {{Automatic}}, 
         "Rows" -> {{Automatic}}}], "Column"]]]]}, 
 NotebookAutoSave -> True, WindowSize -> All, 
 WindowMargins -> {{Automatic, 0}, {Automatic, 0}}, 
 WindowElements -> {}, WindowTitle -> "MUnit Workflow", 
 StyleDefinitions -> "Palette.nb"]
  